unit Karkulka_LHCList;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, FMX.Effects,
  FMX.StdCtrls, FMX.ListBox, FMX.Layouts, FMX.Objects, FMX.Controls.Presentation;

type
  TKarkulka_LHCList_Form = class(TForm)
    LHCListpanel: TCalloutPanel;
    Image1: TImage;
    LHCListbox: TListBox;
    ShadowEffect12: TShadowEffect;
    b_OpenLHC: TButton;
    Label10: TLabel;
    b_DeleteLHC: TButton;
    Label11: TLabel;
    Label12: TLabel;
    ShadowEffect13: TShadowEffect;
    GlowEffect2: TGlowEffect;
    Label1: TLabel;
    Image2: TImage;
    procedure b_OpenLHCClick(Sender: TObject);
    procedure LHCListboxItemClick(const Sender: TCustomListBox;
      const Item: TListBoxItem);
    procedure b_DeleteLHCClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    procedure OnSelectFile(const S: string);
  end;

var
  Karkulka_LHCList_Form: TKarkulka_LHCList_Form;

implementation
uses
   e_Type,
   MiniLed_Main,
   t_xFileDialog;
{$R *.fmx}
{$R *.LgXhdpiPh.fmx ANDROID}
{$R *.LgXhdpiTb.fmx ANDROID}

procedure TKarkulka_LHCList_Form.b_DeleteLHCClick(Sender: TObject);
var
   LI: TListBoxItem;
   SE: TStringElement;
begin
   LI := LHCListbox.Selected;
   if LI <> nil then
   begin
       SE :=  TStringElement(LI.Data);
       MainForm.LHCs.ElementToFree := SE;
       MainForm.LHC_Save;
       MainForm.LHC_UpdateList;
   end;
end;

procedure TKarkulka_LHCList_Form.b_OpenLHCClick(Sender: TObject);
begin
   close;
   XFileDialog.Filter := '.opx';
   XFileDialog.Directory := '/';
   XFileDialog.ed_Caption.Text := 'Vbr souboru projektu';
   XFileDialog.OnSelect := OnSelectFile;
//   xFileDialog.DirsOnly := true;
   XFileDialog.Show;
end;

procedure TKarkulka_LHCList_Form.FormCreate(Sender: TObject);
begin
   MainForm.LHC_UpdateList;
end;

procedure TKarkulka_LHCList_Form.LHCListboxItemClick(const Sender: TCustomListBox; const Item: TListBoxItem);
var
   SE: TStringElement;
begin
   SE := TStringElement(Item.Data);
//   Close;
   MainForm.OnSelectFile(SE.Text);
end;

procedure TKarkulka_LHCList_Form.OnSelectFile(const S: string);
begin
   MainForm.AddProject(S);
end;


end.
