unit u_DeviceInfo;

interface

type
  T_DeviceInfo = record
  public
     class function GetIMEI: string; static;
     class function GetModel: string; static;
     class function GetOS: string; static;
     class function GetModel_W: string; static;
     class function GetOS_W: string; static;
  end;

implementation
uses
  StrUtils
{$IFDEF MSWINDOWS}
;
{$ELSE}
 ,
{$ENDIF}
{$IFDEF IOS}
  iOSapi.UIKit, iOSapi.Foundation, Macapi.Helpers;
{$ENDIF}
{$IFDEF ANDROID}
  // for IMEI
//  Androidapi.JNI.Telephony,
  Androidapi.JNI.Provider ,
  Androidapi.JNIBridge,
  Androidapi.JNI.GraphicsContentViewText ,
  Androidapi.JNI.JavaTypes,
  FMX.Helpers.Android,
  // END IMEI

  //androidapi.JNI.JavaTypes,
  Androidapi.Helpers,
  androidapi.JNI.Os;

{$ENDIF}


{$IFDEF ANDROID}

{ T_DeviceInfo }

class function T_DeviceInfo.GetIMEI: string;
//  var
//    obj: JObject;
//    tm: JTelephonyManager;
  begin
//     obj := SharedActivityContext.getSystemService(TJContext.JavaClass.TELEPHONY_SERVICE);
//     if obj <> nil then
//     begin
//        tm := TJTelephonyManager.Wrap( (obj as ILocalObject).GetObjectID );
//        if tm <> nil then
//           result := JStringToString(tm.getDeviceId);
//     end;
//     if result = '' then
     result := JStringToString(TJSettings_Secure.JavaClass.getString(SharedActivity.getContentResolver,
     TJSettings_Secure.JavaClass.ANDROID_ID));
  end;

class function T_DeviceInfo.GetModel: string;
var
   Manu, model, product: string;
begin
   Manu    := JStringToString(TJBuild.JavaClass.MANUFACTURER);
   Model   := JStringToString(TJBuild.JavaClass.MODEL);
   Product := JStringToString(TJBuild.JavaClass.PRODUCT);
   result := Manu +' '+Model+' '+Product;
end;

class function T_DeviceInfo.GetOS: string;
begin
  result := 'ANDROID '+ JStringToString(TJBuild_VERSION.JavaClass.RELEASE);
end;

class function T_DeviceInfo.GetModel_W: string;
begin
   result := ReplaceText(GetModel,' ','%20');
end;


class function T_DeviceInfo.GetOS_W: string;
begin
   result := ReplaceText(GetOS,' ','%20');
end;


{$ENDIF}
{$IFDEF IOS}
class function T_DeviceInfo.GetIMEI: string;
var
  Device : UIDevice;
begin
   Device := TUIDevice.Wrap(TUIDevice.OCClass.currentDevice);
   result := NSStrToStr(Device.uniqueIdentifier);
end;

class function T_DeviceInfo.GetModel: string;
var
  Device : UIDevice;
begin
   Device := TUIDevice.Wrap(TUIDevice.OCClass.currentDevice);
   result := NSStrToStr(Device.model);
end;

class function T_DeviceInfo.GetOS: string;
var
   Device : UIDevice;
begin
   Device := TUIDevice.Wrap(TUIDevice.OCClass.currentDevice);
   result := NSStrToStr(Device.systemName) + ' ' + NSStrToStr(Device.systemVersion);
end;

class function T_DeviceInfo.GetModel_W: string;
begin

end;


class function T_DeviceInfo.GetOS_W: string;
begin

end;

procedure TDeviceInfoForm.btnGetDeviceInfoClick(Sender: TObject);
var
   Device : UIDevice;
begin
   Device := TUIDevice.Wrap(TUIDevice.OCClass.currentDevice);
   lbOSName.Text := Format('OS Name: %s', [NSStrToStr(Device.systemName)]);
   lbOSVersion.Text := Format('OS Version: %s', [NSStrToStr(Device.systemVersion)]);
   lbDeviceType.Text := Format('Device Type: %s', [NSStrToStr(Device.model)]);
end;
{$ENDIF}
{$IFDEF MSWINDOWS}
class function T_DeviceInfo.GetIMEI: string;
begin
   result := 'WindowsTest';
end;

class function T_DeviceInfo.GetModel: string;
begin
   result := 'TestDevice';
end;

class function T_DeviceInfo.GetOS: string;
begin
   result := 'WIN';
end;

class function T_DeviceInfo.GetModel_W: string;
begin
   result := GetModel;
end;


class function T_DeviceInfo.GetOS_W: string;
begin
   result := GetOS;
end;

//procedure TDeviceInfoForm.btnGetDeviceInfoClick(Sender: TObject);
//var
//   Device : UIDevice;
//begin
//   Device := TUIDevice.Wrap(TUIDevice.OCClass.currentDevice);
//   lbOSName.Text := Format('OS Name: %s', [NSStrToStr(Device.systemName)]);
//   lbOSVersion.Text := Format('OS Version: %s', [NSStrToStr(Device.systemVersion)]);
//   lbDeviceType.Text := Format('Device Type: %s', [NSStrToStr(Device.model)]);
//end;
{$ENDIF}





end.
