unit F_PlugIn;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, Buttons, ExtCtrls,
  e_Type;

type
  TPlugInDialog = class(TForm)
    List: TListBox;
    Panel1: TPanel;
    b_Add: TBitBtn;
    b_Remove: TBitBtn;
    StatusBar: TStatusBar;
    BitBtn3: TBitBtn;
    OpenDialog: TOpenDialog;
    procedure FormCreate(Sender: TObject);
    procedure b_AddClick(Sender: TObject);
    procedure b_RemoveClick(Sender: TObject);
    procedure ListClick(Sender: TObject);
  private
    SL: TStringListElement;
    procedure SaveSL;
    procedure FillList;
  public
    { Public declarations }
  end;


implementation
uses
   FileVersion,
   t_Saver,
   u_Cktm,
   u_String,
   Worlds;

{$R *.DFM}

procedure TPlugInDialog.FormCreate(Sender: TObject);
var
  SLE: TStringListElement;
begin
   SLE := TStringListElement(World.FindElementName('PLUGIN'));
   SL := SLE;
   if SL = nil then SL := TStringListElement.Create;
   FillList;
end;

procedure TPlugInDialog.b_AddClick(Sender: TObject);
var
   S: string;
   FV: TFileVersion;
begin
   if OpenDialog.Execute then
   begin
      S := OpenDialog.FileName;
      if not FileExists(S) then
      begin
         ShowMessage(S+' .. k ho nemu najt nebo co');
         exit;
      end;
      FV := TFileVersion.Create;
      FV.FileName := S;
      if FV.InfoString('InternalName') = 'RBO' then
      begin
         if not CheckModulRegistration(S) then
         begin
            FV.Free;
            Exit;
         end;
      end;
      SL.AddNameString(FV.FileDescription, S);
      FillList;
      FV.Free;
      SaveSL;
      LoadPackage(S);
   end;
end;

procedure TPlugInDialog.SaveSL;
var
   Save: TSave;
begin
   Save := TSave.CreateAll(GetAbsolutePath('PlugIn.ORB'));
   Save.Input := SL;
   Save.DoIt;
   Save.Free;
end;

procedure TPlugInDialog.b_RemoveClick(Sender: TObject);
begin
   if List.ItemIndex < 0 then exit;
   SL.FreeElement(SL.Elements[List.ItemIndex]);
   ShowMessage('Odebrn modulu se projev a po restartu programu');
   FillList;
   SaveSL;
end;

procedure TPlugInDialog.FillList;
var
   i: integer;
begin
   List.Clear;
   for i := 0 to SL.LastIndex do
   begin
      List.Items.Add(SL.Names[i]);
   end;
end;

procedure TPlugInDialog.ListClick(Sender: TObject);
begin
   if List.ItemIndex < 0 then exit;
   StatusBar.SimpleText := SL.Strings[List.ItemIndex];
end;

END.
