unit T_EdiPro;

interface
uses
  Classes, TypInfo,
  Elements, Tools, M_Intera, E_Props,
  F_Prop,

  DB;
//  E_DClass,
//  F_ViewDT,
//  T_MyTool,
//  F_KeyFs,
//  F_UStr,
//  F_EEDt,
//  F_SQLTxt;

type
  TObjectPropertyEditor = class(TTool)
  private
    FProp: TFProp;
    FElProps: TInstanceProperties;
    FPocetInf : Integer;
    FJustFilled: boolean;

    //FLeft: integer;
    //FTop: integer;
    procedure FillInfo;
    procedure On_tm_EditProperty(var aMessage: TOrbisMouseEvent; var Handled: boolean);

   function    GetForm: TFProp;
   function    GetLeft: longInt; virtual;
   function    GetTop: longInt; virtual;
   function    GetWidth: longInt; virtual;
   function    GetHeight: longInt; virtual;
   procedure   SetLeft(aValue: longInt); virtual;
   procedure   SetTop(aValue: longInt); virtual;
   procedure   SetWidth(aValue: longInt); virtual;
   procedure   SetHeight(aValue: longInt); virtual;

   function    GetCaption: string; virtual;
   procedure   SetCaption(const aValue: string); virtual;
    procedure SetJustFilled(const Value: boolean);
 public
    procedure DoIt; override;
    procedure on_tm_EndTask(var aMessage: TOrbisMessage; var Handled: boolean); override;
    procedure HandleMessage(var aMessage: TOrbisMessage; var Handled: boolean); override;
    destructor Destroy; override;
    property JustFilled: boolean read FJustFilled write SetJustFilled;
 published
   property Form: TFProp read GetForm;
   property Left: longInt   read GetLeft   write SetLeft;
   property Top: longInt    read GetTop    write SetTop;
   property Width: longInt  read GetWidth  write SetWidth;
   property Height: longInt read GetHeight write SetHeight;
   property Caption: string read GetCaption write SetCaption;
 end;

implementation

uses
  Forms, SysUtils, Dialogs, Graphics, DBTables, Grids,
  // KERNEL
  E_Class,
  M_Orbis,
  U_String,
  u_Props,
  // 0TEMP
  T_Edit;


function ElementaryPropsCount(aElement: TElement): integer;
begin
  result := 0;
  if aElement is TOwnerEntity then
     result:= GetTypeData(TOwnerEntity.ClassInfo)^.PropCount
  else
  if aElement is TNameEntity then
     result:= GetTypeData(TNameEntity.ClassInfo)^.PropCount
  else
  if aElement is TEntity then
     result:= GetTypeData(TEntity.ClassInfo)^.PropCount
  else
  if aElement is TOwnerElement then
     result:= GetTypeData(TOwnerElement.ClassInfo)^.PropCount
  else
  if aElement is TNameElement then
     result:= GetTypeData(TNameElement.ClassInfo)^.PropCount
  else
  if aElement is TElement then
     result:= GetTypeData(TElement.ClassInfo)^.PropCount
end;


function ElementaryName(aElement: TElement): string;
begin
  if aElement is TOwnerEntity then
     result:= 'TOwnerEntity'
  else
  if aElement is TNameEntity then
     result:= 'TNameEntity'
  else
  if aElement is TEntity then
     result:= 'TEntity'
  else
  if aElement is TOwnerElement then
     result:= 'TOwnerElement'
  else
  if aElement is TNameElement then
     result:= 'TNameElement'
  else
  if aElement is TElement then
     result:= 'TElement'
end;



function TObjectPropertyEditor.GetForm: TFProp;
begin
  if FProp = nil then
  begin
     FProp:= TFProp.Create(Application);
     FProp.Tool:= Self;
  end;
  result:= FProp
end;


destructor TObjectPropertyEditor.Destroy;
begin
  if FElProps <> nil then
     FElProps.Free;
  inherited destroy
end;



procedure TObjectPropertyEditor.FillInfo;
var
  I,AI,MI: Integer;
  //PropInfo: PPropInfo;
  //PropList: PPropList;
  Vystup: string;

  //PomDSType : TDsType;
  //Instance: TPersistent;
  aObject: TObject;


  procedure AddRow(aGrid: TStringGrid; aName, aValue: string);
  var
    aRow: integer;
  begin
    if not JustFilled then
    begin
       aRow:= aGrid.RowCount;
       if (aRow = 1) and (aGrid.Cells[0,0] = '') then
          aRow:= 0
       else
          aGrid.RowCount:= aRow + 1;

       aGrid.Cells[0,aRow]:= aName;
       aGrid.Cells[1,aRow]:= aValue;
    end
    else
    begin
       if aGrid = Form.sgAscProperties then
       begin
          aRow := AI;
          Inc(AI);
       end
       else if aGrid =Form.sgElementProperties then
       begin
          aRow := I;
       end
       else if aGrid =Form.sgMethods then
       begin
          aRow := MI;
          Inc(MI);
       end;
       aGrid.Cells[0,aRow]:= aName;
       aGrid.Cells[1,aRow]:= aValue;
    end;
  end;


begin
  if FElProps.PropCount < 0 then exit;

  try
    AI := 0;
    MI := 0;
    for I := 0 to FElProps.PropCount - 1 do
    begin
      FElProps.PropIndex:= I;

      { nastaven hodnoty }
      if FElProps.PropKind = tkClass then
      begin
        aObject:= TObject(FElProps.ActualProperty.PropLongInt);
        if aObject = nil then
           Vystup:= 'nil'
        else
        if aObject is TComponent then
        begin
          try
            Vystup:= TComponent(aObject).Name
          except
          end
        end
        else
        if aObject is TElement then
        begin
          Vystup:= TElement(aObject).Name
        end
        else
          Vystup:= aObject.ClassName
      end
      else
        Vystup:= FElProps.PropString;

      if (TObject(FElProps.Instance) is TElement) and
         (ElementaryPropsCount(TElement(FElProps.Instance)) > I) then
      begin
        AddRow(Form.sgElementProperties, FElProps.PropName, Vystup);
      end
      else
      begin
        if FElProps.PropKind = tkMethod then
           AddRow(Form.sgMethods, FElProps.PropName, Vystup)
        else
           AddRow(Form.sgAscProperties, FElProps.PropName, Vystup)
      end
    end;
  except
    ShowMessage('Error filling property form (' + FElProps.PropName+')');
  end;
  JustFilled := true;
  {**************}
    //Instance:= FElProps.Instance;
    FPocetInf:= 0;
(*
    if FElProps.Instance is TDatabaseClass then
    begin
      PomDSType := (Instance as TDatabaseClass).DataSourceType;
      case PomDSType of
        dstTable : FPocetInf := 1;
        dstSQL,dstSQLdef,dstQBE : FPocetInf := 2;
      end;

      if (PomDSType = dstSQL) or (PomDSType = dstSQLdef) then
      begin
        Form.StringGrid1.RowCount := Form.StringGrid1.RowCount + 1;
        Form.StringGrid1.Cells[0,Form.StringGrid1.RowCount-1]:= 'DSSQL';
      end;

      if (PomDSType = dstQBE) then
      begin
        Form.StringGrid1.RowCount := Form.StringGrid1.RowCount + 1;
        Form.StringGrid1.Cells[0,Form.StringGrid1.RowCount-1]:= 'DSQBE';
      end;

      Form.StringGrid1.RowCount := Form.StringGrid1.RowCount + 1;
      Form.StringGrid1.Cells[0,Form.StringGrid1.RowCount-1]:= 'Fields';
    end;

    if Instance is TVirtualElement then
    begin
      Form.StringGrid1.RowCount := Form.StringGrid1.RowCount + 1;
      Form.StringGrid1.Cells[0,Form.StringGrid1.RowCount-1]:= 'DSData';
      FPocetInf := 1;
    end;
*)
  {**************}

end;



procedure TObjectPropertyEditor.DoIt;
begin
  if not (TObject(Input) is TPersistent) then exit;

//  Form.StringGrid1.ColWidths[0]:= 100;
//  Form.StringGrid1.ColWidths[1]:= 1000; { prehnana hodnota, Align asClient to srovna }

  FElProps:= TInstanceProperties.Create;
  FElProps.Instance:= TPersistent(Input);
  FElProps.PropName:= 'NAME';

  Form.lbClassName.Caption:= FElProps.PropString + ' : ' + Input.ClassName;
  Form.tsElementProperties.Enabled:= true;
  if TObject(Input) is TElement then
     Form.tsElementProperties.Caption:= ElementaryName(Input)
  else
     Form.tsElementProperties.Enabled:= false;

  FillInfo;
  Form.Left:= Left;
  Form.Top:= Top;

  {Velikost formule}
{
  if FElProps.PropCount + FPocetInf + 1 < 20 then
    Form.Height:= (FPocetInf+FElProps.PropCount+1)*(Form.StringGrid1.DefaultRowHeight+1) + 28
  else
    Form.Height:= 20*(Form.StringGrid1.DefaultRowHeight+1) + 28;

  if (Form.Top + Form.Height) > Screen.Height then
  begin
    Form.Height:= Screen.Height-Form.Top-10
  end;
}
  Form.Show;
end;



procedure TObjectPropertyEditor.On_tm_EditProperty(var aMessage: TOrbisMouseEvent; var Handled: boolean);
var
  //col,
  row: longInt;
  //EdText: TEditTool;
  //aTool: TTool;

  NazevProperty,HodnotaProperty{,aAdress} : string;
  //EditMyProperty : TT_EditForm;
{  ViewData : TF_ViewData;
  KeyFields : TF_KeyFields;
  SqlEditor : TF_SqlText;
  EEData : TF_EEData;
}
  //i,PocetPoli : Integer;
{  PomDSType : TDSType; }
  //FInstance: TPersistent;
  aObject: TObject;
  OPE: TObjectPropertyEditor;

begin
  //col:= aMessage.X;
  row:= aMessage.Y;
  if (row = 0) and (TObject(Input) is TTable) then
  begin
{
    ViewData := TF_ViewData.Create(Application);
    ViewData.DBGrid1.DataSource := ViewData.DataSource1;
    ViewData.DataSource1.DataSet:= TTable(Input);
    ViewData.ShowModal;
}
  end
  else
  if row > 0 then
  begin

{***************************}
    NazevProperty := Form.PropName;
    HodnotaProperty := Form.PropString;
    //FInstance:= FElProps.Instance;
(*
    if (FInstance is TDatabaseClass) then
      begin
        PomDSType := (FInstance as TDatabaseClass).DataSourceType;
        if NazevProperty = 'DSData' then
          begin
            ViewData := TF_ViewData.Create(Application);
            ViewData.DBGrid1.DataSource := (FInstance as TDatabaseClass).DSData;
            ViewData.ShowModal;
            exit;
          end;

        if NazevProperty = 'Fields' then
          begin
            F_FStr := TF_FStr.Create(Application);
            for i := 0 to (FInstance as TDatabaseClass).DSData.DataSet.FieldCount - 1 do
              begin
                F_FStr.SG.Cells[0,i+1] := IntToStr(i+1);
                F_FStr.SG.Cells[1,i+1] := (FInstance as TDatabaseClass).DSData.DataSet.Fields[i].FieldName;
                F_FStr.SG.Cells[2,i+1] := DataTypeToStr((FInstance as TDatabaseClass).DSData.DataSet.Fields[i].DataType);
                F_FStr.SG.Cells[3,i+1] := IntToStr((FInstance as TDatabaseClass).DSData.DataSet.Fields[i].DataSize);
{                F_FStr.SG.Cells[4,i] := ;  Mla by tu bt hvzdika, zda pole je primrn kl }
              end;
              F_FStr.ShowModal;
            exit;
          end;

        if NazevProperty = 'NameField' then
          begin
            EditMyProperty := TT_EditForm.Create(Application);
            EditMyProperty.CB.Show;
            EditMyProperty.Edit.Hide;
            EditMyProperty.CB.Items.Clear;
            for i := 0 to (FInstance as TDatabaseClass).PropertyCount - 1 do
              begin
                EditMyProperty.CB.Items.Add((FInstance as TDatabaseClass).PropertyName[i]);
              end;
            EditMyProperty.CB.Text := GetPropString(FInstance, row-1);

            EditMyProperty.ShowModal;

            SetPropString(FInstance, row-1, EditMyProperty.CB.Text);
            Form.StringGrid1.Cells[1,row]:= GetPropString(FInstance, row-1);
            exit;
          end;

        if NazevProperty = 'AdressField' then
          begin
            KeyFields := TF_KeyFields.create(Application);

            if PomDSType = dstTable then
              begin
                KeyFields.Table.DatabaseName := (FInstance as TDatabaseClass).DataSourcePath;
                KeyFields.Table.TableName := (FInstance as TDatabaseClass).DataSource;
              end;

            if (PomDSType = dstSQL) or (PomDSType = dstSQLdef) then
              begin
                KeyFields.Query.DatabaseName := (FInstance as TDatabaseClass).DataSourcePath;
                KeyFields.Query.SQL := (FInstance as TDatabaseClass).DSSQL;
              end;

            if PomDSType = dstQBE then
              begin
{
                KeyFields.QBE.DatabaseName := (FInstance as TDatabaseClass).DataSourcePath;
                KeyFields.QBE.QBE := (FInstance as TDatabaseClass).DSSQL;
}
              end;

            F_KeyFs.KeyFieldsAsStr := GetPropString(FInstance, row-1);
            F_KeyFs.FDSType := pomDSType;
            KeyFields.ShowModal;

            if PomDSType = dstTable then
              begin
                (FInstance as TDatabaseClass).DSIndexName := KeyFields.Table.IndexName;
              end;

            SetPropString(FInstance, row-1, F_KeyFs.KeyFieldsAsStr);
            Form.StringGrid1.Cells[1,row]:= GetPropString(FInstance, row-1);
            exit;
          end;

        if (NazevProperty = 'DSSQL') or (NazevProperty = 'DSQBE') then
          begin
            SQLEditor := TF_SqlText.Create(Application);
            SQLEditor.Memo.Lines := (FInstance as TDatabaseClass).DSSQL;
            SQLEditor.ShowModal;

            (FInstance as TDatabaseClass).DSSQL := SQLEditor.Memo.Lines;
            exit;
          end;

      end;

    if (FInstance is TVirtualElement) then
      begin
        if NazevProperty = 'DSData' then
          begin
            EEData := TF_EEData.Create(Application);
            PocetPoli := (FInstance as TVirtualElement).PropertyCount;
            EEData.SG.ColCount := PocetPoli;
            aAdress := (FInstance as TVirtualElement).ElementAdress;
            for i := 0 to PocetPoli - 1 do
              begin
                EEData.SG.Cells[i,0] := (FInstance as TVirtualElement).PropertyName[i];
                EEData.SG.Cells[i,1] := (FInstance as TVirtualElement).GetPropertyStringByIndex(i);
              end;
            EEData.ShowModal;
            exit;
          end;
      end;
*)

{***************************}
    FElProps.PropName:= NazevProperty;

    if FElProps.PropKind = tkClass then
    begin
      aObject:= TObject(FElProps.ActualProperty.PropLongInt);
      if aObject is TPersistent then
      begin
        OPE:= TObjectPropertyEditor.Create;
        OPE.Input:= TElement(aObject);
        OPE.DoIt
      end
    end
    else
    begin
{
      EdText:= TEditTool.Create;
      EdText.Text:= FElProps.PropString;
      EdText.DoIt;
      SetPropString(FInstance, row-1, EdText.Text);
}
      FElProps.PropString:= HodnotaProperty;
    end;
    FillInfo
{
    Form.StringGrid1.Cells[1,row]:= GetPropString(FInstance, row-1);
}

{
    MessageDlg(GetPropName(FInstance, row-1) + ': ' + GetPropString(FInstance, row-1),
                mtInformation, [mbOK], 0);
}
  end;
  Handled := true;
end;



procedure   TObjectPropertyEditor.on_tm_EndTask(var aMessage: TOrbisMessage; var Handled: boolean);
begin
  Self.Free
end;


procedure TObjectPropertyEditor.HandleMessage(var aMessage: TOrbisMessage; var Handled: boolean);
begin
   Handled := false;

   inherited HandleMessage(aMessage, Handled);
   if Handled then exit;
   case aMessage.Message of
      tm_EditProperty: on_tm_EditProperty(TOrbisMouseEvent(aMessage ), Handled);
   end;
end;


function    TObjectPropertyEditor.GetLeft: longInt;
begin
   result := Form.Left;
end;

function    TObjectPropertyEditor.GetTop: longInt;
begin
   result := Form.Top;
end;

function    TObjectPropertyEditor.GetWidth: longInt;
begin
   result := Form.Width;
end;

function    TObjectPropertyEditor.GetHeight: longInt;
begin
   result := Form.Height;
end;

procedure   TObjectPropertyEditor.SetLeft(aValue: longInt);
begin
   Form.Left := aValue;
end;

procedure   TObjectPropertyEditor.SetTop(aValue: longInt);
begin
   Form.Top := aValue;
end;

procedure   TObjectPropertyEditor.SetWidth(aValue: longInt);
begin
   Form.Width := aValue;
end;

procedure   TObjectPropertyEditor.SetHeight(aValue: longInt);
begin
   Form.Height := aValue;
end;

function    TObjectPropertyEditor.GetCaption: string;
begin
   result := Form.Caption;
end;

procedure   TObjectPropertyEditor.SetCaption(const aValue: string);
begin
   Form.Caption := aValue;
end;


procedure TObjectPropertyEditor.SetJustFilled(const Value: boolean);
begin
   FJustFilled := Value;
end;

BEGIN
   RegisterOrbisClass(TObjectPropertyEditor);
END.
