unit d_Raster;

interface
uses
   Graphics,
   Windows,
   RasData_TLB,
   G_Elems,
   e_Device,
   e_Proje,
   e_Raster;

type

TTopRaster_Device = class(TDevice)
  private
    FRAS_X1: double;
    FRAS_dX: double;
    FRAS_dY: double;
    FRAS_Y1: double;
    FRAS_Width: integer;
    FRAS_Height: integer;
    FRAS_FileName: string;
    FRAS_PixelSizeY: double;
    FRAS_PixelSizeX: double;
    FITR: ITopRaster;
    FRaster: e_Raster.TRaster;
    FOldProjection: TPageProjection;
    FModelView: TDoubleRect;
    FRAS_TYP: integer;
    FRAS_Compress: integer;
    FMaxBlack: byte;
    FMaxBlackForAll: boolean;
    FWork_FileName: string;
    procedure SetRAS_dX(const Value: double);
    procedure SetRAS_dY(const Value: double);
    procedure SetRAS_FileName(const Value: string);
    procedure SetRAS_Height(const Value: integer);
    procedure SetRAS_Width(const Value: integer);
    procedure SetRAS_X1(const Value: double);
    procedure SetRAS_Y1(const Value: double);
    procedure SetRAS_PixelSizeX(const Value: double);
    procedure SetRAS_PixelSizeY(const Value: double);
    procedure SetRaster(const Value: e_Raster.TRaster);
    procedure SetOldProjection(const Value: TPageProjection);
    procedure SetModelView(const Value: TDoubleRect);
    procedure SetRAS_Compress(const Value: integer);
    procedure SetRAS_TYP(const Value: integer);
    procedure SetMaxBlack(const Value: byte);
    procedure SetMaxBlackForAll(const Value: boolean);
    procedure SetWork_FileName(const Value: string);
 protected
    function GetHandle: HDC; override;
    procedure SetVisible(aVisible: boolean); override;
 public
    constructor Create; override;
    procedure Clear; override;
    procedure WriteText(aText: string); override;
    procedure WriteLnText(aText: string); override;
    procedure DrawDevice(X, Y: integer; Graphic: graphics.TGraphic); override;
    procedure Reset;  override;
    procedure Close;  override;
    procedure Adjust;  override;
    procedure CopyFinal;
    procedure SetupPage(Sender: TObject); override;
    property Raster: e_Raster.TRaster read FRaster write SetRaster;
    property OldProjection: TPageProjection read FOldProjection write SetOldProjection;
    property ModelView: TDoubleRect read FModelView write SetModelView;
published
   property Work_FileName: string read FWork_FileName write SetWork_FileName;
   property RAS_FileName: string read FRAS_FileName write SetRAS_FileName;
   property RAS_Width: integer read FRAS_Width write SetRAS_Width;
   property RAS_Height: integer read FRAS_Height write SetRAS_Height;
   property RAS_X1: double read FRAS_X1 write SetRAS_X1;
   property RAS_Y1: double read FRAS_Y1 write SetRAS_Y1;
   property RAS_dX: double read FRAS_dX write SetRAS_dX;
   property RAS_dY: double read FRAS_dY write SetRAS_dY;
   property RAS_PixelSizeX: double read FRAS_PixelSizeX write SetRAS_PixelSizeX;
   property RAS_PixelSizeY: double read FRAS_PixelSizeY write SetRAS_PixelSizeY;
   property RAS_TYP: integer read FRAS_TYP write SetRAS_TYP;
   property RAS_Compress: integer read FRAS_Compress write SetRAS_Compress;
   property MaxBlack: byte read FMaxBlack write SetMaxBlack;
   property MaxBlackForAll: boolean read FMaxBlackForAll write SetMaxBlackForAll;
end;

implementation
uses
   Forms,
   Types,
   SysUtils,
   u_String;

{ TTopRaster_Device }

procedure TTopRaster_Device.Adjust;
begin

end;

procedure TTopRaster_Device.Clear;
begin

end;

procedure TTopRaster_Device.Close;
begin
   CopyFinal;
   //Raster.Free;
end;

procedure TTopRaster_Device.CopyFinal;
var
   Raster1: TRaster;
   FITR1: ITopRaster;
   Ar: Array of byte;
   Len: integer;
   i: integer;
   res: HResult;
   PutLin: integer;
   Er: boolean;
   S: string;
begin
   Raster1 := e_Raster.TRaster.Create;
   Raster1.WarmUp := true; // ne aktivace, jen zahrati
   Raster1.SrvRas.Height := RAS_Height;
   Raster1.SrvRas.Width := RAS_Width;
   if RAS_TYP = 0 then
   begin
      Raster1.SrvRas.BitPix := 1;
      Raster1.SrvRas.RasTyp := 0;
      Raster1.SrvRas.DefCol := 0;
   end
   else
   begin
      Raster1.SrvRas.BitPix := 24;
      Raster1.SrvRas.RasTyp := 5;
      Raster1.SrvRas.DefCol := $FFFFFF;
   end;
   //Raster.SrvRas.DefCol := 255;
   Raster1.SrvRas.Compres := RAS_Compress;
   //Raster1.SrvRas.CreateRas(RAS_FileName,2,1); // na konci bylo 255
   Raster1.SrvRas.CreateRas(RAS_FileName,2,0); // na konci bylo 255
   Raster1.SrvRas.X1 := RAS_X1;
   Raster1.SrvRas.Y1 := RAS_Y1;
   Raster1.SrvRas.Dx := RAS_dX;
   Raster1.SrvRas.Dy := RAS_dY;
   FITR1 := Raster1.SrvRas as ITopRaster;
   // plneni
   if RAS_TYP = 0 then
   begin
      //Len := B.Width div 8;
      Len := RAS_WIDTH div 8;
      if not((RAS_WIDTH mod 8)=0) then
         Inc(Len);
      SetLength(Ar,Len);
   end
   else
   begin
      //Len := B.Width*3;
      Len := RAS_WIDTH * 3;
      SetLength(Ar,Len);
   end;
   for i := 0 to RAS_Height - 1 do
   begin
      try
      res := FITR.ReadLines(i,1,Ar[0],PutLin);   // funguje s dlazdicema pres cely rastr
      res := FITR1.WriteLines(i,1,Ar[0],PutLin);   // funguje s dlazdicema pres cely rastr
      Application.Processmessages;
      except
         Er := true;
         //ShowMessage('Err');
      end;
   end;
   // konec
   Raster1.Free;
   Raster.Free;
   //ruseni pracovniho rastru
   S := Work_FileName;
   if FileExists(S) then
      DeleteFile(PChar(S));
   S := ChangeFileExt(S,'.TFW');
   if FileExists(S) then
      DeleteFile(PChar(S));
   S := ChangeFileExt(S,'.TFE');
   if FileExists(S) then
      DeleteFile(PChar(S));
end;

constructor TTopRaster_Device.Create;
begin
  inherited;
end;

procedure TTopRaster_Device.DrawDevice(X, Y: integer; Graphic: TGraphic);
var
   B: Graphics.TBitmap;
   Ar: Array of byte;
   BV: byte;
   al,Len: integer;
   sh: byte;
   P: PByteArray;
   i,j,jj,bj,j24: integer;
   res: HResult;
   PutLin: integer;
   Er: boolean;
begin
   if not (Graphic is Graphics.TBitmap) then exit;
   B := Graphics.TBitmap(Graphic);
   if RAS_TYP = 0 then
   begin
      //Len := B.Width div 8;
      Len := RAS_WIDTH div 8;
      if not((RAS_WIDTH mod 8)=0) then
         Inc(Len);
      SetLength(Ar,Len);
   end
   else
   begin
      //Len := B.Width*3;
      Len := RAS_WIDTH * 3;
      SetLength(Ar,Len);
   end;
   for i := 0 to B.Height-1 do
   begin
      if X > 0 then
         res := FITR.ReadLines(Y+i,1,Ar[0],PutLin);   // funguje s dlazdicema pres cely rastr
      P := B.ScanLine[i];
      j := 0;
      //bj := 0;
      bj := X;
      jj := (B.Width * 3) - 1;
      while j < jj do
      begin
         if RAS_TYP = 0 then
         begin
            al := bj div 8;
            sh := bj mod 8;
            if sh = 0 then
               BV := 0
            else
               BV := not Ar[al];
            if MaxBlackForAll then
            begin
               if (P[j] < MaxBlack) and (P[j+1] < MaxBlack) and (P[j+2] < MaxBlack) then
                  BV := BV or (128 shr sh);
            end
            else
            begin
               if (P[j] < MaxBlack) or (P[j+1] < MaxBlack) or (P[j+2] < MaxBlack) then
                  BV := BV or (128 shr sh);
            end;
            Ar[al] := not BV;
         end
         else
         begin
            j24 := j + (X * 3);
            Ar[j24]   := P[j+2];
            Ar[j24+1] := P[j+1];
            Ar[j24+2] := P[j];
         end;
         Inc(j,3);
         Inc(bj);
      end;
      try

      res := FITR.WriteLines(Y+i,1,Ar[0],PutLin);   // funguje s dlazdicema pres cely rastr

      //res := FITR.WritePixLine(Y+i,X,Len, Ar[0]);

      except
         Er := true;
         //ShowMessage('Err');
      end;
   end;
end;

function TTopRaster_Device.GetHandle: HDC;
begin
   result := 0;
end;

procedure TTopRaster_Device.Reset;
var
   S: string;
begin
   //if RAS_TYP = 2 then
   Raster := e_Raster.TRaster.Create;
   Raster.WarmUp := true; // ne aktivace, jen zahrati
   Raster.SrvRas.Height := RAS_Height;
   Raster.SrvRas.Width := RAS_Width;
   if RAS_TYP = 0 then
   begin
      Raster.SrvRas.BitPix := 1;
      Raster.SrvRas.RasTyp := 0;
      Raster.SrvRas.DefCol := 0;
   end
   else
   begin
      Raster.SrvRas.BitPix := 24;
      Raster.SrvRas.RasTyp := 5;
      Raster.SrvRas.DefCol := $FFFFFF;
   end;
   //Raster.SrvRas.DefCol := 255;
   //@@@Tile@ Raster.SrvRas.Compres := RAS_Compress;
   Raster.SrvRas.Compres := 0;
   S := ExtractFilePath(RAS_FileName);
   CheckBackSlash(S);
   Work_FileName := S + 'WORK_TIF_.TIF';
   Raster.SrvRas.CreateRas(Work_FileName,2,1); // na konci bylo 255
   //Raster.SrvRas.CreateRas(RAS_FileName,2,0); // na konci bylo 255
   Raster.SrvRas.X1 := RAS_X1;
   Raster.SrvRas.Y1 := RAS_Y1;
   Raster.SrvRas.Dx := RAS_dX;
   Raster.SrvRas.Dy := RAS_dY;
   FITR := Raster.SrvRas as ITopRaster;
   SetupPage(nil);
end;

procedure TTopRaster_Device.SetMaxBlack(const Value: byte);
begin
  FMaxBlack := Value;
end;

procedure TTopRaster_Device.SetMaxBlackForAll(const Value: boolean);
begin
  FMaxBlackForAll := Value;
end;

procedure TTopRaster_Device.SetModelView(const Value: TDoubleRect);
begin
  FModelView := Value;
end;

procedure TTopRaster_Device.SetOldProjection(const Value: TPageProjection);
begin
  FOldProjection := Value;
end;

procedure TTopRaster_Device.SetRaster(const Value: e_Raster.TRaster);
begin
  FRaster := Value;
end;

procedure TTopRaster_Device.SetRAS_Compress(const Value: integer);
begin
  FRAS_Compress := Value;
end;

procedure TTopRaster_Device.SetRAS_dX(const Value: double);
begin
  FRAS_dX := Value;
end;

procedure TTopRaster_Device.SetRAS_dY(const Value: double);
begin
  FRAS_dY := Value;
end;

procedure TTopRaster_Device.SetRAS_FileName(const Value: string);
begin
  FRAS_FileName := Value;
end;

procedure TTopRaster_Device.SetRAS_Height(const Value: integer);
begin
  FRAS_Height := Value;
end;

procedure TTopRaster_Device.SetRAS_PixelSizeX(const Value: double);
begin
   FRAS_PixelSizeX := Value;
   RAS_Height := Round(RAS_dX / Value);
end;

procedure TTopRaster_Device.SetRAS_PixelSizeY(const Value: double);
begin
  FRAS_PixelSizeY := Value;
  RAS_Width := Round(RAS_dY / Value);
end;

procedure TTopRaster_Device.SetRAS_TYP(const Value: integer);
begin
  FRAS_TYP := Value;
end;

procedure TTopRaster_Device.SetRAS_Width(const Value: integer);
begin
  FRAS_Width := Value;
end;

procedure TTopRaster_Device.SetRAS_X1(const Value: double);
begin
  FRAS_X1 := Value;
end;

procedure TTopRaster_Device.SetRAS_Y1(const Value: double);
begin
  FRAS_Y1 := Value;
end;

procedure TTopRaster_Device.SetupPage(Sender: TObject);
var
   HResX, HResY: double;
   //AuxRegion: TRect;
begin
   Page.Rect := Rect(0,0,RAS_Width,RAS_Height);
   //Page.Rect := Rect(0,0,RAS_Width - 1,RAS_Height - 1);
   {
   Page.Rect.Left := 0;
   Page.Rect.Top  := 0;
   Page.Rect.Right := RAS_Width - 1;
   Page.Rect.Bottom := RAS_Height - 1;
   }
   Page.ClipRegion:= Page.Rect;
   Page.Color := OldProjection.Page.Color;

   //HResX := 1000;
   //HResY := 1000;
   //HResX := HResX * GetDeviceCaps(Canvas.Handle, LOGPIXELSX) / SizeOfInch;
   //HResY := HResY * GetDeviceCaps(Canvas.Handle, LOGPIXELSY) / SizeOfInch;
   HResX := RAS_Width / RAS_dy;
   HresY := RAS_Height / RAS_dx;
   //HResX := RAS_dy / RAS_Width;
   //HresY := RAS_dx / RAS_Height;
   Page.SetResolution(HResX, HResY);
   //Page.SetResolution(OldProjection.Page.Resolution.X, OldProjection.Page.Resolution.Y);
   Projection.ChangeProjectionByRect(ModelView,Page);
   //Projection.ChangeProjection
   // (OldProjection.CenterPoint, OldProjection.Scale, Page)
end;

procedure TTopRaster_Device.SetVisible(aVisible: boolean);
begin

end;

procedure TTopRaster_Device.SetWork_FileName(const Value: string);
begin
  FWork_FileName := Value;
end;

procedure TTopRaster_Device.WriteLnText(aText: string);
begin

end;

procedure TTopRaster_Device.WriteText(aText: string);
begin

end;

end.
