unit e_GeometryEx;

interface
uses
   e_Geometry,
   e_Type;

type

Tgis_Note = class(TPointElement)
  private
    FImages: TStringListElement;
    FAudios: TStringListElement;
    FText: string;
    procedure SetAudios(const Value: TStringListElement);
    procedure SetImages(const Value: TStringListElement);
    procedure SetText(const Value: string);
    function GetNoAudios: boolean;
    function GetNoImages: boolean;
published
   property Text: string read FText write SetText;
   property Images: TStringListElement read FImages write SetImages;
   property Audios: TStringListElement read FAudios write SetAudios;
   property NoImages: boolean read GetNoImages stored false;
   property NoAudios: boolean read GetNoAudios stored false;
end;

  Tgis_PointElement = class(TPointElement)
  private
    FSymbol: integer;
    FComment: integer;
    FColor: integer;
    FStatus: integer;
    FGroup: integer;
    procedure SetColor(const Value: integer);
    procedure SetComment(const Value: integer);
    procedure SetSymbol(const Value: integer);
    procedure SetStatus(const Value: integer);
    procedure SetGroup(const Value: integer);
  published
     property Group: integer read FGroup write SetGroup;
     property Symbol: integer read FSymbol write SetSymbol;
     property Color: integer read FColor write SetColor;
     property Comment: integer read FComment write SetComment;
     property Status: integer read FStatus write SetStatus;
  end;


implementation
uses
   Elements,
   e_Class;

{ Tgis_Note }

function Tgis_Note.GetNoAudios: boolean;
begin
   result := (FAudios = nil) or FAudios.NoElements;
end;

function Tgis_Note.GetNoImages: boolean;
begin
   result := (FImages = nil) or FImages.NoElements;
end;

procedure Tgis_Note.SetAudios(const Value: TStringListElement);
begin
   ExchangeFieldElement(TElement(FAudios), Value);
end;

procedure Tgis_Note.SetImages(const Value: TStringListElement);
begin
   ExchangeFieldElement(TElement(FImages), Value);
end;

procedure Tgis_Note.SetText(const Value: string);
begin
  FText := Value;
end;

{ Tgis_PointElement }

procedure Tgis_PointElement.SetColor(const Value: integer);
begin
  FColor := Value;
end;

procedure Tgis_PointElement.SetComment(const Value: integer);
begin
  FComment := Value;
end;

procedure Tgis_PointElement.SetGroup(const Value: integer);
begin
  FGroup := Value;
end;

procedure Tgis_PointElement.SetStatus(const Value: integer);
begin
  FStatus := Value;
end;

procedure Tgis_PointElement.SetSymbol(const Value: integer);
begin
  FSymbol := Value;
end;

initialization
   RegisterOrbisClass(Tgis_Note);
   RegisterOrbisClass(Tgis_PointElement);
end.
