unit e_WMS;

interface
uses
   Elements;
type

Tgis_WMSLayer=class(TOwnerEntity)
  private
    FLayers: string;
    FURL: string;
    FComment: string;
    FVersion: string;
    FMaxScale: double;
    FMinScale: double;
    FMaxHeight: integer;
    FMaxWidth: integer;
    procedure SetComment(const Value: string);
    procedure SetLayers(const Value: string);
    procedure SetURL(const Value: string);
    procedure SetVersion(const Value: string);
    procedure SetMaxScale(const Value: double);
    procedure SetMinScale(const Value: double);
    procedure SetMaxHeight(const Value: integer);
    procedure SetMaxWidth(const Value: integer);
published
   property URL: string read FURL write SetURL;
   property Version: string read FVersion write SetVersion;
   property Layers: string read FLayers write SetLayers;
   property Comment: string read FComment write SetComment;
   property MaxWidth: integer read FMaxWidth write SetMaxWidth;
   property MaxHeight: integer read FMaxHeight write SetMaxHeight;
   property MinScale: double read FMinScale write SetMinScale;
   property MaxScale: double read FMaxScale write SetMaxScale;
end;

implementation
uses
   e_Class;

{ Tgis_WMSLayer }

procedure Tgis_WMSLayer.SetComment(const Value: string);
begin
  FComment := Value;
end;

procedure Tgis_WMSLayer.SetLayers(const Value: string);
begin
  FLayers := Value;
end;

procedure Tgis_WMSLayer.SetMaxHeight(const Value: integer);
begin
  FMaxHeight := Value;
end;

procedure Tgis_WMSLayer.SetMaxScale(const Value: double);
begin
  FMaxScale := Value;
end;

procedure Tgis_WMSLayer.SetMaxWidth(const Value: integer);
begin
  FMaxWidth := Value;
end;

procedure Tgis_WMSLayer.SetMinScale(const Value: double);
begin
  FMinScale := Value;
end;

procedure Tgis_WMSLayer.SetURL(const Value: string);
begin
  FURL := Value;
end;

procedure Tgis_WMSLayer.SetVersion(const Value: string);
begin
  FVersion := Value;
end;

INITIALIZATION
   RegisterOrbisClass(Tgis_WMSLayer);
END.
