unit f_ThematicMapsEditor;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  f_OrbisDialog, StdCtrls, Buttons, ExtCtrls, ComCtrls, ImgList;

type
  TThematicMapsEditor_Form = class(TOrbisDialog_Form)
    MapList: TListView;
    MapImages: TImageList;
    Splitter1: TSplitter;
    LayerP: TPanel;
    ColorDialog: TColorDialog;
    LayerPanel: TScrollBox;
    procedure MapListSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure b_OKClick(Sender: TObject);
  private
    FAddCaption: string;
    procedure SetAddCaption(const Value: string);
    { Private declarations }
  public
    property AddCaption: string read FAddCaption write SetAddCaption;
  end;


implementation
uses
   Elements,
   e_ThematicMap,
   r_ThematicLayerEditor,
   r_ThematicLinesLayerEditor,
   r_ThematicTextLayerEditor;

{$R *.DFM}

procedure TThematicMapsEditor_Form.MapListSelectItem(Sender: TObject;
  Item: TListItem; Selected: Boolean);
var
   LE: TThematicLayerEditor_Frame;
   Map: TEntity;
   i,j,k: integer;
   E: TElement;

procedure AddEdFrame;
var
   Isconnection: boolean;
begin
   E := Map.Elements[i];
   IsConnection := e is TThematicConnection;
   if not ((e is TThematicLayer) or IsConnection) then exit;
   if IsConnection and (TThematicConnection(E).ConnectionType < 1) then exit;
   if (E is TThematicLayer) and TThematicLayer(E).AsText then
      LE := TThematicLayerTextEditor_Frame.Create(LayerPanel)
   else
   if (E is TThematicLayer) and TThematicLayer(E).IsLinesLayer then
      LE := TThematicLinesLayerEditor_Frame.Create(LayerPanel)
   else
      LE := TThematicLayerEditor_Frame.Create(LayerPanel);
   LE.Name := 'ThematicLayer_'+IntToStr(i);
   LE.Align := alTop;
   LE.Parent := LayerPanel;
   LE.l_LayerName.Caption := Map.Elements[i].Name;
   if IsConnection then
   begin
      LE.LayerConnection := true;
      LE.Connection := TThematicConnection(e);
   end
   else
      LE.Layer := TThematicLayer(E);
   LE.ColorDialog := ColorDialog;
end;

begin
   if not Selected then exit;
   if not (TObject(Item.Data) is TEntity) then exit;
   LayerPanel.DestroyComponents;
   //Application.ProcessMessages;
   //Layerpanel.Visible := false;
   //Application.ProcessMessages;
   Map := TEntity(Item.Data);
   Caption := Map.Name + ' ' + AddCaption;
   {
   if not Visible then
      for i := 0 to Map.LastIndex do
         AddEdFrame
   else
   }
      for i := Map.LastIndex downto 0 do
         AddEdFrame;
end;

procedure TThematicMapsEditor_Form.b_OKClick(Sender: TObject);
begin
   Tool.SetPropertyBooleanByName('Review',true);
   Application.ProcessMessages;
end;

procedure TThematicMapsEditor_Form.SetAddCaption(const Value: string);
begin
  FAddCaption := Value;
end;

end.
