unit i_PolyLineElement;
interface

uses
   Graphics,
// KERNEL
   Elements,
   Tools,
   T_Recurs,
// GLIB
   g_Elems,
// SPACE
   e_Geometry,
   //E_Space,
// DEVICE
   e_Device,
   i_Basic;
// SYMBOL
   //e_PlZn,
// TOPOL
   //I_Top;



type

TPolyLineElementInterpret = class(TRectInterpret)
private
    FColor: integer;
    FShowPoints: boolean;
    procedure SetColor(const Value: integer);
    procedure SetShowPoints(const Value: boolean);
protected
   procedure Process(Element: TElement); override;
   function  IsItsClass(AObject: TObject): boolean; override;
   function  QGoInside(Element: TElement): boolean; override;
   function  QProcessBefore(Element: TElement): boolean; override;
public
   function   CanUniGoInside(Element: TElement): boolean; override;
   procedure  Reset(aDevice: TDevice); override;
   procedure  Close; override;
published
   property Color: integer read FColor write SetColor;
   //property ShowPoints: boolean read FShowPoints write SetShowPoints;
   property LinePoints: boolean read FShowPoints write SetShowPoints;
end;



implementation

uses
   WinTypes,
   WinProcs,
   Dialogs,
   SysUtils,
// KERNEL
   e_Class;
// GLIB
   //ClipArea,
   //E_Color,
// SYMBOL
   //u_Symbol,
// SPACE
   //e_GeometryElement,
// TOPOL
   //e_TopoLElements;
   //E_TplPrp;



{ TPolyLineElementInterpret }



procedure TPolyLineElementInterpret.Process(Element: TElement);
var
   i: integer;
   IX,IY: double;
   Lin: TPolyLineElement;
   R,RR: double;
begin
    Device.Pen.Style:= psSolid;
    Device.Pen.Color:= Color;
    Device.Pen.Width:= 1;
    Lin := TPolyLineElement(Element);

    IX:= T2DCoordinate(Lin.Elements[0]).X;
    IY:= T2DCoordinate(Lin.Elements[0]).Y;
    Device.MoveTo(IX, IY);

    for I:= 1 to Lin.Count-1 do
    begin
      IX:= T2DCoordinate(Lin.Elements[I]).X;
      IY:= T2DCoordinate(Lin.Elements[I]).Y;
      Device.LineTo(IX, IY);
    end;
    if LinePoints then
    begin
       Device.Pen.Color:= clRed;
       Device.Brush.Style := bsClear;
       RR := Device.Projection.GetModelLength(3);
       for I:= 0 to Lin.Count-1 do
       begin
          if I = 0 then R := RR*1.5
                   else R := RR;
          IX:= T2DCoordinate(Lin.Elements[I]).X;
          IY:= T2DCoordinate(Lin.Elements[I]).Y;
          Device.Rectangle(IX-R,IY-R,IX+R,IY+R);
       end;
    end;
end;



function  TPolyLineElementInterpret.IsItsClass(AObject: TObject): boolean;
begin
   result := AObject is TPolyLineElement;
end;



function  TPolyLineElementInterpret.QGoInside(Element: TElement): boolean;
begin
  Result:= false;
end;



function  TPolyLineElementInterpret.QProcessBefore(Element: TElement): boolean;
var
  ModelLength: double;
begin
  result:= false;
  if not (Element is TPolyLineElement) then exit;
  try
    if not TPolyLineElement(Element).IsOverRegion
            (Rect.MinX,Rect.MinY,Rect.MaxX,Rect.MaxY) then exit;
    Result:= true

  except
  end;
end;


procedure   TPolyLineElementInterpret.Reset(aDevice: TDevice);
begin
   inherited Reset(aDevice);
end;

procedure   TPolyLineElementInterpret.Close;
begin
   inherited Close;
end;


function  TPolyLineElementInterpret.CanUniGoInside(Element: TElement): boolean;
begin
   result := false;
end;



procedure TPolyLineElementInterpret.SetColor(const Value: integer);
begin
   FColor := Value;
end;

procedure TPolyLineElementInterpret.SetShowPoints(const Value: boolean);
begin
   FShowPoints := Value;
end;

INITIALIZATION
   RegisterOrbisClass(TPolyLineElementInterpret);
END.
