unit t_OilPro1;

interface
uses
   Elements,
   e_Files,
   e_Type,
   G_Elems,
   t_OilPro,
   Tools;

type

TFindOrCreateElement = class(TCreateElement)
public
   procedure DoIt; override;
end;


TFindClassInOwnersWithOwner = class(TTool)
  private
    FNameOfClass: string;
    FanOwner: TEntity;
    FaFirst: boolean;
    procedure SetanOwner(const Value: TEntity);
    procedure SetNameOfClass(const Value: string);
    procedure SetaFirst(const Value: boolean);
public
   function NumberToPropertyName(aNumber: longInt): string;override;
   procedure DoIt; override;
published
   property NameOfClass: string read FNameOfClass write SetNameOfClass;
   property anOwner: TEntity read FanOwner write SetanOwner;
   property aFirst: boolean read FaFirst write SetaFirst;
end;

TIsMyOwner = class(TResultTool)
  private
    FanEntity: TEntity;
    procedure SetanEntity(const Value: TEntity);
public
   function NumberToPropertyName(aNumber: longInt): string;override;
   procedure DoIt; override;
published
   property anEntity: TEntity read FanEntity write SetanEntity;
end;


TSumProperty = class(TResultTool)
  private
    FPropertyToSum: string;
    FDigit: integer;
    procedure SetPropertyToSum(const Value: string);
    procedure SetDigit(const Value: integer);
public
   function NumberToPropertyName(aNumber: longInt): string;override;
   procedure DoIt; override;
published
   property PropertyToSum: string read FPropertyToSum write SetPropertyToSum;
   property Digit: integer read FDigit write SetDigit;
end;
{ TODO -oPPK -cDodlat : IncProperty a CatProperty }

TAverageProperty = class(TResultTool)
private
    FDigit: integer;
    FPropertyToAverage: string;
    FPropertyToWeight: string;
    procedure SetDigit(const Value: integer);
    procedure SetPropertyToAverage(const Value: string);
    procedure SetPropertyToWeight(const Value: string);
public
   function NumberToPropertyName(aNumber: longInt): string;override;
   procedure DoIt; override;
published
   property PropertyToAverage: string read FPropertyToAverage write SetPropertyToAverage;
   property PropertyToWeight: string read FPropertyToWeight write SetPropertyToWeight;
   property Digit: integer read FDigit write SetDigit;
end;

TSumVectors = class(TResultTool)
private
    FDigit: integer;
    FPropertyToValue: string;
    FPropertyToAngle: string;
    procedure SetDigit(const Value: integer);
    procedure SetPropertyToAngle(const Value: string);
    procedure SetPropertyToValue(const Value: string);
public
   function NumberToPropertyName(aNumber: longInt): string;override;
   procedure DoIt; override;
published
   property PropertyToAngle: string  read FPropertyToAngle write SetPropertyToAngle;
   property PropertyToValue: string read FPropertyToValue write SetPropertyToValue;
   property Digit: integer read FDigit write SetDigit;
end;

TInc = class(TTool)
  private
    FIncValue: integer;
    procedure SetIncValue(const Value: integer);// inkrementace int hodnoty
// input TIntegerElement
public
   function NumberToPropertyName(aNumber: longInt): string;override;
   procedure DoIt; override;
published
   property IncValue: integer read FIncValue write SetIncValue stored false;
end;

TRoundTo = class(TResultTool)
  private
    FaValue: double;
    FaDigit: integer;
    procedure SetaDigit(const Value: integer);
    procedure SetaValue(const Value: double);
public
   function NumberToPropertyName(aNumber: longInt): string;override;
   procedure DoIt; override;
published
   property aValue: double read FaValue write SetaValue;
   property aDigit: integer read FaDigit write SetaDigit;
end;

// Nacpe Uhel do 2 PI
TAngle22PI = class(TResultTool)
  private
    FaValue: double;
    procedure SetaValue(const Value: double);
public
   function NumberToPropertyName(aNumber: longInt): string;override;
   procedure DoIt; override;
published
   property aValue: double read FaValue write SetaValue;
end;

TDistance = class(TResultTool)
  private
    FY1: double;
    FY2: double;
    FX2: double;
    FX1: double;
    procedure SetX1(const Value: double);
    procedure SetX2(const Value: double);
    procedure SetY1(const Value: double);
    procedure SetY2(const Value: double);
public
   function NumberToPropertyName(aNumber: longInt): string;override;
   procedure DoIt; override;
published
   property X1: double read FX1 write SetX1;
   property Y1: double read FY1 write SetY1;
   property X2: double read FX2 write SetX2;
   property Y2: double read FY2 write SetY2;
end;

T_Angle = class(TDistance)
public
   procedure DoIt; override;
end;


// Concatenation retezeni stringu
// Input TStringElement
// je-li input nil, vrac na output novy TStringElement
TCat = class(TResultTool)
  private
    FNextString: string;
    procedure SetNextString(const Value: string);
public
   function NumberToPropertyName(aNumber: longInt): string;override;
   procedure DoIt; override;
published
   property NextString: string read FNextString write SetNextString stored false;
end;

// vytahne z retezce cislo i parciln
TStringToInteger = class(TResultTool)
private
    FaString: string;
    procedure SetaString(const Value: string);
public
   function NumberToPropertyName(aNumber: longInt): string;override;
   procedure DoIt; override;
published
   property aString: string read FaString write SetaString;
end;

TStringToDelimiter = class(TResultTool)
  private
    FaStart: integer;
    FaDelimiter: string;
    FaString: string;
    procedure SetaDelimiter(const Value: string);
    procedure SetaStart(const Value: integer);
    procedure SetaString(const Value: string);
public
   function NumberToPropertyName(aNumber: longInt): string;override;
   procedure DoIt; override;
published
   property aString: string read FaString write SetaString;
   property aDelimiter: string read FaDelimiter write SetaDelimiter;
   property aStart: integer read FaStart write SetaStart;
end;

TStringCopy = class(TResultTool)
private
    FaStart: integer;
    FaCount: integer;
    FaString: string;
    procedure SetaCount(const Value: integer);
    procedure SetaStart(const Value: integer);
    procedure SetaString(const Value: string);
public
   function NumberToPropertyName(aNumber: longInt): string;override;
   procedure DoIt; override;
published
   property aString: string read FaString write SetaString;
   property aStart: integer read FaStart write SetaStart;
   property aCount: integer read FaCount write SetaCount;
end;

TUpperCase = class(TResultTool)
  private
    FText: string;
    procedure SetText(const Value: string);
public
   function NumberToPropertyName(aNumber: longInt): string;override;
   procedure DoIt; override;
published
   property Text: string read FText write SetText;
end;

TStringReplace = class(TResultTool)
  private
    FOldPattern: string;
    FNewPattern: string;
    FaString: string;
    procedure SetaString(const Value: string);
    procedure SetNewPattern(const Value: string);
    procedure SetOldPattern(const Value: string);
public
   function NumberToPropertyName(aNumber: longInt): string;override;
   procedure DoIt; override;
published
   property aString: string read FaString write SetaString;
   property OldPattern: string read FOldPattern write SetOldPattern;
   property NewPattern: string read FNewPattern write SetNewPattern;
end;

TStringTranslate = class(TStringReplace)
private
   FTranslateTable: TStringListELement;
    function GetTtranslateTable: TStringListElement;
    procedure SetTranslateTable(const Value: TStringListElement);
public
   function NumberToPropertyName(aNumber: longInt): string;override;
   procedure DoIt; override;
published
   property TranslateTable: TStringListElement read GetTtranslateTable write SetTranslateTable;
end;

TConvertCodePage = class(TResultTool)
  private
    FText: string;
    FCP1: string;
    FCP2: string;
    procedure SetText(const Value: string);
    procedure SetCP1(const Value: string);
    procedure SetCP2(const Value: string);
public
   function NumberToPropertyName(aNumber: longInt): string;override;
   procedure DoIt; override;
published
   property Text: string read FText write SetText;
   property CP1: string read FCP1 write SetCP1;
   property CP2: string read FCP2 write SetCP2;
end;

TGetPropertyStringByName = class(TResultTool)
  private
    FPropertyName: string;
    procedure SetPropertyName(const Value: string);
public
   function NumberToPropertyName(aNumber: longInt): string; override;
   procedure DoIt; override;
published
   property PropertyName: string read FPropertyName write SetPropertyName;
end;

TSetPropertyStringByName = class(TTool)
  private
    FPropertyName: string;
    FPropertyValue: string;
    procedure SetPropertyName(const Value: string);
    procedure SetPropertyValue(const Value: string);
public
   function NumberToPropertyName(aNumber: longInt): string; override;
   procedure DoIt; override;
published
   property PropertyName: string read FPropertyName write SetPropertyName;
   property PropertyValue: string read FPropertyValue write SetPropertyValue;
end;

TWGS84toJTSK = class(TTool)
  private
    FLongitude: double;
    FLatitude: double;
    FCoord: T2DCoordinate;
    procedure SetLatitude(const Value: double);
    procedure SetLongitude(const Value: double);
    procedure SetCoord(const Value: T2DCoordinate);
public
   function NumberToPropertyName(aNumber: longInt): string; override;
   procedure DoIt; override;
published
   property Coord: T2DCoordinate read FCoord write SetCoord;
   property Latitude: double read FLatitude write SetLatitude;
   property Longitude: double read FLongitude write SetLongitude;
end;

TJTSKtoWGS84 = class(TTool)
  private
    FX: double;
    FY: double;
    FCoord: T2DCoordinate;
    procedure SetX(const Value: double);
    procedure SetY(const Value: double);
    procedure SetCoord(const Value: T2DCoordinate);
public
   function NumberToPropertyName(aNumber: longInt): string; override;
   procedure DoIt; override;
published
   property Coord: T2DCoordinate read FCoord write SetCoord;
   property X: double read FX write SetX;
   property Y: double read FY write SetY;
end;

TCreateElementCopy = class(TTool)
public
   procedure DoIt; override;
end;

TGetAbsoluteFilePath = class(TResultTool)
  private
    FRootPath: string;
    FPath: string;
    procedure SetPath(const Value: string);
    procedure SetRootPath(const Value: string);
public
   function NumberToPropertyName(aNumber: longInt): string; override;
   procedure DoIt; override;
published
   property Path: string read FPath write SetPath;
   property RootPath: string read FRootPath write SetRootPath;
end;

TGetRelativeFilePath = class(TGetAbsoluteFilePath)
public
   procedure DoIt; override;
end;

{
   MoveElement (anElement,Where,aNumber)
     anElement ... Element kterym se bude hybat
     Where  ...... smer nebo umisteni
            UP ... o 1 misto nahoru
            DOWN . o 1 misto dolu
            FIRST  jako prvni
            LAST   jako posledni
     aNumber ...... pocet susnu o kolik se index posune (u First a Last nema smysl)
                   defoult je jedna
}
TMoveElement = class(TTool)
  private
    FWhere: string;
    FanElement: TElement;
    FanEntity: TEntity;
    FanIndex: integer;
    FaNumber: integer;
    FMoveDown: boolean;
    procedure SetanElement(const Value: TElement);
    procedure SetWhere(const Value: string);
    procedure SetanEntity(const Value: TEntity);
    procedure SetanIndex(const Value: integer);
    procedure SetaNumber(const Value: integer);
    procedure SetMoveDown(const Value: boolean);
public
   function NumberToPropertyName(aNumber: longInt): string; override;
   procedure DoIt; override;
   procedure MoveFirst;
   procedure MoveLast;
   procedure Move;
   property  anEntity: TEntity read FanEntity write SetanEntity;
   property  anIndex: integer read FanIndex write SetanIndex;
   property  MoveDown: boolean read FMoveDown write SetMoveDown;
published
   property anElement: TElement read FanElement write SetanElement;
   property Where: string read FWhere write SetWhere;
   property aNumber: integer read FaNumber write SetaNumber;
end;

TRunProcess = class(TTool)
private
    FParams: string;
    FFileName: string;
    procedure SetFileName(const Value: string);
    procedure SetParams(const Value: string);
public
   function NumberToPropertyName(aNumber: longInt): string; override;
   procedure DoIt; override;
published
   property FileName: string read FFileName write SetFileName;
   property Params: string read FParams write SetParams;
end;


TDeleteFile = class(TResultTool)
private
    FFileName: string;
    procedure SetFileName(const Value: string);
public
   function NumberToPropertyName(aNumber: longInt): string; override;
   procedure DoIt; override;
published
   property FileName: string read FFileName write SetFileName;
end;

TCopyFile = class(TDeleteFile)
  private
    FFileName1: string;
    FProgressSize: integer;
    procedure SetFileName1(const Value: string);
    procedure SetProgressSize(const Value: integer);
public
   function NumberToPropertyName(aNumber: longInt): string; override;
   procedure DoIt; override;
published
   property FileName1: string read FFileName1 write SetFileName1;
   property ProgressSize: integer read FProgressSize write SetProgressSize;
end;

TRenameFile = class(TCopyFile)
public
   procedure DoIt; override;
end;

TFileExists = class(TDeleteFile)
public
   procedure DoIt; override;
end;

TDirectoryExists = class(TDeleteFile)
public
   procedure DoIt; override;
end;

TCopyDirectory = class(TresultTool)
  private
    FDirectory: string;
    FDirectory1: string;
    FProgr: integer;
    procedure SetDirectory(const Value: string);
    procedure SetDirectory1(const Value: string);
public
   function NumberToPropertyName(aNumber: longInt): string; override;
   procedure DoIt; override;
   procedure ProcessDir(aDir: TDirectoryElement; const aDestPath: string);
published
   property Directory: string read FDirectory write SetDirectory;
   property Directory1: string read FDirectory1 write SetDirectory1;
end;

TForceDirectories = class(TResultTool)
  private
    FDirectory: string;
    procedure SetDirectory(const Value: string);
public
   function NumberToPropertyName(aNumber: longInt): string; override;
   procedure DoIt; override;
published
   property Directory: string read FDirectory write SetDirectory;
end;

THTMLHelp = class(TResultTool)
  private
    FFileName: string;
    procedure SetFileName(const Value: string);
public
   function NumberToPropertyName(aNumber: longInt): string; override;
   procedure DoIt; override;
published
   property FileName: string read FFileName write SetFileName;
end;

TPaletteColorToRGB = class(TResultTool)
  private
    FWinTopol: boolean;
    FaColor: integer;
    procedure SetaColor(const Value: integer);
    procedure SetWinTopol(const Value: boolean);
public
   function NumberToPropertyName(aNumber: longInt): string; override;
   procedure DoIt; override;
published
   property aColor: integer read FaColor write SetaColor;
   property WinTopol: boolean read FWinTopol write SetWinTopol;
end;

TDBTableDefinitionFromFile = class(TTool)
  private
    FFileName: string;
    procedure SetFileName(const Value: string);
public
   function  NumberToPropertyName(aNumber: longInt): string; override;
   procedure DoIt; override;
published
   property FileName: string read FFileName write SetFileName;
end;

TCreateTable = class(TResultTool)
  private
    FTableName: string;
    FDBFDefinition: TEntity;
    FCRTFileName: string;
    function GetDBDefinition: TEntity;
    procedure SetNextFieldDef(const Value: string);
    procedure SetTableName(const Value: string);
    procedure SetCRTFileName(const Value: string);
public
   function  NumberToPropertyName(aNumber: longInt): string; override;
   procedure DoIt; override;
   property  DBFDefinition: TEntity read GetDBDefinition;
published
   property TableName: string read FTableName write SetTableName;
   property CRTFileName: string read FCRTFileName write SetCRTFileName;
   property NextFieldDef: string write SetNextFieldDef;
end;

TGetSimpleGeometryByXY = class(TTool)
  private
    FY: double;
    FX: double;
    FTolerance: double;
    procedure SetX(const Value: double);
    procedure SetY(const Value: double);
    procedure SetTolerance(const Value: double);
public
   function  NumberToPropertyName(aNumber: longInt): string; override;
   procedure DoIt; override;
published
   property X: double read FX write SetX;
   property Y: double read FY write SetY;
   property Tolerance: double read FTolerance write SetTolerance;
end;

TLineAngleAtXY = class(TResultTool)
  private
    FY: double;
    FX: double;
    FTolerance: double;
    procedure SetTolerance(const Value: double);
    procedure SetX(const Value: double);
    procedure SetY(const Value: double);
public
   function  NumberToPropertyName(aNumber: longInt): string; override;
   procedure DoIt; override;
published
   property X: double read FX write SetX;
   property Y: double read FY write SetY;
   property Tolerance: double read FTolerance write SetTolerance;
end;

TLineSwapDirection = class(TResultTool)
public
   procedure DoIt; override;
end;

TPrinterInfo = class(TTool)
public
   function NumberToPropertyName(aNumber: longInt): string;override;
   procedure DoIt; override;
end;


implementation
uses
   Classes,
   Forms,
   ShellApi,
   Windows,
   u_Math,
   SysUtils,
   cpConvrt,
   CreaDbf,
   e_Class,
   e_Color,
   e_Device,
   e_GeometryElement,
   e_Geometry,
   m_Orbis,
   t_Coord,
   r_WGS84,
   MathLib,
   Printers_f,
   u_Shell,
   u_String;

{ TFindOrCreateElement }

procedure TFindOrCreateElement.DoIt;
var
   Cl:TElementClass;
   aEl:TElement;
   aEnt:TEntity;
begin
   if Input=nil then {raise error}
   else
   begin
      if not(Input is TEntity) then{raise error}
      else
      begin
         aEnt:=TEntity(Input);
         CL:=GetOrbisClass(NameOfClass);
         if CL=nil then {raise neexistuje class}
         else
         begin
            aEl := aEnt.FindOrCreateElementName(CL,ElementName);
            Output:=aEl;
         end;
      end;
   end;
end;

{ TFindClassInOwnersWithOwner }

procedure TFindClassInOwnersWithOwner.DoIt;
var
   EC: TElementClass;
begin
   Output := nil;
   if Input = nil then exit;
   if anOwner = nil then exit;
   EC := GetOrbisClass(NameOfClass);
   if EC = nil then exit;
   if aFirst then
      Output := Input.FindFirstClassWithOwnerInOwners(EC,anOwner)
   else
      Output := Input.FindClassWithOwnerInOwners(EC,anOwner);
end;

function TFindClassInOwnersWithOwner.NumberToPropertyName(aNumber: Integer): string;
begin
case aNumber of
   0:result:='NameOfClass';
   1:result:='anOwner';
   2:result:='aFirst';
   else result:='';
   end;{case}
end;

procedure TFindClassInOwnersWithOwner.SetaFirst(const Value: boolean);
begin
  FaFirst := Value;
end;

procedure TFindClassInOwnersWithOwner.SetanOwner(const Value: TEntity);
begin
  FanOwner := Value;
end;

procedure TFindClassInOwnersWithOwner.SetNameOfClass(const Value: string);
begin
  FNameOfClass := Value;
end;

{ TSumProperty }

procedure TSumProperty.DoIt;
var
   D: extended;
   En: TEntity;
   e: TElement;
   i: integer;
   S: string;
begin
   Result := '0';
   D := 0;
   if Input = nil then exit;
   if not (Input is TEntity) then exit;
   En := TEntity(Input);
   if En.NoElements then exit;
   if PropertyToSum = '' then exit;
   for i := 0 to En.LastIndex do
   begin
      e := En.Elements[i];
      S := e.GetPropertyStringByName(PropertyToSum);
      D := D + StrToExtended(S);
   end;
   if Digit <> 0 then
      D := Simple_RoundTo(D,Digit);
   Result := FloatToStr(D);
end;

function TSumProperty.NumberToPropertyName(aNumber: Integer): string;
begin
case aNumber of
   0:result:='PropertyToSum';
   1:result:='Digit';
   else result:='';
   end;{case}
end;

procedure TSumProperty.SetDigit(const Value: integer);
begin
  FDigit := Value;
end;

procedure TSumProperty.SetPropertyToSum(const Value: string);
begin
  FPropertyToSum := Value;
end;

{ TInc }

procedure TInc.DoIt;
var
   ie: TIntegerElement;
begin
   if input = nil then exit;
   if not (input is TIntegerElement) then exit;
   ie := TIntegerElement(Input);
   ie.Value := ie.Value + IncValue;
end;

function TInc.NumberToPropertyName(aNumber: Integer): string;
begin
   case aNumber of
      0:result:='IncValue';
      else result:='';
      end;{case}
end;

procedure TInc.SetIncValue(const Value: integer);
begin
   FIncValue := Value;
end;

{ TCat }

procedure TCat.DoIt;
var
   ie: TStringElement;
begin
   ie := nil;
   Result := '';
   if (input <> nil) and (input is TStringElement) then
   begin
     ie := TStringElement(Input);
     Result := ie.Value;
   end;
   Result := Result + NextString;
   if ie <> nil then
      ie.Value := Result;
end;

function TCat.NumberToPropertyName(aNumber: Integer): string;
begin
   result:='NextString';
end;

procedure TCat.SetNextString(const Value: string);
begin
  FNextString := FNextString + Value;
end;

{ TGetPropertyStringByName }

procedure TGetPropertyStringByName.DoIt;
begin
   result := '';
   if Input <> nil then
      result := Input.GetPropertyStringByName(PropertyName);
end;

function TGetPropertyStringByName.NumberToPropertyName(aNumber: Integer): string;
begin
   result := 'PropertyName'
end;

procedure TGetPropertyStringByName.SetPropertyName(const Value: string);
begin
  FPropertyName := Value;
end;

{ TSetPropertyStringByName }

procedure TSetPropertyStringByName.DoIt;
begin
   if Input <> nil then
      Input.SetPropertyStringByName(PropertyName,PropertyValue);
end;

function TSetPropertyStringByName.NumberToPropertyName(aNumber: Integer): string;
begin
   case aNumber of
      0: result := 'PropertyName';
   else
      result := 'PropertyValue';
   end;
end;

procedure TSetPropertyStringByName.SetPropertyName(const Value: string);
begin
  FPropertyName := Value;
end;

procedure TSetPropertyStringByName.SetPropertyValue(const Value: string);
begin
  FPropertyValue := Value;
end;

{ TCreateElementCopy }

procedure TCreateElementCopy.DoIt;
begin
   Output := nil;
   if Input = nil then exit;
   Output := CreateElementCopy(Input);
end;

{ TGetAbsoluteFilePath }

procedure TGetAbsoluteFilePath.DoIt;
begin
   result := GetAbsolutePath(RootPath, Path);
end;
{
procedure TGetAbsoluteFilePath.DoIt;
var
   S: string;
begin
   if RootPath = '' then
   begin
      result := GetAbsolutePath(Path);
   end
   else
   begin
      S := RootPath;
      CheckBackSlash(S);
      if Path = '' then
      begin
         result := S;
         exit;
      end;
      if pos(':',Path) = 0 then
      begin
         result := S + Path;
      end
      else
         result := Path;
   end;
end;
}
function TGetAbsoluteFilePath.NumberToPropertyName(aNumber: Integer): string;
begin
   case aNumber of
      0: result := 'Path';
      1: result := 'RootPath';
   end;
end;

procedure TGetAbsoluteFilePath.SetPath(const Value: string);
begin
  FPath := Value;
end;

procedure TGetAbsoluteFilePath.SetRootPath(const Value: string);
begin
  FRootPath := Value;
end;

{ TGetRelativeFilePath }

procedure TGetRelativeFilePath.DoIt;
var
   S: string;
   S1: string;
begin
   if pos(':',Path) > 0 then
   begin
      S := '';
      if RootPath = '' then
         S := GetAbsolutePath(S)
      else
         S := RootPath;
      CheckBackSlash(S);
      S := AnsiUpperCase(S);
      S1 := AnsiUpperCase(Path);
      if Pos(S,S1) = 1 then
      begin
         result := copy(Path,Length(S)+1,Length(S1)-Length(S));
      end
      else
         result := Path;
   end
   else
   begin
      result := Path;
   end;
end;

{ TMoveElement }

procedure TMoveElement.DoIt;
var
   En: TEntity;
   Ix: integer;
   CH: char;
begin
   if Input = nil then exit;
   if not (Input is TEntity) then exit;
   En := TEntity(Input);
   anEntity := En;
   if anElement = nil then exit;
   if not anElement.IsMyOwner(En) then exit;
   Ix := En.IndexOf(anElement);
   anIndex := Ix;
   if aNumber = 0 then
      aNumber := 1;
   if Where = '' then
      Where := 'D';
   CH := UpperCase(Where)[1];
   case CH of
      'F': MoveFirst;
      'L': MoveLast;
      'U': begin
              MoveDown := false;
              Move;
           end;
      'D': begin
              MoveDown := true;
              Move;
           end;
   end;
end;

procedure TMoveElement.Move;
var
   Ix: integer;
   i: integer;
begin
   if MoveDown then
   begin
      Ix := anIndex + aNumber;
      if Ix >= anEntity.LastIndex then
      begin
         MoveLast;
         exit;
      end;
      for i := anIndex to Ix - 1 do
      begin
         anEntity.ExchangeElementsIndex(i, i + 1);
      end;
   end
   else
   begin
      Ix := anIndex - aNumber;
      if Ix <= 0 then
      begin
         MoveFirst;
         exit;
      end;
      for i := anIndex Downto Ix + 1 do
      begin
         anEntity.ExchangeElementsIndex(i, i - 1);
      end;
   end;
end;

procedure TMoveElement.MoveFirst;
begin
   if anIndex = 0 then exit;
   anEntity.RemoveElement(anElement);
   anEntity.InsertElement(0,anElement);
end;

procedure TMoveElement.MoveLast;
var
   Ix: integer;
begin
   Ix := anEntity.LastIndex;
   if anIndex = Ix then exit;
   anEntity.RemoveElement(anElement);
   anEntity.AddElement(anElement);
end;

function TMoveElement.NumberToPropertyName(aNumber: Integer): string;
begin
   case aNumber of
      0:result:='anElement';
      1:result:='Where';
      2:result:='aNumber';
   else
      result:='';
   end;{case}
end;

procedure TMoveElement.SetaNumber(const Value: integer);
begin
  FaNumber := Value;
end;

procedure TMoveElement.SetanElement(const Value: TElement);
begin
  FanElement := Value;
end;

procedure TMoveElement.SetanEntity(const Value: TEntity);
begin
  FanEntity := Value;
end;

procedure TMoveElement.SetanIndex(const Value: integer);
begin
  FanIndex := Value;
end;

procedure TMoveElement.SetWhere(const Value: string);
begin
  FWhere := Value;
end;

procedure TMoveElement.SetMoveDown(const Value: boolean);
begin
  FMoveDown := Value;
end;

{ TUpperCase }

procedure TUpperCase.DoIt;
begin
   if Text = '' then exit;
   result := AnsiUpperCase(Text);
end;

function TUpperCase.NumberToPropertyName(aNumber: Integer): string;
begin
   result:='Text';
end;

procedure TUpperCase.SetText(const Value: string);
begin
  FText := Value;
end;

{ TConvertCodePage }

procedure TConvertCodePage.DoIt;
var
   C1, C2: char;
   L1,L2: integer;
   {
   0: IBM,ANSI
   1: windows,1250
   2: Latin2,852
   3: Kamenici
   4: 8859_2
   5: utf8
   }
   function CPCode(aCH: char; aCP:string): integer;
   begin
      result := -1;
      case aCH of
         'i': if aCP = 'ibm' then
                 result := 0;
         'a': if aCP = 'ans' then
                 result := 0;
         '1': if aCP = '125' then
                 result := 1;
         'w': if aCP = 'win' then
                 result := 1;
         'l': if aCP = 'lat' then
                 result := 2;
         '8': if aCP = '852' then
                 result := 2
              else if aCP = '885' then
                 result := 4;
         'k': if aCP = 'kam' then
                 result := 3;
         'u': if aCP = 'utf' then
                 result := 5;

      end;
   end;
begin
   result := Text;
   if CP1 = CP2 then exit;
   if (CP1 = '') or (CP2 = '') or (Length(CP1) < 3) or (Length (CP2) < 3) then exit;
   C1 := CP1[1];
   C2 := CP2[1];
   L1 := CPCode(C1,Copy(CP1,1,3));
   L2 := CPCode(C2,Copy(CP2,1,3));
   if (L1 < 0) or (L2 < 0) then exit;
   //if not (CP1 in [852,1250]) then exit;
   //if not CP2 in  [0,852,1250] then exit;
   case L1 of
      1:
      case L2 of
         0: result := WinToIBM(Text);
         2: result := WinTo852(Text);
         4: result := WinTo_8859_2(Text);
         5: result := AnsiToUtf8(Text);
      end;
      2:
      case L2 of
         0: result := WinToIBM(cp852ToWin(Text));
         1: result := cp852ToWin(Text);
         4: result := WinTo_8859_2(cp852ToWin(Text));
         5: result := AnsiToUtf8(cp852ToWin(Text));
      end;
      5:
      case L2 of
         0: result := WinToIBM(Utf8ToAnsi(Text));
         1: result := Utf8ToAnsi(Text);
         2: result := WinTo852(Utf8ToAnsi(Text));
         4: result := WinTo_8859_2(Utf8ToAnsi(Text));
      end;
   end;
end;

function TConvertCodePage.NumberToPropertyName(aNumber: Integer): string;
begin
   case aNumber of
      0: result :='Text';
      1: result := 'CP1';
      2: result := 'CP2';
   end;{case}
end;

procedure TConvertCodePage.SetCP1(const Value: string);
begin
  FCP1 := LowerCase(Value);
end;

procedure TConvertCodePage.SetCP2(const Value: string);
begin
  FCP2 := LowerCase(Value);
end;

procedure TConvertCodePage.SetText(const Value: string);
begin
   FText := Value;
end;

{ TRunProcess }

procedure TRunProcess.DoIt;
begin
   if FileName = '' then
   begin
      if Params <> '' then
            ShellExecute(0, Nil, PChar(Params), Nil, Nil, SW_NORMAL);
      exit;
   end;
   _CreateProcess(FileName,Params);
end;

function TRunProcess.NumberToPropertyName(aNumber: Integer): string;
begin
   case aNumber of
      0:result:='FileName';
      1:result:='Params';
   end;
end;

procedure TRunProcess.SetFileName(const Value: string);
begin
  FFileName := Value;
end;

procedure TRunProcess.SetParams(const Value: string);
begin
  FParams := Value;
end;

{ TDeleteFile }

procedure TDeleteFile.DoIt;
begin
   if FileExists(FileName) then
      DeleteFile(PChar(FileName));
end;

function TDeleteFile.NumberToPropertyName(aNumber: Integer): string;
begin
   result := 'FileName';
end;

procedure TDeleteFile.SetFileName(const Value: string);
begin
   FFileName := Value;
end;

{ TRoundTo }

procedure TRoundTo.DoIt;
var
   FE: TFloatElement;
   D: double;
begin
   FE := nil;
   if Input is TFloatElement then
   begin
      FE := TFloatElement(Input);
      aValue := FE.Value;
   end;
   D := Simple_RoundTo(aValue,aDigit);
   if FE <> nil then
      FE.Value := D;
   result := FloatToStr(D);
end;

function TRoundTo.NumberToPropertyName(aNumber: Integer): string;
begin
   if (Input <> nil) and (Input Is TFloatElement) then
   begin
      case aNumber of
         0: result := 'aDigit';
      end;
   end
   else
   begin
      case aNumber of
         0: result := 'aValue';
         1: result := 'aDigit';
      end;
   end;
end;

procedure TRoundTo.SetaDigit(const Value: integer);
begin
  FaDigit := Value;
end;

procedure TRoundTo.SetaValue(const Value: double);
begin
  FaValue := Value;
end;

{ TRenameFile }

procedure TRenameFile.DoIt;
begin
   Error := 0;
   Result := '';
   if not FileExists(FileName) then
   begin
      Error := 1;
      Result := '1';
      exit;
   end;
   RenameFile(FileName,FileName1);
end;

{ TCopyFile }

procedure TCopyFile.DoIt;
var
   H1,H2: integer;
   Buffer: Pointer;
   ri:integer;
   i: integer;
   ShowProgress: boolean;
   //Stream: TFileStream;
begin
   Error := 0;
   Result := '';
   if not FileExists(FileName) then
   begin
      Error := 1;
      Result := '1';
      exit;
   end;
   H1 := FileOpen(FileName,fmOpenRead);
   if H1 < 0 then
   begin
      Error := 2;
      Result := '2';
      exit;
   end;
   H2 := FileCreate(FileName1);
   if H2 < 0 then
   begin
      Error := 3;
      Result := '3';
      FileClose(H1);
      exit;
   end;
   Application.ProcessMessages;
   i := FileSeek(H1,0,2);
   ShowProgress := false;
   if ProgressSize = 0 then
      ProgressSize := 1024;
   if i > ProgressSize then
   begin
      StartProgress('Copy '+FileName,0,i);
      ProgressText := FileName1;
      //Gauge.MaxValue := i;
      Progress := 0;
      ShowProgress := true;
      Application.ProcessMessages;
   end;
   FileSeek(H1,0,0);
   GetMem(Buffer,1028);
   Application.ProcessMessages;
   i := 0;
   repeat
      ri := FileRead(H1,Buffer^,1024);
      Application.ProcessMessages;
      if ShowProgress then
      begin
         i := i + ri;
         Progress := i;
      end;
      FileWrite(H2,Buffer^,ri);
      Application.ProcessMessages;
   until {Stop or }(ri < 1024);
   FileClose(H1);
   FileClose(H2);
   FreeMem(Buffer,1028)
end;

function TCopyFile.NumberToPropertyName(aNumber: Integer): string;
begin
   case aNumber of
      0: result := 'FileName';
      1: result := 'FileName1';
      2: result := 'ProgressSize';
   end;
end;

procedure TCopyFile.SetFileName1(const Value: string);
begin
  FFileName1 := Value;
end;

procedure TCopyFile.SetProgressSize(const Value: integer);
begin
  FProgressSize := Value;
end;

{ TCopyDirectory }

procedure TCopyDirectory.DoIt;
var
   Dir: TDirectoryElement;
begin
   Result := '0';
   if not DirectoryExists(Directory) then
   begin
      Result := '1';
      exit;
   end;
   if not DirectoryExists(Directory1) then
   begin
      Result := '2';
      exit;
   end;
   CheckBackSlash(FDirectory1);
   StartProgress('copy Dir '+Directory+' to '+Directory1,0,0);
   ProgressText := 'ten sloky ...';
   Application.ProcessMessages;
   Dir := TDirectoryElement.Create;
   AddElement(Dir);
   FProgr := 0;
   Dir.FileName := Directory;
   MaxProgress := Dir.WholeCount;
   ProcessDir(Dir, Directory1);
   Dir.Free;
end;

function TCopyDirectory.NumberToPropertyName(aNumber: Integer): string;
begin
   case aNumber of
      0: result := 'Directory';
      1: result := 'Directory1';
   end;
end;

procedure TCopyDirectory.ProcessDir(aDir: TDirectoryElement; const aDestPath: string);
var
   DS: string;
   i: integer;
   e: TElement;
   DE: TDirectoryElement;
   FE: TFileElement;
   CF: TCopyFile;
begin
   DS := aDestPath + aDir.Name + '\';
   ForceDirectories(DS);
   for i := 0 to aDir.LastIndex do
   begin
      e := aDir.Elements[i];
      Inc(FProgr);
      Progress := FProgr;
      ProgressText := e.Name;
      Application.ProcessMessages;
      if e is TDirectoryElement then
      begin
         DE := TDirectoryElement(e);
         ProcessDir(DE,DS);
      end
      else
      if e is TFileElement then
      begin
         FE := TFileElement(e);
         CF := TCopyFile.Create;
         CF.FileName := FE.FileName;
         CF.FileName1 := DS+FE.Name;
         CF.ProgressSize := 500000;
         CF.DoIt;
         CF.Free;
      end;
   end;
end;

procedure TCopyDirectory.SetDirectory(const Value: string);
begin
  FDirectory := Value;
end;

procedure TCopyDirectory.SetDirectory1(const Value: string);
begin
  FDirectory1 := Value;
end;

{ TForceDirectories }

procedure TForceDirectories.DoIt;
begin
   result := '1';
   if Directory = '' then exit;
   if ForceDirectories(Directory) then
      result := '0';
end;

function TForceDirectories.NumberToPropertyName(aNumber: Integer): string;
begin
   result := 'Directory';
end;

procedure TForceDirectories.SetDirectory(const Value: string);
begin
  FDirectory := Value;
end;

{ TStringToDelimiter }

procedure TStringToDelimiter.DoIt;
var
   S1,S2: string;
   Del: char;
begin
   Result := '';
   if aDelimiter = '' then
      Del := '='
   else
      Del := aDelimiter[1];
   StringAsTwoParams(aString,Del,S1,S2);
   case aStart of
      0: Result := S1;
      1: Result := S2;
   end
end;

function TStringToDelimiter.NumberToPropertyName(aNumber: Integer): string;
begin
   case aNumber of
      0: result := 'aString';
      1: result := 'aDelimiter';
      2: result := 'aStart';
   end;

end;

procedure TStringToDelimiter.SetaDelimiter(const Value: string);
begin
  FaDelimiter := Value;
end;

procedure TStringToDelimiter.SetaStart(const Value: integer);
begin
  FaStart := Value;
end;

procedure TStringToDelimiter.SetaString(const Value: string);
begin
  FaString := Value;
end;

{ THTMLHelp }

function HHelp(hwndCaller : HWND; pszFile: PChar; uCommand : Integer;
            dwData : DWORD) : HWND; stdcall; external 'hhctrl.ocx' name 'HtmlHelpA';


procedure THTMLHelp.DoIt;
//var
//   aResult: HWND;
begin
   {aResult := }HHelp(GetDesktopWindow, PChar(FileName),  0,0);
end;

function THTMLHelp.NumberToPropertyName(aNumber: Integer): string;
begin
   result := 'FileName';
end;

procedure THTMLHelp.SetFileName(const Value: string);
begin
  FFileName := Value;
end;

{ TPaletteColorToRGB }

procedure TPaletteColorToRGB.DoIt;
var
   i: integer;
begin
   //i := 0;
   if WinTopol then
      i := DejBarvickuTopolW(aColor)
   else
      i := DejBarvicku(aColor);
   result := IntToStr(i);
end;

function TPaletteColorToRGB.NumberToPropertyName(aNumber: Integer): string;
begin
   case aNumber of
      0:result:='aColor';
      1:result:='WinTopol';
   else
      result := '';
   end;{case}
end;

procedure TPaletteColorToRGB.SetaColor(const Value: integer);
begin
  FaColor := Value;
end;

procedure TPaletteColorToRGB.SetWinTopol(const Value: boolean);
begin
  FWinTopol := Value;
end;

{ TStringToInteger }

procedure TStringToInteger.DoIt;
var
   S: string;
   ie: TStringElement;
   i: integer;
begin
   Result := '';
   if (input <> nil) and (input is TStringElement) then
   begin
      ie := TStringElement(Input);
      S := ie.Value;
   end
   else
      S := aString;
   i := 1;
   if S <> '' then
   begin
      while not (i > Length(S)) and not (S[i] in ['0'..'9']) do Inc(i);
      while not (i > Length(S)) and (S[i] in ['0'..'9']) do
      begin
         Result := Result + S[i];
         Inc(i);
      end;
   end;
   if Result = '' then
      Result := '0'
   else
   begin
      i := StrToIntDef(Result,0); // odstraneni nul na zacetku
      Result := IntToStr(i);
   end;
end;

function TStringToInteger.NumberToPropertyName(aNumber: Integer): string;
begin
   result:='aString';
end;

procedure TStringToInteger.SetaString(const Value: string);
begin
  FaString := Value;
end;

{ TAverageProperty }

procedure TAverageProperty.DoIt;
var
   D,Dw: extended;
   P,Pw: extended;
   En: TEntity;
   e: TElement;
   i: integer;
   S,Sw: string;
   DoWeight: boolean;
begin
   Result := '0';
   D := 0;
   Dw := 0;
   if Input = nil then exit;
   if not (Input is TEntity) then exit;
   En := TEntity(Input);
   if En.NoElements then exit;
   if PropertyToAverage = '' then exit;
   DoWeight := PropertyToWeight <> '';
   if not DoWeight then
      Dw := En.Count;
   for i := 0 to En.LastIndex do
   begin
      e := En.Elements[i];
      S := e.GetPropertyStringByName(PropertyToAverage);
      P := StrToExtended(S);
      if DoWeight then
      begin
         Sw := e.GetPropertyStringByName(PropertyToWeight);
         Pw := StrToExtended(Sw);
         if Pw <= 0 then
            Pw := 1;
         P := P * Pw;
         Dw := Dw + Pw;
      end;
      D := D + P;
   end;
   D := D / Dw;
   if Digit <> 0 then
      D := Simple_RoundTo(D,Digit);
   Result := FloatToStr(D);
end;

function TAverageProperty.NumberToPropertyName(aNumber: Integer): string;
begin
case aNumber of
   0:result:='PropertyToAverage';
   1:result:='Digit';
   2:result:='PropertyToWeight';
   else result:='';
   end;{case}
end;

procedure TAverageProperty.SetDigit(const Value: integer);
begin
  FDigit := Value;
end;

procedure TAverageProperty.SetPropertyToAverage(const Value: string);
begin
  FPropertyToAverage := Value;
end;

procedure TAverageProperty.SetPropertyToWeight(const Value: string);
begin
  FPropertyToWeight := Value;
end;

{ TSumVectors }

procedure TSumVectors.DoIt;
var
   DC,DC0: TDoubleCoord;
   Angle: double;
   Value: double;
   En: TEntity;
   e: TElement;
   i: integer;
   Sa,Sv: string;
begin
   Result := '0';
   DC.X := 0;
   DC.Y := 0;
   DC0 := DC;
   if Input = nil then exit;
   if not (Input is TEntity) then exit;
   En := TEntity(Input);
   if En.NoElements then exit;
   if PropertyToAngle = '' then exit;
   if PropertyToValue = '' then exit;
   for i := 0 to En.LastIndex do
   begin
      e := En.Elements[i];
      Sa := e.GetPropertyStringByName(PropertyToAngle);
      Angle := StrToExtended(Sa);
      Sv := e.GetPropertyStringByName(PropertyToValue);
      Value := StrToExtended(Sv);
      VratPosunutyBod(DC,Angle,Value,DC);
   end;
   XYToPolar(DC0,DC,Value,Angle);

   Angle := Angle - (DvaPi) * int(Angle/DvaPi);
   if Angle < 0 then
      Angle := DvaPi +Angle;
   if Digit <> 0 then
      Angle := Simple_RoundTo(Angle,Digit);
   Result := FloatToStr(Angle);
end;

function TSumVectors.NumberToPropertyName(aNumber: Integer): string;
begin
case aNumber of
   0:result:='PropertyToAngle';
   1:result:='PropertyToValue';
   2:result:='Digit';
   else result:='';
   end;{case}
end;

procedure TSumVectors.SetDigit(const Value: integer);
begin
  FDigit := Value;
end;

procedure TSumVectors.SetPropertyToAngle(const Value: string);
begin
   FPropertyToAngle := Value;
end;

procedure TSumVectors.SetPropertyToValue(const Value: string);
begin
   FPropertyToValue := Value;
end;

{ TStringCopy }

procedure TStringCopy.DoIt;
begin
   Result := '';
   if aStart < 1 then
      exit;
   Result := copy(aString, aStart, aCount);   
end;

function TStringCopy.NumberToPropertyName(aNumber: Integer): string;
begin
   case aNumber of
      0: result := 'aString';
      1: result := 'aStart';
      2: result := 'aCount';
   end;
end;

procedure TStringCopy.SetaCount(const Value: integer);
begin
  FaCount := Value;
end;

procedure TStringCopy.SetaStart(const Value: integer);
begin
  FaStart := Value;
end;

procedure TStringCopy.SetaString(const Value: string);
begin
  FaString := Value;
end;

{ TCreateTable }

procedure TCreateTable.DoIt;
var
   S: string;
   OK: boolean;
begin
   if Error > 0 then
   begin
      result := IntToStr(Error);
      exit;
   end;
   if TableName = '' then
   begin
      Error := 1;
      result := IntToStr(Error);
      exit;
   end;
   if CRTFileName <> '' then
   begin
      S := GetAbsolutePath(CRTFileName);
      VytvorDBFDle(S, TableName, OK);
      if not OK then
         Error := 2;
   end
   else
   begin
      if DBFDefinition.NoElements then
      begin
         Error := 1;
         //ShowMessage('Pro tvorbu DBF Nutno zadat CRT nebo man.definici!');
         result := IntToStr(Error);
         exit;
      end;
      CreateTable(TableName,DBFDefinition);
   end;
   result := IntToStr(Error);
end;

function TCreateTable.GetDBDefinition: TEntity;
begin
   if FDBFDefinition = nil then
   begin
      FDBFDefinition := TStringListElement.Create;
      FDBFDefinition.Name := 'DBF_Def';
      AddElement(FDBFDefinition);
   end;
   result := FDBFDefinition;
end;

function TCreateTable.NumberToPropertyName(aNumber: Integer): string;
begin
   case aNumber of
      0: result := 'TableName'
   else
      result := 'NextFieldDef';
   end
end;

procedure TCreateTable.SetCRTFileName(const Value: string);
begin
  FCRTFileName := Value;
end;

procedure TCreateTable.SetNextFieldDef(const Value: string);
var
   SL: TStringList;
   S: string;
   i: integer;
   FD: TFieldDefElement;
   aName: string;
   aType: char;
   aSize, aDecimal: word;
   uValue: string;
begin
   uValue := AnsiUpperCase(Value);
   i := pos('.CRT',uValue);
   if i <= 0 then
      i := pos('.DBF',uValue);
   if i > 0 then                       // jmeno CRT nebo DBF souboru
   begin
      CRTFileName := uValue;
      exit;
   end;
   //aName := '';
   //aType := 'C';
   //aSize := 3;
   aDecimal := 0;
   SL := TStringList.Create;
   SL.CommaText := Value;
   if SL.Count < 3 then
   begin
      Error := 3;
      //ShowMessage('Error field definition: '+Value);
      exit;
   end;
   aName := SL.Strings[0];
   S := SL.Strings[1];
   aType := S[1];
   S := SL.Strings[2];
   aSize := StrToIntDef(S,3);
   if SL.Count > 3 then
   begin
      S := SL.Strings[3];
      aDecimal := StrToIntDef(S,0);
   end;
   FD := TFieldDefElement.Create;
   FD.SetField(aName,aType,aSize,aDecimal);
   DBFDefinition.NextElement := FD;
end;

procedure TCreateTable.SetTableName(const Value: string);
begin
   FTableName := Value;
end;

{ TGetSimpleGeometryByXY }

procedure TGetSimpleGeometryByXY.DoIt;
var
   GE: TGeometryElement;
begin
   Output := nil;
   if not (Input is TGeometryElement) then exit;
   GE := TGeometryElement(Input);
   Output := GE.GetSimpleGeometryByXY(X,Y,Tolerance);
end;

function TGetSimpleGeometryByXY.NumberToPropertyName(aNumber: Integer): string;
begin
   case aNumber of
      0: result := 'X';
      1: result := 'Y';
      2: result := 'Tolerance';
   end;
end;

procedure TGetSimpleGeometryByXY.SetTolerance(const Value: double);
begin
  FTolerance := Value;
end;

procedure TGetSimpleGeometryByXY.SetX(const Value: double);
begin
  FX := Value;
end;

procedure TGetSimpleGeometryByXY.SetY(const Value: double);
begin
  FY := Value;
end;

{ TAngle22PI }

procedure TAngle22PI.DoIt;
var
   FE: TFloatElement;
   D: double;
   DvaPI: double;
begin
   FE := nil;
   if Input is TFloatElement then
   begin
      FE := TFloatElement(Input);
      aValue := FE.Value;
   end;
   D := Abs(aValue);
   DvaPI := PI*2;
   if D > DvaPi then D := D-(Int(D/DvaPi)*DvaPi);
   if aValue < 0 then
      D := DvaPI - D;
   if FE <> nil then
      FE.Value := D;
   result := FloatToStr(D);
end;

function TAngle22PI.NumberToPropertyName(aNumber: Integer): string;
begin
   result := 'aValue';
end;

procedure TAngle22PI.SetaValue(const Value: double);
begin
  FaValue := Value;
end;

{ TDistance }

procedure TDistance.DoIt;
var
   D: double;
begin
   D := Distance(X1, Y1, X2, Y2);
   result := FloatToStr(D);
end;

function TDistance.NumberToPropertyName(aNumber: Integer): string;
begin
   case aNumber of
      0: result := 'X1';
      1: result := 'Y1';
      2: result := 'X2';
      3: result := 'Y2';
   else result:='';
   end;{case}
end;

procedure TDistance.SetX1(const Value: double);
begin
  FX1 := Value;
end;

procedure TDistance.SetX2(const Value: double);
begin
  FX2 := Value;
end;

procedure TDistance.SetY1(const Value: double);
begin
  FY1 := Value;
end;

procedure TDistance.SetY2(const Value: double);
begin
  FY2 := Value;
end;

{ T_Angle }

procedure T_Angle.DoIt;
var
   D: double;
   L: double;
   A,B: TDoubleCoord;
begin
   A.X := X1;
   A.Y := Y1;
   B.X := X2;
   B.Y := Y2;
   XYToPolar(A, B, L, D);
   result := FloatToStr(D);
end;

{ TStringReplace }

procedure TStringReplace.DoIt;
begin
   Result := StringReplace(aString, OldPattern, NewPattern,[rfReplaceAll, rfIgnoreCase]);
end;

function TStringReplace.NumberToPropertyName(aNumber: Integer): string;
begin
   case aNumber of
      0: result := 'aString';
      1: result := 'OldPattern';
      2: result := 'NewPattern';
   end;
end;

procedure TStringReplace.SetaString(const Value: string);
begin
  FaString := Value;
end;

procedure TStringReplace.SetNewPattern(const Value: string);
begin
  FNewPattern := Value;
end;

procedure TStringReplace.SetOldPattern(const Value: string);
begin
  FOldPattern := Value;
end;

{ TFileExists }

procedure TFileExists.DoIt;
begin
{$IFDEF FILEEVENT}
   PostTextMsg(tm_FileExists,FileName,nil);
   Application.ProcessMessages;
{$ENDIF}
   if FileExists(FileName) then
      result := 'true'
   else
      result := 'false';
end;

{ TDirectoryExists }

procedure TDirectoryExists.DoIt;
begin
   if DirectoryExists(FileName) then
      result := 'true'
   else
      result := 'false';
end;

{ TIsMyOwner }

procedure TIsMyOwner.DoIt;
begin
   result := 'false';
   if input = nil then exit;
   if anEntity = nil then exit;
   if Input.IsMyOwner(anEntity) then
      result := 'true';
end;

function TIsMyOwner.NumberToPropertyName(aNumber: Integer): string;
begin
   result := 'anEntity';
end;

procedure TIsMyOwner.SetanEntity(const Value: TEntity);
begin
  FanEntity := Value;
end;

{ TLineAngleAtXY }

procedure TLineAngleAtXY.DoIt;
var
   L: TPolyLineElement;
   TL: TGeometryElement;
   I: longInt;
   Uvnitr: boolean;
   XP, YP, Vzd: double;
   X1,Y1,X2,Y2: double;
   pAngle: double;
begin
   result := '0';
   if Input = nil then exit;
   if Input Is  TGeometryELement then
   begin
      TL := TGeometryElement(Input);
      if TL.NoGeometry then exit;
      if not (TL.Geometry is TPolyLineElement) then exit;
      L  := TPolyLineElement(TL.Geometry);
   end
   else
   begin
      if not (Input is TPolyLineElement) then exit;
      L := TPolyLineElement(Input);
   end;

   if Tolerance < 0.001 then
      Tolerance := 0.001;
   for I:= 0 to L.Count-2 do
   begin
      X1 := L.Xi[I];
      Y1 := L.Yi[I];
      X2 := L.Xi[I+1];
      Y2 := L.Yi[I+1];
      DejVztahyBod_Usecka(X, Y, X1, Y1, X2, Y2,Uvnitr, Xp, Yp, Vzd);
      if Uvnitr and (Vzd < Tolerance) then
      begin
         pAngle:= Atan2M(X2-X1, Y2-Y1) + Pi/2;
         Result:= FloatToStr(pAngle);
         Break;
      end;
    end;
end;


function TLineAngleAtXY.NumberToPropertyName(aNumber: Integer): string;
begin
   case aNumber of
      0: result := 'X';
      1: result := 'Y';
      2: result := 'Tolerance';
   end;
end;

procedure TLineAngleAtXY.SetTolerance(const Value: double);
begin
  FTolerance := Value;
end;

procedure TLineAngleAtXY.SetX(const Value: double);
begin
  FX := Value;
end;

procedure TLineAngleAtXY.SetY(const Value: double);
begin
  FY := Value;
end;

{ TLineSwapDirection }

procedure TLineSwapDirection.DoIt;
var
   L: TPolyLineElement;
   TL: TGeometryElement;
   QE: TQuickEntity;
   E: TEntity;
   A: TPolyLineAreaElement;
   i: integer;
   iL: integer;
   //Orig: boolean;
begin
   result := '0';
   if Input = nil then exit;
   if Input Is  TGeometryELement then
   begin
      TL := TGeometryElement(Input);
      if TL.NoGeometry then exit;
      if not (TL.Geometry is TPolyLineElement) then exit;
      L  := TPolyLineElement(TL.Geometry);
   end
   else
   begin
      if not (Input is TPolyLineElement) then exit;
      L := TPolyLineElement(Input);
   end;
   QE := TQuickEntity.Create;
   QE.AddAllFrom := L;
   L.Clear;
   for i := QE.LastIndex downto 0 do
      L.AddElement(QE.Elements[i]);
   QE.Clear;
   // otoceni v plochach
   for i := 0 to L.OwnersCount - 1 do
   begin
      E := L.Owners[i];
      if E is TPolyLineAreaElement then
      begin
         A := TPolyLineAreaElement(E);
         iL := A.IndexOf(L);
         A.LinesOrigines[iL] := not A.LinesOrigines[iL]
      end;
   end;
   QE.Free;
   L.CalculateLabelProps;
   result := '1';
end;

{ TStringTranslate }

procedure TStringTranslate.DoIt;
var
   SE: TStringElement;
   S: string;
   NoTranslate: boolean;
   TT: TStringListElement;
   ii: integer;
begin
   //Error := 1;
   S := aString;
   TT := TranslateTable;
   NoTranslate := (TT = nil) or TT.NoElements;
   if not NoTranslate then
   begin
      for ii := 0 to TT.LastIndex do
      begin
         SE := TT.StringElements[ii];
         S := StringReplace(S,SE.Name,SE.Value,[rfReplaceAll, rfIgnoreCase]);
      end;
   end;
   Result := S;
end;

function TStringTranslate.GetTtranslateTable: TStringListElement;
begin
   //result := nil;
   if FTranslateTable = nil then
   begin
      FTranslateTable := TStringListElement(FindElementClass(TStringListElement));
      if FTranslateTable = nil then
      begin
         ExChangeFieldElement(TElement(FTranslateTable), TStringListElement.Create);
      end;
   end;
   result := FTranslateTable;
end;

function TStringTranslate.NumberToPropertyName(aNumber: Integer): string;
begin
   case aNumber of
      0: result := 'aString';
      1: Result := 'TranslateTable';
   end;
end;

procedure TStringTranslate.SetTranslateTable(const Value: TStringListElement);
begin
   ExchangeFieldElement(TElement(FTranslateTable),Value);
end;


{ TDBTableDefinitionFromFile }

procedure TDBTableDefinitionFromFile.DoIt;
var
   Ok: boolean;
begin
   OK := false;
   Output := NactiDefiniciZeSouboru(FileName, OK);
end;

function TDBTableDefinitionFromFile.NumberToPropertyName(aNumber: Integer): string;
begin
   result := 'FileName';
end;

procedure TDBTableDefinitionFromFile.SetFileName(const Value: string);
begin
   FFileName := Value;
end;

{ TPrinterInfo }

procedure TPrinterInfo.DoIt;
var
   PD: TPrintDevice;
   C: T2DCoordinate;
begin
   if (Output = nil) then
   begin
      C := T2DCoordinate.Create;
      Output := C;
   end
   else
   begin
      if not (output is T2DCoordinate) then exit;
      C := T2DCoordinate(Output);
   end;
   Printer.FileName := GetAbsolutePath('0.prn');
   PD := TPrintDevice.Create;
   C.X := PD.RealWidth;
   C.Y := PD.RealHeight;
   Printer.Abort;
   PD.Free;
end;

function TPrinterInfo.NumberToPropertyName(aNumber: Integer): string;
begin
   result := 'Output';
end;

{ TWGS84toJTSK }

procedure TWGS84toJTSK.DoIt;
var
   A: TMapCoord;
begin
   if (Input <> nil) and (Input is T2DCoordinate) then
   begin
      Coord := T2DCoordinate(Input);
      Latitude := Coord.X;
      Longitude := Coord.Y;
   end
   else
   begin
      if Coord = nil then
         Coord :=  T2DCoordinate.Create;
   end;
   Output := Coord;
   WGS84toJTSK(Latitude,Longitude,A);
   Coord.X := -A.Y;
   Coord.Y := -A.X;
end;

function TWGS84toJTSK.NumberToPropertyName(aNumber: Integer): string;
begin
case aNumber of
   0:result:='Latitude';
   1:result:='Longitude';
   2:result:='Coord';
   else result:='';
   end;{case}
end;

procedure TWGS84toJTSK.SetCoord(const Value: T2DCoordinate);
begin
  FCoord := Value;
end;

procedure TWGS84toJTSK.SetLatitude(const Value: double);
begin
  FLatitude := Value;
end;

procedure TWGS84toJTSK.SetLongitude(const Value: double);
begin
  FLongitude := Value;
end;

{ TJTSKtoWGS84 }

procedure TJTSKtoWGS84.DoIt;
var
   A: TMapCoord;
   Latitude,Longitude: double;
begin
   if (Input <> nil) and (Input is T2DCoordinate) then
   begin
      Coord := T2DCoordinate(Input);
   end
   else
   begin
      if Coord = nil then
         Coord :=  T2DCoordinate.Create;
   end;
   Output := Coord;
   A.X := -Y;
   A.Y := -X;
   JTSKtoWGS84(A,Latitude,Longitude);
   Coord.X := Latitude;
   Coord.Y := Longitude;
end;

function TJTSKtoWGS84.NumberToPropertyName(aNumber: Integer): string;
begin
case aNumber of
   0:result:='X';
   1:result:='Y';
   2:result:='Coord';
   else result:='';
   end;{case}
end;

procedure TJTSKtoWGS84.SetCoord(const Value: T2DCoordinate);
begin
  FCoord := Value;
end;

procedure TJTSKtoWGS84.SetX(const Value: double);
begin
   FX := Value;
end;

procedure TJTSKtoWGS84.SetY(const Value: double);
begin
   FY := Value;
end;

INITIALIZATION
   RegisterOrbisClass(TFindOrCreateElement);
   RegisterOrbisClass(TFindClassInOwnersWithOwner);
   RegisterOrbisClass(TGetPropertyStringByName);
   RegisterOrbisClass(TSetPropertyStringByName);
   RegisterOrbisClass(TsumProperty);
   RegisterOrbisClass(TAverageProperty);
   RegisterOrbisClass(TSumVectors);
   RegisterOrbisClass(TCat);
   RegisterOrbisClass(TStringToInteger);
   RegisterOrbisClass(TStringToDelimiter);
   RegisterOrbisClass(TStringCopy);
   RegisterOrbisClass(TStringReplace);
   RegisterOrbisClass(TStringTranslate);
   RegisterOrbisClass(TUpperCase);
   RegisterOrbisClass(TConvertCodePage);
   RegisterOrbisClass(TInc);
   RegisterOrbisClass(TRoundTo);
   RegisterOrbisClass(TAngle22PI);
   RegisterOrbisClass(TDistance);
   RegisterOrbisClass(T_Angle);
   RegisterOrbisClass(TCreateElementCopy);
   RegisterOrbisClass(TGetAbsoluteFilePath);
   RegisterOrbisClass(TGetRelativeFilePath);
   RegisterOrbisClass(TMoveElement);
   RegisterOrbisClass(TRunProcess);
   RegisterOrbisClass(TDeleteFile);
   RegisterOrbisClass(TCopyFile);
   RegisterOrbisClass(TRenameFile);
   RegisterOrbisClass(TCopyDirectory);
   RegisterOrbisClass(TForceDirectories);
   RegisterOrbisClass(THtmlHelp);
   RegisterOrbisClass(TPaletteColorToRGB);
   RegisterOrbisClass(TDBTableDefinitionFromFile);
   RegisterOrbisClass(TCreateTable);
   RegisterOrbisClass(TGetSimpleGeometryByXY);
   RegisterOrbisClass(TFileExists);
   RegisterOrbisClass(TDirectoryExists);
   RegisterOrbisClass(TIsMyOwner);
   RegisterOrbisClass(TLineAngleAtXY);
   RegisterOrbisClass(TLineSwapDirection);
   RegisterOrbisClass(TPrinterInfo);
   RegisterOrbisClass(TWGS84toJTSK);
   RegisterOrbisClass(TJTSKtoWGS84);
END.
