unit t_XML_ISLHC;
// -----------------------------------------------------------------------
//      ppk
// 2013 zmena ... kasle se na _L a vrstva se urcuje podle seznamu druhu
// DET linie ... tak to zatim nevim a asi to v tuhle chvili neni dulezity
// -----------------------------------------------------------------------
interface
uses
  classes,
// KERNEL
   Elements,
   e_Class,
   e_Type,
   e_LHCModel,
   e_KatastrModel,
   //Zb ImMujXml,E_LesCel,

{$IFDEF TAX}
   ImMujXml,E_LesCel,
{$ENDIF}

// 0TEMP
   T_Loader,
   u_xeString;

type

TCharSet = set of _xchar;

TGeometryStatus = (gsNil,gsArea,gsLine,gsPoint,gsText);
TAreaStatus = (asNil,asMain,asHole);

TLHC_XMLLoader = class(TOrbisLoader)
private
   FReader: TReader;
   FStream: TStream;
   FLineNo: integer;
   FXMLSize: integer;
   FFWChar: _xchar;
    FLastPosition: integer;
    FAreaStatus: TAreaStatus;
    FActual_ETZ: TElement;
    FActual_OST: TElement;
    FActual_BZL: TElement;
    FActual_OU1: TElement;
    FActual_KPO: TElement;
    FActual_Text: TElement;
    FActual_JP: TElement;
    FActual_Line: TElement;
    FActual_HS: TElement;
    FActual_OU2: TElement;
    FActual_Area: TElement;
    FActual_ZAL: TElement;
    FActual_KLO: TElement;
    FActual_KAT: TElement;
    FActual_GArea: TElement;
    FActual_LHC: TElement;
    FActual_KBO: TElement;
    FActual_OLH: TElement;
    FActual_DRV: TElement;
    FActual_Point: TElement;
    FActual_ODD: TElement;
    FActual_GLine: TElement;
    FActual_MZD: TElement;
    FActual_KTO: TElement;
    FActual_POR: TElement;
    FActual_PSK: TElement;
    FActual_POS: TElement;
    FActual_DIL: TElement;
    FAreaEntity: TEntity;
    FGeometryStatus: TGeometryStatus;
    FActual_Hole: TElement;
    FLayers: TEntity;
{$IFDEF TAX}
    FLesniCelek:TLesniCelek;
{$ENDIF}
{$IFDEF LED}
    FLHCModel: Tgis_ForestModel;
{$ENDIF}
    FTempDirectory: string;
    FPerPartes: boolean;
    FLastLayer: TEntity;
    FLHC_KOD: string;
    FNewFormat: boolean;
    FDilecBYPorost: boolean;
    FIgnoreL_: boolean;
    FParcelModel: Tgis_ParcelModel;
    FLcr: boolean;
    FPAR: boolean;
    FG_DIL: boolean;
    FFormat2013: boolean;
    FARE_Druhy_L: TEntity;
    FTXT_Druhy_L: TEntity;
    FLIN_Druhy_L: TEntity;
    FPNT_Druhy_L: TEntity;        // dopedn naten znak
   function EndOfFile: Boolean;
   function IsSpace(aChar: _xchar): Boolean;
   function  GetSingleChar: _xchar;
   function  GetChar: _xchar;
   function  GetXMLName(aCharSet: TCharSet): _xstring; // naten etzec po space
   procedure AddParam(aElement: TStringListElement; aName, aParam: string);
   procedure LoadElemElemProperty(aElement: TElement; aPropName: string);
   procedure LoadElemAttribute(aSlovo: string; aElement: TStringListElement);
   procedure LoadElement(aName: string; aElement: TElement; aProp: string);{ <Name      /> }
   function  LoadComment(aName: string; aElement: TElement; aProp: string): _xstring;  { <!--           --> }
   procedure LoadProcessingInstruction(aName: string; aElement: TElement; aProp: string);{ <?Name      /> }
   procedure LoadDeclaration(aName: string; aElement: TElement); { <!Name      /> }
   function  LoadTag(aElement: TElement): boolean;   { < > }
   procedure SetLastPosition(const Value: integer);
    procedure SetActual_Area(const Value: TElement);
    procedure SetActual_BZL(const Value: TElement);
    procedure SetActual_DIL(const Value: TElement);
    procedure SetActual_DRV(const Value: TElement);
    procedure SetActual_ETZ(const Value: TElement);
    procedure SetActual_GArea(const Value: TElement);
    procedure SetActual_GLine(const Value: TElement);
    procedure SetActual_HS(const Value: TElement);
    procedure SetActual_JP(const Value: TElement);
    procedure SetActual_KAT(const Value: TElement);
    procedure SetActual_KBO(const Value: TElement);
    procedure SetActual_KLO(const Value: TElement);
    procedure SetActual_KPO(const Value: TElement);
    procedure SetActual_KTO(const Value: TElement);
    procedure SetActual_LHC(const Value: TElement);
    procedure SetActual_Line(const Value: TElement);
    procedure SetActual_MZD(const Value: TElement);
    procedure SetActual_ODD(const Value: TElement);
    procedure SetActual_OLH(const Value: TElement);
    procedure SetActual_OST(const Value: TElement);
    procedure SetActual_OU1(const Value: TElement);
    procedure SetActual_OU2(const Value: TElement);
    procedure SetActual_Point(const Value: TElement);
    procedure SetActual_POR(const Value: TElement);
    procedure SetActual_POS(const Value: TElement);
    procedure SetActual_PSK(const Value: TElement);
    procedure SetActual_Text(const Value: TElement);
    procedure SetActual_ZAL(const Value: TElement);
    procedure SetAreaEntity(const Value: TEntity);
    procedure SetAreaStatus(const Value: TAreaStatus);
    procedure SetGeometryStatus(const Value: TGeometryStatus);
    procedure SetActual_Hole(const Value: TElement);
    procedure SetLayers(const Value: TEntity);
    procedure SetTempDirectory(const Value: string);
    function GetTempDirectory: string;
    procedure SetPerPartes(const Value: boolean);
    procedure SetLastLayer(const Value: TEntity);
    procedure SetLHC_KOD(const Value: string);
    procedure SetNewFormat(const Value: boolean);
{$IFDEF TAX}
    procedure SetLesniCelek(const Value: TLesniCelek);
    procedure SetPripravLesniCelekZAdresare(const Value: String);
    procedure SetPripravLesniCelek(Value: boolean);
    procedure SetUkonciLesniCelek(Value: boolean);
{$ENDIF}
{$IFDEF LED}
    procedure SetLHCModel(const Value: Tgis_ForestModel);
    procedure SetDilecBYPorost(const Value: boolean);
    procedure SetIgnoreL_(const Value: boolean);
    procedure SetParcelModel(const Value: Tgis_ParcelModel);
    procedure SetLcr(const Value: boolean);
    procedure SetPAR(const Value: boolean);
    procedure SetG_DIL(const Value: boolean);
    procedure SetFormat2013(const Value: boolean);
    procedure SetARE_Druhy_L(const Value: TEntity);
    procedure SetLIN_Druhy_L(const Value: TEntity);
    procedure SetPNT_Druhy_L(const Value: TEntity);
    procedure SetTXT_Druhy_L(const Value: TEntity);
{$ENDIF}

protected
   property  Reader: TReader read FReader write FReader;
   property  Stream: TStream read FStream write FStream;
   property  LastPosition: integer read FLastPosition write SetLastPosition;
public
   procedure   DoIt; override;
   function    GetGaugeMax: longInt; override;
   procedure   UpdateGauge; override;
   procedure   LoadInfo; override;
   procedure   LoadClass; override;
   procedure   LoadAll; override;
   procedure   LoadElements; override;
   procedure   ProcessElement(aElement: TStringListElement);

   procedure   Load_PAR(aElement: TStringListElement; aTyp: integer);
   procedure   Load_PAR_B(aElement: TStringListElement);
   procedure   Load_L_KN_KAT(aElement: TStringListElement);
   procedure   Load_LHC(aElement: TStringListElement);
   procedure   Load_ODD(aElement: TStringListElement);
   procedure   Load_DIL(aElement: TStringListElement);
   procedure   Load_POR(aElement: TStringListElement);
   procedure   Load_KAT(aElement: TStringListElement);
   procedure   Load_PSK(aElement: TStringListElement);
   procedure   Load_ETZ(aElement: TStringListElement);
   procedure   Load_ZAL(aElement: TStringListElement);
   procedure   Load_DRV(aElement: TStringListElement);
   procedure   Load_POS(aElement: TStringListElement);
   procedure   Load_BZL(aElement: TStringListElement);
   procedure   Load_JP(aElement: TStringListElement);
   procedure   Load_OST(aElement: TStringListElement);
   procedure   Load_OP(aElement: TStringListElement);
   procedure   Load_HS(aElement: TStringListElement);
   procedure   Load_OU1(aElement: TStringListElement);
   procedure   Load_OU2(aElement: TStringListElement);
   procedure   Load_OLH(aElement: TStringListElement);
   procedure   Load_MZD(aElement: TStringListElement);
   procedure   Load_KLO(aElement: TStringListElement);
   procedure   Load_KBO(aElement: TStringListElement);
   procedure   Load_KPO(aElement: TStringListElement);
   procedure   Load_KTO(aElement: TStringListElement);
   procedure   Load_PSK_OBRAZ(aElement: TStringListElement);
   procedure   Load_BZL_OBRAZ(aElement: TStringListElement);
   procedure   Load_JP_OBRAZ(aElement: TStringListElement);
   procedure   Load_OST_OBRAZ(aElement: TStringListElement);
   procedure   Load_MP(aElement: TStringListElement);
   procedure   Load_P(aElement: TStringListElement);
   procedure   Load_ML(aElement: TStringListElement);
   procedure   Load_L(aElement: TStringListElement);
   procedure   Load_B(aElement: TStringListElement);
   procedure   LoadLast_PSK;
{$IFDEF LED}
   procedure   UpdateLayers;
   procedure   UpdatePSKByWorkLevel;
   procedure   FindDetLines;
   procedure   FindPARLines;
   function    FindLayerByDruh(aTyp, aDruh: string): string;
{$ENDIF}
   property   GeometryStatus: TGeometryStatus read FGeometryStatus write SetGeometryStatus;
   property   AreaStatus: TAreaStatus read FAreaStatus write SetAreaStatus;

   property   Actual_LHC: TElement read FActual_LHC write SetActual_LHC;
   property   Actual_ODD: TElement read FActual_ODD write SetActual_ODD;
   property   Actual_DIL: TElement read FActual_DIL write SetActual_DIL;
   property   Actual_POR: TElement read FActual_POR write SetActual_POR;
   property   Actual_KAT: TElement read FActual_KAT write SetActual_KAT;
   property   Actual_PSK: TElement read FActual_PSK write SetActual_PSK;
   property   Actual_ETZ: TElement read FActual_ETZ write SetActual_ETZ;
   property   Actual_ZAL: TElement read FActual_ZAL write SetActual_ZAL;
   property   Actual_DRV: TElement read FActual_DRV write SetActual_DRV;
   property   Actual_POS: TElement read FActual_POS write SetActual_POS;
   property   Actual_BZL: TElement read FActual_BZL write SetActual_BZL;
   property   Actual_JP: TElement read FActual_JP write SetActual_JP;
   property   Actual_OST: TElement read FActual_OST write SetActual_OST;
   property   Actual_HS: TElement read FActual_HS write SetActual_HS;
   property   Actual_OU1: TElement read FActual_OU1 write SetActual_OU1;
   property   Actual_OU2: TElement read FActual_OU2 write SetActual_OU2;
   property   Actual_OLH: TElement read FActual_OLH write SetActual_OLH;
   property   Actual_MZD: TElement read FActual_MZD write SetActual_MZD;
   property   Actual_KLO: TElement read FActual_KLO write SetActual_KLO;
   property   Actual_KBO: TElement read FActual_KBO write SetActual_KBO;
   property   Actual_KPO: TElement read FActual_KPO write SetActual_KPO;
   property   Actual_KTO: TElement read FActual_KTO write SetActual_KTO;
   property   Actual_Area: TElement read FActual_Area write SetActual_Area;
   property   Actual_GArea: TElement read FActual_GArea write SetActual_GArea;
   property   Actual_Hole: TElement read FActual_Hole write SetActual_Hole;
   property   Actual_Line: TElement read FActual_Line write SetActual_Line;
   property   Actual_GLine: TElement read FActual_GLine write SetActual_GLine;
   property   Actual_Point: TElement read FActual_Point write SetActual_Point;
   property   Actual_Text: TElement read FActual_Text write SetActual_Text;
   property   LastLayer: TEntity read FLastLayer write SetLastLayer;
   property   LHC_KOD: string read FLHC_KOD write SetLHC_KOD;
   property   DilecBYPorost: boolean read FDilecBYPorost write SetDilecBYPorost;
published
   property XMLSize: integer read FXMLSize;
   property AreaEntity: TEntity read FAreaEntity write SetAreaEntity;
   property Layers: TEntity read FLayers write SetLayers;
{$IFDEF TAX}
   property LesniCelek:TLesniCelek read FLesniCelek write SetLesniCelek;
   property PripravLesniCelekZAdresare: string write SetPripravLesniCelekZAdresare;
   property PripravLesniCelek: boolean write SetPripravLesniCelek;
   property UkonciLesniCelek: boolean write SetUkonciLesniCelek;
{$ENDIF}
{$IFDEF LED}
   property LHCModel: Tgis_ForestModel read FLHCModel write SetLHCModel;
   property ParcelModel: Tgis_ParcelModel read FParcelModel write SetParcelModel;
   property LIN_Druhy_L: TEntity read FLIN_Druhy_L write SetLIN_Druhy_L;
   property ARE_Druhy_L: TEntity read FARE_Druhy_L write SetARE_Druhy_L;
   property PNT_Druhy_L: TEntity read FPNT_Druhy_L write SetPNT_Druhy_L;
   property TXT_Druhy_L: TEntity read FTXT_Druhy_L write SetTXT_Druhy_L;
{$ENDIF}
   property TempDirectory: string read GetTempDirectory write SetTempDirectory;
   property PerPartes: boolean read FPerPartes write SetPerPartes;
   property NewFormat: boolean read FNewFormat write SetNewFormat;
   property Format2013: boolean read FFormat2013 write SetFormat2013;
   property IgnoreL_: boolean read FIgnoreL_ write SetIgnoreL_;
   property Lcr: boolean read FLcr write SetLcr;
   property PAR: boolean read FPAR write SetPAR;
   property G_DIL: boolean read FG_DIL write SetG_DIL;
end;


implementation

uses
  SysUtils,
  Strutils,
  FileCtrl,
  Forms,
  Dialogs,
  TypInfo,
{$IFDEF LED}
  e_Geometry,
  e_GeometryElement,
  e_TopolElements,
  G_Elems,
  t_Applac,
  t_LineExtractor,
  t_ForestModelSelector,
  u_Symbol,
{$ENDIF}
{$IFDEF TAX}

{$ENDIF}
  m_Orbis,
  u_String;
  //f_Gauge,
//KERNEL




               { TLHC_XMLLoader }



function TLHC_XMLLoader.EndOfFile: Boolean;
begin
  Result:= Reader.Position >= XMLSize
end;


function TLHC_XMLLoader.GetSingleChar: _xchar;
var
   aChar: _xchar;
begin
  Reader.read(aChar, 1);
  if aChar = #13 then
     Inc(FLineNo);
  Result:= aChar;
  UpdateGauge
end;



function TLHC_XMLLoader.IsSpace(aChar: _xchar): Boolean;
begin
  Result:= aChar in [#9, #10, #13, #32]
end;



function TLHC_XMLLoader.GetChar: _xchar;
var
  aChar: _xchar;
begin
{ dopedn ten znaku, aby se vynechvaly space znaky }
  Result:= FFWChar;
  aChar:= FFWChar;

  if IsSpace(FFWChar) then
  begin
    repeat
      aChar:= GetSingleChar
    until not IsSpace(aChar) or EndOfFile;
  end
  else
    aChar:= GetSingleChar;

  FFWChar:= aChar;
end;


function TLHC_XMLLoader.GetXMLName(aCharSet: TCharSet): _xstring;
var
  aChar: _xchar;
begin
  Result:= '';
  if EndOfFile then
     Exit;
  aChar:= GetChar;
  while not isSpace(aChar) and not EndOfFile do
  begin
     Result:= Result + aChar;
     if aChar in aCharSet then Exit;
     aChar:= GetChar;
  end;
end;


function TLHC_XMLLoader.LoadTag(aElement: TElement): boolean;   { < > }
var
  Znak: _xchar;
  aStr: _xstring;
  aName: string;
  OnlySpace: Boolean;
begin
  Result:= True;

  aStr:= '';
  OnlySpace:= True;
  repeat
    Znak:= FFWChar;
    FFWChar:= GetSingleChar;

    if (Znak <> '<') then
    begin
      if not IsSpace(Znak) then
         OnlySpace:= False;
      aStr:= aStr + Znak;
    end
  until (Znak = '<') or EndOfFile;

  if EndOfFile then
  begin
    Result:= False;
    Exit;
  end;
  { !!!!!!!!! Na text prdme....
  if (aElement is TEntity) and not OnlySpace then
  begin
    TEntity(aElement).AddElement(TStringElement.CreateAll('TEXT', aStr));

  end;
  }
  aName:= GetXMLName(['>']);
  if Copy(aName, 1, 3) = '!--' then
     LoadComment(aName, aElement, '')
  else
  if Copy(aName, 1, 1) = '!' then
     LoadDeclaration(aName, aElement)
  else
  if Copy(aName, 1, 1) = '?' then
     LoadProcessingInstruction(aName, aElement, '')
  else
  if Copy(aName, 1, 1) = '/' then
     Result:= false
  else
     LoadElement(aName, aElement, '')
end;


procedure TLHC_XMLLoader.AddParam(aElement: TStringListElement; aName, aParam: string);
begin
  {
  if aElement.HasPropertyByName(aName) then
     aElement.SetPropertyStringByName(aName, aParam)
  else
  }
  if aElement is TStringListElement then
     TStringListElement(aElement).AddNameString(aName, aParam)
end;



procedure TLHC_XMLLoader.LoadElemElemProperty(aElement: TElement; aPropName: string);
var
  aName: string;
begin
  aName:= GetXMLName(['>']);
  if Copy(aName, 1, 3) = '!--' then
     LoadComment(aName, aElement, '')
  else
  if Copy(aName, 1, 1) = '!' then
     LoadDeclaration(aName, aElement)
  else
  if Copy(aName, 1, 1) = '?' then
     LoadProcessingInstruction(aName, aElement, aPropName)
  else
     LoadElement(aName, aElement, aPropName)
end;



procedure TLHC_XMLLoader.LoadElemAttribute(aSlovo: string; aElement: TStringListElement);
var
  aName, aParam: _xstring;
  PosEq: integer;
  aChar: _xchar;
  FirstDel: _xchar;
  aChyba: Boolean;
begin
  PosEq:= Pos('=', aSlovo);
  if PosEq <= 0 then
  begin
     aName:= aSlovo;
     aParam:= GetXMLName(['=']);
  end
  else
  begin
    aName:= Copy(aSlovo, 1, PosEq-1);
  end;

  repeat // Peskoen vodn vozovky nebo apostrofu nebo <
    FirstDel:= GetChar;
  until (FirstDel in ['''', '"', '<']) or EndOfFile;


  if not (FirstDel in ['''','"', '<']) then
  begin
    ShowMessage('CHYBA pi natn atributu "' + aName + '", nenalezen vodn apostrof nebo uvozovka'
                + #13 + #10 + 'dek .' + IntToStr(FLineNo));
    Exit;
  end;

  {
  if FirstDel = '<' then
  begin
    LoadElemElemProperty(aElement, aName);
    Exit;
  end;
  }
  aParam:= '';
  aChyba:= False;
  repeat
    aChar:= FFWChar;
    FFWChar:= GetSingleChar;

    if aChar=FirstDel then
    begin
      break;
    end;
    aParam:= aParam + aChar;
  until EndOfFile;

  if EndOfFile then
  begin
    ShowMessage('CHYBA pi natn atributu "' + aName + '"'
                + #13 + #10 + 'dek .' + IntToStr(FLineNo));
    Exit;
  end;

  AddParam(aElement, aName, aParam);
end;



procedure TLHC_XMLLoader.LoadElement(aName: string; aElement: TElement; aProp: string);  { <ElementName     /> }
var
  aSlovo: string;
  EmptyElement: Boolean;
  ReadContent: Boolean;
  aSubElement: TStringListElement;
begin
  { oven sprvnosti jmna elementu }

  { naten hlaviky, zatm nevm jestli je to przdn element }
  EmptyElement:= False;
  ReadContent:= False;

  if Pos('/>', aName) > 0 then
  begin
    EmptyElement:= True;
    aName:= Copy(aName, 1, Pos('/>', aName)-2);
  end
  else if Pos('>', aName) > 0 then
  begin
    ReadContent:= True;
    aName:= Copy(aName, 1, Pos('>', aName)-1);
  end;

  { Zaloen aSubElementu a pidn do aElementu }
  begin
    aSubElement:= TStringListElement.Create;
    aSubElement.Name:= aName;
  end;



  if not EmptyElement and not ReadContent then
  repeat
    aSlovo:= getXMLName(['>', '=']);
    if Pos('!--', aSlovo) > 0 then
    begin
      LoadComment(aSlovo, aSubElement, aProp);
      aSlovo:= '';
    end
    else
    if Pos('/>', aSlovo) > 0 then
    begin
      EmptyElement:= True;
      aSlovo:= copy(aSlovo, 1, Pos('/>', aSlovo)-1);
    end
    else if Pos('>', aSlovo) > 0 then
    begin
      ReadContent:= True;
      aSlovo:= copy(aSlovo, 1, Pos('>', aSlovo)-1);
    end
    else if Pos('=', aSlovo) > 0 then
    begin
       LoadElemAttribute(aSlovo, aSubElement);
       aSlovo:= ''
    end;
    if aSlovo <> '' then
       LoadElemAttribute(aSlovo, aSubElement);
  until EmptyElement or ReadContent;
  ProcessElement(aSubElement);
  aSubElement.Free;
  aSubElement := nil;
  if ReadContent then
  begin
    repeat
    until not LoadTag(aSubElement);
  end;
end;



function TLHC_XMLLoader.LoadComment(aName: string; aElement: TElement; aProp: string): _xstring;  { <!--           --> }
var
  aChar: _xchar;
  aStat: integer; {0: bezne, 1: 1.pom, 2: 2.pom za 1.}
begin
{ proztmn natn, polyk mezery, atd. }
  aStat:= 0;
  Result:= '' + FFWChar;
  aName:= Copy(aName, Pos('!--', aName) + 3, Length(aName));
  //FFWChar:= GetSingleChar;
  while not EndOfFile do
  begin
    aChar:= FFWChar;
    FFWChar:= GetSingleChar;

    case aStat of
    0: if aChar = '-' then
          aStat:= 1
       else
          Result:= Result + aChar;
    1: if aChar = '-' then
          aStat:= 2
       else
       begin
          Result:= Result + '-' + aChar;
          aStat:= 0
       end;
    2: if aChar = '>' then
       begin
         Result:= aName + Result;
//         ShowMessage('<!-- ' + result + ' -->');
         Exit
       end
       else
       begin
          Result:= Result + '--' + aChar;
          aStat:= 0
       end;
    end;
  end;
end;



procedure TLHC_XMLLoader.LoadProcessingInstruction
          (aName: string; aElement: TElement; aProp: string); { <?PITarget      ?> }
var
  anID, aRes: integer;
  e: TElement;
begin
  {Tohle je taky blbost ........
  if aName = '?SHORTCUT' then
  begin
    aName:= GetXMLName(['>']);
    Val(aName, anID, aRes);
    if aRes > 0 then
       ShowMessage('SHORTCUT ERROR ' + #13 + #10 + IntToStr(FLineNo))
    else
    begin
    try
      E := Container.Elements[anID];
      if aProp = '' then
         TEntity(aElement).AddElement(E)
      else
         aElement.SetPropertyLongIntByName(aProp, integer(E))
    except
       ShowMessage('SHORTCUT ERROR ' + #13 + #10 + IntToStr(FLineNo))
    end;
    end;
  end;
  }
  while (Pos('?>', aName) <= 0) and not EndOfFile do
  begin
    aName:= GetXMLName(['>']);
  end;
end;


procedure TLHC_XMLLoader.LoadDeclaration(aName: string; aElement: TElement); { <!Name      /> }
begin
  while (Pos('>', aName) <= 0) and not EndOfFile do
  begin
    aName:= GetXMLName(['>']);
  end;
end;


procedure   TLHC_XMLLoader.DoIt;
begin
{$IFDEF TAX}
   //if LesniCelek = nil then exit; //jenom pridat kontrolu LesnihoCelku
{$ENDIF}
   if (FileName = '') or (Filename = '0') then exit;
   if not FileExists(FileName) then
   begin
      ShowMessage('Soubor '+FileName+' neexistuje');
      exit;
   end;

   Stream := TMemoryStream.Create;
   try
      TMemoryStream(Stream).LoadFromFile(FileName);
      FXMLSize:= Stream.Size;
   except
      Stream.Free;
      Stream := TFileStream.Create(FileName, fmOpenRead{Write !!!!!!!} );
   end;

   (*
   Stream := TFileStream.Create(FileName, fmOpenRead{Write !!!!!!!} );
   FXMLSize:= Stream.Size;
   *)
   DilecByPorost := false;
   Reader := TReader.Create(Stream, 4096);
   FLineNo:= 1;
   LastPosition := 0;
   // by OrbisLoader
   StartGauge;
   Prepare;
   LoadInfo;
   LoadClasses;
   LoadAll;
   Output := Container.elements[0];
{$IFDEF LED}
   UpdateLayers;
{$ENDIF}
   Finish;
   EndGauge;
   // by OrbisLoader

   Reader.Free;
   Stream.Free;
end;


function    TLHC_XMLLoader.GetGaugeMax: longInt;
begin
   result := XMLSize;
end;


procedure   TLHC_XMLLoader.UpdateGauge;
begin
   if (Stream.Position > LastPosition) and (Stream.Position mod 200{4096} = 0) then
   begin
      //PostTextMsg(tm_AddToProtocol,IntToStr(Stream.position),nil);
      LastPosition := Stream.Position;
      Progress := LastPosition;
      ProgressText := IntToStr(LastPosition)+' byt z celkovch '+IntToStr(Stream.Size);
      //FGauge.Progress:= FStream.Position;
      Application.ProcessMessages
   end;
end;


procedure   TLHC_XMLLoader.LoadInfo;
begin
end;


procedure   TLHC_XMLLoader.LoadClass;
begin
end;


procedure   TLHC_XMLLoader.LoadAll;
begin
   FFWChar:= GetSingleChar;
   while not EndOfFile do
   begin
     LoadTag(Input)
   end;
end;



procedure   TLHC_XMLLoader.LoadElements;
begin
end;




procedure TLHC_XMLLoader.ProcessElement(aElement: TStringListElement);
var
   i: integer;
   S: string;
begin
   S := aElement.Name;
   if S = 'P_KN_LHP' then Load_PAR(aElement,1) else
   if S = 'P_KN_0' then Load_PAR(aElement,0) else
   if S = 'P_KN_MIMOLHP' then Load_PAR(aElement,-1) else
   if AnsiStartsText('B_KN_',S)then Load_PAR_B(aElement) else
   if S = 'L_KN_KAT' then Load_L_KN_KAT(aElement) else
   if S = 'LHC' then Load_LHC(aElement) else
   if S = 'ODD' then Load_ODD(aElement) else
   if S = 'DIL' then Load_DIL(aElement) else
   if S = 'POR' then Load_POR(aElement) else
   if S = 'KAT' then Load_KAT(aElement) else
   if S = 'PSK' then Load_PSK(aElement) else
   if S = 'ETZ' then Load_ETZ(aElement) else
   if S = 'ZAL' then Load_ZAL(aElement) else
   if S = 'DRV' then Load_DRV(aElement) else
   if S = 'POS' then Load_POS(aElement) else
   if S = 'BZL' then Load_BZL(aElement) else
   if S = 'JP'  then Load_JP(aElement) else
   if S = 'OST' then Load_OST(aElement) else
   if S = 'OP'  then Load_OP(aElement) else
   if S = 'HS'  then Load_HS(aElement) else
   if S = 'OU1' then Load_OU1(aElement) else
   if S = 'OU2' then Load_OU2(aElement) else
   if S = 'OLH' then Load_OLH(aElement) else
   if S = 'MZD' then Load_MZD(aElement) else
   if S = 'KLO' then Load_KLO(aElement) else
   if S = 'KBO' then Load_KBO(aElement) else
   if S = 'KPO' then Load_KPO(aElement) else
   if S = 'KTO' then Load_KTO(aElement) else
   if S = 'PSK_OBRAZ' then Load_PSK_OBRAZ(aElement) else
   if S = 'BZL_OBRAZ' then Load_BZL_OBRAZ(aElement) else
   if S = 'JP_OBRAZ' then Load_JP_OBRAZ(aElement) else
   if S = 'OST_OBRAZ' then Load_OST_OBRAZ(aElement) else
   //if S = 'MP' then Load_MP(aElement) else
   if S = 'P' then Load_P(aElement) else
   //if S = 'ML' then Load_ML(aElement) else
   if S = 'L' then Load_L(aElement) else
   if S = 'B' then Load_B(aElement);

end;

procedure TLHC_XMLLoader.SetLastPosition(const Value: integer);
begin
   FLastPosition := Value;
end;

procedure TLHC_XMLLoader.Load_BZL(aElement: TStringListElement);
begin
{$IFDEF TAX}
   if LesniCelek <> nil then
      nactiBZLXml(aElement,LesniCelek);
{$ENDIF}
{$IFDEF LED}
   if LHCModel <> nil then
   begin
      LHCModel.CreateSkupinaName(aElement.GetStringByName('BZL'));
      LoadLast_PSK;
   end;
{$ENDIF}
end;

procedure TLHC_XMLLoader.Load_DIL(aElement: TStringListElement);
var
   S: string;
begin
 // showmessage('DIL: '+aElement.GetStringByName('DIL'));
{$IFDEF TAX}
   if LesniCelek <> nil then
      nactiDilXml(aElement,LesniCelek);
{$ENDIF}
{$IFDEF LED}
   S := aElement.GetStringByName('DIL');
   if (S = '') or not(S[1] in ['a'..'z','A'..'Z']) then
      DilecByPorost  := true
   else
   if LHCModel <> nil then
      LHCModel.CreateDilecName(S);
   if G_DIL then
      Actual_Area := LHCModel.ActualDilec;
{$ENDIF}
end;

procedure TLHC_XMLLoader.Load_DRV(aElement: TStringListElement);
begin
{$IFDEF TAX}
   if LesniCelek <> nil then
      nactiDrevXml(aElement,LesniCelek);
{$ENDIF}
end;

procedure TLHC_XMLLoader.Load_ETZ(aElement: TStringListElement);
var
   SLE: TStringListELement;
   SE: TStringElement;
begin
{$IFDEF TAX}
   if LesniCelek <> nil then
      nactiEtazXml(aElement,LesniCelek);
{$ENDIF}
{$IFDEF LED}
   if Actual_Area <> nil then
   begin
      SLE := TStringListElement(TEntity(Actual_Area).FindOrCreateElementName(TStringListELement,'ETZ'));
      SLE.AddNameString(aElement.GetStringByName('VEK'),aElement.GetStringByName('ZAKM'));
   end;
{$ENDIF}
end;

procedure TLHC_XMLLoader.Load_HS(aElement: TStringListElement);
begin

end;

procedure TLHC_XMLLoader.Load_JP(aElement: TStringListElement);
begin
{$IFDEF TAX}
   if LesniCelek <> nil then
      nactiJineXml(aElement,LesniCelek);
{$ENDIF}
{$IFDEF LED}
   if LHCModel <> nil then
   begin
      LHCModel.CreateSkupinaName(aElement.GetStringByName('JP'));
      LoadLast_PSK;
   end;
{$ENDIF}
end;

procedure TLHC_XMLLoader.Load_KAT(aElement: TStringListElement);
begin
{$IFDEF TAX}
   if LesniCelek <> nil then
      nactiKatXml(aElement,LesniCelek);
{$ENDIF}
end;

procedure TLHC_XMLLoader.Load_KBO(aElement: TStringListElement);
{$IFDEF LED}
var
   G: TGeometryElement;
   E: TEntity;
   S, SD: string;
   P: TPointElement;
{$ENDIF}
begin
{$IFDEF LED}
   GeometryStatus := gsPoint;
   if Layers = nil then exit;
   G := TTopolPointElement.Create;
   P := TPointElement.Create;
   G.Geometry := P;
   SD := aElement.GetStringByName('BOD_DRUH');
   G.SetPropertyStringByName('Druh',SD);
   G.SetPropertyStringByName('Barva',aElement.GetStringByName('BOD_BARVA'));
   G.SetPropertyStringByName('Znacka',aElement.GetStringByName('BOD_ZNACKA'));
   P.SetPropertyStringByName('Angle',aElement.GetStringByName('BOD_UHELZN'));
   if IgnoreL_ or Format2013 then
      S := ''
   else
      S := aElement.GetStringByName('L_');
   // Hledn vrstvy
   if S = '' then
   begin
      S := FindLayerByDruh('P',SD);
      if S = '' then
         S := 'PNT_SLU';
   end
   else
      NewFormat := true;
   E := TEntity(Layers.FindOrCreateElementName(TPointCollection,S));
   E.AddElement(G);
   Actual_Point := G;
{$ENDIF}
end;

procedure TLHC_XMLLoader.Load_KLO(aElement: TStringListElement);
{$IFDEF LED}
var
   G: TGeometryElement;
   E: TEntity;
   S,SD: string;
{$ENDIF}
begin
{$IFDEF LED}
   GeometryStatus := gsLine;
   if Layers = nil then exit;
   G := TTopolLineElement.Create;
   SD := aElement.GetStringByName('LIN_DRUH');
   G.SetPropertyStringByName('Druh',SD);
   G.SetPropertyStringByName('Barva',aElement.GetStringByName('LIN_BARVA'));
   G.SetPropertyStringByName('Znacka',aElement.GetStringByName('LIN_ZNACKA'));
   if IgnoreL_ or Format2013 then
      S := ''
   else
      S := aElement.GetStringByName('L_');
   if S = '' then
   begin
      S := FindLayerByDruh('L',SD);
      if S = '' then
      S := 'LIN_SLU';
   end
   else
      NewFormat := true;
   E := TEntity(Layers.FindOrCreateElementName(TPolyLineCollection,S));
   E.AddElement(G);
   Actual_Line := G;
{$ENDIF}
end;


procedure TLHC_XMLLoader.Load_KPO(aElement: TStringListElement);
{$IFDEF LED}
var
   G: TGeometryElement;
   E: TEntity;
   S,SD: string;
{$ENDIF}
begin
{$IFDEF LED}
   GeometryStatus := gsArea;
   //if AreaEntity = nil then exit;
   if Layers = nil then exit;
   G := TTopolAreaElement.Create;
   SD :=aElement.GetStringByName('PLO_DRUH');
   G.SetPropertyStringByName('Druh',SD);
   G.SetPropertyStringByName('Barva',aElement.GetStringByName('PLO_BARVA'));
   G.SetPropertyStringByName('Znacka',aElement.GetStringByName('PLO_ZNACKA'));
   if IgnoreL_ or Format2013 then
      S := ''
   else
      S := aElement.GetStringByName('L_');
   if S = '' then
   begin
      S := FindLayerByDruh('A',SD);
   if S = '' then
   begin
      if TTopolAreaElement(G).Druh = 110 then
         S := 'ARE_DET'
      else
         S := 'ARE_SRF';
      end;
   end
   else
      NewFormat := true;
   if S = 'ARE_DET' then
      S := 'ARE_DETW';
   E := TEntity(Layers.FindOrCreateElementName(TAreaCollection,S));
   E.AddElement(G);
   Actual_Area := G;
{$ENDIF}
end;

procedure TLHC_XMLLoader.Load_KTO(aElement: TStringListElement);
{$IFDEF LED}
var
   G: TGeometryElement;
   TT: TTopolTextElement;
   E: TEntity;
   S,SD: string;
   T: TTextElement;
{$ENDIF}
begin
{$IFDEF LED}
   GeometryStatus := gsText;
   if Layers = nil then exit;
   TT := TTopolTextElement.Create;
   TT.Barva := 13;
   TT.Znacka := 0;
   TT.TextAtrib := [OkT,T30];
   TT.CodePage := cpWindows;
   TT.TopolFont := 8;
   TT.WidthCoef := 1;
   TT.Slope := 0;
   TT.Distance := 2;
   TT.TextMode := 2;
   TT.Height := 5;
   G := TT;
   T := TTextElement.Create;
   G.Geometry := T;
   SD := aElement.GetStringByName('TXT_STYL');
   G.SetPropertyStringByName('Druh',SD);
   G.SetPropertyStringByName('Direction',aElement.GetStringByName('TXT_UHEL'));
   T.SetPropertyStringByName('Text',aElement.GetStringByName('TEXT'));
   if IgnoreL_ or Format2013 then
      S := ''
   else
      S := aElement.GetStringByName('L_');
   if S = '' then
   begin
      S := FindLayerByDruh('T',SD);
      if S = '' then
         S := 'TXT_TXT';
   end
   else
      NewFormat := true;
   E := TEntity(Layers.FindOrCreateElementName(TTextCollection,S));
   E.AddElement(G);
   Actual_Text := G;
{$ENDIF}
end;

procedure TLHC_XMLLoader.Load_LHC(aElement: TStringListElement);
begin
{$IFDEF TAX}
   if LesniCelek <> nil then
      nactiLHCXml(aElement,LesniCelek);
{$ENDIF}
{$IFDEF LED}
   if LHCModel <> nil then
   begin
      LHCModel.CreateLHCCislo(aElement.GetIntegerByName('LHC_KOD'));
      LHCModel.CreateLSCislo(1);
   end;
{$ENDIF}
   LHC_KOD := aElement.GetStringByName('LHC_KOD');
end;

procedure TLHC_XMLLoader.Load_MZD(aElement: TStringListElement);
begin

end;

procedure TLHC_XMLLoader.Load_ODD(aElement: TStringListElement);
begin
   // PostTextMsg(tm_AddToProtocol,'Odd: '+aElement.GetStringByName('ODD'),nil);
{$IFDEF TAX}
   if LesniCelek <> nil then
      nactiOddXml(aElement,LesniCelek);
{$ENDIF}
   // showmessage('Odd: '+aElement.GetStringByName('ODD'));
{$IFDEF LED}
   if LHCModel <> nil then
      LHCModel.CreateOddeleniCislo(aElement.GetIntegerByName('ODD'));
{$ENDIF}
   Application.ProcessMessages;
end;

procedure TLHC_XMLLoader.Load_OLH(aElement: TStringListElement);
begin

end;

procedure TLHC_XMLLoader.Load_OST(aElement: TStringListElement);
begin
{$IFDEF TAX}
   if LesniCelek <> nil then
      nactiOstXml(aElement,LesniCelek);
{$ENDIF}
{$IFDEF LED}
   if LHCModel <> nil then
   begin
      LHCModel.CreateSkupinaName(aElement.GetStringByName('OST'));
      LoadLast_PSK;
   end;
{$ENDIF}
end;

procedure TLHC_XMLLoader.Load_OP(aElement: TStringListElement);
var
   i: integer;
   e: TElement;
   S: string;
begin
   aElement.Name := 'OST';
   e := aElement.FindElementName('OP');
   if e <> nil then
      e.Name := 'OST';
   Load_OST(aElement);
end;

procedure TLHC_XMLLoader.Load_OU1(aElement: TStringListElement);
begin

end;

procedure TLHC_XMLLoader.Load_OU2(aElement: TStringListElement);
begin

end;

procedure TLHC_XMLLoader.Load_POR(aElement: TStringListElement);
var
   S: string;
begin
{$IFDEF TAX}
   if LesniCelek <> nil then
      nactiPorXml(aElement,LesniCelek);
{$ENDIF}
{$IFDEF LED}
   S := aElement.GetStringByName('POR');
   if S = '' then S := 'a';
   if DilecByPorost then
   begin
      if LHCModel <> nil then
         LHCModel.CreateDilecName(UpperCase(S));
      //DilecByPorost := false;
   end;
   if LHCModel <> nil then
      LHCModel.CreatePorostName(S);
{$ENDIF}
end;

procedure TLHC_XMLLoader.Load_POS(aElement: TStringListElement);
begin

end;

procedure TLHC_XMLLoader.Load_PSK(aElement: TStringListElement);
begin
{$IFDEF TAX}
   if LesniCelek <> nil then
      nactiPskXml(aElement,LesniCelek);
{$ENDIF}
{$IFDEF LED}
   if LHCModel <> nil then
   begin
      LHCModel.CreateSkupinaName(aElement.GetStringByName('PSK'));
      LoadLast_PSK;
   end;
{$ENDIF}
end;

procedure TLHC_XMLLoader.Load_ZAL(aElement: TStringListElement);
begin
{$IFDEF TAX}
   if LesniCelek <> nil then
      nactiZalXml(aElement,LesniCelek);
{$ENDIF}
end;

procedure TLHC_XMLLoader.Load_B(aElement: TStringListElement);
{$IFDEF LED}
var
   C: T2DCoordinate;
   S,sY,sX: string;
{$ENDIF}
begin
{$IFDEF LED}
   S := aElement.GetStringByName('S');
   StringAsTwoParams(S,'$',Sy,Sx);
   Sy := '-'+Sy;
   Sx := '-'+Sx;
   C := T2DCoordinate.Create;
   C.SetPropertyStringByName('X',Sx);
   C.SetPropertyStringByName('Y',Sy);
   case GeometryStatus of
   gsArea:
      begin
         TPolyLineElement(Actual_GLine).AddAndUpdateRect(C);
         TPolyLineAreaElement(Actual_Hole).UpdateRect(Actual_GLine);
      end;
   gsLine:
      begin
         TPolyLineElement(Actual_GLine).AddAndUpdateRect(C);
      end;
   gsPoint:
      begin
         TGeometryElement(Actual_Point).Geometry.AddAndUpdateRect(C);
      end;
   gsText:
      begin
         TTopolTextElement(Actual_Text).StartPoint := C;
         TTopolTextElement(Actual_Text).Geometry.UpdateRect(C);
      end;
   else
      C.Free;
   end;

{$ENDIF}
end;

procedure TLHC_XMLLoader.Load_BZL_OBRAZ(aElement: TStringListElement);
begin

end;

procedure TLHC_XMLLoader.Load_JP_OBRAZ(aElement: TStringListElement);
begin

end;

procedure TLHC_XMLLoader.Load_L(aElement: TStringListElement);
{$IFDEF LED}
var
   Are: TPolyLineAreaElement;
{$ENDIF}
begin
{$IFDEF LED}
   Actual_GLine := TPolyLineElement.Create;
   case GeometryStatus of
   gsArea:
      begin
         if Actual_Area = nil then exit;
         Are := TPolyLineAreaElement.Create;
         Are.AddElement(Actual_GLine);
         if AreaStatus = asNil then
         begin
            TGeometryElement(Actual_Area).AddGeometry(Are);
            Actual_GArea := Are;
            Actual_Hole := Are;
            AreaStatus := asMain;
         end
         else
         begin
            if AreaStatus = asMain then AreaStatus := asHole;
            TAreaElement(Actual_GArea).AddHole(Are);
            Actual_Hole := Are;
         end;
      end;
   gsLine:
      begin
         TGeometryElement(Actual_Line).Geometry := TPolyLineElement(Actual_GLine);
      end;
   end;
{$ENDIF}
end;


procedure TLHC_XMLLoader.Load_ML(aElement: TStringListElement);
begin

end;

procedure TLHC_XMLLoader.Load_MP(aElement: TStringListElement);
begin

end;

procedure TLHC_XMLLoader.Load_OST_OBRAZ(aElement: TStringListElement);
begin

end;

procedure TLHC_XMLLoader.Load_P(aElement: TStringListElement);
begin
{$IFDEF LED}
   AreaStatus := asNil;
{$ENDIF}
end;

procedure TLHC_XMLLoader.Load_PSK_OBRAZ(aElement: TStringListElement);
begin

end;

procedure TLHC_XMLLoader.SetActual_Area(const Value: TElement);
begin
  FActual_Area := Value;
end;

procedure TLHC_XMLLoader.SetActual_BZL(const Value: TElement);
begin
  FActual_BZL := Value;
end;

procedure TLHC_XMLLoader.SetActual_DIL(const Value: TElement);
begin
  FActual_DIL := Value;
end;

procedure TLHC_XMLLoader.SetActual_DRV(const Value: TElement);
begin
  FActual_DRV := Value;
end;

procedure TLHC_XMLLoader.SetActual_ETZ(const Value: TElement);
begin
  FActual_ETZ := Value;
end;

procedure TLHC_XMLLoader.SetActual_GArea(const Value: TElement);
begin
  FActual_GArea := Value;
end;

procedure TLHC_XMLLoader.SetActual_GLine(const Value: TElement);
begin
  FActual_GLine := Value;
end;

procedure TLHC_XMLLoader.SetActual_HS(const Value: TElement);
begin
  FActual_HS := Value;
end;

procedure TLHC_XMLLoader.SetActual_JP(const Value: TElement);
begin
  FActual_JP := Value;
end;

procedure TLHC_XMLLoader.SetActual_KAT(const Value: TElement);
begin
  FActual_KAT := Value;
end;

procedure TLHC_XMLLoader.SetActual_KBO(const Value: TElement);
begin
  FActual_KBO := Value;
end;

procedure TLHC_XMLLoader.SetActual_KLO(const Value: TElement);
begin
  FActual_KLO := Value;
end;

procedure TLHC_XMLLoader.SetActual_KPO(const Value: TElement);
begin
  FActual_KPO := Value;
end;

procedure TLHC_XMLLoader.SetActual_KTO(const Value: TElement);
begin
  FActual_KTO := Value;
end;

procedure TLHC_XMLLoader.SetActual_LHC(const Value: TElement);
begin
  FActual_LHC := Value;
end;

procedure TLHC_XMLLoader.SetActual_Line(const Value: TElement);
begin
  FActual_Line := Value;
end;

procedure TLHC_XMLLoader.SetActual_MZD(const Value: TElement);
begin
  FActual_MZD := Value;
end;

procedure TLHC_XMLLoader.SetActual_ODD(const Value: TElement);
begin
  FActual_ODD := Value;
end;

procedure TLHC_XMLLoader.SetActual_OLH(const Value: TElement);
begin
  FActual_OLH := Value;
end;

procedure TLHC_XMLLoader.SetActual_OST(const Value: TElement);
begin
  FActual_OST := Value;
end;

procedure TLHC_XMLLoader.SetActual_OU1(const Value: TElement);
begin
  FActual_OU1 := Value;
end;

procedure TLHC_XMLLoader.SetActual_OU2(const Value: TElement);
begin
  FActual_OU2 := Value;
end;

procedure TLHC_XMLLoader.SetActual_Point(const Value: TElement);
begin
  FActual_Point := Value;
end;

procedure TLHC_XMLLoader.SetActual_POR(const Value: TElement);
begin
  FActual_POR := Value;
end;

procedure TLHC_XMLLoader.SetActual_POS(const Value: TElement);
begin
  FActual_POS := Value;
end;

procedure TLHC_XMLLoader.SetActual_PSK(const Value: TElement);
begin
  FActual_PSK := Value;
end;

procedure TLHC_XMLLoader.SetActual_Text(const Value: TElement);
begin
  FActual_Text := Value;
end;

procedure TLHC_XMLLoader.SetActual_ZAL(const Value: TElement);
begin
  FActual_ZAL := Value;
end;

procedure TLHC_XMLLoader.SetAreaEntity(const Value: TEntity);
begin
  FAreaEntity := Value;
end;

procedure TLHC_XMLLoader.SetAreaStatus(const Value: TAreaStatus);
begin
  FAreaStatus := Value;
end;

procedure TLHC_XMLLoader.SetGeometryStatus(const Value: TGeometryStatus);
begin
  FGeometryStatus := Value;
end;

procedure TLHC_XMLLoader.SetActual_Hole(const Value: TElement);
begin
  FActual_Hole := Value;
end;

procedure TLHC_XMLLoader.SetLayers(const Value: TEntity);
begin
  FLayers := Value;
end;


{$IFDEF LED}
procedure TLHC_XMLLoader.UpdateLayers;
var
   i,j: integer;
   e: TElement;
   R: TRectEntity;
   G: TGeometryElement;
begin
   if Layers = nil then exit;
   if Layers.NoElements then exit;
   for i := 0 to Layers.LastIndex do
   begin
      e := Layers.Elements[i];
      if not (e is TRectEntity) then continue;
      R := TRectEntity(e);
      if not R.NoElements then
      for j := 0 to R.LastIndex do
      begin
         e := R.Elements[j];
         if not (e is TGeometryElement) then continue;
         G := TGeometryElement(e);
         if not G.NoGeometry then
         begin
            G.Geometry.Update;
            if G.Geometry is TPolyLineElement then
               TPolyLineElement(G.Geometry).CalculateLabelProps;
         end;

      end;
      R.ResetAndUpdate;
   end;
   if LHCModel <> nil then
      LHCModel.UpdateAll := True;
   UpdatePSKByWorkLevel;
   if not NewFormat then
      FindDETLines;
   if PAR then
      FindPARLines;
end;
{$ENDIF}

{$IFDEF LED}
procedure TLHC_XMLLoader.SetLHCModel(const Value: Tgis_ForestModel);
begin
  FLHCModel := Value;
end;
{$ENDIF}

procedure TLHC_XMLLoader.SetTempDirectory(const Value: string);
begin
  FTempDirectory := Value;
end;

function TLHC_XMLLoader.GetTempDirectory: string;
begin
   //if FTemDirectory = '' or not DirectoryExists(FTempDirectory) then
   //   FTempDirectory := GetAbsolutePath('');
   result := CHeckBackSlash(FTempDirectory);
end;

procedure TLHC_XMLLoader.SetPerPartes(const Value: boolean);
begin
  FPerPartes := Value;
end;

procedure TLHC_XMLLoader.SetLastLayer(const Value: TEntity);
begin
  FLastLayer := Value;
end;

procedure TLHC_XMLLoader.SetLHC_KOD(const Value: string);
begin
  FLHC_KOD := Value;
end;

procedure TLHC_XMLLoader.LoadLast_PSK;
var
   S: string;
   E: TEntity;
begin
{$IFDEF LED}
   GeometryStatus := gsArea;
   //if AreaEntity = nil then exit;
   if Layers = nil then exit;
   S := 'ARE_DET';
   E := TEntity(Layers.FindOrCreateElementName(TAreaCollection,S));
   Actual_Area := LHCModel.ActualSkupina;
   E.AddElement(Actual_Area);
{$ENDIF}
end;

procedure TLHC_XMLLoader.SetNewFormat(const Value: boolean);
begin
  FNewFormat := Value;
end;

{$IFDEF LED}
procedure TLHC_XMLLoader.SetParcelModel(const Value: Tgis_ParcelModel);
begin
  FParcelModel := Value;
end;

procedure TLHC_XMLLoader.UpdatePSKByWorkLevel;
var
   i,j: integer;
   DETW: TEntity;
   e: TElement;
   FMS: TForestModelSelector;
   PSK: Tgis_PorostniSkupina;
   TA: TTopolAreaElement;
   APP: TMultiAreaPointPlacer;
   SameBarva: boolean;
   LastBarva: integer;
   SLE: TStringListElement;
   SE: TStringELement;
   ETZCount: integer;
   V1,V2,Z1,Z2,VV,ZZ: integer;
   VS: integer;
begin
   if Layers = nil then exit;
   if LHCModel = nil then exit;
   DETW := TEntity(Layers.FindElementName('ARE_DETW'));
   SameBarva := true;
   if DETW <> nil then
   begin
      LastBarva := -1;
      FMS := TForestModelSelector.Create;
      FMS.FrameClass := Tgis_PorostniSkupina;
      FMS.ForestModel := LHCModel;
      APP := TMultiAreaPointPlacer.Create;
      APP.Input := DETW;
      APP.DoIt;
      APP.Free;
      for i := 0 to DETW.LastIndex do
      begin
         e := DETW.Elements[i];
         if not(e is TTopolAreaElement) then continue;
         TA := TTopolAreaElement(e);
         if LastBarva = -1 then
            LastBarva := TA.Barva
         else
         if TA.Barva <> LastBarva then
            SameBarva := false;
         FMS.X := TA.X;
         FMS.Y := TA.Y;
         FMS.DoIt;
         if FMS.ActualFrame <> nil then
         begin
            FMS.ActualFrame.Barva := TA.Barva;
            FMS.ActualFrame.Znacka := TA.Znacka;
         end;
      end;
      DETW.Free;
      FMS.Free;
   end;
   if SameBarva then   // barvy a znacky pro det
   begin
      DETW := TEntity(Layers.FindElementName('ARE_DET'));
      if DETW <> nil then
      for i := 0 to DETW.LastIndex do
      begin
         e := DETW.Elements[i];
         if not (e is Tgis_PorostniSKupina) then continue;
         PSK := Tgis_PorostniSkupina(e);
         SLE := TStringListElement(PSK.FindElementName('ETZ'));
         if (SLE = nil) or SLE.NoElements then
         begin
            PSK.Barva := 15;
            PSK.Znacka := 1;
            PSK.VEK_ST := 0;
            Continue;
         end;
         ETZCount := SLE.Count;
         V1 := 0;
         Z1 := 0;
         V2 := 0;
         Z2 := 0;
         VS := 0;
         if ETZCount = 1 then
         begin
            SE := SLE.StringElements[0];
            V1 := StrToIntDef(SE.Name,0);
            Z1 := SE.AsInteger;
            VS := (V1 + 9) div 10;
            if V1 > 0 then
            begin
               if Z1 >= 7 then
                  PSK.Znacka := 1
               else
               begin
                  if Z1 >= 4 then
                     Z1 := 10000
                  else
                     Z1 := 20000;
                  V1 := V1 + 19;
                  if V1 > 179 then
                     V1 := 179;
                  PSK.Znacka := Z1 + (V1 div 20);
               end;
            end;
         end
         else
         begin
            for j := 0 to SLE.LastIndex do
            begin
               SE := SLE.StringElements[j];
               VV := StrToIntDef(SE.Name,0);
               ZZ := SE.AsInteger;
               if ZZ >= 7 then
                  ZZ := 10
               else
               if ZZ >= 4 then
                  ZZ := 6
                else
                  ZZ := 3;
               if VV > V1 then
               begin
                  V2 := V1;
                  Z2 := Z1;
                  V1 := VV;
                  Z1 := ZZ;
               end
               else
               if VV > V2 then
               begin
                  V2 := VV;
                  Z2 := ZZ;
               end;
            end;
            VS := (V1 + 9) div 10;
            if Z2 > Z1 then
            begin
               ZZ := Z1;
               Z1 := Z2;
               Z2 := ZZ;
               VV := V1;
               V1 := V2;
               V2 := VV;
            end;
            V1 := V1 + 19;
            if V1 > 179 then
               V1 := 179;
            V2 := V2 + 19;
            if V2 > 179 then
               V2 := 179;
            if (Z1 = 10) and (Z2 = 3) then
               ZZ := 20000
            else
            if (Z1 = 10) and (Z2 = 6) then
               ZZ := 10000
            else
            if (Z1 = 6) and (Z2 = 3) then
               ZZ := 25000
            else
            if (Z1 = Z2) then
            begin
               if V2 < V1 then
               begin
                  ZZ := Z1;
                  Z1 := Z2;
                  Z2 := ZZ;
                  VV := V1;
                  V1 := V2;
                  V2 := VV;
               end;
               case Z1 of
                  6: ZZ := 10000;
               else
                  ZZ := 26000;
               end;
            end;
            PSK.Znacka := ZZ + 10* (V1 div 20) + (V2 div 20);
         end;
         case VS of
            0:     PSK.Barva := 15;
            1,2:   PSK.Barva := 14;
            3,4:   PSK.Barva := 11;
            5,6:   PSK.Barva := 9;
            7,8:   PSK.Barva := 10;
            9,10:  PSK.Barva := 6;
            11,12: PSK.Barva := 7;
            13,14: PSK.Barva := 5;
            else
               PSK.Barva := 2;
         end;
         PSK.VEK_ST := VS;
         if Format2013 then
            PSK.Znacka := 1;
      end;
   end;
end;

procedure TLHC_XMLLoader.FindDetLines;
var
   LE: TLineExtractor;
   LIN_DET,ARE_DET,WE: TEntity;
   i: integer;
   L: TPolyLineElement;
   TL: TTopolLineElement;
   e: TElement;
begin
   if Layers = nil then exit;
   LIN_DET := TEntity(Layers.FindOrCreateElementName(TPolyLineCollection,'LIN_DET'));
   ARE_DET := TEntity(Layers.FindOrCreateElementName(TAreaCollection,'ARE_DET'));
   LE := TLineExtractor.Create;
   LE.Input := ARE_DET;
   LE.NoDuplicates := True;
   LE.DoIt;
   WE := TEntity(LE.Output);
   for i := 0 to WE.LastIndex do
   begin
      e := WE.Elements[i];
      if not (e is TPolyLineElement) then continue;
      L := TPolyLineElement(e);
      TL := TTopolLineElement.Create;
      TL.Druh := 1;
      TL.Barva := 0;
      TL.Znacka := 0;
      TL.Geometry := L;
      LIN_DET.AddElement(TL);
   end;
   if LIN_DET is TRectEntity then
      TRectEntity(LIN_DET).ResetAndUpdate;
   LE.Free;
end;


{$ENDIF}

{$IFDEF TAX}
procedure TLHC_XMLLoader.SetLesniCelek(const Value: TLesniCelek);
begin
  FLesniCelek := Value;
end;

procedure TLHC_XMLLoader.SetPripravLesniCelekZAdresare(const Value: String);
begin
   LesniCelek := PripravLesniCelekXML(Value);
end;

procedure TLHC_XMLLoader.SetPripravLesniCelek(Value: boolean);
begin
   LesniCelek := PripravLesniCelekXML('');
end;

procedure TLHC_XMLLoader.SetUkonciLesniCelek(Value: boolean);
begin
   if LesniCelek <> nil then
      UkonciLesniCelekXML(LesniCelek);
end;

{$ENDIF}


procedure TLHC_XMLLoader.SetDilecBYPorost(const Value: boolean);
begin
  FDilecBYPorost := Value;
end;


procedure TLHC_XMLLoader.SetIgnoreL_(const Value: boolean);
begin
  FIgnoreL_ := Value;
end;


procedure TLHC_XMLLoader.SetLcr(const Value: boolean);
begin
  FLcr := Value;
end;

procedure TLHC_XMLLoader.Load_PAR(aElement: TStringListElement; aTyp: integer);
{$IFDEF LED}
var
   G: TGeometryElement;
   E: TEntity;
   S: string;
   aKU: Tgis_Katastr;
   aP: Tgis_Parcela;
   aPC: Tgis_ParcelaCast;
   aParcis, aParpod, aDruh: integer;
{$ENDIF}
begin
{$IFDEF LED}
   if ParcelModel = nil then exit;
   if Layers = nil then exit;
   GeometryStatus := gsArea;
   aKu := ParcelModel.CreateKatastrCislo(aElement.GetIntegerByName('KATUZE_KOD'));
   if aKu.Nazev = '' then
      aKu.Nazev := aElement.GetStringByName('NAZEV');
   aParcis := aElement.GetIntegerByName('PARCIS');
   aParpod := aElement.GetIntegerByName('PARPOD');
   aDruh := aElement.GetIntegerByName('DRUH');
   if aDruh = 1 then
      aParcis := -aParcis;
   ParcelModel.CreateParcelaCislo(aParcis, aParpod,0); // KATUZE_KOD_PUV se nenacita...
   ParcelModel.CreateParCast;
   aP := ParcelModel.ActualParcela;
   aPC := ParcelModel.ActualParCast;
   aPC.Zmena := aElement.GetStringByName('ZMENA');
   //if AreaEntity = nil then exit;
   aPC.SuperID := aTyp;
   aPC.Znacka := 1;
   case aTyp of
      -1: if aParcis < 0 then aPC.Barva := 4 else aPC.Barva := 11;
       0: aPC.Barva := 10;
       1: aPC.Barva := 9;
   end;
   if aTyp = 1 then
   begin
      aP.SetPropertyStringByName('Vymera',aElement.GetStringByName('VYMERA'));
      aPC.Kultura := aElement.GetintegerByName('DRUPOZ_KOD');
      aPC.KulturaC := aElement.GetintegerByName('DRUPOZ_LHP');
      aPC.Poznamka := aElement.GetStringByName('POZNAMKA');
      aPC.PUPFL_Text := aElement.GetStringByName('PUPFL_KN');
      aPC.PUPFLC_Text := aElement.GetStringByName('PUPFL_LHP');
      aPC.LV := aElement.GetIntegerByName('LV');
   end;
   aPC.ATR_PUV := aElement.GetIntegerByName('ATR_PUV');
   G := aPC;
   //G.SetPropertyStringByName('Druh',aElement.GetStringByName('PLO_DRUH'));
   //G.SetPropertyStringByName('Barva',aElement.GetStringByName('PLO_BARVA'));
   //G.SetPropertyStringByName('Znacka',aElement.GetStringByName('PLO_ZNACKA'));
   NewFormat := true;
   S := 'ARE_PAR';
   E := TEntity(Layers.FindOrCreateElementName(TGeometryElementCollection,S));
   if not (G.IsMyOwner(E)) then
      E.AddElement(G);
   Actual_Area := G;
   PAR := true;
{$ENDIF}
end;

procedure TLHC_XMLLoader.SetPAR(const Value: boolean);
begin
  FPAR := Value;
end;

procedure TLHC_XMLLoader.FindPARLines;
var
   LE: TLineExtractor;
   LIN_PAR,ARE_PAR,WE: TEntity;
   i: integer;
   L: TPolyLineElement;
   TL: TTopolLineElement;
   e: TElement;
begin
   if Layers = nil then exit;
   LIN_PAR := TEntity(Layers.FindOrCreateElementName(TGeometryElementCollection,'LIN_PAR'));
   ARE_PAR := TEntity(Layers.FindOrCreateElementName(TGeometryElementCollection,'ARE_PAR'));
   LE := TLineExtractor.Create;
   LE.Input := ARE_PAR;
   LE.NoDuplicates := True;
   LE.DoIt;
   WE := TEntity(LE.Output);
   for i := 0 to WE.LastIndex do
   begin
      e := WE.Elements[i];
      if not (e is TPolyLineElement) then continue;
      L := TPolyLineElement(e);
      TL := TTopolLineElement.Create;
      TL.Druh := 8210;
      TL.Barva := -25600;
      TL.Znacka := 17350;
      TL.Geometry := L;
      LIN_PAR.AddElement(TL);
   end;
   if LIN_PAR is TRectEntity then
      TRectEntity(LIN_PAR).ResetAndUpdate;
   LE.Free;
end;

procedure TLHC_XMLLoader.Load_L_KN_KAT(aElement: TStringListElement);
{$IFDEF LED}
var
   G: TGeometryElement;
   TL: TTopolLineELement;
   E: TEntity;
   S: string;
{$ENDIF}
begin
{$IFDEF LED}
   GeometryStatus := gsLine;
   if Layers = nil then exit;
   TL := TTopolLineElement.Create;
   TL.Druh := 36;
   TL.Barva := 11;
   TL.Znacka := 15640;
   S := 'LIN_KU';
   NewFormat := true;
   E := TEntity(Layers.FindOrCreateElementName(TGeometryElementCollection,S));
   E.AddElement(TL);
   Actual_Line := TL;
{$ENDIF}
end;

procedure TLHC_XMLLoader.SetG_DIL(const Value: boolean);
begin
  FG_DIL := Value;
end;

procedure TLHC_XMLLoader.Load_PAR_B(aElement: TStringListElement);
var
   E: TEntity;
   S: string;
   TP: TTopolPointElement;
   P: TPointElement;
   PC: Tgis_ParcelaCast;
begin
   GeometryStatus := gsPoint;
   if Layers = nil then exit;
   TP := TTopolPointElement.Create;
   // Hledn vrstvy
   S := 'PNT_PAR';
   E := TEntity(Layers.FindOrCreateElementName(TGeometryElementCollection,S));
   E.AddElement(TP);
   Actual_Point := TP;
   P := TPointElement.Create;
   TP.Geometry := P;
   TP.Druh := 8210;
   TP.Barva := 11;
   TP.Znacka := 1022;
   PC := ParcelModel.ActualParCast;
   if PC <> nil then
      TP.Name := 'P '+ IntToStr(PC.KU_KOD) + ' ' + PC.Name + ' (' + IntToStr(PC.ATR_PUV) + ')'
   else
      TP.Name := 'P -';
   TP.Properties := PC;
   //P.SetPropertyStringByName('Angle',aElement.GetStringByName('BOD_UHELZN'));
end;

procedure TLHC_XMLLoader.SetFormat2013(const Value: boolean);
begin
  FFormat2013 := Value;
end;

procedure TLHC_XMLLoader.SetARE_Druhy_L(const Value: TEntity);
begin
  ExchangeFieldElement(TElement(FARE_Druhy_L), Value);
end;

procedure TLHC_XMLLoader.SetLIN_Druhy_L(const Value: TEntity);
begin
  ExchangeFieldElement(TElement(FLIN_Druhy_L), Value);
end;

procedure TLHC_XMLLoader.SetPNT_Druhy_L(const Value: TEntity);
begin
  ExchangeFieldElement(TElement(FPNT_Druhy_L), Value);
end;

procedure TLHC_XMLLoader.SetTXT_Druhy_L(const Value: TEntity);
begin
  ExchangeFieldElement(TElement(FTXT_Druhy_L), Value);
end;

function TLHC_XMLLoader.FindLayerByDruh(aTyp, aDruh: string): string;
var
   anEntity: TEntity;
   e: TElement;
begin
   anEntity := nil;
   result := '';
   case aTyp[1] of
      'L': anEntity := LIN_Druhy_L;
      'A': anEntity := ARE_Druhy_L;
      'P': anEntity := PNT_Druhy_L;
      'T': anEntity := TXT_Druhy_L;
   end;
   if anEntity = nil then exit;
   e := anEntity.FindElementName(aDruh);
   if e = nil then exit;
   if not (e is TStringElement) then exit;
   result := TStringElement(e).Value;
end;

INITIALIZATION
   RegisterOrbisClass(TLHC_XMLLoader);
END.

