unit t_OrbisPageForm;

interface
uses
   ComCtrls,
   f_ORBISPageForm,
   t_ORBISPageFrame,
   t_FormTool,
   t_ControlTool,
   Tools;

type

TOrbisPageForm = class(TFormTool)
  private
    function GetPageForm: TOrbisPage_Form;
    procedure SetNewPageName(const Value: string);
public
   procedure   CreateForm; override;

   function    AddTool(aTool: TTool): TTool; override;
   property    PageForm: TOrbisPage_Form read GetPageForm;
published
   property    NewPageName: string write SetNewPageName stored false;
end;


implementation
uses
   Forms,
   SysUtils,
   e_Class;

{ TOrbisPageForm }

function TOrbisPageForm.AddTool(aTool: TTool): TTool;
begin
   result := inherited AddTool(aTool);
   if result is TOrbisFormPage then
   begin
      TOrbisFormPage(result).Control.Name := 'Tab'+IntToStr(PageForm.PageControl.PageCount);
      TOrbisFormPage(result).Owner := PageForm;
      TOrbisFormPage(result).TabSheet.PageControl := PageForm.PageControl;
   end;
end;

procedure TOrbisPageForm.CreateForm;
begin
   aForm := TORBISPage_Form.Create(Application);
   PageForm.Tool := Self;
   PageForm.IsPossibleToClose := false;
end;

function TOrbisPageForm.GetPageForm: TOrbisPage_Form;
begin
   result := TORBISPage_Form(aForm);
end;

procedure TOrbisPageForm.SetNewPageName(const Value: string);
var
   //Tab: TTabSheet;
   P: TOrbisFormPage;
begin
   {
   Tab := TTabSheet.Create(PageForm);
   Tab.Name := 'Tab'+IntToStr(PageForm.PageControl.PageCount);
   Tab.Caption := Value;
   Tab.PageControl := PageForm.PageControl;
   }
   P := TOrbisFormPage.Create;
   P.Name := Value;
   AddTool(P);
end;


INITIALIZATION
   RegisterOrbisClass(TOrbisPageForm);
END.
