unit t_ProjectIntroDialog;

interface
uses
   f_ProjectIntroDialog,
   t_OrbisDialog;

type

TProjectIntroDialog = class(TOrbisDialog)
private
   function GetForm: TProjectIntroDialog_Form;
   procedure SetLastProjectName(const Value: string);
   function GetDontViewDialog: boolean;
   function GetOLP: boolean;
   procedure SetOLP(const Value: boolean);
public
   procedure DoIt; override;
   procedure CreateForm; override;
   property  Form: TProjectIntroDialog_Form read GetForm;
   property  LastProjectName: string write SetLastProjectName;
   property  DontViewDialog: boolean read GetDontViewDialog;
   property  OpenLastProject: boolean read GetOLP write SetOLP;
end;


implementation
uses
   Forms;

{ TProjectIntroDialog }

procedure TProjectIntroDialog.CreateForm;
begin
   aForm := TProjectIntroDialog_Form.Create(Application);
   aForm.Tool := Self;
   aForm.IsPossibleToClose := false;
end;

procedure TProjectIntroDialog.DoIt;
begin
   Inherited;
   if result = 1 then
   begin
      if Form.r_NewProject.Checked then result := 4 else
      if Form.r_OpenProject.Checked then result := 5 else result := 6;
   end;
end;

function TProjectIntroDialog.GetDontViewDialog: boolean;
begin
   result := Form.c_DontViewDialog.Checked;
end;

function TProjectIntroDialog.GetForm: TProjectIntroDialog_Form;
begin
   result := TProjectIntroDialog_Form(aForm);
end;

function TProjectIntroDialog.GetOLP: boolean;
begin
   result := Form.c_AutoLastProject.Checked;
end;

procedure TProjectIntroDialog.SetLastProjectName(const Value: string);
begin
   if Value <> '' then
   begin
      Form.r_OpenLastProject.Enabled := true;
      Form.l_LastProject.enabled := true;
      Form.l_LastProject.Caption := Value;
   end;
end;

procedure TProjectIntroDialog.SetOLP(const Value: boolean);
begin
   Form.c_AutoLastProject.Checked := Value;
end;

end.
