unit u_DBLib;
{
 direktivy:
 IP - podpora infopower fc
 FEDITOR - podpora dialogu pro nastaven databzovch pol
 }

interface
uses
   Classes,
   Controls,
   DB,
   DBTables,
   SysUtils,
{$IFDEF IP}
   wwTable,
   wwQuery,
{$ENDIF}
   StdCtrls,
   u_BDELib;

   type
       TStatusModifyStru =(add, drop);
       EExtInvalid = class(Exception);

   function orbAddDbFieldsToListBox(aDataSet: TDataSet; var aListBox: TListBox): Boolean;
   function orbCanCallExecSQL(aSqlList: TStrings): Boolean;
   function orbCloseDataSet(aDs: TDataSet): Boolean;
   function orbDataSetApplyUpdates(DataSet: TDataSet; Apply: Boolean): Boolean;
   function OrbDeleteIndexFile(aIdxName: String): Boolean;
   function orbExecQuery(aQry: TQuery): Boolean;
   function orbGetAliasParams(aText: String; var aSLst: TstringList): Boolean;
   function orbGetAppName: String;
   function orbGetDbFields(aDataSet: TDataSet; var aSList: TStringList): Boolean;
   function orbGetDbPassword(aDataBase: TDatabase): String;
   function orbGetTblFromDir(aPath, aExt: String;  var sListTbl: TstringList): Boolean;

   function orbGetTblFromServer(aDrv: String; var sListTbl: TstringList;
            ShowSysTables: Boolean; aQuery: TQuery): Boolean;
   function orbIsEditMode(aDs: TDataSource): Boolean;
   function orbIsInsertEditMode(aDs: TDataSource): Boolean;
   function orbIsInsertMode(aDs: TDataSource): Boolean;
   function orbIsOpenMode(aDs: TDataSource): Boolean;
   function orbIsOpenQuery(aQry: TQuery): Boolean;
   function orbIsOpenTable(aTbl: TTable): Boolean;
   function orbOpenDataSource(aDs: TDataSource): Boolean;
   function orbOpenQuery(aQry: TQuery): Boolean;
   function orbOpenTable(aTbl: TTable): Boolean;
   function orbSetTypeDb(aTbl: TTable): String;
   function orbTestBde: Boolean;

   procedure OrbCheckIndex(aTable: TTable; aIdxName, aIdxFields: String;
             aOptions:TIndexOptions);
   procedure OrbCheckPrimaryKey(aTable: TTable; aIdxFields: String);
{$IFDEF FEDITOR}
   procedure orbDlgSetFields(aTbl: TTable);
{$ENDIF}

{   procedure OrbModifyStru(aTblModify: TTable; aFieldName, aFieldType: String;
             aStatusModifyStru:TStatusModifyStru );
}


implementation

uses
    Dialogs,
{$IFDEF FEDITOR}
    F_Editor,
{$ENDIF}

    Forms,
    u_DBTyps,
    u_String;



function orbGetAppName: String;
var
   PomString: String;
   Pozice: SmallInt;
begin
   PomString := ExtractFileName(ParamStr(0));
   Pozice := Pos('.', PomString);

   if Pozice > 0 then
      Result := Copy(PomString, 1, PoZice - 1)
   else
      Result := PomString;

end;



procedure OrbCheckIndex(aTable: TTable; aIdxName, aIdxFields: String;
           aOptions:TIndexOptions);
var
   i, idxNum: integer;
   idxExists : Boolean;
begin
{
    TIndexOptions = set of (ixPrimary, ixUnique, ixDescending, ixExpression,
     ixCaseInsensitive, ixNonMaintained);
}
    aIdxFields := UpperCase(aIdxFields);
    aIdxName := UpperCase(aIdxName);


   { kontrola existence indexu }
   idxExists := false;

   {Nati existujc indexy}
   aTable.IndexDefs.update;

   {Porovnej indexy}
   for i := 0 to aTable.IndexDefs.Count - 1 do
   begin
      if aTable.IndexDefs.Items[i].Name = aIdxName then
      begin
        idxExists := True;
        IdxNum := i;
        break;
     end;
   end;

   { eventuln reindexace, pop. vytvoenn novho indexu }
   if idxExists then
   begin
      try
//         orbfDbiRegenIndex(aTable, aIdxName, aIdxFields, IdxNum);
      except
         on E: EDBEngineError do
         begin
            MessageDlg(cNoRefreshIdx + aIdxName + cforTable
             + aTable.TableName + cChybHlaseni + E.Message, mtError, [mbOK], 0);
         end;
      end;

   end
   else
   begin
      try
         aTable.AddIndex(aIdxName, aIdxFields, aOptions);
      except
         on E: EDatabaseError do
         begin
            screen.cursor := crDefault;
            MessageDlg(cNoCreateIdx + aIdxName + cforTable
             + aTable.TableName + cChybHlaseni + E.Message, mtError, [mbOK], 0);
         end;
      end;
   end;
end;





procedure OrbCheckPrimaryKey(aTable: TTable; aIdxFields: String);
var
   i, idxNum: integer;
   idxExists : Boolean;
   exclTable: TTable;
   aOptions: TIndexOptions;
   aIdxName: string;
begin
{
    TIndexOptions = set of (ixPrimary, ixUnique, ixDescending, ixExpression,
     ixCaseInsensitive, ixNonMaintained);
}
    aIdxFields := UpperCase(aIdxFields);

   { kontrola existence indexu }
   idxExists := false;

   {Nati existujc indexy}
   exclTable := TTable.Create(Application);
   exclTable.DatabaseName := aTable.DatabaseName;
   exclTable.TableName := aTable.TableName;
   exclTable.Exclusive := True;
   ShowMessage('DbName: ' + exclTable.DatabaseName + cNewRow
    + 'TblName: ' + exclTable.TableName + cNewRow
    + 'IdxField: ' + aIdxFields);

   if orbOpenTable(exclTable) then
   begin
      ShowMessage('TblName: ' + exclTable.TableName + ' open');
      exclTable.IndexDefs.update;

      {Porovnej indexy}
      for i := 0 to exclTable.IndexDefs.Count - 1 do
      begin
         if (UpperCase(exclTable.IndexDefs.Items[i].Fields) = aIdxFIelds) then
         begin
           idxExists := True;
           ShowMessage('Idx ' + aIdxFields + ' exists');
           IdxNum := i;
           break;
        end;
      end;

      { vytvoenn novho indexu }
      if not idxExists then
      begin
         ShowMessage('Idx: ' + aIdxFields + ' neexist');
         try
            aOptions := [ixPrimary];
            ShowMessage('Vytvarim primarni klic ' + aIdxFields);
            exclTable.AddIndex('', aIdxFields, aOptions);
            exclTable.cLose;
            ShowMessage('Idx: ' + aIdxFields + ' vytvoren');
         except
            on E: EDatabaseError do
            begin
               screen.cursor := crDefault;
               MessageDlg(cNoCreateIdx + aIdxName + cforTable
                + exclTable.TableName + cChybHlaseni + E.Message, mtError, [mbOK], 0);
            end;
         end;
      end;
   end;

   exclTable.Free;
end;



function OrbDeleteIndexFile(aIdxName: String): Boolean;
begin
   if DeleteFile(aIdxName) then
      Result := True
   else
      Result := False;
end;



(*
procedure OrbModifyStru(aTblModify: TTable; aFieldName, aFieldType: String;
    aStatusModifyStru:TStatusModifyStru );
var
   Query1: TQuery;
begin
   aTblModify.active := false;

   with Query1 do
   begin
      sql.clear;
      sql.add ('alter table "' + aTblModify.databaseName
         + aTblModify.TableName + '"');
            if aStatusModifyStru = add then
               sql.add ('   add ' + aFieldName + ' ' + aFieldType)
            else
               sql.add ('   drop ' + aFieldName);

      try
         execSQL;
      except
         on E:EDatabaseError do
         begin
            MessageDlg('Nemohu zmnit strukturu tabulky '
             + aTblModify.DatabaseName + aTblModify.TableName + #13#10
             + 'Chybov hlen: ' +  #13#10 + E.Message , mtError, [mbOK], 0);
         end;
      end;
   end;
   aTblModify.Active := true;
end;
*)


{
  Nate seznam pol s TQuery, TTable do ListBoxu
  Vaek 5.5.97 zmna
}

function orbAddDbFieldsToListBox(aDataSet: TDataSet; var aListBox: TListBox): Boolean;
var
   i: Integer;
begin
   Result := False;
   if aDataSet.FieldCount > 0 then
   begin
      aListBox.Items.Clear;
      for i := 0 to aDataSet.FieldCount - 1 do
          aListBox.Items.Add(aDataSet.Fields[i].FieldName);

      Result := True;
   end;
end;


{
  Nate seznam pol z TQuery, TTable do StringListu
  Vaek 5.5.97
}
function orbGetDbFields(aDataSet: TDataSet; var aSList: TStringList): Boolean;
var
   i: Integer;
begin
   Result := False;

   if (aDataSet.FieldCount > 0) then
   begin
      aSList.Clear;
      for i := 0 to aDataSet.FieldCount - 1 do
          aSList.Add(aDataSet.Fields[i].FieldName);

      Result := True;
   end;
end;



function orbGetDbPassword(aDataBase: TDatabase): String;
var
   i, posPass, delStr: Integer;
const
   cPaswd = 9;   // 'PASSWORD='
begin
   Result := '';

//   for i := 0 to MainFormVM.Database1.Params.Count - 1 do
   for i := 0 to aDataBase.Params.Count - 1 do
   begin
      posPass := Pos('PASSWORD=', aDataBase.Params.Strings[i]);
      if posPass > 0 then
      begin
         delStr := length(aDataBase.Params.Strings[i]);
         Result  := copy (aDataBase.Params.Strings[i], cPaswd + 1,
            delStr - cPaswd);

         Break;
      end;
   end;
end;




{
  Nate seznam pol vetn typ z TQuery, TTable do StringListu
  Vaek 27.10.97

function orbGetDbFieldsAndTypes(aDataSet: TDataSet; var aSList: TStringList): Boolean;
var
   i: Integer;
begin
   Result := False;

   if (aDataSet.FieldCount > 0) then
   begin
      aSList.Clear;
      for i := 0 to aDataSet.FieldCount - 1 do
      begin
         aSList.Add(aDataSet.Fields[i].FieldName);
      end;

      Result := True;
   end;
end;
}


function orbSetTypeDb(aTbl: TTable): String;
var
   aExt: String;
begin
   Result := cNoDb;

   with aTbl do
   begin

      if TableType = ttDefault then
      begin
         aExt := UpperCase(ExtractFileExt(TableName));

         if aExt = cTecka + cExtDbase then
            Result := cDbase
         else if aExt = cTecka + cExtPdox then
            Result := cPdox
         else if aExt = '' then
            Result := cSql;
      end
      else if TableType = ttParadox then
         Result := cPdox
      else if TableType = ttDBase then
         Result := cDbase;
   end;
end;



function orbOpenTable(aTbl: TTable): Boolean;
begin
   Result := false;

   if aTbl = nil then exit;

   with aTbl do
   begin
      if State = dsInactive then
         try
            Active := True;
            Result := True;
         except
            on E:EDatabaseError do
            begin
               screen.cursor := crDefault;
               MessageDlg(cNoOpenTbl + cInDb
                + DatabaseName + cChybHlaseni
                + E.Message , mtError, [mbOK], 0);
            end;
         end
      else
         Result := True;
   end;
end;



function orbOpenQuery(aQry: TQuery): Boolean;
begin
   Result := false;

   if aQry = nil then exit;

   with aQry do
   begin
      if State = dsInactive then
         try
            Active := True;
            Result := True;
         except
            on E:EDatabaseError do
            begin
               screen.cursor := crDefault;
               MessageDlg(cNoOpenSql + cNewRow + aQry.SQL.Text + ' ...'
                + cInDb + DatabaseName + cChybHlaseni
                + E.Message , mtError, [mbOK], 0);
            end;
         end
      else
         Result := True;
   end;
end;



function orbOpenDataSource(aDs: TDataSource): Boolean;
begin
   Result:= False;

   if aDs = nil then exit;

   if (aDs.Dataset is TTable) then
      Result := orbOpenTable(TTable(aDs.Dataset))
   else if (aDs.Dataset is TQuery) then
      Result := orbOpenQuery(TQuery(aDs.Dataset))
{$IFDEF IP}
   else if (aDs.Dataset is TwwTable) then
      Result := orbOpenTable(TwwTable(aDs.Dataset))
   else if (aDs.Dataset is TwwQuery) then
      Result := orbOpenQuery(TwwQuery(aDs.Dataset))
{$ENDIF}

   else
      exit;

end;



function orbCloseDataSet(aDs: TDataSet): Boolean;
begin
   Result:= False;

   if aDs = nil then exit;

   with aDs do
   begin
      if State <> dsInactive then
         try
            Close;
            Result := True;
         except
            on E:EDatabaseError do
            begin
               screen.cursor := crDefault;
              if (aDs is TTable) then
                 MessageDlg(cNoCloseTable + TTable(aDs).TableName + cNewRow
                  + ' ...' + cInDb + TTable(aDs).DatabaseName + cChybHlaseni
                  + E.Message , mtError, [mbOK], 0)
              else
                 MessageDlg(cNoCloseSQL + cNewRow + TQuery(aDs).SQL.Text
                  + ' ...' + cInDb + TQuery(aDs).DatabaseName + cChybHlaseni
                  + E.Message , mtError, [mbOK], 0);
               Result := False;
            end;
         end
      else
         Result := True;
   end;
end;



function orbExecQuery(aQry: TQuery): Boolean;
begin
   Result := false;

   if aQry = nil then exit;

   with aQry do
   begin
      if Active = True then Close;

      try
         ExecSQL;
         Result := True;
      except
         on E:EDatabaseError do
         begin
            screen.cursor := crDefault;
            MessageDlg(cNoExecSql + cNewRow + aQry.SQL.Text + ' ...'
             + cInDb + DatabaseName + cChybHlaseni
             + E.Message , mtError, [mbOK], 0);
         end;
      end
   end;
end;



function orbCanCallExecSQL(aSqlList: TStrings): Boolean;
var
   PomStr: String;
begin
   Result := False;
   if aSqlList.Count = 0 then exit;

   PomStr := UpperCase(aSqlList.Strings[0]);

   if Pos('INSERT', PomStr) > 0 then Result := True
   else if Pos('UPDATE', PomStr) > 0 then Result := True
   else if Pos('DELETE', PomStr) > 0 then Result := True
   else if Pos('ALTER', PomStr) > 0 then Result := True;
end;



function orbIsInsertMode(aDs: TDataSource): Boolean;
begin
   if (aDS.State in [dsInsert]) then
      Result := True
   else
      Result := False;
end;



function orbIsEditMode(aDs: TDataSource): Boolean;
begin
   if (aDS.State in [dsEdit]) then
      Result := True
   else
      Result := False;
end;



function orbIsInsertEditMode(aDs: TDataSource): Boolean;
begin
   if (aDS.State in [dsEdit, dsInsert]) then
      Result := True
   else
      Result := False;
end;



function orbIsOpenMode(aDs: TDataSource): Boolean;
begin
   if aDS.State = dsInactive then
      Result := False
   else
      Result := True;
end;



function orbIsOpenQuery(aQry: TQuery): Boolean;
begin
   if aQry.State = dsInactive then
      Result := False
   else
      Result := True;
end;



function orbIsOpenTable(aTbl: TTable): Boolean;
begin
   if aTbl.State = dsInactive then
      Result := False
   else
      Result := True;
end;


{$IFDEF FEDITOR}
procedure orbDlgSetFields(aTbl: TTable);
var
   ModalDlg : TFEditor;
begin
   ModalDlg := TFEditor.Create(Application);
   ModalDlg.SetFields(aTbl);

   if ModalDlg.ShowModal = mrOK then
      ModalDlg.GetFields(aTbl);

   ModalDlg := nil;
   ModalDlg.Free;
end;
{$ENDIF}



function orbGetAliasParams(aText: String; var aSLst: TstringList): Boolean;
var
   aDrvName, s: String;
begin
   Result := False;

   Session.GetAliasParams(aText, aSLst);
   aDrvName := Session.GetAliasDriverName(aText);
   s := cParamAlias + aText + cDvojtecka + cNewRow;

   if aDrvName <> cStandard then
   begin
      aSLst.Insert(0, cDefaultDrv + aDrvName);
//      s := s + 'DEFAULT DRIVER=' + aDrvName;
   end;

{
   for i := 0 to aSLst.Count - 1 do
   begin
      s := s + cNewRow + aSlst.Strings[i] ;
   end;
}
   if aSLst.Count > 0 then Result := True;

//   ShowMessage(s);

end;



function orbGetTblFromDir(aPath, aExt: String;  var sListTbl: TstringList): Boolean;
var
   Path: String;
   aNasel: Integer;
   aSoubRec: TSearchRec;
begin
   Result := False;
   if sListTbl = nil then
      sListTbl := TStringList.Create
   else
      sListTbl.Clear;

   if aExt <> cExtPdox then
      if aExt <> cExtDbase then
      begin
         screen.cursor := crDefault;
         raise EExtInvalid.Create('Neppustn ppona databzov tabulky:'
           + cNewRow + 'ppona je "' + aExt + '"');
         exit;
      end;

   CheckBackSlash(aPath);
   Path := aPath + '*.' + aExt;
   aNasel := FindFirst(Path, $0000003F, aSoubRec);
   if aNasel = 0 then Result := True;

   while aNasel = 0 do
   begin
     sListTbl.Add(aSoubRec.Name);
     aNasel := FindNext(aSoubRec);
   end;

   FindClose(aSoubRec);
end;



function orbTestBde: Boolean;
begin
   Result := True;

   if not orbfDbiInit then
   begin
      Result := False;

      MessageDlg('!! Nelze inicializovat Borland Database Engine 32Bits !!'
        + cNewRow + cNewRow + 'Zjistte zda je BDE32 sprvn nainstalovn.'
        + cNewRow + cNewRow + '!! Program bude ukonen !!', mtError, [mbOK], 0);

       Application.terminate;
   end;
end;


function orbGetTblFromServer(aDrv: String; var sListTbl: TstringList;
         ShowSysTables: Boolean; aQuery: TQuery): Boolean;
begin
   Result := False;
   if aQuery = nil then exit;

   if sListTbl = nil then
      sListTbl := TStringList.Create
   else
      sListTbl.Clear;

   with aQuery do
   begin
      SQL.Clear;
      if aDrv = cInterbase then
      begin
         SQL.Add('select RDB$RELATION_NAME as TBL_NAME FROM RDB$RELATIONS');

         if not ShowSysTables then
         begin
            SQL.Add('   where RDB$SYSTEM_FLAG <> 1');
            SQL.Add('   AND RDB$VIEW_BLR IS NULL');
         end
         else
         begin
            SQL.Add('   where RDB$VIEW_BLR IS NULL');
         end;
         SQL.Add('   order by RDB$RELATION_NAME');
      end
      else if aDrv = cOracle then
      begin
//         SQL.Add('select TABLE_NAME as TBL_NAME from DBA_TABLES');
         SQL.Add('select OWNER||''.''||TABLE_NAME as TBL_NAME from SYS.ALL_TABLES');

         if not ShowSysTables then
            SQL.Add('   where OWNER NOT IN (''SYS'',''SYSTEM'')');
      end
      else
      begin
         ShowMessage('Ovlada ' + aDrv + ' nen v tto verzi podporovn!');
      end;

      try
         Open;
         First;

         while not EOF do
         begin
            sListTbl.Add(FieldByName(cTbl_Name).AsString);
            Result := True;
            Next;
         end;

         Close;
      except
         on E:EDatabaseError do
         begin
            screen.cursor := crDefault;
            MessageDlg(cNoGetTables + DatabaseName + cChybHlaseni
            + E.Message , mtError, [mbOK], 0);
         end;
      end;
   end;
end;



function orbDataSetApplyUpdates(DataSet: TDataSet; Apply: Boolean): Boolean;
begin
   Result := True;

   with DataSet do
   begin
      if (State in [dsEdit, dsInsert]) then
      begin
         if Apply then
         begin
            MessageDlg('Provdn zmny nejsou uloeny, zadejte nejdve uloit nebo neuloit zmny!',
              mtConfirmation, [mbOk], 0);

            Result := False;

         end
         else
         begin
            if (MessageDlg('Provdn zmny nejsou uloeny, chcete pesto skonit?',
               mtConfirmation, [mbYes, mbNo], 0) = mrYes) then
               Cancel
            else
               Result := False;
         end;
      end;
   end;
end;


end.
