unit u_BDELib;

interface

uses
  BDE, Classes, Controls, DB, DBTables, Dialogs, StdCtrls, SysUtils,
  Windows,
  u_DbTyps,
  u_String;


type
  TDbiKey = packed array [0..DBIMAXFLDSINKEY-1] of Word;

  TorbIDXDesc = class
  private
     function  GetszFormat: string;
     function  GetszKeyCond: string;
     function  GetszKeyExp: string;
     function  GetszName: string;
     function  GetszTagName: string;

//     procedure SetaiKeyFld(aValue: TDbiKey);
     procedure SetbCaseInsensitive(aValue: WordBool);
     procedure SetbDescending(aValue: WordBool);
     procedure SetbExpIdx(aValue: WordBool);
     procedure SetbMaintained(aValue: WordBool);
     procedure SetbPrimary(aValue: WordBool);
     procedure SetbSubset(aValue: WordBool);
     procedure SetbUnique(aValue: WordBool);
     procedure SetiFldsInKey(aValue: Word);
     procedure SetiIndexId(aValue: Word);
     procedure SetiKeyExpType(aValue: Word);
     procedure SetiKeyLen(aValue: Word);
     procedure SetszFormat(aValue: string);
     procedure SetszKeyCond(aValue: string);
     procedure SetszKeyExp(aValue: string);
     procedure SetszName(aValue: string);
     procedure SetszTagName(aValue: string);
  public
     fIDXDesc: IDXDesc;

     property szName: string read GetszName write SetszName;
     property iIndexId: Word read fIDXDesc.iIndexId write SetiIndexId;
     property szTagName: string read GetszTagName write SetszTagName;
     property szFormat: string read GetszFormat write SetszFormat;
     property bPrimary: WordBool read fIDXDesc.bPrimary write SetbPrimary;
     property bUnique: WordBool read fIDXDesc.bUnique write SetbUnique;
     property bDescending: WordBool read fIDXDesc.bDescending write SetbDescending;
     property bMaintained: WordBool read fIDXDesc.bMaintained write SetbMaintained;
     property bSubset: WordBool read fIDXDesc.bSubset write SetbSubset;
     property bExpIdx: WordBool read fIDXDesc.bExpIdx write SetbExpIdx;
     property iCost: Word read fIDXDesc.iCost;
     property iFldsInKey: Word read fIDXDesc.iFldsInKey write SetiFldsInKey;
     property iKeyLen: Word read fIDXDesc.iKeyLen write SetiKeyLen;
     property bOutOfDate: WordBool read fIDXDesc.bOutOfDate;
     property iKeyExpType: Word read fIDXDesc.iKeyExpType write SetiKeyExpType;

   //  property aiKeyFld: TDbiKey read fIDXDesc.aiKeyFld write SetaiKeyFld;
     property szKeyExp: string read GetszKeyExp write SetszKeyExp;
     property szKeyCond: string read GetszKeyCond write SetszKeyCond;
     property bCaseInsensitive: WordBool read fIDXDesc.bCaseInsensitive
              write SetbCaseInsensitive;
end;




// Vrt pihlaovac jmno uivatele do st
   function  orbfDbiGetMyNetUserName: String;

// Test existence BDE
   function orbfDbiInit: Boolean;

   function  orbfDbiPackTable(aTbl: TTable): Boolean;

   function  orbDbiSaveChanges(DataSet: TDataSet): Boolean;

   function orbGetConfigParameter(hCur: hDBICur; Param: string; Count: pword): string;


   procedure orbSetConfigParameter(hCur: hDBICur; Param: string; Value: string);
   procedure orbSetConfigParameter2(hCfg: hDBICfg;Param: string; Value: string);

// Provede uzamen tabulky do exclusivnho mdu
   procedure orbAcqAndRelPersistTableLock(aTbl: TTable);
   procedure orbfDbiAcqTableLock(aTbl: TTable);
// Vlo nov Alias do IDAPI.CFG
   procedure orbfDbiAddAlias(DestCfg: hDBICfg; AliasName: String;
             adbDriveType: String; AliasParams: TStringList; aSaveAlias: Boolean);
// Zalo nov index
   procedure orbfDbiAddIndex(aTbl: TTable; adbDriveType: String; NewIndex: IDXDesc);
// Vlo nov heslo do seznamu hesel
   procedure orbfDbiAddPassword(hSes: hDBISes; aPswd: String);
// Vymae alias z configuranho souboru Bde (DestCfg)
   procedure orbDbiDeleteAlias(DestCfg: hDBICfg; AliasName: String);
// Vrac handle pro aktuln session
   procedure orbDbiGetCurrSession(var hTmpSes: hDBISes);

// Vrac bde Config Info List
   procedure orbDbiOpenCfgInfoList(CfgInfoList: TStrings);

 // Vrt seznam uivatel, kte maj uzameny njak zzznamy v tabulce aTable
   procedure orbfDbiOpenLockList(aTbl: TTable; var aLockList: TStringList);
// Obnov existujc index aTagName
   procedure orbfDbiRegenIndex(aTbl: TTable; aIndexName, aTagName: String;
             aIndexNum: Word);
// Obnov vechny indexy pro tabulku aTbl
   procedure orbfDbiRegenIndexes(aTbl: TTable);

implementation



procedure orbAcqAndRelPersistTableLock(aTbl: TTable);
var
  Drv: PChar;
begin
{
   Preventivn uzamen tabulky do exclusivnho mdu
   Pklad voln:
   orbAcqAndRelPersistTableLock(Table1);
}

   with aTbl do begin
      if TableType = ttParadox then
         Drv := StrNew(cPdox)
      else if TableType = ttdBASE then
         Drv := StrNew(cDbase)
      else
         Drv := Nil; {SQL databze}

      try
         Check(DbiAcqPersistTableLock(DBHandle, PChar(TableName), Drv));
         Check(DbiRelPersistTableLock(DBHandle, PChar(TableName), Drv));
      finally
         if Assigned(Drv) then StrDispose(Drv);
      end;
   end;

end;



procedure orbfDbiAcqTableLock(aTbl: TTable);
begin
{
   Pklad voln:
   fDbiAcqTableLock(Table1);
}
   Check(DbiAcqTableLock(aTbl.Handle, dbiWRITELOCK));
end;




procedure orbfDbiAddAlias(DestCfg: hDBICfg; AliasName: String;
   adbDriveType: String; AliasParams: TStringList; aSaveAlias: Boolean);
var
  sPom, sParams: String;
  i: Integer;
begin
{
   pro aktuln sezen DestCfg je nil, jinak pro jin IDAPI.CFG (IDAPI32.CFG)
   mus bt zadn

   Pklady pouit:
   fDbiAddAlias(nil, 'TestAlias', nil, 'PATH:C:\BDE32\EXAMPLES\TABLES', True);

   fDbiAddAlias(nil, 'RemoteAlias', 'INTRBASE', 'PATH:frobosrv:d:/interbas;'
      + 'SERVER NAME:frobosrv:d:/interbas/slim.gdb;' + 'USER NAME:test;'
      + 'SQLQRYMODE:SERVER;' + 'SQLPASSTHRU MODE:SHARED NOAUTOCOMMIT', True);
}
   sParams :=' ';
   for i := 0 to AliasParams.Count - 1 do
   begin
      sPom := AliasParams.Strings[i];
      ChangeCharInString(sPom, '=', ':', False);

      if i = 0 then
         sParams := sPom
      else
         sParams := sParams + cStrednik + sPom;
   end;

   orbfDbiInit;

   if ((adbDriveType = '') or (adbDriveType = 'STANDARD')) then
      Check(DbiAddAlias(DestCfg, PChar(AliasName), nil,
         PChar(sParams), aSaveAlias {Bool(-1)}))
   else
      Check(DbiAddAlias(DestCfg, PChar(AliasName), PChar(adbDriveType),
         PChar(sParams), aSaveAlias {Bool(-1)}));
{
   try
      Check(DbiCfgSave(DestCfg, nil, False))

   finally
   end;
}   
end;



function orbfDbiPackTable(aTbl: TTable): Boolean;
begin
   Result := True;
   Check(DbiPackTable(aTbl.DbHandle,aTbl.Handle,PChar(aTbl.TableName),szDBASE,True));
{
DBIERR_NONE	The table was successfully rebuilt.
DBIERR_INVALIDPARAM	The specified table name or the pointer to the table name is NULL.
DBIERR_INVALIDHNDL	The specified database handle or cursor handle is invalid or NULL.
DBIERR_NOSUCHTABLE	Table name does not exist.
DBIERR_UNKNOWNTBLTYPE	Table type is unknown.
DBIERR_NEEDEXCLACCESS	The table is not open in exclusive mode.
}

end;



procedure orbDbiOpenCfgInfoList(CfgInfoList: TStrings);
var
  TmpCursor: hDBIcur;
  Driver: CFGDesc;
  rslt: dbiResult;
  pomStr: String;
begin
//  Check(DbiOpenCfgInfoList(nil, dbiREADONLY, cfgPersistent, '\system\init', TmpCursor));
  Check(DbiOpenCfgInfoList(nil, dbiREADONLY, cfgPersistent,
   '\drivers\intrbase\db open', TmpCursor));
//   '\Drivers\paradox\init', TmpCursor));
//   '\Drivers\paradox\table create', TmpCursor));
//  Check(DbiOpenCfgInfoList(nil, dbiREADONLY, cfgPersistent, '\system\formats\date', TmpCursor));

  CfgInfoList.Clear;
  repeat
    rslt:= DbiGetNextRecord(TmpCursor, dbiNOLOCK, @Driver, nil);
    if (rslt <> DBIERR_EOF) then
    begin
      pomStr := '';
{
      CfgInfoList.Add('Node Name: ' + StrPas(Driver.szNodeName));
      CfgInfoList.Add('Value: ' + StrPas(Driver.szValue));
      CfgInfoList.Add('DataType: ' + IntToStr(Driver.iDataType));
      CfgInfoList.Add('Description: ' + StrPas(Driver.szDescription));

      if Driver.bHasSubnodes then
         CfgInfoList.Add('Has Subnodes: True')
      else
         CfgInfoList.Add('Has Subnodes: False');

      CfgInfoList.Add('------');
}
      pomStr := StrPas(Driver.szNodeName) + ';';
      pomStr := pomStr + StrPas(Driver.szValue) + ';';
      pomStr := pomStr + IntToStr(Driver.iDataType) + ';';
      pomStr := pomStr + StrPas(Driver.szDescription) + ';';

      if Driver.bHasSubnodes then
         pomStr := pomStr + 'TRUE'
      else
         pomStr := pomStr + 'FALSE';

      CfgInfoList.Add(pomStr);

(*
    szNodeName      : DBINAME;          { Node name }
    szDescription   : packed array [0..DBIMAXSCFLDLEN-1] of Char; { Node description }
    iDataType       : Word;             { Value type }
    szValue         : packed array [0..DBIMAXSCFLDLEN-1] of Char; { Value }
    bHasSubnodes    : WordBool;         { True, if not leaf node }
*)
    end;
  until rslt <> DBIERR_NONE;
  Check(DbiCloseCursor(TmpCursor));
end;




procedure orbDbiDeleteAlias(DestCfg: hDBICfg; AliasName: String);
begin
   Check(DbiDeleteAlias(DestCfg, PChar(AliasName)));
end;



procedure orbfDbiAddIndex(aTbl: TTable; adbDriveType: String; NewIndex: IDXDesc);
begin
{
   aDriveType je szDBASE, szPARADOX, pro SQL databze je nil

   Pkl struktury pro Paradox 7:
   ------------------------------
   NewIndex.szName:= 'NewIndex';
   NewIndex.iIndexId:= 0;
   NewIndex.bPrimary:= FALSE;
   NewIndex.bUnique:= TRUE;
   NewIndex.bDescending:= TRUE;
   NewIndex.bMaintained:= TRUE;
   NewIndex.bSubset:= FALSE;
   NewIndex.bExpIdx:= FALSE;
   NewIndex.iFldsInKey:= 1;
   NewIndex.aiKeyFld[0]:= 2;
   NewIndex.bCaseInsensitive:= TRUE;

   Pkl struktury pro dBase:
   --------------------------
   NewIndex.szTagName:= 'NewIndex1';
   NewIndex.bPrimary:= FALSE;
   NewIndex.bUnique:= FALSE;
   NewIndex.bDescending:= FALSE;
   NewIndex.bMaintained:= TRUE;
   NewIndex.bSubset:= FALSE;
   NewIndex.bExpIdx:= FALSE;
   NewIndex.iFldsInKey:= 1;
   NewIndex.aiKeyFld[0]:= 2;
   NewIndex.szKeyExp:= '';   // Although this is not an Expression index,

   NewIndex.szKeyCond:= '';  // szKeyExp and szKeyCond must be set blank
   NewIndex.bCaseInsensitive:= FALSE;
   NewIndex.iBlockSize:= 0;

}

   Check(DbiAddIndex(aTbl.dbhandle, aTbl.handle, PChar(aTbl.TableName),
       PChar(adbDriveType), NewIndex, nil));
end;



procedure orbDbiGetCurrSession(var hTmpSes: hDBISes);
begin
   Check(DbiGetCurrSession(hTmpSes));
end;



function orbGetConfigParameter(hCur: hDBICur; Param: string; Count: pword): string;
var
   rslt: DBIResult;
   Config: CFGDesc;
   Path, Option: string;
   Temp: array[0..255] of char;
begin
{
 Pklad voln:
   Edt_Level.Text := orbGetConfigParameter(DBASELEVEL, nil)
   parametry voln PARAM jsou jako konstanty v u_DBTyps nap:
   DBASELANGDRIVER, DBASELEVEL, PARADOXLANGDRIVER, PARADOXLEVEL
}
   Result := '';
   hCur := nil;

   if Count <> nil then Count^ := 0;

   try
      if Pos(';', Param) = 0 then
         raise EDatabaseError.Create('Invalid parameter passed to function.  There must ' +
           'be a semi-colon delimited sting passed');

      Path := Copy(Param, 0, Pos(';', Param) - 1);
      Option := Copy(Param, Pos(';', Param) + 1, Length(Param) - Pos(';', Param));
      Check(DbiOpenCfgInfoList(nil, dbiREADONLY, cfgPERSISTENT, StrPCopy(Temp, Path), hCur));
      Check(DbiSetToBegin(hCur));

      repeat
         rslt := DbiGetNextRecord(hCur, dbiNOLOCK, @Config, nil);
         if rslt = DBIERR_NONE then
         begin
            if StrPas(Config.szNodeName) = Option then Result := Config.szValue;
            if Count <> nil then Inc(Count^);
         end
         else
            if rslt <> DBIERR_EOF then Check(rslt);
      until rslt <> DBIERR_NONE;
   finally
      if hCur <> nil then Check(DbiCloseCursor(hCur));
   end;
end;



procedure orbSetConfigParameter(hCur: hDBICur; Param: string; Value: string);
var
  rslt: DBIResult;
  Config: CFGDesc;
  Path, Option: string;
  CloseCfg, Found: boolean;
  Temp: array[0..255] of char;
begin
{
   hCur := nil;
}

  if hCur = nil then
     CloseCfg := True
  else
     CloseCfg := False;

   Found := False;
   try
      if Pos(';', Param) = 0 then
         raise EDatabaseError.Create('Invalid parameter passed to function.  There must ' +
           'be a semi-colon delimited sting passed');

      Path := Copy(Param, 0, Pos(';', Param) - 1);
      Option := Copy(Param, Pos(';', Param) + 1, Length(Param) - Pos(';', Param));
      if hCur = nil then
         Check(DbiOpenCfgInfoList(nil, dbiREADWRITE, cfgPERSISTENT, StrPCopy(Temp, Path), hCur));

      repeat
         rslt := DbiGetNextRecord(hCur, dbiNOLOCK, @Config, nil);
         if rslt = DBIERR_NONE then
         begin
            if StrPas(Config.szNodeName) = Option then
            begin
               StrPCopy(Config.szValue, Value);
               Check(DbiModifyRecord(hCur, @Config, FALSE));
               Found := True;
               break;
            end;
         end
         else
            if rslt <> DBIERR_EOF then Check(rslt);
      until rslt <> DBIERR_NONE;

      if Found = False then
         raise EDatabaseError.Create(Param + ' entry was not found in configuration file');

   finally
      if CloseCfg then Check(DbiCloseCursor(hCur));
   end;
end;



procedure orbSetConfigParameter2(hCfg: hDBICfg; Param: string; Value: string);
var
  Config: SYSConfig;
  Path, Option: string;
  ParamCount, I: word;
  pFields, pFld: pFLDDesc;
  pRecBuf, pRec: pBYTE;
  CloseCfg, Found, SelfInitialized: boolean;
  rslt: DBIResult;
begin
{
    Pklad voln:
    orbSetConfigParameter2(DBASELEVEL, '3')
    parametry voln PARAM jsou jako konstanty v u_DBTyps nap:
    DBASELANGDRIVER, DBASELEVEL, PARADOXLANGDRIVER, PARADOXLEVEL
    zmny se ulo do configuranho souboru
}

   {$Ifdef WIN32}
   if hCfg = nil then
      CloseCfg := True
   else
      CloseCfg := False;

   pFld := nil;
   pRec := nil;
   Found := False;
   SelfInitialized := False;

   try
      if Pos(';', Param) = 0 then
         raise EDatabaseError.Create('Invalid parameter passed to function.  There must ' +
           'be a semi-colon delimited sting passed');

      Path := Copy(Param, 0, Pos(';', Param) - 1);
      Option := Copy(Param, Pos(';', Param) + 1, Length(Param) - Pos(';', Param));
      rslt := DbiGetSysConfig(Config);

      if rslt <> DBIERR_NONE then
      begin
         if rslt = DBIERR_NOTINITIALIZED  then // Engine not initialized error...
         begin
            SelfInitialized := True;
            DbiInit(nil);
            Check(DbiGetSysConfig(Config));
         end
         else
            Check(rslt);
      end;

      (* DbiOpenConfigFile is defined as such:
          function DbiOpenConfigFile (            { Open/Create configuration }
                pszDirPath    : PChar;            { Directory }
                bCreate       : Bool;             { TRUE to create/overwrite }
          var   hCfg          : hDBICfg           { Handle to config }
                             ): DBIResult stdcall; *)

      if hCfg = nil then Check(DbiOpenConfigFile(Config.szIniFile, FALSE, hCfg));



      (* DbiCfgGetRecord is defined as such:
          function DbiCfgGetRecord (              { Get a record }
                hCfg          : hDBICfg;          { Config Handle/NULL }
                pszCfgPath    : PChar;            { Path }
          var   iFields       : Word;             { Returned nbr of fields }
                pfldDesc      : pFLDDesc;         { Field descriptors }
                pRec          : Pointer           { Field values }
                             ): DBIResult stdcall; *)
      { Call it without the field and record buffer to get the count... }

      Check(DbiCfgGetRecord(hCfg, PChar(Path), ParamCount, nil, nil));
      pFields := AllocMem(ParamCount * sizeof(FLDDesc));
      pFld := pFields;
      pRecBuf := AllocMem(10000);
      pRec := pRecBuf;

      { Get the node values... }
      Check(DbiCfgGetRecord(hCfg, PChar(Path), ParamCount, pFields, pRecBuf));

      for I := 0 to ParamCount - 1 do
      begin
         if pFields^.szName = Option then
         begin
            StrPCopy(PChar(pRecBuf), Value);

            (* DbiCfgModifyRecord is defines as such:
                 function DbiCfgModifyRecord (           { Modify a record }
                       hCfg          : hDBICfg;          { Config Handle/NULL }
                       pszCfgPath    : PChar;            { Path }
                       iFields       : Word;             { Nbr of fields }
                       pfldDesc      : pFLDDesc;         { Field descriptors }
                       pRec          : Pointer           { Data values }
                    ): DBIResult stdcall; *)

            Check(DbiCfgModifyRecord(hCfg,  PChar(Path), ParamCount, pFld, pRec));
            Found := True;
         end;

         Inc(pFields);
         Inc(pRecBuf, 128);
      end;

      if Found = False then
         raise EDatabaseError.Create(Param + ' entry was not found in configuration file');

   finally
      if pFld <> nil then FreeMem(pFld);

      if pRec <> nil then FreeMem(pRec);

      if ((hCfg <> nil) and closecfg) then
         Check(DbiCloseConfigFile(hCfg, TRUE, TRUE, FALSE));

      (* DbiCloseConfigFile is defined as such:
             function DbiCloseConfigFile (           { Close the config file }
             var   hCfg          : hDBICfg;          { Handle }
                   bSave         : Bool;             { To save the changes }
                   bDefault      : Bool;             { To make this file the default }
                   bSaveAs16     : Bool              { To save as a 16-bit config file }
                ): DBIResult stdcall; *)
        { Close and save the config file... }

      if SelfInitialized = True then DbiExit;
   end;

   {$Else}
      raise EDatabaseError.Create('Non supported function in 16 bit');
   {$EndIf}

end;



procedure orbfDbiAddPassword(hSes: hDBISes; aPswd: String);
begin
{
  Pklady pouit:
  Nastav Session3 jako aktuln
  DbiAddPassword(Session3.Handle, 'HESLO');

  Pro aktuln Session
  DbiAddPassword(nil, 'HESLO');
}
  if hSes <> nil then Check(DbiSetCurrSession(hSes));

  Check(DbiAddPassword(PChar(aPswd)));
end;


{
procedure orbDbiOpenLdList (aStrList: TStringList);
begin
   Check(DbiOpenLdList(var hCur: hDBICur));
end;
}


procedure orbfDbiRegenIndex(aTbl: TTable; aIndexName, aTagName: String;
   aIndexNum: Word);
var
   oldExclMode: Boolean;
begin
{
   Nefunguje pro obnovu index SQL server !!!!
   Funguje pouze pro Paradox a dBase indexy.
   Pklad voln:
   fDbiRegenIndex(Table1, 'ByCompany', '', 1);
}
  oldExclMode := aTbl.Exclusive;

   try
      Check(DbiRegenIndex(aTbl.DBHandle, nil, PChar(aTbl.TableName), nil,
          PChar(aIndexName), PChar(aTagName), aIndexNum));
   finally
      if aTbl.Exclusive then aTbl.Exclusive := oldExclMode;
   end;
end;



procedure orbfDbiRegenIndexes(aTbl: TTable);
begin
{
   Nefunguje pro obnovu index SQL server !!!!
   Funguje pouze pro Paradox a dBase indexy.
   Pklad voln:
   fDbiRegenIndexes(BIOLIFE_TABLE);
}
   Check(DbiRegenIndexes(aTbl.Handle));
end;



procedure orbfDbiOpenLockList(aTbl: TTable; var aLockList: TStringList);
var
   TmpCursor: hdbicur;
   Lock: LOCKDesc;
   rslt: dbiResult;
begin
   Check(DbiOpenLockList(aTbl.handle, True, True, TmpCursor));
   Check(DbiSetToBegin(TmpCursor));
   aLockList.Clear;

   repeat
      rslt:= DbiGetNextRecord(TmpCursor, dbiNOLOCK, @Lock, nil);

      if (rslt <> DBIERR_EOF) then
      begin
         aLockList.Add(cLockType + inttostr(Lock.iType));
         aLockList.Add(cUserName + StrPas(Lock.szUserName));

         aLockList.Add(cNetSession + inttostr(Lock.iNetSession));
         aLockList.Add(cSession + inttostr(Lock.iSession));
         aLockList.Add(cRecNum + inttostr(Lock.iRecNum));
      end;
   until rslt <> DBIERR_NONE;

   Check(DbiCloseCursor(TmpCursor));
end;



function orbfDbiGetMyNetUserName: String;
begin
   {Musm inicializovat BDE}
   Check(dbiInit(Nil));
   SetLength(Result, dbiMaxUserNameLen + 1);
   Check(DbiGetNetUserName(PChar(Result)));
   SetLength(Result, StrLen(PChar(Result)));
end;



function orbfDbiInit: Boolean;
var
  Rslt: DBIResult;
begin
   {Zkusm inicializovat BDE}
   Result := False;
   Rslt := dbiInit(Nil);

   if Rslt = DBIERR_MULTIPLEINIT then     // Illegal attempt to initialize BDE more than once.
   else if Rslt = DBIERR_OSEACCES then    // Attempting to run a BDE application from a Windows NT directory without write access; create a Windows NT TEMP directory to avoid this
   else if Rslt = DBIERR_NONE then        // The BDE environment was initialized successfully.
      Result := True;
end;



function  orbDbiSaveChanges(DataSet: TDataSet): Boolean;
var
   MyError: LongInt;
begin
// nefunguje pro  delphi 3, Tdataset nema handle
//   MyError := DbiSaveChanges(Dataset.handle);

    if MyError = DBIERR_NONE then
//     All changes have been saved successfully.
       result := True
    else if MyError = DBIERR_INVALIDHNDL then
//     The specified cursor is invalid or NULL.
       result := False
    else if MyError = DBIERR_NODISKSPACE then
//     The changes could not be saved because there is no disk space available.
       result := False
    else if MyError = DBIERR_NOTSUPPORTED then
//	This function is not supported for SQL tables.
       result := False
    else
       result := False;

  end;




function TorbIDXDesc.GetszName: string;
begin
   result := StrPas(fIDXDesc.szName);
end;



procedure TorbIDXDesc.SetszName(aValue: string);
begin
   StrPCopy(fIDXDesc.szName, aValue);
end;



procedure TorbIDXDesc.SetiIndexId(aValue: Word);
begin
   fIDXDesc.iIndexId := aValue;
end;



function  TorbIDXDesc.GetszTagName: string;
begin
   result := StrPas(fIDXDesc.szTagName);
end;



procedure TorbIDXDesc.SetszTagName(aValue: string);
begin
   StrPCopy(fIDXDesc.szTagName, aValue);
end;



function  TorbIDXDesc.GetszFormat: string;
begin
   result := StrPas(fIDXDesc.szFormat);
end;



procedure TorbIDXDesc.SetszFormat(aValue: string);
begin
   StrPCopy(fIDXDesc.szFormat, aValue);
end;



procedure TorbIDXDesc.SetbPrimary(aValue: WordBool);
begin
   fIDXDesc.bPrimary := aValue;
end;



procedure TorbIDXDesc.SetbDescending(aValue: WordBool);
begin
   fIDXDesc.bDescending := aValue;
end;



procedure TorbIDXDesc.SetbExpIdx(aValue: WordBool);
begin
   fIDXDesc.bExpIdx := aValue;
end;



procedure TorbIDXDesc.SetbMaintained(aValue: WordBool);
begin
   fIDXDesc.bMaintained := aValue;
end;



procedure TorbIDXDesc.SetbSubset(aValue: WordBool);
begin
   fIDXDesc.bSubset := aValue;
end;



procedure TorbIDXDesc.SetbUnique(aValue: WordBool);
begin
   fIDXDesc.bUnique := aValue;
end;



procedure TorbIDXDesc.SetiFldsInKey(aValue: Word);
begin
   fIDXDesc.iFldsInKey := aValue;
end;



procedure TorbIDXDesc.SetiKeyLen(aValue: Word);
begin
   fIDXDesc.iKeyLen := aValue;
end;



procedure TorbIDXDesc.SetiKeyExpType(aValue: Word);
begin
   fIDXDesc.iKeyExpType := aValue;
end;



function  TorbIDXDesc.GetszKeyExp: string;
begin
   result := StrPas(fIDXDesc.szKeyExp);
end;



procedure TorbIDXDesc.SetszKeyExp(aValue: string);
begin
   StrPCopy(fIDXDesc.szKeyExp, aValue);
end;



procedure TorbIDXDesc.SetbCaseInsensitive(aValue: WordBool);
begin
   fIDXDesc.bCaseInsensitive := aValue;
end;



function  TorbIDXDesc.GetszKeyCond: string;
begin
   result := StrPas(fIDXDesc.szKeyCond);
end;



procedure TorbIDXDesc.SetszKeyCond(aValue: string);
begin
   StrPCopy(fIDXDesc.szKeyCond, aValue);
end;


{
procedure TorbIDXDesc.SetaiKeyFld(aValue: TDbiKey);
begin
  fIDXDesc.aiKeyFld := aValue;
end;
 }

end.
