unit F_dgndmp;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, StdCtrls, Buttons,
  Elements,
  t_DGNImp;

type
  TForm1 = class(TForm)
    Memo: TMemo;
    Panel1: TPanel;
    b_Open: TBitBtn;
    procedure b_OpenClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

TDGNDumper = class(TDGNImport)
private
   Fmemo: TMemo;
public
   procedure DoIt; override;
   property Memo: TMemo read FMemo write FMemo;
end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses
   f_DGNImp,
   MSElems,
   u_TCB;


{ TDGNDumper }

procedure TDGNDumper.DoIt;
var
   i: longInt;
   KontrolW: word;
   FirstTime: boolean;
   S: string;
   CT: Tcolor_table_type5;
begin
   if Memo <> nil then Memo.Lines.Clear;
   {
   Felikost := FileSize(F);
   }
   Pozice := 0;
   {
   JeDBW := False;
   }
   Is3D  := False;
   IsTCB := False;
   {
   JeKYSDGN := False;
   }
   {
   WCS:= TWCSWorld(World).GetIDWCS(cs_JTSK);
   }
   if FileName = '' then exit;
   OpenStream;
   {
   StartGauge;
   }
   FirstTime := true;
   while (True) do
   begin
      if FirstTime then
      begin
         FirstTime := false;
         FStream.Read(EHDR, SizeOf(EHDR));
      end
      else
      begin
         FStream.Seek(Pozice + 4 + EHDR.Words shl 1, 0);
         Pozice := FStream.Position;
         FStream.Read(EHDR, SizeOf(Elm_hdr));
         if EHDR.Header = EOD then
         begin

            if Memo <> nil then Memo.Lines.Add('EOD '+IntToStr(FStream.Position));
            for i := Levels.Count - 1  downto 0 do
            begin
               if Level[i].NoElements then Levels.ElementToFree := Level[i];
            end;
            {
            EndGauge;
            }
            exit;
         end;
      end;
      LVL  := aLevel;
      S := IntToStr(Pozice - 2);
      S := S + ' T:'+ IntToStr(Typ shr 8) + ' L:'+ IntToStr(LVL)+' SIZE:'+ IntToStr(EHDR.Words)+' NAME:';
      {
      JeDB := False;
      }
      JeLin:= False;

       F_GaugeForm.Gauge1.Progress := Pozice;
      Application.ProcessMessages;
      try
         case Typ of
            DGNFIL_HEADER_ELM:
            begin
               S := S + 'DGNFIL_HEADER_ELM ';
               if not IsTCB then
               begin
                  IsTCB := True;
                  FStream.Read(TCB, SizeOf(TTCB));
                  if (Design3D in TCB.fbfdcn) and not Ignor3D then Is3D := True;

                  Prep := (SwapLong(TCB.uorpersub)*SwapLong(TCB.subpermast));
                  if Is3D then S := S + '3D '
                          else S := S + '2D ';

                  aOrigin := DPoint3DToCoord(TCB.GlobOrg);
                  AddElement(aOrigin);
                  S := S + ' u-s:'+ IntToStr(SwapLong(TCB.uorpersub));
                  S := S + ' s-m:'+ IntToStr(SwapLong(TCB.subpermast));
                  S := S + ' x:'+FloatToStr(aOrigin.x)+' y:'+FloatToStr(aOrigin.y);
               end;
            end;
            CELL_LIB_ELM:       S := S + 'CELL_LIB_ELM';
            SHAREDCELL_DEF_ELM: S := S + 'SHAREDCELL_DEF_ELM';
            SHARED_CELL_ELM:    S := S + 'SHARED_CELL_ELM';
            CELL_HEADER_ELM:    S := S + 'CELL_HEADER_ELM';

            TEXT_NODE_ELM:      S := S + 'TEXT_NODE_ELM';
            CMPLX_STRING_ELM:   S := S + 'CMPLX_STRING_ELM';
            CMPLX_SHAPE_ELM:    S := S + 'CMPLX_SHAPE_ELM';

            LINE_ELM:           S := S + 'LINE_ELM';
            ELLIPSE_ELM:        S := S + 'ELLIPSE_ELM';
            ARC_ELM:            S := S + 'ARC_ELM';
            LINE_STRING_ELM:    S := S + 'LINE_STRING_ELM';
            CURVE_ELM:          S := S + 'CURVE_ELM';
            SHAPE_ELM:          S := S + 'SHAPE_ELM';
            TEXT_ELM:
            begin
               S := S + 'TEXT_ELM ';
               if not Deleted then
               begin
                  if Is3D then
                  begin
                     FStream.Read(Text3D,SizeOf(Ttext_3d));
                     Sg[1] := Text3D.Pis;
                     if Text3D.Numchars < 1 then Sg := ''
                     else begin
                        FStream.Read(Sg[2],Text3D.numchars - 1);
                        Sg[0] := Chr(Text3D.numchars);
                     end;
                     S := S + ' N:'+IntToStr(22 + (Text3D.numchars+1) div 2  );
                     {
                     S := S + ' G:'+IntToStr(Text3D.DHDR.grphgrp);
                     }

                     S := S + ' A:'+IntToStr(Text3D.DHDR.Attindx);
                     S := S + ' J:'+IntToStr(byte(Text3D.Just));
                     {
                     S := S + ' E:'+IntToStr(SwapLong(Text3D.edflds));
                     }
                     S := S + ' H:'+IntToStr(SwapLong(Text3D.hghtmult));
                     S := S + ' L:'+IntToStr(SwapLong(Text3D.lngthmult));
                  end
                  else
                  begin
                     FStream.Read(Text2D,SizeOf(Ttext_2d));
                     Sg[1] := Text2D.Pis;
                     if Text2D.Numchars < 1 then Sg := ''
                     else begin
                        FStream.Read(Sg[2],Text2D.numchars - 1);
                        Sg[0] := Chr(Text2D.numchars);
                     end;
                     S := S + ' N:'+IntToStr(Text2D.numchars);
                     {
                     S := S + ' G:'+IntToStr(Text2D.DHDR.grphgrp);
                     }
                     S := S + ' A:'+IntToStr(Text2D.DHDR.Attindx);
                     {
                     S := S + ' E:'+IntToStr(SwapLong(Text2D.edflds));
                     }
                     S := S + ' H:'+IntToStr(SwapLong(Text2D.hghtmult));
                     S := S + ' L:'+IntToStr(SwapLong(Text2D.lngthmult));
                  end;
                  S := S +' '+ IntToStr(Text3D.Font)+' '+Sg;
               end;
            end;

            MICROSTATION_ELM:   S := S + 'MICROSTATION_ELM';

            GROUP_DATA_ELM:
            begin
               S := S + 'GROUP_DATA_ELM';
               if LVL = 1 then
               begin
                  FStream.Read(CT,SizeOf(CT));
                  for i := 0 to 5 do
                  begin
                     S := S + ' '+IntToStr(i)+':'+IntToStr(CT.Color_Info[i].R);
                     S := S + ','+IntToStr(CT.Color_Info[i].G);
                     S := S + ','+IntToStr(CT.Color_Info[i].B);
                  end;
               end;
            end;
            DIG_SETDATA_ELM:    S := S + 'DIG_SETDATA_ELM';
            LEV_SYM_ELM:        S := S + 'LEV_SYM_ELM';
            CONIC_ELM:          S := S + 'CONIC_ELM';
            SURFACE_ELM:        S := S + 'SURFACE_ELM';
            SOLID_ELM:          S := S + 'SOLID_ELM';
            BSPLINE_POLE_ELM:   S := S + 'BSPLINE_POLE_ELM';
            POINT_STRING_ELM:   S := S + 'POINT_STRING_ELM';
            CONE_ELM:           S := S + 'CONE_ELM';
            BSPLINE_SURFACE_ELM:S := S + 'BSPLINE_SURFACE_ELM';
            BSURF_BOUNDARY_ELM: S := S + 'BSURF_BOUNDARY_ELM';
            BSPLINE_KNOT_ELM:   S := S + 'BSPLINE_KNOT_ELM';
            BSPLINE_CURVE_ELM:  S := S + 'BSPLINE_CURVE_ELM';
            BSPLINE_WEIGHT_ELM: S := S + 'BSPLINE_WEIGHT_ELM';
            DIMENSION_ELM:      S := S + 'DIMENSION_ELM';
             MULTILINE_ELM:     S := S + 'MULTILINE_ELM';
            TEXT_ARRAY_ELM:     S := S + 'TEXT_ARRAY_ELM';
            TEXT_STACK_ELM:     S := S + 'TEXT_STACK_ELM';
            RASTER_HDR:         S := S + 'RASTER_HDR';
            RASTER_COMP:        S := S + 'RASTER_COMP';
         end;{case}
         if  Deleted then S := S + ' DEL';
      except
      end;
      {
      Levels.UpdateRect(Level[LVL]);
      }
      try
         if Memo <> nil then Memo.Lines.Add(S);
      except
         ShowMessage('Zbytek se tam nevejde !');
         exit;
      end;
   end;
end;

procedure TForm1.b_OpenClick(Sender: TObject);
var
   D: TDGNImportDialog;
   DD: TDGNDumper;
begin
   D := TDGNImportDialog.Create;
   D.DoIt;
   DD := TDGNDumper.Create(D.Result, nil);
   DD.Memo := Memo;
   Caption := D.Result;
   DD.DoIt;
   D.Free;
   DD.Free;
end;

end.
