unit T_dgnimp;

interface

uses
   Classes,
   e_TopolElements,
   e_TMPText,
   e_WCS,
   Elements,
   //f_Gauge,
   MSElems,
   g_Elems,
   Tools,
   Typky,
   u_TCB;

type

{ TBufferStream class }

TBufferStream = class(TFileStream)
private
    FLastPos: longInt;
    FBuffer:  Pointer;
    FBufSize: Cardinal;
    FBufPos:  Cardinal;
    FBufEnd:  Cardinal;
    function  GetTruePosition: longInt;
public
    constructor Create(const aFileName: string; Mode: Word; BufSize: Cardinal);
    destructor Destroy; override;
    function Read(var Buffer; Count: Longint): Longint; override;
    function Write(const Buffer; Count: Longint): Longint; override;
    function SeekTo(Offset: Longint): Longint; virtual;
    property TruePosition: longInt read GetTruePosition;
end;


TDGNImport = class(TTool)
  private
    FTextStyles: TEntity;
    FAsTMPText: boolean;
    FTMPTextColor: integer;
    procedure SetTextStyles(const Value: TEntity);
    procedure SetAsTMPText(const Value: boolean);
    procedure SetTMPTextColor(const Value: integer);
{
private
}
protected
  { serizn datov pole }
   FFileName: string;

   { Vrstvy }
   LVL   : Byte;

   Line : TTopolLineElement;
   Bod   : TTopolPointElement;
   aOrigin,
   Coord  : TCoordinate;
   Tbx   : TTopolTextElement;
   TMPText: TtmpText;
   Pozice: LongInt;

   Cell2D: TCell_2d;
   Cell3D: TCell_3d;
   CellName: String;
   Line2D: TLine_2D;
   Line3D: TLine_3D;
   LineString2D: TLine_string_2d;
   LineString3D: TLine_string_3d;
   Text2D      : Ttext_2d;
   Text3D      : Ttext_3d;
   TextNode    : Ttext_node_2d;
   Ellipse2D   : TEllipse_2D;
   Ellipse3D   : TEllipse_3D;
   {
   Elipsa      : TParametryElipsy;
   }
   Arc2D       : TArc_2D;
   Arc3D       : TArc_3D;
   {
   Oblouk      : TParametryOblouku;
   }


   P2D   : Point2D;
   P3D   : Point3D;

   EHDR  : Elm_Hdr;
   Sg    : String;
   TCB   : TTCB;
   Is3D  : Boolean;
   Ignor3D:Boolean;
   PripojitDatabaze : Boolean;
   DBProBody: boolean;
   IsTCB : Boolean;
   TretiQ: Boolean;
   JeLin : Boolean;

   Prep  : LongInt;

   PomD: Double;

   function GetLevels: TRectEntity;
   function GetLevel(aLvl: longInt): TRectEntity;

   function GetColor(Symb: word): longInt;
   function GetSymbol(Symb: word): longInt;

   function JsouAtributy(dhdr: Disp_Hdr): Boolean;
   function aClass(dhdr: Disp_Hdr): Word;
   function aLevel: Word;
   function Complex: boolean;
   function Typ: Word;
   function Deleted: boolean;

   procedure RadixToAscii(var Rad: TCellName; var Asc: string; Delka: byte);
   procedure VaxToIeee(var D: double);
   function  SwapLong( L: longInt ): LongInt;
   function  LL(L: LongInt): double;
   function  LL1(L: LongInt): double;
   procedure KontrolaSour(var S: TCoordinate);
   function  Point2DToCoord(B: Point2D): TCoordinate;
   function  Point3DToCoord(B: Point3D): TCoordinate;
   function  DPoint2DToCoord(var B: DPoint2D): TCoordinate;
   function  DPoint3DToCoord(var B: DPoint3D): TCoordinate;
   procedure ShiftCoord(var ss: TCoordinate);{ Posunuti vzhledem ke globalnimu pocatku }
   function  GetFont(Font: byte;var Sklon: double): byte;
   function  VratKoefVysky (hmult: longint; font: byte): double;
   function  VratKoefSirky (lngthmult: longInt; hmult: real; Font: byte): double;
   procedure OtocUhel(var Uh: double);
   procedure SetRect(aR: TRectEntity);  // nastavi rectangle podle EHDR
   { Natan element Microstation }

   procedure Read_DGNFIL_HEADER_ELM;
   procedure Read_CELL_LIB_ELM;
   procedure Read_SHAREDCELL_DEF_ELM;
   procedure Read_SHARED_CELL_ELM;
   procedure Read_CELL_HEADER_ELM;
   procedure Read_TEXT_NODE_ELM;
   procedure Read_CMPLX_STRING_ELM;
   procedure Read_CMPLX_SHAPE_ELM;
   procedure Read_LINE_ELM;
   procedure Read_ELLIPSE_ELM;
   procedure Read_ARC_ELM;
   procedure Read_LINE_STRING_ELM;
   procedure Read_CURVE_ELM;
   procedure Read_SHAPE_ELM;
   procedure Read_TEXT_ELM;
   procedure Read_MICROSTATION_ELM;
{
protected
}
public
   FWCS: TWCS;
   FStream: TStream;
   //F_gaugeForm: TF_gaugeForm;
   function  GetWCS: TWCS; virtual;
   procedure SetWCS(aWCS: TWCS);
   procedure OpenStream; virtual;
   function  CreateICSRect(Ymin, Xmin, Ymax, Xmax: double): TRectangle;
{
public
}
   constructor CreateAll(aFileName: string; aWCS: TWCS);  virtual;
   destructor  Destroy; override;
   procedure   DoIt; override;
   procedure   SendProtocolMessage(aMessage: string);
   procedure   StartGauge;
   procedure   EndGauge;
   procedure   FillTextStyle(aCode: integer);
   function    GetFileName: string; virtual; abstract;

   property    WCS: TWCS read GetWCS write SetWCS;
   property    Protocol: string write SendProtocolMessage;
   property    Level[aLevel: longInt]: TRectEntity read GetLevel;
published
   property FileName: string read FFileName write FFileName;
   property Levels: TRectEntity read GetLevels;
   property TextStyles: TEntity read FTextStyles write SetTextStyles;
   property AsTMPText: boolean read FAsTMPText write SetAsTMPText;
   property TMPTextColor: integer read FTMPTextColor write SetTMPTextColor;
end;

const

  EOD = $FFFF;                { Konec Souboru }



implementation


uses
  Controls,
  Dialogs,
  Forms,
  SysUtils,
  e_Class,
  e_Geometry,
  e_Text,
  MathLib,
  m_Orbis,
  {!t_Main,}
  {!f_DGNDMP,}
  //t_MainTl,
  Worlds;


type
   PByteArray = ^TByteArray;
   TByteAray = Array[0..64000]of Byte;

{ TBufferStream }

constructor TBufferStream.Create(const aFileName: string; Mode: Word; BufSize: Cardinal);
begin
   inherited Create(aFileName, Mode);
   if BufSize > 500 then
   begin
      FBufSize := BufSize;
      GetMem(FBuffer, FBufSize);
      FBufPos := 0;
      FBufend := 0;
      FLastPos := 0;
   end;
end;

destructor TBufferStream.Destroy;
begin
   if FBuffer <> nil then FreeMem(FBuffer, FBufSize);
end;

function TBufferStream.Read(var Buffer; Count: Longint): Longint;
begin
   if (Count > (FBufend - FBufpos)) then
   begin
      Seek(FLastPos + FBufPos, 0);
      FLastPos := Position;
      ReadBuffer(FBuffer^, FBufSize);
      FBufEnd := FBufSize - 1;
      FBufPos := 0;
   end;
   Move(PByteArray(FBuffer)^[FBufpos], Buffer, Count);
   FBufPos := FBufPos + Count;
   result := Count;
end;

function TBufferStream.Write(const Buffer; Count: Longint): Longint;
begin
end;


function TBufferStream.SeekTo(Offset: Longint): Longint;
begin
   if (Offset > FLastPos) and (Offset < (FLastPos + FBufEnd)) then
   begin
      FBufpos := Offset - FLastpos;
   end
   else
   begin
      Seek(Offset, 0);
      FLastPos := Position;
      FBufPos := 0;
      FBufEnd := 0;
   end;
end;

function  TBufferStream.GetTruePosition: longInt;
begin
   result := FLastPos + FBufPos;
end;



{ TDGNImport }


function TDGNImport.GetLevels: TRectEntity;
var
   i: longInt;
   R, RR: TRectEntity;
begin
   if Output = nil then
   begin
      R := TRectEntity.Create;
      Output := R;
      Output.Name := FileName;
      for i := 0 to 63 do
      begin
         RR := TRectEntity.Create;
         RR.Name := 'Level '+ IntToStr(i);
         R.AddElement(RR);
      end;
   end;
   result := TRectEntity(Output);
end;

function TDGNImport.GetLevel(aLvl: longInt): TRectEntity;
begin
   result := TRectEntity(Levels.Elements[aLvl]);
end;

function TDGNImport.GetColor(Symb: word): longInt;
begin
   result := Barvy[(Symb and mskSymbColor)shr 8];
end;

function TDGNImport.GetSymbol(Symb: word): longInt;
begin
   if ((Symb and mskSymbWeight) shr 3) < 3 then
   begin
      case Symb and mskSymbStyle of
         0: result := 0;
         1: result := 1;
         2: result := 2;
         3: result := 3;
         4: result := 24;
         5: result := 23;
         6: result := 26;
         7: result := 25;
      else  result := 9;
      end;
   end
   else
   begin
      case Symb and mskSymbStyle of
         0: result := 4;
         1: result := 5;
         2: result := 6;
         3: result := 7;
         4: result := 34;
         5: result := 33;
         6: result := 36;
         7: result := 35;
      else  result := 4;
      end;
   end;
end;

function TDGNImport.JsouAtributy(dhdr: Disp_Hdr): Boolean;
begin
   JsouAtributy := A in dhdr.Props.bits;
end;

function TDGNImport.aClass(dhdr: Disp_Hdr): Word;
begin
   result := (dhdr.Props.aclass and mskPropsClass) + 1;
end;

function TDGNImport.aLevel: Word;
begin
   result := EHDR.Header and mskLevel;
end;

function TDGNImport.Complex: boolean;
begin
   result := (EHDR.Header and mskComplex) <> 0;
end;

function TDGNImport.Typ: Word;
begin
   result := EHDR.Header and mskType ;
end;

function TDGNImport.Deleted: boolean;
begin
   result := (EHDR.Header and mskDeleted) <> 0;
end;

   { from: TTopolReader }


constructor TDGNImport.CreateAll(aFileName: string; aWCS: TWCS);
begin
   inherited Create;
   FWCS := aWCS;
   FileName:= aFileName;
   //OpenStream;
   //StartGauge;
end;




function TDGNImport.CreateICSRect(Ymin, Xmin, Ymax, Xmax: double): TRectangle;
begin
  result:= TRectangle.Create;
  if result = nil then exit;

  result.MaxX:= Ymin;
  result.MaxY:= Xmin;
  result.MinX:= Ymax;
  result.MinY:= Xmax;

  FWCS.RecalculateToICS(result.Min);
  FWCS.RecalculateToICS(result.Max);
end;


procedure TDGNImport.StartGauge;
begin
   Screen.Cursor:= crHourGlass;
   StartProgress('Import souboru ' + FileName,0,FStream.Size);
   (*
   Application.CreateForm(TF_GaugeForm, F_GaugeForm);
   F_GaugeForm.Caption:= 'Import souboru ' + FileName;
   F_GaugeForm.Gauge1.MaxValue:= FStream.Size; {!!!!!!!!!!!!!!!!!!!!!!!!}
   F_GaugeForm.Show
   *)
end;


procedure   TDGNImport.SendProtocolMessage(aMessage: string);
begin
   PostTextMsg(tm_AddToProtocol, aMessage, nil);
   Application.ProcessMessages
end;



procedure TDGNImport.EndGauge;
begin
   Screen.Cursor:= crDefault;
   EndProgress;
   (*
   if F_GaugeForm <> nil then
   begin
      F_GaugeForm.Free;
      F_GaugeForm:= nil
   end;
   *)
end;


procedure TDGNImport.OpenStream;
begin
   try
      FStream := TMemoryStream.Create;
      TMemoryStream(FStream).LoadFromFile(FileName);
   except
      FStream.Free;
      FStream := TFileStream.Create(FileName, fmOpenRead{Write !!!!!!!});
   end;
end;



function  TDGNImport.GetWCS: TWCS;
begin
   if not assigned(FWCS) then
   begin
     {!!!!!!!!!!!!!!!!!!! Chyba !!!!!!!!!!!!!!!!!!}
   end
   else
   begin
      result := FWCS;
   end;
end;

procedure TDGNImport.SetWCS(aWCS: TWCS);
begin
   FWCS := aWCS;
end;


destructor  TDGNImport.Destroy;
begin
   EndGauge;
   if FStream <> nil then FStream.Free;
   {
   if F_GaugeForm <> nil then
      F_GaugeForm.Free;
   }
   inherited Destroy;
end;




{ pevzato z DGNBLK ... hrza !!!!!!}

procedure TDGNImport.RadixToAscii(var Rad: TCellName; var Asc: string; Delka: byte);
var
  Status: Integer;
  c, i, IRad: byte;
  n: word;
begin;
   c      := 0;
   n      := 0;
   IRad   := 0;
   status := 0;
   Asc    := '';
   for  i := 0 to Delka - 1 do
   begin

     case (i mod 3) of
       0:
       begin
         n := Rad[IRad];
         Inc(IRad);
         c := n div 1600;
         n := n mod 1600;
       end;
       1:
       begin
         c := n div 40;
         n := n mod 40;
       end;
       2:
         c := n;
     end;
     if (c = 0) then
        c := 32
     else
     if (c >= 1) and (c <= 26) then
        c := c + 64
     else
     if (c = 27 ) then
        c := Ord('$')
     else
     if (c = 28 ) then
        c := Ord('.')
     else
     if (c >= 30) and (c <= 39 ) then
        c := c + 18
     else
     begin
       c := 32;
       status := -1;
     end;
     Asc := Asc + Chr(c);
   end;
   {
   return status;
   }
 end;

(*
procedure VTI(var D: double); near;
begin
  asm
      push  di
      push  si
      push  ds
      lds   si,[bp+04]
      mov   ax,word ptr [si]
      mov   bx,word ptr [si+02]
      mov   cx,word ptr [si+04]
      mov   dx,word ptr [si+06]
      mov   di,ax
      and   di,8000H {odmaskovn znamnka .... di = sign}
      and   ax,7fffH {odstrann sign bitu z prvnho wordu }
      shr   ax,1
      rcr   bx,1
      rcr   cx,1
      rcr   dx,1
      shr   ax,1
      rcr   bx,1
      rcr   cx,1
      rcr   dx,1
      shr   ax,1
      rcr   bx,1
      rcr   cx,1
      rcr   dx,1
      or    ax,ax
      je    @@Nula
      add   ax,37e0H
  @@Nula:
      or    ax,di
      mov   word ptr [si],dx
      mov   word ptr [si+02],cx
      mov   word ptr [si+04],bx
      mov   word ptr [si+06],ax
      pop   ds
      pop   si
      pop   di
  end;
end;

*)

procedure TDGNImport.VaxToIeee(var D: double);
type
   T4W = packed Array[0..3]of Word;
var
   Sign: word;
   W4: T4W;
   W41: T4W;
   Shift: T4W;
   i: integer;
begin
   {
   asm
      mov eax,[ebp-$08]
      mov al,[eax]
      Mov AX,0
      rcr AX,1
      Mov AX,0007H
      rcr AX,1
   end;
   }
   W4 := T4W(D);
   Sign := W4[0];
   Sign := Sign and $8000;
   W4[0] := W4[0] and $7fff;
   for i := 0 to 3 do
   begin
      Shift[i] := (W4[i] and 7) shl 13{5};
      W4[i] := W4[i] shr 3;
      if i > 0 then W4[i] := W4[i] or Shift[i-1];
   end;
   if W4[0] > 0 then W4[0] := W4[0] + $37e0;
   W4[0] := W4[0] or Sign;
   for i := 0 to 3 do
      W41[i] := W4[3-i];
   D := double(W41);
end;



{
function TDGNImport.SwapLong( L: longInt ): LongInt; assembler;
asm
  mov   ax, word ptr L + 2
  mov   dx, word ptr L
end;
}

function TDGNImport.SwapLong( L: longInt ): LongInt;
type
   T2W = record
      L,H: word;
   end;
begin
   T2W(result).H := T2W(L).L;
   T2W(result).L := T2W(L).H;
end;


function TDGNImport.LL(L: LongInt): double;
var
   PomR: double;
begin
   PomR   := SwapLong(L);
   result := PomR/Prep;
end;

procedure TDGNImport.KontrolaSour(var S: TCoordinate);
begin
   if (Abs(S.x) > 1E8) or
      (Abs(S.y) > 1E8) then
   begin
      {
      ShowMessage('Nalezena souradnice s hodnotou nepouzitelnou v TopoLu - Bude prevedena jako 0!',False);
      }
      S.y := 0;
      S.x := 0;
      S.z := 0;
   end;
end;

function TDGNImport.Point2DToCoord(B: Point2D): TCoordinate;
begin
   result := T2DCoordinate.Create;
   result.x := LL(B.x);
   result.y := LL(B.y);
   KontrolaSour(result);
end;


function TDGNImport.Point3DToCoord(B: Point3D): TCoordinate;
begin
   result := T3DCoordinate.Create;
   result.x := LL(B.x);
   result.y := LL(B.y);
   result.z := LL(B.z);
   KontrolaSour(result);
end;



function TDGNImport.DPoint2DToCoord(var B: DPoint2D): TCoordinate;
begin
   result := T2DCoordinate.Create;
   VaxToIeee(B.x);
   result.x := B.x/Prep;
   VaxToIeee(B.y);
   result.y := B.y/Prep;
   KontrolaSour(result);
end;


function TDGNImport.DPoint3DToCoord(var B: DPoint3D): TCoordinate;
begin
   result := T3DCoordinate.Create;
   VaxToIeee(B.x);
   result.x := B.x/Prep;
   VaxToIeee(B.y);
   result.y := B.y/Prep;
   VaxToIeee(B.z);
   result.z := B.z/Prep;
   KontrolaSour(result);
end;



procedure TDGNImport.ShiftCoord(var ss: TCoordinate);{ Posunuti vzhledem ke globalnimu pocatku }
begin
 ss.x := aOrigin.x + ss.x;
 ss.y := aOrigin.y + ss.y;
 ss.z := aOrigin.z + ss.z;
 KontrolaSour(ss);
end;


function TDGNImport.GetFont(Font: byte;var Sklon: double): byte;
  var
     Pomf: byte;
     Poms: double;
  begin
     Poms := 0;
     Pomf := 5;
     case Font of
        0: Pomf := 5;
        1: Pomf := 8;
        2: Pomf := 4;
        3: Pomf := 8;
       32: Pomf := 8;
        7: Pomf := 9;
       23: begin
              Pomf := 8;
              Poms := 8;
           end;
       30: begin
              Pomf := 5;
              Poms := -15;
           end;
       31: begin
              Pomf := 5;
              Poms := 15;
           end;
       42: Pomf := 1;
       43: Pomf := 6;
       50,
      127: Pomf := 5;
     end;
     result := Pomf;
     Sklon  := DejRadZeStupnu(Poms);
  end;



function TDGNImport.VratKoefVysky (hmult: longint; font: byte): double;
  var
     Pom: double;
  begin
     Pom   := 6;

     case font of
        8,4: Pom := 20{15}{28};
          9: Pom := 40{24};
          1: Pom := 53;
          6: Pom := 25;
     end;

     Pom := ((6/Pom)*(hmult/1000)/Prep);
     result := Abs(Pom);
  end;



function TDGNImport.VratKoefSirky (lngthmult: longInt; hmult: real; Font: byte): double;
  var
     Pom: real;
  begin
     Pom := (lngthmult/hmult);
     case font of
        3: Pom := Pom * 1.2;
       23: Pom := Pom * 0.8;
     end;
     result := Pom;
  end;


procedure TDGNImport.OtocUhel(var Uh: double);
begin
    if Uh < PI then Uh := Uh + PI
               else Uh := Uh - PI;
end;




procedure TDGNImport.DoIt;
var
   i: longInt;
   KontrolW: word;
   FirstTime: boolean;
   S: string;
begin
   {
   if PripojitDatabaze then HledejRidiciDatabazi;
   }
   {
   Felikost := FileSize(F);
   }
   Pozice := 0;
   {
   JeDBW := False;
   }
   Is3D  := False;
   IsTCB := False;
   {
   JeKYSDGN := False;
   }

   WCS:= TWCSWorld(World).GetIDWCS(cs_JTSK);
   if FileName = '' then exit;
   OpenStream;
   StartGauge;
   FirstTime := true;
   while (True) do
   begin
      if FirstTime then
      begin
         FirstTime := false;
         FStream.Read(EHDR, SizeOf(Elm_hdr));
      end
      else
      begin
         FStream.Seek(Pozice + 4 + EHDR.Words shl 1, 0);
         Pozice := FStream.Position;
         FStream.Read(EHDR, SizeOf(Elm_hdr));
         if EHDR.Header = EOD then
         begin
            for i := Levels.Count - 1  downto 0 do
            begin
               if Level[i].NoElements then Levels.ElementToFree := Level[i];
            end;
            EndGauge;
            exit;
         end;
      end;
      LVL  := aLevel;
      {
      JeDB := False;
      }
      JeLin:= False;

      Progress := Pozice;
      Application.ProcessMessages;
      try
         if not Deleted then
         case Typ of
           DGNFIL_HEADER_ELM:  Read_DGNFIL_HEADER_ELM;
           CELL_LIB_ELM:       Read_CELL_LIB_ELM;
           SHAREDCELL_DEF_ELM: Read_SHAREDCELL_DEF_ELM;
           SHARED_CELL_ELM:    Read_SHARED_CELL_ELM;
           CELL_HEADER_ELM:    Read_CELL_HEADER_ELM;
           TEXT_NODE_ELM:      Read_TEXT_NODE_ELM;
           {
           CMPLX_STRING_ELM    Read_CMPLX_STRING_ELM;
           CMPLX_SHAPE_ELM     Read_CMPLX_SHAPE_ELM;
           }
           LINE_ELM:           Read_LINE_ELM;
           ELLIPSE_ELM:        Read_ELLIPSE_ELM;
           ARC_ELM:            Read_ARC_ELM;
           LINE_STRING_ELM,
           CURVE_ELM,
           SHAPE_ELM:          Read_LINE_STRING_ELM;
           TEXT_ELM:           Read_TEXT_ELM;
           MICROSTATION_ELM:   Read_MICROSTATION_ELM;
         end;{case}
      except
         case Typ of
           DGNFIL_HEADER_ELM:  S := 'DGNFIL_HEADER_ELM';
           CELL_LIB_ELM:       S := 'CELL_LIB_ELM';
           SHAREDCELL_DEF_ELM: S := 'SHAREDCELL_DEF_ELM';
           SHARED_CELL_ELM:    S := 'SHARED_CELL_ELM';
           CELL_HEADER_ELM:    S := 'CELL_HEADER_ELM';
           LINE_ELM:           S := 'LINE_ELM';
           ELLIPSE_ELM:        S := 'ELLIPSE_ELM';
           ARC_ELM:            S := 'ARC_ELM';
           LINE_STRING_ELM,
           CURVE_ELM,
           SHAPE_ELM:          S := 'LINE_STRING_ELM';
           TEXT_NODE_ELM :     S := 'TEXT_NODE_ELM';
           TEXT_ELM:           S := 'TEXT_ELM';
           MICROSTATION_ELM:   S := 'MICROSTATION_ELM';
         else
           S := 'Neznm element';
         end;{case}
         ShowMessage('Chyba importu: ' + S + '   '+IntToStr(Pozice));
      end;
      Levels.UpdateRect(Level[LVL]);
   end;
end;


procedure TDGNImport.Read_DGNFIL_HEADER_ELM;
begin
   if not IsTCB then
   begin
      IsTCB := True;
      FStream.Read(TCB, SizeOf(TTCB));
      if (Design3D in TCB.fbfdcn) and not Ignor3D then Is3D := True;
      //if (Design3D in TCB.fbfdcn) then ShowMessage('3D');
      Prep := (SwapLong(TCB.uorpersub)*SwapLong(TCB.subpermast));
      {
      if TretiQ then Prep := 0 - Prep;
      }
      aOrigin := DPoint3DToCoord(TCB.GlobOrg);
      AddElement(aOrigin);
   end;
end;

procedure TDGNImport.Read_CELL_LIB_ELM;
begin
end;

procedure TDGNImport.Read_SHAREDCELL_DEF_ELM;
begin
end;

procedure TDGNImport.Read_SHARED_CELL_ELM;
begin
end;


procedure TDGNImport.Read_CELL_HEADER_ELM;
var
   WW: Word;
   PE: TPointElement;
begin
   if Is3D then  FStream.Read(Cell3D, SizeOf(TCell_3D)) else
                 FStream.Read(Cell2D, SizeOf(TCell_2D));

   if not Deleted then
   begin
      Bod := TTopolPointElement.Create;
      Bod.Cislo    := 1;
      Bod.Presnost := 9;
      Bod.Znacka       := 0;
      //Bod.Uhel     := 0;
      PE := TPointElement.Create;
      Bod.Geometry := PE;
      if Is3D then
      begin
         Bod.Druh  := aClass(Cell3D.DHdr);
         Bod.Barva := GetColor(Cell3D.DHdr.Symb);
         Coord     := Point3DToCoord(Cell3D.Origin);
         RadixToAscii(Cell3D.name,CellName,6);
      end
      else
      begin
         Bod.Druh := aClass(Cell2D.DHdr);
         Bod.Barva := GetColor(Cell2D.DHdr.Symb);
         Coord     := Point2DToCoord(Cell2D.Origin);
         RadixToAscii(Cell2D.name,CellName,6);
      end;
      ShiftCoord(Coord);
      {
      WCS.RecalculateToICS(Coord);
      }
      {
      Bod.CS := WCS.ID;
      Bod.x  := Coord.x;
      Bod.y  := Coord.y;
      Bod.z  := Coord.z;
      }
      PE.X := Coord.x;
      PE.Y := Coord.y;
      Coord.Free;
      {
      Bod.Druh := PrevodniTabulka.VratKodDleBunky(CellName);
      }
      Bod.Name := CellName;

      Level[LVL].AddAndUpdateRect(Bod);

      {
      if PripojitDatabaze and DBProBody and
         ((Is3D and JsouAtributy(Cell3D.DHdr)) or
         JsouAtributy(Cell2D.DHdr))  then
      begin
         BlockRead(F,AtribLink,SizeOf(TAtribLink));
         JeDB := True;
         JeLin:= True;
         UlozDBBod;
      end
      }
   end;
end;

procedure TDGNImport.Read_TEXT_NODE_ELM;
var
   aDirection,DH: double;
begin
   if Is3D then exit;
   if not AsTMPText then exit;
   TMPText := TtmpText.Create;
   FStream.Read(TextNode,SizeOf(Ttext_node_2d));
   FillTextStyle(TextNode.font);
   Coord := Point2DToCoord(TextNode.Origin);
   ShiftCoord(Coord);
   SetRect(TMPText);
   TMPText.AbsRefX := Coord.X;
   TMPText.AbsRefY := Coord.Y;
   aDirection := DejRadZeStupnu(SwapLong(TextNode.rotation)/360000);
   if not TretiQ and Ignor3D then otocUhel(aDirection);
   TMPText.TextAngle := aDirection;
   DH := SwapLong(TextNode.hghtmult);
   TMPText.TextHeight := DH*6/1000000;
   Level[LVL].AddAndUpdateRect(TMPText);
end;

procedure TDGNImport.Read_CMPLX_STRING_ELM;
begin
end;

procedure TDGNImport.Read_CMPLX_SHAPE_ELM;
begin
end;

procedure TDGNImport.Read_LINE_ELM;
var
   LE: TPolyLineElement;
begin
   if Is3D then FStream.Read(Line3D,SizeOf(TLine_3D))
           else FStream.Read(Line2D,SizeOf(TLine_2D));
   {
   if (Is3D and (Class(Line3D.dhdr) = PATTERN_COMPONENT_CLASS)) or
                (Class(Line2D.dhdr) = PATTERN_COMPONENT_CLASS) then
   }
   begin
      Line := TTopolLineElement.Create;
      Line.Cislo    := 1;
      Line.Presnost      := 9;
      Line.Symbol        := 0;
      LE := TPolyLineElement.Create;
      Line.Geometry := LE;
      {
      Line.DrziSe        := NedrziSe;
      }
      if Is3D then
      begin
         Line.Druh  := aClass(Line3D.DHdr);
         Line.Barva := GetColor(Line3D.DHdr.Symb);
         Coord      := Point3DToCoord(Line3D.StartP);
      end
      else
      begin
         Line.Druh  := aClass(Line2D.DHdr);
         Line.Barva := GetColor(Line2D.DHdr.Symb);
         Coord      := Point2DToCoord(Line2D.StartP);
      end;
      ShiftCoord(Coord);
      {
      WCS.RecalculateToICS(Coord);
      }
      LE.AddAndUpdateRect(Coord);

      if Is3D then Coord := Point3DToCoord(Line3D.EndP)
              else Coord := Point2DToCoord(Line2D.EndP);

      ShiftCoord(Coord);
      {
      WCS.RecalculateToICS(Coord);
      }
      LE.AddAndUpdateRect(Coord);
      {
      NastavSymbolDoStredu(Linie, PLomBod);
      }

      Level[LVL].AddAndUpdateRect(Line);
      {
      if PripojitDatabaze and
         ((Is3D and JsouAtributy(Line3D.DHdr)) or
         JsouAtributy(Line2D.DHdr))  then
      begin
         JeDB := True;
         JeLin:= True;
         BlockRead(F,AtribLink,SizeOf(TAtribLink));
         UlozDBLin;
      end
      }
   end;
end;

procedure TDGNImport.Read_ELLIPSE_ELM;
begin
(*
   KontrolaVrstvy(LVL);
   Line := Linie00;
   if Is3D then BlockRead(F,Ellipse3D,SizeOf(TEllipse_3d))
           else BlockRead(F,Ellipse2D,SizeOf(TEllipse_2d));

   begin
      with Line do
      begin
         VratOpsanyObd(OpsanyObdelnik);
         Cislo         := VV[LVL]^.CLin;
         if Is3D then Druh := aClass(Ellipse3D.DHdr) else
                      Druh := aClass(Ellipse2D.DHdr);
         Presnost      := 9;
         Atributy      := [lnKrivka,lnElipsa];
         Vybrana       := false;
         if Is3D then
            NastavBarvuAStylln(Ellipse3D.DHdr.Symb,Barva,Znacka) else
            NastavBarvuAStylln(Ellipse2D.DHdr.Symb,Barva,Znacka);
         Symbol        := 0;
         Cas           := GetPackTime;
         PrvniSour     := VV[LVL]^.CSour;
         PosledniSour  := VV[LVL]^.CSour + 2;
         DrziSe        := Nedrzise;
         Delka         := 0;
      end;


      if Is3D then
      begin
         DPoint3DToCoord(Ellipse3D.Origin,Elipsa.Orig);
         VAXtoIEEE(Ellipse3D.Primary);
         Elipsa.a    := Abs(Ellipse3D.Primary/Prep);
         VAXtoIEEE(Ellipse3D.Secondary);
         Elipsa.b    := Abs(Ellipse3D.Secondary/Prep);
         Elipsa.Uhel := 0;{ ve 3D ?????????? }
      end
      else begin
         DPoint2DToCoord(Ellipse2D.Origin,Elipsa.Orig);
         VAXtoIEEE(Ellipse2D.Primary);
         Elipsa.a    := Abs(Ellipse2D.Primary/Prep);
         VAXtoIEEE(Ellipse2D.Secondary);
         Elipsa.b    := Abs(Ellipse2D.Secondary/Prep);
         Elipsa.Uhel := DejRadZeStupnu
                        (SwapLong(Ellipse2D.rotation)/360000);
         if not TretiQ and Ignor3D then otocUhel(Elipsa.Uhel);
      end;

      if Elipsa.a = Elipsa.b then
         Line.Atributy := Line.Atributy+[lnKruznice];

      UlozLin;

      Sour := Elipsa.Orig;
      ShiftCoord(Coord);
      UlozSour;
      Sour.y := Elipsa.a;
      Sour.x := Elipsa.b;
      UlozSour;
      Sour.y := Elipsa.Uhel;
      Sour.x := 0;
      UlozSour;
      if PripojitDatabaze and
         ((Is3D and JsouAtributy(Ellipse3D.DHdr)) or
         JsouAtributy(Ellipse2D.DHdr))  then
      begin
         BlockRead(F,AtribLink,SizeOf(TAtribLink));
         JeDB := True;
         JeLin:= True;
         UlozDBLin;
      end
   end;
*)
end;

procedure TDGNImport.Read_ARC_ELM;
var
   Oblouk_a: double;
   Oblouk_b: double;
   Oblouk_Uhel: double;
   Oblouk_Zacatek: double;
   Oblouk_Konec: double;
   Oblouk_Orig: TCoordinate;
   Start,
   Sweep: double;
   SweepL: LongInt;
   Kladny: boolean;
   LE: TPolyLineElement;
   //********
     x1,y1: double;
     x2,y2: double;
     Alfa : double;
     dU   : double;
     ku   : double;
     Uhel1,
     Uhel2: double;
     U1,U2: double;
     sinUhel,cosUhel: double;
     i,j  : word;
     PomR: double;
     Ro     : double;
     Sour   : TSour;

procedure NacpiUhelDoDvaPi (var Uhel: double);
//  var
 //    DvaPI: double;
  begin
   //  DvaPI := 2*PI;
     if Uhel < 0 then Uhel := DvaPi + Uhel else
     if Uhel > DvaPi then Uhel := Uhel-(Int(Uhel/DvaPi)*DvaPi);
  end;

begin
   if Is3D then FStream.Read(Arc3D,SizeOf(TArc_3d))
           else FStream.Read(Arc2D,SizeOf(TArc_2d));
   Oblouk_Orig := nil;
   Line := TTopolLineElement.Create;
   Line.Cislo    := 1;
   Line.Presnost      := 5;
   Line.Symbol        := 0;
   LE := TPolyLineElement.Create;
   Line.Geometry := LE;
   if Is3D then
   begin
      Line.Druh  := aClass(Arc3D.DHdr);
      Line.Barva := GetColor(Arc3D.DHdr.Symb);
      //Coord      := Point3DToCoord(LineString3D.Vertice);
   end
   else
   begin
      Line.Druh  := aClass(Arc2D.DHdr);
      Line.Barva := GetColor(Arc2D.DHdr.Symb);
      //Coord      := Point2DToCoord(LineString2D.Vertice);
   end;
   // test barva
   //Line.Barva := 8;

   if Is3D then
   begin
      Oblouk_Orig := DPoint3DToCoord(Arc3D.Origin);
      VAXtoIEEE(Arc3D.Primary);
      Oblouk_a       := Abs(Arc3D.Primary/Prep);
      VAXtoIEEE(Arc3D.Secondary);
      Oblouk_b       := Abs(Arc3D.Secondary/Prep);
      Oblouk_Uhel    := 0;{ ve 3D ?????????? }
   end
   else begin
      Oblouk_Orig := DPoint2DToCoord(Arc2D.Origin);
      VAXtoIEEE(Arc2D.Primary);
      Oblouk_a       := Abs(Arc2D.Primary/Prep);
      VAXtoIEEE(Arc2D.Secondary);
      Oblouk_b       := Abs(Arc2D.Secondary/Prep);
      Oblouk_Uhel    := DejRadZeStupnu
                        (SwapLong(Arc2D.rotation)/360000);
      if not TretiQ and Ignor3D then otocUhel(Oblouk_Uhel);
   end;


   //NastavUhlyOblouku;
   if Is3D then
   begin
      Start := DejRadZeStupnu(SwapLong(Arc3D.StartAng)/360000);
      Arc3D.SweepAng := SwapLong(Arc3D.SweepAng);
      SweepL := (Arc3D.SweepAng and $7FFFFFFF);
      Kladny:= (Arc3D.SweepAng and $80000000) = 0;
      Sweep := DejRadZeStupnu(SweepL/360000);
   end
   else begin
           Start := DejRadZeStupnu(SwapLong(Arc2D.StartAng)/360000);
           Arc2D.SweepAng := SwapLong(Arc2D.SweepAng);
           SweepL := Arc2D.SweepAng and $7FFFFFFF;
           Kladny:= Arc2D.SweepAng and $80000000 = 0;
           Sweep := SweepL/360000;
           if Sweep = 360 then Sweep := 0 else
              Sweep := DejRadZeStupnu(SweepL/360000);
        end;
   if Kladny then
   begin
      Oblouk_Zacatek := Start;
      Oblouk_Konec   := Start + Sweep;
   end
   else begin
      Oblouk_Zacatek := Start - Sweep;
      Oblouk_Konec   := Start;
   end;
   {
   PostTextMsg(tm_AddToProtocol,'Oblouk',nil);
   PostTextMsg(tm_AddToProtocol,'  Orig : '+FloatToStr(Oblouk_Orig.X)+'||'+FloatToStr(Oblouk_Orig.Y),nil);
   PostTextMsg(tm_AddToProtocol,'  uhel : '+FloatToStr(Oblouk_Uhel),nil);
   PostTextMsg(tm_AddToProtocol,'  a    : '+FloatToStr(Oblouk_a),nil);
   PostTextMsg(tm_AddToProtocol,'  b    : '+FloatToStr(Oblouk_b),nil);
   PostTextMsg(tm_AddToProtocol,'  start: '+FloatToStr(Oblouk_Zacatek),nil);
   PostTextMsg(tm_AddToProtocol,'  end  : '+FloatToStr(Oblouk_Konec),nil);
   }
   //END NastavUhlyOblouku;

   //Oblouk na Linii

     { Osa a bude delsi a basta ! }
     { -------------------------- }
     if Oblouk_b > Oblouk_a then
     begin
        U1     := Oblouk_a;
        Oblouk_a := Oblouk_b;
        Oblouk_b := U1;
        Oblouk_Uhel := Oblouk_Uhel + PiPul;
        NacpiUhelDoDvaPi(Oblouk_Uhel);
        Oblouk_Zacatek := Oblouk_Zacatek - PiPul;
        Oblouk_Konec   := Oblouk_Konec - PiPul;
     end;

     { Uhly Oblouk_Zacatek a Oblouk_Konec je treba nacpat do intervalu <0,2> }
     NacpiUhelDoDvaPi(Oblouk_Zacatek);
     NacpiUhelDoDvaPi(Oblouk_Konec);

     U1 := Oblouk_Zacatek;
     U2 := Oblouk_Konec;
     if U2 = 0 then U2 := DvaPi;

     { Vypocet KrokovehoUhlu }
     { --------------------- }
        {
        if PevnaDelkaVertexu then
           Ro := SQRT(SQR(Oblouk_a)-SQR(PresnostKrivek/2))
        else
        }
     Ro := Oblouk_a - 0.01{PresnostKrivek};
     //Ro := SQRT(SQR(Oblouk_a)-SQR(0.5{PresnostKrivek/2}));
     dU := 2*ACos(Ro/Oblouk_a);


     sinUhel := (Sin(Oblouk_Uhel));
     cosUhel := (Cos(Oblouk_Uhel));

     x1 := Oblouk_a*(cos(U1));
     y1 := Oblouk_b*(sin(U1));
     x2 := (x1*cosUhel-y1*sinUhel);
     y2 := (x1*sinUhel+y1*cosUhel);

     Coord := T2DCoordinate.Create;
     Coord.y := Oblouk_Orig.y+y2;
     Coord.x := Oblouk_Orig.x+x2;
     LE.AddAndUpdateRect(Coord);

     Alfa := U1+dU;
     if U2 < U1 then
        U2 := U2 + DvaPI;
     while Alfa < U2 do
     begin
        x1 := (Oblouk_a*(cos(Alfa)));
        y1 := (Oblouk_b*(sin(Alfa)));
        x2 := (x1*cosUhel-y1*sinUhel);
        y2 := (x1*sinUhel+y1*cosUhel);

        Coord := T2DCoordinate.Create;
        Coord.y := Oblouk_Orig.y+y2;
        Coord.x := Oblouk_Orig.x+x2;
        LE.AddAndUpdateRect(Coord);

        Alfa := Alfa+dU;
     end;
     x1 := Oblouk_a*(cos(U2));
     y1 := Oblouk_b*(sin(U2));
     x2 := (x1*cosUhel-y1*sinUhel);
     y2 := (x1*sinUhel+y1*cosUhel);
     Coord := T2DCoordinate.Create;
     Coord.y := Oblouk_Orig.y+y2;
     Coord.x := Oblouk_Orig.x+x2;
     LE.AddAndUpdateRect(Coord);
   //END Oblouk na Linii

   Oblouk_Orig.Free;
   Level[LVL].AddAndUpdateRect(Line);

   {
   Sour := Oblouk.Orig;
   ShiftCoord(Sour);
   UlozSour;
   Sour.y := Oblouk.a;
   Sour.x := Oblouk.b;
   UlozSour;
   Sour.y := Oblouk.Uhel;
   Sour.x := Oblouk.Zacatek;
   UlozSour;
   Sour.y := Oblouk.Konec;
   Sour.x := 0;
   UlozSour;
   if PripojitDatabaze and
      ((Is3D and JsouAtributy(Arc3D.DHdr)) or
      JsouAtributy(Arc2D.DHdr))  then
   begin
      JeDB := True;
      JeLin:= True;
      BlockRead(F,AtribLink,SizeOf(TAtribLink));
      UlozDBLin;
   end
}

(*
   KontrolaVrstvy(LVL);
   Line := Linie00;
   if Is3D then BlockRead(F,Arc3D,SizeOf(TArc_3d))
           else BlockRead(F,Arc2D,SizeOf(TArc_2d));
   begin
      with Line do
      begin
         VratOpsanyObd(OpsanyObdelnik);
         Cislo         := VV[LVL]^.CLin;
         if Is3D then Druh := aClass(Arc3D.DHdr) else
                      Druh := aClass(Arc2D.DHdr);
         Presnost      := 9;
         Atributy      := [lnKrivka,lnOblouk];
         Vybrana       := false;
         if Is3D then
            NastavBarvuAStylln(Arc3D.DHdr.Symb,Barva,Znacka) else
            NastavBarvuAStylln(Arc2D.DHdr.Symb,Barva,Znacka);
         Symbol        := 0;
         Cas           := GetPackTime;
         PrvniSour     := VV[LVL]^.CSour;
         PosledniSour  := VV[LVL]^.CSour + 3;
         DrziSe        := NedrziSe;
         Delka         := 0;
      end;

      if Is3D then
      begin
         DPoint3DToCoord(Arc3D.Origin,Oblouk.Orig);
         VAXtoIEEE(Arc3D.Primary);
         Oblouk.a       := Abs(Arc3D.Primary/Prep);
         VAXtoIEEE(Arc3D.Secondary);
         Oblouk.b       := Abs(Arc3D.Secondary/Prep);
         Oblouk.Uhel    := 0;{ ve 3D ?????????? }
      end
      else begin
         DPoint2DToCoord(Arc2D.Origin,Oblouk.Orig);
         VAXtoIEEE(Arc2D.Primary);
         Oblouk.a       := Abs(Arc2D.Primary/Prep);
         VAXtoIEEE(Arc2D.Secondary);
         Oblouk.b       := Abs(Arc2D.Secondary/Prep);
         Oblouk.Uhel    := DejRadZeStupnu
                           (SwapLong(Arc2D.rotation)/360000);
         if not TretiQ and Ignor3D then otocUhel(Oblouk.Uhel);
      end;

      if Oblouk.a = Oblouk.b then
         Line.Atributy := Line.Atributy+[lnKruznice];

      UlozLin;


      NastavUhlyOblouku;
      Sour := Oblouk.Orig;
      ShiftCoord(Sour);
      UlozSour;
      Sour.y := Oblouk.a;
      Sour.x := Oblouk.b;
      UlozSour;
      Sour.y := Oblouk.Uhel;
      Sour.x := Oblouk.Zacatek;
      UlozSour;
      Sour.y := Oblouk.Konec;
      Sour.x := 0;
      UlozSour;
      if PripojitDatabaze and
         ((Is3D and JsouAtributy(Arc3D.DHdr)) or
         JsouAtributy(Arc2D.DHdr))  then
      begin
         JeDB := True;
         JeLin:= True;
         BlockRead(F,AtribLink,SizeOf(TAtribLink));
         UlozDBLin;
      end
   end;
*)
end;

procedure TDGNImport.Read_LINE_STRING_ELM;
var
   i: longInt;
   LE: TPolyLineElement;
begin
   if Is3D then FStream.Read(LineString3D,SizeOf(TLine_string_3d))
           else FStream.Read(LineString2D,SizeOf(TLine_string_2d));
   {
   if (Is3D and (Class(LineString3D.dhdr) = PATTERN_COMPONENT_CLASS)) or
                (Class(LineString2D.dhdr) = PATTERN_COMPONENT_CLASS) then
   }
   begin
      Line := TTopolLineElement.Create;
      Line.Cislo    := 1;
      Line.Presnost      := 9;
      Line.Symbol        := 0;
      LE := TPolyLineElement.Create;
      Line.Geometry := LE;
      {
      Line.DrziSe        := NedrziSe;
      }
      {
      case Typ of
        CURVE_ELM :
          begin
             Atributy := Atributy+[lnKrivka,lnFerguson];
          end;
      end;
      }
      if Is3D then
      begin
         Line.Druh  := aClass(LineString3D.DHdr);
         Line.Barva := GetColor(LineString3D.DHdr.Symb);
         Coord      := Point3DToCoord(LineString3D.Vertice);
      end
      else
      begin
         Line.Druh  := aClass(LineString2D.DHdr);
         Line.Barva := GetColor(LineString2D.DHdr.Symb);
         Coord      := Point2DToCoord(LineString2D.Vertice);
      end;
      ShiftCoord(Coord);
      {
      WCS.RecalculateToICS(Coord);
      }
      LE.AddAndUpdateRect(Coord);


      if Is3D then
      begin
         for i := 2 to LineString3D.NumVerts do
         begin
            FStream.Read(P3D,SizeOf(Point3D));
            Coord := Point3DToCoord(P3D);
            ShiftCoord(Coord);
            {
            WCS.RecalculateToICS(Coord);
            }
            LE.AddAndUpdateRect(Coord);
         end;
      end
      else
      begin
         for i := 2 to LineString2D.NumVerts do
         begin
            FStream.Read(P2D,SizeOf(Point2D));
            Coord := Point2DToCoord(P2D);
            ShiftCoord(Coord);
            {
            WCS.RecalculateToICS(Coord);
            }
            LE.AddAndUpdateRect(Coord);
         end;
      end;
      {
      NastavSymbolDoStredu(Line, PLomBod);
      }

      Level[LVL].AddAndUpdateRect(Line);
      {
      if PripojitDatabaze and
         ((Is3D and JsouAtributy(LineString3D.DHdr)) or
         JsouAtributy(LineString2D.DHdr))  then
      begin
         JeDB := True;
         JeLin:= True;
         BlockRead(F,AtribLink,SizeOf(TAtribLink));
         UlozDBLin;
      end
      }
   end;
end;

procedure TDGNImport.Read_CURVE_ELM;
begin
end;

procedure TDGNImport.Read_SHAPE_ELM;
begin
end;

procedure TDGNImport.Read_TEXT_ELM;
var
   TE: TTextElement;
   aSlope: double;
   aDirection,DH: double;
   S: string;
begin
   if AsTMPText then
   begin
      if Is3D then exit;
      FStream.Read(Text2D,SizeOf(Ttext_2d));
      if Text2D.Numchars < 1 then Sg := ''
      else begin
         SetLength(Sg,Ord(Text2D.numchars));
         Sg[1] := Text2D.Pis;
         if Text2D.numchars > 1 then
            FStream.Read(Sg[2],Text2D.numchars - 1);
         //Sg[0] := Chr(Text2D.numchars);
      end;
      if Complex and (TMPText <> nil) then
      begin
         S := TMPText.Text;
         if S <> '' then S := S +#13+#10;
         S := S + Sg;
         TMPText.Text := S;
         TMPText.Name := S;
         exit;
      end;
      TMPText := TTMPText.Create;
      FillTextStyle(Text2D.Font);
      TMPText.Text := Sg;
      TMPText.Name := Sg;
      Coord := Point2DToCoord(Text2D.Origin);
      ShiftCoord(Coord);
      SetRect(TMPText);
      TMPText.AbsRefX := Coord.X;
      TMPText.AbsRefY := Coord.Y;
      aDirection := DejRadZeStupnu(SwapLong(Text2D.rotation)/360000);
      if not TretiQ and Ignor3D then otocUhel(aDirection);
      TMPText.TextAngle := aDirection;
      DH := SwapLong(Text2D.hghtmult);
      TMPText.TextHeight := DH*6/1000000;
      Level[LVL].AddAndUpdateRect(TMPText);
      exit;
   end;
   TBX := TTopolTextElement.Create;
   TE := TTextElement.Create;
   TBX.Geometry := TE;
   with TBX do
   begin
      if Is3D then
      begin
         FStream.Read(Text3D,SizeOf(Ttext_3d));
         SetLength(Sg,Ord(Text3D.Pis));
         if Text3D.Numchars < 1 then Sg := ''
         else begin
            SetLength(Sg,Text3D.numchars);
            Sg[1] := Text3D.Pis;
            if Text3D.numchars > 1 then
               FStream.Read(Sg[2],Text3D.numchars - 1);
            //Sg[0] := Chr(Text3D.numchars);
         end;
         TopolFont := GetFont(Text3D.Font,aSlope);
         Slope := aSlope;
         Coord := Point3DToCoord(Text3D.Origin);
         StartPoint := Coord;
         ShiftCoord(Coord);

         Text3D.hghtmult := SwapLong(Text3D.hghtmult);
         Text3D.lngthmult:= SwapLong(Text3D.lngthmult);

         Height    := VratKoefVysky (Text3D.hghtmult,TopolFont);
         WidthCoef := VratKoefSirky (Text3D.lngthmult,Text3D.hghtmult,Text3D.font);
         Direction := 0; { ve 3D ?????? }
         Barva := GetColor(Text3D.DHdr.Symb);
         Druh := aClass(Text3D.DHdr);
      end
      else
      begin
         FStream.Read(Text2D,SizeOf(Ttext_2d));
         if Text2D.Numchars < 1 then Sg := ''
         else begin
            SetLength(Sg,Ord(Text2D.numchars));
            Sg[1] := Text2D.Pis;
            if Text2D.numchars > 1 then
               FStream.Read(Sg[2],Text2D.numchars - 1);
            //Sg[0] := Chr(Text2D.numchars);
         end;
         TopolFont := GetFont(Text2D.Font,aSlope);
         Slope := aSlope;
         Coord := Point2DToCoord(Text2D.Origin);
         StartPoint := Coord;
         ShiftCoord(Coord);

         Text2D.hghtmult := SwapLong(Text2D.hghtmult);
         Text2D.lngthmult:= SwapLong(Text2D.lngthmult);

         Height     := VratKoefVysky (Text2D.hghtmult,TopolFont);
         WidthCoef := VratKoefSirky (Text2D.lngthmult,Text2D.hghtmult,Text2D.font);
         aDirection      := DejRadZeStupnu(SwapLong(Text2D.rotation)/360000);
         if not TretiQ and Ignor3D then otocUhel(aDirection);
         Direction := aDirection;
         Barva := GetColor(Text2D.DHdr.Symb);
         Druh := aClass(Text2D.DHdr);
      end;
      TE.X      := TBX.StartPoint.X;
      TE.Y      := TBX.StartPoint.Y;
      TE.Text   := Sg;
      Cislo      := 1;
      TextMode := 1;
      Level[LVL].AddAndUpdateRect(TBX);
   end;
end;

procedure TDGNImport.Read_MICROSTATION_ELM;
begin
   if aLevel = 10 then
   begin
   {
      if PripojitDatabaze then
      begin
         BlockRead(F,StartApp,SizeOf(TStartApp));
         VratJmenoRidiciDatabaze;
      end;
   }
   end;
end;

procedure TDGNImport.SetTextStyles(const Value: TEntity);
begin
  FTextStyles := Value;
end;

procedure TDGNImport.FillTextStyle(aCode: integer);
var
   e: Telement;
   PS: TParagraphStyle;
begin
   if TMPText = nil then exit;
   TMPText.FontCode := aCode;
   TMPText.FontName := 'Arial';
   TMPText.FontStyle := 0;
   TMPText.TextColor := 0;
   if TMPTextColor <> 0 then
      TMPText.TextColor := TMPTextColor;
   TMPText.TextSize := 0;
   if TextStyles = nil then exit;
   e := TextStyles.FindElementName(IntToStr(aCode));
   if e = nil then exit;
   if not (e is TParagraphStyle) then exit;
   PS := TParagraphStyle(e);
   TMPText.FontName := PS.FontName;
   TMPText.FontStyle := integer(PS.FontStyle);
   TMPText.TextColor := PS.TextColor;
   TMPText.TextSize := PS.TextSize;
   if TMPTextColor <> 0 then
      TMPText.TextColor := TMPTextColor;
end;

procedure TDGNImport.SetAsTMPText(const Value: boolean);
begin
  FAsTMPText := Value;
end;

procedure TDGNImport.SetTMPTextColor(const Value: integer);
begin
  FTMPTextColor := Value;
end;

procedure TDGNImport.SetRect(aR: TRectEntity);
begin
   if aR = nil then exit;
   aR.MinX := aOrigin.x + LL1(EHDR.xlow);
   aR.MinY := aOrigin.y + LL1(EHDR.ylow);
   aR.MaxX := aOrigin.x + LL1(EHDR.xhigh);
   aR.MaxY := aOrigin.y + LL1(EHDR.yhigh);
end;

function TDGNImport.LL1(L: longInt): double;
var
   PomR: double;
  procedure UpravATak(var LLL: LongInt);
  begin
     LLL := SwapLong(LLL);
     if LLL > 0 then LLL := LLL - MaxLongInt - 1  else
     if LLL < 0 then LLL := LLL + MaxLongInt + 1;
  end;
begin
   UpravATak(L);
   PomR   := L;
   result := PomR/Prep;
end;

INITIALIZATION
   RegisterOrbisClass(TDGNImport);
END.