unit E_txtdev;

interface

uses
  WinTypes,
  Elements, E_Device;

type

TTextFileDevice = class(TDevice)
private
  FTextFile: TextFile;
  function GetFileName: string;
  procedure SetFileName(aText: string);
  function IsOpen: boolean;
protected
    function GetHandle: HDC; override;
    procedure SetVisible(aVisible: boolean); override;
public
  constructor Create; override;
  destructor  Destroy; override;
  procedure Clear; override;
  procedure Reset; override;
  procedure Adjust; override;
  procedure SetupPage(Sender: TObject); override;

  procedure WriteText(aText: string); override;
  procedure WriteLnText(aText: string); override;
published
  property FileName: string read GetFileName write SetFileName;
end;


implementation
{ SysUtils
fmClosed = $D7B0;
fmInput  = $D7B1;
fmOutput = $D7B2;
fmInOut  = $D7B3;
}

uses
  SysUtils,
  e_Class;

                        { TTextFileDevice }

function TTextFileDevice.GetHandle: HDC;
begin
  result:= 0;
end;

procedure TTextFileDevice.SetVisible(aVisible: boolean);
begin
end;


constructor TTextFileDevice.Create;
begin
end;


destructor TTextFileDevice.Destroy;
begin
  if IsOpen then
     CloseFile(FTextFile)
end;

procedure TTextFileDevice.Clear;
begin
end;

procedure TTextFileDevice.Reset;
begin
end;

procedure TTextFileDevice.Adjust;
begin
end;

procedure TTextFileDevice.SetupPage(Sender: TObject);
begin
end;




function TTextFileDevice.IsOpen: boolean;
begin
  result:= TTextRec(FTextFile).Mode = fmOutput;
end;



function TTextFileDevice.GetFileName: string;
begin
  if not IsOpen then exit;
  result:= TTextRec(FTextFile).Name;
end;

procedure TTextFileDevice.SetFileName(aText: string);
begin
  if IsOpen then
     closeFile(FTextFile);

  assignFile(FTextFile, aText);
  rewrite(FTextFile)
end;


procedure TTextFileDevice.WriteText(aText: string);
begin
  if not IsOpen then exit;
  Write(FTextFile, aText)
end;


procedure TTextFileDevice.WriteLnText(aText: string);
begin
  if not IsOpen then exit;
  WriteLn(FTextFile, aText)
end;



initialization
  RegisterOrbisClass(TTextFileDevice);
end.

