unit F_cmdln;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls,
   ExtCtrls,
   f_SyntaxFind,
   Dialogs, Menus, Grids,
   // KERNEL
   Elements,
   // OIL
   t_CmdLn,
   // EXPLORER
   f_Watch, Highlighter, OILHighlighter, SyntaxEditor, ComCtrls, ToolWin,
  StdActns, ActnList, ImgList;

type
  TCommandLineDlg = class(TForm)
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    PopupMenu1: TPopupMenu;
    Psmo1: TMenuItem;
    FontDialog: TFontDialog;
    StatusBar: TStatusBar;
    RMemo: TRichEdit;
    Splitter1: TSplitter;
    SyntaxEdit: TSyntaxEdit;
    OILHighlighter: TOILHighlighter;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    OpenFile1: TMenuItem;
    Save1: TMenuItem;
    SaveAs1: TMenuItem;
    N1: TMenuItem;
    Close1: TMenuItem;
    Edit1: TMenuItem;
    Cut1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    N2: TMenuItem;
    EditUndoAction1: TMenuItem;
    EditRedoAction1: TMenuItem;
    N3: TMenuItem;
    ControlChars1: TMenuItem;
    Search1: TMenuItem;
    Find1: TMenuItem;
    Findnext1: TMenuItem;
    SearchReplaceAction1: TMenuItem;
    Options1: TMenuItem;
    AutoIndentItem: TMenuItem;
    UnindentItem: TMenuItem;
    CursorEOLItem: TMenuItem;
    CursorTabItem: TMenuItem;
    TripleItem: TMenuItem;
    GroupUndoItem: TMenuItem;
    HideSelectionItem: TMenuItem;
    InsertItem: TMenuItem;
    BlanksItem: TMenuItem;
    OptimalItem: TMenuItem;
    SmartItem: TMenuItem;
    ControlItem: TMenuItem;
    ReadOnlyItem: TMenuItem;
    NumberItem: TMenuItem;
    HintItem: TMenuItem;
    UndoItem: TMenuItem;
    HighlightItem: TMenuItem;
    TabItem: TMenuItem;
    MenuImageList: TImageList;
    FontDialog1: TFontDialog;
    MainActionList: TActionList;
    EditCopyAction: TEditCopy;
    EditCutAction: TEditCut;
    EditPasteAction: TEditPaste;
    FileOpenAction: TAction;
    FileSaveAction: TAction;
    FileCloseAction: TAction;
    FileNewAction: TAction;
    EditControlCharAction: TAction;
    EditUndoAction: TAction;
    EditRedoAction: TAction;
    FileSaveAsAction: TAction;
    SearchFindAction: TAction;
    SearchNextAction: TAction;
    SearchReplaceAction: TAction;
    FontAction: TAction;
    MainControlBar: TControlBar;
    MenuToolBar: TToolBar;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton16: TToolButton;
    ToolButton15: TToolButton;
    ButtonToolBar: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton9: TToolButton;
    ToolButton3: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton10: TToolButton;
    ToolButton19: TToolButton;
    ToolButton12: TToolButton;
    ToolButton11: TToolButton;
    ToolButton13: TToolButton;
    ToolButton17: TToolButton;
    Edit2: TEdit;
    UpDown1: TUpDown;
    ToolButton18: TToolButton;
    SearchToolBar: TToolBar;
    ToolButton21: TToolButton;
    ToolButton22: TToolButton;
    ToolButton23: TToolButton;
    cb_Vycet: TCheckBox;
    FileRUNAction: TAction;
    p_Run: TPanel;
    diode: TPanel;
    SpustitOIL1: TMenuItem;
    N4: TMenuItem;
    b_Run: TBitBtn;
    procedure b_EvalClick(Sender: TObject);
    procedure ed_CommandExit(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure ed_CommandKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ed_CommandClick(Sender: TObject);
    procedure ed_CommandKeyPress(Sender: TObject; var Key: Char);
    procedure Panel2Resize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure b_CloseClick(Sender: TObject);
    procedure HeaderSizing(Sender: TObject; ASection, AWidth: Integer);
    procedure b_OpenClick(Sender: TObject);
    procedure b_OpenRunClick(Sender: TObject);
    procedure b_SaveClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure CMemoKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure b_WatchesClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure SyntaxEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Button1Click(Sender: TObject);
    procedure EditCopyActionExecute(Sender: TObject);
    procedure EditCutActionExecute(Sender: TObject);
    procedure EditPasteActionExecute(Sender: TObject);
    procedure FileOpenActionExecute(Sender: TObject);
    procedure FileSaveActionExecute(Sender: TObject);
    procedure FileCloseActionExecute(Sender: TObject);
    procedure FileNewActionExecute(Sender: TObject);
    procedure EditUndoActionExecute(Sender: TObject);
    procedure EditRedoActionExecute(Sender: TObject);
    procedure FileSaveAsActionExecute(Sender: TObject);
    procedure SearchFindActionExecute(Sender: TObject);
    procedure SearchNextActionExecute(Sender: TObject);
    procedure FontActionExecute(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure SyntaxEditCaretChange(Sender: TObject; X, Y: Cardinal);
    procedure SyntaxEditReplaceText(Sender: TObject; const Search,
      Replace: WideString; Line, Start, Stop: Integer;
      var ReplaceAction: TReplaceAction);
    procedure SyntaxEditSettingChange(Sender: TObject);
    procedure SyntaxEditDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure OptionMenuClick(Sender: TObject);
    procedure FileRUNActionExecute(Sender: TObject);
  private
     FLastSearchOptions: TSearchOptions;
     FSyntaxFindDialog: TSyntaxFindDialog;
     FE: TElement;
     C: TCommandLine;
     SL: TStringList;
     FWatches: TWatchForm;
     procedure SetFE(aValue: TElement);
    function GetSyntaxFindDialog: TSyntaxFindDialog;
  protected
     procedure UpdateActions; override;
  public
    procedure RunOil2;
    procedure CheckChanges;
    property  E: TElement read FE write SetFE;
    property  SyntaxFindDialog: TSyntaxFindDialog read GetSyntaxFindDialog;
  end;


implementation

{$R *.DFM}

uses
   CommCtrl,
   Windows,
   IniFiles,
   SysUtils,
   {!t_Main,}
   // KERNEL
   _iniFile,
   Clipbrd,
   u_String,
   Worlds,
   // OIL
   {t_Comp1,}
   t_compil,
   T_Errors,
   Language;


procedure TCommandLineDlg.CheckChanges;
begin
   if SyntaxEdit.Modified then
   if MessageDlg('Text scriptu byl modifikovn ... chcete jej uloit do souboru ?',
      mtConfirmation, [mbYes, mbNo], 0) = mrYes then
   begin
      b_SaveClick(nil);
   end;
end;

procedure TCommandLineDlg.SetFE(aValue: TElement);
begin
   FE := aValue;
   C.ActiveElement := aValue;
end;

procedure TCommandLineDlg.b_EvalClick(Sender: TObject);
var
   S: TStringList;
   SS: string;
   i: integer;
begin
   RMemo.Lines.Clear;
   if SyntaxEdit.Lines.Count = 0 then exit;
   SS := Uppercase(SyntaxEdit.Lines.Strings[0]);
   if pos('PROGRAM',SS) > 0 then
   begin
      RunOil2;
      exit;
   end;
   S := TStringList.Create;
   for i := 0 to SyntaxEdit.Lines.Count - 1 do
   begin
      S.Add(SyntaxEdit.Lines.Strings[i]);
   end;
   C.Line := '';
   C.Lines.Clear;
   C.Lines.Assign(S);
   S.Free;
   C.DoIt;
   S := TStringList.Create;
   if cb_Vycet.Checked then
   begin
      S.Sorted := true;
      S.Duplicates := dupIgnore
   end
   else
   begin
      S.Sorted := false;
      S.Duplicates := dupAccept;
   end;
   S.Assign(C.ResultLines);
   RMemo.Lines.Assign(S);
   S.Free;
   SyntaxEdit.SetFocus;
   if FWatches <> nil then
   begin
      try
         FWatches.Run;
      except
      end;
   end;
end;

procedure TCommandLineDlg.ed_CommandExit(Sender: TObject);
begin
   //b_Eval.SetFocus;
end;

procedure TCommandLineDlg.FormActivate(Sender: TObject);
begin
   inherited;
   //b_Eval.SetFocus;
end;

procedure TCommandLineDlg.ed_CommandKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  {
  l_Col.Caption := IntToStr(Ed_Command.SelStart + 1);
  }
end;

procedure TCommandLineDlg.ed_CommandClick(Sender: TObject);
begin
  {
  Label3.Caption := IntToStr(Ed_Command.SelStart + 1);
  }
end;


procedure TCommandLineDlg.ed_CommandKeyPress(Sender: TObject;
  var Key: Char);
begin
   {
   Label3.Caption := IntToStr(Ed_Command.SelStart + 1);
   }
end;

procedure TCommandLineDlg.Panel2Resize(Sender: TObject);
begin
   //CMemo.Width := Header.Width - 20;
end;

procedure TCommandLineDlg.FormCreate(Sender: TObject);
var
   Ini: TIniFile;
   S: string;
   i: longInt;
begin
   SL := TStringList.Create;
   SL.Duplicates := dupIgnore;
   C := TCommandline.Create;
   Ini := TIniFile.Create(GetModulIniFile);
   Left   := Ini.ReadInteger('OILForm','Left', 0);
   Top    := Ini.ReadInteger('OILFForm','Top', 0);
   Height := Ini.ReadInteger('OILFForm','Height', 200);
   Width  := Ini.ReadInteger('OILFForm','Width', 200);
   OpenDialog.InitialDir := Ini.ReadString('OILFForm','OpenDir', '');
   i := 0;
   repeat
      S := Ini.ReadString('OILFForm',IntToStr(i), '');
      if S <> '' then SL.Add(S);
      inc(i);
   until (S = '') or (i > 9);
   OpenDialog.HistoryList := SL;
   SaveDialog.HistoryList := SL;
   Ini.Free;

   FileNewAction.Execute;
   //FFileFilter := '';
   //SyntaxEdit1.Lines.OnConfirmConversion := ConfirmConversion;

   // reflect current edit options into menu items
   with SyntaxEdit do
   begin
     GroupUndoItem.Checked := eoGroupUndo in Options;
     AutoIndentItem.Checked := eoAutoIndent in Options;
     InsertItem.Checked := eoInserting in Options;
     TabItem.Checked := eoUseTabs in Options;
     SmartItem.Checked := eoSmartTabs in Options;
     OptimalItem.Checked := eoOptimalFill in Options;
     UnindentItem.Checked := eoAutoUnindent in Options;
     CursorTabItem.Checked := eoCursorThroughTabs in Options;
     CursorEOLItem.Checked := eoScrollPastEOL in Options;
     BlanksItem.Checked := eoKeepTrailingBlanks in Options;
     HighlightItem.Checked := eoUseSyntaxHighlighting in Options;
     UndoItem.Checked := eoUndoAfterSave in Options;
     ControlItem.Checked := eoShowControlChars in Options;
     ReadOnlyItem.Checked := eoShowCursorWhileReadOnly in Options;
     NumberItem.Checked := eoLineNumbers in Options;
     HintItem.Checked := eoShowScrollHint in Options;
     TripleItem.Checked := eoTripleClicks in Options;
     HideSelectionItem.Checked := eoHideSelection in Options;
   end;
   UpDown1.Position := SyntaxEdit.CharWidth;
   //SyntaxEdit.Font := SyntaxEdit.Font;
    {
    InitializeFlatSB(RMemo.Handle);
    FlatSB_EnableScrollBar(RMemo.Handle, SB_BOTH, ESB_ENABLE_BOTH);
    FlatSB_SetScrollProp(RMemo.Handle, WSB_PROP_HSTYLE, FSB_FLAT_MODE, True);
    FlatSB_SetScrollProp(RMemo.Handle, WSB_PROP_VSTYLE, FSB_FLAT_MODE, True);
    FlatSB_ShowScrollBar(RMemo.Handle, SB_BOTH, true);
    }
end;

procedure TCommandLineDlg.FormDestroy(Sender: TObject);
begin
   if FSyntaxFindDialog <> nil then
   begin
      FSyntaxFindDialog.Free;
      FSyntaxFindDialog := nil;
   end;
   C.Free;
end;

procedure TCommandLineDlg.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
   Action := caFree;
end;

procedure TCommandLineDlg.b_CloseClick(Sender: TObject);
begin
   Close;
end;

procedure TCommandLineDlg.HeaderSizing(Sender: TObject; ASection,
  AWidth: Integer);
begin
   //CMemo.Width := AWidth;
end;

procedure TCommandLineDlg.b_OpenClick(Sender: TObject);
var
  I: Integer;
  Ext: WideString;

begin
   if OpenDialog.InitialDir = '' then OpenDialog.InitialDir := ExtractFilePath(ParamStr(0));
   if not OpenDialog.Execute then exit;
   OpenDialog.InitialDir := ExtractFilePath(OpenDialog.FileName);
   SaveDialog.InitialDir := ExtractFilePath(OpenDialog.FileName);
   SaveDialog.FileName := OpenDialog.FileName;
   SyntaxEdit.Lines.LoadFromFile(OpenDialog.FileName);
   SyntaxEdit.Info := OpenDialog.FileName;
   SyntaxEdit.Modified := False;
   //if ReadOnly then SyntaxEdit1.Options := SyntaxEdit1.Options + [eoReadOnly];
   StatusBar.Panels[1].Text := '';
   Caption := 'OIL: '+ OpenDialog.FileName;
   // try to find a proper highlighter for the newly loaded file
   //SyntaxEdit.HighLighter := OILHighlighter;
end;
{
   if OpenDialog.InitialDir = '' then OpenDialog.InitialDir := ExtractFilePath(ParamStr(0));
   if OpenDialog.Execute then
   begin
      CMemo.Lines.Clear;
      CMemo.Lines.LoadFromFile(OpenDialog.FileName);
      if SL.Count > 9 then SL.Delete(0);
      SL.Add(OpenDialog.FileName);
      OpenDialog.InitialDir := ExtractFilePath(OpenDialog.FileName);
      OpenDialog.HistoryList := SL;
      SaveDialog.HistoryList := SL;
      Caption := 'OIL: '+ OpenDialog.FileName;
      CMemo.Modified := false;
   end;
   }

procedure TCommandLineDlg.b_OpenRunClick(Sender: TObject);
begin
   //b_OpenClick(nil);
   //b_EvalClick(nil);
end;

procedure TCommandLineDlg.b_SaveClick(Sender: TObject);
begin
   SaveDialog.InitialDir := OpenDialog.InitialDir;
   SaveDialog.FileName   := OpenDialog.FileName;
   if SaveDialog.Execute then
   begin
      SyntaxEdit.Lines.SaveUnicode := false;
      SyntaxEdit.Lines.SaveToFile(SaveDialog.FileName);
      //CMemo.Modified := false;
      if SL.Count > 9 then SL.Delete(0);
      SL.Add(SaveDialog.FileName);
      OpenDialog.HistoryList := SL;
      SaveDialog.HistoryList := SL;
      Caption := 'OIL: '+ SaveDialog.FileName;
      OpenDialog.InitialDir := ExtractFilePath(SaveDialog.FileName);
      OpenDialog.FileName := SaveDialog.FileName;
   end;
end;

procedure TCommandLineDlg.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
var
   Ini: TIniFile;
   i: longInt;
begin
   CheckChanges;
   World.ObjectModel.FreeElement(World.ObjectModel.FindElementName('PROGRAM'));
   if FWatches <> nil then
   begin
      try
         FWatches.Free;
      except
      end;
   end;
   Ini := TIniFile.Create(GetModulIniFile);
   Ini.EraseSection('OILFForm');
   Ini.WriteInteger('OILForm','Left', Left);
   Ini.WriteInteger('OILFForm','Top', Top);
   Ini.WriteInteger('OILFForm','Height', Height);
   Ini.WriteInteger('OILFForm','Width', Width);
   Ini.WriteString('OILFForm','OpenDir', OpenDialog.InitialDir);
   for i := 0 to SL.Count - 1 do
   begin
      Ini.WriteString('OILFForm',IntToStr(i), SL.Strings[i]);
   end;
   Ini.Free;
   SL.Free;
end;

procedure TCommandLineDlg.CMemoKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   //if Key = VK_F9 then b_EvalClick(nil);
end;

procedure TCommandLineDlg.b_WatchesClick(Sender: TObject);
begin
   if FWatches = nil then
   begin
      FWatches:= TWatchForm.Create(Application);
      FWatches.C.ActiveElement := E;
   end
   else
   begin
      try
         FWatches.Free;
         FWatches := nil;
      except
      end;
   end;
end;

procedure TCommandLineDlg.BitBtn1Click(Sender: TObject);
var
   MC: TProgramCompiler;
   S: string;
   SlS: TStringList;
begin
   {
   try
   S := 'PROGRAM';
   World.ObjectModel.FreeElement(World.ObjectModel.FindElementName(S));
   MC := TProgramCompiler.Create;
   MC.Source:=CMemo.Lines;
   MC.DoIt;
   MC.Output.Name := S;
   World.ObjectModel.NextElement := MC.Output;
   except on E:TCompilerError do
      ShowMessage(e.message+' '+inttostr(e.Line)+' '+inttostr(e.Position));
   end;
   MC.Free;
   MC := nil;
   }
end;

procedure TCommandLineDlg.BitBtn2Click(Sender: TObject);
begin
   try
      TOILProgram(World.ObjectModel.FindElementName('PROGRAM')).DoIt;
   except
      ShowMessage('Blbost');
   end;
end;

procedure TCommandLineDlg.RunOil2;
var
   MC: TProgramCompiler;
   S,SS: string;
   CompDone: boolean;
   SL: TStringList;
   i: integer;
begin
   try
   S := 'PROGRAM';
   CompDone := false;
   RMemo.Lines.Add('Compiling...');
   World.ObjectModel.FreeElement(World.ObjectModel.FindElementName(S));
   MC := TProgramCompiler.Create;
   SL := TStringList.Create;
   for i := 0 to SyntaxEdit.Lines.Count - 1 do
   begin
      SL.Add(SyntaxEdit.Lines.Strings[i]);
   end;
   MC.Source:=SL;
   SL.Free;
   MC.DoIt;
   MC.Output.Name := S;
   World.ObjectModel.NextElement := MC.Output;
   CompDone := true;
   except on E:TCompilerError do
      SS := (e.message+' '+inttostr(e.Line)+' '+inttostr(e.Position));
   end;
   MC.Free;
   if not CompDone then
   begin
      RMemo.Lines.Add('    [Error]...'+SS);
      World.ObjectModel.FreeElement(World.ObjectModel.FindElementName(S));
      exit;
   end
   else
   begin
      RMemo.Lines.Add('    [OK]...'+SS);
   end;
   MC := nil;
   CompDone := false;
   RMemo.Lines.Add('Running...');
   try
      TOILProgram(World.ObjectModel.FindElementName('PROGRAM')).DoIt;
      CompDone := true;
   except

   end;
   if CompDone then
      RMemo.Lines.Add('    [OK]...Done')
   else
      RMemo.Lines.Add('    [Error]...!');
end;

procedure TCommandLineDlg.SyntaxEditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   inherited;
   if Key = VK_F9 then FileRUNAction.Execute;
end;

procedure TCommandLineDlg.Button1Click(Sender: TObject);
begin
   b_OpenClick(Sender);
end;

procedure TCommandLineDlg.EditCopyActionExecute(Sender: TObject);
begin
  SyntaxEdit.CopyToClipboard;
end;

procedure TCommandLineDlg.EditCutActionExecute(Sender: TObject);
begin
  SyntaxEdit.CutToClipboard;
end;

procedure TCommandLineDlg.EditPasteActionExecute(Sender: TObject);
begin
  SyntaxEdit.PasteFromClipboard;
end;

procedure TCommandLineDlg.FileOpenActionExecute(Sender: TObject);
begin
   b_OpenClick(nil);
  { from syntax
  with OpenDialog do
  begin
    if Execute then DoLoad(FileName, ofReadOnly in Options);
  end;
  }
end;

procedure TCommandLineDlg.FileSaveActionExecute(Sender: TObject);
begin
   b_SaveClick(nil);
  { from syntax
  if FileExists(SyntaxEdit1.Info) then
  begin
    SyntaxEdit1.Lines.SaveToFile(SyntaxEdit1.Info);
  end
  else FileSaveAsAction.Execute;
  }
end;

procedure TCommandLineDlg.FileCloseActionExecute(Sender: TObject);
begin
  Close;
end;

procedure TCommandLineDlg.FileNewActionExecute(Sender: TObject);
begin
  //SyntaxEdit.Lines.Add(' ... ');
  SyntaxEdit.ClearAll(False, False);
  SyntaxEdit.Info := 'New Document.oil';
  SyntaxEdit.Lines.SaveUnicode := true;
  SyntaxEdit.Modified := False;
  //SyntaxEdit.HighLighter := OILHighlighter;
  Caption := 'New OIL - Editor';
  StatusBar.Panels[1].Text := '';
  StatusBar.Panels[3].Text := '';
end;

procedure TCommandLineDlg.EditUndoActionExecute(Sender: TObject);
begin
  SyntaxEdit.Undo;
end;

procedure TCommandLineDlg.EditRedoActionExecute(Sender: TObject);
begin
  SyntaxEdit.Redo;
end;

procedure TCommandLineDlg.FileSaveAsActionExecute(Sender: TObject);
begin
  { from syntax
  with SaveDialog do
  begin
    if SyntaxEdit1.Info = '' then FileName := 'New document.txt'
                             else FileName := SyntaxEdit1.Info;
    if Execute then
    begin
      SyntaxEdit1.Info := FileName;
      SyntaxEdit1.Lines.SaveToFile(FileName);
      Self.Caption := ExtractFileName(FileName) + ' - Editor';
    end;
  end;
  }
end;

procedure TCommandLineDlg.SearchFindActionExecute(Sender: TObject);
var
  Result: TModalResult;
  CurrentWord: WideString;
  BB, BE: TPoint;
begin
  // the dialog must appear at second place otherwise the edit will be shown modally
  with SyntaxEdit, SyntaxFindDialog do
  begin
    if (Sender as TAction).Tag = 0 then SearchRadioButton.Checked := True;
    if (Sender as TAction).Tag = 1 then ReplaceRadioButton.Checked := True;
    if not SelAvail then
    begin
      GlobalRadioButton.Checked := True;
      CurrentWord := GetWordAndBounds(CaretXY, BB, BE);
      if (BB.X <= CaretX) and (CaretX <= BE.X) then
        if CurrentWord <> '' then FindTextComboBox.Text := CurrentWord;
        // otherwise use last text
    end
    else
    begin
      FindTextComboBox.Text := SelText;
      SelectedRadioButton.Checked := True;
    end;

    Result:= ShowModal;
    if Result <> mrCancel then
    begin
      FLastSearchOptions := [];
      if CaseCheckBox.Checked then Include(FLastSearchOptions, soMatchCase);
      if WholeWordCheckBox.Checked then Include(FLastSearchOptions, soWholeWord);
      if BackwardRadioButton.Checked then Include(FLastSearchOptions, soBackwards);
      if HomeRadioButton.Checked then Include(FLastSearchOptions, soEntireScope);
      if SelectedRadioButton.Checked then Include(FLastSearchOptions, soSelectedOnly);
      if NonSpacingCheckBox.Checked then Include(FLastSearchOptions, soIgnoreNonSpacing);
      if CompressCheckBox.Checked then Include(FLastSearchOptions, soSpaceCompress);
      if RECheckBox.Checked then Include(FLastSearchOptions, soRegularExpression);
      if PromptCheckBox.Checked then Include(FLastSearchOptions, soPrompt);
      if ReplaceRadioButton.Checked then
      begin
        Include(FLastSearchOptions, soReplace);
        if Result = mrYesToAll then Include(FlastSearchOptions, soReplaceAll);
      end;

      if SyntaxEdit.SearchReplace(FindTextComboBox.Text, NewTextComboBox.Text, FLastSearchOptions) = 0 then
        MessageDlg('No further occurence of ''' + FindTextComboBox.Text + ''' found.',
                   mtInformation, [mbOK], 0);
    end;
  end;
end;

procedure TCommandLineDlg.SearchNextActionExecute(Sender: TObject);
begin
  with SyntaxFindDialog do
  begin
    if FindTextComboBox.Text = '' then SearchFindAction.Execute
                                  else
    begin
        // use the same options as before but start at current cursor position
      if SyntaxEdit.SearchReplace(FindTextComboBox.Text, NewTextComboBox.Text,
                                   FLastSearchOptions - [soEntireScope, soSelectedOnly]) = 0 then
        MessageDlg('No further occurence of ''' + FindTextComboBox.Text + ''' found.',
                   mtInformation, [mbOK], 0);
    end;
  end;
end;

procedure TCommandLineDlg.FontActionExecute(Sender: TObject);
begin
  FontDialog.Font := SyntaxEdit.Font;
  if FontDialog.Execute then
  begin
    SyntaxEdit.Font := FontDialog.Font;
    SyntaxEdit.CharWidth := UpDown1.Position;
  end;
end;

procedure TCommandLineDlg.Edit2Change(Sender: TObject);
begin
  SyntaxEdit.CharWidth := UpDown1.Position;
end;

function TCommandLineDlg.GetSyntaxFindDialog: TSyntaxFindDialog;
begin
   if FSyntaxFindDialog = nil then
   begin
      FSyntaxFindDialog := TSyntaxFindDialog.Create(Application);
   end;
   result := FSyntaxFindDialog;
end;

procedure TCommandLineDlg.SyntaxEditCaretChange(Sender: TObject; X,
  Y: Cardinal);
begin
  StatusBar.Panels[0].Text := Format('%d : %d', [Y + 1, X + 1]);
  StatusBar.Update;
  SyntaxEdit.MarkLine := -1;
end;

procedure TCommandLineDlg.SyntaxEditReplaceText(Sender: TObject;
  const Search, Replace: WideString; Line, Start, Stop: Integer;
  var ReplaceAction: TReplaceAction);
begin
  with Sender as TSyntaxEdit do
  begin
    case MessageDlg('Replace this occurence of ''' + Search + '''?', mtConfirmation,
                    [mbYes, mbNo, mbCancel, mbAll], 0) of
      mrCancel:
        ReplaceAction := raCancel;
      mrYes:
        ReplaceAction := raReplace;
      mrYesToAll:
        ReplaceAction := raReplaceAll;
    else
      // no
      ReplaceAction := raSkip;
    end;
  end;
end;

procedure TCommandLineDlg.SyntaxEditSettingChange(Sender: TObject);
begin
  with SyntaxEdit do
    if eoReadOnly in Options then StatusBar.Panels[2].Text := 'Read only'
                             else
      if eoInserting in Options then StatusBar.Panels[2].Text := 'Insert'
                                else StatusBar.Panels[2].Text := 'Overwrite'
end;

procedure TCommandLineDlg.UpdateActions;
const
 ReasonToString: array[TChangeReason] of WideString =
   ('none', 'text insertion', 'text deletion', 'text replacement', 'text movement', 'text copying',
    'cursor movement', 'text overwrite', 'text indentation');

begin
  inherited;
  // misc
  with EditUndoAction do
  begin
    Enabled := SyntaxEdit.CanUndo;
    if not Enabled then Hint := ''
                   else Hint := 'Undo ' + ReasonToString[SyntaxEdit.UndoList.GetCurrentUndoReason];
  end;
  with EditRedoAction do
  begin
    Enabled := SyntaxEdit.CanRedo;
    if not Enabled then Hint := ''
                   else Hint := 'Redo ' + ReasonToString[SyntaxEdit.UndoList.GetCurrentRedoReason];
  end;

  // file
  FileSaveAction.Enabled := SyntaxEdit.Modified;

  // edit
  EditCopyAction.Enabled := SyntaxEdit.SelAvail;
  EditCutAction.Enabled := SyntaxEdit.SelAvail;
  EditPasteAction.Enabled := Clipboard.HasFormat(CF_TEXT) or
                             Clipboard.HasFormat(CF_UNICODETEXT);
  if SyntaxEdit.Modified then StatusBar.Panels[1].Text := 'Modified'
                          else StatusBar.Panels[1].Text := '';
end;

procedure TCommandLineDlg.SyntaxEditDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
   Accept := true;
end;

procedure TCommandLineDlg.OptionMenuClick(Sender: TObject);
begin
  with Sender as TMenuItem do
  begin
    Checked := not Checked;
  end;
  with SyntaxEdit do
  begin
    if UndoItem.Checked then Options := Options + [eoGroupUndo]
                        else Options := Options - [eoGroupUndo];
    if AutoIndentItem.Checked then Options := Options + [eoAutoIndent]
                              else Options := Options - [eoAutoIndent];
    if InsertItem.Checked then Options := Options + [eoInserting]
                          else Options := Options - [eoInserting];
    if TabItem.Checked then Options := Options + [eoUseTabs]
                       else Options := Options - [eoUseTabs];
    if SmartItem.Checked then Options := Options + [eoSmartTabs]
                         else Options := Options - [eoSmartTabs];
    if OptimalItem.Checked then Options := Options + [eoOptimalFill]
                           else Options := Options - [eoOptimalFill];
    if UnindentItem.Checked then Options := Options + [eoAutoUnindent]
                            else Options := Options - [eoAutoUnindent];
    if CursorTabItem.Checked then Options := Options + [eoCursorThroughTabs]
                             else Options := Options - [eoCursorThroughTabs];
    if CursorEOLItem.Checked then Options := Options + [eoScrollPastEOL]
                             else Options := Options - [eoScrollPastEOL];
    if BlanksItem.Checked then Options := Options + [eoKeepTrailingBlanks]
                          else Options := Options - [eoKeepTrailingBlanks];
    if HighlightItem.Checked then Options := Options + [eoUseSyntaxHighlighting]
                             else Options := Options - [eoUseSyntaxHighlighting];
    if UndoItem.Checked then Options := Options + [eoUndoAfterSave]
                        else Options := Options - [eoUndoAfterSave];
    if ControlItem.Checked then Options := Options + [eoShowControlChars]
                           else Options := Options - [eoShowControlChars];
    if ReadOnlyItem.Checked then Options := Options + [eoShowCursorWhileReadOnly]
                            else Options := Options - [eoShowCursorWhileReadOnly];
    if NumberItem.Checked then Options := Options + [eoLineNumbers]
                          else Options := Options - [eoLineNumbers];
    if HintItem.Checked then Options := Options + [eoShowScrollHint]
                        else Options := Options - [eoShowScrollHint];
    if TripleItem.Checked then Options := Options + [eoTripleClicks]
                          else Options := Options - [eoTripleClicks];
    if HideSelectionItem.Checked then Options := Options + [eoHideSelection]
                                 else Options := Options - [eoHideSelection];
  end;
end;

procedure TCommandLineDlg.FileRUNActionExecute(Sender: TObject);
begin
   diode.Color := clRed;
   b_Run.Caption := 'OIL b...';
   b_EvalClick(nil);
   b_Run.Caption := 'Spustit OIL [F9]';
   diode.Color := clLime;
end;

end.

