unit t_FreeNoGeometryElements;

interface
uses
   Tools;
type

TFreeNoGeometryElements = class(TTool)
// Input ... linear entity of TGeometryElement
//       tool will free all elements with no Geometry
public
   procedure DoIt; override;
end;

TRemoveNoGeometryElements = class(TTool)
// Input ... linear entity of TGeometryElement
//       tool will free all elements with no Geometry
public
   procedure DoIt; override;
end;

implementation
uses
   e_Class,
   e_GeometryElement,
   Elements;

{ TFreeNoGeometryElements }

procedure TFreeNoGeometryElements.DoIt;
var
   i: integer;
   E: TEntity;
   El: TElement;
   G: TGeometryElement;
begin
   if Input = nil then exit;
   if not(Input is TEntity) then exit;
   E := TEntity(Input);
   for i := E.LastIndex downto 0 do
   begin
      El := E.Elements[i];
      if not (El is TGeometryElement) then continue;
      G := TGeometryElement(El);
      if G.NoGeometry then
         G.Free;
   end;
end;

{ TRemoveNoGeometryElements }

procedure TRemoveNoGeometryElements.DoIt;
var
   i: integer;
   E: TEntity;
   El: TElement;
   G: TGeometryElement;
begin
   if Input = nil then exit;
   if not(Input is TEntity) then exit;
   E := TEntity(Input);
   for i := E.LastIndex downto 0 do
   begin
      El := E.Elements[i];
      if not (El is TGeometryElement) then continue;
      G := TGeometryElement(El);
      if G.NoGeometry then
         E.RemoveElement(G);
   end;
end;

INITIALIZATION
   RegisterOrbisClass(TFreeNoGeometryElements);
   RegisterOrbisClass(TRemoveNoGeometryElements);
END.
