{ D-}

unit ClipArea;


{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&} interface {&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}
uses
  WinTypes;

{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}

const
{ O.S. Toto platilo pro 16 bitovou verzi !
  MaxWord = 65535-100;
  MaxBufferLen = MaxWord div 4;
}

  MaxNoOfWord = 10000000; { miliarda ... tato konst se zatim nikde jinde nepouziva }
  MaxBufferLen = MaxNoOfWord div 4;




type
  TMaxBuffer = array[0..MaxBufferLen] of WinTypes.TPoint;


  TypSour = integer;

  TBodLPtr = ^TBodL;

  TBodL = record
            X, Y: TypSour
          end;

  TSmer = (SmNekamMimo,
           SmS,  SmJ, SmV, SmZ,
           SmSV, SmSZ, SmJV, SmJZ,
           SmSVV, SmSSV, SmSZZ, SmSSZ,
           SmJVV, SmJJV, SmJZZ, SmJJZ);


  TOrezavacPloch = class
    PodMinX, PodMinY, NadMaxX, NadMaxY: boolean;
    MinX, MinY, MaxX, MaxY: TypSour;

    PrvniPole: boolean;

    Pole1,   Pole2 : pointer; { z pole 1 se cte, do pole 2 se zapisuje }

    BodPtr1, BodPtr2: TBodLPtr;
    Pocet1,  Pocet2: longInt;

    VelikostPole1, VelikostPole2: integer;
    MaxPocetBodu, PocetVynechanychBodu: integer;

    MaloMista: boolean;

    PredX, PredY, PredPredX, PredPredY: TypSour;
    PredSmer: TSmer;

    constructor Create(IRect: TRect;
                       IPole2: pointer; IVelikostPole2: longInt; IPocet2: longInt);


    procedure   Orezavej;
    procedure   DejPoleVelikostAPocet { po Free bude pole smazano !}
                (var Pole: pointer; var Velikost: integer; var Pocet: integer);

    procedure   DejKopiiPoleVelikostAPocet
                (var Pole: pointer; var Velikost: integer; var Pocet: integer);

    procedure   ZrusBuffry;

    destructor  Destroy; override;


    procedure   PridejBodInt(X, Y: TypSour);
    procedure   PrepisBodInt(X, Y: TypSour);
    procedure   SrovnejPocatekAKonec;
    procedure   PrehodPole;

    procedure   DejPrvniBod   (var X, Y: TypSour);
    procedure   DejPosledniBod(var X, Y: TypSour);
    procedure   DejDalsiBod   (var X, Y: TypSour);

    procedure   OrezMinX;
    procedure   OrezMinY;
    procedure   OrezMaxX;
    procedure   OrezMaxY;

  end;






{&&&&&&&&&&&&&&&&&&&&&&&&&}  implementation {&&&&&&&&&&&&&&&&&&&&&&&&&&&&}
{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}

type

  Misto = set of (Vpravo, Vlevo, Nahore, Dole);

{
  PtrRec= record
            ofs, seg: word
          end;
}
  PtrRec= record
            ofs: DWord
          end;

  TPointBufPtr = ^TPoint;


function MyRoundI(Val: double): integer;
begin
  if Val > High(Integer) then Result:= High(Integer)
  else
  if Val < Low(Integer) then Result:= Low(integer)
  else
    Result:= round(Val)
end;



{ ********************    Metody TOrezavacPloch   ******************** }

constructor TOrezavacPloch.Create
            (IRect: TRect;
             IPole2: pointer; IVelikostPole2: longInt; IPocet2: longInt);
var
  I: integer;

begin
  inherited Create;
  Pole2:= IPole2;
  VelikostPole2:= IVelikostPole2;
  Pocet2:= IPocet2;

  MinX:= IRect.Left;
  MinY:= IRect.Top;
  MaxX:= IRect.Right;
  MaxY:= IRect.Bottom;

  PodMinX:= false; PodMinY:= false;
  NadMaxX:= false; NadMaxY:= false;

  for I:= 0 to Pocet2-1 do
  begin
    if TMaxBuffer(Pole2^)[I].X < MinX then PodMinX:= true;
    if TMaxBuffer(Pole2^)[I].Y < MinY then PodMinY:= true;
    if TMaxBuffer(Pole2^)[I].X > MaxX then NadMaxX:= true;
    if TMaxBuffer(Pole2^)[I].Y > MaxY then NadMaxY:= true
  end;

  Pocet1:= 0;

  VelikostPole1:= 0;

  MaloMista:= false;

  Pole1:= nil;

  if Pole2 <> nil then
  begin
    MaxPocetBodu:= VelikostPole2 div (sizeOf(TypSour) * 2);
    pointer(BodPtr2):= Pole2;

    BodPtr1:= nil
  end
  else
  begin
    MaloMista:= true;
    VelikostPole2:= 0
  end;

  VelikostPole1:= 0;

  PredX:= -9999;
  PredY:= -9999;
  PredPredX:= -9998;
  PredPredY:= -9998;
  PredSmer:= SmNekamMimo;

  PocetVynechanychBodu:= 0
end;









procedure   TOrezavacPloch.Orezavej;
begin
  if not MaloMista then
  begin
    PrehodPole;

    if PodMinX and (Pole1 <> nil) then
    begin
      OrezMinX;
      SrovnejPocatekAKonec;
      PrehodPole
    end;
    if PodMinY and (Pole1 <> nil) then
    begin
      OrezMinY;
      SrovnejPocatekAKonec;
      PrehodPole
    end;
    if NadMaxX and (Pole1 <> nil) then
    begin
      OrezMaxX;
      SrovnejPocatekAKonec;
      PrehodPole
    end;
    if NadMaxY and (Pole1 <> nil) then
    begin
      OrezMaxY;
      SrovnejPocatekAKonec;
      PrehodPole
    end
  end;

  if Pole2 <> nil then
     freeMem(Pole2, VelikostPole2);

  Pole2:= nil
end;







procedure   TOrezavacPloch.DejPoleVelikostAPocet
            (var Pole: pointer; var Velikost: integer; var Pocet: integer);
begin
  Pole:= nil;
  if not MaloMista then
  begin
    Pole:= Pole1;
    Velikost:= VelikostPole1;
    Pocet:= Pocet1
  end
  else
  begin
    Pocet:= 0;
    MaloMista:= true;
  end
end;



procedure   TOrezavacPloch.DejKopiiPoleVelikostAPocet
            (var Pole: pointer; var Velikost: integer; var Pocet: integer);
begin
  Pole:= nil;
  Pocet:= 0;
  Velikost:= 0;
  if MaloMista then exit;

  GetMem(Pole, VelikostPole1);

  if Pole = nil then
  begin
    MaloMista:= true;
    exit;
  end;

  Velikost:= VelikostPole1;
  Move(Pole1^, Pole^, Velikost);
  Pocet:= Pocet1
end;





procedure TOrezavacPloch.ZrusBuffry;
begin
  if Pole1 <> nil then
     freeMem(Pole1, VelikostPole1);

  if Pole2 <> nil then
     freeMem(Pole2, VelikostPole2);

  Pole1:= nil;
  Pole2:= nil
end;


destructor TOrezavacPloch.Destroy;
begin
  ZrusBuffry;
  inherited destroy
end;



procedure   TOrezavacPloch.PridejBodInt(X, Y: TypSour);
begin
  if not MaloMista and (Pocet2 < MaxPocetBodu) then
  begin
{
    writeln(PomocnySoubor, Pocet2:4, X:5, Y:5);
}
    BodPtr2^.X:= X;
    BodPtr2^.Y:= Y;
    inc(PtrRec(BodPtr2).ofs, 2*sizeOf(TypSour));
    inc(Pocet2);
  end
  else
    MaloMista:= true
end;




procedure   TOrezavacPloch.PrepisBodInt(X, Y: TypSour);
begin
  if (Pocet2 <= MaxPocetBodu) then
  begin
{
    writeln(PomocnySoubor, Pocet2:4, X:5, Y:5);
}
    dec(PtrRec(BodPtr2).ofs, 2*sizeOf(TypSour));
    dec(Pocet2);
    BodPtr2^.X:= X;
    BodPtr2^.Y:= Y;
    inc(PtrRec(BodPtr2).ofs, 2*sizeOf(TypSour));
    inc(Pocet2);
  end
  else
    MaloMista:= true
end;





{
procedure TOrezavacPloch.PisBuffer;
begin
  if Pole2 <> nil then
  begin
    for I:= 1 to Pocet2 do
    begin
      writeln
    end
  end
end;
}


procedure TOrezavacPloch.SrovnejPocatekAKonec;
var
  PocX, KonX, PocY, KonY: TypSour;
  BodPtr: TBodLPtr;
begin
{ srovnn konce a potku aby i po oezn byly potek a konec toton }
  if Pole2 = nil then exit;
  if Pocet2 < 3 then exit;

  pointer(BodPtr):= Pole2;
  PocX:= BodPtr^.X;
  PocY:= BodPtr^.Y;
  inc(PtrRec(BodPtr).ofs, 2*sizeOf(TypSour));

  pointer(BodPtr):= Pole2;
  inc(PtrRec(BodPtr).ofs, (Pocet2-1) * 2 * sizeOf(TypSour));
  KonX:= BodPtr^.X;
  KonY:= BodPtr^.Y;

  if (PocX <> KonX) or (PocY <> KonY) then
     PridejBodInt(PocX, PocY);
end;





procedure   TOrezavacPloch.PrehodPole;
begin
  if not MaloMista then
  begin
    if Pole1 <> nil then
      freeMem(Pole1, VelikostPole1);

    Pole1 := Pole2;
    pointer(BodPtr1):= Pole1;
    Pocet1:= Pocet2;
    VelikostPole1:= VelikostPole2;

    MaxPocetBodu:= Pocet1;

    { Pocet1 se nasobi dvemi (pokud to jde), aby se tam vesly pripadne
      lomove body vznikle navic pri orezani - napr. cip trojuhelniku
      za roh vyrezu }
    VelikostPole2:= 2*Pocet1 * longInt(sizeOf(TypSour)) * 2;
    {$IFNDEF WIN32}
    if VelikostPole2 > maxAvail then
       VelikostPole2:= maxAvail div 2;
    {$ENDIF}
    MaxPocetBodu:= VelikostPole2 div (longInt(sizeof(TypSour) * 2));

    if VelikostPole2 > 0 then
    begin
      getMem(Pole2, VelikostPole2);

      if Pole2 <> nil then
      begin
        pointer(BodPtr2):= Pole2;
        Pocet2:= 0
      end
      else
      begin
        MaloMista:= true;
        VelikostPole2:= 0
      end
    end
    else
    { nezbyl jiz zadny bod }
    begin
      Pole2:= nil;
      freeMem(Pole1, VelikostPole1);
      Pole1:= nil;
      VelikostPole1:= 0
    end
  end
  else
  begin
    MaloMista:= true;
  end
end;









procedure TOrezavacPloch.DejPrvniBod(var X, Y: TypSour);
begin
  pointer(BodPtr1):= Pole1;
  X:= BodPtr1^.X;
  Y:= BodPtr1^.Y;
  inc(PtrRec(BodPtr1).ofs, 2*sizeOf(TypSour))
end;




procedure TOrezavacPloch.DejPosledniBod(var X, Y: TypSour);
begin
  pointer(BodPtr1):= Pole1;
  inc(PtrRec(BodPtr1).ofs, (Pocet1-1) * 2 * sizeOf(TypSour));
  X:= BodPtr1^.X;
  Y:= BodPtr1^.Y
end;




procedure TOrezavacPloch.DejDalsiBod(var X, Y: TypSour);
begin
  X:= BodPtr1^.X;
  Y:= BodPtr1^.Y;
  inc(PtrRec(BodPtr1).ofs, 2*sizeOf(TypSour))
end;






procedure   TOrezavacPloch.OrezMinX;
var
  V1X, V1Y, V2X, V2Y, PX, PY: TypSour;
  J: integer;

begin
  DejPosledniBod(V1X, V1Y);
  DejPrvniBod(V2X, V2Y);
  for J:= 1 to Pocet1 do
  begin
    if V2X >= MinX then
      if V1X >= MinX then PridejBodInt(V2X, V2Y)
      else
      begin
        PY:= MyRoundI(1.0 * (MinX - V1X) * (V2Y - V1Y)/(V2X - V1X) + V1Y);
        PX:= MinX;
        PridejBodInt(PX, PY);
        PridejBodInt(V2X, V2Y)
      end
    else
    if V1X >= MinX then
    begin
      PY:= MyRoundI(1.0 * (MinX - V1X) * (V2Y - V1Y)/(V2X - V1X) + V1Y);
      PX:= MinX;
      PridejBodInt(PX, PY)
    end;

    V1X:= V2X; V1Y:= V2Y;

    if J < Pocet1 then DejDalsiBod(V2X, V2Y)
  end
end;






procedure   TOrezavacPloch.OrezMinY;
var
  V1X, V1Y, V2X, V2Y, PX, PY: TypSour;
  J: integer;

begin
  DejPosledniBod(V1X, V1Y);
  DejPrvniBod(V2X, V2Y);
  for J:= 1 to Pocet1 do
  begin
    if V2Y >= MinY then
      if V1Y >= MinY then PridejBodInt(V2X, V2Y)
      else
      begin
        PX:= MyRoundI(1.0 * (MinY - V1Y) * (V2X - V1X)/(V2Y - V1Y) + V1X);
        PY:= MinY;
        PridejBodInt(PX, PY);
        PridejBodInt(V2X, V2Y)
      end
    else
    if V1Y >= MinY then
    begin
      PX:= MyRoundI(1.0 * (MinY - V1Y) * (V2X - V1X)/(V2Y - V1Y) + V1X);
      PY:= MinY;
      PridejBodInt(PX, PY)
    end;

    V1X:= V2X; V1Y:= V2Y;

    if J < Pocet1 then DejDalsiBod(V2X, V2Y)
  end
end;







procedure   TOrezavacPloch.OrezMaxY;
var
  V1X, V1Y, V2X, V2Y, PX, PY: TypSour;
  J: integer;

begin
  DejPosledniBod(V1X, V1Y);
  DejPrvniBod(V2X, V2Y);
  for J:= 1 to Pocet1 do
  begin
    if V2Y <= MaxY then
      if V1Y <= MaxY then PridejBodInt(V2X, V2Y)
      else
      begin
        PX:= MyRoundI(1.0 * (MaxY - V1Y) * (V2X - V1X)/(V2Y - V1Y) + V1X);
        PY:= MaxY + 1;
        PridejBodInt(PX, PY);
        PridejBodInt(V2X, V2Y)
      end
    else
    if V1Y <= MaxY then
    begin
      PX:= MyRoundI(1.0 * (MaxY - V1Y) * (V2X - V1X)/(V2Y - V1Y) + V1X);
      PY:= MaxY + 1;
      PridejBodInt(PX, PY)
    end;

    V1X:= V2X; V1Y:= V2Y;

    if J < Pocet1 then DejDalsiBod(V2X, V2Y)
  end
end;



procedure   TOrezavacPloch.OrezMaxX;
var
  V1X, V1Y, V2X, V2Y, PX, PY: TypSour;
  J: integer;

begin
  DejPosledniBod(V1X, V1Y);
  DejPrvniBod(V2X, V2Y);
  for J:= 1 to Pocet1 do
  begin
    if V2X <= MaxX then
      if V1X <= MaxX then PridejBodInt(V2X, V2Y)
      else
      begin
        PY:= MyRoundI(1.0 * (MaxX - V1X) * (V2Y - V1Y)/(V2X - V1X) + V1Y);
        PX:= MaxX;
        PridejBodInt(PX, PY);
        PridejBodInt(V2X, V2Y)
      end
    else
    if V1X <= MaxX then
    begin
      PY:= MyRoundI(1.0 * (MaxX - V1X) * (V2Y - V1Y)/(V2X - V1X) + V1Y);
      PX:= MaxX;
      PridejBodInt(PX, PY)
    end;

    V1X:= V2X; V1Y:= V2Y;

    if J < Pocet1 then DejDalsiBod(V2X, V2Y)
  end
end;



{ ********************   konec metod TOrezavacPloch   ******************** }


(*
procedure ClipPolygon(Rect: TRect;
                      var Buffer: pointer;
                      var BufferSize: word; var PointNo: integer);
var
  Orezavac: TOrezavacPloch;

begin
  Orezavac:= TOrezavacPloch.Create
  Orezavac.Init(Rect, Buffer, BufferSize, PointNo);
  Orezavac.Orezavej;
  Orezavac.DejPoleVelikostAPocet(Buffer, BufferSize, PointNo);
  Orezavac.Free
end;

*)

(*

procedure VypisBuffer
          (LSPtr: TPointBufPtr; PocetBodu: integer);

var
  I: longInt;
  LS: pointType;  { LS ... lokalni souradnice }
  F: text;

begin
  assign(F, 'BUFFER.TXT');
  rewrite(F);

  for I:= 1 to PocetBodu do
  begin
    LS:= LSPtr^;

    writeln(F, I:3, ':',LS.X:6, LS.Y:6);

    inc(PtrRec(LSPtr).ofs, 4);
  end;

  close(F)
end;
*)














end.
