unit F_color;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls,
  e_Pale, Grids, Spin;

type
  TFormColor = class(TForm)
    ColorDialog1: TColorDialog;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    ColorDialog2: TColorDialog;
    DG: TStringGrid;
    Panel1: TPanel;
    b_Orig: TButton;
    b_Load: TButton;
    b_Save: TButton;
    b_Cancel: TBitBtn;
    b_OK: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    ed_R: TSpinEdit;
    ed_G: TSpinEdit;
    ed_B: TSpinEdit;
    cb_63: TCheckBox;
    ed_CCount: TSpinEdit;
    Label4: TLabel;
    b_CCountOK: TButton;
    l_Modified: TLabel;
    procedure S0MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure b_LoadClick(Sender: TObject);
    procedure b_SaveClick(Sender: TObject);
    procedure b_OrigClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure DGDrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect;
      State: TGridDrawState);
    procedure DGMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DGMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ed_CCountChange(Sender: TObject);
    procedure DGSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure ed_RChange(Sender: TObject);
    procedure b_OKClick(Sender: TObject);
  private
    FPalette: TColorPalette;
    FModified: boolean;
    FPaletteFileName: string;
    FSelecti: integer;
    FRGBAllow: boolean;
    { Private declarations }
    procedure SetShape(I, R, G, B: integer);
    procedure GetShape(I: integer; var R, G, B: longInt);
    procedure SetPalette(const Value: TColorPalette);
    procedure SetModified(const Value: boolean);
    procedure SetPaletteFileName(const Value: string);
    procedure SetSelecti(const Value: integer);
  public
    { Public declarations }
     FColors: Array of integer;
     property Palette: TColorPalette read FPalette write SetPalette;
     property PaletteFileName: string read FPaletteFileName write SetPaletteFileName;
     property Modified: boolean read FModified write SetModified;
     property Selecti: integer read FSelecti write SetSelecti;
  end;

implementation

{$R *.DFM}
uses
  u_String,
  E_Color,
  Elements;



procedure TFormColor.S0MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  {
  if Sender is TShape then
  begin
    ColorDialog1.Color:= TShape(Sender).Brush.Color;
    if ColorDialog1.Execute then
       TShape(Sender).Brush.Color:= ColorDialog1.Color
  end;
  }
end;


procedure TFormColor.GetShape(I: integer; var R, G, B: longInt);
var
  Barva: longInt;
begin
  Barva := 0;
  {
  case I of
  0: Barva:= S0.Brush.Color;
  1: Barva:= S1.Brush.Color;
  2: Barva:= S2.Brush.Color;
  3: Barva:= S3.Brush.Color;
  4: Barva:= S4.Brush.Color;
  5: Barva:= S5.Brush.Color;
  6: Barva:= S6.Brush.Color;
  7: Barva:= S7.Brush.Color;
  8: Barva:= S8.Brush.Color;
  9: Barva:= S9.Brush.Color;
  10: Barva:= S10.Brush.Color;
  11: Barva:= S11.Brush.Color;
  12: Barva:= S12.Brush.Color;
  13: Barva:= S13.Brush.Color;
  14: Barva:= S14.Brush.Color;
  15: Barva:= S15.Brush.Color
  end;

  R:= (Barva mod 256) div 4;
  Barva:= Barva div 256;
  G:= (Barva mod 256) div 4;
  Barva:= Barva div 256;
  B:= Barva div 4
  }
end;



procedure TFormColor.SetShape(I, R, G, B: integer);
var
  Barva: longInt;

begin
  {
  R:= R*4;
  if R>128 then R:= R+3;
  G:= G*4;
  if G>128 then G:= G+3;
  B:= B*4;
  if B>128 then B:= B+3;

  Barva:=  RGB(R, G, B);
  case I of
  0:  S0.Brush.Color := Barva;
  1:  S1.Brush.Color := Barva;
  2:  S2.Brush.Color := Barva;
  3:  S3.Brush.Color := Barva;
  4:  S4.Brush.Color := Barva;
  5:  S5.Brush.Color := Barva;
  6:  S6.Brush.Color := Barva;
  7:  S7.Brush.Color := Barva;
  8:  S8.Brush.Color := Barva;
  9:  S9.Brush.Color := Barva;
  10: S10.Brush.Color:= Barva;
  11: S11.Brush.Color:= Barva;
  12: S12.Brush.Color:= Barva;
  13: S13.Brush.Color:= Barva;
  14: S14.Brush.Color:= Barva;
  15: S15.Brush.Color:= Barva;
  end
  }
end;



procedure TFormColor.b_LoadClick(Sender: TObject);
var
  F: system.text;
  R, G, B, I: longInt;
  S: string;
  aPale: TColorPalette;
  Barva: integer;
begin
  OpenDialog1.Filter := 'PALETA.TXT|PALETA.TXT|Texty (*.TXT)|*.TXT';

  if OpenDialog1.Execute then
  begin
    system.assign(F, OpenDialog1.FileName);
    {$I-} system.reset(F) {$I+};
    if ioResult = 0 then
    begin
      PaletteFileName:= OpenDialog1.FileName;
      aPale := TColorPalette.Create;
      while not EOF(F) do
      begin
       {$I-} readln(F,R,G,B,S); {$I+}
       if ioResult = 0 then
       begin
          R:= R*4;
          if R>128 then R:= R+3;
          G:= G*4;
          if G>128 then G:= G+3;
          B:= B*4;
          if B>128 then B:= B+3;
          Barva:=  RGB(R, G, B);
          if S = '' then
             S := IntToStr(Barva);
          aPale.AddColorName(Barva,S);
       end;
      end;
      system.close(F);
      SetLength(FColors,aPale.Count);
      DG.RowCount := aPale.Count;
      for i := 0 to aPale.LastIndex do
      begin
         FColors[i] := aPale.Color[i];
         DG.Cells[0,i] := IntToStr(i);
         DG.Cells[2,i] := aPale.Elements[i].Name;
      end;
      Modified := false;
      aPale.Free;
      DG.Repaint;
    end
  end;
end;



procedure TFormColor.b_SaveClick(Sender: TObject);
var
  F: system.text;
  R, G, B, I: Integer;
  Barva: integer;
  S: string;
  Nazev: string;
begin
  SaveDialog1.Filter := 'PALETA.TXT|PALETA.TXT|Texty (*.TXT)|*.TXT';
  if PaletteFileName = '' then
  begin
     SaveDialog1.InitialDir := GetAbsolutePath('');
     SaveDialog1.FileName := 'Paleta.txt';
  end
  else
  begin
     SaveDialog1.InitialDir := ExtractFilePath(PaletteFileName);
     SaveDialog1.FileName := ExtractFileName(PaletteFileName);
  end;
  if SaveDialog1.Execute then
  begin
    Nazev:= SaveDialog1.FileName;
    if Nazev <> '' then
    begin
      system.assign(F, Nazev);
      {$I-} system.rewrite(F) {$I+};
      if ioResult = 0 then
      begin
        //PaletFile:= OpenDialog1.FileName;
        PaletteFileName := Nazev;
        for I:= 0 to DG.RowCount - 1 do
        begin
           Barva := FColors[i];
           R:= (Barva mod 256) div 4;
           Barva:= Barva div 256;
           G:= (Barva mod 256) div 4;
           Barva:= Barva div 256;
           B:= Barva div 4;
           S := DG.Cells[2,i];
           if S = '' then
              S := IntToStr(i)+' '+IntToStr(Barva);
         {$I-} writeln(F, R:3, ' ', G:3, ' ', B:3, ' ', S); {$I+}
        end;
        system.close(F);
        Modified := false;
      end
    end
  end;
end;

procedure TFormColor.b_OrigClick(Sender: TObject);
var
   i: integer;
begin
   PaletteFileName := '';
   SetLength(FColors,16);
   DG.RowCount := 16;
   for i := 0 to 15 do
   begin
      FColors[i] := OrigColorTab[i];
      DG.Cells[2,i] := 'Color '+IntToStr(i);
   end;
   DG.Repaint;
   Modified := false;
end;

procedure TFormColor.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   if Key = VK_F1 then Application.HelpJump(ClassName+'_'+ActiveControl.Name);
end;

procedure TFormColor.SetPalette(const Value: TColorPalette);
var
   i: integer;
begin
    FPalette := Value;
    if Value = nil then exit;
    DG.RowCount := Value.Count;
    SetLength(FColors,Value.Count);
    for i := 0 to Value.LastIndex do
    begin
       FColors[i] := Value.Color[i];
       DG.Cells[0,i] := IntToStr(i);
       DG.Cells[2,i] := Value.Elements[i].Name;
    end;
end;

procedure TFormColor.SetModified(const Value: boolean);
begin
   if FModified = Value then exit;
   FModified := Value;
   l_Modified.Visible := Value;
end;

procedure TFormColor.DGDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
begin
   DG.Canvas.Pen.Style := psSolid;
   if gdFocused in State then
   begin
      DG.Canvas.Pen.Width := 2;
      DG.Canvas.Pen.Color := 255;
   end
   else
   begin
      DG.Canvas.Pen.Width := 0;
      DG.Canvas.Pen.Color := $A0A0A0;
   end;
   if aCol = 1 then
   begin
      DG.Canvas.Brush.Style := bsSolid;
      DG.Canvas.Brush.Color := FColors[aRow];
      DG.Canvas.Rectangle(Rect);
   end
   else
   begin
      DG.Canvas.Brush.Style := bsClear;
      DG.Canvas.Rectangle(Rect);
   end;
end;

procedure TFormColor.SetPaletteFileName(const Value: string);
begin
  FPaletteFileName := Value;
  if Value = '' then
     Caption := 'Color palette'
  else
     Caption := Value;   
end;

procedure TFormColor.DGMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
   aCol,aRow: integer;
begin
   DG.MouseToCell(X,Y,aCol,aRow);
   if aCol <> 1 then exit;
    ColorDialog1.Color:= FColors[aRow];
    if ColorDialog1.Execute then
    begin
       FColors[aRow]:= ColorDialog1.Color;
       Modified := true;
       DG.Repaint;
    end;
end;

procedure TFormColor.DGMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
   aCol,aRow: integer;
begin
   DG.MouseToCell(X,Y,aCol,aRow);
   if aCol = 2 then
   begin
      if not (goEditing in DG.Options) then
         DG.Options := DG.Options + [goEditing];
   end
   else
   begin
      if goEditing in DG.Options then
         DG.Options := DG.Options - [goEditing];
   end;
end;

procedure TFormColor.ed_CCountChange(Sender: TObject);
begin
   b_CCountOK.Visible := ed_CCount.Value <> DG.RowCount;
end;

procedure TFormColor.DGSelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);
var
   C: integer;
begin
   FRGBAllow := false;
   Selecti := ARow;
   C := FColors[ARow];
   ed_R.Value := GetRValue(C);
   ed_G.Value := GetGValue(C);
   ed_B.Value := GetBValue(C);
   FRGBAllow := true;
end;

procedure TFormColor.ed_RChange(Sender: TObject);
var
   i,R,G,B,C: integer;
begin
   if not FRGBAllow then exit;
   i := DG.Selection.Left;
   i := Selecti;
   if (i < 0) or (i > DG.RowCount - 1) then exit;
   C := RGB(ed_R.Value,ed_G.Value,ed_B.Value);
   FColors[i] := C;
   Modified := true;
   DG.Repaint;
end;

procedure TFormColor.SetSelecti(const Value: integer);
begin
  FSelecti := Value;
end;

procedure TFormColor.b_OKClick(Sender: TObject);
begin
   if not Modified then exit;
   if MessageDlg('Paleta byla zmnna - uloit?',
      mtConfirmation, [mbYes, mbNo], 0) = mrYes then
      b_SaveClick(nil);
end;

end.
