unit Mathlib;




{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&} interface {&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}

uses
//   WinTypes,
   Types,
// GLIB
   g_Elems;

{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}




type
  TBytePtr    = ^byte;
  TWordPtr    = ^word;
  TIntegerPtr = ^integer;
  TLongIntPtr = ^longInt;
  TRealPtr    = ^real48;
  TBooleanPtr = ^boolean;



  TIntObdelnikPtr = ^TIntObdelnik;
  TIntObdelnik    = record
    LH: TPoint;
    PD: TPoint;
  end;

  PSour = ^TSour;
  TSour = record
    Y, X: double;
  end;


  PObdelnik = ^TObdelnik;
  TObdelnik = record
    PH: TSour;
    LD: TSour
  end;




  PVektor = ^TVektor;
  TVektor = record
    X, Y, Modul: real48
  end;
  TSourSystem = (JTSK, Gauss, Matematicky);

const

  SizeSour = sizeOf(TSour);

  SourSystem = Matematicky;


const
  MaxL =  2147483647;
  MinL = -2147483647;
  MaxI = 32767;
  MinI = -32768;
  MaxW = 65535;

  MaxAlok = 65528;

  PiPul = 3.1415926535897932385/2;
  DvaPi = 2*3.1415926535897932385;

(*
  Obd00: TIntObdelnik = (
                         LH: (X:0; Y:0);
                         PD: (X:0; Y:0)
                        );

{$IFDEF WINDOWS}
  ObdR00: TObdelnik = (
                       PH: (Y:0; X:0);
                       LD: (Y:0; X:0)
                      );
{$ELSE}
  Port00: viewPortType = (
                          x1  : 0;
                          y1  : 0;
                          x2  : 0;
                          y2  : 0;
                          clip: clipOn
                         );

{$ENDIF}
*)
  VektorNula = 1E-4;
  VolnaNula  = VektorNula*2;
  PrisnaNula = VektorNula/10;

  ObdelnikCSFR: TObdelnik = (PH: (Y: 150000; X:  920000);
                             LD: (Y: 925000; X: 1340000));

  ObdelnikInM: TObdelnik = (PH: (Y: 1500000; X:  5000);
                            LD: (Y: 1000000; X:  1000));

  ObdelnikInG: TObdelnik = (PH: (Y: 500000; X:  500000);
                            LD: (Y: 100000; X:  100000));


  Obdelnik00: TObdelnik = (PH: (Y: 0; X: 0);
                           LD: (Y: 0; X: 0));

function AlokSize (Size: longInt): longInt;


procedure XYToPolar(A,B: TDoubleCoord; var Length: double;var Angle: double);


function MinWord (X, Y: word)   : word;
function MaxWord (X, Y: word)   : word;
function MinLong (X, Y: longInt): longInt;
function MaxLong (X, Y: longInt): longInt;
function MinReal (X, Y: real48)   : real48;
function MaxReal (X, Y: real48)   : real48;

function ATan2G (DeltaVodorovne, DeltaSvisle: real48): real48;
{Vraci orientovany uhel od svisle osy ve smeru hodin z intervalu <0, 2Pi)
hodnotu DvaPi vraci len v pripade, ze oba vstupni parametre = 0 - je to chyba!}

function ATan2M (DeltaVodorovne, DeltaSvisle: double): double;
{Vraci orientovany uhel od vodorovne osy proti smeru hodin z intervalu <0, 2Pi)
hodnotu 2Pi vraci len v pripade, ze oba vstupni parametre = 0 - je to chyba!}



function NormUhel (Uhel: real48): real48;

function Angle22PI(Angle: double): double;

function DejRadZeStupnu    (UhelVeStu: real48)   : real48;
function DejRadZGradu      (UhelVGrad: real48)   : real48;
function DejRadZeStuMinSek (Stupne   : longInt;
                            Minuty   : longInt;
                            Sekundy  : longInt): real48;


function DejGrady       (UhelVRad: real48): real48;
function DejStupne      (UhelVRad: real48): real48;
procedure VratStuMinSek (UhelVRad: real48;
                     var Stupne  : longInt;
                     var Minuty  : longInt;
                     var Sekundy : longInt
                        );

procedure VratStuMinRSek (UhelVRad: real48;
                      var Stupne  : longInt;
                      var Minuty  : longInt;
                      var Sekundy : real48
                        );




function BodVpravoOdOrientPrimky (A, B, C: TDoubleCoord): boolean;

function CoordBodVpravoOdOrientPrimky (AA, BB, CC: T2DCoordinate): boolean;


function Acos (x: real48): real48;

procedure DelejVektor (
                       PocBod : TSour;
                       KoncBod: TSour;

                   var Vektor : TVektor
                      );

function Uhel2Vektoru (V1, V2: TVektor): real48;

function Uhel2Usecek (A, B, C: TDoubleCoord): double;
function CoordUhel2Usecek (AA, BB, CC: T2DCoordinate): double;

procedure VratPosunutyBod (Bod  : TDoubleCoord;
                           Uhel : double;
                           Draha: double;
                       var PosunutyBod: TDoubleCoord);

function GetRotatedCrd(CenterCrd, RotatedCrd: TDoubleCoord;
                       Angle: double): TDoubleCoord;



function DecTrunc(X: real48): real48;
{ Vraci X zaokrouhlene na nejblizsi nizsi mocninu 10 }

procedure Swap(var X, Y: double);
{ prohodi X a Y }

procedure Order(var X, Y: double);
{usporada X,Y vzestupne}

procedure SwapLInt (var X, Y: longInt);

procedure OrderLInt (var X, Y: longInt);

procedure SwapInt (var X, Y: integer);

procedure OrderInt (var X, Y: integer);

function ShodneHodnoty(X, Y, Tolerance: real48): boolean;


function VyskaObdelniku(Obdelnik: TObdelnik): real48;

function SirkaObdelniku(Obdelnik: TObdelnik): real48;







function PrekryvOO     (OO1, OO2: TIntObdelnik)                : boolean;
function BodVIObdelniku (Bod: TPoint; Obdelnik: TIntObdelnik): boolean;
function XYVObdelniku  (X, Y: integer; Obdelnik: TIntObdelnik): boolean;


function BodVObdelnikuSouradnicemi
         (SourB, SourO1, SourO2: TSour; Kriterium: real48): boolean;
function BodVObdelniku
         (Sour: TSour; const Obdelnik: TObdelnik; Kriterium: real48): boolean;
function BodYXVObdelniku
         (Y, X: real48; Obdelnik: TObdelnik; Kriterium: real48): boolean;


function RectanglesOverlay(aX1, aY1, aX2, aY2, bX1, bY1, bX2, bY2, Tolerance: double): boolean;

function PrekryvObdelniku(const Obdelnik1, Obdelnik2: TObdelnik;
                                           Kriterium: real48): boolean;
function PrekryvObdelnikuSouradnicemi
         (SourA1, SourA2, SourB1, SourB2: TDoubleCoord; Kriterium: double): boolean;

function CoordPrekryvObdelnikuSouradnicemi( SourAA1, SourAA2:T2DCoordinate;
                                            SourB1, SourB2: TDoubleCoord;
                                            Kriterium : double): boolean;

function ObdelnikUvnitrObdelniku
         (const Obdelnik1, Obdelnik2: TObdelnik; Kriterium: real48): boolean;

function ShodneObdelniky
         (const Obdelnik1, Obdelnik2: TObdelnik; Kriterium: real48): boolean;

procedure VratStred(const Obdelnik: TObdelnik; var SourStredu: TSour);


procedure IniOpObdelnik(var OpObdelnik: TObdelnik);

procedure NastavMaxObdelnik(var Obdelnik: TObdelnik);

function  JeToMaxObdelnik(const Obdelnik: TObdelnik): boolean;

function  DobryObdelnik(const Obdelnik: TObdelnik): boolean;

function  BodovyObdelnik(Obdelnik: TObdelnik): boolean;

procedure NastavObdelnikCSFR(var Obdelnik: TObdelnik);

procedure ZvetsiObdelnikDoStran(var Obdelnik: TObdelnik; Pridavek: real48);

function  NastavenObdelnikCSFR(Obdelnik: TObdelnik): boolean;

procedure AktualizaceOpObdelnika(Y, X: real48; var OpObdelnik: TObdelnik);

procedure AktualizaceObdelnikemOpObdelnika(Obdelnik: TObdelnik;
                                           var OpObdelnik: TObdelnik);


function VzdalenostBodu(Sour1, Sour2: TSour): real48;
function Distance(X1, Y1, X2, Y2: double): double;
function InTolerance(X1, Y1, X2, Y2, Tolerance: double): boolean;

procedure DejStred(Sour1, Sour2: TSour; var Stred: TSour);

procedure GiveAbscPointByLength(X1, Y1, X2, Y2, Length, RoundKoef: double;
                                var Xp, Yp: double);


procedure PrusecikUsecek(
                             Ya1,Xa1,  Yb1,Xb1,   Ya2,Xa2,  Yb2,Xb2: double;
                         var Yp, Xp                                : double;
                         var Rovnobezky, Uvnitr1, Uvnitr2          : boolean);

function ProtnutyUsecky
         (XA1,YA1,  XB1,YB1,    XA2,YA2,  XB2,YB2: double): boolean;




{
function  ExistujePrusecikPrimek (A, B, C, D: TSour; var P: TSour): boolean;
}

function BodJeMeziBody(BodX, BodY, AX, AY, BX, BY: double): boolean;

function BodLeziNaUsecce(XB,YB,X1,Y1,X2,Y2: double): boolean;

procedure DejPatuKolmice(
                             AX, AY, BX, BY, MX, MY: double;
                         var PX, PY      : double);

procedure DejVztahyBod_Usecka(
                                  BodX, BodY, AX, AY,  BX, BY: double;
                              var PataKolmiceJeUvnitrUsecky: boolean;
                              var PataX, PataY              : double;
                              var VzdalenostBoduOdPrimky   : double);

{
function ExistujePrusecikUsecek (A, B, C, D: TSour; var P: TSour): boolean;
}
function TotozneBody (A, B: TSour): boolean;
function IdentickeBody       (A, B: TSour): boolean;
function VolneIdentickeBody  (A, B: TSour): boolean;
function PrisneIdentickeBody (A, B: TSour): boolean;

function EqualPoints(X1, Y1, X2, Y2: double): boolean;

function RealneIdentickeBody (A, B: TSour): boolean;

function ObdelnikRovnaSeObdelniku
         (Obdelnik1, Obdelnik2: TObdelnik; Kriterium: real48): boolean;


function MyRoundI (R:real48): integer;
function MyRoundL (R:real48): longInt;
function CutRealE20 (R:real48): real48;


function Tan (Uhel: real48): real48;



(*
procedure DoplnTriVrcholyKosodelnika (LD, SmerBod: TSour;
                           Sirka,  Vyska, UhelSkl  : real48;

                       var LH, PH, PD: TSour);


*)

{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&} implementation {&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}

{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}


function Angle22PI(Angle: double): double;
var
   D: double;
   DvaPI: double;
begin
   D := Abs(Angle);
   DvaPI := PI*2;
   if D > DvaPi then D := D-(Int(D/DvaPi)*DvaPi);
   if Angle < 0 then
      D := DvaPI - D;
   result := D;
end;

procedure XYToPolar(A,B: TDoubleCoord; var Length: double;var Angle: double);
var
  dX,dY: double;
  PomR : double;
begin
   dX := B.x - A.x;
   dY := B.y - A.y;
   begin
      if dX = 0 then
      begin
         if not(dY < 0) then
           Angle := PI/2
         else
           Angle := 1.5*PI;
         Length := Abs(dY);
      end
      else
      begin
         if dY < 0 then
         begin
            if dX < 0 then PomR := PI
                      else PomR := 0;
         end
         else
         begin
            if dX > 0 then PomR := 0
                      else PomR := PI;
         end;
         Angle  := ArcTAN(dY/dX);
         Angle  := PomR + Angle;
         Length := SQRT(SQR(dY)+SQR(dX));
      end;
   end;
end;




function AlokSize (Size: longInt): longInt;
begin
  AlokSize := Size +7 div 8 * 8;
end;



function MinWord(X, Y: word): word;
begin
  if x < y then MinWord:=x
  else MinWord:=y;
end;

function MaxWord(X, Y: word): word;
begin
  if x > y then MaxWord:=x
  else MaxWord:=y;
end;

function MinLong(X, Y: LongInt): LongInt;
begin
  if x < y then MinLong:=x
  else MinLong:=y;
end;

function MaxLong(X, Y: LongInt): LongInt;
begin
  if x > y then MaxLong:=x
  else MaxLong:=y;
end;


function MinReal(X, Y: real48): real48;
begin
  if x < y then MinReal:=x
  else MinReal:=y;
end;





function MaxReal (X, Y: real48): real48;
begin
  if X > Y
  then MaxReal := X
  else MaxReal := Y;
end;





function MyRoundI (R:real48): integer;
const
  MinInt = -16300;
  MaxInt =  16300;
begin
  if R > MaxInt
  then MyRoundI := MaxInt
  else
  if R < MinInt
  then MyRoundI := MinInt
  else MyRoundI := round (R);
end;






function MyRoundL (R:real48): longInt;
const
  MinLInt =  -2000000000;   {-2147483648..2147483647}
  MaxLInt =   2000000000;

begin
  if R > MaxLInt
  then MyRoundL := MaxLInt
  else
  if R < MinLInt
  then MyRoundL := MinLInt
  else MyRoundL := round (R);
end;






function CutRealE20 (R:real48): real48;
const
  MinReal =  -1E20;
  MaxReal =  +1E20;

begin
  if R > MaxReal
  then CutRealE20 := MaxReal
  else
  if R < MinReal
  then CutRealE20 := MinReal
  else CutRealE20:= R
end;













function Tan (Uhel: real48): real48;
var
  Pom: real48;
begin
  Pom := cos (Uhel);

  if abs(Pom) < 1E-20
  then Tan := 1E20
  else Tan := sin(Uhel)/Pom;
end;






function ATan2G (DeltaVodorovne, DeltaSvisle: real48): real48;
var
  A: real48;

begin
  if DeltaVodorovne = 0
  then begin
    if DeltaSvisle = 0
    then ATan2G := DvaPi
    else begin
      if DeltaSvisle < 0
      then ATan2G := pi
      else ATan2G := 0;
    end;
  end
  else begin
    A := PiPul -arcTan (DeltaSvisle/DeltaVodorovne);

    if DeltaVodorovne < 0 then A := A +pi;

    if A < DvaPi
    then ATan2G := A
    else ATan2G := A -DvaPi
  end;
end;








function ATan2M (DeltaVodorovne, DeltaSvisle: double): double;
var
  A: double;

begin
  if DeltaVodorovne = 0
  then begin
    if DeltaSvisle = 0
    then A := 0
    else A := abs (DeltaSvisle)/DeltaSvisle*pi/2;
  end
  else A := arcTan (DeltaSvisle/DeltaVodorovne);

  if DeltaVodorovne < 0
  then A := A +pi
  else A := A +2*pi;

  if A > 2*Pi
  then ATan2M := A -2*Pi
  else ATan2M := A;
end;







(*


function ATan2M (DeltaVodorovne, DeltaSvisle: real48): real48;
var
  A: real48;

begin
  if DeltaVodorovne = 0
  then begin
    if DeltaSvisle = 0
    then ATan2M := DvaPi
    else begin
      if DeltaSvisle < 0
      then ATan2M := DvaPi -PiPul
      else ATan2M := PiPul;
    end;
  end
  else begin
    A := pi +arcTan (DeltaSvisle/DeltaVodorovne);

    if DeltaVodorovne > 0 then A := A +pi;

    if A < DvaPi
    then ATan2M := A
    else ATan2M := A -DvaPi;
  end;
end;




*)





function NormUhel (Uhel: real48): real48;
begin
  Uhel := Uhel -DvaPi*int(Uhel/DvaPi);

  if Uhel < 0
  then NormUhel := DvaPi +Uhel
  else NormUhel := Uhel;
end;







function DejRadZeStupnu (UhelVeStu: real48): real48;
begin
  DejRadZeStupnu:= NormUhel (UhelVeStu*pi/180);
end;












function DejRadZGradu (UhelVGrad: real48): real48;
begin
  DejRadZGradu:= NormUhel (UhelVGrad*pi/200);
end;
















function DejRadZeStuMinSek (Stupne : longInt;
                            Minuty : longInt;
                            Sekundy: longInt): real48;
begin
  DejRadZeStuMinSek := NormUhel (pi*(Stupne*360 +Minuty*60 +Sekundy)/64800);
end;














function DejStupne (UhelVRad: real48): real48;
begin
  DejStupne := NormUhel (UhelVRad)*180/pi;
end; {function DejStupne}













procedure VratStuMinSek (UhelVRad: real48;
                     var Stupne  : longInt;
                     var Minuty  : longInt;
                     var Sekundy : longInt);
begin

  Sekundy := myroundL (648000*(NormUhel (UhelVRad)/pi));

  Stupne  := Sekundy div 3600;
  Minuty  := Sekundy div 60 mod 60;
  Sekundy := Sekundy mod 60;

end; {function VratStuMinSek}





procedure VratStuMinRSek (UhelVRad: real48;
                      var Stupne  : longInt;
                      var Minuty  : longInt;
                      var Sekundy : real48);
begin

  Sekundy := 648000*(NormUhel (UhelVRad)/pi);

  Stupne  := trunc (Sekundy) div 3600;
  Minuty  := trunc (Sekundy) div 60 mod 60;

  Sekundy := Sekundy -Stupne*3600 -Minuty*60;

end; {function VratStuMinRSek}



function DejGrady (UhelVRad: real48): real48;
begin
  DejGrady := NormUhel (UhelVRad)*200/pi;
end; {function DejGrady}


function BodVpravoOdOrientPrimky (A, B, C: TDoubleCoord): boolean;
var
  Fii: double;

begin
   Fii := Atan2M(B.X - A.X, B.Y - A.Y);
   BodVpravoOdOrientPrimky := (A.X - C.X)*sin(Fii) - (A.Y - C.Y)*cos(Fii) < 0;
end;

function CoordBodVpravoOdOrientPrimky (AA, BB, CC: T2DCoordinate): boolean;
var
  Fii: double;
  A,B,C: TDoubleCoord;
begin
   A.x := AA.x;
   A.y := AA.y;
   B.x := BB.x;
   B.y := BB.y;
   C.x := CC.x;
   C.y := CC.y;
   Fii := Atan2M(B.X - A.X, B.Y - A.Y);
   result := (A.X - C.X)*sin(Fii) - (A.Y - C.Y)*cos(Fii) < 0;
end;



function Acos (x: real48): real48;
begin
  if x >= 1
  then acos := 0
  else
    if x<=-1
    then acos:=Pi
    else acos:=PiPul-arctan(x/sqrt(1-sqr(x)))
end;


procedure DelejVektor (
                       PocBod : TSour;
                       KoncBod: TSour;

                   var Vektor : TVektor
                      );
begin
  Vektor.X     := KoncBod.X -PocBod.X;
  Vektor.Y     := KoncBod.Y -PocBod.Y;
  Vektor.Modul := sqrt (sqr (Vektor.X) +sqr (Vektor.Y))
end;














function Uhel2Vektoru (V1, V2: TVektor): real48;
begin
  if (abs(V1.Modul) > 1E-10) and (abs(V2.Modul) > 1E-10) then
     Uhel2Vektoru := Acos ((V1.X*V2.X +V1.Y*V2.Y)/V1.Modul/V2.Modul)
  else Uhel2Vektoru:= 0
end;






function Uhel2Usecek (A, B, C: TdoubleCoord): double;
begin
   if ((abs(A.X-B.X)> 1E-10) or (abs(A.Y-B.Y) > 1E-10)) and
      ((abs(C.X-B.X)> 1E-10) or (abs(C.Y-B.Y) > 1E-10)) then
        Uhel2Usecek := ACos(((A.Y - B.Y)*(C.Y - B.Y) +(A.X - B.X)*(C.X - B.X))
                       /sqrt(sqr(A.Y - B.Y) +sqr(A.X - B.X))
                       /sqrt(sqr(C.Y - B.Y) +sqr(C.X - B.X)))
   else
       Uhel2Usecek:= 0;
end;


function CoordUhel2Usecek (AA, BB, CC: T2DCoordinate): double;
var
   A,B,C: TDoubleCoord;
begin
   A.x := AA.x;
   A.y := AA.y;
   B.x := BB.x;
   B.y := BB.y;
   C.x := CC.x;
   C.y := CC.y;
   if ((abs(A.X-B.X)> 1E-10) or (abs(A.Y-B.Y) > 1E-10)) and
      ((abs(C.X-B.X)> 1E-10) or (abs(C.Y-B.Y) > 1E-10)) then
        CoordUhel2Usecek := ACos(((A.Y - B.Y)*(C.Y - B.Y) +(A.X - B.X)*(C.X - B.X))
                       /sqrt(sqr(A.Y - B.Y) +sqr(A.X - B.X))
                       /sqrt(sqr(C.Y - B.Y) +sqr(C.X - B.X)))
   else
       CoordUhel2Usecek:= 0;
end;







procedure VratPosunutyBod(
                              Bod        : TDoubleCoord;
                              Uhel       : double;
                              Draha      : double;
                          var PosunutyBod: TDoubleCoord);
begin
  if Draha < 1E-20 then
  begin
    PosunutyBod:= Bod;
    exit
  end;
  PosunutyBod.Y := Bod.Y +Draha*sin(Uhel);
  PosunutyBod.X := Bod.X +Draha*cos(Uhel);
end;



function GetRotatedCrd(CenterCrd, RotatedCrd: TDoubleCoord;
                       Angle: double): TDoubleCoord;
var
  Radius: double;
begin
  Radius:= sqrt(sqr(CenterCrd.X-RotatedCrd.X) +  sqr(CenterCrd.Y-RotatedCrd.Y));
  if Radius < 1E-20 then
  begin
    result:= CenterCrd;
    exit
  end;
  Angle:= Angle + Atan2M(RotatedCrd.X-CenterCrd.X, RotatedCrd.Y-CenterCrd.Y);
  result.X:= CenterCrd.X + Radius * cos(Angle);
  result.Y:= CenterCrd.Y + Radius * sin(Angle)
end;





function DecTrunc(
                  X:real48): real48;
var
  D: real48;

begin
  if X < 1E-12 then
    D:= 0
  else
    if X >= 1 then
    begin
      D:=1;
      while X / D >= 10.0 do D:= D * 10
    end else
    begin
      D:= 0.1;
      while X / D < 0.9999999999 do D:= D / 10
    end;
  DecTrunc:= D
end;



procedure Swap(
               var X, Y: double);
var
  Pom: double;

begin
  Pom:= X;
  X  := Y;
  Y  := Pom
end;


procedure Order(
                var X, Y: double);
{ prehodi tak aby vlevo byla mensi hodnota }
begin
  if X > Y then Swap(X, Y)
end;



procedure SwapLInt(
                   var X, Y: longInt);
var
  Pom: longInt;

begin
  Pom:= X;
  X  := Y;
  Y  := Pom
end;


procedure OrderLInt(
                    var X, Y: longInt);
{ prehodi tak aby vlevo byla mensi hodnota }
begin
  if X > Y then SwapLInt (X, Y)
end;





procedure SwapInt(
                  var X, Y: integer);
var
  Pom: integer;

begin
  Pom:= X;
  X  := Y;
  Y  := Pom
end;


procedure OrderInt(
                   var X, Y: integer);
{ prehodi tak aby vlevo byla mensi hodnota }
begin
  if X > Y then SwapInt (X, Y)
end;





function ShodneHodnoty(
                       X, Y, Tolerance: real48): boolean;
begin
  ShodneHodnoty:= abs(Y-X) <= abs(Tolerance)
end;



function PrekryvOO(
                   OO1, OO2: TIntObdelnik): boolean;
begin
  PrekryvOO := (OO1.LH.x <= OO2.PD.x)
               and
               (OO1.PD.x >= OO2.LH.x)
               and
               (OO1.LH.y <= OO2.PD.y)
               and
               (OO1.PD.y >= OO2.LH.y)
end;







function BodVIObdelniku(
                        Bod     : TPoint;
                        Obdelnik: TIntObdelnik): boolean;
begin
  BodVIObdelniku := (Bod.X <= Obdelnik.PD.x)
                    and
                    (Bod.X >= Obdelnik.LH.x)
                    and
                    (Bod.Y <= Obdelnik.PD.y)
                    and
                    (Bod.Y >= Obdelnik.LH.y);
end;







function XYVObdelniku(
                      X, Y    : integer;
                      Obdelnik: TIntObdelnik): boolean;
begin
  XYVObdelniku := (X <= Obdelnik.PD.x)
                  and
                  (X >= Obdelnik.LH.x)
                  and
                  (Y <= Obdelnik.PD.y)
                  and
                  (Y >= Obdelnik.LH.y);
end;












function VyskaObdelniku(
                        Obdelnik: TObdelnik): real48;
begin
  with Obdelnik do
    case SourSystem of
      JTSK       :
		   VyskaObdelniku:= LD.X - PH.X;
      Matematicky: VyskaObdelniku:= PH.Y - LD.Y;
      Gauss      : VyskaObdelniku:= PH.X - LD.X;
    end;
end;






function SirkaObdelniku(
                        Obdelnik: TObdelnik): real48;
begin
  with Obdelnik do
    case SourSystem of
      JTSK       :
		   SirkaObdelniku := LD.Y - PH.Y;
      Matematicky: SirkaObdelniku := PH.X - LD.X;
      Gauss      : SirkaObdelniku := PH.Y - LD.Y;
    end;
end;






function BodVObdelnikuSouradnicemi(
                                   SourB, SourO1, SourO2: TSour;
                                   Kriterium            : real48): boolean;
begin
  Order(SourO1.X, SourO2.X);
  Order(SourO1.Y, SourO2.Y);
  with SourB do
    BodVObdelnikuSouradnicemi:=
      (Y <= SourO2.Y + Kriterium)
      and
      (Y >= SourO1.Y - Kriterium)
      and
      (X <= SourO2.X + Kriterium)
      and
      (X >= SourO1.X - Kriterium);
end;





function BodVObdelniku(
                       Sour     : TSour;
                       const Obdelnik : TObdelnik;
                       Kriterium: real48): boolean;
begin
  with Sour, Obdelnik do
    case SourSystem of
      JTSK        :
		    BodVObdelniku :=
                                     (Y <= LD.Y + Kriterium)
                                     and
                                     (Y >= PH.Y - Kriterium)
                                     and
                                     (X <= LD.X + Kriterium)
                                     and
                                     (X >= PH.X - Kriterium);
      Matematicky,
      Gauss       : BodVObdelniku :=
                                     (Y <= PH.Y + Kriterium)
                                     and
                                     (Y >= LD.Y - Kriterium)
                                     and
                                     (X <= PH.X + Kriterium)
                                     and
                                     (X >= LD.X - Kriterium);
  end;
end;





function BodYXVObdelniku(
                         Y, X     : real48;
                         Obdelnik : TObdelnik;
                         Kriterium: real48): boolean;
var
  Sour: TSour;

begin
  Sour.Y:= Y;
  Sour.X:= X;
  BodYXVObdelniku := BodVObdelniku(Sour, Obdelnik, Kriterium)
end;




procedure IniOpObdelnik(
                        var OpObdelnik: TObdelnik);
const
  VH = 1E20;

begin
  with OpObdelnik do
    case SourSystem of
      JTSK        :
		    begin
                      LD.Y:= -VH; PH.Y:= VH; PH.X:= VH; LD.X:= -VH;
                    end;
      Matematicky,
      Gauss       : begin
                      LD.Y:= VH; PH.Y:= -VH; PH.X:= -VH; LD.X:= VH;
                    end;
    end;
end;





const
  Max = 9999999;

procedure NastavMaxObdelnik(
                            var Obdelnik: TObdelnik);
begin
  with Obdelnik do
    case SourSystem of
      JTSK        :
		    begin
                      LD.Y := Max; PH.Y := -Max; PH.X := -Max; LD.X := Max;
                    end;
      Matematicky,
      Gauss       : begin
                      PH.Y := Max; LD.Y := -Max; LD.X := -Max; PH.X := Max;
                    end;
    end;
end;





function JeToMaxObdelnik(
                         const Obdelnik: TObdelnik): boolean;
begin
  with Obdelnik do
    case SourSystem of
      JTSK        :
		    JeToMaxObdelnik:= (LD.Y =  Max)
                                      and
                                      (LD.X =  Max)
                                      and
                                      (PH.Y = -Max)
                                      and
                                      (PH.X = -Max);
      Matematicky,
      Gauss       : JeToMaxObdelnik:= (PH.Y =  Max)
                                      and
                                      (PH.X =  Max)
                                      and
                                      (LD.Y = -Max)
                                      and
                                      (LD.X = -Max);
    end;
end;




function DobryObdelnik(const Obdelnik: TObdelnik): boolean;
begin
  with Obdelnik do
    case SourSystem of
      JTSK        :
		    DobryObdelnik:= ((LD.Y >= PH.Y) and (LD.X >= PH.X))
                                    and
                                    ((LD.Y >  PH.Y) or  (LD.X >  PH.X))
                                    and
                                    ((LD.Y - PH.Y) > 0.01)
                                    and
                                    ((LD.X - PH.X) > 0.01);
      Matematicky,
      Gauss       : DobryObdelnik:= ((PH.Y >= LD.Y) and (PH.X >= LD.X))
                                    and
                                    ((PH.Y >  LD.Y) or  (PH.X >  LD.X))
                                    and
                                    ((PH.Y -  LD.Y) > 0.01)
                                    and
                                    ((PH.X -  LD.X) > 0.01);
    end;
end;


function BodovyObdelnik(
                        Obdelnik: TObdelnik): boolean;
begin
  with Obdelnik do
    case SourSystem of
      JTSK        :
		    BodovyObdelnik :=
                      not DobryObdelnik(Obdelnik)
                      and ((LD.Y >= PH.Y) and (LD.X >= PH.X));
      Matematicky,
      Gauss       : BodovyObdelnik :=
                      not DobryObdelnik(Obdelnik)
                      and ((PH.Y >= LD.Y) and (PH.X >= LD.X));
    end;
end;



procedure NastavObdelnikCSFR(
                             var Obdelnik: TObdelnik);
begin
  case SourSystem of
    JTSK       :
		 Obdelnik:= ObdelnikCSFR;
    Matematicky: Obdelnik:= ObdelnikInM;
    Gauss      : Obdelnik:= ObdelnikInG;
  end;
end;


procedure ZvetsiObdelnikDoStran(var Obdelnik: TObdelnik; Pridavek: real48);
begin
  with Obdelnik do
    case SourSystem of
      JTSK        :
		    begin
                      LD.Y:= LD.Y + Pridavek;
                      LD.X:= LD.X + Pridavek;
                      PH.Y:= PH.Y - Pridavek;
                      PH.X:= PH.X - Pridavek
                    end;
      Matematicky,
      Gauss       : begin
                      LD.Y:= LD.Y - Pridavek;
                      LD.X:= LD.X - Pridavek;
                      PH.Y:= PH.Y + Pridavek;
                      PH.X:= PH.X + Pridavek
                    end;
     end;
end;




function NastavenObdelnikCSFR(
                              Obdelnik: TObdelnik): boolean;
begin
  with Obdelnik do
    case SourSystem of
      JTSK       :
		   NastavenObdelnikCSFR:= (LD.Y = ObdelnikCSFR.LD.Y) and
                                          (LD.X = ObdelnikCSFR.LD.X) and
                                          (PH.Y = ObdelnikCSFR.PH.Y) and
                                          (PH.X = ObdelnikCSFR.PH.X);
      Matematicky: NastavenObdelnikCSFR:= (LD.Y = ObdelnikInM.LD.Y) and
                                          (LD.X = ObdelnikInM.LD.X) and
                                          (PH.Y = ObdelnikInM.PH.Y) and
                                          (PH.X = ObdelnikInM.PH.X);
      Gauss      : NastavenObdelnikCSFR:= (LD.Y = ObdelnikInG.LD.Y) and
                                          (LD.X = ObdelnikInG.LD.X) and
                                          (PH.Y = ObdelnikInG.PH.Y) and
                                          (PH.X = ObdelnikInG.PH.X);
    end
end;






procedure AktualizaceOpObdelnika(
                                     Y, X      : real48;
                                 var OpObdelnik: TObdelnik);
{ aktualizuje opisujici obdelnik souradnicemi Y X }
begin
  with OpObdelnik do
    case SourSystem of
       JTSK        :
		     begin
                       if (abs(Y) < 1E19) then
                       begin
                         if Y > LD.Y then LD.Y := Y;
                         if Y < PH.Y then PH.Y := Y
                       end;

                       if (abs(X) < 1E19) then
                       begin
                         if X > LD.X then LD.X := X;
                         if X < PH.X then PH.X := X;
                       end
                     end;
       Matematicky,
       Gauss       : begin
                       if (abs(Y) < 1E19) then
                       begin
                         if Y < LD.Y then LD.Y := Y;
                         if Y > PH.Y then PH.Y := Y
                       end;

                       if (abs(X) < 1E19) then
                       begin
                         if X < LD.X then LD.X := X;
                         if X > PH.X then PH.X := X;
                       end
                     end;
    end;
end;



procedure AktualizaceObdelnikemOpObdelnika(
                                               Obdelnik  : TObdelnik;
                                           var OpObdelnik: TObdelnik);
begin
  with Obdelnik do
  begin
    AktualizaceOpObdelnika(LD.Y, PH.X, OpObdelnik);
    AktualizaceOpObdelnika(PH.Y, LD.X, OpObdelnik)
  end
end;



function PrekryvObdelniku(
                          const Obdelnik1, Obdelnik2: TObdelnik;
                          Kriterium           : real48): boolean;

begin
  case SourSystem of
    JTSK        :
		  PrekryvObdelniku := not(
                                          (Obdelnik1.LD.Y + Kriterium < Obdelnik2.PH.Y) or
                                          (Obdelnik2.LD.Y + Kriterium < Obdelnik1.PH.Y) or
                                          (Obdelnik1.LD.X + Kriterium < Obdelnik2.PH.X) or
                                          (Obdelnik2.LD.X + Kriterium < Obdelnik1.PH.X)
                                          );
    Matematicky,
    Gauss       : PrekryvObdelniku := not(
                                          (Obdelnik1.PH.Y + Kriterium < Obdelnik2.LD.Y) or
                                          (Obdelnik2.PH.Y + Kriterium < Obdelnik1.LD.Y) or
                                          (Obdelnik1.PH.X + Kriterium < Obdelnik2.LD.X) or
                                          (Obdelnik2.PH.X + Kriterium < Obdelnik1.LD.X)
                                          );
  end;
end;




function RectanglesOverlay(aX1, aY1, aX2, aY2, bX1, bY1, bX2, bY2, Tolerance: double): boolean;
begin
  { uprava aby v "1" byly vetsi hodnoty }
  Order(aY2, aY1); Order(aX2, aX1);
  Order(bY2, bY1); Order(bX2, bX1);

  result := not
    ( (aY1 + Tolerance < bY2) or
      (bY1 + Tolerance < aY2) or
      (aX1 + Tolerance < bX2) or
      (bX1 + Tolerance < aX2) )
end;





function PrekryvObdelnikuSouradnicemi( SourA1, SourA2, SourB1, SourB2: TDoubleCoord;
                                       Kriterium : double): boolean;

begin
  { uprava aby v "1" byly vetsi hodnoty }
  Order(SourA2.Y, SourA1.Y); Order(SourA2.X, SourA1.X);
  Order(SourB2.Y, SourB1.Y); Order(SourB2.X, SourB1.X);

  PrekryvObdelnikuSouradnicemi := not
    ( (SourA1.Y + Kriterium < SourB2.Y) or
      (SourB1.Y + Kriterium < SourA2.Y) or
      (SourA1.X + Kriterium < SourB2.X) or
      (SourB1.X + Kriterium < SourA2.X)   )
end;


function CoordPrekryvObdelnikuSouradnicemi( SourAA1, SourAA2:T2DCoordinate;
                                            SourB1, SourB2: TDoubleCoord;
                                            Kriterium : double): boolean;
var
  SourA1,SourA2: TDoubleCoord;
begin
   SourA1.x := SourAA1.x;
   SourA1.y := SourAA1.y;
   SourA2.x := SourAA2.x;
   SourA2.y := SourAA2.y;
  { uprava aby v "1" byly vetsi hodnoty }
  Order(SourA2.Y, SourA1.Y); Order(SourA2.X, SourA1.X);
  Order(SourB2.Y, SourB1.Y); Order(SourB2.X, SourB1.X);

  result := not
    ( (SourA1.Y + Kriterium < SourB2.Y) or
      (SourB1.Y + Kriterium < SourA2.Y) or
      (SourA1.X + Kriterium < SourB2.X) or
      (SourB1.X + Kriterium < SourA2.X)   )
end;



function ObdelnikUvnitrObdelniku(
                                 const Obdelnik1, Obdelnik2: TObdelnik;
                                 Kriterium           : real48): boolean;
{ Zda druhy obdelnik obsahuj prvni, Kriterium zprisnuje pozadavek }

begin
  case SourSystem of
    JTSK        :
		  ObdelnikUvnitrObdelniku := (Obdelnik1.PH.Y - Kriterium >= Obdelnik2.PH.Y) and
                                             (Obdelnik1.PH.X - Kriterium >= Obdelnik2.PH.X) and
                                             (Obdelnik1.LD.Y + Kriterium <= Obdelnik2.LD.Y) and
                                             (Obdelnik1.LD.X + Kriterium <= Obdelnik2.LD.X);
    Matematicky,
    Gauss       : ObdelnikUvnitrObdelniku := (Obdelnik1.LD.Y - Kriterium >= Obdelnik2.LD.Y) and
                                             (Obdelnik1.LD.X - Kriterium >= Obdelnik2.LD.X) and
                                             (Obdelnik1.PH.Y + Kriterium <= Obdelnik2.PH.Y) and
                                             (Obdelnik1.PH.X + Kriterium <= Obdelnik2.PH.X);
  end;
end;




function ShodneObdelniky
         (const Obdelnik1, Obdelnik2: TObdelnik; Kriterium: real48): boolean;
{ Kriterium zmekcuje pozadavek }
begin
  ShodneObdelniky := (abs(Obdelnik1.PH.Y - Obdelnik2.PH.Y) <= Kriterium + VektorNula) and
                     (abs(Obdelnik1.PH.X - Obdelnik2.PH.X) <= Kriterium + VektorNula) and
                     (abs(Obdelnik1.LD.Y - Obdelnik2.LD.Y) <= Kriterium + VektorNula) and
                     (abs(Obdelnik1.LD.X - Obdelnik2.LD.X) <= Kriterium + VektorNula);
end;




procedure VratStred(const Obdelnik: TObdelnik; var SourStredu: TSour);
begin
  with Obdelnik, SourStredu do
  begin
    Y:= (LD.Y + PH.Y) / 2;
    X:= (LD.X + PH.X) / 2
  end
end;







function VzdalenostBodu(
                        Sour1, Sour2: TSour): real48;
begin
  if (abs(Sour1.Y) < 1E20) and (abs(Sour1.X) < 1E20) and
     (abs(Sour2.Y) < 1E20) and (abs(Sour2.X) < 1E20)  then
     VzdalenostBodu:= sqrt(sqr(Sour1.Y - Sour2.Y) + sqr(Sour1.X - Sour2.X))
  else
     VzdalenostBodu:= 0
end;


function Distance(X1, Y1, X2, Y2: double): double;
begin
  result:= sqrt(sqr(X2 - X1) + sqr(Y2 - Y1))
end;



function InTolerance(X1, Y1, X2, Y2, Tolerance: double): boolean;
begin
  result:= (abs(X1-X2) <= Tolerance) and (abs(Y1-Y2) <= Tolerance) and
           (Distance(X1, Y1, X2, Y2) <= Tolerance)
end;


procedure DejStred(
                       Sour1, Sour2: TSour;
                   var Stred       : TSour);
begin
  with Stred do
  begin
    Y:= (Sour1.Y + Sour2.Y) / 2;
    X:= (Sour1.X + Sour2.X) / 2
  end
end;





procedure GiveAbscPointByLength(X1, Y1, X2, Y2, Length, RoundKoef: double; var Xp, Yp: double);
var
  AbscLen: double;
begin
  AbscLen:= Distance(X1, Y1, X2, Y2);
  if (AbscLen > 0) and (Length < AbscLen) then
  begin
    Xp:= Length * (X2 - X1)/AbscLen + X1;
    Yp:= Length * (Y2 - Y1)/AbscLen + Y1;
  end
  else
  begin
    Xp:= X2;
    Yp:= Y2
  end;
  if RoundKoef <> 0 then
  begin
    Xp:= round(Xp/RoundKoef)*RoundKoef;
    Yp:= round(Yp/RoundKoef)*RoundKoef;
  end;
end;




procedure PrusecikParametrickychPrimek(
                                           K1, Q1, K2, Q2: double;
                                       var Yp, Xp        : double;
                                       var Rovnobezky    : boolean);
var
  Jmenovatel: double;//real48;

begin
  Jmenovatel:= K1 - K2;

  if abs(Jmenovatel) > 1E17 then
  begin
    Yp:= 0;
    Xp:= 0;
    Rovnobezky:= true
  end
  else
  if (abs(Jmenovatel * 1E20) <= abs(Q2 - Q1)) or
     (abs(Jmenovatel * 1E20) <= abs(K1*Q2 - K2*Q1)) then Rovnobezky:= true
  else
  begin
    Yp:= (K1*Q2 - K2*Q1) / Jmenovatel;
    Xp:= (Q2-Q1)/Jmenovatel;
    Rovnobezky:= false
  end
end;




procedure PrusecikUsecek(
                             Ya1,Xa1,  Yb1,Xb1,   Ya2,Xa2,  Yb2,Xb2: double;
                         var Yp, Xp                                : double;
                         var Rovnobezky, Uvnitr1, Uvnitr2          : boolean);
var
  Svisla1, Svisla2: boolean;
  K1, Q1, K2, Q2, YR, XR: double;

begin
  Uvnitr1 := false;
  Uvnitr2 := false;

  YR := Ya1; Ya1 := 0;
  XR := Xa1; Xa1 := 0;

  Yb1 := Yb1 - YR;
  Ya2 := Ya2 - YR;
  Yb2 := Yb2 - YR;

  Xb1 := Xb1 - XR;
  Xa2 := Xa2 - XR;
  Xb2 := Xb2 - XR;

  Svisla1 := true;
  K1:= 0; Q1:= 0;
  if abs(Xa1-Xb1) > 1E-20 then
  begin
    K1      := (Ya1 - Yb1)/(Xa1 - Xb1);
    Q1      := (Xa1*Yb1 - Xb1*Ya1) / (Xa1 - Xb1);
    Svisla1 := false
  end;

  Svisla2 := true;
  K2:= 0; Q2:= 0;
  if abs(Xa2-Xb2) > 1E-20 then
  begin
    K2      := (Ya2 - Yb2)/(Xa2 - Xb2);
    Q2      := (Xa2*Yb2 - Xb2*Ya2) / (Xa2 - Xb2);
    Svisla2 := false
  end;

  if Svisla1 and Svisla2 then Rovnobezky:= true
  else
    if Svisla1 then
    begin
      Xp         := Xa1;
      Yp         := K2*Xp + Q2; {Svisla2 je urcite false }
      Rovnobezky := false
    end
    else
      if Svisla2 then
      begin
        Xp         := Xa2;
        Yp         := K1*Xp + Q1; { Svisla1 je urcite false }
        Rovnobezky := false
      end
      else
        PrusecikParametrickychPrimek(K1, Q1, K2, Q2, Yp, Xp, Rovnobezky);

  { Usecky se protinaji mezi krajnimi body ? }
  if not Rovnobezky then
  begin
    if Svisla1 then Uvnitr1 := (Yp <= Ya1) and (Yp >= Yb1) or
                               (Yp >= Ya1) and (Yp <= Yb1)
    else            Uvnitr1 := (XP <= Xa1) and (Xp >= Xb1) or
                               (Xp >= Xa1) and (Xp <= Xb1);

    if Svisla2 then Uvnitr2 := (Yp <= Ya2) and (Yp >= Yb2) or
                               (Yp >= Ya2) and (Yp <= Yb2)
    else            Uvnitr2 := (XP <= Xa2) and (Xp >= Xb2) or
                               (Xp >= Xa2) and (Xp <= Xb2);
  end;

  Yp := Yp + YR;
  Xp := Xp + XR
end;






function ProtnutyUsecky(
                        XA1,YA1,  XB1,YB1,  XA2,YA2,  XB2,YB2: double): boolean;
var
  Yp, Xp: double;
  Rovnobezky, Uvnitr1, Uvnitr2: boolean;

begin
  PrusecikUsecek
    (XA1,YA1, XB1,YB1,   XA2,YA2, XB2,YB2, Yp,Xp, Rovnobezky,
     Uvnitr1, Uvnitr2);

  ProtnutyUsecky := Uvnitr1 and Uvnitr2
end;



(*
function  ExistujePrusecikPrimek(
                                     A, B, C, D: TSour;
                                 var P         : TSour): boolean;

{Vraci "true" existuje-li prusecik primky danou body AB
 s primkou danou body CD (t.z. primky nejsou rovnobezne), a naopak.
 V pripade existence pruseciku v promene P vraci jeji souradnice.}


const RNula = 1E-12;


var
  ABdx: extended;
  ABdy: extended;
  CDdx: extended;
  CDdy: extended;

  SAB    : extended;
  SCD    : extended;
  SCD_SAB: extended;
  Pom    : extended;

begin
{ zrusena oprava Smid 7.4.93 }
  ABdx := B.X -A.X;
  ABdy := B.Y -A.Y;
  CDdx := D.X -C.X;
  CDdy := D.Y -C.Y;

  if abs (ABdx) < RNula {primka AB je rovnobezna s osou "Y"}
  then begin
    if abs (CDdx) < RNula {primka CD je rovnobezna s osou "Y"}
    then  ExistujePrusecikPrimek := false
    else begin
      ExistujePrusecikPrimek := true;
      SCD := CDdy/CDdx;
      P.X := A.X;
      P.Y := SCD*(A.X -C.X) +C.Y;
    end;
  end
  else begin
    if abs (CDdx) < RNula
    then begin
      ExistujePrusecikPrimek := true;
      SAB := ABdy/ABdx;
      P.X := C.X;
      P.Y := (C.X -A.X)*SAB +A.Y;
    end
    else begin
      SAB := ABdy/ABdx;
      SCD := CDdy/CDdx;
      SCD_SAB := SCD -SAB;

      if abs (SCD_SAB) < 1E-5    { oprava Smid z 1E-4 na 1E-5 }
      then ExistujePrusecikPrimek := false
      else begin
        ExistujePrusecikPrimek := true;
        Pom := (SCD*C.X -SAB*A.X -C.Y +A.Y)/SCD_SAB;
        P.X := Pom;
        Pom := (SCD*(A.Y -A.X*SAB) -SAB*(C.Y -C.X*SCD) )/SCD_SAB;
        P.Y := Pom;
      end;
    end;
  end;
end;

*)


function BodJeMeziBody(
                       BodX, BodY, AX, AY, BX, BY: double): boolean;
begin
  Order (AX, BX);
  Order (AY, BY);

  BodJeMeziBody := ((BodX > AX) or (abs (BodX -AX) < VektorNula))
                   and
                   ((BodX < BX) or (abs (BodX -BX) < VektorNula))
                   and
                   ((BodY > AY) or (abs (BodY -AY) < VektorNula))
                   and
                   ((BodY < BY) or (abs (BodY -BY) < VektorNula))
end;


function BodLeziNaUsecce(XB,YB,X1,Y1,X2,Y2: double): boolean;
const
   RNula = 1E-9;
var
   DX,DY,BX,BY: double;
begin
   result := false;
   if not BodJeMeziBody(XB,YB,X1,Y1,X2,Y2) then
      exit;
   DX := X2 - X1;
   DY := Y2 - Y1;
   BX := XB - X1;
   BY := YB - Y1;
   if abs(DX) < RNula then    // svislitko
   begin
      result := (Abs(BX) < RNula); // je mezi body, takze tohle staci
      exit;
   end;
   {  vodorovna cast se resi v nasl vzorci...
   if Abs(DY) < RNula then    // vodorovnitko
   begin
      result := (Abs(BY) < RNula);
      exit;
   end;
   }
   result := Abs(BY-(DY*BX/DX)) < RNula;
end;



{
function ExistujePrusecikUsecek(
                                    A, B, C, D: TSour;
                                var P         : TSour): boolean;
begin
  ExistujePrusecikUsecek := ExistujePrusecikPrimek (A, B, C, D, P)
                            and BodJeMeziBody (P, A, B)
                            and BodJeMeziBody (P, C, D);
end;

}



procedure DejVztahyBod_Usecka(
                                  BodX, BodY, AX, AY,  BX, BY: double;
                              var PataKolmiceJeUvnitrUsecky: boolean;
                              var PataX, PataY              : double;
                              var VzdalenostBoduOdPrimky   : double);
begin
  DejPatuKolmice (AX, AY, BX, BY, BodX, BodY, PataX, PataY);

  PataKolmiceJeUvnitrUsecky := BodJeMeziBody (PataX, PataY, AX, AY, BX, BY);

  VzdalenostBoduOdPrimky := Distance(BodX, BodY, PataX, PataY);
end;




(*
procedure DejPatuKolmice(
                             A, B, M: TSour;
                         var P      : TSour);

{Vraci sour. "P" paty kolmice  spustene z bodu "M" na primku
 danou body "A" a "B", pricemz je:
 SAB - smernice primky dane body "A" a "B"
 SMP - smernice kolme primky k primce dane body "A" a "B"}

const RNula = 1E-9;

var
  DX, DY, SAB, SMP, Pom: extended;
begin
  DX := B.X -A.X;
  DY := B.Y -A.Y;

  if abs (DX) < RNula {primka AB je rovnobezna s osou "Y"} then
  begin
    P.X := A.X;
    P.Y := M.Y;
  end else
  begin
    if abs (DY) < RNula {primka AB je rovnobezna s osou "X"} then
    begin
      P.X := M.X;
      P.Y := A.Y;
    end else
    begin
      SAB := DY/DX;
      SMP := -1/SAB;
      Pom := (A.Y -M.Y +M.X*SMP -A.X*SAB)/(SMP -SAB);
      P.X := Pom;
      Pom := (A.X -M.X -M.Y*SAB +A.Y*SMP) / (SMP -SAB);
      P.Y := Pom;
    end;
  end;
end;
*)



procedure DejPatuKolmice(
                             AX, AY, BX, BY, MX, MY: double;
                         var PX, PY      : double);

{Vraci sour. "P" paty kolmice  spustene z bodu "M" na primku
 danou body "A" a "B", pricemz je:
 SAB - smernice primky dane body "A" a "B"
 SMP - smernice kolme primky k primce dane body "A" a "B"}

const RNula = 1E-9;

var
  DX, DY, SAB, SMP, Pom: extended;
begin
  DX := BX -AX;
  DY := BY -AY;

  if abs (DX) < RNula {primka AB je rovnobezna s osou "Y"} then
  begin
    PX := AX;
    PY := MY;
  end else
  begin
    if abs (DY) < RNula {primka AB je rovnobezna s osou "X"} then
    begin
      PX := MX;
      PY := AY;
    end else
    begin
      SAB := DY/DX;
      SMP := -1/SAB;
      Pom := (AY -MY +MX*SMP -AX*SAB)/(SMP -SAB);
      PX := Pom;
      Pom := (AX -MX -MY*SAB +AY*SMP) / (SMP -SAB);
      PY := Pom;
    end;
  end;
end;





function TotozneBody(
                     A, B: TSour): boolean;

begin
  TotozneBody := (A.X = B.X) and (A.Y = B.Y)
end;

function IdentickeBody(
                       A, B: TSour): boolean;

begin
  IdentickeBody := (abs (A.X - B.X) < VektorNula)
                   and
                   (abs (A.Y - B.Y) < VektorNula)
end;





function PrisneIdentickeBody(
                             A, B: TSour): boolean;
begin
  PrisneIdentickeBody:= (abs (A.X - B.X) < PrisnaNula)
                        and
                        (abs (A.Y - B.Y) < PrisnaNula)
end;





function VolneIdentickeBody(
                            A, B: TSour): boolean;
begin
  VolneIdentickeBody := (abs (A.X - B.X) < VolnaNula)
                        and
                        (abs (A.Y - B.Y) < VolnaNula)
end;




function EqualPoints(X1, Y1, X2, Y2: double): boolean;
begin
  result:= (X1=X2) and (Y1=Y2)
end;




function RealneIdentickeBody(
                             A, B: TSour): boolean;
var
  XMira, YMira: real48;
begin
  if A.X < B.X
  then XMira := A.X/1e8
  else XMira := B.X/1e8;

  if A.Y < B.Y
  then YMira := A.Y/1e8
  else YMira := B.Y/1e8;


  RealneIdentickeBody:= (abs (A.X - B.X) < XMira)
                        and
                        (abs (A.Y - B.Y) < YMira)
end;





function ObdelnikRovnaSeObdelniku(
                                  Obdelnik1, Obdelnik2: TObdelnik;
                                  Kriterium           : real48): boolean;
{ Zda se obdelniky rovnaji }

begin

  ObdelnikRovnaSeObdelniku:=
       ((abs(Obdelnik1.PH.Y - Obdelnik2.PH.Y) <= Kriterium) and
        (abs(Obdelnik1.PH.X - Obdelnik2.PH.X) <= Kriterium) and
        (abs(Obdelnik1.LD.Y - Obdelnik2.LD.Y) <= Kriterium) and
        (abs(Obdelnik1.LD.X - Obdelnik2.LD.X) <= Kriterium))
end;


(*


procedure DoplnTriVrcholyKosodelnika(
                                     LD, SmerBod          : TSour;
                                     Sirka, Vyska, UhelSkl: real48;

                       var LH, PH, PD: TSour);
var
  Uhel: real48;

begin
  UhelSkl := NormUhel (PI/2 -DejRadZeStupnu (UhelSkl));

  Uhel := Atan2M  (SmerBod.Y -LD.Y, SMerBod.X - LD.X);
  VratPosunutyBod (LD, Uhel, Sirka, PD);

  Uhel := NormUhel (Uhel +UhelSkl);
  VratPosunutyBod  (LD, Uhel, Vyska, LH);
  VratPosunutyBod (PD, Uhel, Vyska, PH)

end; {procedure VratObdelnikTextu}


*)




end.