unit e_GFile;

interface
uses
   // GLIB
   G_Elems;

type

TGraphicFileElement = class(TRectEntity)
private
  FFileName: string;
protected
   function  GetFileName: string; virtual;
   function  GetPath: string; virtual;
   procedure SetFileName(aValue: string); virtual;
   procedure SetPath(aValue: string); virtual;
published
   property FileName: string read GetFileName write SetFileName;
   property Path: string read GetPath write SetPath stored false;
end;

// TBMPFileElement je zde kvli kompatibilit
TBMPFileElement = class(TGraphicFileElement);

implementation
uses
   SysUtils,
   // KERNEL
   e_Class,
   u_String;

{ TBMPFileElement }

function  TGraphicFileElement.GetFileName: string;
begin
   Result:= FFileName;
end;

function  TGraphicFileElement.GetPath: string;
begin
   Result := ExtractFilePath(FFileName);
end;

procedure TGraphicFileElement.SetFileName(aValue: string);
begin
   FFileName := aValue;
end;

procedure TGraphicFileElement.SetPath(aValue: string);
begin
   FFileName := CheckBackSlash(aValue) + ExtractFileName(FFileName);
end;




INITIALIZATION
   RegisterOrbisClass(TGraphicFileElement);
   RegisterOrbisClass(TBMPFileElement);
END.
