unit E_pale;
{
[Unit_Description]
Description=Barevn paleta
Admin=Petr
TechTopic=Elements
Topic=Zobrazen dat
Version=1.0

1] xml
<colorpalette version="4.0">
   <color r="255" g="128" b="0" comment="0 prvn divn barva"/>
   <color r="0" g="0" b="255" comment="1 modr"/>
   <color r="0" g="255" b="0" comment="2 zelen"/>
</colorpalette>

2] klasika
255 128   0 0 prvn divn barva
  0   0 255 1 modr
  0 255   0 2 zelen

3] mapper like
255,128,  0, 0 prvn divn barva
  0,  0,255, 1 modr
  0,255,  0, 2 zelen

}

interface
uses
   FMx.Graphics,
   // KERNEL
   System.UITypes,
   e_Type,
   Elements;

type
{
 properta NextRGBColor m syntaxi: NextRGBColor = '23,56,251,modr'
                                                   R  G  B   nzev
}
//TColor = TAlphaColor;

TRGB_Color = class(TIntegerElement)
  private
    FComment: string;
    function GetB: byte;
    function GetG: byte;
    function GetR: byte;
    procedure SetB(const aValue: byte);
    procedure SetComment(const aValue: string);
    procedure SetG(const aValue: byte);
    procedure SetR(const aValue: byte);
published
   property R: byte read GetR write SetR;
   property G: byte read GetG write SetG;
   property B: byte read GetB write SetB;
   property Comment: string read FComment write SetComment;
end;

TColorPalette = class(TOwnerEntity)
private
   function  GetColor(aIndex: longInt): TColor;
   procedure PutColor(aIndex: longInt; aValue: TColor);
   procedure SetNextRGBColor(aValue: string);
   procedure SetNextColor(aValue: longInt);
public
   procedure AddColorName(aColor: integer;const aName: string);
   property  Color[aIndex: longInt]: TColor read GetColor write PutColor;
published
   property NextRGBColor: string write SetNextRGBColor;
   property NextColor: longInt   write SetNextColor;
end;

implementation

uses
   SysUtils,
//   WinProcs,
   // KERNEL
   e_Class,
   u_String;

{ TColorPalette }

procedure TColorPalette.AddColorName(aColor: integer;const aName: string);
begin
   AddElement(TRGB_Color.CreateAll(aName, aColor));
end;

function  TColorPalette.GetColor(aIndex: longInt): TColor;
begin
   result := TIntegerElement(Elements[aIndex]).Value;
end;

procedure TColorPalette.PutColor(aIndex: longInt; aValue: TColor);
begin
   TIntegerElement(Elements[aIndex]).Value := aValue;
end;

procedure TColorPalette.SetNextRGBColor(aValue: string);
var
   R, G, B: longInt;
   S1, S2, aName: string;
   TwoPar: boolean;
   E: TIntegerElement;
   ACol: TAlphaColor;
begin
   R := 0;
   G := 0;
   B := 0;
   aName := 'Color';
   if aValue <> '' then
   begin
      TwoPar := StringAsTwoParams(aValue, ',', S1, S2);
      R := StrToInt(S1);
      S1 := S2;
      if TwoPar then
      begin
         TwoPar := StringAsTwoParams(S1, ',', S1, S2);
         G := StrToInt(S1);
         S1 := S2;
         if TwoPar then
         begin
            TwoPar := StringAsTwoParams(S1, ',', S1, S2);
            B := StrToInt(S1);
            if TwoPar then aName := S2;
         end;
      end;
   end;
   TAlphaColors(ACol).R := R;
   TAlphaColors(ACol).G := G;
   TAlphaColors(ACol).B := B;
   E := TRGB_Color.CreateAll(aName, ACol);
   AddElement(E);
end;

procedure TColorPalette.SetNextColor(aValue: longInt);
begin
   AddElement(TRGB_Color.CreateAll('Color '+IntToStr(Count), aValue));
end;


{ TRGB_Color }

function TRGB_Color.GetB: byte;
begin
//   result := getBValue(Value);
   result := TAlphaColors(Value).B;
end;

function TRGB_Color.GetG: byte;
begin
//   result := getGValue(Value);
   result := TAlphaColors(Value).G;
end;

function TRGB_Color.GetR: byte;
begin
//   result := getRValue(Value);
   result := TAlphaColors(Value).R;
end;

procedure TRGB_Color.SetB(const aValue: byte);
var
   aVal: integer;
begin
   aVal := Value;
   TAlphaColors(aVal).B := (aValue);
   Value := aVal;
end;

procedure TRGB_Color.SetComment(const aValue: string);
begin
  FComment := aValue;
end;

procedure TRGB_Color.SetG(const aValue: byte);
var
   aVal: integer;
begin
   aVal := Value;
   TAlphaColors(aVal).G := (aValue);
   Value := aVal;
end;

procedure TRGB_Color.SetR(const aValue: byte);
var
   aVal: integer;
begin
   aVal := Value;
   TAlphaColors(aVal).R := (aValue);
   Value := aVal;
end;

INITIALIZATION
   RegisterOrbisClass(TColorPalette);
   RegisterOrbisClass(TRGB_Color);
END.
