unit t_ShImg;
{
*********************************************************************
*                                                                   *
*  ORBIS ... Tdy interaktivnch nstroj                          *
*                                                                   *
*                       Topol Pro 1996                             *
*********************************************************************

[Unit_Description]
Description=Tdy interaktivnch nstroj
Admin=Petr
TechTopic=Interactive tools
Topic=Zobrazen dat
Version=1.0

[Edit]
 8.8.1997 18:00=Registrace
}


interface
uses
  Classes,
  Controls,
  Graphics,
  Menus,
  WinTypes,
// KERNEL
  Elements,
  Tools,
// DEVICE
  e_Proje,
  t_Device,
// INTERPRET
  e_IScrpt,
  i_Basic,
// GUI
// O.S. 12.7.98
  F_STDImg,
  //T_Intera,
  t_InterfaceTool,
  M_InterA;


type

{ TInteractiveTool }
{ Postup pi tvorb novho interaktivnho nstroje:
  1. Vytvoen novho objetku class (TInteractiveTool)
  2. Do editanho formule vloit tlatko na sputn
     nstroje s vyvolnm udlosti
     Tool.PostMsg(tm_NewTool, Tool, nil, DontKill);
     Udlost tm_NewTool pidat do pslunho M_Proj
  3. Do potomka TFormToolManageru vloit
     a. CreateTools: instanci nstroje do property NextTool
        NextTool := TNewTool.Create;
     b. HandleMessage:
        obsluha udlosti tm_NewTool
     c. Nov procedura On_tm_NewTool
        FindMenuItemIn('Tools','TNewTool').OnClick(nil);
}






TShiftImage = class(TInterfaceTool)
 private
   FBitMap: graphics.TBitMap;
   FDX, FDY, FPrevX, FPrevY: integer;
   FStartDrag: Boolean;
 public
   procedure RegisterCursors; override;
   procedure On_tm_StartDrag(var aMessage: TOrbisMouseEvent; var Handled: boolean); override;
   procedure On_tm_DragOver(var aMessage: TOrbisMouseEvent; var Handled: boolean); override;
   procedure On_tm_DragDrop(var aMessage: TOrbisMouseEvent; var Handled: boolean); override;
   procedure On_tm_DragEnd(var aMessage: TOrbisMouseEvent; var Handled: boolean); override;
end;



implementation
uses
   Dialogs,
   Forms,
   SysUtils,
   // KERNEL
   e_Class,
   M_Orbis,
   u_String,
   // GLIB
   G_Elems,
   // DEVICE
   D_STDImg,
   e_Device,
   // INTERPRET
   i_Uni,
   // GUI
   F_SetScl,
//   t_Loader,
//   t_Saver,
{$IFNDEF NOTIS}
// SPACETOOL
   //t_SelAre,
//   t_SelMS,
//   t_TisCre,
{$ENDIF}
// MAPPER
   t_Print,
// MAIN
   m_Proj;
   //u_Cursor;


const
   crHandFlat = 0;
   crHandGrab = 1;


{ TShiftImage }



procedure TShiftImage.On_tm_DragDrop(var aMessage: TOrbisMouseEvent;
  var Handled: boolean);
var
  DeltaX, DeltaY: integer;
  DeltaXD, DeltaYD: double;
begin
  DeltaX:= aMessage.X-FDX;
  DeltaY:= aMessage.Y-FDY;
  DeltaXD:= Device.Projection.GetModelLength(DeltaX);
  DeltaYD:= Device.Projection.GetModelLength(DeltaY);
  Device.Projection.Center_X:= Device.Projection.Center_X - DeltaXD;
  Device.Projection.Center_Y:= Device.Projection.Center_Y + DeltaYD;
  if CanBeFlash and (FlashTool <> nil) then
     FlashTool.BeforeFlashReView;
  PostMsgToOwners(tm_BreakAndReView, Input, DontKill);
  PostMsgToOwners(tm_ProjectionCHanged, Device.Projection, false);
end;

procedure TShiftImage.On_tm_DragEnd(var aMessage: TOrbisMouseEvent;
  var Handled: boolean);
begin
  if Assigned(FBitMap) then
     FBitMap.Free;
  FBitMap:= nil;
  CursorIndex := crHandFlat;
  if CanBeFlash and (FlashTool <> nil) then
  begin
     Application.ProcessMessages;
     PostMsgToOwners(tm_ToolSelected, FlashTool, DontKill);
  end;
end;

procedure TShiftImage.On_tm_DragOver(var aMessage: TOrbisMouseEvent;
  var Handled: boolean);
var
  aRect: TRect;
  aWidth, aHeight: integer;
begin
  if not (Device is TImageCanvasDevice) then
     Exit;
  if FStartDrag then
  begin
    FStartDrag:= False;
    FDX:= aMessage.X;
    FDY:= aMessage.Y;
    FPrevX:= aMessage.X;
    FPrevY:= aMessage.Y;
    exit;
  end;
  TImageCanvasDevice(Device).Canvas.Brush.Color:= Device.Page.Color;
  TImageCanvasDevice(Device).Canvas.Brush.Style:= bsSolid;

{ maskovn svisl }
  aRect.Top:= 0;
  aRect.Bottom:= TImageCanvasDevice(Device).Canvas.ClipRect.Bottom;
  if aMessage.X > FDX then
  begin   // odkrvn lev sti
    aRect.Right:= aMessage.X-FDX;
    aWidth:= aMessage.X - FPrevX;
    if aWidth < 0 then
       aWidth:= 0;
    aRect.Left:= aRect.Right - aWidth
  end
  else
  begin   // odkrvn prav sti
    aRect.Left:= TImageCanvasDevice(Device).Canvas.ClipRect.Right - (FDX-aMessage.X);
    aWidth:= FPrevX - aMessage.X;
    if aWidth < 0 then
       aWidth:= 0;
    aRect.Right:= aRect.Left + aWidth
  end;

  TImageCanvasDevice(Device).Canvas.FillRect(aRect);

{ maskovn vodorovn }
  aRect.Left:= 0;
  aRect.Right:= TImageCanvasDevice(Device).Canvas.ClipRect.Right;
  if aMessage.Y > FDY then
  begin   // odkrvn horn sti
    aRect.Bottom:= aMessage.Y-FDY;
    aHeight:= aMessage.Y - FPrevY;
    if aHeight < 0 then
       aHeight:= 0;
    aRect.Top:= aRect.Bottom - aHeight;
  end
  else
  begin   // odkrvn doln sti
    aRect.Top:= TImageCanvasDevice(Device).Canvas.ClipRect.Bottom - (FDY-aMessage.Y);
    aHeight:= FPrevY - aMessage.Y;
    if aHeight < 0 then
       aHeight:= 0;
    aRect.Bottom:= aRect.Top + aHeight;
  end;

  TImageCanvasDevice(Device).Canvas.FillRect(aRect);

  TImageCanvasDevice(Device).Canvas.Draw(aMessage.X-FDX, aMessage.Y-FDY, FBitmap);
  FPrevX:= aMessage.X;
  FPrevY:= aMessage.Y;
end;


procedure TShiftImage.On_tm_StartDrag(var aMessage: TOrbisMouseEvent;
  var Handled: boolean);
begin
  if FBitMap <> nil then
     FBitMap.Free;
  FBitMap:= nil;
  if not (Device is TImageCanvasDevice) then
     Exit;
  FStartDrag:= True;
  FBItmap:= graphics.TBitMap.Create;
  FBitMap.Width:= TCanvasDevice(Device).Page.Width;
  FBitMap.Height:= TCanvasDevice(Device).Page.Height;
  FBitMap.Canvas.Draw(0, 0, TImageCanvasDevice(Device).Bitmap);
  CursorIndex := crHandGrab;
end;


procedure TShiftImage.RegisterCursors;
begin
   NewCursorName('HANDFLAT');
   NewCursorName('HANDGRAB');
end;

BEGIN
   RegisterOrbisClass(TShiftImage);
END.
