unit T_IMtoIS;

interface
uses
// KERNEL
   Elements,
   Tools,
   i_Basic,
// INTERPRET
   e_IModel;

type

TInterpretModelToIntrepretScript = class(TTool)
private
   procedure SetProperties(aInterpret: TInterpret; aModel: TInterpretModel);
public
   procedure DoIt; override;
end;

implementation

uses
// TEST
   Dialogs,
// KERNEL
   e_Class,
   e_ElementModel,
// INTERPRET
   e_IScrpt;


{ TInterpretModelToIntrepretScript }

procedure TInterpretModelToIntrepretScript.SetProperties(aInterpret: TInterpret;
                                                         aModel: TInterpretModel);
var
   i: longInt;
   PM: TPropertyModel;
begin
   if aModel.NoPropertyModels then exit;
   for i := 0 to aModel.PropertyModels.LastIndex do
   begin
      PM := TPropertyModel(aModel.PropertyModels.Elements[i]);
      aInterpret.SetPropertyStringByName(PM.Name, PM.Value);
   end;
end;


procedure TInterpretModelToIntrepretScript.DoIt;
var
   ISc: TInterpretScript;
   IME: TInterpretModelEntity;
   IM, SM: TInterpretModel;
   IT,II: TInterpret;
   EC: TElementClass;
   i, j: longInt;
begin
   if Input = nil then exit;
   if not (Input is TInterpretModelEntity) then exit;
   IME := TInterpretModelEntity(Input);
   ISc := TInterpretScript.Create;
   Output := ISc;
   if not (IME.NoElements) then
   for i := 0 to IME.LastIndex do
   begin
      IM := TInterpretModel(IME.Elements[i]);
      if IM.CoverMePlease then
      begin
         Isc.FindClassName := IM.ElementClassName;
         if Isc.IsError then
         begin
            ISc.NewClassName := IM.ElementClassName;
            if ISc.IsError then Continue;
            Isc.ActualInterpret := TInterpret.Create;
         end;
         EC := GetOrbisClass(IM.InterpretClassName);
         if EC = nil then Continue;
         II := TInterpret(EC.Create);
         II.Name := IM.Name;
         SetProperties(II, IM);
         try
         ISc.ActualInterpret.NextSubInterpret := II;
         except
            ShowMessage(II.Name);
         end;
      end
      else
      begin
         ISc.NewClassName := IM.ElementClassName;
         if ISc.IsError then Continue;
         Isc.ActualInterpretName := IM.InterpretClassName;
         if ISc.IsError then Continue;
         Isc.ActualInterpret.Name := IM.Name;
         SetProperties(ISC.ActualInterpret,IM);
         II := Isc.ActualInterpret;
      end;
      if IM.NoSubModels then Continue;
      for j := 0 to IM.SubModels.LastIndex do
      begin
         SM := TInterpretModel(IM.SubModels.Elements[j]);
         EC := GetOrbisClass(SM.InterpretClassName);
         if EC = nil then Continue;
         IT := TInterpret(EC.Create);
         IT.Name := SM.Name;
         SetProperties(IT, SM);
         try
         II.NextSubInterpret := IT;
         except
            ShowMessage(II.Name+' - '+IT.Name);
         end;
      end;
   end;
end;

end.
