unit CtiRadek;
{
[Unit_Description]
Description=Objekt pro rozbor TXT dku
Admin=Olda
TechTopic=Utilities
Topic=Text
Version=1.0
}



{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&} interface {&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}

{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}


type

   TsetOfChar = set of char;



  TCtiRadekClass = class
    Obsah: string;
    Ukazovatko: integer;
    ChybaCteni: boolean;

    constructor Create(ObsahRadku: string);

    procedure  NovyString(ObsahRadku: string);

    procedure  ZnovuOdZacatkuRadku;
    procedure  StepVl;
    procedure  StepVp;
    procedure  JdiNa(Pozice: byte);

    function   KonecRadku: boolean;

    function   DosloKChybe: boolean;
    function   AktualniZnak: char;
    function   DejChar: char;
    procedure  PreskocMezery;
    procedure  PreskocMnozinu(Mn: TsetOfChar);
    procedure  JdiNaMnozinu(Mn: TsetOfChar);
    procedure  JdiZaZnak(Znak: char);

    function   DejString(DelkaRetezce: integer): string;
    function   DejStringPos(Odkud, Pokud: byte): string;
    function   DejStringPoApostrof: string;
    function   DejStringPoZnak(Zn: char): string;
    function   DejParametrStr(var MeziApostrofy: boolean): string;
    function   DejStringMeziApostrofy: string;
    function   DejStringPoMnozinu(Mn: TSetOfChar): string;
    function   DejInteger: integer;
    function   DejLongInt: longInt;
    function   DejReal: real48;
    function   DejExtended: extended;
    function   DejDekodovanyReal: real48;
    function   DejBoolean: boolean;
  end;




{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&} implementation {&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}

{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}




{----------------------------------------------------------------------------}
{                             METODY TCtiRadek                               }
{----------------------------------------------------------------------------}



constructor TCtiRadekClass.Create(ObsahRadku: string);
begin
  inherited Create;
  Obsah:= ObsahRadku;
  Ukazovatko:= 1;
  ChybaCteni:= false
end;



procedure  TCtiRadekClass.NovyString(ObsahRadku: string);
begin
  Obsah:= ObsahRadku;
  Ukazovatko:= 1;
  ChybaCteni:= false
end;





function TCtiRadekClass.DosloKChybe: boolean;
begin
  DosloKChybe:= ChybaCteni
end;


function TCtiRadekClass.KonecRadku: boolean;
begin
  KonecRadku:= Ukazovatko > length(Obsah)
end;



procedure TCtiRadekClass.ZnovuOdZacatkuRadku;
begin
  Ukazovatko:= 1
end;



procedure TCtiRadekClass.StepVl;
begin
  if Ukazovatko > 0 then
     dec(Ukazovatko)
  else
     ChybaCteni:= true
end;




procedure TCtiRadekClass.StepVp;
begin
  if Ukazovatko < 254 then
     inc(Ukazovatko)
  else ChybaCteni:= true
end;




procedure  TCtiRadekClass.JdiNa(Pozice: byte);
begin
  Ukazovatko:= Pozice
end;





function TCtiRadekClass.DejChar: char;
begin
  result := #0;
  if not ChybaCteni then
  begin
    if length(Obsah)>=Ukazovatko then
    begin
      result:= Obsah[Ukazovatko];
      if Ukazovatko < 254 then
         inc(Ukazovatko)
      else ChybaCteni:= true
    end
    else ChybaCteni:= true
  end
end;



function TCtiRadekClass.AktualniZnak: char;
begin
  if Ukazovatko <= length(Obsah) then
     AktualniZnak:= Obsah[Ukazovatko]
  else
     AktualniZnak:= #0
end;




procedure TCtiRadekClass.PreskocMezery;
begin
  while (Ukazovatko <= length(Obsah)) and (Obsah[Ukazovatko] = ' ') do
        inc(Ukazovatko)
end;




procedure TCtiRadekClass.PreskocMnozinu(Mn: TsetOfChar);
begin
  while (Ukazovatko <= length(Obsah)) and (Obsah[Ukazovatko] in Mn) do
        inc(Ukazovatko)
end;


procedure TCtiRadekClass.JdiNaMnozinu(Mn: TsetOfChar);
begin
  while (Ukazovatko <= length(Obsah)) and not (Obsah[Ukazovatko] in Mn) do
        inc(Ukazovatko)
end;



procedure TCtiRadekClass.JdiZaZnak(Znak: char);
begin
  while (Ukazovatko <= length(Obsah)) and (Obsah[Ukazovatko] <> Znak) do
        inc(Ukazovatko);

  if Ukazovatko <= length(Obsah) then
     inc(Ukazovatko);
end;



function TCtiRadekClass.DejString(DelkaRetezce: integer): string;
begin
  if not ChybaCteni then
  begin
    DejString:= copy(Obsah, Ukazovatko, DelkaRetezce);
    Ukazovatko:= Ukazovatko + DelkaRetezce
  end
end;



function TCtiRadekClass.DejStringPos(Odkud, Pokud: byte): string;
begin
end;




function TCtiRadekClass.DejStringPoApostrof: string;
var
  Bufer: string;
  Nasel: boolean;

begin
  if not ChybaCteni then
  begin
    Bufer := '';
    Nasel:= false;
    while (Ukazovatko <= length (Obsah)) and not Nasel do
    begin
      Bufer := Bufer + Obsah[Ukazovatko];
      if (Obsah[Ukazovatko] = '''') then
      begin
         if (Ukazovatko < length(Obsah)) and (Obsah[Ukazovatko+1] = '''') then
            inc (Ukazovatko)
         else
            Nasel:= true
      end;
      if not Nasel then
         inc(Ukazovatko);
    end;

    if Nasel then
//       {$IFDEF WIN32}
          SetLength(Bufer, Length(Bufer) - 1);
//       {$ELSE}
//          dec(byte(Bufer[0]));
//       {$ENDIF}
    DejStringPoApostrof := Bufer
  end;
end;




function TCtiRadekClass.DejStringPoZnak(Zn: char): string;
var
  Bufer: string;
begin
  if not ChybaCteni then
  begin
    Bufer := '';
    while (Ukazovatko <= length (Obsah)) and (Obsah[Ukazovatko] <> Zn) do
    begin
      Bufer := Bufer + Obsah[Ukazovatko];
      inc (Ukazovatko);
    end;

    DejStringPoZnak := Bufer;
  end;
end;





function TCtiRadekClass.DejParametrStr(var MeziApostrofy: boolean): string;
{ ocekava se parametr bud uzavreny mezi apostrofy nebo oddeleny mezerami }

begin
  if DejChar='''' then
  begin
    DejParametrStr:= DejStringPoApostrof;
    StepVp;
    MeziApostrofy:= true
  end
  else
  begin
    StepVl;
    DejParametrStr:= DejStringPoZnak(' ');
    MeziApostrofy:= false
  end
end;




function TCtiRadekClass.DejStringMeziApostrofy: string;
{ ocekava se parametr bud uzavreny mezi apostrofy nebo oddeleny mezerami }

begin
  JdiNaMnozinu(['''']);
  StepVp;
  DejStringMeziApostrofy:= DejStringPoApostrof;
  StepVp
end;






function TCtiRadekClass.DejStringPoMnozinu(Mn: TSetOfChar): string;
var
  Bufer: string;

begin
  if not ChybaCteni then
  begin
    Bufer := '';
    while (Ukazovatko <= length (Obsah)) and
          not (Obsah[Ukazovatko] in Mn) do begin
      Bufer := Bufer + Obsah[Ukazovatko];
      inc (Ukazovatko);
    end;

    DejStringPoMnozinu := Bufer;
  end;
end;






function TCtiRadekClass.DejInteger: integer;
var
  Zac, Code: integer;
  Cislo: integer;
  ZacloCislo: boolean;

begin
  DejInteger:= 0;

  if not ChybaCteni then
  begin
    while (Ukazovatko <= length (Obsah)) and
          not (Obsah[Ukazovatko] in ['+','-','0'..'9'])
          do inc(Ukazovatko);
    Zac:= Ukazovatko;

    ZacloCislo:= false;

    while (Ukazovatko <= length (Obsah)) and
          ( (Obsah[Ukazovatko] in ['+','-']) and not ZacloCislo
          or
           (Obsah[Ukazovatko] in  ['0'..'9'])) do
    begin
      ZacloCislo:= Obsah[Ukazovatko] in ['0'..'9'];
      inc(Ukazovatko)
    end;

    val(copy(Obsah, Zac, Ukazovatko - Zac), Cislo, Code);
    ChybaCteni:= Code <> 0;
    if ChybaCteni then DejInteger:= 0
    else               DejInteger:= Cislo
  end
end;


function TCtiRadekClass.DejLongInt: longInt;
var
  Zac, Code: integer;
  Cislo: longint;
  ZacloCislo: boolean;

begin
  DejLongInt:= 0;

  if not ChybaCteni then
  begin
    while (Ukazovatko <= length (Obsah))  and
          not (Obsah[Ukazovatko] in ['+','-','0'..'9'])
          do inc(Ukazovatko);
    Zac:= Ukazovatko;
    ZacloCislo:= false;

    while (Ukazovatko <= length (Obsah))
          and
          ( (Obsah[Ukazovatko] in ['+','-']) and not ZacloCislo
           or
          (Obsah[Ukazovatko] in  ['0'..'9']))  do
    begin
      ZacloCislo:= Obsah[Ukazovatko] in ['0'..'9'];
      inc(Ukazovatko)
    end;

    val(copy(Obsah, Zac, Ukazovatko - Zac), Cislo, Code);
    ChybaCteni:= Code <> 0;
    if ChybaCteni then DejLongInt:= 0
    else               DejLongInt:= Cislo
  end
end;




function TCtiRadekClass.DejReal: real48;
var
  Zac, Code: integer;
  Cislo: real48;

begin
  DejReal:= 0;

  if not ChybaCteni then
  begin
    while (Ukazovatko <= length (Obsah))  and
           not (Obsah[Ukazovatko] in ['+','-','.','0'..'9'])
          do inc(Ukazovatko);
    Zac:= Ukazovatko;
    while (Ukazovatko <= length (Obsah))  and
          (Obsah[Ukazovatko] in ['+','-','.','0'..'9'])
          do inc(Ukazovatko);
    val(copy(Obsah, Zac, Ukazovatko - Zac), Cislo, Code);
    ChybaCteni:= Code <> 0;
    if ChybaCteni then DejReal:= 0
    else               DejReal:= Cislo
  end
end;






function TCtiRadekClass.DejExtended: extended;
var
  Zac, Code: integer;
  Cislo: extended;

begin
  DejExtended:= 0;

  if not ChybaCteni then
  begin
    while (Ukazovatko <= length (Obsah))  and
          not (Obsah[Ukazovatko] in ['+','-','.','0'..'9'])
          do inc(Ukazovatko);
    Zac:= Ukazovatko;
    while (Ukazovatko <= length (Obsah))  and
          (Obsah[Ukazovatko] in ['+','-','.','0'..'9'])
          do inc(Ukazovatko);
    val(copy(Obsah, Zac, Ukazovatko - Zac), Cislo, Code);
    ChybaCteni:= Code <> 0;
    if ChybaCteni then DejExtended:= 0
    else               DejExtended:= Cislo
  end
end;






function TCtiRadekClass.DejDekodovanyReal: real48;
var
  I: integer;
  Cislo: real48;

begin
  DejDekodovanyReal:= 0;

  if not ChybaCteni then
  begin
    for I:= Ukazovatko to Ukazovatko + 3 do
      ChybaCteni:= not (Obsah[I] in ['?'..'~']);

    if not ChybaCteni then
    begin
      Cislo:= 0;
      for I:= Ukazovatko to Ukazovatko + 3 do
        Cislo:= Cislo * 64  +  ord(Obsah[I]) - 63;
      Cislo:= Cislo / 10;
      inc(Ukazovatko,4);
      DejDekodovanyReal:= Cislo
    end
    else DejDekodovanyReal:= 0
  end
end;




function TCtiRadekClass.DejBoolean: boolean;
var
  Znak: char;

begin
  repeat
    Znak:= upCase(DejChar)
  until (Znak in ['F','T','A','N','0','1']) or ChybaCteni;

  DejBoolean:= Znak in ['T','A','1'];
end;





END.
