unit U_string;
{
[Unit_Description]
Description=Funkce pro prci s etzci
Admin=Olda
TechTopic=Utilities
Topic=Text
Version=1.0
}

interface
uses
   Classes;


type
   TDelimiters = Set of ' '..'~';

var
   RootDirectory: string;
   DBTransLiterate: boolean;
   _USR: string = 'USR';

function     StringToInteger(S: string): integer;
function     WinDirStr: string;
function     ExecPath: string;
function     GetAbsolutePath(const relPath: string): string; overload;
function     GetAbsolutePath(const RootPath,relPath: string): string; overload;
function     IsRelativePath(const aPath: string): boolean;

{$IF RTLVersion < 22}   // XE
function     GetPString(var PS: PString): string;
procedure    SetPString(var PS: PString; const Str: string);
{$IFEND}

function     TakeFromApos(S: string): string;
function     BezVnejsichMezer(Retezec: string): string;
function     RemoveAllSpaces(Value: string): string;

procedure    SwapChars(var S: string; CH1, CH2: char);

function     CheckClassName(var aName: string): string;

function     IntToStrZ(Int: longInt; Width: integer; Zero: boolean): string;
function     IntToPrezStr(Int: longInt): string;
function     DoubleToStr(Real: double; Width, Prec: integer): string;

function     ChangeCharInString(var s: string; chOld, chNew: char; All: Boolean): boolean;
{ dopln zprava mezerami }
function     StrToStrSp(aStr: string; Width: integer): string;
function     StringIsFloat(S: string): boolean;

function     StrToLongInt(S: string): longInt;
function     StrToExtended(S: string): extended;

function     BoolToStr(aBool: boolean): string;
function     StrToBool(aStr: string): boolean;

function     CheckBackSlash(var Retezec: string): string;
function     AddBackSlash(var Retezec: string): string;
function     RemoveBackSlash(var Retezec: string): string;
function     StringAsParameter(s: string; var aName, aValue: string): boolean;
function     StringAsParameterWS(s: string; var aName, aValue: string): boolean;
function     StringAsParameterIgnoreBlock(s: string; var aName, aValue: string; BlockMarks: TDelimiters): boolean;
function     StringAsTwoParams(s: string; Delimiter: char; var Par1, Par2: string): boolean;
function     StringAsTwoParamsWS(s: string; Delimiter: char; var Par1, Par2: string): boolean;

function     ReadToDelimiter( S: string; Delimiters: TDelimiters;
                              Start: longInt;var Delimiter: char;
                              var Position: longInt): string;

function     ReadToDelimiterWithoutWS( S: string; Delimiters: TDelimiters;
                                     Start: longInt;var Delimiter: char;
                                     var Position: longInt): string;
function     ReadToDelimiterWithoutWSIgnoreBlock( S: string; Delimiters: TDelimiters; BlockMarks: TDelimiters;
                                     Start: longInt;var Delimiter: char;
                                     var Position: longInt): string;
function     GetNameWithoutNumber(aName: string): string;
function     GetNameEndNumber(aName: string): integer;
function     RomeToInteger(const Value: string): integer;
function     IntegerToRome(Value: integer): string;
(*
{$IFNDEF WIN32}
Procedure    PCharToList(Str2:PChar; List:TStringList; Prvni,Posledni:Char);
Function     StrParamCount(P:PChar; Prvni,Posledni:Char):word;
Function     StrScanN(Str:PChar; Chr:Char):PChar;
{$ENDIF}
*)
implementation


uses
   {!T_Main,}
   SysUtils,
   StrUtils
{$IFDEF MSWINDOWS}
   ,
   WinProcs;
{$ELSE}
   ;
{$ENDIF}

function   StringToInteger(S: string): integer;
var
   i: integer;
   res: string;
begin
   Result := 0;
   i := 1;
   res := '';
   if S <> '' then
   begin
      while not (i > Length(S)) and not (S[i] in ['0'..'9']) do Inc(i);
      while not (i > Length(S)) and (S[i] in ['0'..'9']) do
      begin
         res := res + S[i];
         Inc(i);
      end;
   end;
   Result := StrToIntDef(res,0);
end;


function     RomeToInteger(const Value: string): integer;
var
   S: string;
   i: integer;
   V: integer;
   LastV: integer;
   Mult: integer;
begin
   result := 0;
   if Value = '' then exit;
   S := UpperCase(Value);
   Mult := 1;
   LastV := 0;
   V := 0;
   for i := Length(S) downto 1 do
   begin
      case S[i] of
         'I': V := 1;
         'V': V := 5;
         'X': V := 10;
         'L': V := 50;
         'C': V := 100;
         'D': V := 500;
         'M': V := 1000;
      end;
      if V > LastV then
         Mult := 1
      else
      if V < LastV then
         Mult := -1;
      LastV := V;
      V := V * Mult;
      result := result + V;
   end;
end;

function     IntegerToRome(Value: integer): string;
var
   i: integer;
   ci: integer;
   S: string;

   function ProcessValue(aValue: integer; const aStr: string; Multi: boolean): boolean;
   begin
      if i >= aValue then
      begin
         if Multi then
         begin
            ci := i div aValue;
            i := i - (ci * aValue);
            S := S + DupeString(aStr,ci);
         end
         else
         begin
            i := i - aValue;
            S := S + aStr;
         end;
      end;
      result := i > 0;
   end;

begin
   i := Value;
   result := '';
   S := '';
   if ProcessValue(1000,'M',true) then
      if ProcessValue(900,'CM',false) then
         if ProcessValue(500,'D',false) then
            if ProcessValue(490,'XD',false) then
               if ProcessValue(400,'CD',false) then
                  if ProcessValue(100,'C',true) then
                     if ProcessValue(90,'XC',false) then
                        if ProcessValue(50,'L',false) then
                           if ProcessValue(40,'XL',false) then
                              if ProcessValue(10,'X',true) then
                                 if ProcessValue(9,'IX',false) then
                                    if ProcessValue(5,'V',false) then
                                       if ProcessValue(4,'IV',false) then
                                          ProcessValue(1,'I',true);
   result := S;
end;


function ExecPath: string;
begin
   result := ExtractFilePath(ParamStr(0));
   CheckBackSlash(result);
end;


function  IsRelativePath(const aPath: string): boolean;
begin
   result := (pos(':',aPath) = 0) and (pos('\\',aPath) <> 1);

end;

function   GetAbsolutePath(const relPath: string): string;
var
   S: string;
begin
   if RootDirectory <> '' then
   begin
      S := RootDirectory;
      CheckBackSlash(S);
   end
   else
      S := ExecPath;
   if relPath = '' then
   begin
      result := S;
      exit;
   end;
   if IsRelativePath(relPath) then
   begin
      result := S + relPath;
   end
   else
      result := relPath;
end;

function   GetAbsolutePath(const RootPath,relPath: string): string;
var
   S: string;
begin
   if RootPath = '' then
   begin
      result := GetAbsolutePath(relPath);
   end
   else
   begin
      S := RootPath;
      CheckBackSlash(S);
      if relPath = '' then
      begin
         result := S;
         exit;
      end;
      if IsRelativePath(relPath) then
      begin
         result := S + relPath;
      end
      else
         result := relPath;
   end;
end;


function WinDirStr: string;
type
  TDirStr          = array[0..100] of Char;
var
  PomDirStr: TDirStr;
begin
{$IFDEF MSWINDOWS}
  getWindowsDirectory(PomDirStr, sizeOf(TDirStr));
  result:= StrPas(PomDirStr);
{$ELSE}
  result := '';
{$ENDIF}
end;




function StrToLongInt(S: string): longInt;
var
  aCode: integer;
begin
  result:= 0;
  if S = '' then exit;
  val(S, result, aCode);
end;


function  StringIsFloat(S: string): boolean;
var
  Buffer: array[0..63] of Char;
  E: extended;
begin
  result := true;
  if not TextToFloat(StrPLCopy(Buffer, S, SizeOf(Buffer) - 1), E
{$IFDEF Win32} ,fvExtended {$ENDIF}
) then
  begin
    SwapChars(S, '.', ',');
    if not  TextToFloat(StrPLCopy(Buffer, S, SizeOf(Buffer) - 1), E
{$IFDEF Win32} ,fvExtended {$ENDIF}
    ) then
       result := false;
  end
end;




function StrToExtended(S: string): extended;
var
  Buffer: array[0..63] of Char;
begin
  if not TextToFloat(StrPLCopy(Buffer, S, SizeOf(Buffer) - 1), Result
{$IFDEF Win32} ,fvExtended {$ENDIF}
) then
  begin
    SwapChars(S, '.', ',');
    if not  TextToFloat(StrPLCopy(Buffer, S, SizeOf(Buffer) - 1), Result
{$IFDEF Win32} ,fvExtended {$ENDIF}
    ) then
       result := 0;
  end
end;

function     BoolToStr(aBool: boolean): string;
begin
  if aBool then result:= 'TRUE'
  else result:= 'FALSE'
end;

function     StrToBool(aStr: string): boolean;
begin
  result:= false;
  if aStr = '' then exit;
  result:= UpCase(aStr[1]) = 'T'
end;

function     CheckClassName(var aName: string): string;
begin
   if aName > '' then
   begin
      if UpperCase(aName[1]) <> 'T' then aName := 'T' + aName;
   end;
   result := aName;
end;


procedure    SwapChars(var S: string; CH1, CH2: char);
var
   Delimiters: TDelimiters;
   Pos: longInt;
   Delimiter: Char;
begin
   Delimiters := [CH1, CH2];
   ReadToDelimiterWithoutWS(S, Delimiters, 1, Delimiter, Pos);
   Dec(Pos);
   if Delimiter = #0 then exit;
   if (Pos < 1) or (Pos > Length(S)) then exit;
   if Delimiter = CH1 then S[Pos] := CH2
                      else S[Pos] := CH1;
end;


{$IF RTLVersion < 22}   // XE

function     GetPString(var PS: PString): string;
begin
   if not Assigned(PS) then result := ''
                       else result := PS^;
end;

procedure    SetPString(var PS: PString; const Str: string);
begin
   if assigned(PS) then disposeStr(PS);
   if Str <> '' then PS := NewStr(Str)
                else PS := nil;
end;
{$IFEND}


function     CheckBackSlash(var Retezec: string): string;
begin
   result:= '\';
   if Retezec = '' then exit;
   if Retezec[Length(Retezec)] <> '\' then Retezec := Retezec + '\';
   result := Retezec;
end;


function     AddBackSlash(var Retezec: string): string;
begin
   result:= '\';
   if Retezec = '' then exit;
   if Retezec[Length(Retezec)] <> '\' then Retezec := Retezec + '\';
   result := Retezec;
end;

function     RemoveBackSlash(var Retezec: string): string;
begin
  result:= '';
  if Retezec = '' then exit;
  if Retezec[Length(Retezec)] = '\' then Retezec := Copy(Retezec, 1, Length(Retezec)-1);
  result := Retezec;
end;



function  ChangeCharInString(var s: string; chOld, chNew: char; All: Boolean): boolean;
var
   PosCh: Integer;
begin
{Vasek 14.5.97}
   Result := False;
   if ((s = '') or (chOld = '')) then exit;

   PosCh := Pos(chOld , s);

   while PosCh > 0 do
   begin
      s[PosCh] := chNew;
      Result := True;

      if All then
         PosCh := Pos(chOld , s)
      else
         PosCh := 0;
   end;
end;



function     TakeFromApos(S: string): string;
begin
  result:= S;
  if S[1] <> '''' then exit;
  if S[length(S)] <> '''' then exit;
  result:= copy(S, 2, length(S)-2);
end;

function BezVnejsichMezer(Retezec: string): string;
var
  I: integer;
  aPom: integer;
begin
  result:= '';
  if Retezec = '' then exit;
  I:= 1;
  aPom:= length(Retezec);
  while (I <= aPom) and (Retezec[I] in [' ',#0]) do
     inc(I);
  if I > aPom then result:= ''
  else
  begin
    delete(Retezec, 1, I-1);
    while (length(Retezec) > 0) and (Retezec[length(Retezec)] in [' ',#0]) do
          SetLength(Retezec, Length(Retezec)-1);
    result:= Retezec
  end
end;

function     RemoveAllSpaces(Value: string): string;
var
  I: integer;
  //aPom: integer;
begin
  result:= '';
  if Value = '' then exit;
  for i := 1 to Length(Value) do
     if not (Value[I] in [' ',#0]) then result := result + Value[I];
end;

function IntToStrZ(Int: longInt; Width: integer; Zero: boolean): string;
begin
  if Zero then
     result:= Format('%*.*d', [Width,Width,Int])
  else
     result:= Format('%*d', [Width,Int])
end;


function     IntToPrezStr(Int: longInt): string;
var
  aStr: string;
  Oddel: string;
begin
  aStr:= '';
  Oddel:= '';

  repeat
    if Int >= 1000 then
       aStr:= IntToStrZ(Int mod 1000, 3, true) + Oddel + aStr
    else
       aStr:= IntToStr(Int mod 1000) + Oddel + aStr;

    Oddel:= ' ';
    Int:= Int div 1000;
  until not(Int > 0);

  result:= aStr
end;


function DoubleToStr(Real: double; Width, Prec: integer): string;
begin
  result:= Format('%*.*f',[Width,Prec,Real])
end;


function StrToStrSp(aStr: string; Width: integer): string;
var
  I: integer;
begin
  if length(aStr) >= Width then
     result:= copy(aStr, 1, Width)
  else
  begin
    result:= aStr;
    for I:= 1 to Width-length(aStr) do
    begin
      result:= result + ' '
    end
  end
end;


function StringAsParameter(s: string; var aName, aValue: string): boolean;
var
   i: byte;
begin
   result := false;
   aName  := '';
   aValue := '';
   i := pos('=', s);
   if i = 0 then
   begin
      aName := BezVnejsichMezer(s);
      exit;
   end;
   result := true;
   aName  := BezVnejsichMezer(Copy(s, 1, i - 1));
   aValue := BezVnejsichMezer(Copy(s, i + 1, length(s) - i));
end;

function StringAsParameterWS(s: string; var aName, aValue: string): boolean;
var
   i: byte;
begin
   result := false;
   aName  := '';
   aValue := '';
   i := pos('=', s);
   if i = 0 then
   begin
      aName := s;
      exit;
   end;
   result := true;
   aName  := Copy(s, 1, i - 1);
   aValue := Copy(s, i + 1, length(s) - i);
end;

function StringAsParameterIgnoreBlock(s: string; var aName, aValue: string; BlockMarks: TDelimiters): boolean;
var
   i: byte;
   Delimiter: char;
   Position: integer;
begin
   result := false;
   aName := ReadToDelimiterWithoutWSIgnoreBlock(S, ['='], BlockMarks, 1, Delimiter, Position);
   aValue := '';
   if Delimiter = '=' then
   begin
      result := true;
      aValue := BezVnejsichMezer(Copy(s, Position, length(s) - position + 1));
   end;
end;


function StringAsTwoParams(s: string; Delimiter: char; var Par1, Par2: string): boolean;
var
   i: byte;
begin
   result := false;
   Par1 := '';
   Par2 := '';
   i := pos(Delimiter, s);

   if i = 0 then
   begin
      Par1 := BezVnejsichMezer(s);
      exit;
   end;

   result := true;
   Par1   := BezVnejsichMezer(Copy(s, 1, i - 1));

   if i < length(s) then
      Par2   := BezVnejsichMezer(Copy(s, i + 1, length(s) - i));
end;

function StringAsTwoParamsWS(s: string; Delimiter: char; var Par1, Par2: string): boolean;
var
   i: byte;
begin
   result := false;
   Par1 := '';
   Par2 := '';
   i := pos(Delimiter, s);

   if i = 0 then
   begin
      Par1 := s;
      exit;
   end;

   result := true;
   Par1   := Copy(s, 1, i - 1);

   if i < length(s) then
      Par2   := Copy(s, i + 1, length(s) - i);
end;

function     ReadToDelimiter( S: string; Delimiters: TDelimiters;
                              Start: longInt;var Delimiter: char;
                              var Position: longInt): string;
begin
   result := '';
   Position := Start;
   Delimiter := #0;
   if S = '' then exit;

   while (Position <= length(S)) and not (S[Position] in Delimiters) do inc(Position);
  { ------------v-------- pridano !!!! }
   if Position <= length(S) then Delimiter := S[Position];
   if Start < Position then result := Copy(S, Start, Position - Start);
   inc(Position);
end;



function     ReadToDelimiterWithoutWS( S: string; Delimiters: TDelimiters;
                                     Start: longInt;var Delimiter: char;
                                     var Position: longInt): string;
begin
   result := '';
   Position := Start;
   Delimiter := #0;
   if S = '' then exit;

   while (Position <= length(S))and not(S[Position] in Delimiters) do inc(Position);
  { ------------v-------- pridano !!!! }
   if Position <= length(S) then Delimiter := S[Position];
   if Start < Position then result := BezVnejsichMezer(Copy(S, Start, Position - Start));
   inc(Position);
end;

function     ReadToDelimiterWithoutWSIgnoreBlock( S: string; Delimiters: TDelimiters; BlockMarks: TDelimiters;
                                     Start: longInt;var Delimiter: char;
                                     var Position: longInt): string;
var
   BlockMark: char;
   leng: integer;
begin
   result := '';
   Position := Start;
   Delimiter := #0;
   if S = '' then exit;
   leng := length(S);
   while (Position <= leng)and not((S[Position] in Delimiters) or (S[Position] in BlockMarks) )do inc(Position);
   if (position <= leng) and (S[position] in BlockMarks) then
   begin
      BlockMark := S[position];
      Inc(position);
      while (Position <= leng)and not (S[Position] = BlockMark) do inc(Position);
      if (position <= leng) and (S[Position] = BlockMark) then
      begin
         Inc(position);
         while (Position <= length(S))and not (S[Position] in Delimiters) do inc(Position);
      end;
   end;
  { ------------v-------- pridano !!!! }
   if Position <= leng then Delimiter := S[Position];
   if Start < Position then result := BezVnejsichMezer(Copy(S, Start, Position - Start));
   inc(Position);
end;


function GetNameWithoutNumber(aName: string): string;
var
  I: integer;
begin
{ hled zda na konci se nachz slo }
  result:= '';
  I:= length(aName);
  while (I>0) and (aName[I] in ['0'..'9']) do
    dec(I);
  if I = 0 then exit;
  if I = length(aName) then exit;
  result:= copy(aName, 1, I)
end;


function GetNameEndNumber(aName: string): integer;
var
  I: integer;
begin
{ hled zda na konci se nachz slo }
  result:= 0;
  I:= length(aName);
  while (I>0) and (aName[I] in ['0'..'9']) do
    dec(I);
  if I = 0 then exit;
  if I = length(aName) then exit;
  result:= StrToInt(copy(aName, I+1, 255));
end;



{$IFNDEF WIN32}
(*
procedure PCharToList(Str2:PChar; List:TStringList; Prvni,Posledni:Char);
var w,Size:word;
    Str,Pocatek,Konec,PS:Pchar;
    ss:string;
begin
     If (List=nil) or (Str2=nil) or (Prvni=#0) or (Posledni=#0) then Exit;
     If StrLen(Str2)<3 then Exit;

     Size:=StrLen(Str2)+1;
     GetMem(Str,Size);
     StrCopy(Str,Str2);

     w:=StrParamCount(Str,Prvni,Posledni);
     If w>0 then
     begin
          Pocatek:=Str;
          Repeat
                Konec:=StrScan(Pocatek,Prvni);
                If Konec<>nil then
                begin
                     Konec[0]:=#0;
                     PS:=StrNew(Pocatek); ss:=StrPas(PS);
                     List.Add(ss);
                     Konec[0]:=Prvni;
                     Konec:=StrScan(Konec,Posledni);
                     Konec:=StrScanN(Konec,Posledni);
                     Pocatek:=Konec;
                end;
          Until (Konec=nil) or (StrLen(Konec)=0);
     end;
     FreeMem(Str,Size);
end;

Function StrParamCount(P:PChar;Prvni,Posledni:Char):word;
var TmW:word;
    TP:PChar;
begin
     TmW:=0;
     TP:=P;
     While TP<>nil do
     begin
          TP:=StrScan(TP,Prvni);
          If TP<>nil then
          begin
               TP:=StrScan(TP,Posledni);
               If TP<>nil then Inc(TmW);
          end;
     end;
     StrParamCount:=TmW
end;

Function StrScanN(Str:PChar; Chr:Char):PChar; assembler;
asm
        cld
	les di,STR
	mov si,di
	mov cx,0ffffh
	xor al,al
	repne scasb
	not cx
	mov di,si
	mov al,CHR
@@2:    scasb
        jnz @@3
        loop @@2
@@3:    mov ax,0
	cwd
	jz @@1
	mov ax,di
	mov dx,es
	dec ax
@@1:
end;
*)
{$ENDIF}
INITIALIZATION
END.

