unit cpconvrt;

interface
uses
   u_xestring;

const

// pomocn konstanty
Orbis_cp_UNKNOWN = 0;
Orbis_cp_MULTI   = 3;
Orbis_cp_IBM     = 2;
Orbis_cp_WIN     = 1250;
Orbis_cp_852     = 852;
Orbis_cp_KAM     = 1;

function WinTo_8859_2(const s: _xstring): _xstring;
function _8859_2ToWin(const s: _xstring): _xstring;

function WinTo852(const s: _xstring): _xstring;
function cp852ToWin(const s: _xstring): _xstring;
function WinToKAM(const s: _xstring): _xstring;
function WinToIBM(const s: _xstring): _xstring;

function cp_IsWin(const s: _xstring): boolean;
function cp_Is852(const s: _xstring): boolean;
function cp_IsKam(const s: _xstring): boolean;
function cp_IsIBM(const s: _xstring): boolean;

function cp_GetCodePage(const s: _xstring): integer;

implementation

const

cp_Win: _xstring    = '̼؊َ';
cp_8859_2: _xstring = '̼ةٮ';
cp_KAM: _xstring    = 'L';
cp_852: _xstring    = '֑ҷަ眅';
cp_IBM: _xstring    = 'AEILORUYaeiloruyCDELNORSTUZcdenorstuzl';


function cp_IsIBM(const s: _xstring): boolean;
var
   i: integer;
begin
   result := true;
   for i := 1 to Length(s) do
   begin
      if Ord(s[i]) > 128 then
      begin
         result := false;
         exit;
      end;
   end;
end;


function cp_IsWin(const s: _xstring): boolean;
var
   i: integer;
begin
   result := true;
   for i := 1 to Length(s) do
   begin
      if Ord(s[i]) > 128 then
         if Pos(s[i],cp_Win) = 0 then
         begin
            result := false;
            exit;
         end;
   end;
end;

function cp_Is852(const s: _xstring): boolean;
var
   i: integer;
begin
   result := true;
   for i := 1 to Length(s) do
   begin
      if Ord(s[i]) > 128 then
         if Pos(s[i],cp_852) = 0 then
         begin
            result := false;
            exit;
         end;
   end;
end;

function cp_IsKam(const s: _xstring): boolean;
var
   i: integer;
begin
   result := true;
   for i := 1 to Length(s) do
   begin
      if Ord(s[i]) > 128 then
         if Pos(s[i],cp_KAM) = 0 then
         begin
            result := false;
            exit;
         end;
   end;
end;

function cp_GetCodePage(const s: _xstring): integer;
var
   i: integer;
   Win,Lat,Kam: boolean;
begin
   Win := true;
   Lat := true;
   Kam := true;
   result := Orbis_cp_IBM;
   for i := 1 to Length(s) do
   begin
      if Ord(s[i]) > 128 then
      begin
         if Win then
         if Pos(s[i],cp_WIN) = 0 then
            Win := false;
         if Lat then
         if Pos(s[i],cp_852) = 0 then
            Lat := false;
         if Kam then
         if Pos(s[i],cp_Kam) = 0 then
            Kam := false;
         result := Orbis_cp_Multi;
         if Win and not(Lat or Kam) then
         begin
            result := Orbis_cp_Win;
            exit;
         end
         else
         if Kam and not(Lat or Win) then
         begin
            result := Orbis_cp_Kam;
            exit;
         end
         else
         if Lat and not(Win or Kam) then
         begin
            result := Orbis_cp_852;
            exit;
         end;
       end;
   end;
end;

function WinTo_8859_2(const s: _xstring): _xstring;
var
   ch: _xChar;
   i: integer;
   n: integer;
begin
   result := s;
   if result = '' then exit;
   for i := 1 to length(result) do
   begin
       ch := result[i];
       n := Pos(ch,cp_Win);
       if n > 0 then
       begin
          ch := cp_8859_2[n];
          result[i] := ch;
       end;
   end;
end;

function _8859_2ToWin(const s: _xstring): _xstring;
var
   ch: _xChar;
   i: integer;
   n: integer;
begin
   result := s;
   if result = '' then exit;
   for i := 1 to length(result) do
   begin
       ch := result[i];
       n := Pos(ch,cp_8859_2);
       if n > 0 then
       begin
          ch := cp_Win[n];
          result[i] := ch;
       end;
   end;
end;



function WinTo852(const s: _xstring): _xstring;
var
   ch: _xChar;
   i: integer;
   n: integer;
begin
   result := s;
   if result = '' then exit;
   for i := 1 to length(result) do
   begin
       ch := result[i];
       n := Pos(ch,cp_Win);
       if n > 0 then
       begin
          ch := cp_852[n];
          result[i] := ch;
       end;
   end;
end;


function cp852ToWin(const s: _xstring): _xstring;
var
   ch: _xChar;
   i: integer;
   n: integer;
begin
   result := s;
   if result = '' then exit;
   for i := 1 to length(result) do
   begin
       ch := result[i];
       n := Pos(ch,cp_852);
       if n > 0 then
       begin
          ch := cp_Win[n];
          result[i] := ch;
       end;
   end;
end;


function WinToKAM(const s: _xstring): _xstring;
var
   ch: _xChar;
   i: integer;
   n: integer;
begin
   result := s;
   if result = '' then exit;
   for i := 1 to length(result) do
   begin
       ch := result[i];
       n := Pos(ch,cp_Win);
       if n > 0 then
       begin
          ch := cp_KAM[n];
          result[i] := ch;
       end;
   end;
end;


function WinToIBM(const s: _xstring): _xstring;
var
   ch: _xChar;
   i: integer;
   n: integer;
begin
   result := s;
   if result = '' then exit;
   for i := 1 to length(result) do
   begin
       ch := result[i];
       n := Pos(ch,cp_Win);
       if n > 0 then
       begin
          ch := cp_IBM[n];
          result[i] := ch;
       end;
   end;
end;

(*

function BezHacku(s:_xstring):String;
var i:integer;
ch:CHar;
 begin
  for i:=1 to length(s) do
   begin
    ch:=S[i];
    case ch of
    '':S[i]:='u';
    '':S[i]:='c';
    '':S[i]:='i';
    '':S[i]:='r';
    '':S[i]:='e';
    '':S[i]:='d';
    '':S[i]:='u';
    '':S[i]:='s';
    '':S[i]:='a';
    '':S[i]:='z';
    '':S[i]:='y';
    '':S[i]:='t';
    '':S[i]:='e';
    '':S[i]:='U';
    '':S[i]:='C';
    '':S[i]:='I';
    '':S[i]:='R';
    '':S[i]:='E';
    '':S[i]:='D';
    '':S[i]:='U';
    '':S[i]:='S';
    '':S[i]:='A';
    '':S[i]:='Z';
    '':S[i]:='Y';
    '':S[i]:='T';
    '':S[i]:='E';
    end; { case }
   end;
  result:=S;
 end;
end.

*)
END.
