unit e_Sort;

interface
uses
   Elements;

type

{ TODO -oPPK -cDodlat : SortEntity zobecnit a vubec dodelat }
// v prvnim priblizeni jednoduchy sort a vyhledavani podle Name (jako classes)

TSortedEntity = class(TOwnerEntity)
private
    FIndex: integer;
protected
    function    FindIndex(const aName: string; var NearestRight: integer): integer;
public
    function    FindElementName(aName: string): TElement; override;
    procedure   AddElement(aElement: TElement); override;
end;

implementation
uses
   SysUtils,
   e_Class;

{ TSortedEntity }

procedure TSortedEntity.AddElement(aElement: TElement);
var
   i: integer;
   S: string;
begin
   if aElement = nil then exit;
   S := aElement.Name;
   FindIndex(S, i);
   if i > -1 then InsertElement(i, aElement)
             else inherited;
   aElement.ID := FIndex;
   inc(FIndex);
end;

function TSortedEntity.FindElementName(aName: string): TElement;
var
   i, ri: longInt;
begin
   result := nil;
   i := FindIndex(aName, ri);
   if i > -1 then
   begin
      result := Elements[i];
   end;
end;

function TSortedEntity.FindIndex(const aName: string; var NearestRight: integer): integer;
var
   L,R,C: integer;
   LResult, RResult, CResult: integer;
begin
   result := -1;
   NearestRight := -1;
   if NoElements then exit;
   L := 0;
   R := Count - 1;
   RResult := AnsiCompareText(aName, Elements[R].Name);
   if (RResult > 0) then exit;
   if RResult = 0 then
   begin
      result := R;
      exit;
   end;
   if R > L then
   begin
      LResult := AnsiCompareText(aName, Elements[L].Name);
      if (LResult < 0) then
      begin
         NearestRight := L;
         exit;
      end;
      if LResult = 0 then
      begin
         result := L;
         NearestRight := L + 1;
         exit;
      end;
   end
   else
   begin
      NearestRight := L;
      exit;
   end;
   repeat
      NearestRight := R;
      if R - L <= 1 then exit;
      C := ((R - L) div 2) + L;
      CResult := AnsiCompareText(aName, Elements[C].Name);
      if CResult < 0 then R := C else
      if CResult > 0 then L := C else
      begin
         result := C;
         NearestRight := C + 1;
         exit;
      end;
   until L >= R;
end;

INITIALIZATION
   RegisterOrbisClass(TSortedEntity);
END.
