unit T_HelTez;

interface
uses
// KERNEL
  Elements,
  Tools,
// GLIB
  g_elems,
// SPACE
  e_Space,
  T_HelSel;

type

THeleNactiTez = class(THeleNacti)
private
  FTEZTemp: TEntity;
  function GetPSKByAttribs(anAre: TAreaElement;  var JeToPSK: boolean): TRectEntity;
  function GetPSKBySpace(anAre: TAreaElement;  var JeToPSK: Boolean;
                         var aLHC, aOdd, aDil, aPor, aPSK: string): TRectEntity;
  procedure AddTezToPSK(JeToPSK: Boolean; aPSK: TRectEntity; aAre: TAreaElement);
public
  procedure DoIt; override;
  procedure NactiTez;
end;



THeleClearTez = class(THeleBasic)
private
  function  GetEntituTezby(aName: string): TRectEntity;
  procedure ExtractTezbaAreas;
  function  GetGlobalTezba: TREctEntity;
  procedure JoinLines;
  procedure MakeNewAreas;
public
  procedure DoIt; override;
published
  property GlobalTezba: TREctEntity read GetGlobalTezba;
end;



TExtractTezba = class(THeleBasic)
public
  procedure DoIt; override;
end;

implementation
uses
  Dialogs, SysUtils,
// KERNEL
  e_Class,
// OIL
  T_SelectByName,
  T_Helhie,
// SPACE
   E_Reg,
// SPACETOOL
   T_ToTool,
   T_LinJoi,
// TOPOL
   e_TplPrp,
   T_CopBlk,
// LHC
   e_LhcProps;



procedure THeleNactiTez.AddTezToPSK(JeToPSK: Boolean; aPSK: TRectEntity; aAre: TAreaElement);
var
  aTezba: TRectEntity;
  aTP: TTezPProps;
  aP: TTopolAreaProps;
begin
  if JeToPSK then
     aTezba:= TRectEntity(aPSK.FindElementName('T̎BA'))
  else
     aTezba:= TRectEntity(aPSK.FindElementName('T̎BA NEZAAZEN'));

  if aTezba = nil then
  begin
    aTezba:= TRectEntity.Create;
    if JeToPSK then
       aTezba.Name:= 'T̎BA'
    else
       aTezba.Name:= 'T̎BA NEZAAZEN';

    aPSK.AddElement(aTezba);
  end;

  if not (aAre.Properties is TTezPProps) then
  begin
    aTP:= TTezPProps.Create;
    if aAre.Properties = nil then
    begin
      aAre.Properties:= aTP;
      aTP.Druh:= 135
    end
    else
    begin
      if aAre.Properties is TTopolAreaProps then
      begin
        aP:= TTopolAreaProps(aAre.Properties);
        aTP.Cislo      := aP.Cislo;
        aTP.Druh       := aP.Druh;
        aTP.Barva      := aP.Barva;
        aTP.Znacka     := aP.Znacka;
        aTP.Vyber      := aP.Vyber;
        aTP.Presnost   := aP.Presnost;
        aTP.Symbol     := aP.Symbol;
        aTP.IsDone     := aP.IsDone;

        aTP.LineNo     := aP.LineNo;
        aTP.PaterNo    := aP.PaterNo;
        aTP.HasChildren:= aP.HasChildren;

        aTP.Nalehavost:= aP.GetPropertyLongIntByName('NALEHAVOST');
        aTP.Zpusob:= aP.GetPropertyLongIntByName('ZPUSOB');

        aAre.Properties:= aTP
      end;
    end
  end;

  aTezba.AddAndUpdateRect(aAre);
  aPSK.UpdateRect(aAre);
end;


procedure THeleNactiTez.DoIt;
begin
   inherited;
   NactiTez;
end;


function THeleNactiTez.GetPSKBySpace(anAre: TAreaElement;  var JeToPSK: Boolean;
                                     var aLHC, aOdd, aDil, aPor, aPSK: string): TRectEntity;
var
  HelSku: THeleSkupina;

begin
  Result:= nil;
  JeToPSK:= false;

  HelSku:= THeleSkupina.Create;
  HelSku.Input:= Hierarchy;
  HelSku.X:= anAre.X;
  HelSku.Y:= anAre.Y;
  HelSku.DoIt;
  if not HelSku.Found then
  begin
    HelSku.Free;
    Exit;
  end;

  aLHC := HelSku.LHC;
  aOdd := HelSku.Odd;
  aDIL := HelSku.Dil;
  aPOR := HelSku.Por;
  aPSK := HelSku.PSK;

  result:= HelSku.PSKObject;
  JeToPSK:= Result <> nil;
  HelSku.Free;
end;



function THeleNactiTez.GetPSKByAttribs(anAre: TAreaElement;  var JeToPSK: boolean): TRectEntity;
var
  THH: THeleHier;
  aLHC, aOdd, aDil, aPor, aPSK: string;

  procedure AddToProtocol(aStr: string);
  begin
     Protocol:= 'Zaazovn tebn plochy, plocha .' + IntToStr(anAre.SpaceId) +
                aStr
  end;

begin
  Result:= nil;
  JeToPSK:= false;

  aLHC := anAre.GetPropertyStringByName('LHC');
  aOdd := anAre.GetPropertyStringByName('ODDELENI');
  aDIL := anAre.GetPropertyStringByName('DILEC');
  aPOR := anAre.GetPropertyStringByName('POROST');
  aPSK := anAre.GetPropertyStringByName('SKUPINA');

  THH := THeleHier.Create;
  THH.Input := Hierarchy;
  THH.LHC := aLHC;

  if THH.LHC = '' then
  begin
    AddToProtocol(' nelze zaadit kd LHC ' + aLHC);
  end
  else
  begin
    THH.ODD := aODD;
    if THH.ODD = '' then
    begin
      AddToProtocol(' nelze zaadit kd oddlen ' + aLHC + ' ' + aODD);
    end
    else
    begin
      THH.DIL := aDIL;
      if THH.DIL = '' then
      begin
        AddToProtocol(' nelze zaadit kd dlce ' + aLHC + ' ' + aODD + ' ' + aDIL);
      end
      else
      begin
        THH.POR := aPOR;
        if THH.POR = '' then
        begin
          AddToProtocol(' nelze zaadit kd porostu ' + aLHC + ' ' + aODD + ' ' + aDIL + ' ' + aPOR);
        end
        else
        begin
          THH.PSK := aPSK;
          if THH.PSK = '' then
          begin
            AddToProtocol(' nelze zaadit kd skupiny ' + aLHC + ' ' + aODD + ' ' + aDIL + ' ' + aPOR + ' ' + aPSK);
          end
          else
            JeToPSK:= true
        end
      end
    end
  end;

  THH.DoIt;
  result := TrectEntity(THH.Output);
  if result = nil then
     result:= Hierarchy
end;



procedure THeleNactiTez.NactiTez;
var
  I: integer;
  aHier: TEntity;
  aP: TTopolAreaProps;
  aAre: TAreaElement;
  aPSKAttribs: TRectEntity;
  aPSKSpace  : TRectEntity;
  JeToPSKA: Boolean;
  JeToPSKS: Boolean;
  aNeTezba: TRectEntity;
  aLHC, aOdd, aDil, aPor, aPSK: string;
  BlockRegister: TBlockRegister;

begin
  NajdiVrstvu(FTezTemp, 'TEZ', 'ARE');

  if not(FTEZTEMP is TAreaString) then exit;
  if FTEZTemp.Count = 0 then exit;

  aHier:= Hierarchy;
  if aHier =nil then Exit;

  aNeTezba:= CreateDataRectEntitu('NEZAAZEN T̎BA');

  try
  for I:= 0 to FTezTemp.Count-1 do
  begin
    aAre:= TAreaElement(FTezTemp.elements[I]);
    if I = 0 then
    begin
      aP:= TTopolAreaProps(aAre.Properties);
      if TObject(aP) is TTopolAreaProps then
      begin
        BlockRegister:= aP.BlockRegister;
      end;
    end;

    if not (TObject(aAre) is TAreaElement) then
       continue;
    aPSKAttribs:= GetPSKByAttribs(aAre, JeToPSKA);
    aPSKSpace:= GetPSKBySpace(aAre, JeToPSKS, aLHC, aOdd, aDil, aPor, aPSK);

    if (aPSKAttribs = aPSKSpace) and (aPSKAttribs <> nil) then
    begin
      AddTezToPSK(JeToPSKS, aPSKAttribs, aAre)
    end
    else
    if (aPSKSpace <> nil) then
    begin
      AddTezToPSK(JeToPSKS, aPSKSpace, aAre);
      Protocol:= 'Zaazovn tebn plochy, plocha .' + IntToStr(aAre.SpaceId) +
                  '  zaazena dle prostoru do ' + aLHC + ' ' + aOdd + ' ' + aDil + ' ' + aPor + ' ' + aPSK
    end
    else
    if (aPSKAttribs <> nil) then
    begin
      AddTezToPSK(JeToPSKA, aPSKAttribs, aAre);
      Protocol:= 'Zaazovn tebn plochy, plocha .' + IntToStr(aAre.SpaceId) +
                 ' zaazovn pes atributy - pod touto plochou nele regulrn PSK'
    end
    else
    if aPSKAttribs = nil then
    begin
      Protocol:= 'Zaazovn tebn plochy, plocha .' + IntToStr(aAre.SpaceId) +
                 ' ani pes prostor. vztahy ani pes atributy nelze najt PSK';
      aNeTezba.AddAndUpdateRect(aAre);
      continue
    end
  end;
  BlockRegister.Free;


  except
    ShowMessage('Chyba pi zaazovn ploch tby');
  end;

// zruseni tezby v registru

end;


                    { THeleClearTez }

function THeleClearTez.GetEntituTezby(aName: string): TRectEntity;
var
  aTezba: TRectEntity;

begin
  Result:= nil;
  aTezba:= GlobalTezba;
  if not (TObject(aTezba) is TRectEntity) then
     Exit;
  Result:= TRectEntity(aTezba.findElementName(aName));
  if Result = nil then
  begin
    Result:= TRectEntity.Create;
    Result.Name:= aName;
    aTezba.AddElement(Result)
  end;
end;



procedure THeleClearTez.ExtractTezbaAreas;
var
  aTezba: TRectEntity;
  aTez: TRectEntity;
  I, J: integer;
  aPlochyTezby: TRectEntity;
  aPlocha: TAreaElement;
begin
  aTezba:= GlobalTezba;
  if not (TObject(aTezba) is TRectEntity) then
     Exit;
  aPlochyTezby:= TRectEntity(GetEntituTezby('PLOCHYTEZBY'));
  if aPlochyTezby.Count > 0 then
     aPlochyTezby.FreeAll;

  for I:= aTezba.Count-1 downto 0 do
  begin
    aTez:= TRectEntity(aTezba.Elements[I]);
    if not (TObject(aTez) is TRectEntity) then
       continue;
    if aTez.Name <> 'T̎BA' then
       continue;
    for J:= 0 to aTez.Count-1 do
    begin
      aPlocha:= TAreaElement(aTez.Elements[J]);
      if not (TObject(aPlocha) is TAreaElement) then
         continue;
      aPlochyTezby.AddAndUpdateRect(aPlocha);
    end;
    aTez.Free;
  end;
end;




procedure THeleClearTez.JoinLines;
var
  aSource: TRectEntity;
  aLines: TRectEntity;
  JL: TJoinLines;
  HL: THledacLinii;
  PomLin: TSpaceEntity;
begin
  aSource:= GetEntituTezby('PLOCHYTEZBY');
  if aSource = nil then
     Exit;
  if aSource.Count = 0 then
     Exit;

{ naten blok pro generovn _20VOD.BLK }

  PomLin:= TSpaceEntity.Create;
  HL:= THledacLinii.Create;
  HL.Input:= aSource;
  HL.Output:= PomLin;
  HL.DoIt;

  HL.Free;

  JL:= TJoinLines.Create;
  JL.Input:= PomLin;
  JL.SnapDistance:= 1;
  JL.SelfTest:= false;
  JL.DoIt;
  PomLin.Free;


  aLines:= GetEntituTezby('LINIETEZBY');
  if aLines = nil then
     Exit;
  if aLines.Count > 0 then
     aLines.FreeAll;

  HL:= THledacLinii.Create;
  HL.Input:= JL.Output;
  HL.Output:= aLines;
  HL.DoIt;
  HL.Free;

  JL.Free;
  aLines.Update;
end;



procedure THeleClearTez.MakeNewAreas;
var
  aLines: TRectEntity;
  aAreas: TRectEntity;
  MNAA: TMakeNodesAndAreas;

begin
  aLines:= GetEntituTezby('LINIETEZBY');
  aAreas:= GetEntituTezby('NOVEPLOCHYTEZBY');

  MNAA:= TMakeNodesAndAreas.Create;
  MNAA.Input:= aLines;
  MNAA.DoIt;
  aAreas.AddElement(MNAA.Output);
  MNAA.Free;
end;



procedure THeleClearTez.DoIt;
var
  aTezba: TRectEntity;
begin
  {test existence Tby }
  aTezba:= GlobalTezba;
  if not (TObject(aTezba) is TRectEntity) then
     Exit;
  { vyjmut tebnch ploch a smazn tby z porostnch skupin }
  ExtractTezbaAreas;
  { spojen lini }
  JoinLines;

  { nov zaplochovn }
  MakeNewAreas;
{
  MNAA:= TMakeNodesAndAreas.Create;
  MNAA.Input:= aTez;
  MNAA.DoIt;
  aPlochy:= TAreaString(MNAA.Output);
  MNAA.Free;

  if aPlochy = nil then
     Exit;

  CAAL:= TCarryArToArThroughLines.Create;
  CAAL.Input:= aPlochy;
  CAAL.ProtocolFile:= '';
  CAAL.SelectForProblem:=true;
  CAAL.DoIt;
  CAAL.Free;
}
end;



function THeleClearTez.GetGlobalTezba: TREctEntity;
begin
  result:= TRectEntity(DejDATAEntitu('T̎BA'));
end;

{ TExtractTezba }


procedure TExtractTezba.DoIt;
var
  aTezba: TRectEntity;
  aHier: TRectEntity;
  SBN: TSelectByName;

begin
  aTezba:= CreateDataRectEntitu('T̎BA');

  if not(aTezba is TRectEntity) then
     Exit;
  aTezba.FreeAll;
  aHier:= Hierarchy;

  SBN:= TSelectByName.Create;
  SBN.CaseSensitive:= False;
  SBN.SelectedName:='T̎BA';
  SBN.Input := aHier;
  SBN.Partialy:= false;
  SBN.Output:= aTezba;
  SBN.DoIt;
  SBN.Output.Name := 'T̎BA';
  SBN.Free;

  aTezba.Update;
end;


begin
  RegisterOrbisClass(THeleNactiTez);
  RegisterOrbisClass(THeleClearTez);
  RegisterOrbisClass(TExtractTezba);
end.

