unit f_Synchronize_TABLE_ParcelModel;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, DB, DBTables, Gauges,
  e_KatastrModel,Tools;

type
  TSynchronize_Table_ParcelModel_Form = class(TForm)
    OpenDialog: TOpenDialog;
    Table: TTable;
    Panel1: TPanel;
    Label1: TLabel;
    ed_TableName: TEdit;
    SpeedButton1: TSpeedButton;
    Panel2: TPanel;
    ed_Katastr: TComboBox;
    ed_PARCIS: TComboBox;
    ed_PARPOD: TComboBox;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    ed_Parskukn: TComboBox;
    Label5: TLabel;
    p_Dioda: TPanel;
    Panel3: TPanel;
    Label6: TLabel;
    Label7: TLabel;
    ed_Vymera: TComboBox;
    ed_KatparKod: TComboBox;
    ed_LV: TComboBox;
    ed_LVC: TComboBox;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Panel4: TPanel;
    ed_Kultura: TComboBox;
    Label12: TLabel;
    Gauge: TGauge;
    Panel5: TPanel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    l_Err: TLabel;
    cb_Kat: TCheckBox;
    Label13: TLabel;
    ed_PUPFL: TComboBox;
    cb_boolAsText: TCheckBox;
    Label14: TLabel;
    Edit1: TEdit;
    ed_1: TComboBox;
    Edit2: TEdit;
    ed_2: TComboBox;
    Edit3: TEdit;
    ed_3: TComboBox;
    cb_Protocol: TCheckBox;
    pkpanel: TPanel;
    Label15: TLabel;
    ed_PKPOD: TComboBox;
    Label16: TLabel;
    ed_PKCIS: TComboBox;
    Label17: TLabel;
    ed_Vlastnik: TComboBox;
    cb_PK0: TCheckBox;
    cb_FillSumVym: TCheckBox;
    cb_SKP: TCheckBox;
    cb_OneKU: TCheckBox;
    combo_KU: TComboBox;
    ed_PK_Dil: TComboBox;
    Label18: TLabel;
    cb_pupflc: TCheckBox;
    cb_TestOnly: TCheckBox;
    ed_KATUZE_KOD_PUV: TComboBox;
    Label19: TLabel;
    cb_NoLED: TCheckBox;
    procedure SpeedButton1Click(Sender: TObject);
    procedure ed_TableNameChange(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure cb_KatClick(Sender: TObject);
    procedure cb_ProtocolClick(Sender: TObject);
    procedure cb_SKPClick(Sender: TObject);
    procedure cb_TestOnlyClick(Sender: TObject);
  private
    FFieldList: TStringList;
    FParcelModel: Tgis_ParcelModel;
    FProtocol: boolean;
    FTool: TTool;
    FProtTop: integer;
    FOneKU: Tgis_Katastr;
    procedure SetFieldList(const Value: TStringList);
    procedure SetParcelModel(const Value: Tgis_ParcelModel);
    procedure SetProtocol(const Value: boolean);
    procedure SetTool(const Value: TTool);
    procedure SetOneKU(const Value: Tgis_Katastr);
    { Private declarations }
  public
     procedure DoIt;
     function  Check: boolean;
     procedure FillFieldList;
     property  OneKU: Tgis_Katastr read FOneKU write SetOneKU;
     property FieldList: TStringList read FFieldList write SetFieldList;
     property ParcelModel: Tgis_ParcelModel read FParcelModel write SetParcelModel;
     property Protocol: boolean read FProtocol write SetProtocol;
     property Tool: TTool read FTool write SetTool;
  end;


implementation
uses
   Elements,
   m_Orbis,
   Worlds;

{$R *.dfm}

procedure TSynchronize_Table_ParcelModel_Form.SpeedButton1Click(
  Sender: TObject);
begin
   if OpenDialog.Execute then
   begin
      ed_TableName.Text := OpenDialog.FileName;
   end;
end;

procedure TSynchronize_Table_ParcelModel_Form.ed_TableNameChange(
  Sender: TObject);
begin
   p_Dioda.Color := clRed;
   if FileExists(ed_TableName.Text) then
   begin
      Table.Close;
      Table.TableName := ed_TableName.Text;
      Table.Open;
      if Table.Active then
         p_Dioda.Color := clLime;
      if not Table.Active then exit;
      FillFieldList;
   end;
end;

procedure TSynchronize_Table_ParcelModel_Form.FormDestroy(Sender: TObject);
begin
   FieldList := nil;
end;

procedure TSynchronize_Table_ParcelModel_Form.SetFieldList(
  const Value: TStringList);
begin
   if FFieldList <> nil then
      FFieldList.Free;
   FFieldList := Value;
end;

procedure TSynchronize_Table_ParcelModel_Form.FormCreate(Sender: TObject);
begin
   FieldList := TStringList.Create;
end;

procedure TSynchronize_Table_ParcelModel_Form.FillFieldList;
var
   i: integer;
begin
   if not Table.Active then exit;
   FieldList.Clear;
   Table.First;
   for i := 0 to Table.FieldCount - 1 do
   begin
      FieldList.Add(Table.Fields.Fields[i].FieldName);
   end;
   ed_Katastr.Items.Assign(FieldList);
   ed_PARCIS.Items.Assign(FieldList);
   ed_PARPOD.Items.Assign(FieldList);
   ed_KATUZE_KOD_PUV.Items.Assign(FieldList);
   ed_PKCIS.Items.Assign(FieldList);
   ed_PKPOD.Items.Assign(FieldList);
   ed_PK_Dil.Items.Assign(FieldList);
   ed_ParSkuKn.Items.Assign(FieldList);
   ed_Vymera.Items.Assign(FieldList);
   ed_KatparKod.Items.Assign(FieldList);
   ed_LV.Items.Assign(FieldList);
   ed_LVC.Items.Assign(FieldList);
   ed_Kultura.Items.Assign(FieldList);
   ed_PUPFL.Items.Assign(FieldList);
   ed_Vlastnik.Items.Assign(FieldList);
   ed_1.Items.Assign(FieldList);
   ed_2.Items.Assign(FieldList);
   ed_3.Items.Assign(FieldList);
end;

procedure TSynchronize_Table_ParcelModel_Form.BitBtn1Click(
  Sender: TObject);
begin
   if not CHeck then exit;
   DoIt;
end;

procedure TSynchronize_Table_ParcelModel_Form.DoIt;
var
   i,ii,iii: integer;
   UseDruhParcely: boolean;
   UseKATUZEPUV: boolean;
   UsePK: boolean;
   UsePKDil: boolean;
   UseKNDil: boolean;
   _K: Tgis_Katastr;
   _SKP: Tgis_SkupinaParcel;
   Katastr: integer;
   SKupinaParcel: integer;
   KatS: string;
   Parcis: integer;
   Parpod: integer;
   KATUZEPUV: integer;
   PKcis: integer;
   PKpod: integer;
   PKDil: integer;
   ParSkuKn: integer;
   Vymera: double;
   KatParKod: integer;
   LV: integer;
   KvalP: integer;
   Kultura: integer;
   F: TField;
   Errors,PCErrors: integer;
   P: Tgis_Parcela;
   PC,NextPC: Tgis_ParcelaCast;
   K: boolean;
   SKP: boolean;
   OE,OEPK,MultiPK,PCs: TOwnerEntity;
   PCNotFound: boolean;
   M: Tgis_Majitel;
   Vlastnik: string;
   MM: Tgis_Majitele;
   e: TElement;
   SLErr: TStringList;
   KU1: integer;
   By1KU: boolean;
   S: string;
   STest: string;
   SPTest: string;
   TestHeader: boolean;
   TestError: boolean;
   pupflc: boolean;
   apupfl: string;
   TestOnly: boolean;
   aGP: boolean;
   SGP: string;

procedure SetForPC(S1,S2: string);
var
  i:integer;
  e: TElement;
begin
   for i := 0 to P.LastIndex do
   begin
      e := P.Elements[i];
      if not (e is Tgis_ParcelaCast) then continue;
      e.SetPropertyStringByName(S1,S2);
   end;
end;
procedure WriteTestHeader;
begin
   if TestHeader then
      exit;
   if Protocol then
   begin
      S := ' Vlastnosti: '+IntToStr(Katastr)+','+IntToStr(Parcis)+'/'+IntToStr(ParPod);
      if UseKATUZEPUV then
         S := S+'\'+IntToStr(KATUZEPUV);
      if PC <> nil then
      begin
         if not UseKNDil then
            S := S + ' PK: '+IntToStr(PKcis)+'/'+IntToStr(PKPod);
         if UsePKDil then
            S := S + ' Dil:'+ IntToStr(PKDil);
         if not Pcs.NoElements  then
            S := S + ' n:' + IntToStr(Pcs.Count + 1)
      end;
      Tool.PostTextMsg(tm_AddToProtocol,S,nil);
      Application.ProcessMessages;
   end;
   TestHeader := true;
end;

procedure TestFloat(F1,F2,Tolerance: double);
begin
   if Abs(F1-F2) > Tolerance then
   begin
      WriteTestHeader;
      if Protocol then
      begin
         Tool.PostTextMsg(tm_AddToProtocol,STest+SPTest+' DB '+FloatToStr(F1)+ ' LED '+FloatToStr(F2),nil);
         Application.ProcessMessages;
      end;
   end;
end;

procedure TestInteger(F1,F2: integer);
begin
   if F1 <> F2 then
   begin
      WriteTestHeader;
      if Protocol then
      begin
         Tool.PostTextMsg(tm_AddToProtocol,STest+SPTest+' DB '+IntToStr(F1)+ ' LED '+IntToStr(F2),nil);
         Application.ProcessMessages;
      end;
   end;
end;

procedure TestBoolean(F1,F2: boolean);
begin
   if F1 <> F2 then
   begin
      WriteTestHeader;
      if Protocol then
      begin
         Tool.PostTextMsg(tm_AddToProtocol,STest+SPTest+' DB '+BoolToStr(F1,true)+ ' LED '+BoolToStr(F2,true),nil);
         Application.ProcessMessages;
      end;
   end;
end;

procedure TestString(const F1,F2: string);
begin
   if F1 <> F2 then
   begin
      WriteTestHeader;
      if Protocol then
      begin
         Tool.PostTextMsg(tm_AddToProtocol,STest+SPTest+' DB '+F1+ ' LED '+F2,nil);
         Application.ProcessMessages;
      end;
   end;
end;

begin
   TestOnly := cb_TestOnly.Checked;
   aGP := false;
   By1KU := false;
   KU1 := 0;
   if OneKU <> nil then
   begin
      KU1 := OneKU.Cislo;
      By1KU := true;
   end;
   l_Err.Caption := '';
   MM := Tgis_Majitele(TEntity(World.Objectmodel.FindElementName('DATA')).FindElementClass(Tgis_Majitele));
   K := cb_Kat.Checked;
   SKP := cb_SKP.Checked;
   Table.First;
   UseDruhParcely := ed_Parskukn.Text <> '';
   UseKATUZEPUV := ed_KATUZE_KOD_PUV.Text <> '';
   UsePK := (ed_PKCIS.Text <> '') and (ed_PKPOD.Text <> '');
   UseKNDil := ed_PK_Dil.Text <> '';
   UsePKDil := UsePK and UseKNDil;
   if UsePKDil then UseKNDil := false;
   Gauge.MaxValue := Table.RecordCount;
   Errors := 0;
   PCErrors := 0;
   ParcelModel.FullTest := true;
   OE := TOwnerEntity.Create;
   OE.Name := 'Nown';
   Tool.NextElement := OE;
   OEPK := TOwnerEntity.Create;
   OEPK.Name := 'Nown PK';
   Tool.NextElement := OEPK;
   MultiPK := TOwnerEntity.Create;
   MultiPK.Name := 'Multi PK';
   Tool.NextElement := MultiPK;
   PCs := TOwnerEntity.Create;
   PCs.Name := 'PCs';
   Tool.NextElement := PCs;
   pupflc := cb_pupflc.Checked;
   if Protocol then
   begin
      if SKP then
      begin
         Tool.PostTextMsg(tm_AddToProtocol,'Synchronizace SKP s tabulkou: '+ed_TableName.Text,nil);
         SLErr := TStringList.Create;
      end
      else
      if K then
         Tool.PostTextMsg(tm_AddToProtocol,'Synchronizace katastr s tabulkou: '+ed_TableName.Text,nil)
      else
         Tool.PostTextMsg(tm_AddToProtocol,'Synchronizace parcel s tabulkou: '+ed_TableName.Text,nil);
      if By1KU then
      begin
         Tool.PostTextMsg(tm_AddToProtocol,'Jen pro katastr: '+Combo_KU.Text,nil);
      end;
      Tool.PostTextMsg(tm_AddToProtocol,'START****',nil);
   end;
   while not Table.Eof do
   begin
      Gauge.Progress := Table.RecNo;
      if SKP then
      begin
         F := Table.FieldByName(ed_Katastr.Text);
         if F = nil then exit;
         Katastr := F.AsInteger;
         if By1KU then
         begin
            if Katastr <> KU1 then
            begin
               Table.Next;
               continue;
            end;
         end;
         F := Table.FieldByName(ed_PARCIS.Text);
         if F = nil then exit;
         SKupinaParcel := F.AsInteger;
         ParcelModel.GetKatastrCislo(Katastr);
         ParcelModel.GetSkupinaParcelCislo(SkupinaParcel);
         _SKP := ParcelModel.ActualSkupinaParcel;
         if (_SKP <> nil) and not _SKP.IsMyOwner(OE) then
         begin
            OE.NextElement := _SKP;
            // Nazev katastru
            if ed_Parskukn.Text <> '' then
            begin
               F := Table.FieldByName(ed_Parskukn.Text);
               Vlastnik := F.AsString;
               M := nil;
               if TestOnly then
               begin
                  if _SKP.Vlastnik <> Vlastnik then
                  begin
                     if Protocol then
                     begin
                        Tool.PostTextMsg(tm_AddToProtocol,' KU '+IntToStr(Katastr)+' SKP '+IntToStr(SkupinaParcel)+' Vlastnik LED '+_SKP.Vlastnik+' DB '+Vlastnik,nil);
                        Application.ProcessMessages;
                     end;
                  end;
               end
               else
               begin
                  if (MM <> nil) and (Vlastnik <> '') and (Vlastnik <> '0') then
                     M := MM.CreateMajitelCislo(Vlastnik);
                  if M <> nil then
                  begin
                     _SKP.Majitel := M;
                  end;
               end;
            end;
         end
         else
         begin
            if _SKP =  nil then
            begin
               KatS := IntToStr(Katastr)+'-'+IntToStr(SkupinaParcel);
               if SLErr.IndexOf(KatS) < 0 then
               begin
                  SLErr.Add(KatS);
                  inc(Errors);
                  l_Err.Caption := 'Nenalezeno '+IntToStr(Errors)+' Skupin parcel';
                  if Protocol and not cb_NoLED.Checked then
                  begin
                     Tool.PostTextMsg(tm_AddToProtocol,' Chyb v LEDu: '+IntToStr(Katastr)+', '+IntToStr(SkupinaParcel),nil);
                     Application.ProcessMessages;
                  end;
               end;
            end;
         end;
      end
      else
      if K then
      begin
         F := Table.FieldByName(ed_Katastr.Text);
         if F = nil then exit;
         Katastr := F.AsInteger;
         if By1KU then
         begin
            if Katastr <> KU1 then
            begin
               Table.Next;
               continue;
            end;
         end;
         ParcelModel.GetKatastrCislo(Katastr);
         if ParcelModel.ActualKatastr <> nil then
         begin
            _K := ParcelModel.ActualKatastr;
            OE.NextElement := _K;
            // Nazev katastru
            if ed_Parcis.Text <> '' then
            begin
               F := Table.FieldByName(ed_Parcis.Text);
               if F <> nil then
                  _K.Nazev := F.AsString;
            end;
            if ed_Parpod.Text <> '' then
            begin
               F := Table.FieldByName(ed_Parpod.Text);
               if F <> nil then
                  _K.Cislo_ := F.AsInteger;
            end;
            if ed_PKCIS.Text <> '' then
            begin
               F := Table.FieldByName(ed_PKCIS.Text);
               if F <> nil then
                  _K.ORP := F.AsInteger;
            end;
            if ed_PKPOD.Text <> '' then
            begin
               F := Table.FieldByName(ed_PKPOD.Text);
               if F <> nil then
                  _K.ORP_Nazev := F.AsString;
            end;
            if ed_KATUZE_KOD_PUV.Text <> '' then
            begin
               F := Table.FieldByName(ed_KATUZE_KOD_PUV.Text);
               if F <> nil then
                  _K.Poznamka := F.AsString;
            end;
         end
         else
         begin
            inc(Errors);
            l_Err.Caption := 'Nenalezeno '+IntToStr(Errors)+' Katastr';
            if Protocol then
            begin
               //Tool.PostTextMsg(tm_AddToProtocol,' not found: '+IntToStr(Katastr)+','+IntToStr(Parcis)+'/'+IntToStr(ParPod),nil);
               //if Errors mod 50 = 0 then
               //   Application.ProcessMessages;
            end;
         end;
      end
      else
      begin
         F := Table.FieldByName(ed_Katastr.Text);
         if F = nil then exit;
         Katastr := F.AsInteger;
         if By1KU then
         begin
            if Katastr <> KU1 then
            begin
               Table.Next;
               continue;
            end;
         end;
         F := Table.FieldByName(ed_Parcis.Text);
         if F = nil then exit;
         Parcis := F.AsInteger;
         F := Table.FieldByName(ed_Parpod.Text);
         if F = nil then exit;
         Parpod := F.AsInteger;
         if UseKATUZEPUV then
         begin
            F := Table.FieldByName(ed_KATUZE_KOD_PUV.Text);
            if F = nil then
            begin
               UseKATUZEPUV := false;
               ed_KATUZE_KOD_PUV.Text := '';
            end
            else
               KATUZEPUV := F.AsInteger;
         end
         else
            KATUZEPUV := -1;
         if UseDruhParcely then
         begin
            F := Table.FieldByName(ed_ParSkukn.Text);
            if F = nil then exit;
            ParSkukn := F.AsInteger;
            if (ParSkuKn = 1) or (ParSkuKn = 4) or (ParSkuKn = 6)then
               ParCis := -Abs(Parcis);
            aGP := ParSkuKN > 5;
         end;
         if UsePK then
         begin
            F := Table.FieldByName(ed_PKcis.Text);
            if F = nil then exit;
            PKcis := F.AsInteger;
            F := Table.FieldByName(ed_PKpod.Text);
            if F = nil then exit;
            PKpod := F.AsInteger;
         end;
         if UseKNDil or UsePKDil then
         begin
            F := Table.FieldByName(ed_PK_Dil.Text);
            if F = nil then exit;
            PKDil := F.AsInteger;
         end;
         ParcelModel.GetKatastrCislo(Katastr);
         ParcelModel.GetParcelaCislo(Parcis,ParPod,KATUZEPUV);
         PCNotFound := false;
         PCs.FreeAll;
         if ParcelModel.ActualParcela <> nil then
         begin
            P := ParcelModel.ActualParcela;
            OE.NextElement := P;
            PC := nil;
            //NextPC := nil;
            if UseKNDil or (UsePK and (cb_PK0.Checked or(PKCis > 0))) then
            begin
               if UseKNDil then
                  PC := ParcelModel.GetParCastDil(PKDil,aGP,UseDruhParcely)
               else
               if UsePKDil then
                  PC := ParcelModel.GetParCastPKCisloDil(PKCis,PKPod,PKDil,aGP,UseDruhParcely)
               else
                  PC := ParcelModel.GetParCastPKCislo(PKCis,PKPod,aGP,UseDruhParcely);
               if PC = nil then
               begin
                  SGP := '';
                  if UseDruhParcely then
                     if aGP then
                        SGP := ' GP:Ano'
                     else
                        SGP := ' GP:Ne';
                  PCNotFound := true;
                  inc(PCErrors);
                  l_Err.Caption := 'Nenalezeno '+IntToStr(Errors)+' parcel a '+IntToStr(PCErrors)+' st';
                  if Protocol and not cb_NoLED.Checked  then
                  begin
                     S := ' chyb v LEDu: '+IntToStr(Katastr)+','+IntToStr(Parcis)+'/'+IntToStr(ParPod);
                     if UseKATUZEPUV then
                        S := S+'\'+IntToStr(KATUZEPUV);
                     if not UseKNDil then
                        S := S + ' PK: '+IntToStr(PKcis)+'/'+IntToStr(PKPod);
                     if UsePKDil then
                        S := S + ' Dil:'+ IntToStr(PKDil);
                     Tool.PostTextMsg(tm_AddToProtocol,S+SGP,nil);
                     if PCErrors mod 50 = 0 then
                        Application.ProcessMessages;
                  end;
               end
               else
               begin
                  OEPK.NextElement := PC;
                  if UseKNDil then
                     NextPC := P.GetNextParcastDil(PC,PKDil,aGP,UseDruhParcely)
                  else
                  if UsePKDil then
                     NextPC := P.GetNextParcastPKCisloDil(PC,PKCis,PKPod,PKDil,aGP,UseDruhParcely)
                  else
                     NextPC := P.GetNextParcastPKCislo(PC,PKCis,PKPod,aGP,UseDruhParcely);
                  while NextPC <> nil do
                  begin
                     PCs.NextElement := NextPC;
                     OEPK.NextElement := NextPC;
                     if UseKNDil then
                        NextPC := P.GetNextParcastDil(NextPC,PKDil,aGP,UseDruhParcely)
                     else
                     if UsePKDil then
                        NextPC := P.GetNextParcastPKCisloDil(NextPC,PKCis,PKPod,PKDil,aGP,UseDruhParcely)
                     else
                        NextPC := P.GetNextParcastPKCislo(NextPC,PKCis,PKPod,aGP,UseDruhParcely);
                  end;
                  if not PCs.NoElements then
                     MultiPK.NextElement := PC;
               end;
            end;
            if not PCNotFound then
            begin
               TestHeader := false;
               // Vymera
               F := nil;
               if ed_Vymera.Text <> '' then
                  F := Table.FieldByName(ed_Vymera.Text);
               if F <> nil then
               begin
                  if TestOnly then
                  begin
                     STest := '   Vymera: ';
                     SPTest := 'P';
                     if PC <> nil then
                     begin
                        SPTest := 'PC';
                        TestFloat(F.AsFloat,PC.Vymera,0.0001);
                        if not PCs.NoElements then
                           for iii := 0 to PCs.LastIndex do
                              TestFloat(F.AsFloat,Tgis_ParcelaCast(PCs.Elements[iii]).Vymera,0.0001);
                     end
                     else
                        TestFloat(F.AsFloat,P.Vymera,0.0001);
                  end
                  else
                  begin
                     if PC <> nil then
                     begin
                        PC.Vymera := F.AsFloat;
                        if not PCs.NoElements then
                           for iii := 0 to PCs.LastIndex do
                              Tgis_ParcelaCast(PCs.Elements[iii]).Vymera := PC.Vymera;
                        if cb_FillSumVym.Checked then
                           P.Vymera := P.MultiVymera;
                     end
                     else
                        P.Vymera := F.AsFloat;
                  end;
               end;
               // KatParKod
               F := nil;
               if ed_KatParKod.Text <> '' then
                  F := Table.FieldByName(ed_KatParKod.Text);
               if F <> nil then
               begin
                  if TestOnly then
                  begin
                     STest := '   KATPAR_KOD: ';
                     SPTest := 'P';
                     if PC <> nil then
                     begin
                        SPTest := 'PC';
                        TestInteger(F.AsInteger, PC.KATPAR_KOD);
                        if not PCs.NoElements then
                           for iii := 0 to PCs.LastIndex do
                              TestInteger(F.AsInteger,Tgis_ParcelaCast(PCs.Elements[iii]).KATPAR_KOD);
                     end
                     else
                     begin
                        TestInteger(F.AsInteger, P.KATPAR_KOD);
                        SPTest := 'PC';
                        for iii := 0 to P.LastIndex do
                           TestInteger(F.AsInteger,Tgis_ParcelaCast(P.Elements[iii]).KATPAR_KOD);
                     end;
                  end
                  else
                  begin
                     if PC <> nil then
                     begin
                        PC.KATPAR_KOD := F.AsInteger;
                        if not PCs.NoElements then
                           for iii := 0 to PCs.LastIndex do
                              Tgis_ParcelaCast(PCs.Elements[iii]).KATPAR_KOD := PC.KATPAR_KOD;
                     end
                     else
                     begin
                        P.KATPAR_KOD := F.AsInteger;
                        SetForPC('KATPAR_KOD',F.AsString);
                     end;
                  end;
               end;
               // LV
               F := nil;
               if ed_LV.Text <> '' then
                  F := Table.FieldByName(ed_LV.Text);
               if F <> nil then
               begin
                  if TestOnly then
                  begin
                     STest := '   LV: ';
                     SPTest := 'P';
                     TestInteger(F.AsInteger,P.LV);
                  end
                  else
                     P.LV := F.AsInteger;
               end;
               // KvalP
               F := nil;
               if ed_LVC.Text <> '' then
                  F := Table.FieldByName(ed_LVC.Text);
               if F <> nil then
               begin
                  if TestOnly then
                  begin
                     STest := '   LVc: ';
                     SPTest := 'PC';
                     if PC <> nil then
                     begin
                        TestInteger(F.AsInteger,PC.LVC);
                        if not PCs.NoElements then
                           for iii := 0 to PCs.LastIndex do
                              TestInteger(F.AsInteger,Tgis_ParcelaCast(PCs.Elements[iii]).LVc);
                     end
                     else
                        for iii := 0 to P.LastIndex do
                           TestInteger(F.AsInteger,Tgis_ParcelaCast(P.Elements[iii]).LVc);
                  end
                  else
                  begin
                     if PC <> nil then
                     begin
                        PC.LVC := F.AsInteger;
                        if not PCs.NoElements then
                           for iii := 0 to PCs.LastIndex do
                              Tgis_ParcelaCast(PCs.Elements[iii]).LVc := PC.LVc;
                     end
                     else
                        SetForPC('LVc', F.AsString);
                  end;
               end;
               // Kultura
               F := nil;
               if ed_Kultura.Text <> '' then
                  F := Table.FieldByName(ed_Kultura.Text);
               if F <> nil then
               begin
                  if TestOnly then
                  begin
                     SPTest := 'P';
                     STest := '   Kultura: ';
                     TestInteger(F.AsInteger, P.Kultura);
                  end
                  else
                     P.Kultura := F.AsInteger;
               end;
               // PUPFL
               F := nil;
               if ed_PUPFL.Text <> '' then
                  F := Table.FieldByName(ed_PUPFL.Text);
               if F <> nil then
               begin
                  if TestOnly then
                  begin
                     SPTest := 'P';
                     if not pupflc then
                     begin
                        STest := '   PUPFL: ';
                        if cb_boolAsText.Checked then
                           TestString(F.AsString, P.PUPFL_Text)
                        else
                           TestBoolean(F.AsBoolean, P.PUPFL);
                     end
                     else
                     begin
                        STest := '   PUPFLc: ';
                        SPTest := 'PC';
                        if PC <> nil then
                        begin
                           if cb_boolAsText.Checked then
                              TestString(F.AsString, PC.Pupflc_Text)
                           else
                              TestBoolean(F.AsBoolean, PC.PUPFLc);
                           if not PCs.NoElements then
                              for iii := 0 to PCs.LastIndex do
                                 if cb_boolAsText.Checked then
                                    TestString(F.AsString, Tgis_ParcelaCast(PCs.Elements[iii]).Pupflc_Text)
                                 else
                                    TestBoolean(F.AsBoolean, Tgis_ParcelaCast(PCs.Elements[iii]).PUPFLc);
                        end
                        else
                        begin
                           for iii := 0 to P.LastIndex do
                              if cb_boolAsText.Checked then
                                 TestString(F.AsString, Tgis_ParcelaCast(P.Elements[iii]).Pupflc_Text)
                              else
                                 TestBoolean(F.AsBoolean, Tgis_ParcelaCast(P.Elements[iii]).PUPFLc);
                        end;
                     end;
                  end
                  else
                  begin
                     if not pupflc then
                     begin
                        if cb_boolAsText.Checked then
                           P.PUPFL_Text := F.AsString
                        else
                           P.PUPFL := F.AsBoolean;
                     end
                     else
                     begin
                        if PC <> nil then
                        begin
                           if cb_boolAsText.Checked then
                              PC.Pupflc_Text := F.AsString
                           else
                              PC.Pupflc := F.AsBoolean;
                           if not PCs.NoElements then
                              for iii := 0 to PCs.LastIndex do
                                 Tgis_ParcelaCast(PCs.Elements[iii]).Pupflc := PC.Pupflc;
                        end
                        else
                        begin
                           if cb_boolAsText.Checked then
                              SetForPC('PUPFLc_Text', F.AsString)
                           else
                           begin
                              if F.AsBoolean then
                                 aPupfl := 'true'
                              else
                                 aPupfl := 'false';
                              SetForPC('PUPFLc', aPupfl)
                           end;
                        end;
                     end;
                  end;
               end;
               // VLASTNIK
               F := nil;
               if ed_Vlastnik.Text <> '' then
                  F := Table.FieldByName(ed_Vlastnik.Text);
               if F <> nil then
               begin
                  Vlastnik := F.AsString;
                  if TestOnly then
                  begin
                     STest := '   VLASTNIK: ';
                     SPTest := 'PC';
                     if PC <> nil then
                     begin
                        TestString(Vlastnik,PC.Vlastnik);
                        if not PCs.NoElements then
                           for iii := 0 to PCs.LastIndex do
                              TestString(Vlastnik,Tgis_ParcelaCast(PCs.Elements[iii]).Vlastnik);
                     end
                     else
                        for iii := 0 to P.LastIndex do
                           TestString(Vlastnik,Tgis_ParcelaCast(P.Elements[iii]).Vlastnik);
                  end
                  else
                  begin
                     M := nil;
                     if (MM <> nil) and (Vlastnik <> '') and (Vlastnik <> '0') then
                        M := MM.CreateMajitelCislo(Vlastnik);
                     if M <> nil then
                     begin
                        if PC <> nil then
                        begin
                           PC.Majitel := M;
                           if not PCs.NoElements then
                              for iii := 0 to PCs.LastIndex do
                                 Tgis_ParcelaCast(PCs.Elements[iii]).Majitel := M;
                        end
                        else
                           P.Majitel := M;
                     end;
                  end;
               end;
               // e1
               F := nil;
               if (edit1.Text <> '') and (ed_1.Text <> '') then
                  F := Table.FieldByName(ed_1.Text);
               if F <> nil then
               begin
                  if PC <> nil then
                     PC.SetPropertyStringByName(Edit1.Text, F.AsString)
                  else
                     SetForPC(Edit1.Text, F.AsString);
               end;
               // e2
               F := nil;
               if (edit2.Text <> '') and (ed_2.Text <> '') then
                  F := Table.FieldByName(ed_2.Text);
               if F <> nil then
               begin
                  if PC <> nil then
                     PC.SetPropertyStringByName(Edit2.Text, F.AsString)
                  else
                     SetForPC(Edit2.Text, F.AsString);
               end;
               // e3
               F := nil;
               if (edit3.Text <> '') and (ed_3.Text <> '') then
                  F := Table.FieldByName(ed_3.Text);
               if F <> nil then
               begin
                  if PC <> nil then
                     PC.SetPropertyStringByName(Edit3.Text, F.AsString)
                  else
                     SetForPC(Edit3.Text, F.AsString);
               end;
            end;
         end
         else
         begin
            inc(Errors);
            l_Err.Caption := 'Nenalezeno '+IntToStr(Errors)+' parcel';
            if Protocol and not cb_NoLED.Checked then
            begin
               S := ' chyb v LEDu: '+IntToStr(Katastr)+','+IntToStr(Parcis)+'/'+IntToStr(ParPod);
               if UseKATUZEPUV then
                  S := S+'\'+IntToStr(KATUZEPUV);
               Tool.PostTextMsg(tm_AddToProtocol,S,nil);
               if Errors mod 50 = 0 then
                  Application.ProcessMessages;
            end;
         end;
      end;
      Table.Next;
   end;
   ParcelModel.FullTest := false;
   if Protocol then
   begin
      for i := 0 to ParcelModel.LastIndex do
      begin
         _K := Tgis_Katastr(ParcelModel.Elements[i]);
         if SKP then
         begin
            if not _K.NoSkupinaParcel then
            for ii := 0 to _K.SkupinyParcel.LastIndex do
            begin
               _SKP := Tgis_SkupinaParcel(_K.SkupinyParcel.Elements[ii]);
               if not _SKP.IsMyOwner(OE) then
               begin
                  if not By1KU or (_SKP.KU_KOD = KU1) then
                     Tool.PostTextMsg(tm_AddToProtocol,' chyb v DB: '+IntToStr(_SKP.KU_KOD)+' '+_SKP.KU_Nazev+', '+_SKP.Name,nil);
               end;
            end;
            continue;
         end
         else
         if K then
         begin
            if not _K.IsMyOwner(OE) then
            begin
               if not By1KU or (_K.Cislo = KU1) then
                  Tool.PostTextMsg(tm_AddToProtocol,' chyb v DB: '+_K.Name+' '+_K.Nazev,nil);
            end;
            Continue;
         end;
         if _K.NoParcela then continue;
         for ii := 0 to _K.Parcely.LastIndex do
         begin
            P := Tgis_Parcela(_K.Parcely.Elements[ii]);
            if not P.IsMyOwner(OE) then
            begin
               if not By1KU or (P.KU_KOD = KU1) then
               begin
                  S := ' chyb v DB: '+IntToStr(P.KU_KOD)+' '+P.KU_Nazev+','+P.Name;
                  if UseKATUZEPUV then
                     S := S + '\'+ IntToStr(P.KATUZE_KOD_PUV);
                  Tool.PostTextMsg(tm_AddToProtocol,S,nil);
               end;
               continue;
            end;
            if UseKNDil or UsePK then
            for iii := 0 to P.LastIndex do
            begin
               e := P.Elements[iii];
               if not (e is Tgis_ParcelaCast) then continue;
               PC := Tgis_ParcelaCast(e);
               if UseKNDil or (PC.PKCIS > 0) or cb_PK0.Checked then
               begin
                  if not PC.IsMyOwner(OEPK) then
                  begin
                     S := '';
                     if UseKATUZEPUV then
                        S := '\'+ IntToStr(P.KATUZE_KOD_PUV);
                     if UseKNDil then
                        S := S+' Dil: '+IntToStr(PC.PK_Dil)
                     else
                        S := S+' PK: '+PC.PKName + ' Dil: '+IntToStr(PC.PK_Dil);
                     Tool.PostTextMsg(tm_AddToProtocol,' chyb v DB: '+IntToStr(P.KU_KOD)+' '+P.KU_Nazev+','+P.Name+S,nil);
                  end;
                  if PC.IsMyOwner(MultiPK) then
                  begin
                     S := '';
                     if UseKATUZEPUV then
                        S := '\'+ IntToStr(P.KATUZE_KOD_PUV);
                     if UseKNDil then
                        S := S+' Dil: '+IntToStr(PC.PK_Dil)
                     else
                        S := S+' PK: '+PC.PKName + ' Dil: '+IntToStr(PC.PK_Dil);;
                     Tool.PostTextMsg(tm_AddToProtocol,' Nsobn sti: '+IntToStr(P.KU_KOD)+' '+P.KU_Nazev+','+P.Name+S,nil);
                  end;
               end;
            end;
         end;
      end;
      Tool.PostTextMsg(tm_AddToProtocol,'    ****',nil);
      Tool.PostTextMsg(tm_AddToProtocol,'END ****',nil);
      Tool.PostTextMsg(tm_AddToProtocol,'konec Synchronizace parcel',nil);
      Application.ProcessMessages;
      if SKP then
         SLErr.Free;
   end;
   OE.Free;
   OEPK.Free;
   MultiPK.Free;
   PCs.Free;
   SetFocus;
end;

function TSynchronize_Table_ParcelModel_Form.Check: boolean;
var
   S: string;
   i: integer;
begin
   result := false;
   if not Table.Active then
   begin
      ShowMessage('DB Tabulka nen nastavena nebo nejde otevt ... Dal pokus !');
      ed_TableName.SetFocus;
      exit;
   end;
   OneKU := nil;
   if cb_OneKU.Checked then
   begin
      S := 'Muste vybrat aspo jeden katastr !(nebo nezakrtvat jeden KU)';
      i := combo_KU.ItemIndex;
      if i < 0 then
      begin
         ShowMessage(S);
         Combo_KU.SetFocus;
         exit;
      end;
      OneKU := Tgis_Katastr(Combo_KU.Items.Objects[i]);
   end;
   S :=  ' je povinn(jako vechno co je erven)... znova!';
   if ed_Katastr.Text = '' then
   begin
      ShowMessage('Poloka pro .Katastru'+S);
      ed_Katastr.SetFocus;
      exit;
   end;
   if ed_PARCIS.Text = '' then
   begin
      if cb_Kat.Checked then
         //ShowMessage('Poloka pro nzev katastru'+S)
      else
      if cb_SKP.Checked then
      begin
         ShowMessage('Poloka pro slo SKP'+S);
         ed_PARCIS.SetFocus;
         exit;
      end
      else
      begin
         ShowMessage('Poloka pro slo parcely'+S);
         ed_PARCIS.SetFocus;
         exit;
      end;
   end;
   if cb_Kat.Checked or cb_SKP.Checked then
   begin
      result := true;
      exit;
   end;
   if ed_PARPOD.Text = '' then
   begin
      ShowMessage('Poloka pro podlomen'+S);
      ed_PARPOD.SetFocus;
      exit;
   end;
   if (ed_PKCIS.Text <> '') or (ed_PKPOD.Text <>'') then
   begin
      if (ed_PKCIS.Text = '') or (ed_PKPOD.Text = '') then
      begin
         ShowMessage('Poloky pro PK slo a PK podlomen mus bt vyplnny ob nebo dn!');
         ed_PKCIS.SetFocus;
         exit;
      end;
   end;
   result := true;
end;

procedure TSynchronize_Table_ParcelModel_Form.SetParcelModel(
  const Value: Tgis_ParcelModel);
var
  e: TElement;
  ku: Tgis_Katastr;
  i: integer;
begin
  FParcelModel := Value;
  Combo_KU.Clear;
  if Value <> nil then
  for i := 0 to Value.LastIndex do
  begin
     e := Value.Elements[i];
     if not (e is Tgis_Katastr) then continue;
     ku := Tgis_Katastr(e);
     Combo_KU.AddItem(ku.Name + ' '+ku.Nazev,ku);
  end;
end;

procedure TSynchronize_Table_ParcelModel_Form.cb_KatClick(
  Sender: TObject);
var
   K: boolean;
begin
   K := cb_Kat.CHecked;
   if K then
      FProtTop := Panel4.Top;
   cb_TestOnly.Enabled := not K;
   cb_SKP.Visible := not K;
   Panel3.Visible := not K;
   //PKPanel.Visible := not K;
   //ed_ParPod.Visible := not K;
   ed_Parskukn.Visible := not K;
   //Label4.Visible := not K;
   Label5.Visible := not K;
   cb_PK0.Visible := not K;
   cb_FillSumVym.Visible := not K;
   if K then
   begin
      Label3.Caption := 'Poloka nzvu katastru';
      Label4.Caption := 'Poloka novho sla katastru';
      Label15.Caption := 'Poloka ORP';
      Label16.Caption := 'Poloka ORP_Nazev';
      Label3.Font.Color := clBlack;
      Label4.Font.Color := clBlack;
      Label15.Font.Color := clBlack;
      Label16.Font.Color := clBlack;
      Label18.Visible := false;
      ed_PK_Dil.Visible := false;
      Label19.Caption := 'Poloka poznmka: ( Poznamka)...........';
      //ed_KATUZE_KOD_PUV.Visible := false;
      Height := Height - Panel3.Height{ - PKPanel.Height};
   end
   else
   begin
      Label3.Caption := 'Poloka sla parcely:   (PARCIS).............';
      Label4.Caption := 'Poloka podlomen:       (PARPOD)...........';
      Label15.Caption := 'Poloka PK sla parcely:   (PKCIS).........';
      Label16.Caption := 'Poloka PK podlomen:       (PKPOD)......';
      Label3.Font.Color := clRed;
      Label4.Font.Color := clRed;
      Label15.Font.Color := clRed;
      Label16.Font.Color := clRed;
      Label18.Visible := true;
      ed_PK_Dil.Visible := true;
      Label19.Caption := 'Poloka pv.KU: ( KATUZE_KOD_PUV)...........';
      //ed_KATUZE_KOD_PUV.Visible := true;
      Height := Height + Panel3.Height{ + PKPanel.Height};
      Panel4.Top := FProtTop;
   end;
end;

procedure TSynchronize_Table_ParcelModel_Form.SetProtocol(
  const Value: boolean);
begin
  FProtocol := Value;
end;

procedure TSynchronize_Table_ParcelModel_Form.SetTool(const Value: TTool);
begin
  FTool := Value;
end;

procedure TSynchronize_Table_ParcelModel_Form.cb_ProtocolClick(
  Sender: TObject);
begin
   Protocol := cb_Protocol.Checked;
end;

procedure TSynchronize_Table_ParcelModel_Form.cb_SKPClick(Sender: TObject);
var
   SKP: boolean;
begin
   SKP := cb_SKP.CHecked;
   if SKP then
      FProtTop := Panel4.Top;
   Panel4.Visible := false;
   cb_Kat.Visible := not SKP;
   Panel3.Visible := not SKP;
   PKPanel.Visible := not SKP;
   //ed_ParPod.Visible := not K;
   ed_ParPod.Visible := not SKP;
   //Label4.Visible := not K;
   Label4.Visible := not SKP;
   Panel4.Visible := true;
   if SKP then
   begin
      Label3.Caption := 'Poloka Skupiny parcel';
      Label5.Caption := 'Poloka Vlastnk';
      Label19.Visible := false;
      ed_KATUZE_KOD_PUV.Visible := false;
      //Label3.Font.Color := clBlack;
      //Label4.Font.Color := clBlack;
      Height := Height - Panel3.Height - PKPanel.Height;
   end
   else
   begin
      Label3.Caption := 'Poloka sla parcely:   (PARCIS).............';
      Label5.Caption := 'Poloka druhu parcely:  (PAR_SKU_KN)...';
      Label19.Visible := true;
      ed_KATUZE_KOD_PUV.Visible := true;
      //Label3.Font.Color := clRed;
      //Label4.Font.Color := clRed;
      Height := Height + Panel3.Height + PKPanel.Height;
      Panel4.Top := FProtTop;
   end;
end;

procedure TSynchronize_Table_ParcelModel_Form.SetOneKU(
  const Value: Tgis_Katastr);
begin
  FOneKU := Value;
end;

procedure TSynchronize_Table_ParcelModel_Form.cb_TestOnlyClick(
  Sender: TObject);
begin
   if cb_TestOnly.Checked then
      cb_Protocol.Checked := true;
end;

end.

