unit f_TopolPointDialog;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  f_SimplePointDialog, StdCtrls, Spin, Buttons, ExtCtrls, Grids;

type
  TTopolPointDialog_Form = class(TSimplePointDialog_Form)
    GroupPanel: TPanel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    ComboDruh: TComboBox;
    ed_AtrPuv: TSpinEdit;
    ColorPanel: TPanel;
    ed_Znacka: TSpinEdit;
    PanelDynamic: TPanel;
    SG: TStringGrid;
    procedure ColorPanelClick(Sender: TObject);
    procedure ComboDruhChange(Sender: TObject);
  private
    procedure SetDynamicProps(const Value: TStringList);
    { Private declarations }
  public
    procedure SetDynamicProp(aName,aValue: string);
    function  GetDynamicProp(aName: string): string;
    property DynamicProps: TStringList write SetDynamicProps;
  end;


implementation
uses
   e_Color,
   e_TopolDruhy,
   f_SimpleColorDialog;

{$R *.DFM}

procedure TTopolPointDialog_Form.ColorPanelClick(Sender: TObject);
var
   D: TSimpleColorDialog;
begin
   D := TSimpleColordialog.Create(Application);
   D.Color := StrToInt(ColorPanel.Caption);
   D.Top := Top;
   D.Left := Left + Width + 1;
   D.Caption := 'Barvy';
   D.ShowModal;
   ColorPanel.Color := DejBarvicku(D.Color);
   Colorpanel.Caption := IntToStr(D.Color);
   D.Free;
end;

procedure TTopolPointDialog_Form.ComboDruhChange(Sender: TObject);
var
   TD: TTopolDruh;
begin
   if ComboDruh.Items.Count = 0  then exit;
   
   TD := TTopolDruh(ComboDruh.Items.Objects[ComboDruh.ItemIndex]);
   ColorPanel.Caption := TD.GetPropertyStringByName('Barva');
   ColorPanel.Color := DejBarvicku(TD.Barva);
   ed_Znacka.Value := TD.Znacka;
   Tool.SetPropertyLongIntByName('NewDruh',TD.KOD);
end;

function TTopolPointDialog_Form.GetDynamicProp(aName: string): string;
var
   i: integer;
begin
   result := '';
   i := SG.Cols[0].IndexOf(aName);
   if i > -1 then
   begin
     result := SG.Cols[1].Strings[i];
   end;
end;

procedure TTopolPointDialog_Form.SetDynamicProp(aName, aValue: string);
var
   i: integer;
begin
   i := SG.Cols[0].IndexOf(aName);
   if i > -1 then
   begin
     SG.Cols[1].Strings[i] := aValue;
   end;
end;

procedure TTopolPointDialog_Form.SetDynamicProps(const Value: TStringList);
begin
   if Value.Count < 1 then
      PanelDynamic.Visible := false
   else
   begin
      SG.RowCount := Value.Count;
      SG.Cols[0].Assign(Value);
   end;
end;

end.
