unit i_Annotation;

interface
uses
   Elements,
   i_Top_t;

type

TGeometryTextAnnotationInterpret = class(TInterpretTopTextu)
protected
   procedure Process(Element: TElement); override;
   function  IsItsClass(AObject: TObject): boolean; override;
   function  QProcessBefore(Element: TElement): boolean; override;
end;


implementation
uses
   Graphics,
   cpConvrt,
   e_Annotation,
   e_Class,
   e_Color,
   m_Orbis,
   u_Symbol;


{ TGeometryTextAnnotationInterpret }

function TGeometryTextAnnotationInterpret.IsItsClass(AObject: TObject): boolean;
begin
   result := (AObject.ClassType = TGeometryTextAnnotation);
end;

procedure TGeometryTextAnnotationInterpret.Process(Element: TElement);
var
  TA: TGeometryTextAnnotation;
  GAC: TGeometryAnnotationCollection;
  AA: TAnnotationAbscissa;
  E: TElement;
  i: integer;
begin
   if BGIF.CHybaFontu then
   begin
      PostTextMsg(tm_AddToProtocol,'Annotation Text interpret - FontError !',nil);
      exit;
   end;
   TA := TGeometryTextAnnotation(Element);
   if not TA.Visible then exit;
   GAC := TA.GACollection;
   if GAC = nil then
   begin
      PostTextMsg(tm_AddToProtocol,'Annotation Text interpret - Lost collection !',nil);
      exit;
   end;
   try
    //SetInterpretTopProps(TTopoLText(Element).ObjectOwner);
      if TA.Style > 0 then
         TextInfo.Druh       := TA.Style
      else
         TextInfo.Druh       := GAC.Style;
      { vechno podle stylu .....
      TextInfo.Barva      := TE.Barva;
      TextInfo.Znacka     := TE.Znacka;
      TextInfo.Font       := TE.TopolFont;
      TextInfo.Vyska      := TE.Height;
      TextInfo.KoefSirky  := TE.WidthCoef;
      TextInfo.Sklon      := TE.Slope;
      TextInfo.Rozestupy  := TE.Distance;
      TextInfo.RezimTextu := TE.TextMode;
      }
      TextInfo.VychoziBod.x := TA.x;
      TextInfo.VychoziBod.y := TA.y;
      TextInfo.Smer       := TA.Angle;
      TextInfo.Atributy   := [OkT,T30];
      TextInfo.CodePage   := cpLatin2;
      TextInfo.Veta       := WinTo852(TA.Text);
      BGIF.TextInfo := TextInfo;
      BGIF.NastavInfoPodleDruhu(TextInfo.Druh);
      //BGIF.CalculateOpsanyObdelnik;
      //if TextInfo.IsOverRegion(Rect.MinX,Rect.MinY,Rect.MaxX,Rect.MaxY)then
      begin
         if UseColor then
         begin
           Device.Pen.Color := Color;
           TextInfo.Atributy := TextInfo.Atributy - [txtZmena];
         end
         else
           Device.Pen.Color := DejBarvicku(TextInfo.Barva);
         {
         if OwnerProps.GetPropertyBooleanByName('USESYMBOL') then
            BGIF.TextInfo.Druh:= OwnerProps.GetPropertyLongIntByName('SYMBOL');
         }
         //Device.Pen.Color := DejBarvicku(aProps.Barva);
         Device.Pen.Style := psSolid;
         BGIF.ZobrazText(False);

         //Device.Pen.Color := 255;
         //Device.Rectangle(TA.MinX,TA.MinY,TA.MaxX,TA.MaxY);
      end;
   except
   end;
   if GAC.NoGeometry then exit;
   for i := 0 to TA.LastIndex do
   begin
      e := TA.Elements[i];
      if not (e.ClassType = TAnnotationAbscissa) then continue;
      AA := TAnnotationAbscissa(e);
      Device.MoveTo(AA.X1,AA.Y1);
      Device.LineTo(AA.X2,AA.Y2);
   end;
end;

function TGeometryTextAnnotationInterpret.QProcessBefore(Element: TElement): boolean;
begin
   result := (Element.ClassType = TGeometryTextAnnotation) and
   TGeometryTextAnnotation(Element).IsOverRegion(Rect.MinX,Rect.MinY,Rect.MaxX,Rect.MaxY);
end;

INITIALIZATION
   RegisterOrbisClass(TGeometryTextAnnotationInterpret);
END.
