unit t_LHCPDialog;

interface
uses
   Elements,
   e_Type,
   e_LHCModel,
   f_LHCPDialog,
   t_ForestModelSelector,
   t_ParcelModelSelector,
   T_OrbisDialog;
type

TLHCPDialog = class(TOrbisDialog)
private
    FFrame: TElement;
    FDET: boolean;
    FComment: string;
    FOldObjectText: string;
    FNewObjectText: string;
    FMezBezlesi: integer;
    FFMSelector: TForestModelSelector;
    FPMSelector: TParcelModelSelector;
    FZAKColor: integer;
    FDynamicProps: string;
    FtxDilec: string;
    FtxOddeleni: string;
    FtxLHC: string;
    FtxLS: string;
    FtxPorost: string;
    FIfer: boolean;
    FIfer_PorostList: string;
    FKATSList: string;
    FtxTaxPro: string;
    FtxTaxator: string;
    FCursorMoving: string;
    FCursorMovingName: string;
    function GetForm: TLHCPDialog_Form;
    procedure SetFrame(const Value: TElement);
    function GetNewObject: boolean;
    procedure SetDET(const Value: boolean);
    procedure SetComment(const Value: string);
    procedure SetNewObjectText(const Value: string);
    procedure SetOldObjectText(const Value: string);
    procedure SetMezBezlesi(const Value: integer);
    function GetColors: TIntegerListElement;
    function GetColorList: string;
    procedure SetColorList(const Value: string);
    function GetColor: integer;
    procedure SetShowColor(const Value: boolean);
    function GetFMSelector: TForestModelSelector;
    procedure SetZAKColor(const Value: integer);
    function GetChangeAreaOnly: boolean;
    procedure SetChangeAreaOnly(const Value: boolean);
    procedure SetDynamicProps(const Value: string);
    function GetPMSelector: TParcelModelSelector;
    procedure SettxDilec(const Value: string);
    procedure SettxLHC(const Value: string);
    procedure SettxLS(const Value: string);
    procedure SettxOddeleni(const Value: string);
    procedure SettxPorost(const Value: string);
    procedure SetIfer(const Value: boolean);
    function GetIfer_ColorList: string;
    function GetIfer_Colors: TIntegerListElement;
    function GetIfer_SrafaList: string;
    function GetIfer_Srafy: TIntegerListElement;
    procedure SetIfer_ColorList(const Value: string);
    procedure SetIfer_PorostList(const Value: string);
    procedure SetIfer_SrafaList(const Value: string);
    procedure SetIferChange(const Value: boolean);
    procedure SetKATSList(const Value: string);
    procedure SettxTaxator(const Value: string);
    procedure SettxTaxPro(const Value: string);
    function GetTaxators: Tgis_Taxator_Collection;
    procedure SetCursorMoving(const Value: string);
    procedure SetCursorMovingName(const Value: string);
public
   procedure DoIt; override;
   procedure CreateForm; override;
   property  Form: TLHCPDialog_Form read GetForm;
   property  NewObject: boolean read GetNewObject;
   property  Colors: TIntegerListElement read GetColors;
   property  Ifer_Colors: TIntegerListElement read GetIfer_Colors;
   property  Ifer_Srafy: TIntegerListElement read GetIfer_Srafy;
   property  FMSelector: TForestModelSelector read GetFMSelector;
   property  PMSelector: TParcelModelSelector read GetPMSelector;
   property  Taxators: Tgis_Taxator_Collection read GetTaxators;
   property  ChangeAreaOnly: boolean read GetChangeAreaOnly write SetChangeAreaOnly;
published
   property  Frame: TElement read FFrame write SetFrame stored false;
   property  Comment: string read FComment write SetComment;
   property  NewObjectText: string read FNewObjectText write SetNewObjectText;
   property  OldObjectText: string read FOldObjectText write SetOldObjectText;
   property  DET: boolean read FDET write SetDET;
   property  MezBezlesi: integer read FMezBezlesi write SetMezBezlesi;
   property  ColorList: string read GetColorList write SetColorList stored false;
   property  Ifer_ColorList: string read GetIfer_ColorList write SetIfer_ColorList;
   property  Ifer_PorostList: string read FIfer_PorostList write SetIfer_PorostList;
   property  Ifer_SrafaList: string read GetIfer_SrafaList write SetIfer_SrafaList;
   property  Color: integer read GetColor stored false;
   property  ZAKColor: integer read FZAKColor write SetZAKColor;
   property  ShowColor: boolean write SetShowColor stored false;
   property  DynamicProps: string read FDynamicProps write SetDynamicProps;
   property  txLHC: string read FtxLHC write SettxLHC;
   property  txLS: string read FtxLS write SettxLS;
   property  txOddeleni: string read FtxOddeleni write SettxOddeleni;
   property  txDilec: string read FtxDilec write SettxDilec;
   property  txPorost: string read FtxPorost write SettxPorost;
   property  txTaxator: string read FtxTaxator write SettxTaxator;
   property  txTaxPro: string read FtxTaxPro write SettxTaxPro;
   property  Ifer: boolean read FIfer write SetIfer;
   property  IferChange: boolean write SetIferChange stored false;
   property  KATSList: string read FKATSList write SetKATSList;
   property  CursorMovingName: string read FCursorMovingName write SetCursorMovingName;
   property  CursorMoving: string read FCursorMoving write SetCursorMoving stored false;
end;


implementation
uses
   Classes,
   Controls,
   Forms,
   Graphics,
   SysUtils,
   StrUtils,
   IniFiles,
   e_Color,
   e_Geometry,
   e_GeometryElement,
   e_Props,
   e_Class,
   u_String,
   Worlds, StdCtrls;

{ TLHCPDialog }

procedure TLHCPDialog.CreateForm;
var
   ini: TIniFile;
   S: string;
   SL: TStringList;
begin
   aForm := TLHCPDialog_Form.Create(Application);
   aForm.Tool := Self;
   aForm.IsPossibleToClose := false;
   S := GetAbsolutePath('START\PKDET.ini');
   if FileExists(S) then
   begin
      ini := TIniFile.Create(S);
      SL := TStringList.Create;
      ini.ReadSection('PK',SL);
      Form.combo_PK.items.Assign(SL);
      ini.Free;
      SL.Free;
   end;
end;

procedure TLHCPDialog.DoIt;
var
   Are: TAreaElement;
   G: TGeometryElement;
   PSK: Tgis_PorostniSkupina;
   POR: Tgis_Porost;
   SL: TStringList;
   i: integer;
   Taxs: Tgis_Taxator_Collection;
   Tax: Tgis_Taxator;
   FU: Tgis_ForestUnit;
begin
   //Output := nil;
   PSK := nil;
   POR := nil;
   FMSelector.FindInput;
   PMSelector.FindInput;
   Taxs := Taxators;
   if PMSelector.ParcelModel <> nil then
      PMSelector.ParcelModel.UpdateAll := true;
   if DET then
   begin
      FMSelector.FrameClassName := 'Tgis_Porost';
   end;
   Form.ed_NewKAT.Items.Clear;
   Form.ed_NewKAT.Items.CommaText := KATSList;
   SL := TStringList.Create;
   SL.CommaText := DynamicProps;
   Form.DynamicProps := SL;
   Form.FModel := FMSelector.ForestModel;
   Form.Taxators := Taxs;
   Form.NewObject := NewObject;
   Form.Panel_Skupina.Visible := DET;
   Form.Panel_Porost.Enabled := true;//not DET;
   Form.MezBezlesi := MezBezlesi;
   Form.cb_Ifer.Checked := Ifer;
   Are := TAreaElement(Input);
   PMSelector.X := Are.X;
   PMSelector.Y := Are.Y;
   PMSelector.SelectByParcely := true;
   PMSelector.DoIt;
   Form.l_ku.Caption := '---';
   Form.l_SKP.Caption := '---';
   Form.l_katparkod.Caption := '---';
   Form.l_vlastnik.Caption := '---';
   Form.l_ku.Font.Color := clBlue;
   Form.l_SKP.Font.Color := clBlue;
   Form.l_katparkod.Font.Color := clBlue;
   Form.l_vlastnik.Font.Color := clBlue;
   Form.l_Kval.Caption := '-';
   Form.l_Svym.Caption := '---';
   if PMSelector.ActualSkupinaParcel <> nil then
   begin
      Form.p_Achtung.Visible := false;
      Form.ed_KU.Text := PMSelector.ActualSkupinaParcel.GetpropertyStringByName('KU_KOD');
      Form.ed_SkParc.Text := PMSelector.ActualSkupinaParcel.Name;
      Form.ed_Kategorie.Text := PMSelector.ActualSkupinaParcel.GetpropertyStringByName('KATPAR_KOD');
      Form.ed_Vlastnik.Text := PMSelector.ActualSkupinaParcel.GetpropertyStringByName('VLASTNIK');
   end
   else
   begin
      Form.p_Achtung.Visible := true;
      Form.ed_KU.Text := '';
      Form.ed_SkParc.Text := '';
      Form.ed_Kategorie.Text := '';
      Form.ed_Vlastnik.Text := '';
   end;

   if NewObject then
   begin
      Caption := NewObjectText+Comment;
      Form.ed_Vymera.Text := ' ';
      if DET then
      begin
         FMSelector.X := Are.X;
         FMSelector.Y := Are.Y;
         FMSelector.DoIt;
         POR := Tgis_Porost(FMSelector.Output);
         if POR <> nil then
         begin
            FMSelector.ForestModel.ActualLHC := POR._LHC;
            FMSelector.ForestModel.ActualLS  := POR._LS;
            FMSelector.ForestModel.ActualOddeleni := POR._Oddeleni;
            FMSelector.ForestModel.ActualDilec := POR._Dilec;
            FMSelector.ForestModel.ActualPorost := POR;
         end
         else
         begin
            FMSelector.ForestModel.ActualLHC := nil;
            {
            FMSelector.ForestModel.GetLHCCislo( StrToIntDef(txLHC,-1));
            Form.ed_LHC.Text := txLHC;
            Form.ed_LS.Text := txLS;
            Form.ed_Oddeleni.Text := txOddeleni;
            Form.ed_Dilec.Text := txDilec;
            Form.ed_Porost.Text := txPorost;
            }
         end;
      end;
   end
   else
   begin
      //Are := TAreaElement(TGeometryElement(Input).Geometry);
      Caption := OldObjectText+Comment;
      Form.ed_Vymera.Text := Are.GetPropertyStringByName('FixedArea');
   end;
   Form.l_Area.Caption := FormatFloat('0.####', Are.Area);
   Form.l_AreaCount.Caption := '1';
   // Nalezen vlastnost dle Frame
   ChangeAreaOnly := true;
   if not NewObject then
   begin
      if DET then
      begin
         PSK := Tgis_PorostniSkupina(Output);
         G := PSK;
         Form.cb_AreaOnly.Visible := (PSK.Geometry is TMultiAreaElement) and (TMultiAreaElement(PSK.Geometry).Count > 1);
         FMSelector.ForestModel.ActualLHC := PSK._LHC;
         FMSelector.ForestModel.ActualLS  := PSK._LS;
         FMSelector.ForestModel.ActualOddeleni := PSK._Oddeleni;
         FMSelector.ForestModel.ActualDilec := PSK._Dilec;
         FMSelector.ForestModel.ActualPorost := PSK._Porost;
         FMSelector.ForestModel.ActualSkupina := PSK;
         Form.ed_Skupina.Text := PSK.Skupina;
         Form.ed_Srafa.Text := PSK.GetpropertyStringByName('Znacka');
         //Form.ed_LHC.Text := PSK.GetpropertyStringByName('LHC');
         //Form.ed_LS.Text := PSK.GetpropertyStringByName('LS_Kod');
         //Form.ed_Oddeleni.Text := PSK.GetpropertyStringByName('Oddeleni');
         //Form.ed_Dilec.Text := PSK.Dilec;
         //Form.ed_Porost.Text := PSK.Porost;

         Form.l_KU.Caption := PSK.GetpropertyStringByName('KU_KOD');
         Form.l_SKP.Caption := PSK.GetpropertyStringByName('SK_PARC');
         Form.l_Katparkod.Caption := PSK.GetpropertyStringByName('KATPAR_KOD');
         Form.l_Vlastnik.Caption := PSK.GetpropertyStringByName('VLASTNIK');
         Form.combo_Taxator.Text := PSK.Taxator;
         Form.Combo_TaxPro.Text := PSK.TaxPro;
         if Form.Combo_TaxPro.Text = '?' then
            Form.Combo_TaxPro.Text := 'ODD';
         if PSK.SkupinaParcel <> PMSelector.ActualSkupinaParcel then
         begin
            Form.l_ku.Font.Color := clRed;
            Form.l_SKP.Font.Color := clRed;
            Form.l_katparkod.Font.Color := clRed;
            Form.l_vlastnik.Font.Color := clRed;
         end;
         Form.l_Kval.Caption := PSK.GetPropertyStringByName('KVAL_P');
         if PSK.KVAL_P = 1 then
            Form.l_Kval.Font.Color := clBlue
         else
            Form.l_Kval.Font.Color := clRed;
         Form.l_SVym.Caption := '('+PSK.GetPropertyStringByName('Vymera')+')';
         Form.ed_VS.Value := PSK.VEK_ST;
         Form.ed_LVS.Value := PSK.LVS;
         Form.ed_KATS.Text := PSK.KATS;
         Form.ed_ZVL_STATUT.Text := PSK.ZVL_STATUT;
         Form.ed_KAT_Poznamka.Text := PSK.KAT_Poznamka;
      end
      else
      begin
         POR := Tgis_Porost(Output);
         G := POR;
         Form.cb_AreaOnly.Visible := (POR.Geometry is TMultiAreaElement) and (TMultiAreaElement(POR.Geometry).Count > 1);
         FMSelector.ForestModel.ActualLHC := POR._LHC;
         FMSelector.ForestModel.ActualLS  := POR._LS;
         FMSelector.ForestModel.ActualOddeleni := POR._Oddeleni;
         FMSelector.ForestModel.ActualDilec := POR._Dilec;
         FMSelector.ForestModel.ActualPorost := POR;
         Form.l_KU.Caption := POR.GetpropertyStringByName('KU_KOD');
         Form.l_SKP.Caption := POR.GetpropertyStringByName('SK_PARC');
         Form.l_Katparkod.Caption := POR.GetpropertyStringByName('KATPAR_KOD');
         Form.l_Vlastnik.Caption := POR.GetpropertyStringByName('VLASTNIK');
         Form.ed_KATS.Text := POR.KATS;
         Form.ed_ZVL_STATUT.Text := POR.ZVL_STATUT;
         Form.ed_KAT_Poznamka.Text := POR.KAT_Poznamka;
         Form.combo_Taxator.Text := POR.Taxator;
         Form.Combo_TaxPro.Text := POR.TaxPro;
         if Form.Combo_TaxPro.Text = '?' then
            Form.Combo_TaxPro.Text := 'ODD';
      end;
      if G.Geometry is TMultiAreaElement then
         Form.l_AreaCount.Caption := IntToStr(G.Geometry.Count);
      // Dynamicke property
      for i := 0 to SL.Count - 1 do
      begin
         Form.SetDynamicProp(SL.Strings[i],G.GetPropertyStringByName(SL.Strings[i]));
      end;
   end
   else
      Form.cb_AreaOnly.Visible := false;
   if not Form.cb_AreaOnly.Visible then ChangeAreaOnly := false;
   inherited;
   MezBezlesi := Form.MezBezlesi;
   Ifer := Form.cb_Ifer.Checked;
   if Result = 1 then
   begin
      txLHC := Form.ed_LHC.Text;
      txLS := Form.ed_LS.Text;
      txOddeleni := Form.ed_Oddeleni.Text;
      txDilec := Form.ed_Dilec.Text;
      txPorost := Form.ed_Porost.Text;
      txTaxator := Form.combo_Taxator.Text;
      txTaxPro  := Form.Combo_TaxPro.Text;
      if txTaxPro = '?' then
         txTaxPro := 'ODD';
      Are.SetPropertyStringByName('FixedArea',Form.ed_Vymera.Text);
      FU := nil;
      if DET then
      begin
         if (Form.ed_LHC.Text <> '') and (Form.ed_LS.Text <> '') and
            (Form.ed_Oddeleni.Text <> '') and (Form.ed_Dilec.Text <> '') and
            (Form.ed_Porost.Text <> '') then
         begin
            FMSelector.ForestModel.CreateLHCCislo(StrToInt(Form.ed_LHC.Text));
            FMSelector.ForestModel.CreateLSCislo(StrToInt(Form.ed_LS.Text));
            FMSelector.ForestModel.CreateOddeleniCislo(StrToInt(Form.ed_Oddeleni.Text));
            FMSelector.ForestModel.CreateDilecName(Form.ed_Dilec.Text);
            FMSelector.ForestModel.CreatePorostName(Form.ed_Porost.Text);
            if NewObject then
            begin
               // kontrola
               FMSelector.ForestModel.CreateSkupinaName(Form.ed_Skupina.Text);
               PSK := FMSelector.ForestModel.ActualSkupina;
               PSK.AddGeometry(TAreaElement(Input));
            end
            else
            if ChangeAreaOnly then
            begin
               FMSelector.ForestModel.CreateSkupinaName(Form.ed_Skupina.Text);
               if PSK <> FMSelector.ForestModel.ActualSkupina then
               begin
                  TMultiAreaElement(PSK.Geometry).RemoveElement(Are);
                  PSK := FMSelector.ForestModel.ActualSkupina;
                  PSK.AddGeometry(Are);
               end;
            end
            else
            begin
               FMSelector.ForestModel.GetSkupinaName(Form.ed_Skupina.Text);
               if (FMSelector.ForestModel.ActualSkupina <> nil) and
                  (FMSelector.ForestModel.ActualSkupina <> PSK) then
               begin
                  FMSelector.ForestModel.ActualSkupina.AddGeometry(PSK.Geometry);
                  PSK.Geometry := nil;
                  PSK := FMSelector.ForestModel.ActualSkupina;
               end
               else
               if (PSK._Porost <> FMSelector.ForestModel.ActualPorost) then
               begin
                  if (PSK._Porost <> nil) then
                     PSK._Porost.Items.RemoveElement(PSK);
                  FMSelector.ForestModel.ActualPorost.CreateItemName('_').Free;
                  FMSelector.ForestModel.ActualPorost.Items.NextElement := PSK;
               end;
            end;
         end
         else
         if NewObject then
         begin
            PSK := Tgis_PorostniSkupina.Create;
            PSK.Geometry := TAreaElement(Input);
         end;
         Output := PSK;
         PSK.Skupina := Form.ed_Skupina.Text;
         PSK.VEK_ST := Form.ed_VS.Value;
         PSK.LVS := Form.ed_LVS.Value;
         PSK.SetPropertyStringByName('Znacka',Form.ed_Srafa.Text);
         PSK.KATS := Form.ed_KATS.Text;
         PSK.ZVL_STATUT := Form.ed_ZVL_STATUT.Text;
         PSK.KAT_Poznamka := Form.ed_KAT_Poznamka.Text;
         if PSK.Znacka < 999 then PSK.Znacka := 1;
         PSK.Barva := Color;
         if PMSelector.ActualSkupinaParcel <> nil then
            PSK.SkupinaParcel := PMSelector.ActualSkupinaParcel;
         FU := PSK;
      end
      else
      begin
         if (Form.ed_LHC.Text <> '') and (Form.ed_LS.Text <> '') and
            (Form.ed_Oddeleni.Text <> '') and (Form.ed_Dilec.Text <> '') and
            (Form.ed_Porost.Text <> '') then
         begin
            FMSelector.ForestModel.CreateLHCCislo(StrToInt(Form.ed_LHC.Text));
            FMSelector.ForestModel.CreateLSCislo(StrToInt(Form.ed_LS.Text));
            FMSelector.ForestModel.CreateOddeleniCislo(StrToInt(Form.ed_Oddeleni.Text));
            FMSelector.ForestModel.CreateDilecName(Form.ed_Dilec.Text);
            //FMSelector.ForestModel.CreatePorostName(Form.ed_Porost.Text);
            if NewObject then
            begin
               FMSelector.ForestModel.CreatePorostName(Form.ed_Porost.Text);
               POR := FMSelector.ForestModel.ActualPorost;
               POR.AddGeometry(TAreaElement(Input));
            end
            else
            if ChangeAreaOnly then
            begin
               FMSelector.ForestModel.CreatePorostName(Form.ed_Porost.Text);
               if POR <> FMSelector.ForestModel.ActualPorost then
               begin
                  TMultiAreaElement(POR.Geometry).RemoveElement(Are);
                  POR := FMSelector.ForestModel.ActualPorost;
                  POR.AddGeometry(Are);
               end;
            end
            else
            begin
               FMSelector.ForestModel.GetPorostName(Form.ed_Porost.Text);
               if (FMSelector.ForestModel.ActualPorost <> nil) and
                  (FMSelector.ForestModel.ActualPorost <> POR) then
               begin
                  FMSelector.ForestModel.ActualPorost.AddGeometry(POR.Geometry);
                  POR.Geometry := nil;
                  POR := FMSelector.ForestModel.ActualPorost;
               end
               else
               if (POR._Dilec <> FMSelector.ForestModel.ActualDilec) then
               begin
                  if (POR._Dilec <> nil) then
                     POR._Dilec.Items.RemoveElement(POR);
                  FMSelector.ForestModel.ActualDilec.CreateItemName('_').Free;
                  FMSelector.ForestModel.ActualDilec.Items.NextElement := POR;
               end;
            end;
         end
         else
         if NewObject then
         begin
            POR := Tgis_Porost.Create;
            POR.Geometry := TAreaElement(Input);
         end;
         Output := POR;
         POR.Porost := Form.ed_Porost.Text[1];
         //PSK.VEK_ST := Form.ed_VS.Value;
         POR.Znacka := 1;
         POR.Barva := ZAKColor;
         POR.KATS := Form.ed_KATS.Text;
         POR.ZVL_STATUT := Form.ed_ZVL_STATUT.Text;
         POR.KAT_Poznamka := Form.ed_KAT_Poznamka.Text;
         if PMSelector.ActualSkupinaParcel <> nil then
            POR.SkupinaParcel := PMSelector.ActualSkupinaParcel;
         FU := POR;
      end;
      txTaxator := TrimRight(TrimLeft(txTaxator));
      if txTaxator = '-' then
         txTaxator := '';
      if txTaxator <> '' then
      begin
         Tax := Tgis_Taxator(Taxs.FindOrCreateElementName(Tgis_Taxator,txTaxator));
         if txTaxPro = 'ODD' then
         begin
            if FU._Oddeleni <> nil then
               FU._Oddeleni._Taxator := Tax;
         end
         else
         if txTaxPro = 'DIL' then
         begin
            if FU._Dilec <> nil then
               FU._Dilec._Taxator := Tax;
         end
         else
         if txTaxPro = 'POR' then
         begin
            if FU._Porost <> nil then
               FU._Porost._Taxator := Tax;
         end;
      end;
      if SL.Count > 0 then
      begin
         if Output is TPropertyGeometryElement then
         begin
            if TPropertyGeometryElement(Output).NoProperties then
               TPropertyGeometryElement(Output).Properties := TDynamicProperties.Create;
         end;
         for i := 0 to SL.Count - 1 do
         begin
            Output.SetPropertyStringByName(SL.Strings[i],Form.GetDynamicProp(SL.Strings[i]));
         end;
      end;
   end;
   SL.Free;
end;

function TLHCPDialog.GetChangeAreaOnly: boolean;
begin
   result := Form.cb_AreaOnly.Checked;
end;

function TLHCPDialog.GetColor: integer;
begin
   result := 0;
   if Ifer then
   begin
      result := Form.FiferColor;
      exit;
   end;
   if Colors.NoElements then exit;
   if Form.ed_VS.Value > Colors.LastIndex then exit;
   result := Colors.Integers[Form.ed_VS.Value];
end;

function TLHCPDialog.GetColorList: string;
var
   i: integer;
   S: string;
begin
   result := '';
   for i := 0 to Colors.LastIndex do
   begin
      S := IntToStr(Colors.Integers[i]);
      if i = 0 then
         result := S
      else
         result := result + ',' + S;
   end;
end;

function TLHCPDialog.GetColors: TIntegerListElement;
begin
   result := TIntegerListElement(FindOrCreateElementName(TIntegerListElement,'COLORS'));
end;

function TLHCPDialog.GetFMSelector: TForestModelSelector;
begin
   if FFMSelector = nil then
   begin
      FFMSelector := TForestModelSelector.Create;
      AddElement(FFMSelector);
   end;
   result := FFMSelector;
end;

function TLHCPDialog.GetForm: TLHCPDialog_Form;
begin
   result := TLHCPDialog_Form(aForm);
end;

function TLHCPDialog.GetIfer_ColorList: string;
var
   i: integer;
   S: string;
begin
   result := '';
   for i := 0 to Ifer_Colors.LastIndex do
   begin
      S := IntToStr(Ifer_Colors.Integers[i]);
      if i = 0 then
         result := S
      else
         result := result + ',' + S;
   end;
end;

function TLHCPDialog.GetIfer_Colors: TIntegerListElement;
begin
   result := TIntegerListElement(FindOrCreateElementName(TIntegerListElement,'IFER_COLORS'));
end;

function TLHCPDialog.GetIfer_SrafaList: string;
var
   i: integer;
   S: string;
begin
   result := '';
   for i := 0 to Ifer_srafy.LastIndex do
   begin
      S := IntToStr(Ifer_Srafy.Integers[i]);
      if i = 0 then
         result := S
      else
         result := result + ',' + S;
   end;
end;

function TLHCPDialog.GetIfer_Srafy: TIntegerListElement;
begin
   result := TIntegerListElement(FindOrCreateElementName(TIntegerListElement,'IFER_SRAFY'));
end;

function TLHCPDialog.GetNewObject: boolean;
begin
   result := Output = nil;
end;

function TLHCPDialog.GetPMSelector: TParcelModelSelector;
begin
   if FPMSelector = nil then
   begin
      FPMSelector := TParcelModelSelector.Create;
      AddElement(FFMSelector);
   end;
   result := FPMSelector;
end;

function TLHCPDialog.GetTaxators: Tgis_Taxator_Collection;
var
   e: TElement;
   En: TEntity;
begin
   result := nil;
   En := TEntity(World.ObjectModel.FindElementName('DATA'));
   if en = nil then exit;
   result := Tgis_Taxator_Collection(En.FindElementClass(Tgis_Taxator_Collection));
end;

procedure TLHCPDialog.SetChangeAreaOnly(const Value: boolean);
begin
   Form.cb_AreaOnly.CHecked := Value;
end;

procedure TLHCPDialog.SetColorList(const Value: string);
begin
   Colors.FreeAll;
   Colors.ValuesString := Value;
end;

procedure TLHCPDialog.SetComment(const Value: string);
begin
  FComment := Value;
end;

procedure TLHCPDialog.SetCursorMoving(const Value: string);
begin
  FCursorMoving := Value;
end;

procedure TLHCPDialog.SetCursorMovingName(const Value: string);
var
   S,S1: string;
   SL: TStringList;
   ini: TIniFile;
   i, ix: integer;
   CC: TComponent;
   WC: TWinControl;
begin
   if not DET then exit; // pro ZAK se tohle zatim nerealizuje ... hoho
   if FCursorMovingName = Value then exit;
   FCursorMovingName := Value;
   S := GetAbsolutePath('START\PKDET.ini');
   if FileExists(S) then
   begin
      ini := TIniFile.Create(S);
      SL := TStringList.Create;
      S1 := ini.ReadString('PK',Value,'');
      SL.CommaText := S1;
      Form.combo_PKD.Clear;
      if S1 <> '' then
      begin
        Form.combo_PKD.items.Assign(SL);
      end;
      for i := 0 to (Form.ComponentCount - 1) do
      begin
         CC := Form.Components[i];
         if CC is TWinControl then
         begin
            WC := TWinControl(CC);
            WC.TabOrder :=1000;
            WC.TabStop := false;
            if WC.CanFocus and Form.Visible then
            try
               WC.SetFocus;
            except
            end;
            //Form.DefocusControl(WC,false);
         end;
      end;
      for i := (SL.Count - 1) downto 0 do
      begin
         S := SL.Strings[i];
         if AnsiStartsText('SG_',S) then
            CC := Form.SG
         else
            CC := Form.FindComponent(S);
         if (CC <> nil) and (CC is TWinControl) then
         begin
            WC := TWinControl(CC);
            WC.Parent.TabOrder := 0;
            WC.TabOrder := 0;
            WC.TabStop := true;
            if WC.CanFocus and Form.Visible then
            try
               WC.SetFocus;
            except
            end;
            //Form.DefocusControl(WC,false);
         end;
      end;
      {
      for i := 0 to (Form.ComponentCount - 1) do
      begin
         CC := Form.Components[i];
         if CC is TWinControl then
         begin
            WC := TWinControl(CC);
            WC.ShowHint := true;
            //WC.ParentShowHint := false;
            WC.Hint := IntToStr(WC.TabOrder);
         end;
      end;
      }
      Form.combo_PK.Hint := 'Pohyb '+S1;
      Form.combo_PK.ShowHint := true;
      try
         if Form.Visible then
            Form.MoveKurzor('');
      except
      end;
      ini.Free;
      SL.Free;
   end;
end;

procedure TLHCPDialog.SetDET(const Value: boolean);
begin
  FDET := Value;
end;

procedure TLHCPDialog.SetDynamicProps(const Value: string);
begin
  FDynamicProps := Value;
end;

procedure TLHCPDialog.SetFrame(const Value: TElement);
begin
   FFrame := Value;
end;

procedure TLHCPDialog.SetIfer(const Value: boolean);
begin
  FIfer := Value;
end;

procedure TLHCPDialog.SetIferChange(const Value: boolean);
var
   Por: string;
   MezBzl: integer;
   S,SV: string;
   //nS: string;
   VS: integer;
   i: integer;
   ipor: integer;
   srf: integer;
   clr: integer;
begin
   Por := Form.ed_Porost.Text;
   S := Form.ed_Skupina.Text;
   MezBzl := Form.MezBezlesi;
   srf := 1;
   clr := 15;
   i := 1;
   SV := '';
   VS := 0;
   if S <> '' then
   begin
      while not (i > Length(S)) and (S[i]=' ') do Inc(i);
      while not (i > Length(S)) and (S[i] in ['0'..'9']) do
      begin
         SV := SV + S[i];
         Inc(i);
      end;
      VS := StrToInt(SV);
      if VS > MezBzl then
      begin
         VS := 0;
         Form.Sh_Ifer.Visible := false;
      end
      else
      begin
         if SV = '' then
            VS := 0
         else
            VS := StrToIntDef(SV[1],0);
         case VS of
            1,2,3:
            begin
               Form.Sh_Ifer.Visible := true;
               if Por = '' then
                  clr := 13
               else
               begin
                  iPor := pos(Por,Ifer_PorostList);
                  if iPor = 0 then
                     clr := 13
                  else
                     clr := Ifer_Colors.Integers[iPor];
               end;
               if VS = 1 then
               begin
                  Form.Sh_Ifer.Visible := false;
                  srf := 1;
               end
               else
               if VS = 2 then
               begin
                  Form.Sh_Ifer.Brush.Style := bsDiagCross;
                  srf := Ifer_Srafy.Integers[0];
               end
               else  //3
               begin
                  Form.Sh_Ifer.Brush.Style := bsFDiagonal;
                  srf := Ifer_Srafy.Integers[1];
               end;
            end;
            else
               Form.Sh_Ifer.Visible := false;
         end;
      end;
   end;
   Form.ed_VS.Value := VS;
   Form.ed_Srafa.Text := IntToStr(srf);
   Form.p_Color.Color := DejBarvicku(clr);
   Form.FiferColor := clr;
end;

procedure TLHCPDialog.SetIfer_ColorList(const Value: string);
begin
   Ifer_Colors.FreeAll;
   Ifer_Colors.ValuesString := Value;
end;

procedure TLHCPDialog.SetIfer_PorostList(const Value: string);
begin
  FIfer_PorostList := Value;
end;

procedure TLHCPDialog.SetIfer_SrafaList(const Value: string);
begin
   Ifer_Srafy.FreeAll;
   Ifer_Srafy.ValuesString := Value;
end;


procedure TLHCPDialog.SetKATSList(const Value: string);
begin
   FKATSList := Value;
end;

procedure TLHCPDialog.SetMezBezlesi(const Value: integer);
begin
   FMezBezlesi := Value;
end;

procedure TLHCPDialog.SetNewObjectText(const Value: string);
begin
  FNewObjectText := Value;
end;

procedure TLHCPDialog.SetOldObjectText(const Value: string);
begin
  FOldObjectText := Value;
end;

procedure TLHCPDialog.SetShowColor(const Value: boolean);
begin
   if not Value then exit;
   Form.p_Color.Color := DejBarvicku(Color);
end;

procedure TLHCPDialog.SettxDilec(const Value: string);
begin
  FtxDilec := Value;
end;

procedure TLHCPDialog.SettxLHC(const Value: string);
begin
  FtxLHC := Value;
end;

procedure TLHCPDialog.SettxLS(const Value: string);
begin
  FtxLS := Value;
end;

procedure TLHCPDialog.SettxOddeleni(const Value: string);
begin
  FtxOddeleni := Value;
end;

procedure TLHCPDialog.SettxPorost(const Value: string);
begin
  FtxPorost := Value;
end;

procedure TLHCPDialog.SettxTaxator(const Value: string);
begin
  FtxTaxator := Value;
end;

procedure TLHCPDialog.SettxTaxPro(const Value: string);
begin
  FtxTaxPro := Value;
end;

procedure TLHCPDialog.SetZAKColor(const Value: integer);
begin
   FZAKColor := Value;
end;

INITIALIZATION
   RegisterOrbisClass(TLHCPDialog);
END.
