unit t_LHCProjectDialog;

interface
uses
   f_LHCProjectDialog,
   t_OrbisDialog;
type

TLHCProjectDialog = class(TOrbisDialog)
private
    FNewProject: boolean;
    FProjectDirectory: string;
    function GetForm: TLHCProjectDialog_Form;
    procedure SetNewProject(const Value: boolean);
    procedure SetProjectDirectory(const Value: string);
public
   procedure DoIt; override;
   procedure CreateForm; override;
   property  Form: TLHCProjectDialog_Form read GetForm;
   property  NewProject: boolean read FNewProject write SetNewProject;
published
   property  ProjectDirectory: string read FProjectDirectory write SetProjectDirectory;
end;

implementation
uses
   Forms,
   SysUtils,
   e_Class,
   e_LHCProject,
   u_String;

{ TLHCProjectDialog }

procedure TLHCProjectDialog.CreateForm;
begin
   aForm := TLHCProjectDialog_Form.Create(Application);
   aForm.Tool := Self;
   aForm.IsPossibleToClose := false;
end;

procedure TLHCProjectDialog.DoIt;
var
   P: TORBISLHCProject;
   S,S1,S3: string;
   i: integer;
begin
   P := TORBISLHCProject(Input);
   if Input = nil then NewProject := true
   else
   begin
      Caption := 'Vlastnosti projektu: '+ P.Name;
      Form.ed_Name.Text := P.Name;
      Form.ed_Name.Enabled := false;
      Form.ed_Author.Text := P.Author;
      Form.m_Comment.Text := P.Comment;
      Form.ed_ExternalData.Text := P.ExternalDataDirectory;
      Form.ed_ParcelData.Text := P.ExternalParcelDirectory;
      if P.ExportDataDirectory = '' then
         P.ExportDataDirectory := P.ExternalDataDirectory;
      if P.ExportParcelDirectory = '' then
         P.ExportParcelDirectory := P.ExternalParcelDirectory;
      Form.ed_ExportData.Text := P.ExportDataDirectory;
      Form.ed_ExportParcel.Text := P.ExportParcelDirectory;
      Form.ed_Data.Text := P.DataDirectory;
   end;
   if NewProject then
   begin
      S := ProjectDirectory;
      Form.ed_Data.Text := S;
      CheckBackSlash(S);
      S1 := 'Nov projekt';
      Caption := S1;
      S3 := '';
      if FileExists(S + S1 + '.OPR') then
      begin
         i := 1;
         S3 := IntToStr(i);
         while FileExists(S + S1 + S3 + '.OPR') do
         begin
            Inc(i);
            S3 := IntToStr(i);
         end;
      end;
      Form.ed_Name.Text := (S1 + S3);
   end;
   Form.ed_Data.Enabled := NewProject;
   Form.b_Data.Enabled := NewProject;
   Inherited;
   case Result of
      1:
      begin
         if NewProject then P := TORBISLHCProject.Create;
         P.Name := Form.ed_Name.Text;
         P.Author := Form.ed_Author.Text;
         P.Comment := Form.m_Comment.Text;
         P.ExternalDataDirectory := Form.ed_ExternalData.Text;
         P.ExternalParcelDirectory := Form.ed_ParcelData.Text;
         P.ExportDataDirectory := Form.ed_ExportData.Text;
         P.ExportParcelDirectory := Form.ed_ExportParcel.Text;
         P.DataDirectory := Form.ed_Data.Text;
         ProjectDirectory := Form.ed_Data.Text;
         Output := P;
      end;
   end;
end;

function TLHCProjectDialog.GetForm: TLHCProjectDialog_Form;
begin
   result := TLHCProjectDialog_Form(aForm);
end;

procedure TLHCProjectDialog.SetNewProject(const Value: boolean);
begin
  FNewProject := Value;
end;


procedure TLHCProjectDialog.SetProjectDirectory(const Value: string);
begin
  FProjectDirectory := Value;
end;

INITIALIZATION
   RegisterOrbisClass(TLHCProjectDialog);
END.
