unit t_SelectSkupina;

interface
uses
   Elements,
   t_InterfaceTool,
   m_Intera,
   t_FrameSelect,
   //t_Helhie,
   G_Elems;

type


TSkupinaSelector = class(TFrameSelector)
private
   FOModel: TElement;
   FOCount: integer;
   FHele: THeleSkupina;
    FQTree: TRectEntityQTree;
   function GetHele: THeleSkupina;
   procedure CheckObjectModel;
    procedure SetQTree(const Value: TRectEntityQTree);
    procedure CreateQTree;
public
   procedure   DoIt; override;
   procedure   FindInput; override;
   property    QTree: TRectEntityQTree read FQTree write SetQTree;
end;



TSelectSkupina = class(TInterfaceTool)
private
   FHele: THeleSkupina;
   function GetHele: THeleSkupina;
   function GetFrame: TRectEntity;
public
   procedure On_tm_MouseUp(var aMessage: TOrbisMouseEvent; var Handled: boolean); override;
   property Hele: THeleSkupina read GetHele;
   property Frame: TRectEntity read GetFrame;
end;

implementation
uses
   e_Class,
   m_Orbis,
   Worlds;
{ TSelectSkupina }

function TSelectSkupina.GetFrame: TRectEntity;
var
   E: TOwnerEntity;
begin
   E := TOwnerEntity(World.ObjectModel.FindOrCreateElementName(TOwnerEntity,'SELECT'));
   result := TRectEntity(E.FindOrCreateElementName(TOwnerEntity,'FRAME'));
end;

function TSelectSkupina.GetHele: THeleSkupina;
var
   aData,
   aHier: TEntity;
begin
   result := nil;
   if FHele = nil then
   begin
      FHele := THeleSkupina.Create;
      AddElement(FHele);
      aData:= TEntity(World.ObjectModel.FindElementName('DATA'));
      if aData = nil then exit;
      aHier:= TEntity(aData.FindElementName('HIERARCHY'));
      if aHier = nil then exit;
      FHele.Input := aHier;
   end;
   result := FHele;
end;

procedure TSelectSkupina.On_tm_MouseUp(var aMessage: TOrbisMouseEvent;
  var Handled: boolean);
var
   Coord: TDoubleCoord;
begin
   Coord:= Device.Projection.GetModelPoint(aMessage.x, aMessage.y);
   Hele.X:= Coord.X;
   Hele.Y:= Coord.Y;
   Hele.Found:= false;
   Hele.DoIt;
   if Hele.Found then
   begin
      postTextMsg(tm_AddToProtocol,'Selected: '+ Hele.LHC + ' ' + Hele.ODD + ' ' + Hele.DIL + ' ' + Hele.POR + '-' + Hele.PSK,nil);
      PostMsgToOwners(tm_ElementSelected, Hele.PSKObject, false);
      Frame.FreeAll;
      Frame.AddElement(Hele.PSKObject);
      Frame.ResetAndUpdate;
   end;
end;

{ TSkupinaSelector }

procedure TSkupinaSelector.CheckObjectModel;
var
   E: TElement;
begin
   E := World.ObjectModel;
   if E <> FOModel then
   begin
      FindInput;
      CreateQTree;
   end
   else
   if FOCount <> TEntity(Input).Count then
   begin
      CreateQTree;
      FOCount := TEntity(Input).Count;
   end;
end;

procedure TSkupinaSelector.CreateQTree;
var
   AQ: TAddEntityToQTree;
begin
   AQ := TAddEntityToQTree.Create;
   AQ.Input := Input;
   AQ.DoIt;
   QTree := AQ.Output;
   AQ.Free;
end;

procedure TSkupinaSelector.DoIt;
begin
   CheckObjectModel;
   Output := nil;
   Hele.X:= X;
   Hele.Y:= Y;
   Hele.Found:= false;
   Hele.DoIt;
   if Hele.Found then
   begin
      Output := Hele.PSKObject;
      PostMsgToOwners(tm_ElementSelected, Hele.PSKObject, false);
      //Frame.FreeAll;
      //Frame.AddElement(Hele.PSKObject);
      //Frame.ResetAndUpdate;
   end;
end;

procedure TSkupinaSelector.FindInput;
var
   aData,
   aHier: TEntity;
begin
   FOModel := World.ObjectModel;
   Input := nil;
   aData:= TEntity(World.ObjectModel.FindElementName('DATA'));
   if aData = nil then exit;
   aHier:= TEntity(aData.FindElementName('LHC'));
   if aHier = nil then exit;
   Input := aHier;
end;

function TSkupinaSelector.GetHele: THeleSkupina;
begin
   if FHele = nil then
   begin
      FHele := THeleSkupina.Create;
      AddElement(FHele);
      FHele.Input := Input;
   end;
   result := FHele;
end;

procedure TSkupinaSelector.SetQTree(const Value: TRectEntityQTree);
begin
   ExchangeFieldElement(TElement(FQTree), Value);
end;

initialization
   RegisterOrbisClass(TSkupinaSelector);
   RegisterOrbisClass(TSelectSkupina);
end.
