unit t_SimpleTextDialog;
interface
uses
   e_BGIF,
   f_SimpleTextDialog,
   t_OrbisDialog;

type

TSimpleTextDialog = class(TOrbisDialog)
  private
    FNew: boolean;
    function GetForm: TSimpleTextDialog_Form;
    function GetText: string;
    procedure SetText(const Value: string);
    function GetStyly: TTextStyles;
    procedure SetStyly(const Value: TTextStyles);
    function GetStyl: integer;
    procedure SetStyl(const Value: integer);
    procedure SetNew(const Value: boolean);
public
   procedure DoIt; override;
   procedure CreateForm; override;
   property  Form: TSimpleTextDialog_Form read GetForm;
published
   property Text: string read GetText write SetText;
   property Styly: TTextStyles read GetStyly write SetStyly;
   property Styl: integer read GetStyl write SetStyl;
   property New: boolean read FNew write SetNew;
end;

implementation
uses
   Forms,
   e_Class;

{ TSimpleTextDialog }

procedure TSimpleTextDialog.CreateForm;
begin
   aForm := TSimpleTextDialog_Form.Create(Application);
   aForm.Tool := Self;
   aForm.IsPossibleToClose := false;
end;

procedure TSimpleTextDialog.DoIt;
begin
  inherited;

end;

function TSimpleTextDialog.GetForm: TSimpleTextDialog_Form;
begin
   result := TSimpleTextDialog_Form(aForm);
end;



function TSimpleTextDialog.GetStyl: integer;
begin
   result := Form.Styl;
end;

function TSimpleTextDialog.GetStyly: TTextStyles;
begin
   result := Form.Styly;
end;

function TSimpleTextDialog.GetText: string;
begin
   result := Form.Edit.Text;
end;


procedure TSimpleTextDialog.SetNew(const Value: boolean);
begin
  FNew := Value;
  Form.New := Value;
end;

procedure TSimpleTextDialog.SetStyl(const Value: integer);
begin
   Form.Styl := Value;
end;

procedure TSimpleTextDialog.SetStyly(const Value: TTextStyles);
begin
   Form.Styly := Value;
end;

procedure TSimpleTextDialog.SetText(const Value: string);
begin
   Form.Edit.Text := Value;
end;

INITIALIZATION
   RegisterOrbisClass(TSimpleTextDialog);
END.
