unit t_TezpDialog;

interface
uses
   Elements,
   e_LHCModel,
   e_GeometryElement,
   f_TezPDialog,
   t_OrbisDialog;

type
TTezPDialog = class(TOrbisDialog)
private
    FFrame: TElement;
    FSRFOnly: boolean;
    FCarryAreaFromFrame: boolean;
    FFrameAreaPropertyName: string;
    FAreaPropertyName: string;
    FBigFrame: TElement;
    FReturnLines: boolean;
    FSrfPrepared: boolean;
    FSRFPictures: boolean;
    FBordToSluAllow: boolean;
    function GetForm: TTezpDialog_Form;
    function GetSkupina: TGeometryElement;
    procedure SetFrame(const Value: TElement);
    procedure SetSRFOnly(const Value: boolean);
    procedure SetCarryAreaFromFrame(const Value: boolean);
    procedure SetFrameAreaPropertyName(const Value: string);
    procedure SetAreaPropertyName(const Value: string);
    procedure SetAreaFromFrame;
    procedure SetCarryArea(const Value: boolean);
    procedure SetBigFrame(const Value: TElement);
    procedure SetReturnLines(const Value: boolean);
    procedure SetSrfPrepared(const Value: boolean);
    procedure SetSRFPictures(const Value: boolean);
    procedure SetBordToSluAllow(const Value: boolean);
public
   procedure DoIt; override;
   procedure CreateForm; override;
   property  Form: TTezpDialog_Form read GetForm;
   property  Skupina: TGeometryElement read GetSkupina;
   property  SrfPrepared: boolean read FSrfPrepared write SetSrfPrepared;
published
   property  BigFrame: TElement read FBigFrame write SetBigFrame stored false;
   property  Frame: TElement read FFrame write SetFrame stored false;
   property  SRFOnly: boolean read FSRFOnly write SetSRFOnly;
   property  CarryAreaFromFrame: boolean read FCarryAreaFromFrame write SetCarryAreaFromFrame;
   property  FrameAreaPropertyName: string read FFrameAreaPropertyName write SetFrameAreaPropertyName;
   property  CarryArea: boolean write SetCarryArea stored false;
   property  ReturnLines: boolean read FReturnLines write SetReturnLines;
   property  SRFPictures: boolean read FSRFPictures write SetSRFPictures;
   property  BordToSluAllow: boolean read FBordToSluAllow write SetBordToSluAllow;
end;

implementation
uses
   Classes,
   Forms,
   SysUtils,
   e_Geometry,
   e_LHCElements,
   e_Class,
   t_PrepareSymbols, t_FormTool;
   //e_LHCProps,
   //e_Space,
   //t_SpPick;

{ TTezPDialog }

procedure TTezPDialog.CreateForm;
begin
   aForm := TTezPDialog_Form.Create(Application);
   aForm.Tool := Self;
   aForm.IsPossibleToClose := false;
end;

procedure TTezPDialog.DoIt;
var
   Are: TAreaElement;
   GAre: TGeometryElement;
   S: string;
   PS: TPrepareARESymbols;
   SL: TStringList;
   i: integer;
begin
   Are := nil;
   GAre := nil;
   Form.b_SLU.Visible := BordToSluAllow;
   if input = nil then exit;
   if SRFPictures then
   begin
      Form.ed_Srafa.Visible := false;
      Form.ComboSRF.Visible := true;
      Form.cb_SRFPictures.Checked := true;
      if not SrfPrepared then
      begin
         // priprava sraf
         PS := TPrepareARESymbols.Create;
         SL := TStringList.Create;
         PS.FillARESymbolsList(SL);
         PS.FillComboBoxEx(Form.ComboSRF,SL,30,20);
         SL.Free;
         PS.Free;
         SRFPrepared := true;
      end;
   end
   else
   begin
      Form.ed_Srafa.Visible := true;
      Form.ComboSRF.Visible := false;
      Form.cb_SRFPictures.Checked := false;
   end;
   if SRFOnly then
   begin
      Form.b_SetArea.Visible := false;
      Form.ed_Nalehavost.Visible := false;
      Form.ed_Zpusob.Visible := false;
      Form.ed_Area.Visible := false;
      Form.Label2.Visible := false;
      Form.Label3.Visible := false;
      Form.Label5.Visible := false;
   end;
   if Input is TAreaElement then Are := TAreaElement(Input)
   else
   if Input is TGeometryElement then
   begin
      GAre := TGeometryElement(Input);
      Are := TAreaElement(GAre.Geometry);
   end
   else
      exit;
   if Skupina <> nil then
   begin
      S := Skupina.GetPropertyStringByName('LHC') + ' ' +
           Skupina.GetPropertyStringByName('Oddeleni') + ' ' +
           Skupina.GetPropertyStringByName('Dilec') + ' '+
           Skupina.GetPropertyStringByName('Porost') + ' ' + Skupina.Name;

      //S := '-';
      Form.l_Skupina.Caption := S;
   end
   else
   begin
      Form.l_Skupina.Caption := '***';
   end;
   Form.l_Area.Caption := FormatFloat('0.####', Are.Area);
   Form.cb_ReturnLines.Checked := ReturnLines;
   if GAre <> nil then
   begin
      if not SRFOnly then
      begin
         Form.ed_Area.Text := Are.GetPropertyStringByName('FixedArea');
         Form.ed_Nalehavost.Text := GAre.GetPropertyStringByName('NALEHAVOST');
         Form.ed_Zpusob.Text := GAre.GetPropertyStringByName('ZPUSOB');
      end;
      if SRFPictures then
      begin
         S := GAre.GetPropertyStringByName('ZNACKA');
         i := Form.ComboSRF.Items.IndexOf(S);
         if i >= 0 then
            Form.ComboSRF.ItemIndex := i
         else
            FOrm.ComboSRF.Text := S;
      end
      else
         Form.ed_Srafa.Text := GAre.GetPropertyStringByName('ZNACKA');
      Form.b_Delete.Enabled := true;
      Form.cb_ReturnLines.Enabled := true;
   end
   else
   begin
      Form.b_Delete.Enabled := false;
      Form.cb_ReturnLines.Enabled := false;
      if not SRFOnly then
      begin
         if not CarryAreaFromFrame then
            Form.ed_Area.Text := FormatFloat('0.####', Are.Area/10000)
         else
            SetAreaFromFrame;
      end;
   end;
   inherited;
   ReturnLines := Form.cb_ReturnLines.Checked;
   if Result = 1 then
   begin
      (*
      if not SRFOnly then
      begin
         Are.SetPropertyStringByName('VYMERA',Form.ed_Area.Text);
         Are.SetPropertyStringByName('NALEHAVOST',Form.ed_Nalehavost.Text);
         Are.SetPropertyStringByName('ZPUSOB',Form.ed_Zpusob.Text);
      end;
      *)
      if GAre = nil then
      begin
         if not SRFOnly then
            GAre := TTezPlocha.Create
         else
            GAre := TSRFPlocha.Create;
         GAre.Geometry := Are;
      end;
      Output := GAre;
      if not SRFOnly then
      begin
         Are.SetPropertyStringByName('FixedArea',Form.ed_Area.Text);
         GAre.SetPropertyStringByName('NALEHAVOST',Form.ed_Nalehavost.Text);
         GAre.SetPropertyStringByName('ZPUSOB',Form.ed_Zpusob.Text);
      end;
      GAre.SetPropertyStringByName('Barva','15');
      if SRFPictures then
         GAre.SetPropertyStringByName('ZNACKA',Form.ComboSRF.Text)
      else
         GAre.SetPropertyStringByName('ZNACKA',Form.ed_Srafa.Text);
   end;
   SRFPictures := Form.cb_SRFPictures.Checked;
end;

function TTezPDialog.GetForm: TTezpDialog_Form;
begin
   result := TTezpDialog_Form(aForm);
end;


function TTezPDialog.GetSkupina: TGeometryElement;
begin
   result := TGeometryElement(BigFrame);
   //result := nil;
end;

procedure TTezPDialog.SetAreaFromFrame;
var
   E: TEntity;
   S: string;
   FrameArea: TAreaElement;
begin
   S := '';
   if (Frame = nil) or not (Frame is TAreaElement)then
   begin
      Form.ed_Area.Text := S;
      exit;
   end;
   FrameArea := TAreaElement(Frame);
   //if FrameAreaPropertyName = '' then
   //   FrameAreaPropertyName := 'VYMERA';
   S := FrameArea.GetPropertyStringByName('FixedArea');
   Form.ed_Area.Text := S;
end;

procedure TTezPDialog.SetAreaPropertyName(const Value: string);
begin
   FAreaPropertyName := Value;
end;

procedure TTezPDialog.SetBigFrame(const Value: TElement);
begin
   FBigFrame := Value;
end;

procedure TTezPDialog.SetBordToSluAllow(const Value: boolean);
begin
  FBordToSluAllow := Value;
end;

procedure TTezPDialog.SetCarryArea(const Value: boolean);
var
   Are: TAreaElement;
begin
   Are := nil;
   if Input is TAreaElement then
      Are := TAreaElement(Input)
   else
   if Input is TGeometryElement then
      Are := TAreaElement(TGeometryElement(Input).Geometry);
   if Are = nil then
   begin
      Form.ed_Area.Text := '000';
      exit;
   end;
   if not SRFOnly then
   begin
      if not CarryAreaFromFrame then
         Form.ed_Area.Text := FormatFloat('0.####', Are.Area/10000)
      else
         SetAreaFromFrame;
   end;
   Application.ProcessMessages;
end;

procedure TTezPDialog.SetCarryAreaFromFrame(const Value: boolean);
begin
   FCarryAreaFromFrame := Value;
end;

procedure TTezPDialog.SetFrame(const Value: TElement);
begin
   FFrame := Value;
end;


procedure TTezPDialog.SetFrameAreaPropertyName(const Value: string);
begin
   FFrameAreaPropertyName := Value;
end;

procedure TTezPDialog.SetReturnLines(const Value: boolean);
begin
  FReturnLines := Value;
end;

procedure TTezPDialog.SetSRFOnly(const Value: boolean);
begin
   FSRFOnly := Value;
end;

procedure TTezPDialog.SetSRFPictures(const Value: boolean);
begin
  FSRFPictures := Value;
end;

procedure TTezPDialog.SetSrfPrepared(const Value: boolean);
begin
  FSrfPrepared := Value;
end;

INITIALIZATION
   RegisterOrbisClass(TTezpDialog);
END.
