unit t_gis_ParcelaCastSelector;

interface
uses
   m_Intera,
   t_ParcelModelSelector,
   T_GraphicSelectors;

type

Tgis_ParcelaCastSelector = class(TGraphicSelector)
private
   FSel: TParcelModelSelector;
    function GetSel: TParcelModelSelector;
protected
   property Sel: TParcelModelSelector read GetSel;
public
   procedure  RegisterCursors; override;
   procedure  On_tm_MouseUp(var aMessage: TOrbisMouseEvent; var Handled: boolean); override;
   procedure   XORDraw;

end;

implementation
uses
   Controls,
   Forms,
   Graphics,
   e_Class,
   e_Geometry,
   e_GeometryElement,
   m_Orbis;

{ Tgis_ParcelaCastSelector }


function Tgis_ParcelaCastSelector.GetSel: TParcelModelSelector;
begin
   if FSel = nil then
   begin
      Fsel := TParcelModelSelector.Create;
      FSel.FindInput;
      FSel.SelectByParcely := true;
      AddTool(FSel);
   end;
   result := FSel;
end;

procedure Tgis_ParcelaCastSelector.On_tm_MouseUp(var aMessage: TOrbisMouseEvent; var Handled: boolean);
var
   aX,aY: double;
begin
    Handled := true;
    Output := nil;
    if aMessage.Button = mbLeft then
    begin
       if Sel = nil then exit;
       Sel.FindInput;
       aX := Device.Projection.GetModelX(aMessage.x);
       aY := Device.Projection.GetModelY(aMessage.y);
       SelX := aX;
       SelY := aY;
       if CLient then
       begin
          PostMsgToOwners(tm_ElementSelected,Self,false);
       end
       else
       begin
          Sel.X := aX;
          Sel.Y := aY;
          Sel.DoIt;
          Output := Sel.ActualParCast;
          if Output = nil then exit;
          XORDraw;
          PostMsgToOwners(tm_ElementSelected,Output,false);
       end;
       Application.ProcessMessages;
    end;
end;

procedure Tgis_ParcelaCastSelector.RegisterCursors;
begin
   NewCursorName('AREASELECT');
end;

procedure Tgis_ParcelaCastSelector.XORDraw;
var
   i: integer;
   MA: TMultiAreaElement;
   GArea: TGeometryElement;
   Area: TAreaElement;

procedure PaintArea(anArea: TAreaElement);
var
   Are: TAreaElement;
   Color: integer;
   KillArea: boolean;
begin
   if anArea = nil then exit;
   {if Color = 0 then }Color := $AAAAAA;
   KillArea := false;
   if anArea is TPolyLineAreaElement then
   begin
      Are := TPolyLineAreaElement(anArea).CreateAreaElement;
      KillArea := true;
   end
   else
   begin
      Are := anArea;
      KillArea := false;
   end;
    Device.Brush.Color:= Color;
    if anArea = Area then
       Device.Brush.Style:= bsbDiagonal
    else
       Device.Brush.Style:= bsDiagCross;
    Device.Pen.Mode:= pmXOR;
    Device.Pen.Width:= 3;
    Device.Pen.Color:= Color;
    Device.Pen.Style:= psSolid;
    Device.PolyPolygon(Are);
    PostMsgToOwners(tm_Repaint,nil,false);
    Application.ProcessMessages;
    if KillArea then
       Are.Free;
end;

begin
   GArea := TGeometryElement(Output);
   if GArea = nil then exit;
   if not (GArea.Geometry is TMultiAreaElement) then
      PaintArea(TAreaElement(GArea.Geometry))
   else
   begin
      MA := TMultiAreaElement(GArea.Geometry);
      for i := 0 to MA.LastIndex do
      begin
         PaintArea(MA.AreaElement[i]);
      end;
   end;

end;

INITIALIZATION
   RegisterOrbisClass(Tgis_ParcelaCastSelector);
END.
