unit t_gis_PorostniSkupinaSelector;

interface
uses
   m_Intera,
   t_ForestModelSelector,
   T_GraphicSelectors;

type

Tgis_PorostniSkupinaSelector = class(TGraphicSelector)
private
   FSel: TForestModelSelector;
    function GetSel: TForestModelSelector;
protected
   property Sel: TForestModelSelector read GetSel;
public
   procedure  RegisterCursors; override;
   procedure  On_tm_MouseUp(var aMessage: TOrbisMouseEvent; var Handled: boolean); override;
   procedure   XORDraw;

end;

implementation
uses
   Controls,
   Forms,
   Graphics,
   e_Class,
   e_Geometry,
   e_GeometryElement,
   m_Orbis;

{ Tgis_PorostniSkupinaSelector }


function Tgis_PorostniSkupinaSelector.GetSel: TForestModelSelector;
begin
   if FSel = nil then
   begin
      Fsel := TForestModelSelector.Create;
      FSel.FindInput;
      FSel.FrameClassName := 'Tgis_PorostniSkupina';
      AddTool(FSel);
   end;
   result := FSel;
end;

procedure Tgis_PorostniSkupinaSelector.On_tm_MouseUp(var aMessage: TOrbisMouseEvent; var Handled: boolean);
var
   aX,aY: double;
begin
    Handled := true;
    Output := nil;
    if aMessage.Button = mbLeft then
    begin
       if Sel = nil then exit;
       Sel.FindInput;
       aX := Device.Projection.GetModelX(aMessage.x);
       aY := Device.Projection.GetModelY(aMessage.y);
       SelX := aX;
       SelY := aY;
       if CLient then
       begin
          PostMsgToOwners(tm_ElementSelected,Self,false);
       end
       else
       begin
          Sel.X := aX;
          Sel.Y := aY;
          Sel.DoIt;
          Output := Sel.Output;
          if Output = nil then exit;
          XORDraw;
          PostMsgToOwners(tm_ElementSelected,Sel.Output,false);
       end;
       Application.ProcessMessages;
    end;
end;

procedure Tgis_PorostniSkupinaSelector.RegisterCursors;
begin
   NewCursorName('AREASELECT');
end;

procedure Tgis_PorostniSkupinaSelector.XORDraw;
var
   i: integer;
   MA: TMultiAreaElement;
   GArea: TGeometryElement;
   Area: TAreaElement;

procedure PaintArea(anArea: TAreaElement);
var
   Are: TAreaElement;
   Color: integer;
begin
   if anArea = nil then exit;
   {if Color = 0 then }Color := $AAAAAA;
   Are := TPolyLineAreaElement(anArea).CreateAreaElement;
    Device.Brush.Color:= Color;
    if anArea = Area then
       Device.Brush.Style:= bsbDiagonal
    else
       Device.Brush.Style:= bsDiagCross;
    Device.Pen.Mode:= pmXOR;
    Device.Pen.Width:= 3;
    Device.Pen.Color:= Color;
    Device.Pen.Style:= psSolid;
    Device.PolyPolygon(Are);
    PostMsgToOwners(tm_Repaint,nil,false);
    Application.ProcessMessages;
    Are.Free;
end;

begin
   GArea := TGeometryElement(Output);
   if GArea = nil then exit;
   if not (GArea.Geometry is TMultiAreaElement) then
      PaintArea(TAreaElement(GArea.Geometry))
   else
   begin
      MA := TMultiAreaElement(GArea.Geometry);
      for i := 0 to MA.LastIndex do
      begin
         PaintArea(MA.AreaElement[i]);
      end;
   end;

end;

INITIALIZATION
   RegisterOrbisClass(Tgis_PorostniSkupinaSelector);
END.
