unit T_SelG;

interface

uses
   Controls,
   Elements,
   G_Elems,
   e_Guide,
   e_MSpace,
   M_InterA,
   t_InterA;

type
(*
TGuide_50_Selector = class(TInteractiveTool)
 protected
   function  Getname: string; override;
 public
   procedure On_tm_MouseUp(var aMessage: TOrbisMouseEvent; var Handled: boolean); override;
end;

TGuide_25_Selector = class(TInteractiveTool)
 protected
   function  Getname: string; override;
 public
   procedure On_tm_MouseUp(var aMessage: TOrbisMouseEvent; var Handled: boolean); override;
end;


TGuide_10_Selector = class(TInteractiveTool)
 protected
   function  Getname: string; override;
 public
   procedure On_tm_MouseUp(var aMessage: TOrbisMouseEvent; var Handled: boolean); override;
end;

TGuide_5_Selector = class(TInteractiveTool)
 protected
   function  Getname: string; override;
 public
   procedure On_tm_MouseUp(var aMessage: TOrbisMouseEvent; var Handled: boolean); override;
end;

*)


TGuideSelector = class(TInteractiveTool)
 private
   FSelect50: boolean;
   FSelect25: boolean;
   FSelect10: boolean;
   FSelect5: boolean;
   FSelect2: boolean;
   FSelectU: boolean;
   FSelectZM: boolean;

   FCoord: TDoubleCoord;
   FV,FH: integer;
    FNewSpace: boolean;
    FMakeDetail: boolean;
    FGuide: TGuide;
    procedure SetGuide(const Value: TGuide);
    procedure SetMakeDetail(const Value: boolean);
    procedure SetNewSpace(const Value: boolean);
 protected
   function  Getname: string; override;
   function  GetCursor: TCursor; override;
   function  Get50: TGuidePage_50;
   function  Get25: TGuidePage_25;
   function  Get10: TGuidePage_10;
   function  Get5: TGuidePage_5;
   function  Get2: TGuidePage_2;
   property  Guide: TGuide read FGuide write SetGuide;
   property  NewSpace: boolean read FNewSpace write SetNewSpace;
 public
   procedure Show(aMap: TMapSpace);
   procedure On_tm_MouseUp(var aMessage: TOrbisMouseEvent; var Handled: boolean); override;
   property  MakeDetail: boolean read FMakeDetail write SetMakeDetail;
   property  Select50: boolean read FSelect50 write FSelect50;
   property  Select25: boolean read FSelect25 write FSelect25;
   property  Select10: boolean read FSelect10 write FSelect10;
   property  Select5: boolean read FSelect5 write FSelect5;
   property  Select2: boolean read FSelect2 write FSelect2;
   property  SelectU: boolean read FSelectU write FSelectU;
   property  SelectZM: boolean read FSelectZM write FSelectZM;
end;

implementation

uses
   { Test }
   WinProcs,
   Dialogs,

   Graphics,
   //g_Elems,
   e_ZM,
   i_Guide,
   m_Proj,
   u_Cursor,
   Worlds;

 (*

{ TGuide_50_Selector }

procedure TGuide_50_Selector.On_tm_MouseUp(var aMessage: TOrbisMouseEvent; var Handled: boolean);
var
   Guide: TGuide;
   Guide_50: TGuidePage_50;
   Guide_10: TGuidePage_10;
   Coord: TDoubleCoord;
   H, V: longInt;
   I_Guide: TGuideInterpret;
begin
    Handled := true;
    if aMessage.Button = mbLeft then
    begin
        try
           if Input = nil then exit;
           if Input is TGuide then Guide := TGuide(Input)
                              else Guide := TGuide(TEntity(Input).FindElementClass(TGuide));
           if Guide = nil then exit;
           Coord := Device.Projection.GetModelPoint(aMessage.x, aMessage.y);

           Guide_50 := TGuidePage_50(Guide.SMO_50[Coord.x, Coord.y]);
           if Guide_50 = nil then exit;
           Coord.x := Guide_50.MaxX - Coord.x;
           Coord.Y := Guide_50.MaxY - Coord.y;
           H := round(Coord.x) div SMO_5_H;
           V := round(Coord.y) div SMO_5_V;
           Guide_10 := TGuidePage_10(Guide_50.Add_SMO_10_ByCR(H, V));
           if assigned(Guide_10) then
           begin
              I_Guide := TGuideInterpret.Create;
              I_Guide.Show_10 := true;
              I_Guide.Show_Text := true;
              I_Guide.Fill_Page := true;
              I_Guide.Input := Guide_10;
              I_Guide.Reset(Device);
              I_Guide.DoIt;
              I_Guide.Free;
           end;
        except
        end;
    end;
end;


function  TGuide_50_Selector.Getname: string;
begin
   result := ' Vbr Listu prvodce 1:50000';
end;



                   { TGuide_25_Selector }

procedure TGuide_25_Selector.On_tm_MouseUp(var aMessage: TOrbisMouseEvent; var Handled: boolean);
var
   Guide: TGuide;
   Guide_50: TGuidePage_50;
   Guide_10: TGuidePage_10;
   Coord: TDoubleCoord;
   H, V: longInt;
   I_Guide: TGuideInterpret;
begin
    Handled := true;
    if aMessage.Button = mbLeft then
    begin
        try
           if Input = nil then exit;
           if Input is TGuide then Guide := TGuide(Input)
                              else Guide := TGuide(TEntity(Input).FindElementClass(TGuide));
           if Guide = nil then exit;
           Coord := Device.Projection.GetModelPoint(aMessage.x, aMessage.y);

           Guide_50 := TGuidePage_50(Guide.SMO_50[Coord.x, Coord.y]);
           if Guide_50 = nil then exit;
           Coord.x := Guide_50.MaxX - Coord.x;
           Coord.Y := Guide_50.MaxY - Coord.y;
           H := round(Coord.x) div SMO_5_H;
           V := round(Coord.y) div SMO_5_V;
           Guide_10 := TGuidePage_10(Guide_50.Add_SMO_10_ByCR(H, V));
           if assigned(Guide_10) then
           begin
              I_Guide := TGuideInterpret.Create;
              I_Guide.Show_10 := true;
              I_Guide.Show_Text := true;
              I_Guide.Fill_Page := true;
              I_Guide.Input := Guide_10;
              I_Guide.Reset(Device);
              I_Guide.DoIt;
              I_Guide.Free;
           end;
        except
        end;
    end;
end;


function  TGuide_25_Selector.Getname: string;
begin
   result := ' Vbr Listu prvodce 1:25000';
end;




{ TGuide_10_Selector }

procedure TGuide_10_Selector.On_tm_MouseUp(var aMessage: TOrbisMouseEvent; var Handled: boolean);
var
   Guide: TGuide;
   Guide_50: TGuidePage_50;
   Guide_10: TGuidePage_10;
   Coord: TDoubleCoord;
   H, V: longInt;
   I_Guide: TGuideInterpret;
begin
    Handled := true;
    if aMessage.Button = mbLeft then
    begin
        try
           if Input = nil then exit;
           if Input is TGuide then Guide := TGuide(Input)
                              else Guide := TGuide(TEntity(Input).FindElementClass(TGuide));
           if Guide = nil then exit;
           Coord := Device.Projection.GetModelPoint(aMessage.x, aMessage.y);

           Guide_50 := TGuidePage_50(Guide.SMO_50[Coord.x, Coord.y]);
           if Guide_50 = nil then exit;
           Coord.x := Guide_50.MaxX - Coord.x;
           Coord.Y := Guide_50.MaxY - Coord.y;
           H := round(Coord.x) div SMO_5_H;
           V := round(Coord.y) div SMO_5_V;
           Guide_10 := TGuidePage_10(Guide_50.Add_SMO_10_ByCR(H, V));
           if assigned(Guide_10) then
           begin
              I_Guide := TGuideInterpret.Create;
              I_Guide.Show_10 := true;
              I_Guide.Show_Text := true;
              I_Guide.Fill_Page := true;
              I_Guide.Input := Guide_10;
              I_Guide.Reset(Device);
              I_Guide.DoIt;
              I_Guide.Free;
           end;
        except
        end;
    end;
end;


function  TGuide_10_Selector.Getname: string;
begin
   result := ' Vbr Listu prvodce 1:10000';
end;


{ TGuide_5_Selector }


procedure TGuide_5_Selector.On_tm_MouseUp(var aMessage: TOrbisMouseEvent; var Handled: boolean);
var
   Guide: TGuide;
   Guide_50: TGuidePage_50;
   Guide_5: TGuidePage_5;
   Coord: TDoubleCoord;
   H, V: longInt;
   I_Guide: TGuideInterpret;
begin
    Handled := true;
    if aMessage.Button = mbLeft then
    begin
        try
           if Input = nil then exit;
           if Input is TGuide then Guide := TGuide(Input)
                              else Guide := TGuide(TEntity(Input).FindElementClass(TGuide));
           if Guide = nil then exit;
           Coord := Device.Projection.GetModelPoint(aMessage.x, aMessage.y);
           Guide_50 := TGuidePage_50(Guide.SMO_50[Coord.x, Coord.y]);
           if Guide_50 = nil then exit;
           Coord.x := Guide_50.MaxX - Coord.x;
           Coord.Y := Guide_50.MaxY - Coord.y;
           H := round(Coord.x) div SMO_5_H;
           V := round(Coord.y) div SMO_5_V;
           Guide_5 := TGuidePage_5(Guide_50.Add_SMO_5_ByCR(H, V));
           Guide_5.Selected := not Guide_5.Selected;
           if assigned(Guide_5) then
           begin
              I_Guide := TGuideInterpret.Create;
              I_Guide.Show_5 := true;
              I_Guide.Show_Text := true;
              I_Guide.Fill_Page := true;
              I_Guide.Input := Guide_5;
              I_Guide.Reset(Device);
              I_Guide.DoIt;
              I_Guide.Free;
           end;
        except
        end;
    end;
end;

function  TGuide_5_Selector.Getname: string;
begin
   result := ' Vbr Listu prvodce 1: 5000';
end;

*)

{ TGuideSelector }


procedure TGuideSelector.Show(aMap: TMapSpace);
var
   I_Guide: TGuideInterpret;
begin
   if assigned(aMap) then
   begin
      I_Guide := TGuideInterpret.Create;
      I_Guide.Show_2 := Select2;
      I_Guide.Show_5 := Select5;
      I_Guide.Show_10 := Select10;
      I_Guide.Show_25 := Select25;
      I_Guide.Show_50 := true;
      I_Guide.Show_U := SelectU;
      I_Guide.Show_ZM := SelectZM;
      I_Guide.Show_Text := true;
      I_Guide.Fill_Page := true;
      I_Guide.Input := aMap;
      I_Guide.Reset(Device);
      I_Guide.DoIt;
      I_Guide.Free;
      Device.Close;
   end;
end;

procedure TGuideSelector.On_tm_MouseUp(var aMessage: TOrbisMouseEvent; var Handled: boolean);
var
   ExtraSpace: TUserMapSpace;
   Guide_50: TGuidePage_50;
   Guide_25: TGuidePage_25;
   Guide_10: TGuidePage_10;
   Guide_5: TGuidePage_5;
   Guide_2: TGuidePage_2;
   MS: TMapSpace;
   S: string;
begin
   Handled := true;
   if not (aMessage.Button = mbLeft) then exit;
   try
      if Input = nil then exit;
      if Input is TGuide then Guide := TGuide(Input)
                         else Guide := TGuide(TEntity(Input).FindElementClass(TGuide));
      if Guide = nil then exit;
      FCoord := Device.Projection.GetModelPoint(aMessage.x, aMessage.y);

      if SelectZM then
      begin
         if MakeDetail then exit;
         S := Guide.ZM.GetNameByCoords(FCoord.x, FCoord.y);
         if S = Guide.ZMSpace.Name then
         begin
            Guide.ZMSpace.Selected := not Guide.ZMSpace.Selected;
         end
         else
         begin
            if Guide.ZMSpace.Selected then
            begin
               Guide.ZMSpace.Selected := false;
               Show(Guide.ZMSpace);
            end;
            case Guide.ZM.Scale of
               200000: Guide.ZMSpace.Rect := CreateRectangleFromCorns(Guide.ZM.FCorns200);
               100000: Guide.ZMSpace.Rect := CreateRectangleFromCorns(Guide.ZM.FCorns100);
               50000:  Guide.ZMSpace.Rect := CreateRectangleFromCorns(Guide.ZM.FCorns50);
               25000:  Guide.ZMSpace.Rect := CreateRectangleFromCorns(Guide.ZM.FCorns25);
               else    Guide.ZMSpace.Rect := CreateRectangleFromCorns(Guide.ZM.FCorns10);
            end;
            Guide.ZMSpace.Selected := true;
            Guide.ZMSpace.Name := Guide.ZM.MapName;
            Guide.ZMSpace.ZM := Guide.ZM; // Assign only
         end;
         Show(Guide.ZMSpace);
         PostMsg(tm_MapSpaceTouched, World.MainTool, nil, DontKill);
         exit;
      end;
      if SelectU then
      begin
         if MakeDetail then exit;
         ExtraSpace:= Guide.UserMapSpace[FCoord.x, FCoord.y];
         if ExtraSpace = nil then exit;
         ExtraSpace.Selected:= not ExtraSpace.Selected;
         Show(ExtraSpace);
         PostMsg(tm_MapSpaceTouched, World.MainTool, nil, DontKill);
         exit
      end;

      if MakeDetail then
      begin
         if Select2  then MS := Get5 else
         if Select5  then MS := Get10 else
         if Select10 then MS := Get50 else
         if Select25 then MS := Get50 else exit;
         if MS = nil then exit;
         MS.MakeDetail;
         Show(MS);
      end
      else
      begin
         if Select2  then MS := Get2 else
         if Select5  then MS := Get5 else
         if Select10 then MS := Get10 else
         if Select25 then MS := Get25 else
         if Select50 then MS := Get50 else exit;
         if MS = nil then exit;
         if not NewSpace then MS.Selected := not MS.Selected;
         Show(MS);
         PostMsg(tm_MapSpaceTouched, World.MainTool, nil, DontKill);
      end;
   except
   end;
end;


(*
procedure TGuideSelector.On_tm_MouseUp(var aMessage: TOrbisMouseEvent; var Handled: boolean);
var
   Guide: TGuide;
   ExtraSpace: TUserMapSpace;
   Guide_50: TGuidePage_50;
   Guide_25: TGuidePage_25;
   Guide_10: TGuidePage_10;
   Guide_5: TGuidePage_5;
   Guide_2: TGuidePage_2;
   Coord: TDoubleCoord;
   H, V: longInt;
begin
  Handled := true;
  if not (aMessage.Button = mbLeft) then exit;
  try
    if Input = nil then exit;
    if Input is TGuide then Guide := TGuide(Input)
                       else Guide := TGuide(TEntity(Input).FindElementClass(TGuide));
    if Guide = nil then exit;
    Coord := Device.Projection.GetModelPoint(aMessage.x, aMessage.y);

    if SelectU then
    begin
      ExtraSpace:= Guide.UserMapSpace[Coord.x, Coord.y];
      if ExtraSpace = nil then exit;
      ExtraSpace.Selected:= not ExtraSpace.Selected;
      Show(ExtraSpace);
      PostMsg(tm_MapSpaceTouched, World.MainTool, nil, DontKill);
      exit
    end;

    if not (Select50 or Select25 or Select2 or Select5 or Select10) then exit;

    Guide_50 := TGuidePage_50(Guide.SMO_50[Coord.x, Coord.y]);
    if Guide_50 = nil then exit;

    if Select50 and not (Select25 or Select10 or Select5 or Select2) then
    begin
      Guide_50.Selected:= not Guide_50.Selected;
      Show(Guide_50);
      PostMsg(tm_MapSpaceTouched, World.MainTool, nil, DontKill);
      exit;
    end;

    if (Guide_50.NoSpaces) and not Guide_50.Selected then
    { kdy vybrm jen 50, tak nemusm zahuovat }
    // !!!!!!!!!!!!!!!!
    begin
      if not InfoSelect then
      begin
         Guide_50.MakeDetail;
         Show(Guide_50);
         exit;
      end;
    end;
    Coord.x := Guide_50.MaxX - Coord.x;
    Coord.Y := Guide_50.MaxY - Coord.y;
    H := round(Coord.x) div SMO_5_H;
    V := round(Coord.y) div SMO_5_V;

    //!!!!!!!!!!!!!!!!!!!!!!!
    {
    Guide_25:= TGuidePage_25(Guide_50.Get_SMO_25_ByCR(H, V));
    if Guide_25 = nil then exit;
    }
    if Select25 and not (Select2 or Select5 or Select10) then
    begin
      Guide_25:= TGuidePage_25(Guide_50.Get_SMO_25_ByCR(H, V));
      if Guide_25 = nil then
      begin
         Guide_25 := TGuidePage_25(Guide_50.Add_SMO_25_ByCR(H, V));
         Guide_25.Selected := true;
      end;
      Guide_25.Selected := not Guide_25.Selected;
      Show(Guide_25);
      PostMsg(tm_MapSpaceTouched, World.MainTool, nil, DontKill);
      exit;
    end;


     {
     if InfoSelect then
     }
     begin
        Guide_10 := TGuidePage_10(Guide_50.Get_SMO_10_ByCR(H, V));
        if Guide_10 = nil then
        begin
           Guide_10 := TGuidePage_10(Guide_50.Add_SMO_10_ByCR(H, V));
           if Select10 and not (Select5 or Select2) then
              Guide_10.Selected := true;
        end;

        if Select10 then
        begin
           if not Select5 then
           begin
              Guide_10.Selected := not Guide_10.Selected;
              Show(Guide_10);
              PostMsg(tm_MapSpaceTouched, World.MainTool, nil, DontKill);
              exit;
           end;
        end;
        if Guide_10 = nil then Guide_10 := TGuidePage_10(Guide_50.Add_SMO_10_ByCR(H, V));
     end;
     {Guide_10.Selected := true;}
     if Guide_10.NoSpaces then
     begin
        if not InfoSelect then
        begin
           Guide_10.MakeDetail;
           Show(Guide_10);
           exit;
        end;
     end;
     Guide_5 := TGuidePage_5(Guide_10.Get_SMO_5_ByCR(H, V));
     if Guide_5 = nil then Guide_5 := TGuidePage_5(Guide_10.Add_SMO_5_ByCR(H, V))
                      else Guide_5.Selected := not Guide_5.Selected;
     Show(Guide_5);
     PostMsg(tm_MapSpaceTouched, World.MainTool, nil, DontKill);
  except
  end;
end;
*)

function  TGuideSelector.Getname: string;
begin
   result := ' Vbr list prvodce ';
end;

function  TGuideSelector.GetCursor: TCursor;
begin
   result := cr_Ruka;
end;



function TGuideSelector.Get10: TGuidePage_10;
var
   Guide_50: TGuidePage_50;
begin
   result := nil;
   Guide_50 := Get50;
   if Guide_50 = nil then exit;
   result := TGuidePage_10(Guide_50.Get_SMO_10_ByCR(FH, FV));
   if result = nil then
   begin
      result := TGuidePage_10(Guide_50.Add_SMO_10_ByCR(FH, FV));
      NewSpace := true;
   end;
end;

function TGuideSelector.Get2: TGuidePage_2;
var
   Guide_5: TGuidePage_5;
begin
   result := nil;
   Guide_5 := Get5;
   if Guide_5 = nil then exit;
   result := TGuidePage_2(Guide_5.Get_SMO_2_ByCR(FH, FV));
   if result = nil then
   begin
      result := TGuidePage_2(Guide_5.Add_SMO_2_ByCR(FH, FV));
      NewSpace := true;
   end;
end;

function TGuideSelector.Get25: TGuidePage_25;
var
   Guide_50: TGuidePage_50;
begin
   result := nil;
   Guide_50 := Get50;
   if Guide_50 = nil then exit;
   result := TGuidePage_25(Guide_50.Get_SMO_25_ByCR(FH, FV));
   if result = nil then
   begin
      result := TGuidePage_25(Guide_50.Add_SMO_25_ByCR(FH, FV));
      NewSpace := true;
   end;
end;

function TGuideSelector.Get5: TGuidePage_5;
var
   Guide_10: TGuidePage_10;
   aCoord: TDoubleCoord;
begin
   result := nil;
   Guide_10 := Get10;
   if Guide_10 = nil then exit;
   result := TGuidePage_5(Guide_10.Get_SMO_5_ByCR(FH, FV));
   if result = nil then
   begin
      result := TGuidePage_5(Guide_10.Add_SMO_5_ByCR(FH, FV));
      NewSpace := true;
   end;
   aCoord.x := result.MaxX - FCoord.x;
   aCoord.Y := result.MaxY - FCoord.y;
   FH := round(aCoord.x) div SMO_2_H;
   FV := round(aCoord.y) div SMO_2_V;
end;

function TGuideSelector.Get50: TGuidePage_50;
var
   aCoord: TDoubleCoord;
begin
   NewSpace := false;
   result := TGuidePage_50(Guide.SMO_50[FCoord.x, FCoord.y]);
   if result = nil then exit;
   aCoord.x := result.MaxX - FCoord.x;
   aCoord.Y := result.MaxY - FCoord.y;
   FH := round(aCoord.x) div SMO_5_H;
   FV := round(aCoord.y) div SMO_5_V;
end;

procedure TGuideSelector.SetGuide(const Value: TGuide);
begin
  FGuide := Value;
end;

procedure TGuideSelector.SetMakeDetail(const Value: boolean);
begin
  FMakeDetail := Value;
end;

procedure TGuideSelector.SetNewSpace(const Value: boolean);
begin
  FNewSpace := Value;
end;

end.
