unit I_TTText;
{****************************************************************************}
{                                                                            }
{          ORBIS ... Interpret True Type Textu                               }
{                    (c) 1996                                                }
{                                                                            }
{****************************************************************************}

interface
uses
   Wintypes,
   Elements,
   e_View,
   g_Elems,
   i_Basic;

type
  TTextInterpret = class(TInterpret)
  protected
    function  QGoInside(Element: TElement): boolean; override;
    function  QProcessBefore(Element: TElement): boolean; override;
    procedure Process(Element: TElement); override;
    function  IsItsClass(AObject: TObject): boolean; override;
  end;



implementation
uses
   Graphics,
   M_Orbis,
   //i_TopoL,
   e_Device,
   Tools;

function  TTextInterpret.QGoInside(Element: TElement): boolean;
begin
  Result:= false
{  Result:= (Element is TEntity) and not ((Element is TView)or(Element is TText));}
end;

function  TTextInterpret.QProcessBefore(Element: TElement): boolean;
begin
  Result:= (Element is TText);
end;


procedure TTextInterpret.Process(Element: TElement);
var
  IX, IY: double;
  I: longInt;
  //ILS: TInterpretBloku;
  oScale: double;
  oCenterPoint: TDoubleCoord;
  R: TDoubleRect;
  iShift: TPoint;
  DShift: TDoubleCoord;
  TTT: TText;
  aSize: longInt;
begin
  if (Element is TText) then
  begin

    TTT:= TText(Element);
    if Device is TCanvasDevice then
    begin
       if TTT.Height <> 0 then
       begin
          aSize := -Device.Projection.GetPageLengthVert1(TTT.Height);
          if Abs(aSize)< 2 then exit;
          Device.Font.Height:= aSize;
       end;
       Device.Font.Name:= TTT.FontName;
       Device.Font.Color:= TTT.Color;
       Device.Font.Style:= TTT.FontStyle;
       Device.Font.CharSet:= TTT.CharSet;
       Device.SetTextOrientation(TTT.Orientation);
    end;
    Device.TextOut(TTT.MinX, TTT.MaxY, TTT.Text)

  end;
end;



function TTextInterpret.IsItsClass(AObject: TObject): boolean;
begin
   result := AObject is TText;
end;

END.
