unit T_select;
{
*********************************************************************
*                                                                   *
*  ORBIS ... Vbr element na zklad seznamu podmnek             *
*                                                                   *
*                       Topol Pro 1996                             *
*********************************************************************
}

 {nutne virtualni set params+zadavani elementu ke zpracovani}
interface


uses Elements,
  classes,
  dialogs,
  SysUtils,

  creacond,
  Tools,
  TypInfo,
  t_oper,
  t_recurs;

type



 TReset = class(TRecursor)
protected
   function  QGoInside(Element: TElement): boolean; override;
   function  QProcessBefore(Element: TElement): boolean; override;
   function  QProcessAfter(Element: TElement): boolean; override;
   procedure Process(Element: TElement); override;
end;


 TSelector = class(TRecursor)
private
   FCondition: tCondition;
   FCondCreator:TCondCreator;
   FCond:string;
   function  GetSelectedElements: TOwnerEntity;
   procedure SetCondition(aValue: TCondition);
   function GetCondCreator:TCondCreator;
   procedure  SetCondCreator(aValue:TCondCreator);
protected
   function  QProcessBefore(Element: TElement): boolean; override;
   function  QProcessAfter(Element: TElement): boolean; override;
   procedure PrepareOutput; override;
public
   property CondTree: TCondition read FCondition write SetCondition;
   property SelectedElements: TOwnerEntity read GetSelectedElements;
   property CondCreator:TCondCreator read GetCondCreator write SetCondCreator;
published
  property Condition: string  read FCond write FCond;
end;
   {pred volanim doit treba pouzit setinput,setoutput }

TAllSelector=class(TSelector)
 protected
   function  QGoInside(Element: TElement): boolean; override;
   procedure Process(Element: TElement); override;
 end;

TFirstSelector=class(TSelector)
 private
   Ffound:boolean;
 protected
   procedure GoInside(Element: TElement);override;
   function  QGoInside(Element: TElement): boolean; override;
   procedure Process(Element: TElement); override;
   procedure PrepareOutput; override;
   property Found:boolean read FFound write FFound;
 end;

 TAbsFirstSelector=class(TSelector)
 private
   Ffound:boolean;
 protected
   function  QGoInside(Element: TElement): boolean; override;
   procedure Process(Element: TElement); override;
   procedure PrepareOutput; override;
   property Found:boolean read FFound write FFound;
 end;

 TLevelSelector=class(TSelector)
 private
   FMaxLevel:integer;
    FOnlyLevel: boolean;
    procedure SetOnlyLevel(const Value: boolean);
 protected
   function  QProcessBefore(Element: TElement): boolean; override;
   function  QGoInside(Element: TElement): boolean; override;
   procedure Process(Element: TElement); override;
 published
   property Maxlevel:integer read FMaxlevel write FMaxLevel;
   property OnlyLevel: boolean read FOnlyLevel write SetOnlyLevel;
 end;


implementation
uses

   e_Class,
//   g_Elems,
   syntax;



const processed=11;
const doquit=12;


{Selector}

procedure TSelector.SetCondition(aValue: TCondition);
var st:string;
begin
  if assigned(FCondition) then
   begin
      FreeParameter(FCondition);
      FCondition := nil;
   end;
   AddParameter(aValue);
   Fcondition:=aValue;
end;



function  TSelector.GetSelectedElements: TOwnerEntity;
begin
   if Output = nil then
   begin
      Output := TOwnerEntity.Create;
      Output.Name := 'Selected elements';
   end;
   result := TOwnerEntity(Output);
end;

function  TSelector.QProcessBefore(Element: TElement): boolean;
begin
   result := true;
end;

function  TSelector.QProcessAfter(Element: TElement): boolean;
begin
   result := false;
end;

procedure TSelector.SetCondCreator(aValue: TCondCreator);
var st:string;
begin
  if assigned(FCondCreator) then
   begin
      FreeTool(FCondition);
      FCondCreator := nil;
   end;
   AddTool(aValue);
   FCondCreator:=aValue;
end;

function TSelector.GetCondCreator: TCondCreator;
begin
    if not assigned(FCondCreator) then
    begin
       FCondCreator := TCondCreator.Create;
       FCondCreator.Name := 'Condition Creator';
       AddTool(FCondCreator);
    end;
    result := FCondCreator;
end;


 procedure TSelector.PrepareOutPut;
  begin
   if Output = nil then
   begin
      Output := TOwnerEntity.Create;
      Output.Name := 'Selected elements';
   end;
   try
      if StrEmpty(Condition,1) then raise SyntaxExcept.CreatePos('Ocekavam indentifikator',1);
      CondCreator.Command:=Condition;
      CondCreator.DoIt;
      CondTree:=TCondition(CondCreator.Output);
   finally
   end;
   {showmessage('reseting');
   Resetor:=TReset.create;
   Resetor.Input:=Input;
   Resetor.DoIt;
   showmessage('delete reset');
   Resetor.free;
   showmessage('reseted');}
 end;

{AllSelector}

function  TAllSelector.QGoInside(Element: TElement): boolean;
begin
    result:= ((Element is TEntity));
end;

procedure TAllSelector.Process(Element: TElement);
begin
 {if Element.ID=processed then
    begin
     FFound:=false;
     Element.Id:=doquit;
    end
 else
  begin}
   CondTree.ParamItem[0]:=Element;
   {Element.ID:=processed;}
   if CondTree.IsTrue then if (Element is TOwnerElement) or(Element is TOwnerEntity)
     then SelectedElements.AddElement(Element);
 { end;}
end;

{FirstSelect}

procedure TFirstSelector.GoInside(Element: TElement);
begin
 inherited GoInside(Element);
 Found:=false;
end;

function  TFirstSelector.QGoInside(Element: TElement): boolean;
begin
    result:= ((Element is TEntity) and  (not Ffound));
end;

procedure TFirstSelector.Process(Element: TElement);
begin
 {if Element.ID=processed then
    begin
     FFound:=false;
     Element.Id:=doquit;
    end
 else
  begin}
   CondTree.ParamItem[0]:=Element;
   {Element.ID:=processed;}
   if CondTree.IsTrue then
      begin
         if Element.OwnersCount>0 then
         begin
          SelectedElements.AddElement(Element);
          Found:=true;
         end
        else Found:=false;
      end else Found:=false;
  end;

 procedure TFirstSelector.PrepareOutPut;
 begin
  inherited PrepareOutput;
  Found:=false;
 end;

{AbsFirstSelector}

function  TAbsFirstSelector.QGoInside(Element: TElement): boolean;
begin
    result:= ((Element is TEntity) and  (not Found));
end;

procedure TAbsFirstSelector.Process(Element: TElement);
begin
 {if Element.ID=processed then
    begin
     FFound:=false;
     Element.Id:=doquit;
    end
 else
  begin}
   CondTree.ParamItem[0]:=Element;
   {Element.ID:=processed;}
   if not Found then if CondTree.IsTrue then if Element.OwnersCount>0 then
         begin
          SelectedElements.AddElement(Element);
          Found:=true;
         end;
  end;

 procedure TAbsFirstSelector.PrepareOutPut;
 begin
  inherited PrepareOutput;
  Found:=false;
 end;

{TLevelSelector}
function  TLevelSelector.QGoInside(Element: TElement): boolean;
begin
    result:= ((Element is TEntity) and (Level<MaxLevel));
end;

procedure TLevelSelector.Process(Element: TElement);
begin
 {if Element.ID=processed then
    begin
     FFound:=false;
     Element.Id:=doquit;
    end
 else
  begin}
   CondTree.ParamItem[0]:=Element;
   {Element.ID:=processed;}
   if CondTree.IsTrue then if Element.OwnersCount>0 then
         begin
          SelectedElements.AddElement(Element);
         end;
 { end;}
end;

procedure TLevelSelector.SetOnlyLevel(const Value: boolean);
begin
  FOnlyLevel := Value;
end;

function TLevelSelector.QProcessBefore(Element: TElement): boolean;
begin
   if OnlyLevel then
      result := Level = MaxLevel
   else
      result := true;   
end;

{TReset}
function  TReset.QGoInside(Element: TElement): boolean;
begin
 if Element.ID<>-1 then result:=true else result:=false;
end;

function  TReset.QProcessBefore(Element: TElement): boolean;
begin
   result := true;
end;

function  TReset.QProcessAfter(Element: TElement): boolean;
begin
   result := false;
end;

procedure TReset.Process(Element: TElement);
 begin
  element.ResetID;
 end;
{************************************************************************}


BEGIN
   RegisterOrbisClass(TAllSelector);
   RegisterOrbisClass(TFirstSelector);
   RegisterOrbisClass(TLevelSelector);
   RegisterOrbisClass(TAbsFirstSelector);
END.