{*******************************************************}
{                                                       }
{       Runtime Licensing Demo Program                  }
{       Use runtime license procedure                   }
{                                                       }
{       Copyright (c) 1998 Help Service Mapping         }
{                                                       }
{*******************************************************}

unit UseLic;

interface

uses Windows, ActiveX;

function CreateInprocObjLic(ProgID: WideString;  // Component ProgID string
                            LicKey: WideString;  // Runtime license key
                            riid: TIID;          // Requested interface
                            var pIntf: IUnknown) // Result
                            : HRESULT;

implementation

uses ComObj;

function CreateInprocObjLic(ProgID: WideString;  // Component ProgID string
                            LicKey: WideString;  // Runtime license key
                            riid: TIID;          // Requested interface
                            var pIntf: IUnknown) // Result
                            : HRESULT;
var
  ClassID: TGUID;
  pClassFactory: IClassFactory2;

begin
  try
    ClassID := ProgIDToClassID(ProgID);

    Result := CoGetClassObject(ClassID, CLSCTX_INPROC_SERVER, nil,
                               IClassFactory2, pClassFactory);

    if not Failed(Result)
    then try
      Result := pClassFactory.CreateInstanceLic(NIL, NIL, riid, LicKey, pIntf);
    finally
      pClassFactory := nil;
    end;
  except
    Result := E_FAIL;
  end;
end;

end.
