unit I_ChkDB;

interface
uses
  Elements,
  I_Chk;

type

TTestDBInterpret = class(TTestInterpret)
private
    FTableName: string;
    procedure SetTableName(const Value: string);
protected
   procedure Process(Element: TElement); override;
published
   property TableName: string read FTableName write SetTableName;
end;

implementation
uses
   Forms,
   SysUtils,
   e_Class,
   e_DBTable;


{ TTestDBInterpret }

procedure TTestDBInterpret.Process(Element: TElement);
var
   S: string;
begin
   if not (Element is TDBTableElement) then exit;
   S := ExtractFileName(TDBTableElement(Element).FileName);
   if CompareText(S,TableName)<> 0 then exit;
   TestCount := TestCount + 1;
   ProgressText := TDBTableElement(Element).FileName;
   TDBTableElement(Element).Tab.Active := true;
   inherited;
   //Device.WriteLnText('CLOSED: ' + Element.Name);
   Application.ProcessMessages;
   TDBTableElement(Element).Tab.Active := false;
   Application.ProcessMessages;
end;

procedure TTestDBInterpret.SetTableName(const Value: string);
begin
  FTableName := Value;
end;

INITIALIZATION
   RegisterOrbisClass(TTestDBInterpret);
END.

