unit I_imodel;

interface


uses
// KERNEL
   Elements,
// INTERPRET
   e_IModel,
   i_Basic;

type

TInterpretIModel = class(TInterpret)
private
   FHeader: string;
   FLeftSpace: string;
   procedure WriteProperties(aModel: TInterpretModel);
public
   procedure DoIt; override;
   property  LeftSpace: string read FLeftSpace write FLeftSpace;
published
   property  Header: string read FHeader write FHeader;
end;

implementation

uses
   e_ElementModel;
{ TInterpretIModel }

procedure TInterpretIModel.WriteProperties(aModel: TInterpretModel);
var
   i: longInt;
   PM: TPropertyModel;
begin
   if aModel.NoPropertyModels then exit;
   LeftSpace := LeftSpace + '   ';
   for i := 0 to aModel.PropertyModels.LastIndex do
   begin
      PM := TPropertyModel(aModel.PropertyModels.Elements[i]);
      Device.WritelnText(LeftSpace + PM.Alias + ' = ' + PM.Value);
   end;
end;




procedure TInterpretIModel.DoIt;
var
   IME: TInterpretModelEntity;
   IM, SM: TInterpretModel;
   IT: TInterpret;
   EC: TElementClass;
   i, j: longInt;
begin
   //Device.WritelnText(' ');
   if Input = nil then exit;
   if not (Input is TInterpretModelEntity) then exit;
   IME := TInterpretModelEntity(Input);
   if Header <> '' then Device.WritelnText(Header);
   //Device.WritelnText('******************************************');
   Device.WritelnText('Interpretan model:');
   Device.WritelnText('******************************************');
   if not (IME.NoElements) then
   for i := 0 to IME.LastIndex do
   begin
      LeftSpace := '    ';
      IM := TInterpretModel(IME.Elements[i]);
      Device.WritelnText(LeftSpace + '-' + IM.Name);
      WriteProperties(IM);
      if IM.NoSubModels then Continue;
      for j := 0 to IM.SubModels.LastIndex do
      begin
         LeftSpace := '         ';
         SM := TInterpretModel(IM.SubModels.Elements[j]);
         Device.WritelnText(LeftSpace  + '-' + SM.Name);
         WriteProperties(SM);
      end;
   end;
   Device.WritelnText('******************************************');
end;


END.
