unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  TForm1 = class(TForm)
    OpenDialog: TOpenDialog;
    OpenSHPFile: TBitBtn;
    ReadHeader: TBitBtn;
    CloseFile: TBitBtn;
    Memo: TMemo;
    procedure OpenSHPFileClick(Sender: TObject);
    procedure ReadHeaderClick(Sender: TObject);
    procedure CloseFileClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  ShpFileName: string;
  Reader: TReader;
  Stream : TFileStream;
  FileLength: longInt;

implementation

{$R *.DFM}

uses
  C_shp, U_BigEnd;

procedure CloseShpFile;
begin
  if Stream <> nil then
  begin
    Stream.Free;
    Stream:= nil
  end;

  if Reader <> nil then
  begin
    Reader.Free;
    Reader:= nil
  end;
end;

procedure TForm1.OpenSHPFileClick(Sender: TObject);
begin
  CloseShpFile;
  if OpenDialog.Execute then
  begin
    ShpFileName:= OpenDialog.FileName;
    Stream := TFileStream.Create(ShpFileName, fmOpenRead);
    Reader := TReader.Create(Stream, 64000);
  end
end;


procedure ProcessPoint(RecPtr: pointer; RecLength: longInt);
begin

end;

procedure ProcessMultiPoint(RecPtr: pointer; RecLength: longInt);
begin

end;

procedure ProcessArc(RecPtr: pointer; RecLength: longInt);
begin

end;

procedure ProcessPolyGon(RecLength: longInt);
type
  TParts = array[0..1023]of longInt;
  TPoints = array[0..32000]of TShpPoint;
var
  Poly: TShpPolygonRec;
  Parts, Points: pointer;
  I: longInt;
begin
  Poly:= TShpPolygonRec.Create;
  Reader.Read(Poly.FXmin, 40);

  getMem(pointer(Parts), Poly.NumParts * 4);
  Reader.Read(Parts^, Poly.NumParts * 4);

  getMem(Points, Poly.NumPoints * 16);
  Reader.Read(Points^, Poly.NumPoints * 16);

  ShowMessage(FloatToStr(Poly.Xmin) + ' ' +  FloatToStr(Poly.Ymin) + ' ' +
              FloatToStr(Poly.Xmax) + ' ' +  FloatToStr(Poly.Ymax) + #13 +
              IntToStr(Poly.NumParts) + ' ' + IntToStr(Poly.NumPoints) + #13 +
              IntToStr(TParts(Parts^)[0]) + ' ' + IntToStr(TParts(Parts^)[1]) + ' ' +
              IntToStr(TParts(Parts^)[2]));
  Form1.Memo.Clear;
  for I:= 0 to Poly.NumPoints-1 do
  begin
    Form1.Memo.Lines.Add(FloatToStr(TPoints(Points^)[I].X) + ' ' + FloatToStr(TPoints(Points^)[I].Y));
  end;

  freeMem(Points, Poly.NumPoints * 16);
  freeMem(Parts, Poly.NumParts*4);
  Poly.Free;
end;


procedure TForm1.ReadHeaderClick(Sender: TObject);
var
  Header: TShpFileHeader;
  FileCode: longInt;
  RecHeader: TShpFileRecHeader;
  RecPtr: pointer;
  BeginPos: longInt;
begin
  Header:= TShpFileHeader.Create;
  Reader.Read(Header.FFileCode, 100);
  BeginPos:= Reader.Position - 100;
  ShowMessage(IntToStr(Reader.Position-BeginPos) + #13 +
              IntToStr(Header.FileLength) + ' ' +
              FloatToStr(Header.XMin) + ' ' + FloatToStr(Header.XMax) + #13 +
              FloatToStr(Header.YMin) + ' ' + FloatToStr(Header.YMax));
  FileLength:= Header.FileLength;
  Header.Free;

  RecHeader:= TShpFileRecHeader.Create;

  while (Reader.Position-BeginPos < FileLength) do
  begin
    Reader.Read(RecHeader.FRecNo, 12);
  {
    showMessage(IntToStr(Reader.Position-BeginPos) + #13 +
                IntToStr(RecHeader.RecNo) + ' ' + IntToStr(RecHeader.RecLength) + #13 +
                         IntToStr(RecHeader.ShapeType));
}
{
    GetMem(RecPtr, RecHeader.RecLength);
    Reader.Read(RecPtr^, RecHeader.RecLength);
}
    case RecHeader.ShapeType of
    sht_point     : ProcessPoint(RecPtr, RecHeader.RecLength);
    sht_multipoint: ProcessMultiPoint(RecPtr, RecHeader.RecLength);
    sht_arc       : ProcessArc(RecPtr, RecHeader.RecLength);
    sht_polygon   :
    begin
      ProcessPolygon(RecHeader.RecLength);
    end;
    end;
{
    FreeMem(RecPtr, RecHeader.RecLength);
}
  end;

  Reader.Position:= 0;
  RecHeader.Free
end;


procedure TForm1.CloseFileClick(Sender: TObject);
begin
  CloseShpFile
end;

end.
