unit U_BigEnd;
{ BigEndian procedures }

interface

type
  T4Byte = array[0..3]of byte;
  T8Byte = array[0..7]of byte;
  TBigEndian = longInt;

function GetLongIntFromBigEnd(aVal: TBigEndian): longInt;
function GetBigEndFromLongInt(aVal: longInt): TBigEndian;

function GetDoubleFromDoubleBigEnd(aVal: double): double;

implementation

function GetLongIntFromBigEnd(aVal: TBigEndian): longInt;
var
  I: byte;
begin
  for I:= 0 to 3 do
     T4Byte(result)[I]:= T4Byte(aVal)[3-I]
end;



function GetBigEndFromLongInt(aVal: longInt): TBigEndian;
var
  I: byte;
begin
  for I:= 0 to 3 do
     T4Byte(result)[I]:= T4Byte(aVal)[3-I]
end;



function GetDoubleFromDoubleBigEnd(aVal: double): double;
var
  I: byte;
  Revers: comp;

begin
  for I:= 0 to 7 do
     T8Byte(Revers)[I]:= T8Byte(aVal)[7-I];
  result:= Revers
end;


end.
