unit e_SHPFileElement;

interface
uses
  DBTables, DB,
// KERNEL
  Elements,
// GLIB
  G_Elems,
// SPACE
  e_DataSet,
  E_Reg,
  C_ShpDBF;



Type

TCodePage = (cpIBM, cpLatin2, cpKamenickych);

TSHPFileElement = class(TRegisteredGeometryElement)
private
   FRecNo:    longInt;
   FShapeType: longInt;
   FDone:      boolean;
   FBarva, FZnacka: smallInt;
   //function   GetObjectsOwner: TSpaceEntityString; virtual; abstract;
   function   GetDBFName: string; virtual;
{ TODO -oO.S. -cZmeny pro ADO : 11.11.99 }
   function   GetDBFTable: TDataSetElement; virtual;
protected
   function   GetSpaceID: longInt; override;
public
   function  HasDBFItem(aItem: string): boolean; override;
   function   GetDBFFieldAsString(aItem: string): string; override;
   procedure  SetDBFFieldAsString(aItem, aValue: string); override;
   function  SetDBFRecord: boolean; override;
   procedure SetPropertyStringByName(AName: string; aValue: string); override;
   //property   ObjectOwner: TSpaceEntityString read GetObjectsOwner;
published
   property ShapeType: longInt read FShapeType write FShapeType;
   property RecNo:    longInt read FRecNo   write FRecNo stored true;
   property OrigNo:   longInt read GetOrigNo stored false;
   property IsDone: boolean   read FDone     write FDone stored false default false;
   property Barva: smallInt read FBarva write FBarva;
   property Znacka: smallInt read FZnacka write FZnacka;

   property DBFName:  string read GetDBFName stored false;
   property DBFTable: TDataSetElement read GetDBFTable stored false;
end;


TSHPAreaElement = class(TSHPFileElement)
end;

TSHPLineElement = class(TSHPFileElement)
end;

TSHPPointElement = class(TSHPFileElement)
end;

TSHPExportElement = class(TSHPFileElement)
private
   FExportProperties: TElement;
   procedure SetExportProperties(const Value: TElement);
public
   function   GetPropertyStringByName(AName: string): string; override;
published
   property ExportProperties: TElement read FExportProperties write SetExportProperties;
end;

implementation
uses
  SysUtils,
  e_Class,
  U_Props;



                 { TTopolProps }




function TSHPFileElement.GetDBFName: string;
var
  aName: string;
  El: TRegisteredGeometryElement;
begin
  result:= '';
  El:= GetOrigElement;
  if not (TElement(El) is TRegisteredGeometryElement) then exit;
  aName:= GetBlockName;
  if aName = '' then exit;
  result:= ChangeFileExt(aName, '.DBF');
end;





function TSHPFileElement.HasDBFItem(aItem: string): boolean;
var
  aDBFName: string;
begin
  result:= false;
  aDBFName:= GetDBFName;

  if TShapeDBFTable(TObjectRegister(ObjectRegister).DBF).SetForName(aDBFName) then
     result:= TShapeDBFTable(TObjectRegister(ObjectRegister).DBF).FieldExists(aItem);
end;




function TSHPFileElement.SetDBFRecord: boolean;
var
  aDBFName: string;
begin
  aDBFName:= GetDBFName;
  result := TShapeDBFTable(ObjectRegister.DBF).SetForNameRecNo(aDBFName, RecNo);
end;



function TSHPFileElement.GetDBFFieldAsString(aItem: string): string;
begin
 result:= TShapeDBFTable(ObjectRegister.DBF).GetFieldAsString(aItem);
end;


procedure TSHPFileElement.SetDBFFieldAsString(aItem, aValue: string);
begin
  TShapeDBFTable(ObjectRegister.DBF).SetFieldAsString(aItem, aValue);
end;



procedure   TSHPFileElement.SetPropertyStringByName(AName: string; aValue: string);
var
  aDBFName: string;
begin
  if GetPropIndex(Self, aName) > -1 then
  begin
     inherited SetPropertyStringByName(aName, aValue);
     exit;
  end;
  try
    if ObjectRegister = nil then exit;
{$IFDEF Databaze}
    aDBFName:= GetDBFName;
    TShapeDBFTable(TObjectRegister(ObjectRegister).DBF).SetForNameRecNo(aDBFName, RecNo);
{$ENDIF}
  except
  end;
end;


function  TSHPFileElement.GetSpaceID: longInt;
begin
  result:= RecNo
end;





function  TSHPFileElement.GetDBFTable: TDataSetElement;
begin
  result:= nil;
  if not (TElement(ObjectRegister) is TObjectRegister) then exit;

  result:= TObjectRegister(ObjectRegister).DBF;
end;




{ TSHPExportElement }

function TSHPExportElement.GetPropertyStringByName(AName: string): string;
begin
   result:= inherited GetPropertyStringByName(aName);
   if result <> '' then exit;
   if ExportProperties = nil then exit;
   result:= ExportProperties.GetPropertyStringByName(AName)
end;

procedure TSHPExportElement.SetExportProperties(const Value: TElement);
begin
  FExportProperties := Value;
end;

INITIALIZATION
   RegisterOrbisClass(TSHPFileElement);
   RegisterOrbisClass(TSHPExportElement);
   RegisterOrbisClass(TSHPAreaElement);
   RegisterOrbisClass(TSHPLineElement);
END.

