unit E_node;


{
[Unit_Description]
Description=Elementy topologie .... uzly
Admin=Olda
TechTopic=Graphics Elements
Topic=Space analysis
Version=1.0

[Edit]
 8.8.1997 19:52=Registrace
}


           { objekty topologie }
{ TNodeBranch               vetev uzlu - element
  TNode                     vlastni uzel - OwnerEntity

     }

interface

uses
// KERNEL
  Elements,
// GLIB
  e_Geometry,
  G_Elems;
// SPACE
  //E_Space;

const
  MaxBranchCount = 10000;

type

TNode = class;

TNodeBranch = class(TElement)
private
  FLineBegin: boolean;
  FNotRegularArea: boolean;
  FRightArea: TAreaElement;
  FNode: TNode;
  FLine: TPolyLineElement;
  procedure SetNode(aNode: TNode);
  function  GetNode: TNode;
  function  GetAngle: double;

  function  GetX2: double;
  function  GetY2: double;
public
  function  GetLeftArea: TAreaElement;

  procedure GiveLineSecondNodeBranch
            (var Node: TNode; var Branch: TNodeBranch);
  function  GetNextNodeBranchRight(var NextNode: TNode): TNodeBranch;
  procedure GiveRightAreaPropertyAndSet
            (var AreaValue: double; var OKej: boolean; var BranchCount: longInt; SetRegularity: boolean);

  property Node: TNode read GetNode write SetNode;

published
  property Angle: double read GetAngle;
  property LineBegin: boolean read FLineBegin write FLineBegin;
  property  Line: TPolyLineElement read FLine write FLine;

{ plocha me nabvat vce stav:
  - dn - tato vtev jet nen zaplochovna = nil
  - zaplochovna regulrn plochou
  - zaplochovna neregulrn plochou, nap. vnj

}
  property X2: double read GetX2;
  property Y2: double read GetY2;
  property RightArea: TAreaElement read FRightArea write FRightArea;
  property LeftArea : TAreaElement read GetLeftArea; { vypotno z protivtve }
  property NotRegularArea: boolean read FNotRegularArea write FNotRegularArea;
end;


TNode = class(TRectEntity)
private
  FCoord: T2DCoordinate;

  function  GetX: double;
  function  GetY: double;
  function  GetLine(aLin: TPolyLineElement): TPolyLineElement;
  procedure AddBranchSorted(Branch: TNodeBranch);
  function  GetBranchCount: longInt;
    procedure SetX(const Value: double);
    procedure SetY(const Value: double);
public
  constructor Create; override;
  destructor  Destroy; override;
   function   IsHit(CoordEl: TCoordinate; Tolerance: double): boolean; override;
   function   IsHitByXY(aX, aY: double; Tolerance: double): boolean; override;
  function  GetBranchOfLineSimp(aLin: TPolyLineElement): TNodeBranch;
  function  GetBranchOfLine
            (aLin: TPolyLineElement; aBegin: boolean): TNodeBranch;
  function    GetNextBranchRight(aBranch: TNodeBranch): TNodeBranch;
  function    GetNextBranchLeft(aBranch: TNodeBranch): TNodeBranch;
  function    AddLine(aLin: TPolyLineElement; aBegin: boolean): TNodeBranch;
published
  property BranchCount: longInt read GetBranchCount stored false;
  property X: double read GetX write SetX;
  property Y: double read GetY write SetY;
end;


procedure GiveNodeBranchForLine(aLine: TPolyLineElement; aBegin: boolean;
                               var aNode: TNode; var aBranch: TNodeBranch);


implementation

uses
  Forms, SysUtils, Dialogs,
// KERNEL
  e_Class,
  M_Orbis,
  Worlds,
// GLIB
  MathLib;



procedure TNodeBranch.SetNode(aNode: TNode);
begin
  FNode:= aNode;
end;

function  TNodeBranch.GetNode: TNode;
begin
  result:= FNode
end;


function  TNodeBranch.GetLeftArea: TAreaElement;
{ nate hodnoty z protivtve }
var
  aNode: TNode;
  aBranch: TNodeBranch;
begin
  result:= nil;
  GiveLineSecondNodeBranch(aNode, aBranch);
  if (aBranch <> nil) then
     result:= aBranch.RightArea
end;




procedure TNodeBranch.GiveRightAreaPropertyAndSet
          (var AreaValue: double; var OKej: boolean; var BranchCount: longInt; SetRegularity: boolean);
{ dobr plocha je takov, kter m kladnou vmru a poet lini
  men ne 2000, preventivn vak, kdy je nastaveno SetRegularity, nastavuje
  vtve na nedobr }
var
  NextNode: TNode;
  NextBranch: TNodeBranch;
  NeregulerniPlochaVetve: boolean;
  //aLine: TPolyLineElement;
begin
  OKej:= true;
  BranchCount:= 1;
  NeregulerniPlochaVetve:= false;
  if SetRegularity then
     Self.FNotRegularArea:= true;
  if (FLine <> nil) and (FNode <> nil) then
  begin
    NextBranch:= GetNextNodeBranchRight(NextNode);
    if NextBranch <> nil then
    try
      //aLine:= NextBranch.FLine;
      AreaValue:= Self.FLine.GetSubAreaValue(Self.FLineBegin);

      while (NextBranch <> self) and (BranchCount < MaxBranchCount) and
             not NeregulerniPlochaVetve do
      begin
        if NextBranch.FNotRegularArea then
           NeregulerniPlochaVetve:= true
        else
          if SetRegularity then
             NextBranch.FNotRegularArea:= true;

        AreaValue:= AreaValue +
                    NextBranch.FLine.GetSubAreaValue(NextBranch.FLineBegin);

        NextBranch:= NextBranch.GetNextNodeBranchRight(NextNode);
        if NextBranch = nil then
        begin
          OKej:= false;
          exit;
        end;
        //aLine:= NextBranch.FLine;
        inc(BranchCount);
        Application.ProcessMessages;
      end
    except
      OKej:= false;
    end;
  end;
  if (BranchCount >= MaxBranchCount) or
     NeRegulerniPlochaVetve then
  begin
    OKej:= false;
  end;
end;






procedure  TNodeBranch.GiveLineSecondNodeBranch
                           (var Node: TNode; var Branch: TNodeBranch);
var
  I: longInt;
  PBranch: TNodeBranch;
begin
  try
  Node:= nil;
  Branch:= nil;
  if FLine <> nil then
  begin
    for I:= 0 to FLine.OwnersCount-1 do
    begin
      if FLine.Owners[I] is TNode then
      begin
        PBranch:= TNode(FLine.Owners[I]).GetBranchOfLine(FLine, not FLineBegin);
        if (PBranch <> nil) and (PBranch <> self) then
        begin
          Node:= TNode(FLine.Owners[I]);
          Branch:= PBranch;
          break
        end
      end
    end;
  end;
  except
    ShowMessage('TNodeBranch.GiveLineSecondNodeBranch: Chyba');
  end
end;



function TNodeBranch.GetAngle: double;
var
  X1, Y1, X2, Y2: double;
begin
  result:= 0;
  if FLine=nil then exit;
  FLine.GetOrientedCoord(0, FLineBegin, X1, Y1);
  FLine.GetOrientedCoord(1, FLineBegin, X2, Y2);

  result:= ATan2M(X2-X1, Y2-Y1)
end;


function  TNodeBranch.GetX2: double;
var
  X2, Y2: double;
begin
  result:= 0;
  if FLine=nil then exit;
  FLine.GetOrientedCoord(1, FLineBegin, X2, Y2);
  result:= X2
end;



function  TNodeBranch.GetY2: double;
var
  X2, Y2: double;
begin
  result:= 0;
  if FLine=nil then exit;
  FLine.GetOrientedCoord(1, FLineBegin, X2, Y2);
  result:= Y2
end;



function  TNodeBranch.GetNextNodeBranchRight(var NextNode: TNode): TNodeBranch;
var
  Branch: TNodeBranch;
begin
  result:= nil;
  GiveLineSecondNodeBranch(NextNode, Branch);
  if (NextNode <> nil) and (Branch <> nil) then
     result:= NextNode.GetNextBranchLeft(Branch);
  { z pohledu uzlu je to vlevo - proti smru hod.ruiek }
end;




constructor TNode.Create;
begin
  inherited Create;
end;


destructor  TNode.Destroy;
begin
  if FCoord <> nil then
     FCoord.Free;
  inherited Destroy
end;


function TNode.GetX: double;
begin
  result:= 0;
  if FCoord <> nil then
     result:= FCoord.X
end;


function TNode.GetY: double;
begin
  result:= 0;
  if FCoord <> nil then
     result:= FCoord.Y
end;


function TNode.GetNextBranchLeft(aBranch: TNodeBranch): TNodeBranch;
var
  I: longInt;
begin
  result:= nil;
  I:= IndexOf(aBranch);
  if I < 0 then exit;

  inc(I);
  if not (Elements[I] is TNodeBranch) then I:= 0;

  if Elements[I] is TNodeBranch then
     result:=  TNodeBranch(Elements[I])
end;



function TNode.GetNextBranchRight(aBranch: TNodeBranch): TNodeBranch;
{ brno z pohledu vtve, ili jinak dal vtev ve smru hod.ruiek }
var
  I: longInt;
begin
  result:= nil;
  I:= IndexOf(aBranch);
  if I < 0 then exit;

  dec(I);
  if I < 0 then I:= BranchCount-1;
  if not (Elements[I] is TNodeBranch) then I:= 0;

  if Elements[I] is TNodeBranch then
     result:=  TNodeBranch(Elements[I])
end;



function TNode.GetBranchOfLineSimp(aLin: TPolyLineElement): TNodeBranch;
var
  I: longInt;
  Nasel: boolean;
  Branch: TNodeBranch;
begin
  Branch := nil;
  result:= nil;
  I:= 0;
  Nasel:= false;
  while (I<Count) and not Nasel do
  begin
    if Elements[I] is TNodeBranch then
    begin
      Branch:= TNodeBranch(Elements[I]);
      Nasel:= (Branch.FLine = aLin)
    end;
    if not Nasel then inc(I)
  end;
  if Nasel then result:= Branch
end;



function TNode.GetBranchOfLine
         (aLin: TPolyLineElement; aBegin: boolean): TNodeBranch;
var
  I: longInt;
  Nasel: boolean;
  Branch: TNodeBranch;
begin
  Branch := nil;
  result:= nil;
  I:= 0;
  Nasel:= false;
  while (I<Count) and not Nasel do
  begin
    if Elements[I] is TNodeBranch then
    begin
      Branch:= TNodeBranch(Elements[I]);
      Nasel:= (Branch.FLine = aLin) and (Branch.FLineBegin = aBegin)
    end;
    if not Nasel then inc(I)
  end;
  if Nasel then result:= Branch
end;


function TNode.GetLine(aLin: TPolyLineElement): TPolyLineElement;
var
  I: longInt;
  Nasel: boolean;
begin
  result:= nil;
  I:= 0;
  Nasel:= false;
  while (I<Count) and not Nasel do
  begin
    if Elements[I] is TPolyLineElement then
    begin
      Nasel:= TPolyLineElement(Elements[I]) = aLin
    end;
    if not Nasel then inc(I)
  end;
  if Nasel then result:= TPolyLineElement(Elements[I])
end;


procedure TNode.AddBranchSorted(Branch: TNodeBranch);
{ zarazuje vetev podle uhlu a pred jine elementy nez je vetev }
var
  I: longInt;
  Zaradit: boolean;
  BranchI: TNodeBranch;
begin
  Zaradit:= false;
  I:= 0;
  if Count > 0 then
  begin
    while (I < Count) and not Zaradit do
    begin
      if Elements[I] is TNodeBranch then
      begin
        BranchI:= TNodeBranch(Elements[I]);
        if BranchI.Angle > Branch.Angle then
           Zaradit:= true
        else
           if BranchI.Angle = Branch.Angle then
            { PostMsgText(tm_AddToProtocol,
                         'Linie .'+IntToStr(Branch.LineNo) +
                         ' m stejn hel jako linie .'+IntToStr(BranchI.LineNo),
                         World.MainTool);
}
{              MessageDlg('Linie .'+IntToStr(Branch.LineNo) +
                         ' m stejn hel jako linie .'+IntToStr(BranchI.LineNo),
                         mtError, [mbOK], 0)
}
      end
      else
        Zaradit:= true;

      if not Zaradit then inc(I)
    end
  end;

  if Zaradit then
     InsertElement(I, Branch)
  else
    AddElement(Branch)
end;


function TNode.GetBranchCount: longInt;
var
  I: longInt;
begin
  result:= 0;
  for I:= 0 to Count-1 do
  begin
    if Elements[I] is TNodeBranch then inc(Result)
  end;
end;



function TNode.AddLine(aLin: TPolyLineElement; aBegin: boolean): TNodeBranch;
var
  //Branch: TNodeBranch;
  X, Y: double;
begin
  result:= nil;
  try
  aLin.GetOrientedCoord(0, aBegin, X, Y);

  if FCoord = nil then
  begin
    FCoord:= T2DCoordinate.Create;
    FCoord.X:= X;
    FCoord.Y:= Y
  end;

  result:= GetBranchOfLine(aLin, aBegin);
  if result = nil then
  begin
    result:= TNodeBranch.Create;
    result.FLine:= aLin;
    result.FLineBegin:= aBegin;
    AddBranchSorted(result);
    if GetLine(aLin) = nil then
       AddAndUpdateRect(aLin)
  end
  except
    ShowMessage('Error: TNode.AddLine')
  end;
end;




procedure GiveNodeBranchForLine(aLine: TPolyLineElement; aBegin: boolean;
                               var aNode: TNode; var aBranch: TNodeBranch);
var
  I: longInt;
  Found: boolean;
  aNodeOwner: TNode;
begin
  aNodeOwner := nil;
  aNode:= nil;
  aBranch:= nil;
  if aLine = nil then exit;
  Found:= false;
  I:= 0;
  while not Found and (I < aLine.OwnersCount) do
  begin
    aNodeOwner:= TNode(aLine.Owners[I]);
    if (TElement(aNodeOwner) is TNode) then
    begin
      aBranch:= aNodeOwner.GetBranchOfLine(aLine, aBegin);
      Found:= (aBranch <> nil)
    end;
    inc(I)
  end;
  if Found then aNode:= aNodeOwner
end;



function TNode.IsHit(CoordEl: TCoordinate; Tolerance: double): boolean;
begin
   result:= false;
   if CoordEl = nil then exit;
   result:= IsHitByXY(CoordEl.X, CoordEl.Y, Tolerance);
end;

function TNode.IsHitByXY(aX, aY, Tolerance: double): boolean;
begin
   result:= Distance(aX, aY, X, Y) < abs(Tolerance)
end;

procedure TNode.SetX(const Value: double);
begin
  if FCoord <> nil then
     FCoord.X := Value;
end;

procedure TNode.SetY(const Value: double);
begin
  if FCoord <> nil then
     FCoord.Y := Value;
end;

INITIALIZATION
   RegisterOrbisClass(TNode);
   RegisterOrbisClass(TNodeBranch);
END.
