unit T_LinJoi;
{ Problmy:
  1. Pidat monost generalizace
  2. pi hledn blzkch bod i seek by se mly hledat ty nejbli,
     t.asi zn. vytvoit si seznam monost a z nich vybrat tu nejbli }

{ A: Nstroj pro vloen nov linie do entity star linie

    Pro novou linii se vytvo kolekce seek a kolekce bod, na kter se seky
    odkazuj. Pro seky se vytvo QTreeAbsc, podle kterho se vytvo kolekce starch
    seek a kolekce jejch bod. Porovnvanm linim se nastav atribut Changed
    na false.
    Spust se nstroj B pro prci nad kolekcemi.
    Pak se spust nstroj C pro rekonstrukci.

  A.1. Vytvoen QTreeAbsc pro novou linii
       (TCreateLinQTreeAbsc)
  A.2. Vloen seek obrcen nov linie do seznamu LinesAbsc
       (TCreateLinesAbscEntity)
  A.3. Pidn seek starch lini, kter vyhovuj QTreeAbsc do LinesAbsc
       (TAddLinesIntoLinesAbscEntity )

  B: Nstroj pro prci nad kolekc LinesAbsc
  B.1. Nov body se vemi body
       (TPoinPointJoiner)
       Cyklus pes vechny body nov linie, porovnvan se vemi body novj.
       Pracujeme vlastn s sekami, take se porovnaj poten body,
       u poslednch i jejich koncov body.
       Pokud jsou blzko, tak pesun novho bodu na starou pozici.
       Pokud zachycen star bod nen koncov, seka se ozna jako IsNewEnd.

       To nemus bt pravda. Budou se porovnvat ad B4 a tam se rozhodne co s km.
       Takto by se zbyten rozdlovaly star linie akoliv poslze v danm mst
       nov linie zmiz.
       Vyhozen vech seek nov linie s identickmi konci.

  B.2. Nov body se starmi sekami
       (TNewPointOldAbscJoiner)
         pokud se jedn o koncov bod linie, uplatnit monost variantnho postupu
         pipojen - t.j.jinak ne po kolmici.
       Cyklus pes vechny nov body, porovnvan se vemi starmi sekami.
       Neporovnv se s sekami, majcmi identick koncov bod s novm bodem.

       Pokud dojde k napojen, ozna se stvajc seka IsNewEnd a vlo se
       nov seka s oznaenm IsNew. Tato seka pevezme ukazatel na pvodn
       linii. Do pvodn linie se nov bod vlo a v rmci B4.

  B.3. Star body s novmi sekami
       (TNewAbscOldPointJoiner)
       Cyklus pes nov seky, porovnvan se starmi body.
       - vloen starho bodu do nov seky. Opt ppadn rozdlen star i nov
       linie.

  B.4. Nov seky se zprac. sekami
       (TAbscAbscJoiner)
       Cyklus pes vechny nov seky, porovnvan se starmi sekami.
       - test identity zda oba body obou seek jsou toton - v obou smrech
         identick nov seka se vyhod
       - tam, kde dochz ke styku, se ozna IsNewEnd
       - tam, kde je IsNew se pesune bod do pvodn linie, ale pouze tehdy, kdy
         m vznam.
       - prsek pro seky, kter nemaj spolen bod - v obou smrech
         se do obou seek vlo nov, prv vypoten bod.

  C: Rekonstrukce lini

  C.1. Rekonstrukce starch lini
       Cyklus pes vechny star seky. Tam kde se najde IsNewEnd,
       provede se aktualizace star seky - t.j. star se zkrt a pid nov
       s pvodnmi atributy. Pokud je napojena databze, pid se nov zznam.
       Jejich seky se jako nov linie vkldaj s
       pvodnmi atributy.

  C.2. Nov linie se vkldaj s default atributy.
}


interface
uses
  WinProcs,
// KERNEL
  Elements,
  Tools,
// DIALOG
  //F_Gauge,
// SPACE
  e_Geometry,
  //E_Space,
  E_QTree,
// SPACETOOL
  E_QTLin;


const
  GaugeConst = 1000;

type

TLinesAbscEntity = class(TEntity)
public
  function  GetLine(Index: longInt): TPolyLineElement;
  function  GetAbsc(Index: longInt): TTopLinAbscissa;
  function  GetIndex(aIndex: longInt): longInt;
  procedure DeleteAbsc(aIndex: longInt);
  procedure InsertAbsc(aIndex: longInt; aAbsc: TTopLinAbscissa); { vlo za index }
  function  GetLastAbscIndexForSameLine(aIndex: longInt): longInt;
  procedure GiveEndProps(aIndex: longInt; var EntityEnd, Physicaly, Logicaly: boolean);
  function  ContainLine(aLine: TPolyLineElement): boolean;
  function  IsChanged: boolean;
  property  Abscissa[Index: longInt]: TTopLinAbscissa read GetAbsc;
end;


TCreateLinesAbscEntity = class(TTool)
{ Vytvo LinesAbsc seek pro vloenou linii
  Input : NovaLinie: TPolyLineElement
  Output: LinesAbsc: TLinesAbscEntity
}
  procedure DoIt; override;
end;


TCreateLinQTreeAbsc = class(TTool)
{ Vytvo QTreeAbsc seek pro vloenou entitu seek
  Input : LinesAbsc: TLinesAbscEntity
  Output: QTreeAbsc: TQTreeTopLinAbsc
}
  procedure DoIt; override;
end;


TAddLinesIntoLinesAbscEntity = class(TTool)
{ Vlo star linie rozdlen na seky do LinesAbsc pomoc QTreeLinesAbsc
  Input       : QTreeLinii: TQTreeTopLin;
  LinesAbsc : TLinesAbscEntity
  QTreeAbsc : TQTreeTopLinAbsc;
  Output      : LinesAbsc : TLinesAbscEntity;
}
private
  FLinesAbsc : TLinesAbscEntity;
  FQTreeAbsc : TQTreeTopLinAbsc;
  FTolerance: double;
  FCompareOnlyDifferentSource: boolean;
  FRefContainer: TElement;
public
  procedure DoIt; override;
published
  property LinesAbsc : TLinesAbscEntity read FLinesAbsc write FLinesAbsc;
  property QTreeAbsc : TQTreeTopLinAbsc read FQTreeAbsc write FQTreeAbsc;
  property Tolerance: double read FTolerance write FTolerance;
  property CompareOnlyDifferentSource: boolean
           read FCompareOnlyDifferentSource write FCompareOnlyDifferentSource;
  property RefContainer: TElement read FRefContainer write FRefContainer;
end;



TProtocolTool = class(TTool)
private
  FProtocol: string;
  FUseProtocol: boolean;
  FProtocoledLine: longInt;
  procedure SetProtocol(aName: string);
protected
  procedure AddToProtocol(aString: string);
  procedure CrdToProtocol(aX, aY: double; aSign: string);
  procedure AbscToProtocol(aAbsc: TTopLinAbscissa; aSign: string);
  procedure AbscEntToProtocol(LAE: TLinesAbscEntity);
  procedure LinToProtocol(Lin: TPolyLineElement);
  function  MakeProtocol(aLinNo: longInt): boolean;
published
  property Protocol: string read FProtocol write SetProtocol;
  property UseProtocol: boolean read FUseProtocol write FUseProtocol;
  property ProtocoledLine: longInt read FProtocoledLine write FProtocoledLine;
end;


TDeleteZeroAbscInFirstLine = class(TProtocolTool)
private
  FSnapDistance : double;
public
  procedure DoIt; override;
published
  property SnapDistance : double  read FSnapDistance  write FSnapDistance;
end;



TPoinPointJoiner = class(TProtocolTool)
{  Cyklus pes vechny body nov linie, porovnvan se vemi body novj. }
private
  FSnapDistance : double;
  FOnlyEnds     : boolean;
  FSelfTest     : boolean; { Zda se bude nov linie testovat sama se sebou }
public
  procedure DoIt; override;
published
  property SnapDistance : double  read FSnapDistance  write FSnapDistance;
  property OnlyEnds     : boolean read FOnlyEnds      write FOnlyEnds;
  property SelfTest      : boolean read FSelfTest      write FSelfTest;
end;



TNewPointOldAbscJoiner = class(TProtocolTool)
{ Cyklus pes vechny nov body, porovnvan se vemi starmi sekami. }
private
  FSnapDistance : double;
  FDivideOldLine: boolean;
  FOnlyEnds     : boolean;
  FSelfTest     : boolean; { Zda se bude nov linie testovat sama se sebou }
public
  procedure DoIt; override;
published
  property SnapDistance: double read FSnapDistance write FSnapDistance;
  property DivideOldLine: boolean read FDivideOldLine write FDivideOldLine;
  property OnlyEnds     : boolean read FOnlyEnds      write FOnlyEnds;
  property SelfTest      : boolean read FSelfTest      write FSelfTest;
end;


TAbscPoint = class(TElement)
public
  X, Y, PataX, PataY: double;
  Line: TPolyLineElement;
end;


TPointsLine = class(TEntity)
public
  StartX, StartY: double;
  function StartDist(aIndex: longInt): double;
  procedure AddPoint(aAbsc: TTopLinAbscissa; aBegin: boolean;
                     PataX, PataY: double);
end;


TNewAbscOldPointJoiner = class(TProtocolTool)
{ Cyklus pes nov seky, porovnvan se starmi body. }
private
  FSnapDistance : double;
  FSelfTest     : boolean; { Zda se bude nov linie testovat sama se sebou }
  procedure ProcessAbsc
            (aLAE: TLinesAbscEntity; aAbsc: TTopLinAbscissa; aPoints: TPointsLine;
             var NewAbscIter: longInt);
public
  procedure DoIt; override;
published
  property SnapDistance: double read FSnapDistance write FSnapDistance;
  property SelfTest      : boolean read FSelfTest      write FSelfTest;
end;

TAbscAbscJoiner = class(TProtocolTool)
{  Cyklus pes vechny nov seky, porovnvan se starmi sekami. }
private
  FSelfTest     : boolean; { Zda se bude nov linie testovat sama se sebou }
public
  procedure DoIt; override;
  property SelfTest      : boolean read FSelfTest      write FSelfTest;
end;

TLinComparator = class(TProtocolTool)
{ Porovn novou linii se starmi liniemi v QTree a vrt ji zpracovanou
 Input: NovaLinie: TPolyLineElement
 QTree: TQTreeTopLin
 Output: Seznam novch a mnnch lini
}
private
  FQTree: TQTreeTopLin;
  //FOldLinesQTree: TQTreeTopLin;
  FLinesAbsc    : TLinesAbscEntity;
  FQTreeAbsc    : TQTreeTopLinAbsc;
  FSnapDistance : double;
  FOnlyEnds     : boolean;
  FSelfTest     : boolean; { Zda se bude nov linie testovat sama se sebou }
  FCompareOnlyDifferentSource: boolean;
  FRefContainer : TElement;

public
  procedure DoIt; override;
published
  property QTree: TQTreeTopLin read FQTree write FQTree;
  property SnapDistance: double read FSnapDistance write FSnapDistance;
  property OnlyEnds    : boolean read FOnlyEnds    write FOnlyEnds;
  property SelfTest    : boolean read FSelfTest    write FSelfTest;
  property CompareOnlyDifferentSource: boolean
           read FCompareOnlyDifferentSource write FCompareOnlyDifferentSource;
  property RefContainer: TElement read FRefContainer write FRefContainer;
end;



TDivideAbscs = class(TProtocolTool)
private
  FMaxOutputAbscLength: double;
  FRoundKoef: double;
  FDivideLines: boolean;
public
  procedure DoIt; override;
published
  property MaxOutputAbscLength: double read FMaxOutputAbscLength write FMaxOutputAbscLength;
  property RoundKoef: double read FRoundKoef write FRoundKoef;
  property DivideLines: boolean read FDivideLines write FDivideLines;
end;


TSaveChangedLines = class(TProtocolTool)
private
  FNewLines: TPolyLineString;
  FQTree: TQTreeTopLin;
  FMinLength: double;
  FSetLinesLabelPoint: boolean;
public
  procedure DoIt; override;
published
  property NewLines: TPolyLineString read FNewLines write FNewLines;
  property QTree: TQTreeTopLin read FQTree write FQTree;
  property MinLength   : double read FMinLength    write FMinLength;
  property SetLinesLabelPoint: boolean read FSetLinesLabelPoint write FSetLinesLabelPoint;
end;




TestLinJoiner = class(TCreateQTreeTopLin)
private
 FLinesContainer: TPolyLineString;
public
  procedure Process(Element: TElement); override;
  procedure DoIt; override;
end;




TJoinLines = class(TTool)
{ input: linie uschovan v linern entit
  output: TQTreeTopLin
  FixedLines - linern entita lini, kter jsou spojeny, jen se vlo do QTree
               a k nim se pipoj ostatn}
private
  FSnapDistance : double;
  FMinLength    : double;
  FOnlyEnds     : boolean;
  FQTree: TQTreeTopLin;
{  FLinesContainer: TPolyLineString; }
  //FLinNo: longInt;
  FSelfTest     : boolean; { Zda se bude nov linie testovat sama se sebou }
  FPrepocitavatPopBodyLinii: boolean;
  FCompareOnlyDifferentSource: boolean;
  FMaxOutputAbscLength: double;
  FRoundKoef: double;
  FDivideOutputLines: boolean;

  FProtocol: string;
  FUseProtocol: boolean;
  FProtocoledLine: longInt;
    FFixedLines: TEntity;
  procedure SetProtocol(aName: string);
    procedure SetFixedLines(const Value: TEntity);
public
  procedure Process(Element: TElement);
  procedure DoIt; override;
  // PPK fixed lines -
published
  property SnapDistance: double read FSnapDistance write FSnapDistance;
  property MinLength   : double read FMinLength    write FMinLength;
  property OnlyEnds    : boolean read FOnlyEnds    write FOnlyEnds;
  property SelfTest    : boolean read FSelfTest    write FSelfTest;
  property PrepocitavatPopBodyLinii: boolean read FPrepocitavatPopBodyLinii
           write FPrepocitavatPopBodyLinii;
  property CompareOnlyDifferentSource: boolean read FCompareOnlyDifferentSource
           write FCompareOnlyDifferentSource;
  property MaxOutputAbscLength: double read FMaxOutputAbscLength write FMaxOutputAbscLength;
  property RoundKoef: double read FRoundKoef write FRoundKoef;
  property DivideOutputLines: boolean read FDivideOutputLines write FDivideOutputLines;
  property Protocol: string read FProtocol write SetProtocol;
  property UseProtocol: boolean read FUseProtocol write FUseProtocol;
  property ProtocoledLine: longInt read FProtocoledLine write FProtocoledLine;
  property FixedLines: TEntity read FFixedLines write SetFixedLines;
end;


(*
TJoinLinesFromBlockToBlock = class(TJoinLines)
private
  FLinNo: longInt;
  FSourceBlockDir,
  FTargetBlockDir: string;
public
  constructor Create; override;
  procedure DoIt; override;
published
  property SourceName  : string  read FSourceBlockDir write FSourceBlockDir;
  property TargetName  : string  read FTargetBlockDir write FTargetBlockDir;
end;
*)


{**********************************************************************}

implementation
uses
  SysUtils, Dialogs, Forms, Controls,
// KERNEL
  E_Class,
  U_String,
  Worlds,
  M_Orbis,
// GLIB
  G_Elems,
  MathLib,
  E_WCS,
// SPACE
  e_Reg,
  //E_SpaPrp,
// SPACETOOL
  T_Topol,
  T_ToTool;
//  T_TopImp,
//  T_ExLnTl;

(*{$IFDEF LAETest}*)

procedure ZapisLAE(Id: string; LAE: TLinesAbscEntity);
{
var
  F: system.Text;
  I: longInt;
  Absc: TTopLinAbscissa;
}  
begin
  (*!!!!!!!G
  system.assign(F, 'h:\orbis\' + Id + '.LAE');
  system.rewrite(F);
  for I:= 0 to LAE.Count-1 do
  begin
    Absc:= LAE.Abscissa[I];
    with Absc do;
      //writeln(F, Absc.Line.SpaceId:5,  X1:17:8, Y1:18:8, X2:17:8,Y2:18:8 {, ' NE:',IsNewEnd:1})
  end;
  system.close(F)
  *)
end;

(*{$ENDIF}*)

procedure TProtocolTool.SetProtocol(aName: string);
begin
  FProtocol:= aName;
end;



procedure TProtocolTool.AddToProtocol(aString: string);
var
  F: system.Text;

begin
  if not UseProtocol then exit;
  system.assign(F, FProtocol);
  {$I-} system.append(F); {$I+}
  if ioresult <> 0 then
  begin
   {$I-} system.rewrite(F); {$I+}
   if ioResult <> 0 then
      ShowMessage('Protocol ' + aString + ' open error')
  end;

  system.writeln(F, aString);
  system.close(F)
end;


procedure TProtocolTool.CrdToProtocol(aX, aY: double; aSign: string);
begin
  AddToProtocol(
                  DoubleToStr(aX, 17, 8) +
                  DoubleToStr(aY, 18, 8) + aSign
                )
end;


procedure TProtocolTool.AbscToProtocol(aAbsc: TTopLinAbscissa; aSign: string);
//var
  //aBlok: string;
  //Atribs: string;

begin
  (*
  aBlok:= '';
  if (aAbsc.Line <> nil) and (aAbsc.Line.Properties is TSpaceEntityProps) then
     aBlok:= ExtractFileName(tSpaceEntityProps(aAbsc.Line.properties).blockName);
  with aAbsc do
  begin
    Atribs:= ' ';
    if IsFirst    then Atribs:= Atribs + 'First ';
    if IsLast     then Atribs:= Atribs + 'Last ';
    if IsNewEnd   then Atribs:= Atribs + 'NewEnd ';
    if FixedBegin then Atribs:= Atribs + 'FixBeg ';
    if FixedEnd   then Atribs:= Atribs + 'FixEnd ';
    if IsNew      then Atribs:= Atribs + 'New ';
    if IsDeleted  then Atribs:= Atribs + 'Del ';

    AddToProtocol(aBlok + ' ' + IntToStrZ(LineNo, 5, false) +
                  ' ' + IntToStrZ(Index, 2, false) +
                  DoubleToStr(X1, 17, 8) +
                  DoubleToStr(Y1, 18, 8) +
                  DoubleToStr(X2, 17, 8) +
                  DoubleToStr(Y2, 18, 8) +
                  Atribs +
                  aSign + ' ' + aAbsc.Line.Name)
  end;
  *)
end;


procedure TProtocolTool.AbscEntToProtocol(LAE: TLinesAbscEntity);
var
  I: longInt;
  Absc: TTopLinAbscissa;
begin
  if LAE = nil then exit;
  for I:= 0 to LAE.Count-1 do
  begin
    Absc:= LAE.Abscissa[I];

    AbscToProtocol(Absc, '');
  end;
end;



function TProtocolTool.MakeProtocol(aLinNo: longInt): boolean;
begin
  result:= false;
  if not UseProtocol then exit;
  result:= (ProtocoledLine = -1) or (ProtocoledLine = aLinNo)
end;

procedure TProtocolTool.LinToProtocol(Lin: TPolyLineElement);
begin
  try
    //AddToProtocol(tSpaceEntityProps(Lin.properties).blockName + ':' + IntToStr(Lin.SpaceId));
  except
  end
end;



                       { TLinesAbscEntity }

procedure TLinesAbscEntity.DeleteAbsc(aIndex: longInt);
var
  TheAbsc, aAbsc: TTopLinAbscissa;
  I, LI: longInt;
  aLine: TPolyLineElement;
  //aLast: boolean;
begin
  if aIndex < Count then
  begin
    TheAbsc:= TTopLinAbscissa(Elements[aIndex]);
    //aLast:= TheAbsc.IsLast;
    aLine:= TheAbsc.Line;
    aLine.FreeElement(aLine.Elements[TheAbsc.Index]);
  (* nelze, neb tmto se pedchoz sece podtrhne koncov bod !
    if aLast then
    { pro posledn seku mae i posledn bod}
       aLine.FreeElement(aLine.Elements[aLine.Count-1])
    else
  *)
    begin
    { peslovn index ve zbylch sekch - avak pouze pro ruen seky
      v souvisl linii }
      LI:= GetLastAbscIndexForSameLine(aIndex);
      for I:= aIndex+1 to LI do
      begin
        aAbsc:= Abscissa[I];
        aAbsc.Index:= aAbsc.Index-1;
      end
    end;

    FreeElement(TheAbsc)
  end
  {
  else
    aIndex:= aIndex
   }
end;



procedure TLinesAbscEntity.InsertAbsc(aIndex: longInt; aAbsc: TTopLinAbscissa);
var
  TheAbsc: TTopLinAbscissa;
  I: longInt;
begin
  THeAbsc := nil;
  if aIndex < Count then
  begin
    InsertElement(aIndex, aAbsc);
    I:= aIndex+1;
   {posouvn ukazovtka na souadnice}
    if I < Count then
       TheAbsc:= Abscissa[I];
    while (I < Count) and  (TheAbsc.Line = aAbsc.Line) do
    begin
      TheAbsc.Index:= TheAbsc.Index+1;
      inc(I);
      if I < Count then
         TheAbsc:= Abscissa[I]
    end
  end
  else
     AddElement(aAbsc);
end;




function TLinesAbscEntity.GetLine(Index: longInt): TPolyLineElement;
begin
  result:= Abscissa[Index].Line;
end;


function TLinesAbscEntity.GetAbsc(Index: longInt): TTopLinAbscissa;
begin
  result:= TTopLinAbscissa(Elements[Index])
end;



function  TLinesAbscEntity.GetIndex(aIndex: longInt): longInt;
begin
  result:= Abscissa[aIndex].Index;
end;





function TLinesAbscEntity.GetLastAbscIndexForSameLine(aIndex: longInt): longInt;
var
  aAbsc: TTopLinAbscissa;
  //TheAbsc: TTopLinAbscissa;
  I: longInt;

begin
  //result:= 0;
  aAbsc:= Abscissa[aIndex];
  I:= aIndex;
  //TheAbsc:= Abscissa[I];
  while (I < Count) and (Abscissa[I].Line = aAbsc.Line) do
  begin
    inc(I);
    //if I < Count then TheAbsc:= Abscissa[I]
  end;

  result:= I-1
end;



procedure  TLinesAbscEntity.GiveEndProps
           (aIndex: longInt;
            var EntityEnd, Physicaly, Logicaly: boolean);
var
  aAbsc, NextAbsc: TTopLinAbscissa;
begin
  EntityEnd:= false;
  Physicaly:= false;
  Logicaly:= false;
  if aIndex = Count-1 then EntityEnd:= true;
  aAbsc:= Abscissa[aIndex];
  if aAbsc.IsLast then Physicaly:= true;
  if EntityEnd or Physicaly then exit;

  NextAbsc:= Abscissa[aIndex+1];
  if aAbsc.Line <> NextAbsc.Line then
  begin
    EntityEnd:= true;
    exit
  end;

  if NextAbsc.IsNewEnd or NextAbsc.IsDeleted then Logicaly:= true;
end;



function  TLinesAbscEntity.ContainLine(aLine: TPolyLineElement): boolean;
var
  I: longInt;
begin
  result:= false;
  if count= 0 then exit;
  for I:= 0 to count-1 do
  begin
    if GetLine(I) = aLine then
    begin
       result:= true;
       break
    end
  end
end;



function  TLinesAbscEntity.IsChanged: boolean;
var
  I: longInt;
  aAbsc: TTopLinAbscissa;
begin
  result:= false;

  for I:= 0 to Count-1 do
  begin
    aAbsc:= Abscissa[I];
    result:= aAbsc.IsNew {or aAbsc.IsNewEnd} or aAbsc.IsDeleted;
    if result then
       break
  end;
end;





                      { TCreateLinesAbscEntity }

procedure TCreateLinesAbscEntity.DoIt;
{ Vytvo LinesAbsc seek pro vloenou linii
  Input : NovaLinie: TPolyLineElement
  Output: LinesAbsc: TLinesAbscEntity
}
var
  Lin: TPolyLineElement;
  LAE: TLinesAbscEntity;
  aAbsc: TTopLinAbscissa;
  I: longInt;
begin
  if Input is TPolyLineElement then
  begin
    Lin:= TPolyLineElement(Input);
    LAE:= TLinesAbscEntity.Create;
    for I:= 0 to Lin.Count-2 do
    begin
      aAbsc:= TTopLinAbscissa.Create;
      LAE.AddElement(aAbsc);
      aAbsc.Line:= Lin;
      // PK Test !!!!!!!!!!!
      //aAbsc.Name := Lin.Name;
      aAbsc.Index:= I
    end;
    Output:= LAE;
  end
end;

                       { TCreateLinQTreeAbsc }


procedure TCreateLinQTreeAbsc.DoIt;
{ Vytvo QTreeAbsc seek pro vloenou entitu seek
  Input : LinesAbsc: TLinesAbscEntity
  Output: QTreeAbsc: TQTreeTopLinAbsc
}
var
  QTreeAbsc: TQTreeTopLinAbsc;
  Lines: TLinesAbscEntity;
  Lin: TPolyLineElement;
  I: longInt;
begin
  if Input is TLinesAbscEntity then
  begin
    Lines:= TLinesAbscEntity(Input);
    Lin:= Lines.GetLine(0);
    QTreeAbsc:= TQTreeTopLinAbsc.Create;
    QTreeAbsc.SetForRectangle(Lin.MinX, Lin.MinY, Lin.MaxX, Lin.MaxY);

    for I:= 0 to Lines.Count-1 do
    begin
      QTreeAbsc.AddElement(Lines.Elements[I])
    end;

    Output:= QTreeAbsc
  end
end;



                   { TAddLinesIntoLinesAbscEntity }

procedure TAddLinesIntoLinesAbscEntity.DoIt;
{ Vlo star linie rozdlen na seky do LinesAbsc pomoc QTreeLinesAbsc
  Input       : QTreeLinii: TQTreeTopLin;
  LinesAbsc : TLinesAbscEntity
  QTreeAbsc : TQTreeTopLinAbsc;
  Output      : LinesAbsc : TLinesAbscEntity;
}

var
  QTreeLinii: TQTreeTopLin;
  QW        : TQTreeWalker;
  //CLAE      : TCreateLinesAbscEntity;
  Lin       : TPolyLineElement;
  I         : longInt;
  aAbsc     : TTopLinAbscissa;

  function OKTestSources(Lin: TPolyLineElement): boolean;
  var
    LinCont   : TElement;
    RGE: TRegisteredGeometryElement;
  begin
    result:= true;
    if not CompareOnlyDifferentSource then exit;
    {
    if Lin.Properties is TSpaceEntityProps then
       LinCont:= TSpaceEntityProps(Lin.Properties).ObjectRegister
    }
    // !!!!!!!!!!!!G
    RGE := TRegisteredGeometryElement(Lin.FindOwnerClass(TRegisteredGeometryElement));
    if RGE <> nil then
       LinCont:= RGE.ObjectRegister
    else
       LinCont:= nil;

    result:= LinCont <> RefContainer
  end;


begin
  Output:= nil;
  if not (TElement(LinesAbsc) is TLinesAbscEntity) then exit;
  if not (TElement(QTreeAbsc) is TQTreeTopLinAbsc) then exit;
  if not (Input is TQTreeTopLin) then exit;

  QTreeLinii:= TQTreeTopLin(Input);
{ 1. Hledn lini, kter se pekrvaj s QTreeAbsc
   Cyklus pes linie, splujc podmnku pekryvu
2. Vybrn seek, kter se najdou v QTreeAbsc
}
  QW:= TQTreeWalker.Create;
  with  QTreeAbsc do
    Lin:= TPolyLineElement(QW.GetFirstElementForRectangle
                    (QTreeLinii, QXmin, QYmin, QXmin+QWidth, QYmin+QWidth, Tolerance));
  while Lin <> nil do
  begin
    if (TElement(Lin) is TPolyLineElement) and
       not LinesAbsc.ContainLine(Lin) and
     { test zda ji nen tato linie obsaena z dvjho qtree }
       OKTestSources(Lin) then
     { pokud se porovnvaj pouze z rozdlnch zdroj }
    begin
      for I:= 0 to Lin.Count-2 do
      begin
        Application.ProcessMessages;

        aAbsc:= TTopLinAbscissa.Create;
        aAbsc.Line:= Lin;
        // PK Test !!!!!!!!!!!
        //aAbsc.Name := Lin.Name;
        aAbsc.Index:= I;

        { Test zda seka zapadne do QTreeAbsc }
        if QTreeAbsc.HasElementOverRectangle
           (aAbsc.Xmin - Tolerance, aAbsc.Ymin-Tolerance,
            aAbsc.Xmax+Tolerance, aAbsc.Ymax+Tolerance) then
        begin
          LinesAbsc.AddElement(aAbsc)
        end
        else
          aAbsc.Free
      end;
    end;
    Lin:= TPolyLineElement(QW.GetNextElement)
  end;
  Output:= LinesAbsc;
  QW.Free;
end;



procedure TDeleteZeroAbscInFirstLine.DoIt;
var
  LAE: TLinesAbscEntity;
  I: longInt;
  //LI: longInt;
  aAbsc: TTopLinAbscissa;
  Lin: TPolyLineElement;
begin
  if Input is TLinesAbscEntity then
  begin
    LAE:= TLinesAbscEntity(Input);
    aAbsc:= LAE.GetAbsc(0);
    Lin:= aAbsc.Line;
    I:= 0;
    while (I < LAE.Count) and (aAbsc.Line = Lin) do
    begin
      with aAbsc do
      if EqualPoints(X1, Y1, X2, Y2) or
         ((SnapDistance > 0) and InTolerance(X1, Y1, X2, Y2, SnapDistance)) then
      begin
         LAE.DeleteAbsc(I);
         {!!!!!!!!!!!!!G
         if MakeProtocol(Lin.SpaceId) then
         begin
           AddToProtocol(' ');
           AddToProtocol('>>> TDeleteZeroAbscInFirstLine.DoIt <<<');
           LinToProtocol(Lin);
           AbscEntToProtocol(LAE);
         end
         }
      end
      else
        inc(I);

      if I< LAE.Count then
         aAbsc:= LAE.GetAbsc(I)
    end
  end;
end;


          { TPoinPointJoiner }


{  Cyklus pes vechny body nov linie, porovnvan se vemi body novj. }
procedure TPoinPointJoiner.DoIt;
var
  LAE: TLinesAbscEntity;
  Lin: TPolyLineElement;
  aAbsc, OldAbsc: TTopLinAbscissa;
  I, J: longInt;
  //Gauge: TF_gaugeForm;
  aDist, aX, aY,
  MinDistBegin, MinJoinXBegin, MinJoinYBegin: double;
  MinDistEnd  , MinJoinXEnd  , MinJoinYEnd: double;
  MinLinBeg   , MinLinEnd: TPolyLineElement;
  FoundJoinBegin, FoundJoinEnd: boolean;
  //aCislo: longInt;
  {!aBlok: string;}

  procedure SetMinBegin;
  begin
    MinJoinXBegin:= aX; MinJoinYBegin:= aY;
    MinDistBegin:= aDist;
    FoundJoinBegin:= true;
    MinLinBeg:= OldAbsc.Line;
  end;

  procedure SetMinEnd;
  begin
    MinJoinXEnd:= aX; MinJoinYEnd:= aY;
    MinDistEnd:= aDist;
    FoundJoinEnd:= true;
    MinLinEnd:= OldAbsc.Line;
  end;


begin
  //Gauge:= nil;
  if Input is TLinesAbscEntity then
  begin
    LAE:= TLinesAbscEntity(Input);
    Lin:= LAE.Abscissa[0].Line;
    //aCislo:= Lin.SpaceId;
    aAbsc:= LAE.Abscissa[0];
{!
    if Lin.Properties is TSpaceEntityProps then
       aBlok:= tSpaceEntityprops(Lin.properties).blockName;
}
    I:= 0;

    if LAE.Count > GaugeConst then
    begin
      {
      Gauge:= TF_GaugeForm.Create(Application);
      Gauge.MaxValue:= LAE.Count;
      Gauge.Show;
      Gauge.Top:= Gauge.Top + 50;
      }
      StartProgress('Porovnn bod',0,LAE.Count);
    end;

    while (I < LAE.Count) and (aAbsc.Line = Lin)  do
    begin
      if {(Gauge <> nil) and }(I mod 10 = 0) then
      begin
        Progress:= I;
        ProgressText:= 'Porovnvn novch bod s body: ' + IntToStr(I);
        Application.ProcessMessages
      end;


{      if not OnlyEnds  or aAbsc.IsMargin then }

      if SelfTest then
      begin
        J:= I+1;

        FoundJoinBegin:= false;
        FoundJoinEnd:= false;
        MinDistBegin:= 1E30;
        MinDistEnd:= 1E30;
        MinLinBeg:= nil;
        MinLinEnd:= nil;

        while J < LAE.Count{-1} do
        begin
          OldAbsc:= LAE.Abscissa[J];
          if OldAbsc.Line <> aAbsc.Line then // pouze nov seky
             break;

          if aAbsc.IsOverRectangle
             (OldAbsc.Xmin, OldAbsc.Ymin, OldAbsc.Xmax, OldAbsc.Ymax, FSnapDistance) then
          begin
            if not OnlyEnds or (aAbsc.Index = 0) then
            {Pokud chci pouze krajn tak zde mu jenom prvn seku}
            begin
              if OldAbsc.isFirst then
              begin
                 if aAbsc.IsJoinedPoint(true, OldAbsc, true, FSnapDistance, aDist, aX, aY) then
                    if aDist < MinDistBegin then
                       SetMinBegin;
              end;

              if aAbsc.IsJoinedPoint(true, OldAbsc, false, FSnapDistance, aDist, aX, aY) then
                 if aDist < MinDistBegin then
                    SetMinBegin
            end;

            if aAbsc.IsLast then
            begin
              if OldAbsc.isFirst then
              begin
                if aAbsc.IsJoinedPoint(false, OldAbsc, true, FSnapDistance, aDist, aX, aY) then
                  if aDist < MinDistEnd then
                    SetMinEnd
              end;

              if aAbsc.IsJoinedPoint(false, OldAbsc, false, FSnapDistance, aDist, aX, aY) then
                if aDist < MinDistEnd then
                  SetMinEnd
            end
          end; { pekrvaj se obdlnky }

          inc(J);

        end; { cyklus pes vechny nov seky }


        if FoundJoinBegin then
        begin
          aAbsc.JoinToPoint(true, MinJoinXBegin, MinJoinYBegin, FSnapDistance);
//        aAbsc.FixedEnd:= true;
          {!!!!!!!!!!!G
          if MakeProtocol(Lin.SpaceId) then
          begin
            AddToProtocol(' ');
            AddToProtocol('>>> TPoinPointJoiner.DoIt, FoundJoinBegin to same line <<<');
            LinToProtocol(Lin);
            AbscEntToProtocol(LAE);
            LinToProtocol(MinLinBeg);
            CrdToProtocol(MinJoinXBegin, MinJoinYBegin, '');
            AbscToProtocol(aAbsc, ' <<');
          end;
          }
        end;

        if FoundJoinEnd then
        begin
          aAbsc.JoinToPoint(false, MinJoinXEnd, MinJoinYEnd, FSnapDistance);
  //        aAbsc.FixedEnd:= true;
          {!!!!!!!!!!!G
          if MakeProtocol(Lin.SpaceId) then
          begin
            AddToProtocol(' ');
            AddToProtocol('>>> TPoinPointJoiner.DoIt, FoundJoinEnd to same line <<<');
            LinToProtocol(Lin);
            AbscEntToProtocol(LAE);
            LinToProtocol(MinLinEnd);
            CrdToProtocol(MinJoinXEnd, MinJoinYEnd, '');
            AbscToProtocol(aAbsc, ' <<');
          end;
          }
        end;
      end;


      J:= LAE.GetLastAbscIndexForSameLine(I) + 1; // u jen star seky

      FoundJoinBegin:= false;
      FoundJoinEnd:= false;
      MinDistBegin:= 1E30;
      MinDistEnd:= 1E30;
      MinLinBeg:= nil;
      MinLinEnd:= nil;

      while J < LAE.Count{-1} do
      begin
        OldAbsc:= LAE.Abscissa[J];

        if aAbsc.IsOverRectangle
           (OldAbsc.Xmin, OldAbsc.Ymin, OldAbsc.Xmax, OldAbsc.Ymax, FSnapDistance) then
        begin
          if not OnlyEnds or (aAbsc.Index = 0) then
          {Pokud chci pouze krajn tak zde mu jenom prvn seku}
          begin
            if OldAbsc.isFirst then
            begin
               if aAbsc.IsJoinedPoint(true, OldAbsc, true, FSnapDistance, aDist, aX, aY) then
                  if aDist < MinDistBegin then
                     SetMinBegin;
            end;

            if aAbsc.IsJoinedPoint(true, OldAbsc, false, FSnapDistance, aDist, aX, aY) then
               if aDist < MinDistBegin then
                  SetMinBegin
          end;

          if aAbsc.IsLast then
          begin
            if OldAbsc.isFirst then
            begin
              if aAbsc.IsJoinedPoint(false, OldAbsc, true, FSnapDistance, aDist, aX, aY) then
                if aDist < MinDistEnd then
                  SetMinEnd
            end;

            if aAbsc.IsJoinedPoint(false, OldAbsc, false, FSnapDistance, aDist, aX, aY) then
              if aDist < MinDistEnd then
                SetMinEnd
          end
        end; { pekrvaj se obdlnky }

        inc(J);

      end; { cyklus pes vechny star seky }

      if FoundJoinBegin then
      begin
        aAbsc.JoinToPoint(true, MinJoinXBegin, MinJoinYBegin, FSnapDistance);
        aAbsc.FixedBegin:= true;
        {!!!!!!!!!!!!G
        if MakeProtocol(Lin.SpaceId) then
        begin
          AddToProtocol(' ');
          AddToProtocol('>>> TPoinPointJoiner.DoIt, FoundJoinBegin to another line <<<');
          LinToProtocol(Lin);
          AbscEntToProtocol(LAE);
          LinToProtocol(MinLinBeg);
          CrdToProtocol(MinJoinXBegin, MinJoinYBegin, '');
          AbscToProtocol(aAbsc, ' <<');
        end;
        }
      end;

      if FoundJoinEnd then
      begin
        aAbsc.JoinToPoint(false, MinJoinXEnd, MinJoinYEnd, FSnapDistance);
        aAbsc.FixedEnd:= true;
        {!!!!!!!!!G
        if MakeProtocol(Lin.SpaceId) then
        begin
          AddToProtocol(' ');
          AddToProtocol('>>> TPoinPointJoiner.DoIt, FoundJoinEnd to another line <<<');
          LinToProtocol(Lin);
          AbscEntToProtocol(LAE);
          LinToProtocol(MinLinEnd);
          CrdToProtocol(MinJoinXEnd, MinJoinYEnd, '');
          AbscToProtocol(aAbsc, ' <<');
        end;
        }
      end;

      inc(I);
      if (I < LAE.Count) then
         aAbsc:= LAE.Abscissa[I]
    end; {cyklus pes vechny seky nov linie }
    ProgressText := 'OK.';
    //if Gauge <> nil then Gauge.Free
  end { is TLinesAbscEntity}
end;



                  { TNewPointOldAbscJoiner }

{ Cyklus pes vechny nov body, porovnvan se vemi starmi sekami. }
procedure TNewPointOldAbscJoiner.DoIt;
var
  LAE: TLinesAbscEntity;
  Lin: TPolyLineElement;
  aAbsc, OldAbsc, NewAbsc: TTopLinAbscissa;
  I, J: longInt;
  PX, PY: double;
  //Gauge: TF_gaugeForm;
begin
  //Gauge:= nil;
  if Input is TLinesAbscEntity then
  begin
    LAE:= TLinesAbscEntity(Input);
    Lin:= LAE.Abscissa[0].Line;
    aAbsc:= LAE.Abscissa[0];
    I:= 0;
    if LAE.Count > GaugeConst then
    begin
      {
      Gauge:= TF_GaugeForm.Create(Application);
      Gauge.MaxValue:= LAE.Count;
      Gauge.Show;
      Gauge.Top:= Gauge.Top + 50;
      }
      StartProgress('Nov body a star seky',0,LAE.Count);
    end;

    while (I < LAE.Count) and (aAbsc.Line = Lin)  do
    { cyklus pes vechny nov body }
    begin
      if {(Gauge <> nil) and }(I mod 10 = 0) then
      begin
        Progress := I;
        ProgressText := 'Porovnvn novch bod s sekami: ' + IntToStr(I);
        Application.ProcessMessages
      end;

      if SelfTest then
         J:= I+1
      else
        J:= LAE.GetLastAbscIndexForSameLine(I) + 1;

      if not OnlyEnds  or aAbsc.IsMargin then
      while J < LAE.Count do
      begin
        { cyklus pes vechny star seky }
        OldAbsc:= LAE.Abscissa[J];
        if aAbsc.IsOverRectangle
           (OldAbsc.Xmin, OldAbsc.Ymin, OldAbsc.Xmax, OldAbsc.Ymax, FSnapDistance) then
        begin
          if not aAbsc.FixedBegin and (not OnlyEnds or (aAbsc.Index = 0)) then
             if aAbsc.JoinToAbsc(true, OldAbsc, FSnapDistance, PX, PY)
                and DivideOldLine then
             begin
               inc(J);
               OldAbsc.CreateDividedWith(PX, PY, NewAbsc);
               LAE.InsertAbsc(J, NewAbsc);
               dec(J); { vrcen, ili nepekroen zbytku
                        1. kdyby do OldAbsc padl i konc.bod
                           - seka opan orientovan
                        2. kdyby do zbytku padl konc. bod v ptm kole
                           - seka stejn orientovan
                        ! konci cyklu bude inc(J) !}
               {!!!!!!!!G
               if MakeProtocol(Lin.SpaceId) then
               begin
                 AddToProtocol(' ');
                 AddToProtocol('>>> TNewPointOldAbscJoiner.DoIt, Current absc <<<');
                 LinToProtocol(Lin);
                 AbscEntToProtocol(LAE);
                 LinToProtocol(OldAbsc.Line);
                 CrdToProtocol(PX, PY, '');
                 AbscToProtocol(NewAbsc, ' <<');
               end;
               }
             end;

          if aAbsc.IsLast and not aAbsc.FixedEnd then
          begin
          { 1. OldAbsc nebyl uznut po.bodem - jako by se nic nedlo,
               zbytek se me pekroit - nen nutn dec(J)
            2. OldAbsc byl   uznut po.bodem - konc.bod me padnout dovnit
               zbytek je lep pekroit, nebude se testovat testovan }
            if aAbsc.JoinToAbsc(false, OldAbsc, FSnapDistance, PX, PY)
                and DivideOldLine then
            begin
              inc(J);
              OldAbsc.CreateDividedWith(PX, PY, NewAbsc);
              LAE.InsertAbsc(J, NewAbsc);
              {!!!!!!!!G
              if MakeProtocol(Lin.SpaceId) then
              begin
                AddToProtocol(' ');
                AddToProtocol('>>> TNewPointOldAbscJoiner.DoIt, Last absc <<<');
                LinToProtocol(Lin);
                AbscEntToProtocol(LAE);
                LinToProtocol(OldAbsc.Line);
                CrdToProtocol(PX, PY, '');
                AbscToProtocol(NewAbsc, ' <<');
              end;
              }
            end;
          end;
        end; { if pekrvaj se obdlnky }
        inc(J)
      end;
      inc(I);
      if (I < LAE.Count) then aAbsc:= LAE.Abscissa[I]
    end;
    ProgressText:= 'OK.';
    //if Gauge <> nil then Gauge.Free

  end
end;



(*
{ Cyklus pes nov seky, porovnvan se starmi body.
  - rozdlen nov seky a jej pitaen ke starmu bodu}
procedure TNewAbscOldPointJoiner.DoIt;
var
  LAE: TLinesAbscEntity;
  Lin: TPolyLineElement;
  aAbsc, OldAbsc, NewAbsc: TTopLinAbscissa;
  I, J: longInt;
  PX, PY: double;
  NearPoint, Danger: boolean;
  IsDivided: boolean;
  Gauge: TF_gaugeForm;
  aBool: boolean;

begin
  aBool:= false;

  Gauge:= nil;
  if Input is TLinesAbscEntity then
  begin
    LAE:= TLinesAbscEntity(Input);
    Lin:= LAE.Abscissa[0].Line;
    aAbsc:= LAE.Abscissa[0];
    I:= 0;
    if aBool then
       ZapisLAE('NAOPJ',LAE);

    if LAE.Count > GaugeConst then
    begin
      Gauge:= TF_GaugeForm.Create(Application);
      Gauge.MaxValue:= LAE.Count;
      Gauge.Show;
      Gauge.Top:= Gauge.Top + 50;
    end;

    while (I < LAE.Count) and (aAbsc.Line = Lin)  do
    { cyklus pes vechny nov seky }
    begin
      if (Gauge <> nil) and (I mod 10 = 0) then
      begin
        Gauge.Progress:= I;
        Gauge.Caption:= 'Porovnvn novch seek s body: ' + IntToStr(I);
        Application.ProcessMessages
      end;


      if SelfTest then
         J:= I+1
      else
        J:= LAE.GetLastAbscIndexForSameLine(I) + 1;

      IsDivided:= false;
      { pokud je aAbsc rozdlen, mus se pejt na dal, jinak hroz
        nekonen cyklus }
      while (J < LAE.Count) {and not IsDivided }do
      begin
        { cyklus pes vechny star seky }
        OldAbsc:= LAE.Abscissa[J];
        if ((J>I+1) or (OldAbsc.Line <> Lin))
           and
           aAbsc.IsOverRectangle
           (OldAbsc.Xmin, OldAbsc.Ymin, OldAbsc.Xmax, OldAbsc.Ymax, FSnapDistance) then
        begin
          aAbsc.RelationToPoint(OldAbsc, true, FSnapDistance,
                                NearPoint, Danger, PX, PY);
          if NearPoint and not Danger then
          begin
            NewAbsc:= aAbsc.CreateDividedWith(PX, PY);
            NewAbsc.IsNew:= true;
            NewAbsc.IsNewEnd:= true; {je vzn na starou linii, tud plat}
            LAE.InsertAbsc(I+1, NewAbsc);
            IsDivided:= true;
            inc(J); { posun J o vloenou seku }

            if MakeProtocol(Lin.SpaceId) then
            begin
              AddToProtocol(' ');
              AddToProtocol('>>> TNewAbscOldPointJoiner.DoIt, Current absc <<<');
              LinToProtocol(Lin);
              AbscEntToProtocol(LAE);
              LinToProtocol(OldAbsc.Line);
              CrdToProtocol(PX, PY, '');
              AbscToProtocol(NewAbsc, ' <<');
            end;
          end;

          if OldAbsc.IsLast then
          begin
            aAbsc.RelationToPoint(OldAbsc, false, FSnapDistance,
                                  NearPoint, Danger, PX, PY);
            if NearPoint and not Danger then
            begin
              NewAbsc:= aAbsc.CreateDividedWith(PX, PY);
              NewAbsc.IsNew:= true;
              NewAbsc.IsNewEnd:= true; {je vzn nas starou linii, tud plat}
              LAE.InsertAbsc(I+1, NewAbsc);
              inc(J); { posun J o vloenou seku }

              if MakeProtocol(Lin.SpaceId) then
              begin
                AddToProtocol(' ');
                AddToProtocol('>>> TNewAbscOldPointJoiner.DoIt, Last absc <<<');
                LinToProtocol(Lin);
                AbscEntToProtocol(LAE);
                LinToProtocol(OldAbsc.Line);
                CrdToProtocol(PX, PY, '');
                AbscToProtocol(NewAbsc, ' <<');
              end;
            end;
          end
        end;

        inc(J);
      end; { cyklus pes vechny star seky }
{ Kdy jen oznauji, a ne fyzicky likviduji, tak musm inc
      if not IsDeleted then
}
      inc(I);
      Application.ProcessMessages;

      if (I < LAE.Count) then
         aAbsc:= LAE.Abscissa[I]
    end; { cyklus pes vechny nov seky }
    if Gauge <> nil then Gauge.Free

  end
end;

*)



function TPointsLine.StartDist(aIndex: longInt): double;
var
  aPoint: TAbscPoint;
begin
  aPoint:= TAbscPoint(Elements[aIndex]);
  result:= Distance(StartX, StartY, aPoint.PataX, aPoint.PataY);
end;




procedure TPointsLine.AddPoint(aAbsc: TTopLinAbscissa; aBegin: boolean;
                               PataX, PataY: double);
var
  aPoint: TAbscPoint;
  aktDist: double;
  Inserted: boolean;
  I: longInt;
begin
  if aAbsc = nil then exit;
  aPoint:= TAbscPoint.Create;
  if aBegin then
  begin
    aPoint.X:= aAbsc.X1;
    aPoint.Y:= aAbsc.Y1;
  end
  else
  begin
    aPoint.X:= aAbsc.X2;
    aPoint.Y:= aAbsc.Y2;
  end;
  aPoint.PataX:= PataX;
  aPoint.PataY:= PataY;
  aPoint.Line:= aAbsc.Line;

  if count > 0 then
  begin
    aktDist:= Distance(StartX, StartY, PataX, PataY);
    Inserted:= false;
    for I:= 0 to Count-1 do
    begin
      if aktDist < StartDist(I) then
      begin
        InsertElement(I, aPoint);
        Inserted:= true;
        break
      end
    end;

    if not Inserted then
       AddElement(aPoint)
  end
  else
    AddElement(aPoint)
end;



{ Cyklus pes nov seky, porovnvan se starmi body.
  - rozdlen nov seky a jej pitaen ke starmu bodu}


procedure TNewAbscOldPointJoiner.ProcessAbsc
          (aLAE: TLinesAbscEntity; aAbsc: TTopLinAbscissa; aPoints: TPointsLine;
           var NewAbscIter: longInt);
var
  I: longInt;
  //OldAbsc,
  NewAbsc, WAbsc: TTopLinAbscissa;
  aPoint: TAbscPoint;
begin
  {!!!!!G
  if MakeProtocol(aAbsc.Line.SpaceId) then
  begin
    AddToProtocol(' ');
    AddToProtocol('>>> TNewAbscOldPointJoiner.ProcessAbsc <<<');
    LinToProtocol(aAbsc.Line);
    AbscEntToProtocol(aLAE);
    AbscToProtocol(aAbsc, ' <<');
  end;
  }
  WAbsc:= aAbsc;
  for I:= 0 to aPoints.Count-1 do
  begin
    aPoint:= TAbscPoint(aPoints.Elements[I]);
    if not (TElement(aPoint) is TAbscPoint) then exit;

    WAbsc.CreateDividedWith(aPoint.X, aPoint.Y, NewAbsc);
    NewAbsc.IsNew:= true;
    NewAbsc.IsNewEnd:= true; {je vzn na starou linii, tud plat}
    inc(NewAbscIter); { posun cyklu novch seek o vloenou seku }
    aLAE.InsertAbsc(NewAbscIter, NewAbsc);

    WAbsc:= NewAbsc;
    {!!!!!G
    if MakeProtocol(aAbsc.Line.SpaceId) then
    begin
      LinToProtocol(aPoint.Line);
      CrdToProtocol(aPoint.X, aPoint.Y,
                    'dist: ' + DoubleToStr(aPoints.StartDist(I), 9, 6));
      AbscToProtocol(NewAbsc, ' **********');
    end;
    }
  end
end;





procedure TNewAbscOldPointJoiner.DoIt;
var
  LAE: TLinesAbscEntity;
  Lin: TPolyLineElement;
  aAbsc, OldAbsc: TTopLinAbscissa;
  I, J: longInt;
  PX, PY, PataX, PataY: double;
  NearPoint, Danger: boolean;
  //IsDivided: boolean;
  //Gauge: TF_gaugeForm;
  aBool: boolean;

  Points: TPointsLine;

begin
  aBool:= false;
  Points:= nil;

  //Gauge:= nil;
  if Input is TLinesAbscEntity then
  begin
    LAE:= TLinesAbscEntity(Input);
    Lin:= LAE.Abscissa[0].Line;
    aAbsc:= LAE.Abscissa[0];
    I:= 0;
    if aBool then
       ZapisLAE('NAOPJ',LAE);

    if LAE.Count > GaugeConst then
    begin
      {
      Gauge:= TF_GaugeForm.Create(Application);
      Gauge.MaxValue:= LAE.Count;
      Gauge.Show;
      Gauge.Top:= Gauge.Top + 50;
      }
      StartProgress('Nov seky - star body',0,LAE.Count);
    end;

    while (I < LAE.Count) and (aAbsc.Line = Lin)  do
    { cyklus pes vechny nov seky }
    begin
      if {(Gauge <> nil) and }(I mod 10 = 0) then
      begin
        Progress:= I;
        ProgressText:= 'Porovnvn novch seek s body: ' + IntToStr(I);
        Application.ProcessMessages
      end;


      if SelfTest then
         J:= I+1
      else
        J:= LAE.GetLastAbscIndexForSameLine(I) + 1;

      //IsDivided:= false;

      if Points <> nil then Points.Free;
      Points:= TPointsLine.Create;

      while (J < LAE.Count) do
      begin
        Points.StartX:= aAbsc.X1;
        Points.StartY:= aAbsc.Y1;

        { cyklus pes vechny star seky }
        OldAbsc:= LAE.Abscissa[J];
        if ((J>I+1) or (OldAbsc.Line <> Lin))
           and
           aAbsc.IsOverRectangle
           (OldAbsc.Xmin, OldAbsc.Ymin, OldAbsc.Xmax, OldAbsc.Ymax, FSnapDistance) then
        begin
          aAbsc.RelationToPoint(OldAbsc, true, FSnapDistance,
                                NearPoint, Danger, PX, PY, PataX, PataY);
          if NearPoint and not Danger then
          begin
            Points.AddPoint(OldAbsc, true, PataX, PataY);
          end;

          if OldAbsc.IsLast then
          begin
            aAbsc.RelationToPoint(OldAbsc, false, FSnapDistance,
                                  NearPoint, Danger, PX, PY, PataX, PataY);
            if NearPoint and not Danger then
            begin
              Points.AddPoint(OldAbsc, false, PataX, PataY);
            end
          end
        end;

        inc(J);
      end; { cyklus pes vechny star seky }
{ Kdy jen oznauji, a ne fyzicky likviduji, tak musm inc
      if not IsDeleted then
}

      if Points.Count > 0 then
         ProcessAbsc(LAE, aAbsc, Points, I);
      Points.Free;
      Points:= nil;

      inc(I);
      Application.ProcessMessages;

      if (I < LAE.Count) then
         aAbsc:= LAE.Abscissa[I]
    end; { cyklus pes vechny nov seky }
    //if Gauge <> nil then Gauge.Free
    ProgressText := 'OK.';

  end;
  if Points <> nil then
     Points.Free;
end;




{  Cyklus pes vechny nov seky, porovnvan se starmi sekami. }
procedure TAbscAbscJoiner.DoIt;
var
  LAE: TLinesAbscEntity;
  Lin: TPolyLineElement;
  aAbsc, OldAbsc, NewAbsc: TTopLinAbscissa;
  I, J: longInt;
  IsDeleted: boolean;
  Id11, Id12, Id21, Id22: boolean;
  XP, YP: double;
  Rovnobezky, Uvnitr1, Uvnitr2: boolean;
  //Gauge: TF_gaugeForm;
  //aCislo: longInt;
{! aBlok: string;}
begin
  //Gauge:= nil;
  if Input is TLinesAbscEntity then
  begin
    LAE:= TLinesAbscEntity(Input);
    Lin:= LAE.Abscissa[0].Line;
    //aCislo:= Lin.SpaceId;
{!
    if Lin.Properties is TSpaceEntityProps then
       aBlok:= tSpaceEntityProps(Lin.properties).blockName;
}
    aAbsc:= LAE.Abscissa[0];
    I:= 0;
    //IsDeleted:= false;

    if LAE.Count > GaugeConst then
    begin
      {
      Gauge:= TF_GaugeForm.Create(Application);
      Gauge.MaxValue:= LAE.Count;
      Gauge.Show;
      Gauge.Top:= Gauge.Top + 50;
      }
      StartProgress('Nov a star seky',0,LAE.Count);
    end;

    while (I < LAE.Count) and (aAbsc.Line = Lin)  do
    { cyklus pes vechny nov body }
    begin
      if {(Gauge <> nil) and }(I mod 10 = 0) then
      begin
        Progress:= I;
        ProgressText:= 'Porovnvn novch seek s sekami: ' + IntToStr(I);
        Application.ProcessMessages
      end;

      if SelfTest then
         J:= I+1
      else
        J:= LAE.GetLastAbscIndexForSameLine(I) + 1;

      IsDeleted:= false;
      while (J < LAE.Count) and not IsDeleted do
      begin
        { cyklus pes vechny star seky }
        OldAbsc:= LAE.Abscissa[J];

        if aAbsc.IsOverRectangle
           (OldAbsc.Xmin, OldAbsc.Ymin, OldAbsc.Xmax, OldAbsc.Ymax, 0) then
        begin
          aAbsc.IdentTest(OldAbsc, Id11, Id22, Id12, Id21);

          if Id11 and Id22 or Id21 and Id12 then
          begin
            aAbsc.IsDeleted:= true;
            // PK G 30.8.2000  pamatuje si ktera usecka ji nahradi
            aAbsc.Swap := not Id11;
            // PPK 17.7.2001 dlen seek
            if Id11 then
            begin
               if aAbsc.IsFirst then
                  OldAbsc.IsNewEnd := not OldAbsc.IsFirst;
               if aAbsc.IsLast then
               begin
                  if not OldAbsc.IsLast then
                     LAE.Abscissa[J+1].IsNewEnd := true;
               end;
            end
            else // Id21
            begin
               if aAbsc.IsLast then
                  OldAbsc.IsNewEnd := not OldAbsc.IsFirst;
               if aAbsc.IsFirst then
               begin
                  if not OldAbsc.IsLast then
                     LAE.Abscissa[J+1].IsNewEnd := true;
               end;
            end;
            // end PPK 7.8.2001 dlen seek
            aAbsc.NewAbscissa := OldAbsc;
          {   LAE.DeleteAbsc(I); }
            IsDeleted:= true;
            {!!!!!!!!G
            if MakeProtocol(Lin.SpaceId) then
            begin
              AddToProtocol(' ');
              AddToProtocol('>>> TAbscAbscJoiner.DoIt, Deleted absc <<<');
              LinToProtocol(Lin);
              AbscEntToProtocol(LAE);
              LinToProtocol(OldAbsc.Line);
              AbscToProtocol(aAbsc, ' <<');
            end;
            }
          end
          else
          begin
            if Id11 then
            begin
               aAbsc.IsNewEnd:= not aAbsc.IsFirst;   // puvodne true
               OldAbsc.IsNewEnd:= not OldAbsc.IsFirst  // puvodne true
            end
            else
            if Id12 then
               aAbsc.IsNewEnd:= not aAbsc.IsFirst   // puvodne true
            else
            if Id21 then
            begin
              if ((J-I>1) or (aAbsc.Line <> OldAbsc.Line)) then
                 OldAbsc.IsNewEnd:= not OldAbsc.IsFirst  // puvodne true
            end
            else
            if Id22 then
            begin
            { nic se nedje, mlo se dt pi porovnvn zatk}
            end
            else
            begin
            { test ken }
              PrusecikUsecek
               (aAbsc.X1, aAbsc.Y1, aAbsc.X2, aAbsc.Y2,
                OldAbsc.X1, OldAbsc.Y1, OldAbsc.X2, OldAbsc.Y2,
                XP, YP, Rovnobezky, Uvnitr1, Uvnitr2);
              if Uvnitr1 and Uvnitr2 then
              begin
                aAbsc.CreateDividedWith(XP, YP, NewAbsc);
                NewAbsc.IsNewEnd:= true;
                LAE.InsertAbsc(I+1, NewAbsc);
                inc(J); { posun o nov vloenou aAbsc }
                inc(J); { vloen za J,
                          v ptm kole se touto sekou ji nechci zabvat}
                OldAbsc.CreateDividedWith(XP, YP, NewAbsc);
                NewAbsc.IsNewEnd:= true;
                LAE.InsertAbsc(J, NewAbsc);
                {!!!!!!!!!!!G
                if MakeProtocol(Lin.SpaceId) then
                begin
                  AddToProtocol(' ');
                  AddToProtocol('>>> TAbscAbscJoiner.DoIt, New absc <<<');
                  LinToProtocol(Lin);
                  CrdToProtocol(XP, YP, '');
                  AbscEntToProtocol(LAE);
                  LinToProtocol(OldAbsc.Line);
                  CrdToProtocol(XP, YP, '');
                  AbscToProtocol(NewAbsc, ' <<');
                end;
                }
              end
            end
          end
        end;

        inc(J)
      end; { cyklus pes vechny star seky }
{ Kdy jen oznauji, a ne fyzicky likviduji, tak musm inc
      if not IsDeleted then
}
         inc(I);

      if (I < LAE.Count) then
         aAbsc:= LAE.Abscissa[I]
    end; { cyklus pes vechny nov seky }

// PPK. 7.8.2001 nilovn odkaz na nahrazujc seky pokud budou zrueny
//    dje se tak a po porovnn vech seek
    aAbsc:= LAE.Abscissa[0];
    I:= 0;
    while (I < LAE.Count) and (aAbsc.Line = Lin)  do
    begin
       OldAbsc := aAbsc.NewAbscissa;
       if OldAbsc <> nil then
          if OldAbsc.IsNew and not OldAbsc.IsNewEnd then
             aAbsc.NewAbscissa := nil;
       inc(I);
       if (I < LAE.Count) then
          aAbsc:= LAE.Abscissa[I]
    end;
// PPK end
    { Vyhozen nevyuitch vloench novch bod do starch lini }
    I:= 1;
    while (I < LAE.Count)  do
    begin
    { ponechm pouze ty IsNew, kter jsou zrove IsNewEnd,
      ty co jsou pouze IsNew, byly nezvazn a nebyly potvrzeny }
      aAbsc:= LAE.GetAbsc(I);
      if aAbsc.IsNew and not aAbsc.IsNewEnd then
      begin
        LAE.DeleteAbsc(I);
      end
      else
        inc(I)
    end;
    //if Gauge <> nil then Gauge.Free
    ProgressText := 'OK.';

  end;
end;




procedure TLinComparator.DoIt;
{ Porovn novou linii se starmi liniemi v QTree a vrt ji zpracovanou
 Input: NovaLinie: TPolyLineElement
 QTree:  TQTreeTopLin
 Output: Seznam novch a mnnch lini
}
var
  CreaLQA : TCreateLinQTreeAbsc;
  CreaLAE : TCreateLinesAbscEntity;
  AddLILAE: TAddLinesIntoLinesAbscEntity;
  PPJ     : TPoinPointJoiner;
  NPOAJ   : TNewPointOldAbscJoiner;
  DZAIFL  : TDeleteZeroAbscInFirstLine;
  NAOPJ   : TNewAbscOldPointJoiner;
  AAJ     : TAbscAbscJoiner;
  Lin     : TPolyLineElement;
  //aCislo  : longInt;
begin
  if not (TElement(QTree) is TQTreeTopLin) then exit;
  if not (Input is TPolyLineElement) then exit;

  Lin:= TPolyLineElement(Input);
  //aCislo:= Lin.SpaceId;
  try
{
    FGF.Caption:= 'Vytv.AbscEnt      ' + IntToStr(Lin.Cislo);
    Application.ProcessMessages;
}
    CreaLAE:= TCreateLinesAbscEntity.Create;
    CreaLAE.Input:= Input;
    CreaLAE.DoIt;
    FLinesAbsc:= TLinesAbscEntity(CreaLAE.Output);
    CreaLAE.Free;
{
    FGF.Caption:= 'Vytv.QTreeAbsc    ' + IntToStr(Lin.Cislo);
}

{$IFDEF LAETest}
  ZapisLAE('CREALAE',FLinesAbsc);
{$ENDIF}

    CreaLQA:= TCreateLinQTreeAbsc.Create;
    CreaLQA.Input:= FLinesAbsc;
    CreaLQA.DoIt;
    FQTreeAbsc:= TQTreeTopLinAbsc(CreaLQA.Output);
    CreaLQA.Free;
{
    FGF.Caption:= 'Pid.lini do Absc' + IntToStr(Lin.Cislo);
}
    AddLILAE:=  TAddLinesIntoLinesAbscEntity.Create;
    AddLILAE.Input:= QTree;
    AddLILAE.LinesAbsc:= FLinesAbsc;
    AddLILAE.QTreeAbsc:= FQTreeAbsc;
    AddLILAE.Tolerance:= SnapDistance;
    AddLILAE.CompareOnlyDifferentSource:= CompareOnlyDifferentSource;
    AddLILAE.RefContainer:= RefContainer;
    AddLILAE.DoIt;
    FLinesAbsc:= TLinesAbscEntity(AddLILAE.Output);
    FQTreeAbsc.Free;

{$IFDEF LAETest}
  ZapisLAE('ADDLILAE',FLinesAbsc);
{$ENDIF}
    AddLILAE.Free;
{
    FGF.Caption:= 'Porov. bod       ' + IntToStr(Lin.Cislo) +
                  ' seek: ' +  IntToStr(FLinesAbsc.Count);
}
    (*!!!!G
    if MakeProtocol(Lin.SpaceId) then
    begin
      AddToProtocol(' ');
      AddToProtocol('>>> TLinComparator.DoIt,  B E G I N   <<<');
      LinToProtocol(Lin); { zpracovavana linie }
      AbscEntToProtocol(FLinesAbsc);
    end;
    *)
    if (FLinesAbsc.Count > 0) and not OnlyEnds then
    begin
      DZAIFL:= TDeleteZeroAbscInFirstLine.Create;
      DZAIFL.SnapDistance:= SnapDistance;
      DZAIFL.Input:= FLinesAbsc;
      DZAIFL.Protocol:= Protocol;
      DZAIFL.UseProtocol:= UseProtocol;
      DZAIFL.ProtocoledLine:= ProtocoledLine;
      DZAIFL.DoIt;
      DZAIFL.Free;
    end;
    (*!!!!G
    if MakeProtocol(Lin.SpaceId) then
    begin
      AddToProtocol(' ');
      AddToProtocol('>>> TLinComparator.DoIt,  DZAIFL ' + FloatToStr(SnapDistance) + '  <<<');
      LinToProtocol(Lin); { zpracovavana linie }
      AbscEntToProtocol(FLinesAbsc);
    end;
    *)
    if FLinesAbsc.Count > 0 then
    begin
      PPJ  := TPoinPointJoiner.Create;
      PPJ.Input:= FLinesAbsc;
      PPJ.SnapDistance:= SnapDistance;
      PPJ.OnlyEnds:= OnlyEnds;
      PPJ.SelfTest:= SelfTest;
      PPJ.Protocol:= Protocol;
      PPJ.UseProtocol:= UseProtocol;
      PPJ.ProtocoledLine:= ProtocoledLine;
      PPJ.DoIt;
  {$IFDEF LAETest}
    ZapisLAE('PPJ',FLinesAbsc);
  {$ENDIF}
      PPJ.Free;

      DZAIFL:= TDeleteZeroAbscInFirstLine.Create;
      DZAIFL.Input:= FLinesAbsc;
      DZAIFL.Protocol:= Protocol;
      DZAIFL.UseProtocol:= UseProtocol;
      DZAIFL.ProtocoledLine:= ProtocoledLine;
      DZAIFL.DoIt;
      DZAIFL.Free;
  {$IFDEF LAETest}
    ZapisLAE('DZAIFL',FLinesAbsc);
  {$ENDIF}
    end;

{
    FGF.Caption:= 'Porov bod a s.  ' + IntToStr(Lin.Cislo) +
                  ' seek: ' +  IntToStr(FLinesAbsc.Count);
    Application.ProcessMessages;
}
    if FLinesAbsc.Count > 0 then
    begin
      NPOAJ:= TNewPointOldAbscJoiner.Create;
      NPOAJ.Input:= FLinesAbsc;
      NPOAJ.SnapDistance:= SnapDistance;
      NPOAJ.DivideOldLine:= true;
      NPOAJ.OnlyEnds:= OnlyEnds;
      NPOAJ.SelfTest:= SelfTest;
      NPOAJ.Protocol:= Protocol;
      NPOAJ.UseProtocol:= UseProtocol;
      NPOAJ.ProtocoledLine:= ProtocoledLine;
      NPOAJ.DoIt;
      NPOAJ.Free;
  {$IFDEF LAETest}
    ZapisLAE('NPOAJ',FLinesAbsc);
  {$ENDIF}
  {
      FGF.Caption:= 'Mazn krtkch   ' + IntToStr(Lin.Cislo);
  }
      DZAIFL:= TDeleteZeroAbscInFirstLine.Create;
      DZAIFL.Input:= FLinesAbsc;
      DZAIFL.Protocol:= Protocol;
      DZAIFL.UseProtocol:= UseProtocol;
      DZAIFL.ProtocoledLine:= ProtocoledLine;
      DZAIFL.DoIt;
      DZAIFL.Free;
  {$IFDEF LAETest}
    ZapisLAE('DZAIFL',FLinesAbsc);
  {$ENDIF}
    end;


    if FLinesAbsc.Count > 0 then
    begin
      NAOPJ:= TNewAbscOldPointJoiner.Create;
      NAOPJ.Input:= FLinesAbsc;
      NAOPJ.SnapDistance:= SnapDistance;
      NAOPJ.SelfTest:= SelfTest;
      NAOPJ.Protocol:= Protocol;
      NAOPJ.UseProtocol:= UseProtocol;
      NAOPJ.ProtocoledLine:= ProtocoledLine;
      NAOPJ.DoIt;
      NAOPJ.Free;

  {$IFDEF LAETest}
    ZapisLAE('NAOPJ',FLinesAbsc);
  {$ENDIF}
// O.S. 16.3.99 Pro toto tady doposud nebylo ?
      DZAIFL:= TDeleteZeroAbscInFirstLine.Create;
      DZAIFL.Input:= FLinesAbsc;
      DZAIFL.Protocol:= Protocol;
      DZAIFL.UseProtocol:= UseProtocol;
      DZAIFL.ProtocoledLine:= ProtocoledLine;
      DZAIFL.DoIt;
      DZAIFL.Free;

  {$IFDEF LAETest}
    ZapisLAE('DZAIFL',FLinesAbsc);
  {$ENDIF}

      AAJ  := TAbscAbscJoiner.Create;
      AAJ.Input:= FLinesAbsc;
      AAJ.SelfTest:= SelfTest;
      AAJ.Protocol:= Protocol;
      AAJ.UseProtocol:= UseProtocol;
      AAJ.ProtocoledLine:= ProtocoledLine;
      AAJ.DoIt;
      AAJ.Free;

  {$IFDEF LAETest}
    ZapisLAE('AAJ',FLinesAbsc);
  {$ENDIF}
    end;

    (*!!!!!!!!G
    if FLinesAbsc.IsChanged and MakeProtocol(Lin.SpaceId) then
    begin
      AddToProtocol(' ');
      AddToProtocol('>>> TLinComparator.DoIt,   E N D   <<<');
      LinToProtocol(Lin); { zpracovavana linie }
      AbscEntToProtocol(FLinesAbsc);
      AddToProtocol(' ');
    end;
    *)
    Output:= FLinesAbsc
  except
  on E:Exception do
  {  PK 22.4.1998 !!!!!!!!!!!!!!
     ShowMessage('Chyba pi komparaci linie .' + Lin.GetPropertyStringByName('Cislo') + ': '
                 + E.Message);
  }
     AddToProtocol('Chyba pi komparaci linie .' + Lin.GetPropertyStringByName('Cislo') + ': '
                 + E.Message);

  end
end;





procedure TDivideAbscs.DoIt;
var
  I: longInt;
  LAE: TLinesAbscEntity;
  aAbsc, NewAbsc: TTopLinAbscissa;
  aDistance: double;
  Xd, Yd: double;
begin
  if input=nil then exit;
  if not (Input is TLinesAbscEntity) then exit;
  LAE:= TLinesAbscEntity(Input);

  I:= 0;
  while I < LAE.Count do
  begin
    aAbsc:= LAE.Abscissa[I];
    if aAbsc.Length > MaxOutputAbscLength then
    begin
      aDistance:= aAbsc.Length / (trunc(aAbsc.Length / MaxOutputAbscLength)+1);
      GiveAbscPointByLength(aAbsc.X1, aAbsc.Y1, aAbsc.X2, aAbsc.Y2, aDistance, RoundKoef, Xd, Yd);
      aAbsc.CreateDividedWith(Xd, Yd, NewAbsc);
      NewAbsc.IsNewEnd:= DivideLines;
      LAE.InsertAbsc(I+1, NewAbsc);
    end;
    inc(I)
  end;
end;



procedure TSaveChangedLines.DoIt;
var
  LAE: TLinesAbscEntity;
  I, LINew, { Last Index Of Absc of New Line }
  //aCislo: longInt;
  LI: longInt;
  NewLine, OrigLine: TPolyLineElement;



  function NoOfSegments(Poc, Kon: longInt): longInt;
  var
    I: longInt;
    AbsEntityEnd, AbsPhysEnd, AbsLogicalEnd: boolean;
  begin
    result:= 1;
    I:= Poc;
    while I < Kon do
    begin
      LAE.GiveEndProps(I, AbsEntityEnd, AbsPhysEnd, AbsLogicalEnd);
      if (AbsEntityEnd or AbsPhysEnd or AbsLogicalEnd) then
         inc(result);
      inc(I)
    end
  end;



  procedure GiveSegEndAndLastCoordIndex(Poc, Max: longInt;
                                        var LastAbscInd, LastCoordInd: longInt);
  { Vrt konec segmentu pro danou linii, pedpokld e Max odpovd max.
    indexu v poli seek pro danou linii. Pokud je nalezen posl. seka zrove
    posledn logicky (t.j. NewEnd nebo skuten posledn pro linii - Last) pak
    tomu odpovd i posledn index souadnice. Pokud se jedn o posledn seku
    linie v rmci seznamu seek pouze proto, e nsledujc ji byly mimo zjmov
    prostor - ili posledn prostorov - pak jako posledn index souadnice se vrt
    skuten posledn index linie }
  var
    I: longInt;
    AbsEntityEnd, AbsPhysEnd, AbsLogicalEnd: boolean;
    //aAbsc: TTopLinAbscissa;
  begin
    LastAbscInd:= 0;
    I:= Poc;
    AbsEntityEnd:= false; AbsPhysEnd:= false; AbsLogicalEnd:= false;
    while (I<=Max) and not (AbsEntityEnd or AbsPhysEnd or AbsLogicalEnd) do
    begin
      LAE.GiveEndProps(I, AbsEntityEnd, AbsPhysEnd, AbsLogicalEnd);
      if not (AbsEntityEnd or AbsPhysEnd or AbsLogicalEnd) then
         inc(I)
    end;

    if AbsPhysEnd or AbsLogicalEnd then
    begin
        LastAbscInd:= I;
        LastCoordInd:= LAE.Abscissa[I].Index + 1
    end
    else
    begin
      LastAbscInd:= Max;
      LastCoordInd:= LAE.Abscissa[Max].Line.Count-1 { posledn index linie}
    end
  end;


  function ChangedLine(Poc, Kon: longInt): boolean;
  var
    I: longInt;
    aAbsc: TTopLinAbscissa;
  begin
    result:= false;
    I:= Poc;
    while (I<=Kon) and not result do
    begin
      aAbsc:= LAE.Abscissa[I];
      result:= aAbsc.IsNew or aAbsc.IsNewEnd or aAbsc.IsDeleted;
      if not result then
         inc(I);
    end;
  end;



  procedure SaveSegments(Poc, Kon: longInt);
  var
    SegFirstAbsc, SegLastAbsc, { index prvn a posledn seky pro segment }
    //OrigLastAbsc,              { index posledn seky pvodn linie }
    FirstCoord, LastCoord: longInt; { indexy souadnic  linii }
    OrigLine, NewLine,LastLine: TPolyLineElement;
    Coord: TCoordinate;
    I: longInt;
    Absc: TTopLinAbscissa;
  begin
{ Vyjmut originln linie a nalezen prvnho segmentu }

    OrigLine:= LAE.GetLine(Poc);
    //I:= OrigLine.SpaceId;
    FirstCoord:= 0;
    SegFirstAbsc:= Poc;
    LastLine := nil;
    while SegFirstAbsc <= Kon do
    begin
      GiveSegEndAndLastCoordIndex(SegFirstAbsc, Kon, SegLastAbsc, LastCoord);
      if not Lae.Abscissa[SegFirstAbsc].IsDeleted then
      begin
      { Kopie linie }

        NewLine:= TPolyLineElement.Create;

        NewLine.Assign(OrigLine);
        {!!!!!!!!G
        if MakeProtocol(OrigLine.SpaceId) then
           LinToProtocol(NewLine);
         }
        NewLine.IsDone:= OrigLine.IsDone;

        for I:= FirstCoord to LastCoord do
        begin
          Coord:= TCoordinate(OrigLine.Elements[I]);
          if not (TElement(Coord) is TCoordinate) then continue;
          NewLine.AddElement(Coord.CreateDuplicate);
          {!!!!!!!G
          if MakeProtocol(OrigLine.SpaceId) then
             CrdToProtocol(Coord.X, Coord.Y, '');
          }
        end;

        if NewLine.Length > MinLength then
        begin
          // PK TEST !!!!!!!!!!!!!!
          //NewLine.Name := 'New '+OrigLine.Name;
          NewLine.RecalculateRect;
          NewLine.CalculateLabelProps;
          OrigLine.Angle := 0;
          OrigLine.PostMsgToOwners(tm_DivideGeometry, NewLine, DontKill);

          Application.ProcessMessages;
          QTree.Add(NewLine);
          // PK G 30.8.2000
          for i := SegFirstAbsc to SegLastAbsc do
          begin
             Lae.Abscissa[i].Line := NewLine;
            // PK TEST !!!!!!!!!!!!!!
            //Lae.Abscissa[i].Name := NewLine.Name;
          end;
        end
        else
        begin
          {!!!!!!!G
          if MakeProtocol(OrigLine.SpaceId) then
             AddToProtocol(' Pli krtk linie ' + DoubleToStr(NewLine.Length, 10,4));
          }
          NewLine.Free
        end;
        {!!!!!!!G
        if MakeProtocol(OrigLine.SpaceId) then
           AddToProtocol('**************************************');
         }
      end
      else
      begin
         Absc := Lae.Abscissa[SegFirstAbsc];
         if Absc.NewAbscissa <> nil then
         begin
            try
            if Absc.NewAbscissa.Line <> LastLine then
            begin
               LastLine := Absc.NewAbscissa.Line;
               if Absc.Swap then
                  OrigLine.Angle := 1
               else
                  OrigLine.Angle := 0;
               OrigLine.PostMsgToOwners(tm_DivideGeometry, LastLine, DontKill);
               Application.ProcessMessages;
            end;
            except
               ShowMessage('hopla!');
            end;
         end;
      end;
      FirstCoord:= LastCoord;
      SegFirstAbsc:= SegLastAbsc + 1;
    end;

  end;


begin
{  if not (NewLines is TPolyLineString) then exit; }
  if not (TElement(QTree) is TQTreeTopLin) then exit;
  if not (Input is TlinesAbscEntity) then exit;

  try
    LAE:= TLinesAbscEntity(Input);
    LINew:= LAE.GetLastAbscIndexForSameLine(0);

    I:= LINew+1;
    { cyklus uschovvn zmnnch starch lini }
    while I < LAE.Count do
    begin
      LI:= LAE.GetLastAbscIndexForSameLine(I);
      OrigLine:= LAE.GetLine(I);
//      if OrigLine.Length < 0.01 then
//         ShowMessage(IntToStr(OrigLine.SpaceId) + ', ' + floatToStr(OrigLine.Length));

      if ChangedLine(I, Li) then
      begin
        if NoOfSegments(I, Li) > 1 then
        begin
          SaveSegments(I, Li);

          OrigLine.Free
        end
        {
        else
          nen poteba nkam extra zapisovat, leda e by zmna byla tak velk
          aby to mlo vliv na QTree. Avak to by zde vzhledem k mezi pipojen
          nemlo hrozit }
      end;
      I:= LI+1
    end;

    NewLine:= LAE.GetLine(0);
{!!}    //aCislo:= NewLine.SpaceId;

//    if NewLine.Length < 0.01 then
//       ShowMessage(IntToStr(aCislo) + ', ' + floatToStr(NewLine.Length));

    if ChangedLine(0, LINew) then
    begin
      if NoOfSegments(0, LINew) > 0 then
      { nov linie je rozpadl na segmenty }
      begin
        SaveSegments(0, LINew);
        {!!!!!!G
        if MakeProtocol(NewLine.SpaceId) then
        begin
           LinToProtocol(NewLine);
           AddToProtocol('*******************  Uloeny segmenty nov linie **************');
        end;
        }
        NewLine.Free;
      end
{ je zmnn ale v kuse
      else
      begin
        NewLine.CalculateLabelProps;
        NewLine.RecalculateRect;
        QTree.Add(NewLine);
      end;
}
    end
    else
    begin
      if (NewLine.Count > 1) and (NewLine.Length > MinLength) then
      begin
        {!!!!!!!!!G
        if MakeProtocol(NewLine.SpaceId) then
        begin
          LinToProtocol(NewLine);
          AddToProtocol('**************** Uloena kompletn linie ****************');
        end;
        }
        QTree.Add(NewLine);

{        NewLines.AddAndUpdateRect(OriginLine) }
      end
    end;


  except
    on E: Exception do
       ShowMessage('Chyba pi ukldn linie . ' +
                   IntToStr(LAE.abscissa[0].lineno) + ' : ' + E.Message)
  end
end;




procedure TestLinJoiner.Process(Element: TElement);
{ Penos z jedn struktury do druh:
  Natat linie z QTree a ukldat je do druh struktury
  Input   : QTree lini
  Praktick loha: do jedn struktury vkldat nco z jin struktury
  Vody - Cesty - chpat je jako QTree }
var
  Lin: TPolyLineElement;
  LC: TLinComparator;
  LAE: TLinesAbscEntity;
  SCL: TSaveChangedLines;
  NewLin: TPolyLineElement;
begin
  if (Element is TPolyLineElement) and not (TPolyLineElement(Element).IsDone) then
  begin
    Lin:= TPolyLineElement(Element);
    Lin.IsDone:= true;

    NewLin:= TPolyLineElement.Create;
    NewLin.Assign(Lin);
    NewLin.GetElements(Lin, 0, Lin.Count-1);

    inc(FPocetLinii);
    GaugeSet(FPocetLinii);

{$IFDEF TestProtocol}
    ProtocolName:= IntToStrZ(FPocetLinii, 4, true) +
                   IntToStrZ(TPolyLineElement(Element).Cislo,4,true) + '.PTC';
    Uroven:= 0;
{$ENDIF}

    LC:= TLinComparator.Create;
    LC.Input:= NewLin;
    LC.QTree:= FQTree;
    LC.SnapDistance:= 5;
    LC.DoIt;
    LAE:= TLinesAbscEntity(LC.Output);
    LC.Free;

    if (LAE.Count > 0) and (LAE.GetLine(0) = NewLin) then
    { Jestli vbec nco z nov linie zbylo }
    begin
      SCL:= TSaveChangedLines.Create;
      SCL.Input:= LAE;
      SCL.QTree:= FQTree;
{      SCL.NewLines:= FLinesContainer; }
      SCL.MinLength:= 5;
      SCL.DoIt;
      SCL.Free;
    end;
    if LAE <> nil then
       LAE.Free;
{
    NewLin.Clear;
    NewLin.Free;
}
{
    FQTree.Add(Lin);
    FLinesContainer.AddAndUpdateRect(Lin);
}
  end
end;


procedure TestLinJoiner.DoIt;
begin
  if Input is TEntity then
  begin
    FLinesContainer:= TPolyLineString.Create;
    TEntity(Input).AddElement(FLinesContainer);
    FLinesContainer.Name:= 'Nov linie';
    inherited DoIt
  end
end;



procedure TJoinLines.SetProtocol(aName: string);
var
  F: system.Text;
begin
  FProtocol:= aName;
  system.assign(F, FProtocol);
 {$I-} system.rewrite(F);
       system.close(F)
 {$I+}
end;


procedure TJoinLines.Process(Element: TElement);
{ Penos z jedn struktury do druh:
  Natat linie z QTree a ukldat je do druh struktury
  Input   : QTree lini
  Praktick loha: do jedn struktury vkldat nco z jin struktury
  Vody - Cesty - chpat je jako QTree }
var
  Lin: TPolyLineElement;
  LC: TLinComparator;
  LAE: TLinesAbscEntity;
  SCL: TSaveChangedLines;
  DivAbsc: TDivideAbscs;
  RGE: TRegisteredGeometryElement;
begin
  Lin:= TPolyLineElement(Element);

  if Lin.Length <= MinLength then
     exit;

  Lin.IsDone:= true;
{$IFDEF TestProtocol}
  ProtocolName:= IntToStrZ(FPocetLinii, 4, true) +
                 IntToStrZ(TPolyLineElement(Element).Cislo,4,true) + '.PTC';
  Uroven:= 0;
{$ENDIF}

  LC:= TLinComparator.Create;
  LC.Input:= Lin;
  LC.QTree:= FQTree;
  LC.SnapDistance:= SnapDistance;
  LC.OnlyEnds:= OnlyEnds;
  LC.SelfTest:= SelfTest;
  LC.CompareOnlyDifferentSource:= CompareOnlyDifferentSource;

{!!!!!!!!!!!!G
  if Lin.Properties is TSpaceEntityProps then
     LC.RefContainer:= TSpaceEntityProps(Lin.Properties).ObjectRegister
  else
     LC.RefContainer:= nil;
}
  RGE := TRegisteredGeometryElement(Lin.FindOwnerClass(TRegisteredGeometryElement));
  if RGE <> nil then
     LC.RefContainer := RGE.ObjectRegister
  else
     LC.RefContainer:= nil;

  LC.Protocol:= Protocol;
  LC.UseProtocol:= UseProtocol;
  LC.ProtocoledLine:= ProtocoledLine;
  LC.DoIt;
  LAE:= TLinesAbscEntity(LC.Output);
  LC.Free;

  if (LAE.Count > 0) and (LAE.GetLine(0) = Lin) then
 { Jestli vbec nco z nov linie zbylo }
  begin
    if MaxOutputAbscLength > 0 then
    begin
      DivAbsc:= TDivideAbscs.Create;
      DivAbsc.MaxOutputAbscLength:= MaxOutputAbscLength;
      DivAbsc.RoundKoef:= RoundKoef;
      DivAbsc.DivideLines:= DivideOutputLines;
      DivAbsc.Input:= LAE;
      DivAbsc.DoIt;
      DivAbsc.Free;
    end;


    SCL:= TSaveChangedLines.Create;
    SCL.Input:= LAE;
    SCL.QTree:= FQTree;
{    SCL.NewLines:= FLinesContainer; }
    SCL.MinLength:= MinLength;
    SCL.SetLinesLabelPoint:= PrepocitavatPopBodyLinii;
    SCL.Protocol:= Protocol;
    SCL.UseProtocol:= UseProtocol;
    SCL.ProtocoledLine:= ProtocoledLine;
    SCL.DoIt;
    SCL.Free;
  end;
end;




procedure TJoinLines.DoIt;
{ vstup - entita zpracovvanch lini
  vstup - TQTreeTopLin lini }

var
  //FGF: TF_GaugeForm;
  Vstup: TRectEntity;
  aNo: longInt;
  I: longInt;
  //J: longInt;
  Lin: TPolyLineElement;
  //aCislo: longInt;
  aSpaceNumber: integer;
  Prochazec: TOznacLinie;
  RGE: TRegisteredGeometryElement;
  E: TElement;
begin
{ input: linie uschovan v hierarchii }
  if not (Input is TRectEntity) then exit;
try
  Vstup:= TRectEntity(Input);

  Prochazec:= TOznacLinie.Create;
  Prochazec.Input:= Input;
  Prochazec.DoIt;
  Prochazec.Free;

  FQTree:= TQTreeTopLin.Create;
{  FLinesContainer:= TPolyLineString.Create; }

  FQTree.SetForRectangle(Vstup.minX, Vstup.minY, Vstup.maxX, Vstup.maxY);
  // PPK 11.07.2001
  // linie u zpracovan, nebudou se spojovat, jen se vlo do QTREE
  if FixedLines <> nil then
  begin
     {
     Prochazec:= TOznacLinie.Create;
     Prochazec.Input:= FixedLines;
     Prochazec.DoIt;
     Prochazec.Free;
     }
     for i := 0 to FixedLines.LastIndex do
     begin
        E := FixedLines.Elements[i];
        if not (E is TPolyLineElement) then continue;
        TPolyLineElement(E).IsDone := true;
        FQTree.Add(E);
     end;
  end;
  // PPK 11.07.2001

  //J:= 0;
  {
  FGF:= TF_GaugeForm.Create(Application);
  FGF.Caption:= '';
  }
  if Vstup.Count > 100 then
  begin
     StartProgress('Spojovn lini',0,Vstup.Count-1);
  end;

  aNo:= Vstup.Count;

  for I:= aNo-1 downTo 0 do
  begin
    {
    if FGF.DoCloseQuery and FGF.RealyClose('Peruit zpracovn lini ?') then
       break;
    }
    Lin:= TPolyLineElement(Vstup.Elements[I]);
    if not (TElement(Lin) is TPolyLineElement) then continue;
    RGE := TRegisteredGeometryElement(Lin.FindOwnerClass(TRegisteredGeometryElement));
    if RGE <> nil then
       aSpacenumber := RGE.SpaceID
    else
       aSpaceNumber := i;
       //aSpaceNumber := -1;
    // PK TEST !!!!!!!!!!!!!
    //Lin.Name := IntToStr(aSpaceNumber);
    //aCislo:= Lin.SpaceId;

    if Lin.Count > 100 then
       ProgressText:= 'Lin '+IntToStr(i)+' crds: ' +
                     IntToStrZ(Lin.Count, 3, false) + ': ' +
                     DoubleToStr(Lin.Length, 6, 2)+' m'
    else
       ProgressText:= 'Lin '+IntToStr(i);
    Progress:= aNo-I-1;
    Application.ProcessMessages;

    if Lin.IsDone then continue;
    Process(Lin);
  end;
  ProgressText := 'OK.';
  //FGF.Free;
  Output:= FQTree;
except
   on E:Exception do
      ShowMessage(E.Message);
end;

end;




(*
constructor TJoinLinesFromBlockToBlock.Create;
begin
  inherited Create;
  FSourceBlockDir:= 'c:\TMP\Vstup.blk';
  FTargetBlockDir:= 'c:\TMP\Vystup.blk';
end;


procedure TJoinLinesFromBlockToBlock.DoIt;
var
  FGF: TF_GaugeForm;
  DrzakQTree: TEntity;
  RBL: TReadBlokLines;
  I, J: longInt;
  Lin: TPolyLineElement;

  Xmin, Ymin, Xmax, Ymax: double;

  OL: TOznacLinie;

  NLDQ: TReadLinesIntoQTree;
  QTree: TSpaceLineBegEndCell;
  PNIQ: TPutNodesIntoQTree;
  ZPVNL: TDeleteDirectRelationsToLinesInQTree;
  NC: TNodesConector;

begin
try
{  FSourceBlockDir:= 'g:\gis\l1\_2ces.blk'; }
{  FSourceBlockDir:= 'c:\0\mezna\det.blk'; }
{  FSourceBlockDir:= 'c:\0\mezna\6l.blk'; }
{  FSourceBlockDir:= 'c:\orbis\spoj.blk'; }
  if FSourceBlockDir = '' then
     FSourceBlockDir:= 'c:\TMP\Vstup.blk';
  DrzakQTree:= TEntity(Input);

  if not (DrzakQTree is TEntity) then exit;
  FQTree:= TQTreeTopLin.Create;
  DrzakQTree.AddElement(FQTree);
{  FLinesContainer:= TPolyLineString.Create; }
{ DrzakQTree.AddElement(FLinesContainer); }
{  FLinesContainer.Name:= 'Nov linie'; }

  RBL:= TReadBlokLines.CreateBlock(FSourceBlockDir);
  RBL.GiveRectangle(Xmin, Ymin, Xmax, Ymax);
  FQTree.SetForRectangle(Xmin, Ymin, Xmax, Ymax);
  J:= 0;

  FDF:= TF_GaugeForm.Create(Application);
  FGF.Caption:= '';
  FGF.MaxValue:= RBL.Size-1;
  FGF.Show;
  Screen.Cursor:= crHourGlass;

  for I:= 1 to RBL.Size-1 do
  begin
    FGF.Progress:= I;
    FGF.Caption:= '                  ' + IntToStr(I);
    Application.ProcessMessages;

    Lin:= RBL.GetLine(I);
    if Lin <> nil then
    begin
      Process(Lin);
{ V tomto ppad by to vyhodilo i z registru
      Lin.Clear;
      Lin.Free
}
    end
  end;


  FGF.Free;
  Screen.Cursor:= crDefault;

  RBL.Free;


{
  NLDQ:= TNacitacLiniiDoQTree.Create;
  NLDQ.Input:= FLinesContainer;
  NLDQ.DoIt;
  QTree:= TSpaceLineBegEndCell(NLDQ.Output);
  NLDQ.Free;

  PNIQ:= TPutNodesIntoQTree.Create;
  PNIQ.Input:= QTree;
  PNIQ.DoIt;
  PNIQ.Free;

  ZPVNL:= TDeleteDirectRelationsToLinesInQTree.Create;
  ZPVNL.Input:= QTree;
  ZPVNL.DoIt;
  ZPVNL.Free;

  NC:= TNodesConector.Create;
  NC.Input:= QTree;
  NC.DoIt;
  NC.Free;

  OL:= TOznacLinie.Create;
  OL.Input:= FLinesContainer;
  OL.DoIt;
  OL.Free;



  NE:= TNodesExportDBFLines.Create;

  NE.FWCS:= TWCSWorld(World).GetIDWCS(cs_JTSK);
  if FTargetBlockDir = '' then
     FTargetBlockDir:= 'C:\TMP\VYSTUP.BLK';
  NE.FBlockDirectory:= FTargetBlockDir;
  NE.Input:= QTree;
  NE.DoIt;
  NE.Free;




  QTree.Free;
  FLinesContainer.Free;
    FQTree.Free;
}
except
   on E:Exception do
      ShowMessage(E.Message);
end;
end;

*)


procedure TJoinLines.SetFixedLines(const Value: TEntity);
begin
  FFixedLines := Value;
end;

initialization
  RegisterOrbisClass(TJoinLines);
//  RegisterOrbisClass(TJoinLinesFromBlockToBlock);
end.
