unit d_Tablet;
// Prost sem to ukrad z TopoLu, ne to pedlm ... u nemm slu
interface
uses
   Elements,
   e_SerialPort,
   u_xestring;

type
  TByteBit = packed record
               Byte, Bit: byte
             end;

  TFiltrByte = packed record
                 Filtr, CBytu: byte
               end;

  TBinarniSouradnice = packed record
                         PrvniX, PrvniY, PocetBytuSour, PocetBituSour: byte;
                         NizsiPakVyssi: boolean;
                         Filtr1BytuSouradnice, FiltrPBytuSouradnice: byte;
                         ZnamenkoX, ZnamenkoY: TFiltrByte;
                         Zaporne1: boolean     { zaporne znamenko znaceno 1 }
                       end;

TTabletActionProcedure = procedure(aX,aY:double; Button: integer; ButtonChanged: boolean) of object;

TTablet = class(TSerialPort)
private
   Xprvni, Xza, Yprvni, Yza: integer;  { umisteni znaku sour.X a Y }
   Bprvni, Bza             : integer;  { umisteni znaku tlacitka }
   JednoZnakoveTlacitko    : boolean;
   DelkaVystupnihoRetezce  : integer;


   ZnakTl1,   ZnakTl2,  ZnakTl3,  ZnakTl4, ZnakTl5, ZnakTl6: char;

   OznaceniTl1, OznaceniTl2, OznaceniTl3, OznaceniTl4,
   OznaceniTl5, OznaceniTl6: string;

   LDX, LDY, PDX, PDY, PHX, PHY: longInt;

   KanalStr, InitStr, FormatStr, PromptStr: string;

   BinarniFormat: boolean;
   OdlisovaciBit: byte;
   ProximityBit : byte;
   FiltrTlacitek: TFiltrByte;

   BinarniSouradnice: TBinarniSouradnice;
    FConfigFile: string;
    FTextWord: string;
    FBinaryWord: string;
    FOldWord: string;
    FProcessing: boolean;
    FOldY: double;
    FOldX: double;
    FOldButton: integer;
    FMoveTolerance: integer;
    FonTabletAction: TTabletActionProcedure;
    procedure SetConfigFile(const Value: string);
    procedure SetProcessing(const Value: boolean);
    procedure SetMoveTolerance(const Value: integer);
    procedure SetonTabletAction(const Value: TTabletActionProcedure);
protected
    procedure SetActive(NewState : Boolean); override;
    procedure SendInitStr;
    procedure GetBinaryXY(var aX, aY: double; var ButtonNumber: integer; var Proximity: boolean);
    property  BinaryWord: string read FBinaryWord write FBinaryWord;
    property  TextWord: string read FTextWord write FTextWord ;
    property  OldWord: string read FOldWord write FOldWord ;
    property  OldX: double read FOldX write FOldX;
    property  OldY: double read FOldY write FOldY;
    property  OldButton: integer read FOldButton write FOldButton;
    property  Processing: boolean read FProcessing write SetProcessing;
public
   function ReadConfigFile: boolean;
   procedure ProcessBinaryWord;
   procedure ProcessTextWord;
   procedure OnDataReceived(Sender: TObject); override;
   property  onTabletAction: TTabletActionProcedure read FonTabletAction write SetonTabletAction;
published
   property  ConfigFile: string read FConfigFile write SetConfigFile;
   property  MoveTolerance: integer read FMoveTolerance write SetMoveTolerance;
end;

implementation
uses
   Classes,
   Dialogs,
   Forms,
   SysUtils,
   Windows,
   e_Class,
   m_Orbis,
   CtiRadek,
   u_String;

{ TTablet }

function FiltrovanyByte(Slovo: _xstring; FiltrByte: TFiltrByte): byte;
begin
  result:= byte(Slovo[FiltrByte.CBytu]) and FiltrByte.Filtr
end;


procedure FiltrujSlovo(var Slovo: _xstring; CBytu, Filtr: byte);
begin
  byte(Slovo[CBytu]):= byte(Slovo[CBytu]) and Filtr
end;


procedure TTablet.GetBinaryXY(var aX, aY: double;var ButtonNumber: integer; var Proximity: boolean);
var
  Pom: byte;
  I: integer;
  MinusX, MinusY: boolean;
  XL, YL: longInt;
  ButtonFilter: TFiltrByte;
  BinaryCoord: TBinarniSouradnice;
  Slovo: _xstring;
begin
  MinusX:= false;
  MinusY:= false;
  ButtonFilter := FiltrTlacitek;
  BinaryCoord := BinarniSouradnice;
  Pom:= byte(BinaryWord[1]);
  Proximity:= Pom and ProximityBit = 0;
  if ButtonFilter.CBytu > 0 then
  begin
    ButtonNumber:= byte(BinaryWord[ButtonFilter.CBytu]) and ButtonFilter.Filtr;

    while (ButtonFilter.Filtr and 1) = 0 do
    begin
      ButtonFilter.Filtr:= ButtonFilter.Filtr shr 1;
      ButtonNumber := ButtonNumber shr 1
    end
  end
  else ButtonNumber := 0;

  XL:= 0;
  YL:= 0;
  Slovo := BinaryWord;
  with BinaryCoord do
  if PrvniX > 0 then
  begin
  { Zjistovani znaminek }
    if (ZnamenkoX.CBytu > 0) then
      MinusX:= FiltrovanyByte(Slovo, ZnamenkoX) <> 0;

    if (ZnamenkoY.CBytu > 0) then
      MinusY:= FiltrovanyByte(Slovo, ZnamenkoY) <> 0;

    if not Zaporne1 then
    begin
      MinusX:= not MinusX;
      MinusY:= not MinusY
    end;

  { Filtrovani souradnic }
    if Filtr1BytuSouradnice > 0 then
    begin
      FiltrujSlovo(Slovo, PrvniX, Filtr1BytuSouradnice);
      FiltrujSlovo(Slovo, PrvniY, Filtr1BytuSouradnice)
    end;

    if FiltrPBytuSouradnice > 0 then
    begin
      FiltrujSlovo(Slovo, PrvniX + PocetBytuSour-1, FiltrPBytuSouradnice);
      FiltrujSlovo(Slovo, PrvniY + PocetBytuSour-1, FiltrPBytuSouradnice)
    end;

  { Zjistovani vlastnich souradnic }
    if NizsiPakVyssi then
    begin
      for I:= PrvniX + PocetBytuSour -1 downTo PrvniX do
        XL:= (XL shl PocetBituSour) + ord(Slovo[I]);

      for I:= PrvniY + PocetBytuSour -1 downTo PrvniY do
        YL:= (YL shl PocetBituSour) + ord(Slovo[I]);
    end

    else
    begin
      for I:= PrvniX to PrvniX + PocetBytuSour -1 do
        XL:= (XL shl PocetBituSour) + ord(Slovo[I]);

      for I:= PrvniY to PrvniY + PocetBytuSour -1 do
        YL:= (YL shl PocetBituSour) + ord(Slovo[I])
    end;

  end;

  if MinusX then aX:= -XL
  else aX:= XL;

  if MinusY then aY:= -YL
  else aY:= YL

end;


procedure TTablet.OnDataReceived(Sender: TObject);
var
   S: string;
   LS: integer;
   i: integer;
begin
   if Processing then
   begin
      BinaryWord := '';
      TextWord := '';
      exit;
   end;
   Processing := true;

   if NextClusterSize >= 0 then // Data available?
   begin
      if NextClusterCCError = 0 then // Error during receiveing?
      begin
         S := ReadNextClusterAsString;
      end
      else
      begin
         S := ReadNextClusterAsString;
         Processing := false;
         Exit;
      end;
       // Read the data and patch them into the editfield
   end
   else
   begin
      Processing := false;
      exit;
   end;

   //S := aMessage.Text;
   i := 1;
   if BinarniFormat then
   begin
      BinaryWord := '';
      while (i <= length(S)) and ((ord(S[i]) and OdlisovaciBit) = 0) do inc(i);
      if i > length(S) then
      begin
         Processing := false;
         exit;
      end;
      while (i <= length(S)) do
      begin
         BinaryWord := BinaryWord + S[i];
         inc(i);
         if i > length(S) then
         begin
            Processing := false;
            exit;
         end;
         while ((ord(S[i]) and OdlisovaciBit) = 0) do
         begin
            BinaryWord := BinaryWord + S[i];
            inc(i);
            if i > length(S) then
            begin
               Processing := false;
               exit; // pokraovn pt
            end;
         end;
         //Slovo naplnno ... jdem ho zpracovat;
         if BinaryWord <> OldWord then
         begin
            ProcessBinaryWord;
            OldWord := BinaryWord;
         end;
         BinaryWord := '';
      end;
   end
   else // text
   begin
      LS := Length(S);
      while (i <= LS) do
      begin
         //TextWord := '';
         while (i <= LS) and (S[i] in [#13,#10]) do inc(i);
         if i > LS then
         begin
            Processing := false;
            exit;
         end;
         while not (S[i] in [#13,#10]) do
         begin
            TextWord := TextWord + S[i];
            inc(i);
            if i > length(S) then
            begin
               Processing := false;
               exit; // pokraovn pt
            end;
         end;
         //Slovo naplnno ... jdem ho zpracovat;
         if length(TextWord) = DelkaVystupnihoRetezce then
         if TextWord <> OldWord then
         begin
            ProcessTextWord;
            OldWord := TextWord;
         end;
         TextWord := '';
      end;
   end;
   Processing := false;
end;


procedure TTablet.ProcessBinaryWord;
var
   aX,aY: double;
   ButN: integer;
   ButCh: boolean;
   Prox: boolean;
   T: double;
begin
   GetBinaryXY(aX,aY,ButN,Prox);
   T := MoveTolerance;
   ButCh := ButN <> OldButton;
   if (Abs(aX - OldX) > T) or (Abs(aY - OldY) > T) or ButCh then
   begin
      OldX := aX;
      OldY := aY;
      OldButton := ButN;
      if Assigned(FOnTabletAction) then
         OnTabletAction(aX,aY,ButN,ButCh);
      //PostTextMsg(tm_AddToProtocol,'T:'+IntToStr(ButN)+' x:'+FloatToStr(aX)+' y:'+FloatToStr(aY),nil);
      //Application.ProcessMessages;
   end;
end;

procedure TTablet.ProcessTextWord;
var
   aX,aY: double;
   ButN: integer;
   ButCh:  boolean;
   Prox: boolean;
   Code: integer;
   T: double;
begin
   val(copy(TextWord, Xprvni, Xza-Xprvni), aX, Code);
   if Code = 0 then
      val(copy(TextWord, Yprvni, Yza-Yprvni), aY, Code);
   if Code = 0 then
   begin
     if JednoznakoveTlacitko then
     begin
        val((TextWord[Bprvni]),ButN,Code);
       if Code <> 0 then
          ButN := 0;
     end
     else
     begin
       val(copy(TextWord, Bprvni, Bza-Bprvni), ButN, Code);
       if Code <> 0 then
          ButN := 0;
     end;
   end;
   T := MoveTolerance;
   ButCh := ButN <> OldButton;
   if (Abs(aX - OldX) > T) or (Abs(aY - OldY) > T) or ButCh then
   begin
      OldX := aX;
      OldY := aY;
      OldButton := ButN;
      if Assigned(FonTabletAction) then
         OnTabletAction(aX,aY,ButN,ButCh);
      //PostTextMsg(tm_AddToProtocol,'T:'+IntToStr(ButN)+' x:'+FloatToStr(aX)+' y:'+FloatToStr(aY),nil);
      //Application.ProcessMessages;
   end;
end;

function TTablet.ReadConfigFile: boolean;
var
  Radek: TCtiRadekClass;
  List: TStringList;
  Pom: string;
  Znak: char;
  CRadku: integer;
  PomS: string;
  PomInt: integer;
  PomCh: char;
  aBool: boolean;

  function DejStringZRadku: string;
  begin
     Pom := List.Strings[CRadku];
     Inc(CRadku);
     Radek := TCtiRadekClass.Create(Pom);
     Znak := Radek.DejChar;
     result := Radek.DejStringPoZnak(#39); {'}
     Radek.Free;
  end;

  function DejByteZe3Cisel(C1, C2, C3: char): byte;
  var
    Pom, Code: integer;
  begin
    val(C3+C2+C1, Pom, Code);
    if Code = 0 then
       result:= Pom
    else
       result:= 0
  end;

  function DejFormatZRadku(var Binarne: boolean): string;
  begin
    Binarne:= false;
    Pom := List.Strings[CRadku];
    Inc(CRadku);
    Radek := TCtiRadekClass.Create(Pom);
    Znak:= Radek.DejChar;

    if upCase(Znak) = 'B' then
    with Radek do
    begin
      Binarne:= true;

      OdlisovaciBit:= DejByteZe3Cisel(DejChar, DejChar, DejChar);

      if DosloKChybe or (OdlisovaciBit = 0) then
         OdlisovaciBit:= 64;

      Znak:= DejChar;
      if (upCase(Znak) = 'P') and not DosloKChybe then
         ProximityBit:= DejByteZe3Cisel(DejChar, DejChar, DejChar)
      else ProximityBit:= 0;

      Znak:= DejChar;
      if (upCase(Znak) = 'T') and not DosloKChybe then
      begin
        FiltrTlacitek.CBytu:= ord(DejChar)-ord('0');
        FiltrTlacitek.Filtr:= DejByteZe3Cisel(DejChar, DejChar, DejChar);
      end
      else FiltrTlacitek.CBytu:= 0;

      Znak:= DejChar;
      if (upCase(Znak) = 'S') and not DosloKChybe then
      with BinarniSouradnice do
      begin
        PrvniX:= ord(DejChar)-ord('0');
        PrvniY:= ord(DejChar)-ord('0');
        PocetBytuSour:= ord(DejChar)-ord('0');
        PocetBituSour:= ord(DejChar)-ord('0');
        NizsiPakVyssi:= upCase(DejChar) = 'A';
      end
      else
      begin
        BinarniSouradnice.PrvniX:= 0;
      end;

      Znak:= DejChar;


      if (upCase(Znak) = 'F') and not DosloKChybe  then
      with BinarniSouradnice do
      begin
        Filtr1BytuSouradnice:= DejByteZe3Cisel(DejChar, DejChar, DejChar);
        FiltrPBytuSouradnice:= DejByteZe3Cisel(DejChar, DejChar, DejChar);

        Znak:= DejChar;
      end
      else
      begin
        BinarniSouradnice.Filtr1BytuSouradnice:= 0;
        BinarniSouradnice.FiltrPBytuSouradnice:= 0;
      end;

      if (upCase(Znak) = 'Z') and not DosloKChybe then
      with BinarniSouradnice do
      begin
        ZnamenkoX.CBytu:= ord(DejChar)-ord('0');
        ZnamenkoX.Filtr:= DejByteZe3Cisel(DejChar, DejChar, DejChar);

        ZnamenkoY.CBytu:= ord(DejChar)-ord('0');
        ZnamenkoY.Filtr:= DejByteZe3Cisel(DejChar, DejChar, DejChar);

        Zaporne1:= upCase(DejChar) = 'A'
      end
      else
      begin
        BinarniSouradnice.ZnamenkoX.CBytu:= 0;
        BinarniSouradnice.ZnamenkoY.CBytu:= 0;
        BinarniSouradnice.Zaporne1:= true
      end
    end;

    result := Radek.DejStringPoZnak(#39); {'}

    Radek.Free;
  end;

  function DejIntegerZRadku: integer;
  begin
    Pom := List.Strings[CRadku];
    Inc(CRadku);
    Radek := TCtiRadekClass.Create(Pom);
    result := Radek.DejInteger;
    Radek.Free;
  end;


  procedure DejZnakAOznaceni(var ZnakTlacitka: char; var Oznaceni: string);
  begin
    ZnakTlacitka:= #27;
    if CRadku < List.Count then
    begin
      Pom := List.Strings[CRadku];
      Inc(CRadku);
      if Pom = '' then exit;
      Radek := TCtiRadekClass.Create(Pom);
      try
         Znak:= Radek.DejChar;
         Pom:= Radek.DejStringPoZnak(#39);
         ZnakTlacitka:= Pom[1];
         Znak:= Radek.DejChar;
         Pom:= Radek.DejStringPoZnak(#39);
         Znak:= Radek.DejChar;
         Oznaceni:= Radek.DejStringPoZnak(#39);
      except
      end;
      Radek.Free;
    end;
  end;

  procedure Dej2longInt(var L1, L2: longInt);
  begin
    Pom := List.Strings[CRadku];
    Inc(CRadku);
    Radek := TCtiRadekClass.Create(Pom);
    L1:= Radek.DejLongInt;
    L2:= Radek.DejLongInt;
    Radek.Free;
  end;


  procedure PrelozSekvenci(var Sekv: string; var OKej: boolean);
  var
    PomStr: string;
    I: byte;
    ZnakH, code: integer;
  begin
    I:= 1;
    PomStr:= '';
    OKej:= true;

    while (I <= length(Sekv)) and OKej do
    begin
      case Sekv[I] of
      '#': begin   { vstup lib. ciselne hodnoty decimalne na 3 cifry }
             val(copy(Sekv, I+1, 3), ZnakH, code);
             OKej:= code=0;
             if OKej then
             begin
               PomStr:= PomStr + chr(ZnakH);
               inc(I, 4)
             end
           end;

      '!': begin   { vstup ESC }
             PomStr:= PomStr + #27;
             inc(I)
           end;

      '\': begin   { vstup ENTER }
             PomStr:= PomStr + #13;
             inc(I)
           end

      else begin   { vsechny ostatni znaky }
             PomStr:= PomStr + Sekv[I];
             inc(I)
           end
      end
    end;

    if OKej then Sekv:= PomStr
    else Sekv:= ''
  end;




begin
  result := false;
  BinarniFormat:= false;
  if not FileExists(ConfigFile) then
  begin
     ShowMessage('konfiguran soubor tabletu nen: '+ConfigFile);
     exit;
  end;
  List := TStringList.Create;
  List.LoadFromFile(ConfigFile);
  CRadku := 0;
  begin
    KanalStr:= DejStringZRadku;
    CommPort := KanalStr;
    //SetPropertyStringByName('CommPort','cp'+KanalStr);
    PomInt{PrenosovaRychlost}:= DejIntegerZRadku;
    //SetPropertyStringByName('BaudRate','CBR_'+IntToStr(PomInt));
    BaudRate := PomInt;

    Pom:= DejStringZRadku;
    PomCh:= UpCase(Pom[1]);
    case PomCh of
       'E': ParityType := 2;//pcEven;
       'O': ParityType := 1;//pcOdd;
    end;

    PomInt:= DejIntegerZRadku;
    DataBits := PomInt;
    {
    case PomInt of
      4: DataBits := db4;
      5: DataBits := db5;
      6: DataBits := db6;
      7: DataBits := db7;
      8: DataBits := db8;
    end;
    }
    PomInt:= DejIntegerZRadku;
    case PomInt of
      1: StopBits := 0;
      2: StopBits := 2;
    end;
    InitStr:=   DejStringZRadku;
    aBool := true;
    PrelozSekvenci(InitStr, aBool);

    FormatStr:= DejFormatZRadku(BinarniFormat);
    if not BinarniFormat then
    begin
       Xprvni:= 1;
       while upCase(FormatStr[Xprvni]) <> 'X' do inc(Xprvni);
       Xza:= Xprvni + 1;
       while upCase(FormatStr[Xza]) = 'X' do inc(Xza);
       Yprvni:= 1;
       while upCase(FormatStr[Yprvni]) <> 'Y' do inc(Yprvni);
       Yza:= Yprvni + 1;
       while upCase(FormatStr[Yza]) = 'Y' do inc(Yza);
       Bprvni:= 1;
       while upCase(FormatStr[Bprvni]) <> 'B' do inc(Bprvni);
       Bza:= Bprvni + 1;
       while upCase(FormatStr[Bza]) = 'B' do inc(Bza);
       JednoznakoveTlacitko:= Bza-Bprvni = 1;
       DelkaVystupnihoRetezce:= length(FormatStr);
    end
    else
       DelkaVystupnihoRetezce:= 10;

    PromptStr:= DejStringZRadku;
    PrelozSekvenci(PromptStr, aBool);

    DejZnakAOznaceni(ZnakTl1, OznaceniTl1);
    if ZnakTl1 <> #27 then
    begin
       DejZnakAOznaceni(ZnakTl2, OznaceniTl2);
       if ZnakTl2 <> #27 then
       begin
         DejZnakAOznaceni(ZnakTl3, OznaceniTl3);
         if ZnakTl3 <> #27 then
         begin
           DejZnakAOznaceni(ZnakTl4, OznaceniTl4);
           if ZnakTl4 <> #27 then
           begin
             DejZnakAOznaceni(ZnakTl5, OznaceniTl5);
             if ZnakTl5 <> #27 then
             begin
               DejZnakAOznaceni(ZnakTl6, OznaceniTl6)
             end
           end
         end
       end
    end;
  end;
  List.Free;
  result := true;
end;


procedure TTablet.SendInitStr;
var
  S,Znaky: string;
begin
  if Active then
  begin
  { vyslani inicializacnich prikazu }
    S := InitStr;
    repeat
      Sleep(100);
      StringAsTwoParams(S,';',Znaky,S);
      if Znaky <> '' then
         SendData(PChar(Znaky), Length(Znaky));
    until S = '';
  end;
end;

procedure TTablet.SetActive(NewState : Boolean);
begin
   if NewState then
   begin
      //ShowMessage('Before Active');
      BinaryWord := '';
      TextWord := '';
      MoveTolerance := MoveTolerance;
      if ReadConfigFile then
      begin
         inherited;
         SendInitStr;
      end;
      //ShowMessage('After Active');
   end
   else
   begin
      //ShowMessage('Before DeActive');
      inherited;
      //ShowMessage('After DeActive');
   end;
end;

procedure TTablet.SetConfigFile(const Value: string);
begin
   FConfigFile := Value;
end;

procedure TTablet.SetMoveTolerance(const Value: integer);
begin
   FMoveTolerance := Value;
   if Value < 1 then
      FMoveTolerance := 1;
end;

procedure TTablet.SetonTabletAction(const Value: TTabletActionProcedure);
begin
  FonTabletAction := Value;
end;

procedure TTablet.SetProcessing(const Value: boolean);
begin
  FProcessing := Value;
end;

INITIALIZATION
   RegisterOrbisClass(TTablet);
END.
