unit T_ExPnTl;
{ Soustava nstroj pro export bodu do topolsk struktury }

interface
uses
// KERNEL
  Elements,
  Tools,
// SPACE
  //E_Space,
  E_QTree,
  E_Props,
// TOPOL
  T_AreLin,
  T_DBFexp,
  T_TlDBF;

type

TExportPointsToTopol = class(TExportTopolElements)
private
  procedure ExportPoints; virtual;
public
  procedure DoIt; override;
end;




implementation
uses
  SysUtils, Forms, Controls, Dialogs, Graphics, FileCtrl,
// KERNEL
  e_Class,
  E_Type,
  u_String,
// GLIB
  e_WCS,
// DIALOG
  //F_Gauge,
// TOPOL
  //E_TplPrp,
  e_TopoLElements,
  T_TopExp,
  T_ExLnTl;




procedure TExportPointsToTopol.ExportPoints;
var
  I: longInt;
  TAW: TTopolPointWriter;
  aPoint: TTopoLPointElement;
  //F_GaugeForm: TF_GaugeForm;
begin
  TAW:= TTopolPointWriter.CreateAll(BlockName, TJTSK.Create, true);
  if TAW = nil then exit;
  {
  Application.CreateForm(TF_GaugeForm, F_GaugeForm);
  F_GaugeForm.MaxValue:= TEntity(Input).Count;
  F_GaugeForm.Caption:= 'Export bodu do ' + BlockName;
  F_GaugeForm.Show;
  }
  StartProgress('Export bodu do ' + BlockName,0,TEntity(Input).Count);
  for I:= 0 to TEntity(Input).Count-1 do
  begin
    {
    if F_gaugeForm.DoCloseQuery and
       F_gaugeForm.RealyClose('Peruit export bodu ?') then
       break;
    }
    Progress:= I;
    Application.ProcessMessages;
    aPoint:= TTopoLPointElement(TEntity(Input).Elements[I]);
    if not (TObject(aPoint) is TTopoLPointElement) then
       continue;
    aPoint.ID:= I+1;
    DoBeforeExport(aPoint);

    { zpis jen geometrie}
    TAW.WritePoint(aPoint);

    { zpis do databze }
    ExportObject(aPoint);
  end;

  //F_GaugeForm.Free;

  TAW.Free;
end;



procedure TExportPointsToTopol.DoIt;
var
  TheCursor: TCursor;

begin
  if input = nil then exit;
  if not (Input is TEntity) then exit;
  if BlockName = '' then exit;

  TheCursor:= Screen.Cursor;
  Screen.Cursor:= crHourGlass;
try
    ExportPoints;
finally
  Screen.Cursor:= TheCursor;
end
end;






INITIALIZATION
  RegisterOrbisClass(TExportPointsToTopol);
END.
