


unit U_TopoLT;
(* Deklarace vsech typu pro Blok *)

{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&} interface {&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}


{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}

uses
   u_Symbol;

const
  Nikoho = -1;






type

  PSour = ^TSour;
  TSour = packed record
    Y, X: real48;
  end;

  PObdelnik = ^TObdelnik;
  TObdelnik = packed record
    PH: TSour;
    LD: TSour
  end;

  TSourExtended = packed record
    Y, X: extended;
  end;

  TObdelnikExtended = packed record
    PH: TSourExtended;
    LD: TSourExtended;
  end;

  PVektor = ^TVektor;
  TVektor = packed record
    X, Y, Modul: real48
  end;
  TSourSystem = (JTSK, Gauss, Matematicky);


  TLomBodPtr = ^TLomBod;
  TLomBod = packed record
              Dalsi: TLomBodPtr;
              Sour : TSour
            end;


  TPolozka = (PolozkaLinie, PolozkaPlochBod);



  TLinAtrib = set of (ZrusenaL, Netopologicka, lnKrivka, lnKruznice,
                      lnFerguson, lnElipsa, lnOblouk, lnCoons);


  TKohoZaco = packed record
                Koho  : longInt;
                Zaruku: boolean;
              end;


  TRukouNohou = packed record
                  Rukou: TKohoZaco;
                  Nohou: TKohoZaco;
                end;


  TDrziSe  = packed record
               Levou : TRukouNohou;
               Pravou: TRukouNohou;
             end;

  TPolohaSymbolu = packed record
                     Sour: TSour;
                     UhelKolmice: real48
                   end;

  PLin = ^TLin;
  TLin = packed record
           Cislo         : longInt;
           Druh          : smallInt;
           Presnost      : byte;
           Atributy      : TLinAtrib;
           Vybrana       : boolean;
           Barva, Znacka : smallInt;
           Symbol        : smallInt;
           Cas           : longInt;

           PrvniSour     : longInt;
           PosledniSour  : longInt;

           DrziSe        : TDrziSe;
           LevaPlocha    : longInt;
           PravaPlocha   : longInt;

           Delka         : real48;
           OpsanyObdelnik: TObdelnik;

           PolohaSymbolu : TPolohaSymbolu
         end;



  TPlochAtrib = set of (NeosetrenaP, PlochaBezVazby, ZrusenaP,
                        PAtr4, PAtr5, PAtr6);

  TPloPtr = ^TPlocha;
  TPlocha = packed record
                Cislo         : longInt;
                Druh          : smallInt;
                Atributy      : TPlochAtrib;
                Vybrana       : boolean;
                Barva, Znacka : smallInt;
                Cas           : longInt;

                PrvniLinie    : longInt;
                PosledniLinie : longInt;

                MaEnklavu     : boolean;
                CisloOtce     : longInt;

                Sour          : TSour;
                OpsanyObdelnik: TObdelnik;

                Vymera        : real48
              end;


  TPlochUkazovatka = packed record
                       PrvniSour, PosledniSour: longInt
                     end;

  TFPlochUkazovatek = file of TPlochUkazovatka;


  TBodAtrib = set of (ZrusenB, BAtr2, BAtr3, BAtr4, BAtr5, BAtr6);

  TBodPtr = ^TBod;
  TBod = packed record
           Cislo         : longInt;
           Druh          : smallInt;
           Presnost      : byte;
           Atributy      : TBodAtrib;
           Vybran        : boolean;
           Barva, Znacka : smallInt;
           Cas           : longInt;
           Sour          : TSour;

           Uhel          : real48;
         end;




  TFPrimIndex = file of longInt;



const

  NedrziSe: TDrzise     = (

                           Levou : (
                                    Rukou: (
                                            Koho  : Nikoho;
                                            Zaruku: false
                                           );
                                    Nohou: (
                                            Koho  : Nikoho;
                                            ZaRuku: false
                                           )
                                   );
                           Pravou: (
                                    Rukou: (
                                            Koho  : Nikoho;
                                            Zaruku: false
                                           );
                                    Nohou: (
                                            Koho  : Nikoho;
                                            ZaRuku: false
                                           )
                                   )
                          );

 { Konstanty rezimu textu }

   Absolutne = 0;
   Relativne = 1;
   Meritkove = 2;


type
   TTopolFont  = Byte;
   //TTextAtrib  = set of (ZrusenT,OkT, txtZmena, T30);
   TRezimTextu = byte {(Absolutne,Relativne,Meritkove)};

   TSText = packed record
      Cislo         : LongInt;
      Cas           : LongInt;
      Atributy      : TTextAtrib;
      RezimTextu    : TRezimTextu;
      Font          : TTopolFont;
      VychoziBod    : TSour;
      KoefVysky     : real48;
      KoefSirky     : real48;
      Smer          : real48; { Uhel v Radianech }
      SmerNapevno   : Boolean;
      Sklon         : real48; { Uhel v Radianech }
      Rozestupy     : real48; { Zvetseni default hodnoty v Bodech }
      Barva         : smallInt;
      DruhCary      : smallInt;
      OpsanyObdelnik: TObdelnik;
   end;

   PTopText = ^TTopText;
   TTopText = packed record
      Cislo         : LongInt;
      Druh          : smallInt;
      Vybran        : boolean;
      Cas           : LongInt;
      Atributy      : TTextAtrib;
      RezimTextu    : TRezimTextu;
      Font          : TTopolFont;
      VychoziBod    : TSour;
      KoefVysky     : real48;
      KoefSirky     : real48;
      Smer          : real48; { Uhel v Radianech }
      SmerNapevno   : Boolean;
      Sklon         : real48; { Uhel v Radianech }
      Rozestupy     : real48; { Zvetseni default hodnoty v Bodech }
      Barva         : smallInt;
      DruhCary      : smallInt;
      OpsanyObdelnik: TObdelnik;
   end;

const
  MinRegulerniPlocha = 0.001;

function RegulerniPlocha(const Plocha: TPlocha): boolean;


{&&&&&&&&&&&&&&&&&&&&&&&&&&&} implementation {&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}


function RegulerniPlocha(const Plocha: TPlocha): boolean;
begin
  with Plocha do
  RegulerniPlocha:=
              ([ZrusenaP, NeosetrenaP, PlochaBezVazby] * Atributy = []) and
              (Vymera > MinRegulerniPlocha)

end;




{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}

end.
