unit e_TopoLElements;

interface
uses
{$IFDEF DBF}
  DBTables, DB,
  e_Dataset,
  E_Reg,
{$ENDIF}
// KERNEL
  Elements,
// GLIB
  G_Elems,
// SPACE
  //E_SpaPrp,
// SYMBOL
//  u_Symbol,
// TOPOL
  U_TopolT;




Type


TTopoLElement = class(TRegisteredGeometryElement)
private
   FCislo   : longInt;
 {    FPuvodniCislo: longInt; }
   FDruh    : smallInt;
   FBarva   : smallInt;
   FZnacka  : smallInt;
   FVyber   : boolean;
   FPresnost: byte;
   FSymbol  : smallInt;
   FDone    : boolean;
   function   GetPhysicalObjectType: char;
   function   GetObjectType: char; virtual;
 {    function   GetObjectsOwner: TSpaceEntityString; virtual; abstract; }
   function   GetDBFName: string; virtual;
 { TODO -oO.S. -cZmeny pro ADO : 11.11.99 }
   function   GetDBFTable: TDataSetElement; virtual;
    function GetSourceTopolElement: TTopolElement; virtual;
protected
   function   GetSpaceID: longInt; override;
public
   function   GetDBFFieldAsString(aItem: string): string; override;
   procedure  SetDBFFieldAsString(aItem, aValue: string); override;
   function   HasDBFItem(aItem: string): boolean; override;
   function   SetDBFRecord: boolean; override;
   procedure  SetPropertyStringByName(AName: string; aValue: string); override;
   function GetGroup: integer; override;
   procedure SetGroup(const Value: integer); override;
 {    property   ObjectOwner: TSpaceEntityString read GetObjectsOwner; }
published
   property PhysicalObjectType: char read GetPhysicalObjectType stored false;
   property ObjectType: char read GetObjectType stored false;
   property Cislo:    longInt read FCislo    write FCislo stored true;
   property Druh:     smallInt read FDruh     write FDruh;
   property Barva:    smallInt read FBarva    write FBarva;
   property Znacka:   smallInt read FZnacka   write FZnacka;
   property Vyber:    boolean read FVyber    write FVyber;
   property Presnost: byte    read FPresnost write FPresnost;
   property Symbol     : smallInt read FSymbol  write FSymbol;
   property IsDone: boolean   read FDone     write FDone stored false default false;

   property DBFName:  string read GetDBFName stored false;
   property SourceTopolElement: TTopolElement read GetSourceTopolElement stored false;
 { TODO -oO.S. -cZmeny pro ADO : 11.11.99 }
   property DBFTable: TDataSetElement read GetDBFTable stored false;
end;


TTopolPointElement = class(TTopolElement)
private
   function    GetObjectType: char; override;
end;

// neni urcen pro ukladani
TTopolExportPointElement = class(TTopolPointElement)
private
   FExportProperties: TElement;
   procedure SetExportProperties(const Value: TElement);
   function   GetSourceTopolElement: TTopolElement; override;
public
   function   GetPropertyStringByName(AName: string): string; override;
published
   property ExportProperties: TElement read FExportProperties write SetExportProperties;
end;

TTopolTextElement = class(TTopolElement)
private
   FCodePage: TCodePage;
   FStartPoint: TCoordinate;
   FTopolFont   : byte;
   FHeight      : double;
   FWidthCoef   : double;
   FDirection   : double; { Uhel v Radianech }
   FSlope       : double; { Uhel v Radianech }
   FDistance    : double; { Zvetseni default hodnoty v Bodech }
   FTextAtrib   : TTextAtrib;
   FTextMode    : byte;
   procedure SetCodePage(aCode: TCodePage);
   function  GetCodePage: TCodePage;
   function  GetStartPoint: TCoordinate;
   procedure SetStartPoint(aStartPoint: TCoordinate);
   function  GetObjectType: char; override;
    function GetText: string;
    procedure SetText(const Value: string);
public
   destructor  Destroy; override;
published
   property TextAtrib: TTextAtrib read FTextAtrib write FTextAtrib;
   property StartPoint: TCoordinate read GetStartPoint write SetStartPoint stored true;
   property CodePage: TCodePage read GetCodePage write SetCodePage;
   property TopolFont: byte read FTopolFont write FTopolFont;
   property Height: double read FHeight write FHeight;
   property WidthCoef: double read FWidthCoef write FWidthCoef;
   property Direction: double read FDirection write FDirection;
   property Slope: double read FSlope write FSlope;
   property Distance: double read FDistance write FDistance;
   property TextMode: byte read FTextMode write FTextMode;
   property Text: string read GetText write SetText stored false;
end;


TTopolLineElement = class(TTopolElement)
private
   FLeftArea  : longInt;
   FRightArea : longInt;
   FDrziSe    : TDrziSe;
   function  GetObjectType: char; override;
    function GetDelka: double;
public
   property DrziSe: TDrziSe read FDrziSe write FDrziSe;
   function GetRightAreaNoForBegin(aBegin: boolean): longInt;
published
   property LeftArea  : longInt read FLeftArea write FLeftArea;
   property RightArea : longInt read FRightArea write FRightArea;
   property Delka: double read GetDelka stored false;
end;


TTopolAreaElement = class(TTopolElement)
private
   FLineNo: longInt;
   FPaterNo: longInt;
   FHasChildren: boolean;
   function  GetObjectType: char; override;
   function  GetHektars: double;
    function GetFixedArea: double;
    function GetFixedAreaIndex: byte;
    procedure SetFixedAreaIndex(const Value: byte);
    procedure SetFixedArea(const Value: double);
published
   property Hektars: double read GetHektars stored false;
   property LineNo: longInt read FLineNo write FLineNo;
   property PaterNo: longInt read FPaterNo write FPaterNo;
   property HasChildren: boolean read FHasChildren write FHasChildren;
   property FixedArea: double read GetFixedArea write SetFixedArea stored false;
   property FixedAreaIndex: byte read GetFixedAreaIndex write SetFixedAreaIndex stored false;
   //property Vymera
end;

TTopolExportAreaElement = class(TTopolAreaElement)
private
    FExportProperties: TElement;
    procedure SetExportProperties(const Value: TElement);
   function   GetSourceTopolElement: TTopolElement; override;
public
   function   GetPropertyStringByName(AName: string): string; override;
published
   property ExportProperties: TElement read FExportProperties write SetExportProperties;
end;

implementation
uses
// KERNEL
  e_Class,
  U_Props,
// SPACE
   e_Geometry,
  //E_Reg,
// TOPOL
  {!PubUnits,}
  C_TLDBF,
  E_TplReg;



{ TTopoLElement}

function TTopoLElement.GetPhysicalObjectType: char;
begin
   result:= ' ';
   if Geometry = nil then exit;

   if Geometry is TPointElement then result:= 'B'
   else
   if Geometry is TTextElement then result:= 'T'
   else
   if Geometry is TPolyLineElement then result:= 'L'
   else
   if Geometry is TAreaElement then result:= 'P'
   else
      result:= 'X';
end;


function TTopoLElement.GetObjectType: char;
begin
  result:= GetPhysicalObjectType
end;


function TTopoLElement.GetDBFName: string;
var
  aName: string;
  El: TRegisteredGeometryElement;
begin
  result:= '';
  El:= GetOrigElement;
  if not (TElement(El) is TRegisteredGeometryElement) then exit;
  aName:= GetBlockName;
  if aName = '' then exit;
  result:= GetDBFNameForTopolObject(aName, ObjectType, TTopolElement(El).Druh);
end;


function TTopoLElement.HasDBFItem(aItem: string): boolean;
var
  aDBFName: string;
begin
  result:= false;
  aDBFName:= GetDBFName;

  if TTopolDBFTable(TTopolObjectRegister(ObjectRegister).DBF).SetForName(aDBFName) then
     result:= TTopolDBFTable(TTopolObjectRegister(ObjectRegister).DBF).FieldExists(aItem);
end;




function TTopoLElement.SetDBFRecord: boolean;
var
  aDBFName: string;
begin
  aDBFName:= GetDBFName;
  result:= TTopolDBFTable(ObjectRegister.DBF).SetForNameCislo(aDBFName, OrigNo);
end;



function TTopoLElement.GetDBFFieldAsString(aItem: string): string;
begin
  result:= TTopolDBFTable(ObjectRegister.DBF).GetFieldAsString(aItem);
end;


procedure TTopoLElement.SetDBFFieldAsString(aItem, aValue: string);
begin
  TTopolDBFTable(ObjectRegister.DBF).SetFieldAsString(aItem, aValue);
end;



procedure   TTopoLElement.SetPropertyStringByName(AName: string; aValue: string);
var
  aDBFName: string;
  TopTable: TTopolDBFTable;
begin
  {
  if GetPropIndex(Self, aName) > -1 then
  begin
     inherited SetPropertyStringByName(aName, aValue);
     exit;
  end;
  }
    if inherited HasPropertyByName(AName) then
    begin
       inherited SetPropertyStringByName(aName, aValue);
       exit;
    end;
//  try
    if ObjectRegister = nil then exit;
    if not HasDBFItem(aName) then
       exit;
    aDBFName:= GetDBFName;
    TopTable:= TTopolDBFTable(TTopolObjectRegister(ObjectRegister).DBF);
    TopTable.Table.Active:= false;
    TopTable.ReadOnly:= False;
    TopTable.SetForNameCislo(aDBFName, Cislo);
    TopTable.Table.Edit;
    TopTable.Table.FieldByName(aName).AsString:= aValue;
    TopTable.Table.Post;
    TopTable.Table.Active:= false;
    TopTable.ReadOnly:= True;
//  except

//  end;
end;


function  TTopoLElement.GetSpaceID: longInt;
begin
  result:= Cislo
end;


function  TTopoLElement.GetDBFTable: TDataSetElement;
begin
  result:= nil;
  if not (ObjectRegister is TTopolObjectRegister) then exit;

  result:= TTopolObjectRegister(ObjectRegister).DBF;
end;


function TTopoLElement.GetSourceTopolElement: TTopolElement;
begin
   result := Self;
end;



{ TTopolPointElement }

function  TTopolPointElement.GetObjectType: char;
begin
  result:= 'B'
end;

{ TTopolTextElement }

destructor TTopolTextElement.Destroy;
begin
  if FStartPoint <> nil then
     FStartPoint.Free;
  inherited destroy
end;


function  TTopolTextElement.GetObjectType: char;
begin
  result:= 'T'
end;

procedure TTopolTextElement.SetCodePage(aCode: TCodePage);
begin
  FCodePage:= aCode
end;

function TTopolTextElement.GetCodePage: TCodePage;
begin
  result:= FCodePage
end;

function TTopolTextElement.GetStartPoint: TCoordinate;
begin
   if not assigned(FStartPoint) then FStartPoint := T2DCoordinate.Create;
   result := FStartPoint;
end;

procedure   TTopolTextElement.SetStartPoint(aStartPoint: TCoordinate);
begin
   if assigned(FStartPoint) then FStartPoint.Free;
   FStartPoint := nil;
   FStartPoint := aStartPoint;
end;

function TTopolTextElement.GetText: string;
begin
   result := '';
   if NoGeometry then exit;
   if not (Geometry is TTextElement) then exit;
   result := TTextElement(Geometry).Text;
end;

procedure TTopolTextElement.SetText(const Value: string);
begin
   if NoGeometry then exit;
   if not (Geometry is TTextElement) then exit;
   TTextElement(Geometry).Text := Value;
end;

{ TTopolLineElement }

function TTopolLineElement.GetDelka: double;
begin
   result := 0;
   if NoGeometry then exit;
   try
      result := TPolyLineElement(Geometry).Length;
   except
   end;
end;

function  TTopolLineElement.GetObjectType: char;
begin
  result:= 'L'
end;

function TTopolLineElement.GetRightAreaNoForBegin(aBegin: boolean): longInt;
begin
  result:= LeftArea;
  if not aBegin then
     result:= RightArea
end;

{TTopolAreaElement}

function  TTopolAreaElement.GetObjectType: char;
begin
  result:= 'P'
end;


function TTopolAreaElement.GetHektars: double;
begin
  result:= 0;
  if not (Geometry is TAreaElement) then exit;
  result:= TAreaElement(Geometry).Area/10000
end;

function TTopoLElement.GetGroup: integer;
begin
   result := FDruh;
end;

procedure TTopoLElement.SetGroup(const Value: integer);
begin
   FDruh := Value;
end;

{ TTopolExportAreaElement }

function TTopolExportAreaElement.GetPropertyStringByName(AName: string): string;
begin
   result:= inherited GetPropertyStringByName(aName);
   if result <> '' then exit;
   if ExportProperties = nil then exit;
   result:= ExportProperties.GetPropertyStringByName(AName)
end;


function TTopolExportAreaElement.GetSourceTopolElement: TTopolElement;
var
   e: TElement;
begin
   result := Self;
   e := ExportProperties;
   if e = nil then exit;
   if not (e is TTopolElement) then exit;
   result := TTopolElement(e);
end;

procedure TTopolExportAreaElement.SetExportProperties(
  const Value: TElement);
begin
   FExportProperties := Value;
end;

{TTopolAreaElement}

function TTopolAreaElement.GetFixedArea: double;
begin
   result := 0;
   if Geometry = nil then exit;
   result := TAreaElement(Geometry).FixedArea;
end;

function TTopolAreaElement.GetFixedAreaIndex: byte;
begin
   result := 0;
   if Geometry = nil then exit;
   result := TAreaElement(Geometry).FixedAreaIndex;
end;

procedure TTopolAreaElement.SetFixedAreaIndex(const Value: byte);
begin
   if Geometry = nil then exit;
   TAreaElement(Geometry).FixedAreaIndex := Value;
end;

procedure TTopolAreaElement.SetFixedArea(const Value: double);
begin
   if Geometry = nil then exit;
   TAreaElement(Geometry).FixedArea := Value;
end;



{ TTopolExportPointElement }

function TTopolExportPointElement.GetPropertyStringByName(AName: string): string;
begin
   result:= inherited GetPropertyStringByName(aName);
   if result <> '' then exit;
   if ExportProperties = nil then exit;
   result:= ExportProperties.GetPropertyStringByName(AName)
end;

function TTopolExportPointElement.GetSourceTopolElement: TTopolElement;
var
   e: TElement;
begin
   result := Self;
   e := ExportProperties;
   if e = nil then exit;
   if not (e is TTopolElement) then exit;
   result := TTopolElement(e);
end;

procedure TTopolExportPointElement.SetExportProperties(
  const Value: TElement);
begin
   FExportProperties := Value;
end;

initialization
   RegisterOrbisClass(TTopolElement);
   RegisterOrbisClass(TTopolPointElement);
   RegisterOrbisClass(TTopolExportPointElement);
   RegisterOrbisClass(TTopolTextElement);
   RegisterOrbisClass(TTopolAreaElement);
   RegisterOrbisClass(TTopolExportAreaElement);
   RegisterOrbisClass(TTopolLineElement);
end.

