{ D-}

unit SioObj;


{ zakladni objekt pro komunikaci se seriovou linkou }



{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&} interface {&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}



{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}

const
  CR = #13;
  LF = #10;


type
  TBinarniRetez= string[10];


  TSIOPtr = ^TSIO;

  TSIO = object

    SioPort: word;
    KomunikovatPrimo: boolean;
    DelkaSlova: byte;

    AdrData       ,
    AdrIntW       ,
    AdrIntR       ,
    AdrLineReg    ,
    AdrModemRegW  ,
    AdrLineStatR  ,
    AdrModemStatR : word;

    constructor Init(SioPortStr: string; Rychlost: integer;
                     Parita: char; PocetDatovychBitu, PocetStopBitu: byte;
                     PrimaKomunikace: boolean; SlovniDelka: byte);

    procedure Inicializace; virtual;
    procedure VysliZnakPrimo(Znak: char);
    procedure Prikaz(Retez: string);
{
    function  VPoradku: boolean;
}
    function  VstupPripraven: boolean;
    function  DejZnak(var TimeOut: boolean): char;
    function  PrijatyRetezec(var PrerusovaciZnak: char): string;
    function  PrijatySamostatnyRetezec(var PrerusovaciZnak: char): string;
    function  PrijatyRetezecBezpecne(var PrerusovaciZnak: char): string;
    function  BinarniSlovo
              (OdlisovaciBit: byte; var PrerusovaciZnak: char): TBinarniRetez;

    destructor Done;
  end;





{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&} implementation {&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}

uses crt, AuxInOut;

{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}



constructor TSIO.Init(SioPortStr: string; Rychlost: integer;
                      Parita: char; PocetDatovychBitu, PocetStopBitu: byte;
                      PrimaKomunikace: boolean; SlovniDelka: byte);
var
  BRBin, ParitaBin, SBBin, DBBin, Param: word;

begin
  case Rychlost of
     110: BRBin:= $00;
     150: BRBin:= $20;
     300: BRBin:= $40;
     600: BRBin:= $60;
    1200: BRBin:= $80;
    2400: BRBin:= $A0;
    4800: BRBin:= $C0;
    9600: BRBin:= $E0;
    else  BRBin:= $E0
  end;

  case upCase(Parita) of
    'N': ParitaBin:= $00;
    'O': ParitaBin:= $08;  { Odd  parity }
    'E': ParitaBin:= $18   { Even parity }
  end;

  case PocetStopBitu of
    1: SBBin:= $00;
    2: SBBin:= $40
  end;

  case PocetDatovychBitu of
    7: DBBin:= $02;
    8: DBBin:= $03
  end;

  Param:= BRBin or ParitaBin or SBBin or DBBin;

  SioPort:= ord(SioPortStr[4]) - ord('1');
  case SioPort of
  0:begin
      AdrData       := $3F8;
      AdrIntW       := $3F9;
      AdrIntR       := $3FA;
      AdrLineReg    := $3FB;
      AdrModemRegW  := $3FC;
      AdrLineStatR  := $3FD;
      AdrModemStatR := $3FE;
    end;

  1:begin
      AdrData       := $2F8;
      AdrIntW       := $2F9;
      AdrIntR       := $2FA;
      AdrLineReg    := $2FB;
      AdrModemRegW  := $2FC;
      AdrLineStatR  := $2FD;
      AdrModemStatR := $2FE;
    end;
  end;

  AuxInit(SioPort, Param);

  KomunikovatPrimo:= PrimaKomunikace;

  if KomunikovatPrimo then
  begin
    port[AdrModemRegW]:= 0
  end;

  DelkaSlova:= SlovniDelka;

  Inicializace
end;






procedure TSIO.Inicializace;
begin
end;





procedure TSIO.VysliZnakPrimo(Znak: char);
begin
  repeat until (port[AdrLineStatR] and 32) <> 0;
  port[AdrData]:= ord(Znak)
end;






procedure TSIO.Prikaz(Retez: string);
var
  I: byte;

begin
  for I:= 1 to length(Retez) do
  begin
    if KomunikovatPrimo then
    begin
      VysliZnakPrimo(Retez[I])
    end
    else
      AuxOutChar(SioPort, Retez[I])
  end
end;





{

function TSIO.VPoradku: boolean;
var
  Hod, Min, Sek, Sek100: word;
  Hod2, Min2, Sek2, Sek1002: word;
  T1, T2: longInt;

begin
  getTime(Hod, Min, Sek, Sek100);
  AuxOutChar(SioPort, #0);
  getTime(Hod2, Min2, Sek2, Sek1002);
  T1:= 36000 * longInt(Hod);
  T1:= Sek100 + Sek * 10 + longInt(Min) * 600 + T1;

  T2:= 36000 * longInt(Hod);
  T2:= Sek1002 + Sek2 * 10 + longInt(Min2) * 600 + T2;

  VPoradku:= T2 - T1 < 100
end;
}






function  TSIO.VstupPripraven: boolean;
var
  Bytik: byte;

begin
  if KomunikovatPrimo then
     port[AdrModemRegW]:= 2;

  if KomunikovatPrimo then
  begin
    Bytik:= port[AdrLineStatR];
    VstupPripraven:= (port[AdrLineStatR] and 1) = 1;
  end
  else
    VstupPripraven:= AuxInReady(SioPort)
end;







function TSIO.DejZnak(var TimeOut: boolean): char;
var
  Pocitadlo: integer;

begin
  DejZnak:= #0;

  Pocitadlo:= 500;
  while not VstupPripraven {and not KeyPressed} and not (Pocitadlo = 0) do
  begin
    dec(Pocitadlo);
    delay(1);
  end;

  TimeOut:= Pocitadlo = 0;

  if not TimeOut then
  begin
    if KomunikovatPrimo then
    begin
      DejZnak:= chr(port[AdrData])
    end
    else
      DejZnak:= AuxInChar(SioPort);
  end
  else
    DejZnak:= #0;

  if KomunikovatPrimo then
     port[AdrModemRegW]:= 0;

end;






function TSIO.PrijatyRetezec(var PrerusovaciZnak: char): string;
var
  Znak: char;
  Retez: string;
  Pocitadlo: integer;
  TimeOut: boolean;

begin
  PrerusovaciZnak:= #0;

  Retez:= '';

  Znak:= DejZnak(TimeOut);

  while not (Znak in [CR, LF]) {and not keyPressed} and not TimeOut do
        Znak:= DejZnak(TimeOut);

  while (Znak in [CR, LF]) {and not keyPressed} and not TimeOut do
        Znak:= DejZnak(TimeOut);


  if TimeOut then
  if keyPressed then
  begin
    PrerusovaciZnak:= readKey;
    if PrerusovaciZnak = #0 then
       PrerusovaciZnak:= chr (ord (readKey) + 123)
  end;


  Pocitadlo:= 0;

  if PrerusovaciZnak = #0 then
  while (not (Znak in [CR, LF])) and (Pocitadlo < DelkaSlova) and
        not keyPressed and not TimeOut do
  begin
    Retez:= Retez + Znak;
    inc(Pocitadlo);
    if Pocitadlo < DelkaSlova then Znak:= DejZnak(TimeOut);
  end;

  if TimeOut then
  if keyPressed then
  begin
    PrerusovaciZnak:= readKey;
    if PrerusovaciZnak = #0 then
       PrerusovaciZnak:= chr (ord (readKey) + 123)
  end;

  PrijatyRetezec:= Retez
end;







function TSIO.PrijatySamostatnyRetezec(var PrerusovaciZnak: char): string;
var
  Znak: char;
  Retez: string;
  Pocitadlo: integer;
  TimeOut: boolean;

begin
  PrerusovaciZnak:= #0;

  Retez:= '';

  Znak:= DejZnak(TimeOut);

  while (Znak in [CR, LF]) {and not keyPressed} and not TimeOut do
        Znak:= DejZnak(TimeOut);


  if TimeOut then
  if keyPressed then
  begin
    PrerusovaciZnak:= readKey;
    if PrerusovaciZnak = #0 then
       PrerusovaciZnak:= chr (ord (readKey) + 123)
  end;


  Pocitadlo:= 0;

  if PrerusovaciZnak = #0 then
  while (not (Znak in [CR, LF])) and (Pocitadlo < DelkaSlova)
        {and not keyPressed} and not TimeOut do
  begin
    Retez:= Retez + Znak;
    inc(Pocitadlo);
    if Pocitadlo < DelkaSlova then Znak:= chr(ord(DejZnak(TimeOut)) and $7F);
  end;

  if TimeOut then
  if keyPressed then
  begin
    PrerusovaciZnak:= readKey;
    if PrerusovaciZnak = #0 then
       PrerusovaciZnak:= chr (ord (readKey) + 123)
  end;

  PrijatySamostatnyRetezec:= Retez
end;




function TSIO.PrijatyRetezecBezpecne(var PrerusovaciZnak: char): string;
var
  Znak: char;
  Retez: string;
  Pocitadlo: integer;
  TimeOut: boolean;

begin
  PrerusovaciZnak:= #0;

  Retez:= '';

  Znak:= DejZnak(TimeOut);

  if (Znak in [CR, LF]) then
  begin
    PrijatyRetezecBezpecne:= '';
    delay(1);
    if not VstupPripraven then exit
  end;


  if keyPressed then
  begin
    PrerusovaciZnak:= readKey;
    if PrerusovaciZnak = #0 then
       PrerusovaciZnak:= chr (ord (readKey) + 123)
  end;


  Pocitadlo:= 0;

  if PrerusovaciZnak = #0 then
  while (not (Znak in [CR, LF])) and (Pocitadlo < DelkaSlova) and
        not keyPressed and not TimeOut do
  begin
    Retez:= Retez + Znak;
    inc(Pocitadlo);
    if Pocitadlo < DelkaSlova then Znak:= chr(ord(DejZnak(TimeOut)) and $7F);
  end;

  if keyPressed then
  begin
    PrerusovaciZnak:= readKey;
    if PrerusovaciZnak = #0 then
       PrerusovaciZnak:= chr (ord (readKey) + 123)
  end;

  PrijatyRetezecBezpecne:= Retez
end;












function TSIO.BinarniSlovo
         (OdlisovaciBit: byte; var PrerusovaciZnak: char): TBinarniRetez;
var
  PrvniZnak, Znak: char;
  Retez: TBinarniRetez;
  Pocitadlo: integer;
  TimeOut: boolean;

begin
  PrerusovaciZnak:= #0;

  Retez:= '';

  PrvniZnak:= DejZnak(TimeOut);
  Znak:= PrvniZnak;
  while ((ord(Znak) and OdlisovaciBit) = 0) {and not keyPressed} and not TimeOut do
        Znak:= DejZnak(TimeOut);

  Retez:= Retez + Znak;

  Znak:= DejZnak(TimeOut);
  Pocitadlo:= 0;

  while ((ord(Znak) and OdlisovaciBit) = 0) and (Pocitadlo < DelkaSlova)
       {and not keyPressed} and not TimeOut do
  begin
    Retez:= Retez + Znak;
    inc(Pocitadlo);
    if Pocitadlo < DelkaSlova then Znak:= DejZnak(TimeOut);
  end;

  if TimeOut then
  if keyPressed then
  begin
    PrerusovaciZnak:= readKey;
    if PrerusovaciZnak = #0 then
       PrerusovaciZnak:= chr (ord (readKey) + 123)
  end;

  BinarniSlovo:= Retez;

{
  if ord(PrvniZnak) < 128 then
  begin
    sound(1000);
    delay(20);
    noSound
  end
}
end;





destructor TSIO.Done;
begin
end;



end.

