{$N+,E+,R-,Q-}
unit PTranPoR;

{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&} interface {&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}

uses MatProc, TranType, PakTrans, PTranPoV;

{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}

type

  PPolynomicka2St2D = ^TPolynomicka2St2D;
  Tpolynomicka2St2D = object(TTransformace2D)

    constructor Init(
                     var PoleIdBodu       : PExtVector;
                         PocetDvojicIdBodu: integer);

    procedure   Transformuj(
                            const ZdrojBod: Bod;
                            var   CilBod  : Bod); virtual;

    procedure   InvTransformuj(
                               const ZdrojBod: Bod;
                               var   CilBod  : Bod); virtual;

  end;



  PPolynomicka3St2D = ^TPolynomicka3St2D;
  TPolynomicka3St2D = object(TTransformace2D)

    constructor Init(
                     var PoleIdBodu       : PExtVector;
                         PocetDvojicIdBodu: integer);

    procedure   Transformuj(
                            const ZdrojBod: Bod;
                            var   CilBod  : Bod); virtual;

    procedure   InvTransformuj(
                               const ZdrojBod: Bod;
                               var   CilBod  : Bod); virtual;

  end;

function TransformaceInit(
                          PoleIdBodu       : PExtVector;
                          PocetDvojicIdBodu: integer;
                          Typ              : byte): PTransformace; export;

(*
  Typ = 0 Podobn 2D
  Typ = 1 Afinn  2D
  Typ = 2 Kolin  2D
  Typ = 3 Podobn 3D
  Typ = 4 Afinn  3D
  Typ = 5 Kolin  3D
  Typ = 6 2 St Pol
  Typ = 7 3 St Pol
*)

procedure TransformaceDone(
                           var Tran: PTransformace); export;

procedure TransformaceTransformuj(
                                        Tran    : PTransformace;
                                  const ZdrojBod: Bod;
                                  var   CilBod  : Bod); export;


procedure TransformaceInvTransformuj(
                                           Tran    : PTransformace;
                                     const ZdrojBod: Bod;
                                     var   CilBod  : Bod); export;

function TransformaceDejPocetIdB(
                                 Tran: PTransformace): integer; export;

function TransformaceVratCisloChyby(
                                    Tran: PTransformace): integer; export;

function TransformaceKlicVypocten(
                                  Tran: PTransformace): boolean; export;

function TransformaceVratPopisChyby(
                                    Tran: PTransformace): string; export;


procedure TransformaceDejZdrojStred(
                                    Tran: PTransformace; var Bod: TranType.Bod); export;

procedure TransformaceDejCilStred(
                                  Tran: PTransformace; var Bod: TranType.Bod); export;

procedure TransformaceDejNov(
                             Tran: PTransformace; i: integer; var Bod: TranType.Bod); export;

procedure TransformaceDejSta(
                             Tran: PTransformace; i: integer; var Bod: TranType.Bod); export;

procedure TransformaceZmenNov(
                              Tran: PTransformace; Puv, No: integer); export;

procedure TransformaceZmenSta(
                              Tran: PTransformace; Puv, No: integer); export;

procedure TransformaceNastavPocetIdBodu(
                                        Tran: PTransformace; aPocetIdBodu: integer); export;

function TransformaceDejNazevTransformace(Tran: PTransformace): PChar; export;

function TransformaceDejNazevTransfTabulky(Tran: PTransformace): PChar; export;

procedure TransformaceDejSourRohu(Tran: PTransformace; var aSourRohy: TObdelnik); export;

procedure TransformaceNastavNazevTransformace(Tran: PTransformace; aNazevTransformace: PChar); export;

procedure TransformaceNastavNazevTransfTabulky(Tran: PTransformace; aNazevTransfTabulky: PChar); export;

procedure TransformaceNastavSourRohu(Tran: PTransformace; aSourRohy: TObdelnik); export;

function TransformaceDejInvKlic(Tran: PTransformace; i: integer): extended; export;

function TransformaceLojza(Typ: byte): pointer; export;

(*
  Typ = 0 Podobn 2D
  Typ = 1 Afinn  2D
  Typ = 2 Kolin  2D
  Typ = 3 Podobn 3D
  Typ = 4 Afinn  3D
  Typ = 5 Kolin  3D
  Typ = 6 2 St Pol
  Typ = 7 3 St Pol
*)
procedure TransformaceNastavInvKlic(
                                    Tran: PTransformace; i: integer; InvKl: extended); export;

procedure TransformaceNastavKlic(
                                 Tran: PTransformace; i: integer; Kl: extended); export;

procedure TransformaceNastavZdrojStred(
                                       Tran: PTransformace; Bod: TranType.Bod); export;

procedure TransformaceNastavCilStred(
                                     Tran: PTransformace; Bod: TranType.Bod); export;

procedure TransformaceNastavNov(
                                Tran: PTransformace; i: integer; Bod: TranType.Bod); export;

procedure TransformaceNastavSta(
                                Tran: PTransformace; i: integer; Bod: TranType.Bod); export;

function TransformaceDejKlic(
                             Tran: PTransformace; i: integer): extended; export;

function TransformaceDejDimenzi(
                                Tran: PTransformace): byte; export;

{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&} implementation {&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}

uses Strings;

{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}


procedure TPolynomicka2St2D.Transformuj(
                                        const ZdrojBod: Bod;
                                        var   CilBod  : Bod);
var
  H: Bod;

begin
  H.X      := ZdrojBod.X - ZdrojStred.X;
  H.Y      := ZdrojBod.Y - ZdrojStred.Y;
  CilBod.X := CilStred.X + H.X * (Klic[1] + H.X * Klic[3])
                         + H.Y * (Klic[2] + H.X * Klic[4] + H.Y * Klic[5])
                         + Klic[6];
  CilBod.Y := CilStred.Y + H.X * (Klic[7] + H.X * Klic[ 9])
                         + H.Y * (Klic[8] + H.X * Klic[10] + H.Y * Klic[11])
                         + Klic[12];
end;

procedure TPolynomicka3St2D.Transformuj(
                                        const ZdrojBod: Bod;
                                        var   CilBod  : Bod);
var
  H: Bod;

begin
  H.X      := ZdrojBod.X - ZdrojStred.X;
  H.Y      := ZdrojBod.Y - ZdrojStred.Y;
  CilBod.X := CilStred.X + H.X *       (Klic[1] + H.X * Klic[3] + H.X * H.X * Klic[6])
                         + H.Y *       (Klic[2] + H.Y * Klic[5] + H.Y * H.Y * Klic[9])
                         + H.X * H.Y * (Klic[4] + H.X * Klic[7] + H.Y * Klic[8])
                         + Klic[10];
  CilBod.Y := CilStred.Y + H.X *       (Klic[11] + H.X * Klic[13] + H.X * H.X * Klic[16])
                         + H.Y *       (Klic[12] + H.Y * Klic[15] + H.Y * H.Y * Klic[19])
                         + H.X * H.Y * (Klic[14] + H.X * Klic[17] + H.Y * Klic[18])
                         + Klic[20];
end;


procedure TPolynomicka2St2D.InvTransformuj(
                                           const ZdrojBod: Bod;
                                           var   CilBod  : Bod);
var
  H: Bod;

begin
  H.X      := ZdrojBod.X - CilStred.X;
  H.Y      := ZdrojBod.Y - CilStred.Y;
  CilBod.X := ZdrojStred.X + H.X * (InvKlic[1] + H.X * InvKlic[3])
                           + H.Y * (InvKlic[2] + H.X * InvKlic[4] + H.Y * InvKlic[5])
                           + InvKlic[6];
  CilBod.Y := ZdrojStred.Y + H.X * (InvKlic[7] + H.X * InvKlic[ 9])
                           + H.Y * (InvKlic[8] + H.X * InvKlic[10] + H.Y * InvKlic[11])
                           + InvKlic[12];
end;

procedure TPolynomicka3St2D.InvTransformuj(
                                           const ZdrojBod: Bod;
                                           var   CilBod  : Bod);
var
  H: Bod;

begin
  H.X      := ZdrojBod.X - CilStred.X;
  H.Y      := ZdrojBod.Y - CilStred.Y;
  CilBod.X := ZdrojStred.X + H.X *       (InvKlic[1] + H.X * InvKlic[3] + H.X * H.X * InvKlic[6])
                           + H.Y *       (InvKlic[2] + H.Y * InvKlic[5] + H.Y * H.Y * InvKlic[9])
                           + H.X * H.Y * (InvKlic[4] + H.X * InvKlic[7] + H.Y * InvKlic[8])
                           + InvKlic[10];
  CilBod.Y := ZdrojStred.Y + H.X *       (InvKlic[11] + H.X * InvKlic[13] + H.X * H.X * InvKlic[16])
                           + H.Y *       (InvKlic[12] + H.Y * InvKlic[15] + H.Y * H.Y * InvKlic[19])
                           + H.X * H.Y * (InvKlic[14] + H.X * InvKlic[17] + H.Y * InvKlic[18])
                           + InvKlic[20];
end;




constructor TPolynomicka2St2D.Init(
                                   var PoleIdBodu       : PExtVector;
                                       PocetDvojicIdBodu: integer);
const
  PocetParametru = 12;

var
  V: PExtVector;
  PM: PExtVector;
  VPS: PExtVector;
  i, j, k, PocetRovnic:integer;

begin
  DostatecnyPocetDvojic := 6;

  if PocetDvojicIdBodu < DostatecnyPocetDvojic then
  begin
    NelzeVypocistKlic := true;
    CisloChyby        := 3;
  end else
  begin
    inherited Init(PoleIdBodu, PocetDvojicIdBodu);
    GetMem(V, SizeOf(extended) * PocetDvojicIdBodu);
    GetMem(PM, DimenseTransformace * SizeOf(extended) * PocetDvojicIdBodu * PocetParametru);
    GetMem(VPS, DimenseTransformace * SizeOf(extended) * PocetDvojicIdBodu);

    j := 0;
    k := 0;

    for i := 1 to PocetDvojicIdBodu do
    begin
      V^[i]  := Vaha[i];

      inc(j);
      PM^[j] := Sta[i].X;
      inc(j);
      PM^[j] := Sta[i].Y;
      inc(j);
      PM^[j] := Sta[i].X * Sta[i].X;
      inc(j);
      PM^[j] := Sta[i].X * Sta[i].Y;
      inc(j);
      PM^[j] := Sta[i].Y * Sta[i].Y;
      inc(j);
      PM^[j] := 1;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;

      inc(k);
      VPS^[k]    := Nov[i].X;

      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := Sta[i].X;
      inc(j);
      PM^[j] := Sta[i].Y;
      inc(j);
      PM^[j] := Sta[i].X * Sta[i].X;
      inc(j);
      PM^[j] := Sta[i].X * Sta[i].Y;
      inc(j);
      PM^[j] := Sta[i].Y * Sta[i].Y;
      inc(j);
      PM^[j] := 1;

      inc(k);
      VPS^[k]    := Nov[i].Y;
    end;

    PocetRovnic := DimenseTransformace * PocetDvojicIdBodu;

    if not ResSoustRovnic(V, PM, VPS, Klic, PocetRovnic, PocetParametru, DimenseTransformace) then
    begin
      NelzeVypocistKlic := true;
      CisloChyby        := 2;
    end;

    if not NelzeVypocistKlic then
    begin
      j := 0;
      k := 0;

      for i := 1 to PocetDvojicIdBodu do
      begin
        inc(j);
        PM^[j] := Nov[i].X;
        inc(j);
        PM^[j] := Nov[i].Y;
        inc(j);
        PM^[j] := Nov[i].X * Nov[i].X;
        inc(j);
        PM^[j] := Nov[i].X * Nov[i].Y;
        inc(j);
        PM^[j] := Nov[i].Y * Nov[i].Y;
        inc(j);
        PM^[j] := 1;
        inc(j);
        PM^[j] := 0;
        inc(j);
        PM^[j] := 0;
        inc(j);
        PM^[j] := 0;
        inc(j);
        PM^[j] := 0;
        inc(j);
        PM^[j] := 0;
        inc(j);
        PM^[j] := 0;

        inc(k);
        VPS^[k]    := Sta[i].X;

        inc(j);
        PM^[j] := 0;
        inc(j);
        PM^[j] := 0;
        inc(j);
        PM^[j] := 0;
        inc(j);
        PM^[j] := 0;
        inc(j);
        PM^[j] := 0;
        inc(j);
        PM^[j] := 0;
        inc(j);
        PM^[j] := Nov[i].X;
        inc(j);
        PM^[j] := Nov[i].Y;
        inc(j);
        PM^[j] := Nov[i].X * Nov[i].X;
        inc(j);
        PM^[j] := Nov[i].X * Nov[i].Y;
        inc(j);
        PM^[j] := Nov[i].Y * Nov[i].Y;
        inc(j);
        PM^[j] := 1;

        inc(k);
        VPS^[k]    := Sta[i].Y;
      end;

      PocetRovnic := DimenseTransformace * PocetDvojicIdBodu;

      if not ResSoustRovnic(V, PM, VPS, InvKlic, PocetRovnic, PocetParametru, DimenseTransformace) then
      begin
        NelzeVypocistKlic := true;
        CisloChyby        := 2;
      end;
    end;
    FreeMem(V, SizeOf(extended) * PocetDvojicIdBodu);
    FreeMem(PM, DimenseTransformace * SizeOf(extended) * PocetDvojicIdBodu * PocetParametru);
    FreeMem(VPS, DimenseTransformace * SizeOf(extended) * PocetDvojicIdBodu);
  end;
end;


constructor TPolynomicka3St2D.Init(
                                   var PoleIdBodu       : PExtVector;
                                       PocetDvojicIdBodu: integer);
const
  PocetParametru = 20;

var
  V: PExtVector;
  PM: PExtVector;
  VPS: PExtVector;
  i, j, k, PocetRovnic: integer;

begin
  DostatecnyPocetDvojic := 10;

  if PocetDvojicIdBodu < DostatecnyPocetDvojic then
  begin
    NelzeVypocistKlic := true;
    CisloChyby        := 3;
  end else
  begin
    inherited Init(PoleIdBodu, PocetDvojicIdBodu);
    GetMem(V, SizeOf(extended) * PocetDvojicIdBodu);
    GetMem(PM, DimenseTransformace * SizeOf(extended) * PocetDvojicIdBodu * PocetParametru);
    GetMem(VPS, DimenseTransformace * SizeOf(extended) * PocetDvojicIdBodu);

    j := 0;
    k := 0;

    for i := 1 to PocetDvojicIdBodu do
    begin
      V^[i]  := Vaha[i];

      inc(j);
      PM^[j] := Sta[i].X;
      inc(j);
      PM^[j] := Sta[i].Y;
      inc(j);
      PM^[j] := Sta[i].X*Sta[i].X;
      inc(j);
      PM^[j] := Sta[i].X*Sta[i].Y;
      inc(j);
      PM^[j] := Sta[i].Y*Sta[i].Y;
      inc(j);
      PM^[j] := Sta[i].X*Sta[i].X*Sta[i].X;
      inc(j);
      PM^[j] := Sta[i].X*Sta[i].X*Sta[i].Y;
      inc(j);
      PM^[j] := Sta[i].X*Sta[i].Y*Sta[i].Y;
      inc(j);
      PM^[j] := Sta[i].Y*Sta[i].Y*Sta[i].Y;
      inc(j);
      PM^[j] := 1;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;

      inc(k);
      VPS^[k]    := Nov[i].X;

      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := Sta[i].X;
      inc(j);
      PM^[j] := Sta[i].Y;
      inc(j);
      PM^[j] := Sta[i].X * Sta[i].X;
      inc(j);
      PM^[j] := Sta[i].X * Sta[i].Y;
      inc(j);
      PM^[j] := Sta[i].Y * Sta[i].Y;
      inc(j);
      PM^[j] := Sta[i].X * Sta[i].X * Sta[i].X;
      inc(j);
      PM^[j] := Sta[i].X * Sta[i].X * Sta[i].Y;
      inc(j);
      PM^[j] := Sta[i].X * Sta[i].Y * Sta[i].Y;
      inc(j);
      PM^[j] := Sta[i].Y * Sta[i].Y * Sta[i].Y;
      inc(j);
      PM^[j] := 1;

      inc(k);
      VPS^[k]    := Nov[i].Y;
    end;

    PocetRovnic := DimenseTransformace * PocetDvojicIdBodu;

    if not ResSoustRovnic(V, PM, VPS, Klic, PocetRovnic, PocetParametru, DimenseTransformace) then
    begin
      NelzeVypocistKlic := true;
      CisloChyby        := 2;
    end;

    if not NelzeVypocistKlic then
    begin
      j := 0;
      k := 0;

      for i := 1 to PocetDvojicIdBodu do
      begin
        inc(j);
        PM^[j] := Nov[i].X;
        inc(j);
        PM^[j] := Nov[i].Y;
        inc(j);
        PM^[j] := Nov[i].X * Nov[i].X;
        inc(j);
        PM^[j] := Nov[i].X * Nov[i].Y;
        inc(j);
        PM^[j] := Nov[i].Y * Nov[i].Y;
        inc(j);
        PM^[j] := Nov[i].X * Nov[i].X * Nov[i].X;
        inc(j);
        PM^[j] := Nov[i].X * Nov[i].X * Nov[i].Y;
        inc(j);
        PM^[j] := Nov[i].X * Nov[i].Y * Nov[i].Y;
        inc(j);
        PM^[j] := Nov[i].Y * Nov[i].Y * Nov[i].Y;
        inc(j);
        PM^[j] := 1;
        inc(j);
        PM^[j] := 0;
        inc(j);
        PM^[j] := 0;
        inc(j);
        PM^[j] := 0;
        inc(j);
        PM^[j] := 0;
        inc(j);
        PM^[j] := 0;
        inc(j);
        PM^[j] := 0;
        inc(j);
        PM^[j] := 0;
        inc(j);
        PM^[j] := 0;
        inc(j);
        PM^[j] := 0;
        inc(j);
        PM^[j] := 0;

        inc(k);
        VPS^[k]    := Sta[i].X;

        inc(j);
        PM^[j] := 0;
        inc(j);
        PM^[j] := 0;
        inc(j);
        PM^[j] := 0;
        inc(j);
        PM^[j] := 0;
        inc(j);
        PM^[j] := 0;
        inc(j);
        PM^[j] := 0;
        inc(j);
        PM^[j] := 0;
        inc(j);
        PM^[j] := 0;
        inc(j);
        PM^[j] := 0;
        inc(j);
        PM^[j] := 0;
        inc(j);
        PM^[j] := Nov[i].X;
        inc(j);
        PM^[j] := Nov[i].Y;
        inc(j);
        PM^[j] := Nov[i].X * Nov[i].X;
        inc(j);
        PM^[j] := Nov[i].X * Nov[i].Y;
        inc(j);
        PM^[j] := Nov[i].Y * Nov[i].Y;
        inc(j);
        PM^[j] := Nov[i].X * Nov[i].X * Nov[i].X;
        inc(j);
        PM^[j] := Nov[i].X * Nov[i].X * Nov[i].Y;
        inc(j);
        PM^[j] := Nov[i].X * Nov[i].Y * Nov[i].Y;
        inc(j);
        PM^[j] := Nov[i].Y * Nov[i].Y * Nov[i].Y;
        inc(j);
        PM^[j] := 1;

        inc(k);
        VPS^[k]    := Sta[i].Y;
      end;

      PocetRovnic := DimenseTransformace * PocetDvojicIdBodu;

      if not ResSoustRovnic(V, PM, VPS, InvKlic, PocetRovnic, PocetParametru, DimenseTransformace) then
      begin
        NelzeVypocistKlic := true;
        CisloChyby        := 2;
      end;
    end;
    FreeMem(V, SizeOf(extended) * PocetDvojicIdBodu);
    FreeMem(PM, DimenseTransformace * SizeOf(extended) * PocetDvojicIdBodu * PocetParametru);
    FreeMem(VPS, DimenseTransformace * SizeOf(extended) * PocetDvojicIdBodu);
  end;
end;


function TransformaceInit(
                          PoleIdBodu       : PExtVector;
                          PocetDvojicIdBodu: integer;
                          Typ              : byte): PTransformace;
begin
  if Typ = 0 then {Podobn 2D}
  begin
    TransformaceInit := New(PPodobnostni2D, Init(PoleIdBodu, PocetDvojicIdBodu));
  end
  else if Typ = 1 then {Afinn  2D}
  begin
    TransformaceInit := New(PAfinni2D, Init(PoleIdBodu, PocetDvojicIdBodu));
  end
  else if Typ = 2 then {Kolin  2D}
  begin
    TransformaceInit := New(PKolinearni2D, Init(PoleIdBodu, PocetDvojicIdBodu));
  end
  else if Typ = 3 then {Podobn 3D}
  begin
    TransformaceInit := New(PPodobnostni3D, Init(PoleIdBodu, PocetDvojicIdBodu));
  end
  else if Typ = 4 then {Afinn  3D}
  begin
    TransformaceInit := New(PAfinni3D, Init(PoleIdBodu, PocetDvojicIdBodu));
  end
  else if Typ = 5 then {Kolin  3D}
  begin
    TransformaceInit := New(PKolinearni3D, Init(PoleIdBodu, PocetDvojicIdBodu));
  end
  else if Typ = 6 then {2 St Pol}
  begin
    TransformaceInit := New(PPolynomicka2St2D, Init(PoleIdBodu, PocetDvojicIdBodu));
  end
  else if Typ = 7 then {3 St Pol}
  begin
    TransformaceInit := New(PPolynomicka3St2D, Init(PoleIdBodu, PocetDvojicIdBodu));
  end
  else
    TransformaceInit := nil;
end;

procedure TransformaceDone(
                           var Tran: PTransformace);
begin
  if Tran <> nil then
    Dispose(Tran, Done);
  Tran := nil;
end;

procedure TransformaceTransformuj(
                                        Tran    : PTransformace;
                                  const ZdrojBod: Bod;
                                  var   CilBod  : Bod);

begin
  if Tran <> nil then
    Tran^.Transformuj(ZdrojBod, CilBod);
end;

procedure TransformaceInvTransformuj(
                                           Tran    : PTransformace;
                                     const ZdrojBod: Bod;
                                     var   CilBod  : Bod);
begin
  if Tran <> nil then
    Tran^.InvTransformuj(ZdrojBod, CilBod);
end;


function TransformaceDejPocetIdB(
                                 Tran: PTransformace): integer;

begin
  if Tran <> nil then
    TransformaceDejPocetIdB := Tran^.DejPocetIdB;
end;


function TransformaceVratCisloChyby(
                                    Tran: PTransformace): integer;
begin
  if Tran <> nil then
    TransformaceVratCisloChyby := Tran^.VratCisloChyby;
end;

function TransformaceKlicVypocten(
                                  Tran: PTransformace): boolean;
begin
  if Tran <> nil then
    TransformaceKlicVypocten := Tran^.KlicVypocten;
end;

function TransformaceVratPopisChyby(
                                    Tran: PTransformace): string;
begin
  if Tran <> nil then
    TransformaceVratPopisChyby := Tran^.VratPopisChyby;
end;

procedure TransformaceDejZdrojStred(
                                    Tran: PTransformace; var Bod: TranType.Bod);
begin
  if Tran <> nil then
    Bod := Tran^.ZdrojStred;
end;

procedure TransformaceDejCilStred(
                                  Tran: PTransformace; var Bod: TranType.Bod);
begin
  if Tran <> nil then
    Bod := Tran^.CilStred;
end;

procedure TransformaceDejNov(
                             Tran: PTransformace; i: integer; var Bod: TranType.Bod);
begin
  if Tran <> nil then
    Bod := Tran^.Nov[i];
end;

procedure TransformaceDejSta(
                             Tran: PTransformace; i: integer; var Bod: TranType.Bod);
begin
  if Tran <> nil then
    Bod := Tran^.Sta[i];
end;


procedure TransformaceZmenNov(
                              Tran: PTransformace; Puv, No: integer);
begin
  if Tran <> nil then
    with Tran^ do
      Nov[Puv] := Nov[No];
end;

procedure TransformaceZmenSta(
                              Tran: PTransformace; Puv, No: integer);

begin
  if Tran <> nil then
    with Tran^ do
      Sta[Puv] := Sta[No];
end;

procedure TransformaceNastavPocetIdBodu(
                                        Tran: PTransformace; aPocetIdBodu: integer);
begin
  if Tran <> nil then
    Tran^.PocetIdentBodu := aPocetIdBodu;
end;

function TransformaceDejNazevTransformace(
                                          Tran: PTransformace): PChar;
begin
  if Tran <> nil then
    TransformaceDejNazevTransformace := Tran^.NazevTransformace;
end;

function TransformaceDejNazevTransfTabulky(
                                           Tran: PTransformace): PChar;
begin
  if Tran <> nil then
    TransformaceDejNazevTransfTabulky := Tran^.NazevTransformacniTabulky;
end;

procedure TransformaceDejSourRohu(
                                  Tran: PTransformace; var aSourRohy: TObdelnik);
begin
  if Tran <> nil then
    aSourRohy := Tran^.SourRohy;
end;

procedure TransformaceNastavNazevTransformace(Tran: PTransformace; aNazevTransformace: PChar);
begin
  if Tran <> nil then
    StrCopy(Tran^.NazevTransformace, aNazevTransformace);
end;

procedure TransformaceNastavNazevTransfTabulky(Tran: PTransformace; aNazevTransfTabulky: PChar);
begin
  if Tran <> nil then
    StrCopy(Tran^.NazevTransformacniTabulky, aNazevTransfTabulky);
end;

procedure TransformaceNastavSourRohu(Tran: PTransformace; aSourRohy: TObdelnik);
begin
  if Tran <> nil then
    Tran^.SourRohy := aSourRohy;
end;


function TransformaceDejInvKlic(Tran: PTransformace; i: integer): extended;
begin
  if Tran <> nil then
    TransformaceDejInvKlic := Tran^.InvKlic[i];
end;


function TransformaceLojza(Typ: byte): pointer;
begin
  if Typ = 0 then {Podobn 2D}
  begin
    TransformaceLojza := New(PPodobnostni2D, Lojza);
  end
  else if Typ = 1 then {Afinn  2D}
  begin
    TransformaceLojza := New(PAfinni2D, Lojza);
  end
  else if Typ = 2 then {Kolin  2D}
  begin
    TransformaceLojza := New(PKolinearni2D, Lojza);
  end
  else if Typ = 3 then {Podobn 3D}
  begin
    TransformaceLojza := New(PPodobnostni3D, Lojza);
  end
  else if Typ = 4 then {Afinn  3D}
  begin
    TransformaceLojza := New(PAfinni3D, Lojza);
  end
  else if Typ = 5 then {Kolin  3D}
  begin
    TransformaceLojza := New(PKolinearni3D, Lojza);
  end
  else if Typ = 6 then {2 St Pol}
  begin
    TransformaceLojza := New(PPolynomicka2St2D, Lojza);
  end
  else if Typ = 7 then {3 St Pol}
  begin
    TransformaceLojza := New(PPolynomicka3St2D, Lojza);
  end
  else
    TransformaceLojza := nil;
end;

procedure TransformaceNastavInvKlic(
                                    Tran: PTransformace; i: integer; InvKl: extended);
begin
  if Tran <> nil then
    Tran^.InvKlic[i] := InvKl;
end;

procedure TransformaceNastavKlic(
                                 Tran: PTransformace; i: integer; Kl: extended);
begin
  if Tran <> nil then
    Tran^.Klic[i] := Kl;
end;

procedure TransformaceNastavZdrojStred(
                                       Tran: PTransformace; Bod: TranType.Bod);
begin
  if Tran <> nil then
    Tran^.ZdrojStred := Bod;
end;

procedure TransformaceNastavCilStred(
                                     Tran: PTransformace; Bod: TranType.Bod);
begin
  if Tran <> nil then
    Tran^.CilStred := Bod;
end;

procedure TransformaceNastavNov(
                                Tran: PTransformace; i: integer; Bod: TranType.Bod);

begin
  if Tran <> nil then
    Tran^.Nov[i] := Bod;
end;

procedure TransformaceNastavSta(
                                Tran: PTransformace; i: integer; Bod: TranType.Bod);

begin
  if Tran <> nil then
    Tran^.Sta[i] := Bod;
end;

function TransformaceDejKlic(
                             Tran: PTransformace; i: integer): extended;
begin
  if Tran <> nil then
    TransformaceDejKlic := Tran^.Klic[i];
end;


function TransformaceDejDimenzi(
                                Tran: PTransformace): byte;

begin
  if Tran <> nil then
    TransformaceDejDimenzi := Tran^.Dimense;
end;

end.
