unit F_editor;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Buttons, StdCtrls, ExtCtrls, DBTables, DB;

type
  TFEditor = class(TForm)
    LBAll: TListBox;
    DoKey: TSpeedButton;
    DoAllKey: TSpeedButton;
    LBFields: TListBox;
    DeleteAllKey: TSpeedButton;
    DeleteKey: TSpeedButton;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    Bevel1: TBevel;
    Chbs: TCheckBox;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    Label8: TLabel;
    procedure ChbsClick(Sender: TObject);
    procedure DoKeyClick(Sender: TObject);
    procedure DoAllKeyClick(Sender: TObject);
    procedure DeleteAllKeyClick(Sender: TObject);
    procedure DeleteKeyClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure LBAllDblClick(Sender: TObject);
    procedure LBFieldsDblClick(Sender: TObject);
  private
    { Private declarations }
    procedure DoFields;
    procedure DoLBAll;
    procedure DoAllFields;
    procedure DeleteAllFields;
    procedure UpField;
    procedure DownField;
    procedure OznListAdoB(Alist, Blist: TlistBox);
  public
    { Public declarations }
     procedure GetFields(aTbl: TTable);
     procedure SetFields(aTbl: TTable);
  end;


implementation

{$R *.DFM}

procedure TFEditor.ChbsClick(Sender: TObject);
begin
  LBAll.Sorted := ChBs.Checked;
end;


procedure TFEditor.DoKeyClick(Sender: TObject);
begin
  DoFields;
end;



procedure TFEditor.DoAllKeyClick(Sender: TObject);
begin
  DoAllFields;
end;



procedure TFEditor.DeleteAllKeyClick(Sender: TObject);
begin
  DeleteAllFields;
end;



procedure TFEditor.DeleteKeyClick(Sender: TObject);
begin
   DoLBAll;
end;



procedure TFEditor.SpeedButton1Click(Sender: TObject);
begin
  UpField;
end;



procedure TFEditor.SpeedButton2Click(Sender: TObject);
begin
  DownField;
end;



procedure TFEditor.DoFields;
begin
   OznListAdoB(LBAll, LBFields);

end;



procedure TFEditor.DoLBAll;
begin
   OznListAdoB(LBFields, LBAll);
end;



procedure TFEditor.OznListAdoB(Alist, Blist: TlistBox);
var
   i: Integer;
begin
   for i := 0 to Alist.Items.Count - 1 do
   begin
      if Alist.Selected[i] then
      begin
         Blist.Items.Add(Alist.Items[i]);
      end;
   end;

   i:= 0;
   while i < Alist.Items.Count do
   begin
      if Alist.Selected[i] then
      begin
         Alist.Items.Delete(i);
      end
      else
        inc(i)
   end;
end;


procedure TFEditor.DoAllFields;
var
   i: Integer;
begin
  for i := 0 to LBAll.Items.Count - 1 do
      LBFields.Items.Add(LBAll.Items[i]);

  LBAll.Items.Clear;
end;



procedure TFEditor.DeleteAllFields;
var
  i: integer;
begin

  for i := 0 to LBFields.Items.Count - 1 do
      LBAll.Items.Add(LBFields.Items[i]);

  LBFields.Items.Clear;
end;



procedure TFEditor.UpField;
var
   i: integer;
begin
   i:= 0;
   while i < LBFields.Items.Count do
   begin
      if (LBFields.Selected[i] and (i > 0)) then
      begin
         LBFields.Items.Move(i,i-1);
         LBFields.Selected[i-1] := true;
      end
      else
        inc(i)
   end;
end;



procedure TFEditor.DownField;
var
   i: integer;
begin
   i := LBFields.Items.Count - 1;
   while i >= 0  do
   begin
      if (LBFields.Selected[i] and (i < LBFields.Items.Count-1)) then
      begin
         LBFields.Items.Move(i,i+1);
         LBFields.Selected[i+1] := true;
      end
      else
        dec(i)
   end;
end;



procedure TFEditor.LBAllDblClick(Sender: TObject);
begin
  DoFields;
end;



procedure TFEditor.LBFieldsDblClick(Sender: TObject);
begin
  DoLBAll;
end;



procedure TFEditor.SetFields(aTbl: TTable);
var
   i : Integer;
begin
   aTbl.DisableControls;

   LBAll.Items.Clear;
   LBFields.Items.Clear;

   for i := 0 to aTbl.FieldCount - 1 do
   begin
      if aTbl.Fields[i].Visible then
         LBFields.Items.Add(aTbl.Fields[i].FieldName)
      else
         LBAll.Items.Add(aTbl.Fields[i].FieldName);
   end;

   aTbl.EnableControls;
end;


procedure TFEditor.GetFields(aTbl: TTable);
var
   i: Integer;
begin
   aTbl.DisableControls;

   for i := 0 to aTbl.FieldCount - 1 do
      aTbl.Fields[i].Visible := False;

   for i := 0 to LBFields.Items.Count - 1 do
   begin
      aTbl.FieldByName(LBFields.Items[i]).Index := i;
      aTbl.FieldByName(LBFields.Items[i]).visible := True;
   end;

   aTbl.EnableControls;
end;

{
procedure TFEditor.GetFields(aTbl: TTable);
var
   ListFields: TStrings;
   i: Integer;
begin
   aTbl.DisableControls;

   ListFields := TStrings.Create;
   ListFields := LBFields.Items;

   for i := 0 to aTbl.FieldCount - 1 do
      aTbl.Fields[i].Visible := False;

   for i := 0 to ListFields.Count - 1 do
   begin
      aTbl.FieldByName(ListFields[i]).index := i;
      aTbl.FieldByName(ListFields[i]).visible := True;
   end;

   aTbl.EnableControls;
end;
 }
end.
