unit Miniled_Import;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, FMX.Effects,
  FMX.Layouts, FMX.ListBox, System.ImageList, FMX.ImgList, FMX.StdCtrls,
  FMX.Controls.Presentation,
  Elements, FMX.Edit;

type
  TImportLayer_Form = class(TForm)
    Layout1: TLayout;
    Label1: TLabel;
    Layout2: TLayout;
    b_Store: TButton;
    b_Cancel: TButton;
    ImageList1: TImageList;
    b_Open: TButton;
    ReflectionEffect1: TReflectionEffect;
    Layout3: TLayout;
    l_Info: TLabel;
    l_Info1: TLabel;
    Layout_Options: TLayout;
    Layout_Name: TLayout;
    Layout_Data: TLayout;
    rb_Nochange: TRadioButton;
    rb_Change: TRadioButton;
    rb_AddData: TRadioButton;
    rb_ReplaceData: TRadioButton;
    ed_Nazev: TEdit;
    procedure b_OpenClick(Sender: TObject);
    procedure b_CancelClick(Sender: TObject);
    procedure b_StoreClick(Sender: TObject);
    procedure rb_NochangeChange(Sender: TObject);
    procedure ed_NazevChange(Sender: TObject);
    procedure rb_AddDataChange(Sender: TObject);
  private
    Data: TEntity;
    { Private declarations }
  public
    FileName: string;
    ReadyToImport: boolean;
    NoButton: boolean;
    Status: integer;         // 0 nic 1 addLayer 2 replace 3 joindata 4 change name
    procedure InfoRed(Realy: boolean);
    procedure Start(Nobut: boolean; const aFileName: string);
    function  RemoteStart(Nobut: boolean; const aFileName: string; ShowDialog: boolean; WhatToDo: integer; const aLayerName: string): integer;
    function  RemoteStore(WhatToDo: integer; const aLayerName: string): boolean;
    function LoadData: boolean;
    function CheckData: boolean;
    function CheckName(const aName: string; var anAlias: string): boolean;
    procedure OnEdit;
    procedure OnSelectFile(const S: string);
  end;

var
  ImportLayer_Form: TImportLayer_Form;

implementation
uses
   e_Type,
   t_Loader,
   MiniLed_Main,
   e_GeometryElement,
   e_GeometryEx,
   t_xFileDialog;

{$R *.fmx}

procedure TImportLayer_Form.b_CancelClick(Sender: TObject);
begin
   Data := nil;
   close;
end;

procedure TImportLayer_Form.b_OpenClick(Sender: TObject);
begin
//   close;
   XFileDialog.Filter := '.orb';
   XFileDialog.Directory := '/';
   XFileDialog.ed_Caption.Text := 'Vbr souboru pro import';
   XFileDialog.OnSelect := OnSelectFile;
//   xFileDialog.DirsOnly := true;
//   l_Info.Text := 'Vyberte soubor pro import'
   XFileDialog.Show;
end;

procedure TImportLayer_Form.b_StoreClick(Sender: TObject);
var
   anAlias: string;
   Lay,LayN,L,LN: TComplicatedGECollection;
   i: integer;
begin
   if not ReadyToImport then
   begin
      ShowMessage('Data nelze importovat, odstrate problmy!');
      exit;
   end;
   // vlastni import
   LayN := TComplicatedGECollection(Data);
   if Status = 4 then   // changeName
   begin
      LayN.Name := ed_Nazev.Text;
      LayN.Text := LayN.Name;
      Status := 1;
   end;
   if Status = 1 then  // AddLayer
   begin
      if LayN.Text = '' then
         LayN.Text := LayN.Name;
      LayN.Color := TAlphaColors.Blue;
      MainForm.Layers.AddElement(LayN);
   end;
   if Status = 2 then
   begin
      Lay := TComplicatedGECollection(MainForm.Layers.FindElementName(LayN.Name));
      Lay.FreeAll;
      Lay.AddAllFrom := LayN;
      Lay.ResetAndUpdate;
   end;
   if Status = 3 then
   begin
      Lay := TComplicatedGECollection(MainForm.Layers.FindElementName(LayN.Name));
      for i := 0 to LayN.LastIndex do
      begin
         LN := LayN.Layers[i];
         L := Lay.Layer[LN.Name];
         L.AddAllFrom := LN;
         L.ResetAndUpdate;
      end;
      Lay.ResetAndUpdate;
   end;
   MainForm.Layers_Save;
   MainForm.Layers_UpdateList;
   Data := nil;
   Close;
//   ShowMessage(IntToStr(Status));
end;

function TImportLayer_Form.CheckData: boolean;
var
   Lay: TComplicatedGECollection;
   anAlias: string;
begin
   result := false;
//   Vseobecne info
   Status := 0;
   if Data = nil then
   begin
      if not NoButton then
         b_Open.Visible := true;
      InfoRed(true);
      l_Info.Text := 'Obsah souboru se nepodailo nast !'
   end
   else
   begin
      if not(Data is TComplicatedGECollection) then
      begin
         InfoRed(true);
         l_Info.Text := 'Data v souboru nejsou kompatibiln s touto aplikac !';
         if not NoButton then
            b_Open.Visible := true;
         exit;
      end;
      Lay := TComplicatedGECollection(DATA);
      l_Info.Text := 'Pro import byla natena vrstva '+Lay.Name+' ['+Lay.Text+']';
      result := true;
      // Kontrola nazvu
      if not CheckName(Lay.Name, anAlias) then
      begin
         Layout_Options.Visible := true;
         rb_Nochange.IsChecked := false;
         rb_Nochange.IsChecked := true;
         rb_AddDataChange(nil);
      end
      else
      begin
         Status := 1;
         ReadyToImport := true;
         b_Store.ImageIndex := 2;
         l_Info1.Text := 'Pokraujte tlatkem Nahrt.'
      end;

   end;

end;

function TImportLayer_Form.CheckName(const aName: string; var anAlias: string): boolean;
var
   e: TComplicatedGECollection;
begin
   result := false;
   anAlias := '';
   if Data = nil then
      exit;
   e := TComplicatedGECollection(MainForm.Layers.FindElementName(aName));
   result := e = nil;
   if e <> nil then
      anAlias := e.Text;
end;

procedure TImportLayer_Form.ed_NazevChange(Sender: TObject);
begin
   OnEdit;
end;

procedure TImportLayer_Form.InfoRed(Realy: boolean);
begin
   if Realy then
      l_Info.FontColor := TAlphaColors.Red
   else
      l_Info.FontColor := TAlphaColors.Black;
end;

function TImportLayer_Form.LoadData: boolean;
var
   L: TLoad;
begin
   result := false;
   b_Open.Visible := false;
   l_Info.Text := 'ten dat ze souboru ....';
   L := TLoad.CreateAll(FileName);
   L.NoProgress := true;
   try
   L.DoIt;
   if not(L.output is TOwnerEntity) then exit;
   Data := TOwnerEntity(L.Output);
   finally

   end;
   result := CheckData;
end;

procedure TImportLayer_Form.OnEdit;
var
   Al: string;
   TooShort: boolean;
begin
   TooShort := Length(ed_Nazev.Text) < 3;
   if not CheckName(ed_Nazev.Text,Al) or TooShort then
   begin
      Status := 0;
      InfoRed(true);
      if TooShort then
         l_Info.Text := 'Nzev je pli krtk!'
      else
         l_Info.Text := 'Vrstva existuje ('+Al+')!';
      l_Info1.Text := '...';
      ReadyToImport := false;
      b_Store.ImageIndex := 0;
   end
   else
   begin
      Status := 4;
      InfoRed(false);
      l_Info.Text := 'Nzev OK';
      l_Info1.Text := 'Tlatkem nahrt dokonte import';
      ReadyToImport := true;
      b_Store.ImageIndex := 2;
   end;
//   Application.ProcessMessages;
end;

procedure TImportLayer_Form.OnSelectFile(const S: string);
begin
   InfoRed(false);
   FileName := S;
   LoadData;
end;


procedure TImportLayer_Form.rb_AddDataChange(Sender: TObject);
var
   anAlias: string;
begin
   if rb_AddData.IsChecked then
      Status := 3
   else
      Status := 2;
   if not CheckName(Data.Name,anAlias) then
   begin
      InfoRed(true);
      l_Info.Text := 'Vrstva s internm nzvem '+Data.Name+' ji existuje pod aliasem '+anAlias+' !';
   end;
//   l_Info1.Text := 'Nsledujc monosti:';
   l_Info1.Text := 'Import dokonete tlatkem Nahrt';
   ReadyToImport := true;
   b_Store.ImageIndex := 2;
end;

procedure TImportLayer_Form.rb_NochangeChange(Sender: TObject);
begin
   if rb_Nochange.IsChecked then
   begin
      Layout_Data.Visible := true;
      Layout_Name.Visible := false;
      rb_ReplaceData.IsChecked := true;
   end
   else
   begin
      Layout_Data.Visible := false;
      Layout_Name.Visible := true;
      ed_Nazev.Text := Data.Name;
      onEdit;
      ed_Nazev.SetFocus;
   end;
   rb_AddDataChange(nil);
end;

function TImportLayer_Form.RemoteStart(Nobut: boolean; const aFileName: string; ShowDialog: boolean; WhatToDo: integer; const aLayerName: string): integer;
begin
   result := 0;
   if ShowDialog then
   begin
      Start(NoBut, aFileName);
   end
   else
   begin
      Status := 0;
      Data := nil;
      FileName := '';
      ReadyToImport := false;
      if aFileName = '' then
      begin
         result := 1;
         exit;
      end
      else
      begin
         FileName := aFileName;
         if not LoadData then
         begin
            result := 2;
            exit;
         end;
         if not RemoteStore(WhatToDo, aLayerName) then
            result := 3;
      end;
   end;
end;

function TImportLayer_Form.RemoteStore(WhatToDo: integer;  const aLayerName: string): boolean;
var
   anAlias: string;
   Lay,LayN,L,LN: TComplicatedGECollection;
   i: integer;
begin
   result := true;
   // vlastni import
   LayN := TComplicatedGECollection(Data);
   if aLayerName <> '' then   // changeName
   begin
      LayN.Name := aLayerName;
   end;
   LayN.Text := LayN.Name;
   if WhatToDo = 1 then  // AddLayer
   begin
      i := 1;
      while not CheckName(LayN.Name,anAlias) do
      begin
         LayN.Name := LayN.Name + IntToStr(i);
      end;
      if LayN.Text = '' then
         LayN.Text := LayN.Name;
      LayN.Color := TAlphaColors.Blue;
      MainForm.Layers.AddElement(LayN);
   end;
   if WhatToDo = 2 then
   begin
      Lay := TComplicatedGECollection(MainForm.Layers.FindElementName(LayN.Name));
      if Lay <> nil then
      begin
         Lay.FreeAll;
         Lay.AddAllFrom := LayN;
         Lay.ResetAndUpdate;
      end
      else
      begin
         LayN.Color := TAlphaColors.Blue;
         MainForm.Layers.AddElement(LayN);
      end;
   end;
   if Status = 3 then
   begin
      Lay := TComplicatedGECollection(MainForm.Layers.FindElementName(LayN.Name));
      if Lay <> nil then
      begin
         for i := 0 to LayN.LastIndex do
         begin
            LN := LayN.Layers[i];
            L := Lay.Layer[LN.Name];
            L.AddAllFrom := LN;
            L.ResetAndUpdate;
         end;
         Lay.ResetAndUpdate;
      end
      else
      begin
         LayN.Color := TAlphaColors.Blue;
         MainForm.Layers.AddElement(LayN);
      end;
   end;
   MainForm.Layers_Save;
   MainForm.Layers_UpdateList;
   Data := nil;
end;

procedure TImportLayer_Form.Start(Nobut: boolean; const aFileName: string);
begin
   Show;
   Status := 0;
   Data := nil;
   FileName := '';
   b_Store.ImageIndex := 0;
   ReadyToImport := false;
   NoButton := Nobut;
   if not NoButton then
      b_Open.Visible := true;
   InfoRed(false);
   l_Info1.Text := '...';
   Layout_Options.Visible := false;
   Layout_Name.Visible := false;
   Layout_Data.Visible := false;
   if aFileName = '' then
   begin
      l_Info.Text := 'Vyberte soubor pro import'
   end
   else
   begin
      FileName := aFileName;
      LoadData;
   end;
end;

end.
