unit Miniled_notes;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, FMX.StdCtrls,
  FMX.SearchBox,
  FMX.Layouts, FMX.ListBox, FMX.TabControl, FMX.Effects, FMX.Edit,
  FMX.Controls.Presentation,
  e_GeometryElement;

type
  TMiniLed_Notes_Form = class(TForm)
    Tabs: TTabControl;
    tab_Routes: TTabItem;
    RoutesList: TListBox;
    tab_Notes: TTabItem;
    NotesList: TListBox;
    ShadowEffect1: TShadowEffect;
    Panel1: TPanel;
    SearchBox1: TSearchBox;
    SearchBox2: TSearchBox;
    Panel2: TPanel;
    b_Delete: TButton;
    ShadowEffect2: TShadowEffect;
    procedure b_DeleteClick(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Single);
    procedure RoutesListItemClick(const Sender: TCustomListBox;
      const Item: TListBoxItem);
    procedure NotesListItemClick(const Sender: TCustomListBox;
      const Item: TListBoxItem);
  private
    { Private declarations }
  public
    ActiveLayer: TComplicatedGECollection;
  end;

var
  MiniLed_Notes_Form: TMiniLed_Notes_Form;

implementation
uses
  MiniLed_main,
  e_Geometry;


{$R *.fmx}

procedure TMiniLed_Notes_Form.b_DeleteClick(Sender: TObject);
var
   LI: TListBoxItem;
   T: TTextElement;
   L: TPolyLineElement;
begin
   if Tabs.ActiveTab = tab_Notes  then
   begin
      LI := NotesList.Selected;
      if LI = nil then exit;
      T := TTextElement(LI.Data);
      with MainForm do
      begin
         ActiveLayer.Layer['N'].ElementToFree := T;
         Layers_Save;
         Review(false);
         Application.ProcessMessages;
      end;
      NotesList.Items.Delete(NotesList.ItemIndex);
   end
   else
   begin
      LI := RoutesList.Selected;
      if LI = nil then exit;
      L := TPolyLineElement(LI.Data);
      with MainForm do
      begin
         ActiveLayer.Layer['L'].ElementToFree := L;
         Layers_Save;
         Review(false);
         Application.ProcessMessages;
      end;
      RoutesList.Items.Delete(RoutesList.ItemIndex);
   end;

end;

procedure TMiniLed_Notes_Form.FormMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Single);
begin
  close;
end;

procedure TMiniLed_Notes_Form.NotesListItemClick(const Sender: TCustomListBox;
  const Item: TListBoxItem);
var
   T: TTextElement;
begin
   if Item = nil  then exit;
   if Item.Data = nil then exit;
   if not (Item.Data is TTextElement) then exit;
   T := TTextElement(Item.Data);
   //L.Update;
   with MainForm do
   begin
      CHangeProjection(T.X,T.Y,RealScale);
      if RealScale < 2000 then
         CHangeProjection(CenterX,CenterY,2000);
      Review(false);
   end;

end;

procedure TMiniLed_Notes_Form.RoutesListItemClick(const Sender: TCustomListBox;
  const Item: TListBoxItem);
var
   L: TPolyLineElement;
begin
   if Item = nil  then exit;
   if Item.Data = nil then exit;
   if not (Item.Data is TPolyLineElement) then exit;
   L := TPolyLineElement(Item.Data);
   L.Update;
   with MainForm do
   begin
      if not L.IsOverRegionEx(Minx,MinY,MaxX,MaxY) then
      begin
         CHangeProjectionByRect(L.MinX,L.MinY,L.MaxX,L.MaxY);
         if RealScale < 2000 then
            CHangeProjection(CenterX,CenterY,2000);
         Review(false);
      end;
      BlinkLine(L);
   end;

end;

end.
