unit Component_MiniOrbis;

interface

uses
  System.SysUtils, System.Classes,
  FMX.Types,
  e_LHCModel,
  MiniLed_Main;

type
  TMiniOrbis = class(TFmxObject)
  private
    FError: integer;
    FAutoOpenProject: Boolean;
    FAutoOpenProjectFile: String;
    FOnSelectJPRL: TNotifyEvent;
    FDataOnBackGround: boolean;
    FOnDataReady: TNotifyEvent;
    FOnMapReady: TNotifyEvent;
    FMapOnBackground: boolean;
    FOpenButtonVisible: boolean;
    procedure set_OnSelectJPRL(const Value: TNotifyEvent);
    function GetSelectedSkupina: Tgis_PorostniSkupina;
    procedure SetDataOnBackGround(const Value: boolean);
    procedure SetOnDataReady(const Value: TNotifyEvent);
    procedure SetOnMapReady(const Value: TNotifyEvent);
    procedure SetMapOnBackground(const Value: boolean);
//    FOnSelectJPRL: EventHandler;
    { Private declarations }
  protected
     FM: MiniLed_Main.TMainForm;

    function GetAutoOpenProject: boolean;
    function GetAutoOpenProjectFile: string;
    function GetDilec: string;
    function GetMapCloseIsVisible: boolean;
    function GetMapVisible: boolean;
    function GetOddeleni: string;
    function GetPorost: string;
    function GetSkupina: string;
    procedure set_Error(const Value: integer);
    procedure SetAutoOpenProject(const Value: boolean);
    procedure SetAutoOpenProjectFile(const Value: string);
    procedure SetDilec(const Value: string);
    procedure SetMapCloseIsVisible(const Value: boolean);
    procedure SetMapVisible(const Value: boolean);
    procedure SetOddeleni(const Value: string);
    procedure SetPorost(const Value: string);
    procedure SetSkupina(const Value: string);
    procedure SetOpenButtonVisible(const Value: boolean);
  public
    { Public declarations }
      function DoIt: String;
      procedure ShowTheForest(Highlight: boolean);
      procedure Import(aFileName: string; ShowDialog: boolean; WhatToDo: integer; aLayerName: string);
      property SelectedSkupina: Tgis_PorostniSkupina read GetSelectedSkupina;
  published
      property Oddeleni: string read GetOddeleni write SetOddeleni;
      property Dilec: string read GetDilec write SetDilec;
      property Porost: string read GetPorost write SetPorost;
      property Skupina: string read GetSkupina write SetSkupina;
      property MapVisible: boolean read GetMapVisible write SetMapVisible;
      property MapCloseIsVisible: boolean read GetMapCloseIsVisible write SetMapCloseIsVisible;
      property AutoOpenProject: boolean read GetAutoOpenProject write SetAutoOpenProject;
      property AutoOpenProjectFile: string read GetAutoOpenProjectFile write SetAutoOpenProjectFile;
      property OnSelectJPRL: TNotifyEvent read FOnSelectJPRL write set_OnSelectJPRL;
      property OnMapReady: TNotifyEvent read FOnMapReady write SetOnMapReady;
      property OnDataReady: TNotifyEvent read FOnDataReady write SetOnDataReady;
      property ErrCode: integer read FError write set_Error;
      property DataOnBackGround: boolean read FDataOnBackGround write SetDataOnBackGround;
      property MapOnBackground: boolean read FMapOnBackground write SetMapOnBackground;
      property OpenButtonVisible: boolean read FOpenButtonVisible write SetOpenButtonVisible;
  end;

procedure Register;

implementation
uses
   Fmx.Forms,
   Miniled_Notes,
   MiniLed_Import,
   t_xFileDialog;

procedure Register;
begin
  RegisterComponents('OrbisM', [TMiniOrbis]);
end;

{ TMiniOrbis }

function TMiniOrbis.DoIt: String;
begin
    if xFileDialog = nil then
       xFileDialog := TxFileDialog.Create(Application);
    if MiniLed_Notes_Form = nil then
       MiniLed_Notes_Form := TMiniLed_Notes_Form.Create(Application);
    if ImportLayer_Form = nil then
       ImportLayer_Form := TImportLayer_Form.Create(Application);

    if FM = nil then
    begin
       MainForm := TMainForm.Create(Application);
       FM := MainForm;
       FM.OnSelectJPRL := FOnSelectJPRL;
       FM.OnMapReady := FOnMapReady;
       FM.OnDataReady := FOnDataReady;
       FM.DataOnBackGround := DataOnBackGround;
       FM.hb_OpenProject.Visible := OpenButtonVisible;
    end;

//    Include(FM.OnSelectJPRL, OnSelectJPRL);
//    Include(FM.Closed, Form4_CLosed);
    if not MapOnBackground then
       FM.Show;
    if AutoOpenProject then
       FM.LoadProject(AutoOpenProjectFile);
end;

function TMiniOrbis.GetAutoOpenProject: boolean;
begin
   result := FAutoOpenProject;
end;

function TMiniOrbis.GetAutoOpenProjectFile: string;
begin
   result := FAutoOpenProjectFile;
end;

function TMiniOrbis.GetDilec: string;
begin
   result := '';
   if FM = nil then exit;
   result := FM.S_Dilec;
end;

function TMiniOrbis.GetMapCloseIsVisible: boolean;
begin
   result := false;
   if FM = nil  then exit;
   result := FM.CloseIsVisible;
end;

function TMiniOrbis.GetMapVisible: boolean;
begin
   result := false;
   if FM = nil  then exit;
   result := FM.Visible;
end;

function TMiniOrbis.GetOddeleni: string;
begin
   result := '';
   if FM = nil then exit;
   result := FM.S_Oddeleni;
end;

function TMiniOrbis.GetPorost: string;
begin
   result := '';
   if FM = nil then exit;
   result := FM.S_Porost;
end;

function TMiniOrbis.GetSelectedSkupina: Tgis_PorostniSkupina;
begin
   result := nil;
   if FM = nil then exit;
   if FM.FMSelector  <> nil then
      if FM.FMSelector.ActualFrame <> nil then
         result := Tgis_PorostniSkupina(FM.FMSelector.ActualFrame);
end;

function TMiniOrbis.GetSkupina: string;
begin
   result := '';
   if FM = nil then exit;
   result := FM.S_Skupina;
end;

procedure TMiniOrbis.Import(aFileName: string; ShowDialog: boolean; WhatToDo: integer; aLayerName: string);
begin
  if FM = nil then exit;
  if ImportLayer_Form = nil then exit;
  ImportLayer_Form.RemoteStart(true, aFileName, ShowDialog,WhatToDo,aLayername);
end;

procedure TMiniOrbis.SetAutoOpenProject(const Value: boolean);
begin
   FAutoOpenProject := Value;
end;

procedure TMiniOrbis.SetAutoOpenProjectFile(const Value: string);
begin
   FAutoOpenProjectFile := Value;
end;

procedure TMiniOrbis.SetDataOnBackGround(const Value: boolean);
begin
  FDataOnBackGround := Value;
  if FM = nil then exit;
  FM.DataOnBackGround := Value;
end;

procedure TMiniOrbis.SetDilec(const Value: string);
begin
   if FM = nil then exit;
   FM.S_Dilec := Value;
end;

procedure TMiniOrbis.SetMapCloseIsVisible(const Value: boolean);
begin
   if FM = nil then exit;
   FM.CloseIsVisible := Value;
end;

procedure TMiniOrbis.SetMapOnBackground(const Value: boolean);
begin
  FMapOnBackground := Value;
end;

procedure TMiniOrbis.SetMapVisible(const Value: boolean);
begin
   if FM = nil then exit;
   FM.Visible := Value;
end;

procedure TMiniOrbis.SetOddeleni(const Value: string);
begin
   if FM = nil then exit;
   FM.S_Oddeleni := Value;
end;

procedure TMiniOrbis.SetOnDataReady(const Value: TNotifyEvent);
begin
  FOnDataReady := Value;
end;

procedure TMiniOrbis.SetOnMapReady(const Value: TNotifyEvent);
begin
  FOnMapReady := Value;
end;

procedure TMiniOrbis.SetOpenButtonVisible(const Value: boolean);
begin
  FOpenButtonVisible := Value;
  if FM <> nil then
     FM.hb_OpenProject.Visible := Value;
end;

procedure TMiniOrbis.SetPorost(const Value: string);
begin
   if FM = nil then exit;
   FM.S_Porost := Value;
end;

procedure TMiniOrbis.SetSkupina(const Value: string);
begin
   if FM = nil then exit;
   FM.S_Skupina := Value;
end;

procedure TMiniOrbis.set_Error(const Value: integer);
begin
  FError := Value;
end;

procedure TMiniOrbis.set_OnSelectJPRL(const Value: TNotifyEvent);
begin
   FOnSelectJPRL := Value;
end;


procedure TMiniOrbis.ShowTheForest(Highlight: boolean);
begin
   ErrCode := 0;
   if FM = nil  then exit;
   FM.ShowTheForest(Highlight);
   ErrCode := FM.Error;
end;

end.
