unit T_SelectByName;

interface
uses
// KERNEL
  Elements,
  Tools,
  T_Recurs;

type

TSelectByName = class(TRecursor)
private
  FCaseSensitive: boolean;
  FSelectedName: string;
  FPartialy: Boolean;
  function GetSelectedElements: TOwnerEntity;
protected
  function  QProcessBefore(Element: TElement): boolean; override;
  function  QGoInside(Element: TElement): boolean; override;
  function  QProcessAfter(Element: TElement): boolean; override;
  procedure PrepareOutput; override;
  procedure Process(Element: TElement); override;
public
  property SelectedElements: TOwnerEntity read GetSelectedElements;
published
  property CaseSensitive: boolean read FCaseSensitive write FCaseSensitive;
  property Partialy: Boolean read FPartialy write FPartialy;
  property SelectedName: string read FSelectedName write FSelectedName;
end;


implementation
uses
  SysUtils;

function  TSelectByName.QProcessBefore(Element: TElement): boolean;
begin
   result := true;
end;


function  TSelectByName.QGoInside(Element: TElement): boolean;
begin
    result:= ((Element is TEntity));
end;


function  TSelectByName.QProcessAfter(Element: TElement): boolean;
begin
   result := false;
end;


procedure TSelectByName.PrepareOutPut;
begin
  if Output = nil then
  begin
    Output := TOwnerEntity.Create;
    AddElement(Output);
    Output.Name := 'Selected elements';
  end;
end;


function TSelectByName.GetSelectedElements: TOwnerEntity;
begin
   if Output = nil then
   begin
      Output := TOwnerEntity.Create;
      AddElement(Output);
      Output.Name := 'Selected elements';
   end;
   result := TOwnerEntity(Output);
end;


procedure TSelectByName.Process(Element: TElement);
var
  Selected: boolean;
  aPom: string;
begin
  if Partialy then
  begin
    aPom:= UpperCase(Element.Name);
    Selected:= Pos(SelectedName, aPom) > 0
  end
  else
  begin
    if CaseSensitive then
       Selected:= Element.Name = SelectedName
    else
       Selected:= CompareText(Element.Name, SelectedName) = 0;
  end;

  if Selected then
     SelectedElements.AddElement(Element);
end;



end.



