unit creacond;

interface

uses elements,t_oper,E_type,dialogs,tools;

type

TExpressionCreator=class(TTool)
private
 FLine:string;
protected
 function Process(aLine:string):TOperator;virtual;
public
 procedure DoIt;override;
published
 property Command:string read FLine write FLine;
end;

TCondCreator=class(TExpressionCreator)
private
protected
public
 procedure DoIt;override;
published
end;

implementation
uses SysUtils,
     {!T_Main,}
     syntax;

{ExpressionCreator}

procedure TExpressionCreator.DoIt;
 begin
  if FLine='' then Output:=nil
   else
   begin
    Output:=nil;
    try
    Output:=Process(FLine);
    if Output<>nil then TOperator(Output).ParamsTable:=TShortlist.create;
    finally
     end;
   end;
  end;


{CondCreator}

procedure TCondCreator.DoIt;
 begin
  Output:=TCondition.create;
  Output.Name:='Condition';
  if FLine='' then TCondition(Output).FirstOperator:=nil
   else
   begin
    try
    TCondition(Output).FirstOperator:=Process(FLine);
    TCondition(Output).ParamsTable:=TShortlist.create;
    finally
     end;
   end;
 end;

 function TExpressionCreator.Process(aLine:string):TOperator;
 var n,tmpn:integer;
     TmpSt:string;
     Len,OpLen,Err:integer;
     num:double;
     Key:TKeyWord;
 begin
 result:=nil;
 n:=1;
 Len:=length(aLine);
 try
 if StrEmpty(aLine,1) then raise SyntaxExcept.CreatePos('Ocekavam vyraz',1);
 {
 showmessage('process: '+aLine);
 }
 if FindBinaryOperator(aLine,n,tmpSt) then
    begin {nalezen binarni operator}
    tmpSt:=UpperCase(tmpSt);
    OpLen:=length(tmpSt);
    if n=0 then raise SyntaxExcept.CreatePos('Ocekavam vyraz',Len+1);
    if n-OpLen=1 then raise SyntaxExcept.CreatePos('Ocekavam vyraz',1);
    case GetKeyWord(tmpSt) of
     _AND:result:=TAndOperator.Create;
     _OR:result:=TOrOperator.Create;
     _SMALLER:result:=TMensiOperator.Create;
     _GREATER:result:=TVetsiOperator.Create;
     _EQUAL:result:=TRovnoOperator.Create;
     _ADD:result:=TPlusOperator.Create;
     _SUBTRACT:result:=TMinusOperator.Create;
     _MULTIPL:result:=TKratOperator.Create;
     _DIVIDE:result:=TDelenoOperator.Create;
     _MOD:result:=TModOperator.Create;
     _DIV:result:=TDivOperator.Create;
     end;{CASE}
    result.ParamsIndex:=0;
    result.FirstOperator:=Process(Copy(aLine,1,n-OpLen-1));
    try
    result.SecondOperator:=Process(Copy(aLine,n,len-n+1));
    except on E:SyntaxExcept do
        begin
         E.Pos:=E.Pos+n-1;
         raise;
        end;
       end;{EXCEPT}
    end{BINARNI OPERATOR}
    else
    begin{UNARNI OPERATOR+CHYBY}
    n:=1;
    skip(aLine,n);
    case aLine[n] of
         '(':begin
             try
              result:=Process(ReadBrackets(aLine,n));
             except on E:SyntaxExcept do
              begin
               E.Pos:=E.Pos+1;
               raise;
              end;
             end;
             end;
          '-':begin
              inc(n);
              skip(aLine,n);
              if n=0 then raise SyntaxExcept.CreatePos('Ocekavam vyraz',Len+1);
              if aLine[n]=#39 then raise SyntaxExcept.CreatePos('Vyraz nema smysl',n);
              if aLine[n] in ['0'..'9'] then
                    begin
                    tmpn:=n;
                    val(ReadNumString(aLine,n),num,Err);
                    if not StrEmpty(aLine,n) then raise SyntaxExcept.CreatePos('Chyba v sytaxi',n);
                    if Err<>0 then raise SyntaxExcept.CreatePos('Chybna hodnota',tmpn);
                    result:=TConstOperator.create;
                    if trunc(num)=num then
                     TConstOperator(result).Constant:=TIntegerElement.createValue(-trunc(num))
                     else
                     TConstOperator(result).Constant:=TFloatElement.createValue(-num);
                   end
               else
              begin
              result:=TUnMinusOperator.Create;
              try
              result.FirstOperator:=Process(copy(aLine,n,Len-n+1));
              except on E:SyntaxExcept do
              begin
               E.Pos:=E.Pos+n-1;
               raise;
              end;
              end;
              end;
              end;
          '+':begin
              inc(n);
              tmpn:=n;
              skip(aLine,tmpn);
              if tmpn=0 then raise SyntaxExcept.CreatePos('Ocekavam vyraz',Len+1);
              if aLine[tmpn]=#39 then raise SyntaxExcept.CreatePos('Vyraz nema smysl',tmpn);
              try
              result:=process(copy(aLine,n,Len-n+1));
              except on E:SyntaxExcept do
              begin
               E.Pos:=E.Pos+n-1;
               raise;
              end;
              end;
              end;
         #39:begin
              tmpSt:=MyReadString(aLine,n);
              {showmessage('text je: '+tmpSt);}
              if not StrEmpty(aLIne,n) then raise SyntaxExcept.CreatePos('Chyba v syntaxi',n);
              result:=TConstOperator.create;
              TConstOperator(result).Constant:=TStringElement.createValue(tmpSt);
             end;
        else{case}
        begin
        if aLine[n] in ['0'..'9'] then
         begin
         tmpn:=n;
         val(ReadNumString(aLine,n),num,Err);
         if not StrEmpty(aLine,n) then raise SyntaxExcept.CreatePos('Chyba v sytaxi',n);
         if Err<>0 then raise SyntaxExcept.CreatePos('Chybna hodnota',tmpn);
         result:=TConstOperator.create;
         if trunc(num)=num then
          TConstOperator(result).Constant:=TIntegerElement.createValue(trunc(num))
          else
          begin
          {
          showmessage('in float');
          }
          TConstOperator(result).Constant:=TFloatElement.createValue(num);
          end;
         end
         else
         if aLine[n] in ['a'..'z','A'..'Z','_'] then
         begin
         tmpSt:=ReadWord(aLine,n);
         tmpSt:=UpperCase(tmpSt);
         Key:=GetKeyWord(TmpSt);
         case Key of
             _CLASS,_ANCESTOR,_EXISTSPROP:
                     begin
                      if aLine[n]<>'(' then raise SyntaxExcept.CreatePos('Ocekavam: (',n);
                      tmpSt:=ReadBrackets(aLine,n);
                      if not StrEmpty(aLine,n) then raise SyntaxExcept.CreatePos('Chyba v syntaxi',n);
                      case Key of
                         _CLASS:result:=TClassIsOperator.Create;
                         _ANCESTOR:result:=TIsAncestorOperator.Create;
                         _EXISTSPROP:result:=TPropExistsOperator.Create;
                         end;
                      result.FirstOperator:=Process(#39+tmpSt+#39);
                     end;
             _NOT:
                  begin
                  result:=TNotOperator.Create;
                  result.FirstOperator:=Process(copy(aLine,n,Len-n+1));
                  end;
             _ABS,_TOBOOLEAN,_TOCHAR,_TOBYTE,_TOFLOAT,_TOSTRING,_TOINTEGER,
             _ROUND,_TRUNC,_COS,_SIN,_ARCTAN,_EXP,_FRAC,_LN,_SQR,_SQRT,_ODD:
                   begin
                   if aLine[n]<>'(' then raise SyntaxExcept.CreatePos('Ocekavam: (',n);
                   tmpSt:=ReadBrackets(aLine,n);
                   if not StrEmpty(aLine,n) then raise SyntaxExcept.CreatePos('Chyba v syntaxi',n);
                   case Key of
                         _ABS:result:=TAbsValOperator.Create;
                         _TOBOOLEAN:result:=TNaBooleanOperator.Create;
                         _TOCHAR:result:=TNaCharOperator.Create;
                         _TOBYTE:result:=TNaByteOperator.Create;
                         _TOFLOAT:result:=TNaFloatOperator.Create;
                         _TOSTRING:result:=TNaStringOperator.Create;
                         _TOINTEGER:result:=TNaIntegerOperator.Create;
                         _ROUND:result:=TRoundOperator.Create;
                         _TRUNC:result:=TTruncOperator.Create;
                         _COS:result:=TCosOperator.Create;
                         _SIN:result:=TSinOperator.Create;
                         _ARCTAN:result:=TArctanOperator.Create;
                         _EXP:result:=TExpOperator.Create;
                         _FRAC:result:=TFracOperator.Create;
                         _LN:result:=TLnOperator.Create;
                         _SQR:result:=TSqrOperator.Create;
                         _SQRT:result:=TSqrtOperator.Create;
                         _ODD:result:=TOddOperator.Create;
                      end;
                   result.FirstOperator:=Process(tmpSt);
                   end;
           else
             begin {properta}
             if not StrEmpty(aLine,n)then raise SyntaxExcept.CreatePos('Chyba v systaxi',n);
             result:=TReadPropOperator.create;
             TReadPropOperator(result).ComparedName:=tmpSt;
             end;
         end;{CASE}
        end
        else raise SyntaxExcept.CreatePos('Nesmyslny znak',n);
     end;{ELSE}
    end;{CASE}
     result.ParamsIndex:=0;
    end;{unarni operator}
 except on SyntaxExcept do
  begin
  if result<>nil then result.free;
  result:=nil;
  raise;
  end;
 end;
 {showmessage('konec: '+aline);}
end;



end.
