﻿unit MiniLed_Main;
//{$DEFINE HK}
{$DEFINE TESTGUI}
//{$DEFINE TEST}
//{$DEFINE ARETEST}
{$IFDEF ANDROID}
   {$DEFINE DIRECTGPS}
{$ENDIF}
(*
      Struktura dat:
      --------------
STARA:
    projekt:
    --------
    ProjectDir/Project.opx
    data:
    -----
    write +
    -------
    ProjectDir/Project_USER.orb

    write -
    -------
    AltDir/Project.opx
NOVA:
    projekt:
    --------
    ProjectDir/Project.opx
    data:
    -----
    write +  !!! zmena ... zadny write +  se nekona
    -------
    ProjectDir/Project_DATA/                          TProjectPath.Root
                          ├ Project_USER.orb          TProjectPath.User
                          ├ audio                     TProjectPath.Audio
                          │    └ *.*
                          └ img                       TProjectPath.img
                               └ *.*

    write -
    -------
    AltDir/Map/Project/Project_DATA/                   TProjectPath.Root
                                  ├ Project_USER.orb   TProjectPath.User
                                  ├ audio              TProjectPath.Audio
                                  │    └ *.*
                                  ├ img                TProjectPath.img
                                  │    └ *.*
                                  └ maps

    Write testing .... try to Create Dir named blabla test  in project destination directory
                       or file mybe ....

*)
interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs,
  FMX.Filter.Effects, FMX.Effects, FMX.StdCtrls, FMX.Objects, FMX.Ani,
  System.Actions, FMX.ActnList, FMX.Edit, FMX.Layouts, FMX.Memo, Xml.xmldom,
  Xml.XMLIntf, Xml.adomxmldom, Xml.XMLDoc, FMX.Gestures, System.Sensors,
  Elements,
  T_MainTl,
  e_LHCModel,
  t_ForestModelSelector,
  e_Geometry,
  e_GeometryEx,
  e_GeometryElement,
//  e_TopolElements,
  e_TopolDruhy,
// java
{$IFDEF DIRECTGPS}
  Androidapi.JNI.Location, Androidapi.JNIBridge, Androidapi.JNI.JavaTypes,
  Androidapi.JNI.Os,
  Androidapi.Helpers,
{$ENDIF}
  FMX.ListBox, FMX.Controls3D, FMX.Objects3D, FMX.TabControl,
  FMX.Colors, System.Math.Vectors, System.Sensors.Components,
  FMX.Controls.Presentation, FMX.MultiView, FMX.ScrollBox, System.ImageList,
  FMX.ImgList, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient,
  IdHTTP;

const

// ActiveTool
    at_Null  = -1; // zadny nastroj
    at_Map   = 0;  // prohlizeni mapy
    at_Note  = 1;  // poznamky
    at_Meas  = 2;  // mereni
    at_Point = 3;  // body
    at_Line  = 4;  // editace linie
    at_Log   = 5;  // trasovani

// PanStatus
    ps_PanInit      = 0;
    ps_Pan          = 1;
    ps_LinPointMove = 2;
    ps_Point        = 3;

// Maprec Errors
    mrer_None             = 0;
    mrer_NoRegFile        = 1;
    mrer_CorruptedRegFile = 2;
    mrer_WrongMapID       = 3;
    mrer_NotRegistered    = 4;

type
  RTileMatrix = record
     ID: string;
     Scale: double;
     MinX: double;
     MinY: double;
     MaxX: double;
     MaxY: double;
     TileWidth: double;
     TileHeight: double;
     OverX: double;
     OverY: double;
     MatrixWidth: integer;
     MatrixHeight: integer;
  end;



  RMap = record
     MinX: double;
     MinY: double;
     MaxX: double;
     MaxY: double;
     Width: double;
     Height: double;
     MapName: String;
     Ext: string;
     MapDir: string;
     MapID: string;
     Subject: string;
     Project: string;
     user: string;
     Plocha: integer;
     Error: integer;
     Registered: boolean;
     TileMatrixSet: Array of RTileMatrix;
  end;


  RODD = record
     MinX: double;
     MinY: double;
     MaxX: double;
     MaxY: double;
     ODD: string;
  end;

  EdColors = record
     LineColor: integer;
     PointColor: integer;
     DefaultColor: integer;
  end;

  TOldProjectPath_ = record
  public
    class var
      Routes:      string;
      Notes:       string;
      User:        string;
      class procedure Clear; static;
  end;

  TOldProjectPath = record
  public
    class var
     prj: TOldProjectPath_;      // Path around the project
     Alt: TOldProjectPath_;      // Alternative path to internal memory
     class procedure Clear; static;
  end;

  TProjectPath = record
  public
    class var
     VeryOld:         TOldProjectPath;   // routes and notes
     Old:             TOldProjectPath;   // user only
     Project:         string;            // Path to Project
     Root:            string;            // ..path ..+ ProjectName_DATA
     User:            string;
     Audio:           string;
     Img:             string;
     maps:            string;
     class procedure Clear; static;
     class procedure CheckDirectories; static;
  end;


  TMainTool = class(TOldMainTool)
  public
     procedure  HandleMessage(var aMessage: TOrbisMessage; var Handled: boolean); override;
     procedure   On_tm_ReView(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
  end;

  TLoadDetThread = class(TThread)
  public
     LHC : Tgis_ForestModel;
     FileName: string;
     procedure Execute; override;
     procedure Finish;
  end;


{$IFDEF DIRECTGPS}
  TLocationListener = class;
{$ENDIF}

  TMainForm = class(TForm)
    Image: TImage;
    b_plus: TButton;
    ShadowEffect1: TShadowEffect;
    XMLDocument_lhc: TXMLDocument;
    ProgressBar: TProgressBar;
    l_Progress: TLabel;
    GlowEffect1: TGlowEffect;
    b_Minus: TButton;
    ShadowEffect3: TShadowEffect;
    GestureManager1: TGestureManager;
    StyleBook1: TStyleBook;
    AniIndicator: TAniIndicator;
    LocationSensor: TLocationSensor;
    topBar: TToolBar;
    b_OpenProject: TButton;
    topbarunvisible: TButton;
    ShadowEffect5: TShadowEffect;
    Button4: TButton;
    p_FInd: TCalloutPanel;
    botbar: TToolBar;
    l_gps: TLabel;
    l_jtsk: TLabel;
    gpsCursor: TCircle;
    Line1: TLine;
    Line2: TLine;
    Memo: TMemo;
    XMLDocument: TXMLDocument;
    b_FindLHC: TButton;
    ShadowEffect7: TShadowEffect;
    ed_odd: TComboBox;
    ed_Dil: TComboBox;
    ed_por: TComboBox;
    ed_PSK: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    ShadowEffect8: TShadowEffect;
    Button8: TButton;
    Button9: TButton;
    Button10: TButton;
    Button11: TButton;
    Button12: TButton;
    topbarvisible: TButton;
    botbarunvisible: TButton;
    botbarvisible: TButton;
    p_Settings: TCalloutPanel;
    Button3: TButton;
    b_HK: TButton;
    p_gpslog: TCalloutPanel;
    b_StartRoute: TButton;
    b_endRoute: TButton;
    Sphere1: TSphere;
    diode: TImage;
    b_TraceRoute: TButton;
    b_RoutesList: TButton;
    dlg_General: TCalloutPanel;
    dlg_Text: TLabel;
    dlg_Edit: TEdit;
    dlg_OK: TButton;
    dlg_Cancel: TButton;
    ShadowEffect2: TShadowEffect;
    ShadowEffect4: TShadowEffect;
    ShadowEffect6: TShadowEffect;
    CalloutPanel1: TCalloutPanel;
    Button1: TButton;
    Button2: TButton;
    ColorButton1: TColorButton;
    l_scale: TLabel;
    GPath: TPath;
    Panel1: TPanel;
    ImagePin: TImage;
    ImageBakule: TImage;
    ActionPanel: TCalloutPanel;
    l_Caption: TLabel;
    l_Text: TLabel;
    b_ActionPanelClose: TButton;
    p_Note: TCalloutPanel;
    p_note_Caption: TLabel;
    p_Note_Text: TLabel;
    ShadowEffect11: TShadowEffect;
    Image_edit: TImage;
    GPS_S: TButton;
    Button6: TButton;
    Image_Edit_Detail: TImage;
    Button13: TButton;
    Button14: TButton;
    FloatAnimation1: TFloatAnimation;
    Timer1: TTimer;
    b_Hand: TButton;
    ShadowEffect12: TShadowEffect;
    Image1: TImage;
    ToolsListBox: TListBox;
    EditLineLayout: TGridLayout;
    Panel2: TPanel;
    Panel3: TPanel;
    b_DeleteLinePoint: TButton;
    Panel4: TPanel;
    Panel5: TPanel;
    b_SelectLinePoint: TButton;
    b_NewLine: TButton;
    Panel6: TPanel;
    b_AddLinePointGPS: TButton;
    Panel7: TPanel;
    SelectLinePointLayout: TGridLayout;
    Panel8: TPanel;
    b_SelectLinePointFirst: TButton;
    Panel9: TPanel;
    b_SelectLinePointDown: TButton;
    Panel10: TPanel;
    b_SelectLinePointUp: TButton;
    Panel11: TPanel;
    b_SelectLinePointLast: TButton;
    MultiView: TMultiView;
    tabc: TTabControl;
    tab_layers: TTabItem;
    tab_Tools: TTabItem;
    Label9: TLabel;
    tab_main: TTabItem;
    Label10: TLabel;
    MainListBox: TListBox;
    b_Main: TButton;
    tab_view: TTabItem;
    tab_Options: TTabItem;
    Label11: TLabel;
    Label8: TLabel;
    cb_jprl: TSwitch;
    Label12: TLabel;
    ListBox_Layers: TListBox;
    gpscur: TImage;
    Label13: TLabel;
    ActiveLayerCombo: TComboBox;
    p_note_Image_Lays: TImage;
    p_note_Layer: TLabel;
    tab_layers_Layout: TLayout;
    tab_Layers_Lays: TImage;
    tab_Layers_edit_LayerName: TEdit;
    Button5: TButton;
    Label14: TLabel;
    tab_Layers_ClearLayer: TButton;
    tab_Layers_LayerDetail: TLabel;
    Button7: TButton;
    Button15: TButton;
    Layout1: TLayout;
    Label15: TLabel;
    tab_Layers_ComboColor: TComboColorBox;
    Label16: TLabel;
    MapCombo: TComboBox;
    Label17: TLabel;
    Image_View: TImage;
    Label7: TLabel;
    l_cbLine: TLabel;
    cb_Line: TSwitch;
    Label19: TLabel;
    cb_Note: TSwitch;
    Layout2: TLayout;
    l_JPRL: TLabel;
    b_Settings: TButton;
    TestPanel: TCalloutPanel;
    Button16: TButton;
    TestMemo: TMemo;
    Circle1: TCircle;
    Precis: TCircle;
    Switch1: TSwitch;
    FixTimer: TTimer;
    ImageList_Main: TImageList;
    ListBoxItem1: TListBoxItem;
    ListBoxItem2: TListBoxItem;
    ListBoxItem3: TListBoxItem;
    ListBoxItem4: TListBoxItem;
    ListBoxItem5: TListBoxItem;
    LockPanel: TPanel;
    Locktext: TLabel;
    GlowEffect2: TGlowEffect;
    LockLayout: TLayout;
    Label18: TLabel;
    LockTimer: TTimer;
    CalloutPanel2: TCalloutPanel;
    GlowEffect3: TGlowEffect;
    htopbar: TToolBar;
    hb_OpenProject: TButton;
    ShadowEffect9: TShadowEffect;
    htopbarunvisible: TButton;
    ShadowEffect10: TShadowEffect;
    hButton4: TButton;
    Button20: TButton;
    Button21: TButton;
    hImage_VIew: TImage;
    Switch2: TSwitch;
    hb_HK: TImage;
    hb_FindLHC: TImage;
    Image2: TImage;
    Img_Black: TImage;
    Img_Orange: TImage;
    Img_Green: TImage;
    ShadowEffect13: TShadowEffect;
    Layout3: TLayout;
    Layout4: TLayout;
    Layout5: TLayout;
    Layout6: TLayout;
    b_Settings2: TButton;
    Point_Edit_Layout: TLayout;
    Point_Edit_ComboBox: TComboBox;
    Panel12: TPanel;
    Label20: TLabel;
    PointColorButton: TColorButton;
    ColorPopup: TPopup;
    ColorListBox: TListBox;
    b_Point_Delete: TButton;
    Label21: TLabel;
    Image_LockedMap: TImage;
    TabViewLayout: TLayout;
    cb_botbar: TSwitch;
    cb_topbar: TSwitch;
    cb_TopBarMargin: TSwitch;
    Label22: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    ListBoxItem6: TListBoxItem;
    ScaleLayout: TLayout;
    Rectangle1: TRectangle;
    Rectangle2: TRectangle;
    Rectangle3: TRectangle;
    Text1: TText;
    Text2: TText;
    Text4: TText;
    Text3: TText;
    Text5: TText;
    Text11: TText;
    Text22: TText;
    Text33: TText;
    Text44: TText;
    Text55: TText;
    b_Tools: TButton;
    ShadowEffect14: TShadowEffect;
    Image3: TImage;
    ImageList_gps: TImageList;
    GPSLayout: TLayout;
    RoundRect1: TRoundRect;
    b_gpss: TButton;
    InfoLayout: TLayout;
    b_Menu: TButton;
    Panel13: TPanel;
    l_JPRLs: TLabel;
    Image4: TImage;
    Label23: TLabel;
    MapListBox: TListBox;
    procedure b_OpenProjectClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ImageResize(Sender: TObject);
    procedure ImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Single);
    procedure ImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Single);
    procedure ImageMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Single);
    procedure b_plusClick(Sender: TObject);
    procedure b_MinusClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure topbarunvisibleClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormGesture(Sender: TObject; const EventInfo: TGestureEventInfo;
      var Handled: Boolean);
    procedure LocationSensorLocationChanged(Sender: TObject; const OldLocation,
      NewLocation: TLocationCoord2D);
    procedure MapComboChange(Sender: TObject);
    procedure b_gpsfindClick(Sender: TObject);
    procedure b_FindLHCClick(Sender: TObject);
    procedure ed_oddChange(Sender: TObject);
    procedure ed_DilChange(Sender: TObject);
    procedure ed_porChange(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure ed_PSKChange(Sender: TObject);
    procedure topbarvisibleClick(Sender: TObject);
    procedure botbarvisibleClick(Sender: TObject);
    procedure botbarunvisibleClick(Sender: TObject);
    procedure b_SettingsClick(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure cb_topbarSwitch(Sender: TObject);
    procedure cb_botbarSwitch(Sender: TObject);
    procedure cb_jprlSwitch(Sender: TObject);
    procedure b_HKClick(Sender: TObject);
    procedure b_StartRouteClick(Sender: TObject);
    procedure b_endRouteClick(Sender: TObject);
    procedure b_TraceRouteClick(Sender: TObject);
    procedure b_RoutesListClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure dlg_CancelClick(Sender: TObject);
    procedure dlg_OKClick(Sender: TObject);
    procedure RoutesListItemClick(const Sender: TCustomListBox;
      const Item: TListBoxItem);
    procedure b_ActionPanelCloseClick(Sender: TObject);
    procedure b_NoteClick(Sender: TObject);
    procedure GPS_SClick(Sender: TObject);
    procedure b_viewClick(Sender: TObject);
    procedure l_JPRLClick(Sender: TObject);
    procedure b_editClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Image_editMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Single);
    procedure Image_editMuseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Single);
    procedure Image_editMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Single);
    procedure FormKeyUp(Sender: TObject; var Key: Word; var KeyChar: Char;
      Shift: TShiftState);
    procedure Button6Click(Sender: TObject);
    procedure b_EditPointClick(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure b_HandClick(Sender: TObject);
    procedure ToolsListBoxItemClick(const Sender: TCustomListBox;
      const Item: TListBoxItem);
    procedure b_DeleteLinePointClick(Sender: TObject);
    procedure b_AddLinePointGPSClick(Sender: TObject);
    procedure b_SelectLinePointFirstClick(Sender: TObject);
    procedure b_SelectLinePointDownClick(Sender: TObject);
    procedure b_SelectLinePointUpClick(Sender: TObject);
    procedure b_SelectLinePointLastClick(Sender: TObject);
    procedure b_SelectLinePointClick(Sender: TObject);
    procedure b_MoveLinePointClick(Sender: TObject);
    procedure b_AddLinePointClick(Sender: TObject);
    procedure b_NewLineClick(Sender: TObject);
    procedure EditLineLayoutResize(Sender: TObject);
    procedure ImageTap(Sender: TObject; const Point: TPointF);
    procedure MainListBoxItemClick(const Sender: TCustomListBox;
      const Item: TListBoxItem);
    procedure b_MainClick(Sender: TObject);
    procedure ListBox_LayersChangeCheck(Sender: TObject);
    procedure ListBox_LayersItemClick(const Sender: TCustomListBox;
      const Item: TListBoxItem);
    procedure ActiveLayerComboChange(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button15Click(Sender: TObject);
    procedure tab_Layers_ComboColorChange(Sender: TObject);
    procedure Image_ViewClick(Sender: TObject);
    procedure tabcChange(Sender: TObject);
    procedure cb_NoteSwitch(Sender: TObject);
    procedure cb_LineSwitch(Sender: TObject);
    procedure Button16Click(Sender: TObject);
    procedure Switch1Switch(Sender: TObject);
    procedure FixTimerTimer(Sender: TObject);
    procedure Button17Click(Sender: TObject);
    procedure LockPanelClick(Sender: TObject);
    procedure LockTimerTimer(Sender: TObject);
    procedure LockPanelMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Single);
    procedure LockPanelMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Single);
    procedure LockPanelMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Single);
    procedure Point_Edit_ComboBoxChange(Sender: TObject);
    procedure PointColorButtonClick(Sender: TObject);
    procedure ColorListBoxApplyStyleLookup(Sender: TObject);
    procedure ColorListBoxItemClick(const Sender: TCustomListBox;
      const Item: TListBoxItem);
    procedure b_Point_DeleteClick(Sender: TObject);
    procedure cb_TopBarMarginSwitch(Sender: TObject);
    procedure b_ToolsClick(Sender: TObject);
    procedure InfoLayoutClick(Sender: TObject);
    procedure b_MenuClick(Sender: TObject);
    procedure b_gpssClick(Sender: TObject);
    procedure MapListBoxItemClick(const Sender: TCustomListBox;
      const Item: TListBoxItem);
    procedure l_JPRLsClick(Sender: TObject);
  private
    { Private declarations }
{$IFDEF DIRECTGPS}
    FLocationManager : JLocationManager;
    locationListener : TLocationListener;
{$ENDIF}
    Unlocking: boolean;
    UnlockX,UnlockY: Single;
    Bm: Fmx.Graphics.TBitmap;
    BmEdit: Fmx.Graphics.TBitmap;
//    G: Graphics;
    LastX,LastLocalX: Single;
    LastY,LastLocalY: Single;
    RefX: Single;
    RefY: Single;
    aX,aY: Single;
    gpsLat,gpsLong,gpsAlt,gpsAcu,jtskX,jtskY: double;
    MMoves: integer;
    FGPSFixed: boolean;
    CheckNotes: boolean;
    CheckLines: boolean;
    CHeckJPRL: boolean;
    PreparingMove: boolean;
    BmMoving: boolean;
    BmInMove: boolean;
    BmPrepared: boolean;
    FActiveProgress: integer;
    FProc: TOwnerEntity;
    Status: integer;
    FOnSelectJPRL: TNotifyEvent;
    FOnDataReady: TNotifyEvent;
    FOnMapReady: TNotifyEvent;
    procedure set_GPSFixed(const Value: boolean);
    function GetProc: TOwnerEntity;
    procedure SetActiveProgress(const Value: integer);
    procedure SetProc(const Value: TOwnerEntity);
    procedure SetOnSelectJPRL(const Value: TNotifyEvent);
//    FOnSelectJPRL: EventHandler;
    procedure ListBox_Layers_ItemApplyStyleLookup(Sender: TObject);
    procedure SetOnDataReady(const Value: TNotifyEvent);
    procedure SetOnMapReady(const Value: TNotifyEvent);
  public
    cbActive: boolean;
    m_Cnt: integer;
//    objParser: GpsToolsNET.NmeaParser;
    GpsOn: boolean;
    GPSTrack: boolean;
    aScale: System.Double;
    aJTSK: boolean;
//    DETshp: GpsShapeNET.ShapeFile;
//    EDITshp: GpsShapeNET.ShapeFile;
    iLHC: integer;
    iOddeleni: integer;
    iDilec: integer;
    iPorost: integer;
    iSkupina: integer;
    Moving: boolean;
    ActiveTool: integer;
    ActiveSubTool: integer;
    WaitingActiveTool: integer;
    Fix: boolean;
    DoFindGPS: boolean;
    Rotate: boolean;
    EditColors: EdColors;
    ToolsMoving: boolean;
    ToolsVisible: boolean;
    ActualMap: integer;
    ActualTileMatrix: integer;
    MapChangeActive: boolean;
    Maps: Array of RMap;
    Odds: Array of RODD;
    Tiles: TStringList;
    iLastOdd: integer;
    S_rok,S_LHC,S_Oddeleni,S_Dilec,S_Porost,S_Skupina: string;
    DBPath: string;
    CloseIsVisible: boolean;
    OddListExists: boolean;
    White: boolean;
//    ObjShape: GpsShapeNET.Shape;
//    ObjMapShape: GpsViewNET.MapShape;
//    aPosition: GpsToolsNET.Position;
    Error: integer;
    Test: boolean;
    CenterX: System.Double;CenterY: System.Double;
    RealScale: System.Double;
    Scale1: System.Double;
    MinX: System.Double;MinY: System.Double;MaxX: System.Double;MaxY: System.Double;
    MultX: System.Double;MultY: System.Double;
    AddX: System.Double;AddY: System.Double;
    GpsX,GpsY: double;
    X1,Y1,X2,Y2: double;
    LastDist: integer;
    MapDirectory: string;
    Reviews: Array of Integer;
    LastReview: integer;
    BColor: TAlphaColor;
    EditLineColor: TAlphaColor;
    FTestClassRef: TClass;
    ModelDET: TElement;
    MainTool: TMainTool;
    LHC: Tgis_ForestModel;
    Routes: TComplicatedGECollection;
    Notes: TComplicatedGECollection;
    Barva: integer;
    LHCS: TOwnerEntity;
    Zn: TTopolDruhy;                 // znacky_dbf
    PSYMB: TOwnerEntity;             // points symbolz
    Layers: TOwnerEntity;            // user layers
    Layers_Modified: boolean;
    ActualSuperLayer: TComplicatedGECollection;
    ActualLayer: TComplicatedGECollection;
    //****************************
    ActualRoute: TPolyLineElement;
    ActualNote: TTextElement;
    RoutesPath: string;
    NotesPath: string;
    LayersPath: string;
    ProjectPath: TProjectPath;
    AlternativeLayersPath: string;
    AreaBlinked: boolean;
    LHCSPath: string;
    AlternativeRoutesPath: string;
    AlternativeNotesPath: string;
    FMSelector: TForestModelSelector;
    ImDrawing: boolean;
    Reviewing: boolean;
    MLine: TPolyLineElement;
    MLineActivePoint: integer;
    PanStatus: integer;
    EPoint: Tgis_PointElement;
//    eTpoint: TTopolPointElement;
    LoadDetThread: TLoadDETThread;
    DataOnBackGround: boolean;
    LastToolListboxIndex: integer;
    Pani,pani1: integer;
    destructor Destroy; override;
    { Public declarations }
{$IFDEF DIRECTGPS}
    procedure onLocationChanged(location: JLocation);
{$ENDIF}
    procedure Import;
    procedure LockDisplay;
    procedure SaveParams;
    procedure LoadParams;
    procedure AfterLoadDET(Sender: TObject);
   { Public declarations }
    procedure ShowGPSCoords;
    procedure ShowScaleAndCoords;
    procedure AddProject(aFileName: string);
    procedure LoadProject(aFileName: string);
    procedure LoadMap(aFileName,aExt: string);
    procedure LoadDET(aFileName,aOddName: string);
    procedure LoadEdit(aFileName: string);
    procedure TryToRegisterMap;
    procedure ShowTheForest(Highlight: boolean);
    function  FindForestOnScreen(aPosition: TPointF; aBlink: boolean): Tgis_PorostniSkupina;
    // <Deprecated>
    procedure Route_StartNew;
    procedure Route_End;
    procedure Route_StoreCoords(gx,gy: double; Redraw: boolean);
    procedure Route_Load(CEC: TComplicatedGECollection);
    procedure Note_Load(CEC: TComplicatedGECollection);
    // </Deprecated>
    procedure OldRoutesAndNotesLoad;
    procedure LHC_UpdateList;
    procedure LHC_Load;
    procedure LHC_Save;
    procedure Layers_Load;
    procedure Layers_Save;
    procedure Layers_Check;
    procedure Layers_CheckColors;
    procedure Layers_UpdateList;
    procedure Layer_UpdateList(aLayer: TComplicatedGECollection);
    procedure Layer_UpdateListDetail(aLayer: TComplicatedGECollection);
    function  Layers_Add(aName,aText: string): TComplicatedGECollection;
    function  Layers_Layer(aName, aLayer: string): TComplicatedGECollection;
    function  Layers_LayerExists(aName, aLayer: string): boolean;
    procedure Colors_Prepare;
    function  MapsDirExists(aDir: string; var MapIndex: integer): boolean;
    procedure ZnPSYMB_Load;
    procedure CHeckActiveTool(NewActive: integer);
    function  GetExecutablePath : String;
    function  GetAbsolutePath(aRootPath,aRelativePath: string): string;
    function  FindLayerPath(aLayer: string): string;
    function  FindLayerExt(aLayer: string): string;
    function  FindLayerValue(aLayer,aValue: string): string;
    function  StopReviews: integer;  // stopne zobrazeni a vrati volnou pozici
    procedure Review(compact: boolean);
    procedure DrawLines(aLay: TComplicatedGECollection; aColor: integer);
    procedure DrawNotes(aLay: TComplicatedGECollection; aColor: integer);
    procedure DrawPoints(aLay: TComplicatedGECollection; aColor: integer);
    procedure DrawLayers;
    procedure ShowLHCList;
    procedure CHeckMLineActivePoint;
    procedure DrawLine(aLine: TPolyElement; aPart: integer; aColor: integer);
    procedure DrawLineEdit(aLine: TPolyElement; aPart: integer; aColor: integer; aBM: TBitmap);
    procedure DrawLineDetail(aLine: TPolyElement; aPart: integer; aColor: integer; aBM: TBitmap);
    procedure DrawPoint(aPoint: Tgis_PointElement; edit: boolean; aBM: TBitmap = nil);
    procedure Point_UpdateBySymbol(aPoint: Tgis_PointElement);
    procedure BlinkLine(aLine: TPolyElement);
    procedure BlinkArea(anArea: TAreaElement);
    procedure Edit_Clear;
    procedure Drawgps;
    function  ChangeActiveTool(aIndex: integer): boolean;
    function  FinishActiveTool: boolean;
    procedure StartActiveTool(aIndex: integer);
    procedure StartLineEditing;
    procedure SaveLineDialog;
    procedure EditLineChangeSubTool(aIndex: integer);
    procedure CHangeProjection(_X,_Y,_Scale: double);
    procedure ChangeProjectionByFirstMapTile;
    procedure CHangeProjectionByRect(X1,Y1,X2,Y2: double);
    procedure OnSelectFile(const S: string);
    procedure AddRefClass(aValue: TClass);
    procedure Orbis_ProgressStart(_ID: Integer; ProgressName: string; MinProgress, MaxProgress, Progress: Integer);
    procedure Orbis_Progress(_ID, Value: Integer);
    procedure Orbis_ProgressEnd(_ID, Value: Integer);
    procedure Orbis_ProgressMax(_ID, Value: Integer);
    procedure Orbis_ProgressText(_ID: Integer; Value: string);
    procedure CheckProgress;
    property Proc: TOwnerEntity read GetProc write SetProc;
    property ActiveProgress: integer read FActiveProgress write SetActiveProgress;
    procedure OnProgress(_ID, _Event: integer; _Name, _Text: string; _MinValue, _MaxValue, _Progress: integer);
    function GetModelX(aPageX: Single): System.Double;
    function GetModelY(aPageY: Single): System.Double;
    function  GetPageX(aModelX: double): single;
    function  GetPageY(aModelY: double): single;
    function GetModelLength(aPageLength: single): System.Double;
    function  GetPageLength(aModelLength: double): single;
    property GPSFixed: boolean read FGPSFixed write set_GPSFixed;
    property OnSelectJPRL: TNotifyEvent read FOnSelectJPRL write SetOnSelectJPRL;
    property OnMapReady: TNotifyEvent read FOnMapReady write SetOnMapReady;
    property OnDataReady: TNotifyEvent read FOnDataReady write SetOnDataReady;
  end;

{$IFDEF DIRECTGPS}

  TLocationListener = class(TJavaLocal, JLocationListener)
  private
    [weak]
    FParent : TMainForm;
  public
    constructor Create(AParent : TMainForm);
    procedure onLocationChanged(location: JLocation); cdecl;
    procedure onProviderDisabled(provider: JString); cdecl;
    procedure onProviderEnabled(provider: JString); cdecl;
    procedure onStatusChanged(provider: JString; status: Integer; extras: JBundle); cdecl;
  end;
{$ENDIF}
TProgressElem = class(TOwnerEntity)
  private
    FMax: integer;
    F_ID: integer;
    FMin: integer;
    FProgress: integer;
    F_Name: string;
    FText: string;
    procedure Set_ID(const Value: integer);
    procedure Set_Name(const Value: string);
    procedure SetMax(const Value: integer);
    procedure SetMin(const Value: integer);
    procedure SetProgress(const Value: integer);
    procedure SetText(const Value: string);
  published
   property _ID: integer read F_ID write Set_ID;
   property _Name: string read F_Name write Set_Name;
   property Min: integer read FMin write SetMin;
   property Max: integer read FMax write SetMax;
   property Progress: integer read FProgress write SetProgress;
   property Text: string read FText write SetText;
end;

var
  MainForm: TMainForm;


implementation
uses
//   Elements, //- + without e_Class
//   e_Class,  //-
//   u_Props,  //+
//   u_String, //+
//   TestUnit,
//   System.Typinfo, // +
//   TestScaledForm,
{$IFDEF HK}
   Main,
   Karkulka_RegMap,
   Karkulka_LHCList,
   e_Karkulka,
   u_DeviceInfo,
//   Test3D,
{$ENDIF}
{$IFDEF DIRECTGPS}
   FMX.Helpers.Android, Androidapi.JNI.GraphicsContentViewText,
{$ENDIF}
   Miniled_Import,
   FMX.MobilePreview,
   Math,
   MathLib,
   G_Elems,
   System.Diagnostics,
   Tools,
   e_Color,
   e_Pale,
   e_Type,
   m_Orbis,
   T_loader,
   T_Saver,
   T_Coord,
   r_WGS84,
   MiniLed_Notes,
   t_XFileDialog,
   System.Hash,
   System.Threading,
   System.IOUtils;

{$R *.fmx}
{$R *.LgXhdpiPh.fmx ANDROID}
{$R *.LgXhdpiTb.fmx ANDROID}

type
   _Path = System.IOUtils.TPath;

procedure TMainForm.b_gpsfindClick(Sender: TObject);
begin
   if GPSFixed then
   begin
      CHangeProjection(jtskX,jtsky,RealScale);
      Review(false);
   end
   else
   begin
       ShowMessage('GPS poloha není k dispozici');
   end;
end;

procedure TMainForm.b_gpssClick(Sender: TObject);
begin
   if not GpsOn then
   begin
      Button4Click(nil);
   end
   else
   begin
      {$IFDEF HK}
      Switch1.IsChecked := not Switch1.IsChecked;
      {$ELSE}
      Switch2.IsChecked := not Switch2.IsChecked;
      {$ENDIF}
   end;
end;

procedure TMainForm.b_MainClick(Sender: TObject);
begin
   tabc.ActiveTab := tab_main;
end;

procedure TMainForm.b_MenuClick(Sender: TObject);
begin
   b_SettingsClick(nil);
end;

procedure TMainForm.b_MinusClick(Sender: TObject);
var
   DestRect,SrcRect: TRectF;
   i: integer;
   X1,Y1,X2,Y2: double;
   sc, DestSc: double;
   srcScale,Step: double;
begin
//   if ActiveTool = 2 then
//   begin
//      Image_edit.Bitmap.Canvas.BeginScene;
//      Image_edit.Bitmap.Canvas.Clear(TAlphaColors.Null);
//      Image_edit.Bitmap.Canvas.EndScene;
//   end;
//   Bm := TBitmap.Create(Round(Image.Bitmap.Width),Round(Image.Bitmap.Height));
////   Bm.BitmapScale := Image.Bitmap.BitmapScale;
//   Bm.CopyFromBitmap(Image.Bitmap);
   X1 := MinX;
   Y1 := MaxY;
   X2  := MaxX;
   Y2  := MinY;
   SrcScale := RealScale;
   Sc := 1;
   DestSc := 1.5;
   Step := 0.05;
   While Sc < DestSc do
   begin
      Sc := Sc + Step;
      ChangeProjection(CenterX,CenterY,SrcScale * Sc);
      SrcRect  := TRectF.Create(0,0,Bm.Width,Bm.Height);
      DestRect := TRectF.Create(GetPageX(X1),GetPageY(Y1),GetPageX(X2),GetPageY(Y2));
      Image.Bitmap.Canvas.BeginScene;
      Image.Bitmap.Canvas.Clear(BColor);
      Image.Bitmap.Canvas.DrawBitmap(Bm,SrcRect,DestRect,1);
      Image.Bitmap.Canvas.EndScene;
      if ActiveTool in [at_Meas,at_Line] then
      begin
         DrawLineEdit(MLine,MLineActivePoint, EditColors.LineColor,nil);
         DrawLineDetail(MLine,MLineActivePoint, EditColors.LineColor,nil);
      end
      else
      if ActiveTool = at_Point then
      begin
         if EPoint  <> nil then
            DrawPoint(ePoint,true);
      end;
      Application.ProcessMessages;
   end;
//   BM.DisposeOf;
   //G := Graphics.FromImage(PictureBox1.Image);
   ChangeProjection(CenterX,CenterY,SrcScale * 1.5);
   Review(false);
   if ActiveTool in  [at_Meas,at_Line] then
   begin
      DrawLineEdit(MLine,MLineActivePoint, EditColors.LineColor,nil);
      DrawLineDetail(MLine,MLineActivePoint, EditColors.LineColor,nil);
   end;
   ShowScaleAndCoords;
end;

procedure TMainForm.b_MoveLinePointClick(Sender: TObject);
begin
   EditLineChangeSubTool(2);
end;

procedure TMainForm.b_plusClick(Sender: TObject);
var
   DestRect,SrcRect: TRectF;
   i: integer;
   X1,Y1,X2,Y2: double;
   sc, DestSc: double;
   srcScale,Step: double;
begin
//   if ActiveTool = 2 then
//   begin
//      Image_edit.Bitmap.Canvas.BeginScene;
//      Image_edit.Bitmap.Canvas.Clear(TAlphaColors.Null);
//      Image_edit.Bitmap.Canvas.EndScene;
//   end;
//   Bm := TBitmap.Create(Round(Image.Bitmap.Width),Round(Image.Bitmap.Height));
////   Bm.BitmapScale := Image.Bitmap.BitmapScale;
//   Bm.CopyFromBitmap(Image.Bitmap);
   X1 := MinX;
   Y1 := MaxY;
   X2  := MaxX;
   Y2  := MinY;
   SrcScale := RealScale;
   Sc := 1;
   DestSc := 1.5;
   Step := 0.1;
   While Sc < DestSc do
   begin
      Sc := Sc + Step;
      ChangeProjection(CenterX,CenterY,SrcScale / Sc);
      SrcRect  := TRectF.Create(0,0,Bm.Width,Bm.Height);
      DestRect := TRectF.Create(GetPageX(X1),GetPageY(Y1),GetPageX(X2),GetPageY(Y2));
      Image.Bitmap.Canvas.BeginScene;
      Image.Canvas.Clear(BColor);
      Image.Bitmap.Canvas.DrawBitmap(Bm,SrcRect,DestRect,1);
      Image.Bitmap.Canvas.EndScene;
      if ActiveTool in [at_Meas,at_Line] then
      begin
         DrawLineEdit(MLine,MLineActivePoint, EditColors.LineColor,nil);
         DrawLineDetail(MLine,MLineActivePoint, EditColors.LineColor,nil);
      end
      else
      if ActiveTool = at_Point then
      begin
         if EPoint  <> nil then
            DrawPoint(ePoint,true);
      end;
      Application.ProcessMessages;
   end;
//   BM.DisposeOf;
   //G := Graphics.FromImage(PictureBox1.Image);
   ChangeProjection(CenterX,CenterY,SrcScale / 1.5);
   Review(false);
   if ActiveTool in  [at_Meas,at_Line] then
   begin
      DrawLineEdit(MLine,MLineActivePoint, EditColors.LineColor,nil);
      DrawLineDetail(MLine,MLineActivePoint, EditColors.LineColor,nil);
   end;
   ShowScaleAndCoords;
end;

procedure TMainForm.b_Point_DeleteClick(Sender: TObject);
begin
   if ePoint = nil  then exit;
   ActualLayer.ElementToFree := ePoint;
   ePoint := nil;
   edit_Clear;
   b_Point_Delete.Visible := false;
   Layers_Modified := true;
end;

procedure TMainForm.b_RoutesListClick(Sender: TObject);
begin
   MiniLed_Notes_Form.Show;
//   Tabs.Visible := not Tabs.Visible;
//   if Tabs.Visible then
//   begin
//      b_RoutesList.Text := 'Zavřít seznam GPS tras a poznámky';
//   end
//   else
//   begin
//      b_RoutesList.Text := 'Seznam GPS tras a poznámky';
//   end;
end;

procedure TMainForm.b_StartRouteClick(Sender: TObject);
begin
   if GPSFixed then
   begin
      Diode.Opacity := 1;
      b_StartRoute.Enabled := false;
      b_EndRoute.Enabled := true;
//      LocationSensor.Distance := 1;
      Route_StartNew;
//      gpsCursor.Visible := false;
      ImDrawing := false;
   end
   else
   begin
       ShowMessage('GPS poloha není k dispozici');
   end;

end;

procedure TMainForm.cb_botbarSwitch(Sender: TObject);
begin
   if not cbActive then exit;
   botBar.Visible := cb_botbar.IsChecked;
   botbarvisible.Visible := not botBar.Visible;
end;

procedure TMainForm.cb_jprlSwitch(Sender: TObject);
begin
//   if not cbActive then exit;
   CHeckJPRL := cb_jprl.IsChecked;
   l_JPRL.Visible := CHeckJPRL;
end;

procedure TMainForm.cb_LineSwitch(Sender: TObject);
begin
   CheckLines := cb_Line.IsChecked;
end;

procedure TMainForm.cb_NoteSwitch(Sender: TObject);
begin
  CheckNotes := cb_Note.IsChecked;
end;

procedure TMainForm.cb_TopBarMarginSwitch(Sender: TObject);
begin
   if cb_TopBarMargin.IsChecked then
   begin
      TopBar.Margins.Top := TopBar.Height / 2;
   end
   else
   begin
      TopBar.Margins.Top := 0;
   end;
   if not cbActive then exit;
   SaveParams;
end;

procedure TMainForm.cb_topbarSwitch(Sender: TObject);
var
   tb: TToolBar;
begin
   {$IFDEF HK}
   tb := topbar;
   {$ELSE}
   tb := htopbar;
   {$ENDIF}
   if not cbActive then exit;
   tb.Visible := cb_topbar.IsChecked;
   topbarvisible.Visible := not tb.Visible;
end;

procedure TMainForm.ActiveLayerComboChange(Sender: TObject);
begin
   ActualSuperLayer := nil;
   if (ActiveLayerCombo.Count > 0) and (ActiveLayerCombo.ItemIndex > -1) then
      ActualSuperLayer := TComplicatedGECollection(ActiveLayercombo.Items.Objects[ActiveLayerCombo.ItemIndex]);
end;

procedure TMainForm.AddProject(aFileName: string);
var
   SE: TStringElement;
   i: integer;
begin
   ShowLHCList;
   if LHCS = nil then
   begin
      LHCS := TOwnerEntity.Create;
      LHCS.Name := 'LHCS';
   end;
   for i := 0 to LHCS.LastIndex do
   begin
      SE := TStringELement(LHCS.Elements[i]);
      if SE.Text = aFIleName then
      begin
         ShowMessage('LHC už bylo přidáno ....');
         Exit;
      end;
   end;
   SE := TStringElement.Create;
   SE.Name := _Path.GetFileNameWithoutExtension(aFileName);
   SE.Text := aFileName;
   LHCS.AddElement(SE);
   LHC_UpdateList;
   LHC_Save;
end;

procedure TMainForm.AddRefClass(aValue: TClass);
begin
   FTestClassRef := aValue;
end;

procedure TMainForm.AfterLoadDET(Sender: TObject);
var
   LS: Tgis_LS;
   i,ii: integer;
begin
   if LoadDETThread.LHC <> nil then
   begin
      LHC := LoadDetThread.LHC;
      LHC.ActualLHC := Tgis_LHC(LHC.FindElementClass(Tgis_LHC));
      //Oddeleni
      ed_odd.Items.Clear;
      if not LHC.ActualLHC.NoItems  then
      begin
         for i := 0 to LHC.ActualLHC.Items.LastIndex do
         begin
            LS := Tgis_LS(LHC.ActualLHC.Items.ForestUnit[i]);
            if not LS.NoItems then
            for ii := 0 to LS.Items.LastIndex do
            begin
               ed_odd.Items.Add(LS.Items.Elements[ii].Name);
               Application.ProcessMessages;
            end;
         end;
         ed_odd.ItemIndex := 0;
      end;
      FMSelector := TForestModelSelector.Create;
      FMSelector.ForestModel := LHC;
      FMSelector.ReferenceFrameClass := Tgis_PorostniSkupina;
      FMSelector.FrameClass := Tgis_PorostniSkupina;
   end;
//   ShowMessage('After DET');
   l_JPRL.Text := 'OK';
   l_JPRLs.Text := 'OK';
   if Assigned(OnDataReady) then
      OnDataReady(nil);
end;

procedure TMainForm.BlinkArea(anArea: TAreaElement);
var
   A1,A,B: TPointF;
   ai: integer;
   MA: TMultiAreaElement;
   aPath: TPathData;
   DestRect,SrcRect: TRectf;

   procedure FillAre(anA: TAreaElement);
   var
      ci: integer;
      L: TPolyLineElement;
      cX,cY: single;
      txR: TRectF;
      tx: string;
      LocPath: TPathData;
   begin
      LocPath := TPathData.Create;
      for ci := 0 to anA.LastIndex - 1 do
      begin
         if ci = 0 then
         begin
            A.X := GetPageX(anA.Xi[ci]);
            A.Y := GetPageY(anA.Yi[ci]);
            LocPath.MoveTo(A);
            A1 := A;
         end
         else
         begin
            B.X := GetPageX(anA.Xi[ci]);
            B.Y := GetPageY(anA.Yi[ci]);
            if B.Distance(A) > 2 then
            begin
               LocPath.LineTo(B);
               A := B;
            end;
         end;
      {$IFDEF ARETEST}
//      Image.Bitmap.Canvas.Font.SetSettings('Arial',8,TFontStyles.);
//      Image.Bitmap.Canvas.BeginScene;
      txR := TRectF.Create(A.X - 20,A.Y - 20,A.X + 40,A.Y + 40);
      Image.Bitmap.Canvas.FillText(txR,IntToStr(ci),false,100,[], TTextAlign.Center, TTextAlign.Center);
//      Image.Bitmap.Canvas.EndScene;
      {$ENDIF}
      end;
      LocPath.ClosePath;
//      aPath.LineTo(A1);
//      aPath.MoveTo(A1);
      aPath.AddPath(LocPath);
   end;

   procedure BlinkAre(anAre: TAreaElement);
   var
      i: integer;
      Hole: TAreaElement;
      Area: TAreaElement;
   begin
      if anAre is TPolyLineAreaElement then
         Area := TPolyLineAreaElement(anAre).CreateAreaElement
      else
         Area := anAre;
      FillAre(Area);
      if Area.Holes <> nil then
      if Area.Holes.Count > 0 then
      for i := 0 to Area.Holes.LastIndex do
      begin
         Hole := TAreaElement(Area.Holes.Elements[i]);
         FillAre(Hole);
      end;

   end;
begin
   if ImDrawing then exit;
   ImDrawing := true;
   Image.Bitmap.Canvas.BeginScene;
   aPath := TPathData.Create;
   Image.Bitmap.Canvas.Fill.Kind := TBrushKind.Solid;
   Image.Bitmap.Canvas.Fill.Color := TAlphaColors.Red;
   aPath.Clear;
   try
   A.X := 0;
   A.Y := 0;
   aPath.MoveTo(A);
   A.X := Image.Bitmap.Width;
   aPath.LineTo(A);
   A.Y := Image.Bitmap.Height;
   aPath.LineTo(A);
   A.X := 0;
   aPath.LineTo(A);
   A.Y := 0;
   aPath.LineTo(A);
   aPath.MoveTo(A);
   if anArea is TMultiAreaElement then
   begin
      MA := TMultiAreaElement(anArea);
      for ai := 0 to MA.LastIndex do
         BlinkAre(TAreaElement(MA.Elements[ai]));
   end
   else
      BlinkAre(anArea);
   Image_edit_Detail.Bitmap.Canvas.BeginScene;
   Image_edit_Detail.Bitmap.Canvas.Clear(TAlphaColors.Null);
   Image_edit_Detail.Bitmap.Canvas.Fill.Color := TAlphaColors.Black;
   Image_edit_Detail.Bitmap.Canvas.FillPath(aPath, 1); //0.6
   Image_edit_Detail.Bitmap.Canvas.EndScene;
   SrcRect  := TRectF.Create(0,0,Image_edit_Detail.Bitmap.Width,Image_edit_Detail.Bitmap.Height);
   DestRect := TRectF.Create(0,0,Image.Bitmap.Width,Image.Bitmap.Height);
   Image.Bitmap.Canvas.DrawBitmap(Image_edit_Detail.Bitmap,SrcRect,DestRect,0.6);
   {$IFNDEF ARETEST}
   Image.Bitmap.Canvas.Stroke.Color := TAlphacolors.Red;
   Image.Bitmap.Canvas.Stroke.Join := TStrokeJoin.sjRound;
   Image.Bitmap.Canvas.Stroke.Dash := TStrokeDash.Solid;
   Image.Bitmap.Canvas.Stroke.Cap := TStrokeCap.scRound;
   Image.Bitmap.Canvas.Stroke.Kind := TBrushKind.Solid;
   Image.Bitmap.Canvas.DrawPath(aPath,1);
   {$ENDIF}
   Image.Bitmap.Canvas.EndScene;
//   Application.ProcessMessages;
   finally
      ImDrawing := false;
      AreaBlinked := true;
   end;
//   Application.ProcessMessages;
end;

procedure TMainForm.BlinkLine(aLine: TPolyElement);
var
   A,B: TPointF;
   i: integer;
begin
   if ImDrawing then exit;
   if aLine.CoordsCount < 2 then exit;
   ImDrawing := true;
   GPath.Align := TAlignLayout.Contents;
   GPath.Data.Clear;
   GPath.Fill := TBrush.Create(TBrushKind.None, $0);
   try
   for i := 0 to aLine.CoordsCount - 1 do
   begin
      if i = 0 then
      begin
         A.X := GetPageX(aLine.Xi[i]);
         A.Y := GetPageY(aLine.Yi[i]);
         GPath.Data.MoveTo(A);
      end
      else
      begin
         B.X := GetPageX(aLine.Xi[i]);
         B.Y := GetPageY(aLine.Yi[i]);
         if B.Distance(A) > 2 then
         begin
//            Image.Bitmap.Canvas.DrawLine(A,B,1);
            GPath.Data.LineTo(B);
//            A.X := B.X;
//            A.Y := B.Y;
         end;
      end;
   end;
   GPath.RecalcUpdateRect;
   for i := 0 to 20 do
   begin
      GPath.Visible := true;
      Application.ProcessMessages;
      Gpath.Visible := false;
      Application.ProcessMessages;
   end;
   finally
   ImDrawing := false;
   end;
//   Application.ProcessMessages;
end;

procedure TMainForm.botbarunvisibleClick(Sender: TObject);
begin
   botbar.Visible := false;
   botbarvisible.visible := True;
end;

procedure TMainForm.botbarvisibleClick(Sender: TObject);
begin
   botbar.Visible := true;
   botbarvisible.visible := false;
end;

procedure TMainForm.Button10Click(Sender: TObject);
var
   FU: Tgis_ForestUnit;
begin
   Fu := LHC.ActualDilec;
   if FU <> nil  then
   begin
      CHangeProjectionByRect(FU.MinX,FU.MinY,FU.MaxX,FU.MaxY);
      if RealScale  < 2000 then
      begin
          CHangeProjection(CenterX,CenterY,2000);
      end;
      Review(false);
      ShowScaleAndCoords;
   end;
end;

procedure TMainForm.Button11Click(Sender: TObject);
var
   FU: Tgis_ForestUnit;
begin
   Fu := LHC.ActualPorost;
   if FU <> nil  then
   begin
      CHangeProjectionByRect(FU.MinX,FU.MinY,FU.MaxX,FU.MaxY);
      if RealScale  < 2000 then
      begin
          CHangeProjection(CenterX,CenterY,2000);
      end;
      Review(false);
      ShowScaleAndCoords;
   end;
end;

procedure TMainForm.Button12Click(Sender: TObject);
var
   FU: Tgis_ForestUnit;
begin
   Fu := LHC.ActualSkupina;
   if FU <> nil  then
   begin
      CHangeProjectionByRect(FU.MinX,FU.MinY,FU.MaxX,FU.MaxY);
      if RealScale  < 2000 then
      begin
          CHangeProjection(CenterX,CenterY,2000);
      end;
      Review(false);
      ShowScaleAndCoords;
   end
   else
   begin
       ShowMessage('PSK neni');
   end;
end;

procedure TMainForm.Button13Click(Sender: TObject);
var
   SP: string;
   S: TSave;
begin
   if PSYMB = nil then
   begin
      ShowMessage('No PSYMB');
      exit;
   end;
   SP := _Path.Combine(_Path.GetSharedDocumentsPath,'Test.orb');
   S := TSave.CreateAll(SP);
   try
   S.NoProgress := true;
   S.Input := PSYMB;
   S.DoIt;
   finally

   end;
end;

procedure TMainForm.Button14Click(Sender: TObject);
begin
{$IFDEF HK}
//    Test3DForm.Show;
{$ELSE}
    FloatAnimation1.Start;
{$ENDIF}
end;

procedure TMainForm.Button15Click(Sender: TObject);
begin
   ListBox_Layers.Visible := true;
   tab_layers_Layout.Visible := false;
   if Layers_Modified then
   begin
      Layers_Save;
      Layers_Modified := false;
   end;
end;

procedure TMainForm.Button16Click(Sender: TObject);
begin
  TestPanel.Visible := false;
end;

procedure TMainForm.Button17Click(Sender: TObject);
begin
   LockPanel.Visible := false;
end;

procedure TMainForm.b_editClick(Sender: TObject);
begin
   Image_edit_Detail.Visible := true;
   Image_edit.Visible := true;
   if (MLine <> nil) and (MLine.Count < 2)  then
   begin
      if ActualLayer <> nil then
      begin
         if MLine.IsMyOwner(ActualLayer) then
            ActualLayer.FreeElement(MLine);
      end;
   end;

   MLine := TPolyLineElement.Create;
//   ActualLayer.AddElement(MLine);
   Layers_UpdateList;

   if ActiveTool = at_Meas then
   begin
      Edit_Clear;
      exit;
   end;
   Edit_Clear;
//   Image_edit.Bitmap.Resize(Round(Image.Bitmap.Width),Round(Image.Bitmap.Height));
//   Image_edit.Bitmap.Canvas.BeginScene;
//   Image_edit.Bitmap.Canvas.Clear(TAlphaColors.Null);
//   Image_edit.Bitmap.Canvas.EndScene;
//   Image_edit_Detail.Bitmap.Resize(Round(Image.Bitmap.Width),Round(Image.Bitmap.Height));
//   Image_edit_Detail.Bitmap.Canvas.BeginScene;
//   Image_edit_Detail.Bitmap.Canvas.Clear(TAlphaColors.Null);
//   Image_edit_Detail.Bitmap.Canvas.EndScene;
//
//   Image_edit.Bitmap.Resize(Round(Image.Bitmap.Width),Round(Image.Bitmap.Height));
//   Image_edit.Bitmap.Canvas.BeginScene;
//   Image_edit.Bitmap.Canvas.Clear(TAlphaColors.Null);
//   Image_edit.Bitmap.Canvas.EndScene;
//   Image_edit_Detail.Bitmap.Resize(Round(Image.Bitmap.Width),Round(Image.Bitmap.Height));
//   Image_edit_Detail.Bitmap.Canvas.BeginScene;
//   Image_edit_Detail.Bitmap.Canvas.Clear(TAlphaColors.Null);
//   Image_edit_Detail.Bitmap.Canvas.EndScene;
   ActiveTool := at_Meas;
   ActionPanel.Visible := true;
   l_Caption.Text := 'Měření vzdálenosti/plochy';
   l_Text.Text := 'Režim měření ukončíte volbou jiného nástroje...';
   EditLineLayout.Visible := true;
   b_NewLine.Text := 'Nové měření';
   EditLineChangeSubTool(0);
end;

procedure TMainForm.b_endRouteClick(Sender: TObject);
begin
   diode.Opacity := 0.1;
   b_endRoute.Enabled := false;
   b_StartRoute.Enabled := true;
   Route_End;
   dlg_Edit.Text := 'Trasa '+IntToStr(Routes.Count);
   dlg_Text.Text := 'Uložit trasu pod názvem:';
   dlg_General.Visible := true;
end;

procedure TMainForm.b_HandClick(Sender: TObject);
begin
   b_Hand.TintColor := TAlphaColors.Blueviolet;
   ChangeActiveTool(0);
//   tabc.ActiveTab := tab_Tools;
//   MultiView.ShowMaster;
//   ToolsListBox.Visible := true
end;

procedure TMainForm.b_HKClick(Sender: TObject);
begin
{$IFDEF HK}
//   Form2.Show;
//   exit;
  if not System.IOUtils.TFile.Exists(IncludeTrailingPathDelimiter(DBPath) + 'LHC_' + S_LHC + '_' + S_rok + '.s3db') then
  begin
     ShowMessage('DB údaje pro LHC '+S_LHC+' a rok '+S_rok+' nejsou k dispozici.');
     exit;
  end;
//  AniIndicator.Visible := true;
//  AniIndicator.Enabled := true;
//  Application.ProcessMessages;
  try
   Form2.ZobrazHK(s_LHC,S_rok,S_Oddeleni,s_Dilec,s_Porost,S_Skupina);
  finally

  end;
//  AniIndicator.Visible := false;
//  AniIndicator.Enabled := false;
{$ELSE}
   if (LHC <> nil) and (FMSelector <> nil) and (FMSelector.ActualFrame <> nil)then
   begin
      if Assigned(OnSelectJPRL) then
         OnSelectJPRL(FMSelector.ActualFrame)
      else
      begin
         ShowMessage('OnSelectJPRL není obsazeno ')
      end;
   end
   else
      Visible := false;
{$ENDIF}
end;

procedure TMainForm.Button1Click(Sender: TObject);
begin
   dlg_Edit.Text := 'Trasa test';
   dlg_General.Visible := true;
end;

procedure TMainForm.Button2Click(Sender: TObject);
begin
   ImDrawing := false;
end;

procedure TMainForm.b_ToolsClick(Sender: TObject);
begin
   b_Tools.TintColor := TAlphaColors.Blueviolet;
   tabc.ActiveTab := tab_Tools;
   MultiView.ShowMaster;
end;

procedure TMainForm.b_TraceRouteClick(Sender: TObject);
begin
   p_gpslog.Visible := not p_gpslog.Visible;
   if p_gpslog.Visible then
   begin
      b_TraceRoute.Text := 'Zavřít trasování GPS' ;
   end
   else
   begin
      b_TraceRoute.Text := 'Trasování GPS' ;
   end;
end;

procedure TMainForm.b_viewClick(Sender: TObject);
begin
   MiniLed_Notes_Form.Show;
end;

procedure TMainForm.b_OpenProjectClick(Sender: TObject);
begin
{$IFDEF HK}
   ShowLHCList;
{$ELSE}
   XFileDialog.Filter := '.opx';
   XFileDialog.Directory := '/';
   XFileDialog.ed_Caption.Text := 'Výběr souboru projektu';
   XFileDialog.OnSelect := OnSelectFile;
//   xFileDialog.DirsOnly := true;
   XFileDialog.Show;
{$ENDIF}

end;

procedure TMainForm.Button3Click(Sender: TObject);
begin
  p_Settings.Visible := false;
end;

procedure TMainForm.topbarunvisibleClick(Sender: TObject);
var
   P1,P2: TPointF;
begin
   topbarvisible.Visible := true;
{$IFDEF HK}
   TopBar.Visible := false;
{$ELSE}
   hTopBar.Visible := false;
{$ENDIF}
end;

procedure TMainForm.topbarvisibleClick(Sender: TObject);
begin
   topbarvisible.Visible := false;
{$IFDEF HK}
   TopBar.Visible := true;
{$ELSE}
   hTopBar.Visible := true;
{$ENDIF}
end;

{$IFDEF HK}

procedure TMainForm.TryToRegisterMap;
var
   MR: RMap;
   ms: System.Classes.TMemoryStream;
   http: TIdHTTP;
   n,DE: IXMLNode;
   i: integer;
   LI: TListBoxItem;
   mrs: string;
   MapError,NewRecord: integer;
   RegOK: boolean;
   ConfirmFileName: string;
begin
//   RegMapForm.Memo.Visible := true;
//   RegMapForm.Memo.Lines.Clear;
   i := 0;
   for MR in Maps do
   begin
//      if MR.Registered then
//         RegMapForm.Memo.Lines.Add(MR.MapName+' ... již je registrována')
//      else
//      if MR.Error < mrer_NotRegistered then
//         RegMapForm.Memo.Lines.Add(MR.MapName+' ... Chybné údaje - Nelze registrovat!')
//      else
      LI := RegMapForm.RegMapListBox.ItemByIndex(i);
      RegMapForm.RegMapListBox.ItemIndex := i;
      Inc(i);
      if not MR.Registered and (MR.Error = mrer_NotRegistered) then
      begin
         ms := TMemoryStream.Create;
         http := TIdHttp.Create;
         try
         LI.ItemData.Detail := '    Navazuji spojení se servrem ...';
//         RegMapForm.Memo.Lines.Add(MR.MapName+' ... Registrace');
//         RegMapForm.Memo.Lines.Add('      ... Navazuji spojení se servrem');
////         ****
//         RegMapForm.Memo.Lines.Add('      * '+T_DeviceInfo.GetModel);
//         RegMapForm.Memo.Lines.Add('      * '+T_DeviceInfo.GetOS);
//         RegMapForm.Memo.Lines.Add('      *** ');
////         ****
         http.Get('https://www.tpro.cz/reg_map_inst.php?device='+T_DeviceInfo.GetIMEI+'&mapid='+MR.MapID+'&model='+T_DeviceInfo.GetModel_W+'&os='+T_DeviceInfo.GetOS_W,ms);
//         RegMapForm.Memo.Lines.Add('      ... OK');
         ms.Position := 0;
         XMLDocument.Active := false;
         XMLDocument.LoadFromStream(ms);
         DE := XMLDocument.DocumentElement;
         MapError := StrToIntDef(DE.ChildNodes['error'].Text,99);
         NewRecord := StrToIntDef(DE.ChildNodes['newrecord'].Text,99);
         RegOK := false;
         case MapError of
            0:
            begin    // registrace se zdarila
               RegOK := true;
               if NewRecord = 1 then
                  mrs := ' Záznam byl vytvořen'
               else
                  mrs := ' Záznam již existuje';
               // vytvoreni registracniho souboru
               ConfirmFileName := ProjectPath.maps+THashSHA1.GetHashString(MR.MapID+T_DeviceInfo.GetIMEI);
               XMLDocument.SaveToFile(ConfirmFileName);
               Maps[i - 1].Error := mrer_None;
               Maps[i - 1].Registered := true;
               mrs := 'Registrace OK ' + mrs;
               LI.ImageIndex := 2;
            end;
            1: mrs := 'Chyba - server hlásí problém s databází';
            2: mrs := 'Chyba - Neexistující mapa';
            3: mrs := 'Chyba - Neautorizovaná mapa';
            4: mrs := 'Chyba - Překročen max. počet instalací';
         end;

         LI.ItemData.Detail := MRS;
         Application.ProcessMessages;
         except
            on e: Exception do
            begin
//               ShowMessage(e.Message);
              MRS := 'Chyba internetového připojení! '+e.Message;
              LI.ItemData.Detail := MRS;
              ShowMessage(mrs);
              exit;
            end;
//            RegMapForm.Memo.Lines.Add('      ... Chyba internetového připojení!');
         end;
      end;
   end;
   Tiles.Clear;
end;

{$ELSE}
procedure TMainForm.TryToRegisterMap;
begin
   // Nothing  if not HK defined
end;
{$ENDIF}

procedure TMainForm.ZnPSYMB_Load;
var
   S,SysP: string;
   L: TLoad;
   i: integer;
   En: TEntity;
   TD: TTopolDruh;
begin
//   S := _Path.Combine(_Path.GetSharedDocumentsPath, 'map');
   S := _Path.Combine(_Path.GetPublicPath, 'map');
   SysP := _Path.Combine(S, 'system');
   S := _Path.Combine(SysP, 'PSYMB.orb');
   if System.IOUtils.TFile.Exists(S) then
   begin
      l_Progress.Text := 'Čtení PSYMB z '+ S;
      Application.ProcessMessages;
      L := TLoad.CreateAll(S);
      L.NoProgress := true;
      try
      L.DoIt;
      if not(L.output is TOwnerEntity) then exit;
      PSYMB := TOwnerEntity(L.Output);
      finally
         L.Free;
      end;
   end
//   ;
   else
      ShowMessage('PSYMB NOT FOUND!');

   S := _Path.Combine(SysP, 'Zn.orb');
   if System.IOUtils.TFile.Exists(S) then
   begin
      l_Progress.Text := 'Čtení Zn z '+ S;
      Application.ProcessMessages;
      L := TLoad.CreateAll(S);
      L.NoProgress := true;
      try
      L.DoIt;
      if not(L.output is TTopolDruhy) then exit;
      Zn := TTopolDruhy(L.Output);
      finally
         L.Free;
      end;
   end
//   ;
   else
      ShowMessage('Zn NOT FOUND!');
  if Zn <> nil then
  begin
     Point_Edit_ComboBox.Clear;
     for i := 0 to Zn.B.LastIndex do
     begin
         TD := TTopolDruh(Zn.B.Elements[i]);
         if i = 0 then
            Zn.B.ActualDruh := TD;
         Point_Edit_ComboBox.Items.AddObject(TD.Name,TD);
     end;
     Point_Edit_ComboBox.ItemIndex := 0;
  end;
end;

procedure TMainForm.Button4Click(Sender: TObject);
var
   But: TButton;
   Sw: TSwitch;
{$IFDEF DIRECTGPS}
  LocationManagerService: JObject;
  iter : JIterator;
  location : JLocation;
{$ENDIF}
begin
{$IFDEF HK}
   But := Button4;
   Sw := Switch1;
{$ELSE}
   But := hButton4;
   Sw := Switch2;
{$ENDIF}
{$IFDEF DIRECTGPS}
   if not GPSOn then
   begin
      if not Assigned(FLocationManager) then
      begin
        LocationManagerService := SharedActivityContext.getSystemService(TJContext.JavaClass.LOCATION_SERVICE);
        FLocationManager := TJLocationManager.Wrap((LocationManagerService as ILocalObject).GetObjectID);
        if not Assigned(locationListener) then
          locationListener := TLocationListener.Create(self);
        FLocationManager.requestLocationUpdates(TJLocationManager.JavaClass.GPS_PROVIDER, 500, 1, locationListener,
            TJLooper.JavaClass.getMainLooper);
      end;

//      iter := FLocationManager.GetAllProviders.Iterator;
//      ListBox1.Clear;
//      while iter.hasNext do
//      begin
//        ListBox1.Items.Add(JStringToString(iter.next.ToString));
//      end;
//      CheckBox1.IsChecked := FLocationManager.isProviderEnabled(TJLocationManager.JavaClass.GPS_PROVIDER);
//      CheckBox2.IsChecked := FLocationManager.isProviderEnabled(TJLocationManager.JavaClass.NETWORK_PROVIDER);
//      location := FLocationManager.getLastKnownLocation(TJLocationManager.JavaClass.GPS_PROVIDER);
//      onLocationChanged(location);


      if not FLocationManager.isProviderEnabled(TJLocationManager.JavaClass.GPS_PROVIDER) then
      begin
         ShowMessage('Není povolena poloha podle GPS satelitů!');
         exit;
      end;
      GPSFixed := false;
      jtskX := 0;
      jtskY := 0;
      l_gps.Text := 'gps zapnuta, čeká na signál...' ;
//      LocationSensor.Active := true;
      GpsOn := true;
      But.Text := 'GPS +';
      b_gpss.ImageIndex := 1;
      Img_Orange.Visible := true;
      Img_Black.Visible := false;
      Img_Green.Visible := false;
      Sw.Visible := true;
   end
   else
   begin
     if Assigned(locationListener) then
        if Assigned(FLocationManager) then
        begin
             FLocationManager.removeUpdates(locationListener);
             FLocationManager := nil;
        end;
      GpsFixed := false;
      gpsCursor.Visible := false;
      gpscur.Visible := false;
      l_gps.Text := 'gps vypnuta...' ;
//      LocationSensor.Active := false;
      But.Text := 'GPS';
      Img_Orange.Visible := false;
      Img_Black.Visible := true;
      Img_Green.Visible := false;
      GpsOn := false;
      Sw.Visible := false;
   end;
{$ELSE}
   if not GPSOn then
   begin
      GPSFixed := false;
      jtskX := 0;
      jtskY := 0;
      l_gps.Text := 'gps zapnuta, čeká na signál...' ;
      LocationSensor.Active := true;
      But.Text := 'GPS +';
      GpsOn := true;
   end
   else
   begin
      GpsFixed := false;
      gpsCursor.Visible := false;
      gpscur.Visible := false;
      l_gps.Text := 'gps vypnuta...' ;
      LocationSensor.Active := false;
      But.Text := 'GPS';
      GpsOn := false;
   end;
{$ENDIF}
end;

procedure TMainForm.b_ActionPanelCloseClick(Sender: TObject);
begin
//   l_gps.Text := TPath.GetHomePath;
   p_Note.Visible := false;
   ActiveTool := 0;
   Status := 0;
//   b_Note_Glow.Enabled := false;
   ActionPanel.Visible := false;
   Image_Edit_Detail.Visible := false;
//   Image_Edit.Visible := false;
end;

procedure TMainForm.b_AddLinePointClick(Sender: TObject);
begin
   EditLineChangeSubTool(0);
end;

procedure TMainForm.b_AddLinePointGPSClick(Sender: TObject);
var
   MX,MY: double;
begin
   if GPSFixed then
   begin
      MX := jtskX;
      MY := jtsky;
      if MLine = nil then
         MLine := TPolyLineElement.Create;
      // No points
      if MLine.Count = 0 then
      begin
         MLine.AddXY(MX,MY);
         MLine.Update;
         MLineActivePoint := 0;
      end
      else
      begin
         // add point
         if MlineActivePoint = 0 then
         begin
            MLine.InsertXY(0,MX,MY);
            MLine.Update;
            MLineActivePoint := 0;
         end
         else
         begin
            MLine.AddXY(MX,MY);
            MLine.Update;
            MLineActivePoint := MLine.LastIndex;
         end;
      end;
      DrawLineEdit(MLine,MLineActivePoint,EditColors.LineColor,nil);
      DrawLineDetail(MLine,MLineActivePoint, EditColors.LineColor,nil);
      l_Text.Text := 'Délka: '+FormatFloat('0.###',MLine.Length)+ ' m      Plocha:'+FormatFloat('0.##',Abs(MLine.Area)/10000)+' ha';
      BMMoving := false;
//      Application.ProcessMessages;
   end
   else
   begin
       ShowMessage('GPS poloha není k dispozici');
   end;
end;

procedure TMainForm.b_DeleteLinePointClick(Sender: TObject);
begin
   if not (ActiveTool in [at_Meas,at_Line])  then exit;
   if MLine.Count < 2 then exit;
   MLine.FreeElement(MLine.Elements[MLineActivePoint]);
   CheckMLineActivePoint;

   DrawLineEdit(MLine,MLineActivePoint,EditColors.LineColor,nil);
   DrawLineDetail(MLine,MLineActivePoint,EditColors.LineColor,nil);
   l_Text.Text := 'Délka: '+FormatFloat('0.###',MLine.Length)+ ' m      Plocha:'+FormatFloat('0.##',Abs(MLine.Area)/10000)+' ha';
end;

procedure TMainForm.Button6Click(Sender: TObject);
var
   S: string;
begin
   S := _Path.Combine(_Path.GetDocumentsPath, 'PSYMB.orb');
   if System.IOUtils.TFile.Exists(S) then
      ShowMessage('PSYMB OK')
   else
      ShowMessage('PSYMB NOT FOUND');
   S := _Path.Combine(_Path.GetDocumentsPath, 'Zn.orb');
   if System.IOUtils.TFile.Exists(S) then
      ShowMessage('Zn OK')
   else
      ShowMessage('Zn NOT FOUND');
end;

procedure TMainForm.Button7Click(Sender: TObject);
var
   cec: TComplicatedGECollection;
begin
   cec := TComplicatedGECollection(ListBox_Layers.Selected.Data);
   Layer_UpdateList(cec);
   MultiView.HideMaster;
   MiniLed_Notes_Form.Show;
end;

procedure TMainForm.b_EditPointClick(Sender: TObject);
begin
   Image_edit.Visible := true;
//   ePoint := TPolyLineElement.Create;
   ePoint := nil;
   if ActiveTool = at_Point then
   begin
      Edit_Clear;
      exit;
   end;
   Edit_Clear;
   ActiveTool := at_Point;
   Point_Edit_Layout.Visible := true;
   PointColorButton.Color := DejBarvicku(Barva);
   ActionPanel.Visible := true;
   l_Caption.Text := 'Editace bodů';
   l_Text.Text := 'Aktivní vrstva... '+ActualSuperLayer.Text;
//   l_Text.Text := 'Režim bodů ukončíte zavřením tohoto panelu...'
end;

procedure TMainForm.b_SelectLinePointClick(Sender: TObject);
begin
   if ActiveSubTool = 1 then
      EditLineChangeSubTool(0)
   else
      EditLineChangeSubTool(1);
end;

procedure TMainForm.b_SelectLinePointDownClick(Sender: TObject);
begin
   if MLine = nil then exit;
   if MLineActivePoint = 0 then exit;
   Dec(MLineActivePoint);
   DrawLineEdit(MLine,MLineActivePoint, EditColors.LineColor,nil);
   DrawLineDetail(MLine,MLineActivePoint, EditColors.LineColor,nil);
end;

procedure TMainForm.b_SelectLinePointFirstClick(Sender: TObject);
begin
   if MLine = nil then exit;
   MLineActivePoint := 0;
   DrawLineEdit(MLine,MLineActivePoint, EditColors.LineColor,nil);
   DrawLineDetail(MLine,MLineActivePoint, EditColors.LineColor,nil);
end;

procedure TMainForm.b_SelectLinePointLastClick(Sender: TObject);
begin
   if MLine = nil then exit;
   MLineActivePoint := MLine.LastIndex;
   DrawLineEdit(MLine,MLineActivePoint, EditColors.LineColor,nil);
   DrawLineDetail(MLine,MLineActivePoint, EditColors.LineColor,nil);
end;

procedure TMainForm.b_SelectLinePointUpClick(Sender: TObject);
begin
   if MLine = nil then exit;
   if MLineActivePoint = MLine.LastIndex then exit;
   Inc(MLineActivePoint);
   DrawLineEdit(MLine,MLineActivePoint, EditColors.LineColor,nil);
   DrawLineDetail(MLine,MLineActivePoint, EditColors.LineColor,nil);
end;

procedure TMainForm.b_SettingsClick(Sender: TObject);
begin
   tabc.ActiveTab := tab_main;
   MultiView.ShowMaster;
   exit;
   p_Settings.Visible := not p_Settings.Visible;
   if p_Settings.Visible then
   begin
      cbActive := false;
      {$IFDEF HK}
      cb_topbar.IsChecked := topBar.Visible;
      {$ELSE}
      cb_topbar.IsChecked := htopBar.Visible;
      {$ENDIF}
      cb_botbar.IsChecked := botbar.Visible;
//      cb_plusminus.IsChecked := b_plus.Visible;
      cb_jprl.IsChecked := CHeckJPRL;
      cbActive := true;
   end;
end;

procedure TMainForm.GPS_SClick(Sender: TObject);
var
   gpss: TGpsStatusClass;
   i: integer;
begin
   gpss := TGpsStatus.Current;
   if Gpss <> nil  then
   begin
      GPS_S.Text := gpss.SatelliteCount.ToString;
   end
   else
   begin
      GPS_S.Text := 'nil';
   end;
end;

procedure TMainForm.b_FindLHCClick(Sender: TObject);
begin
   p_FInd.Visible := not p_Find.Visible;
end;

procedure TMainForm.Button8Click(Sender: TObject);
begin
   p_FInd.Visible := false;
end;

procedure TMainForm.Button9Click(Sender: TObject);
var
   FU: Tgis_ForestUnit;
begin
   Fu := LHC.ActualOddeleni;
   if FU <> nil  then
   begin
      CHangeProjectionByRect(FU.MinX,FU.MinY,FU.MaxX,FU.MaxY);
      if RealScale  < 2000 then
      begin
          CHangeProjection(CenterX,CenterY,2000);
      end;
      Review(false);
      ShowScaleAndCoords;
   end;
end;

function TMainForm.ChangeActiveTool(aIndex: integer): boolean;
begin
   result := true;
   if ActiveTool = aIndex then exit;
   if not FinishActiveTool then
   begin
     result := false;
     WaitingActiveTool := aIndex;
     exit;
   end;
   WaitingActiveTool := at_Null;
   if Layers_Modified then
      Layers_Save;
   Layers_Modified := false;
   StartActiveTool(aindex);
end;

procedure TMainForm.CHangeProjection(_X, _Y, _Scale: double);
var
   Center_X, Center_Y,W,H: Single;
   S: string;
begin
//   l_Scale.Text := '1 : ' + IntToStr(Round(_Scale));
//   S := '0.###';
//   l_jtsk.Text := 'X: '+FormatFloat(S,_X) + ' Y: '+FormatFloat(S,_Y);
   CenterX   := _X;
   CenterY   := _Y;
   RealScale := _Scale;
   W := Image.Width;
   H := Image.Height;
//   W := Image.Bitmap.Width;
//   H := Image.Bitmap.Height;
   Center_X := W / 2;
   Center_Y := H / 2;
   MultX := RealScale/5333; //Resolution.x; dpi / size of inch in mm * 1000
   MultY := MultX;
   AddX := CenterX - (Center_X * MultX);
   AddY := CenterY + (Center_Y * MultY);
   MinX := GetModelX(0);
   MinY := GetModelY(H);
   MaxX := GetModelX(W);
   MaxY := GetModelY(0);
//   if _Scale = Scale1 then
//      aScale := 1
//   else
//      aScale := 2;
end;

procedure TMainForm.ChangeProjectionByFirstMapTile;
var
   MapRec : RMap;
   S: string;
   //G: Graphics;
   bm1: FMx.Graphics.TBitmap;
   DestRect,SrcRect: TRectF;
   rX,rY: integer;
   x1,y1,x2,y2: double;
   wi,hi: single;
   wd,hd: double;
begin
   if Length(Maps) < 1 then exit;
   MapRec := Maps[0];
//   //MessageBox.Show(S);
//   S := MapDirectory + MapRec.MapName;
   try
////   MessageBox.Show(S);
////   exit;
//   //if BM <> nil then
//   //  BM.Dispose;
////   ShowMessage('load bmp');
//   Bm1 := FMX.Graphics.TBitmap.CreateFromFile(S);
//   Image.Bitmap.Canvas.BeginScene;
////   ShowMessage('clear');
//   Image.Bitmap.Canvas.Clear(BColor);
//   aScale := 1;
//   SrcRect.Create(0,0,Bm1.Width,Bm1.Height);
//   DestRect.Create(RefX,RefY,RefX + (Bm1.Width / Image.Canvas.Scale),RefY + (Bm1.Height / Image.Canvas.Scale));
//
////   ShowMessage('draw');
//
//   Image.Bitmap.Canvas.DrawBitmap(Bm1,SrcRect,DestRect,100);
//   Image.Bitmap.Canvas.EndScene;
////   PaintBox.BitmapChanged;
//   wi := Image.Width;
//   hi := Image.Height;
//   if BM1.Width < wi then
//      wi := BM1.Width;
//   if BM1.Height < hi then
//      hi := BM1.Height;
//   WD := MapRec.MaxX - MapRec.MinX;
//   HD := MapRec.MaxY - MapRec.MinY;
   x1 := MapRec.MinX;
   Y1 := MapRec.MinY;
//   Y1 := Y2 - hD / BM1.Height * hi;
//   x2 := X1 + wd / BM1.Width  * wi;
   x2 := MapRec.MaxX;
   Y2 := MapRec.MaxY;

//   Bm1.DisposeOf;
//   ShowMessage('Chng proje');
   CHangeProjectionByRect(X1,Y1,X2,Y2);
//   Scale1 := RealScale;
//   PictureBox1.Image := System.Drawing.Bitmap.Create(S);
//   ShowMessage('After Chng proje');
   finally
//      ShowMessage('ups');
   end;
end;

procedure TMainForm.CHangeProjectionByRect(X1, Y1, X2, Y2: double);
var
   _x,_y: double;
   _Scale: double;
   ScaleX: double;
   ScaleY: double;
   dX,dY: double;
begin
   dX := X2 - X1;
   dY := Y2 - Y1;
   try
     ScaleX := dX/(Image.Width/5333);
     ScaleY := dY/(Image.Height/5333);
     if ScaleX > ScaleY then _Scale := ScaleX
                        else _Scale := ScaleY;
     _x :=  X1 + dX/2;
     _y :=  Y1 + dY/2;
     ChangeProjection(_X,_Y, _Scale)
   except
   end
end;

procedure TMainForm.CHeckActiveTool(NewActive: integer);
begin

end;

procedure TMainForm.CHeckMLineActivePoint;
begin
   if MLineActivePoint < 0 then
      MLineActivePoint := 0
   else
   if MLineActivePoint > MLine.LastIndex then
      MLineActivePoint := MLine.LastIndex;
end;

procedure TMainForm.CheckProgress;
var
   i: integer;
   PE: TProgressElem;
begin
   exit;
   if Proc.NoElements then
   begin
      ProgressBar.Visible := false;
      l_Progress.Visible := false;
      Memo.Lines.Clear;
      Memo.Visible := false;
   end
   else
   begin
      ProgressBar.Visible := true;
      l_Progress.Visible := true;
      Memo.Visible := true;
      Memo.Lines.Clear;
      Memo.Lines.Add('      PROGRESS ');
      Memo.Lines.Add('------------------------');
      for i := 0 to Proc.LastIndex do
      begin
         PE := TProgressElem(Proc.Elements[i]);
         Memo.Lines.Add(PE._Name+' '+IntToStr(PE.Min)+'/'+IntToStr(PE.Progress)+'/'+IntToStr(PE.Max)+' '+PE.Text);
         Memo.Lines.Add('------------------------');
      end;
      Application.ProcessMessages;
   end;

end;

procedure TMainForm.ColorListBoxApplyStyleLookup(Sender: TObject);
var
  ColorObj: TFmxObject;
  LI: TListBoxItem;
  i: integer;
begin
   LI := TListBoxItem(Sender);
   ColorObj := LI.FindStyleResource('color');
   if ColorObj is TShape then
     TShape(ColorObj).Fill.Color := TRGB_Color(LI.Data).Value;
end;

procedure TMainForm.ColorListBoxItemClick(const Sender: TCustomListBox; const Item: TListBoxItem);
begin
   ColorPopup.IsOpen := false;
   Barva := StrToIntDef(Item.Text,13);
   if ActiveTool = at_Point then
   begin
      PointColorButton.Color := DejBarvicku(Barva);
      if EPoint <> nil then
      begin
         EPoint.Color := Barva;
         DrawPoint(ePoint,true);
         Layers_Modified := true;
      end;
   end;
end;

procedure TMainForm.Colors_Prepare;
var
   i: integer;
   LItem: TListBoxItem;
   S: string;
   ColorObj: TFmxObject;
   RGBC: TRGB_Color;
   LIcont: boolean;
begin
  // Code to fill TListView
  ColorListBox.BeginUpdate;
  try
    ColorListBox.Items.Clear;
    for I := 0 to 15 do
    begin
       RGBC := TRGB_Color(SystemColorPalette.Elements[i]);
       LItem := TListBoxItem.Create(ListBox_Layers);
       LItem.Text := IntToStr(i);
       LItem.Data := RGBC;
       // Update data managed by custom appearance
       S := '';
       LICont := false;
//       LItem.ItemData.Detail := S;
//       LItem.ItemData.Bitmap := Image1.Bitmap;
       LItem.ItemData.Accessory := TListBoxItemData.TAccessory(1);
//       LItem.StyleLookup := 'listboxitembottomdetail';
       LItem.StyleLookup := 'colorlistboxitemstyle';
       LItem.OnApplyStyleLookup := ColorListBoxApplyStyleLookup;
//       LItem.IsChecked := En.Visible;
       ColorListBox.AddObject(LItem);
    end;
  finally
    ColorListBox.EndUpdate;
    Barva := 13;
  end;
end;

destructor TMainForm.Destroy;
begin
{$IFDEF DIRECTGPS}
  if Assigned(locationListener) then
     if Assigned(FLocationManager) then
          FLocationManager.removeUpdates(locationListener);
{$ENDIF}
  inherited;
end;

procedure TMainForm.tabcChange(Sender: TObject);
begin
   if tabc.ActiveTab = tab_view then
   begin
      cbActive := false;
      {$IFDEF HK}
      cb_topbar.IsChecked := topBar.Visible;
      {$ELSE}
      cb_botbar.IsChecked := botbar.Visible;
      {$ENDIF}
      cbActive := true;
   end;
end;

procedure TMainForm.tab_Layers_ComboColorChange(Sender: TObject);
var
   LI: TListBoxItem;
   cec: TComplicatedGECollection;
   ColorObj: TFmxObject;
begin
   LI := ListBox_Layers.Selected;
   cec := TComplicatedGECollection(LI.Data);
   cec.Color := tab_Layers_ComboColor.Color;
   Layers_Modified := true;
   ColorObj := LI.FindStyleResource('color');
   if ColorObj is TShape then
      TShape(ColorObj).Fill.Color := cec.Color;
end;

procedure TMainForm.dlg_CancelClick(Sender: TObject);
begin
   case Status of
      0:
      begin
         Routes.FreeElement(ActualRoute);
      end;
      1:
      begin
         ActualRoute := nil;
         Status := 0;
         ImageBakule.Visible := false;
      end;
      2:
      begin
         MLine := nil;
         if WaitingActiveTool > at_Null then
         begin
            EditLineChangeSubTool(0);
            if EditLineLayout.Visible then
               EditLineLayout.Visible := false;
            if ActionPanel.Visible then
               b_ActionPanelCloseClick(nil);
            Edit_Clear;
            StartActiveTool(WaitingActiveTool);

         end
         else
            StartLineEditing;
      end;
   end;
   dlg_General.Visible := false;
end;

procedure TMainForm.dlg_OKClick(Sender: TObject);
var
   T: TTextElement;
begin
   case Status of
      0:
      begin
         ActualRoute.Name := dlg_Edit.Text;
         Layers_UpdateList;
         Layers_Save;
      end;
      1:
      begin
         Status := 0;
         T := ActualNote;
//         T.Name := 'Poznámka';
         T.Text := dlg_Edit.Text;
         ActualLayer.AddElement(T);
         ImageBakule.Visible := false;
         Layers_UpdateList;
         Layers_Save;
         DrawLayers;
      end;
      2:
      begin
         MLine.Name := dlg_Edit.Text;
         ActualLayer.AddAndUpdateRect(MLine);
         Layers_UpdateList;
         Layers_Save;
         DrawLayers;
         if WaitingActiveTool > at_Null then
         begin
            EditLineChangeSubTool(0);
            if EditLineLayout.Visible then
               EditLineLayout.Visible := false;
            if ActionPanel.Visible then
               b_ActionPanelCloseClick(nil);
            Edit_Clear;
            StartActiveTool(WaitingActiveTool);
         end
         else
            StartLineEditing;
      end;
   end;
   dlg_General.Visible := false;
end;

procedure TMainForm.Drawgps;
var
   sX,sY: single;
begin
   if GPSFixed then
   begin
      if (jtskX < MaxX) and (jtskX > MinX) and (jtskY < MaxY) and (jtskY > MinY) then
      begin
         gpscur.Visible := false;
         gpsCursor.Visible := true;
         sX := GetPageX(jtskX);
         sY := GetPageY(jtskY);
         gpsCursor.Position.X := sX - (gpsCursor.Width / 2);
         gpsCursor.Position.Y := sY - (gpsCursor.Height / 2);
      end
      else
      begin
         gpsCursor.Visible := false;
         gpsCur.Visible := true;
         gpsCur.RotationAngle := DejStupne(ATan2G(jtskX - CenterX, jtskY - CenterY));
      end;
   end;
end;

procedure TMainForm.DrawLayers;
var
   i,ii: integer;
   e: TElement;
   cec, cc: TComplicatedGECollection;
begin
   if Layers = nil then exit;
   for i := 0 to Layers.LastIndex do
   begin
      e := Layers.Elements[i];
      if not (e is TComplicatedGECollection) then continue;
      cec := TComplicatedGECollection(e);
      if not cec.Visible then continue;
      for ii := 0 to cec.LastIndex do
      begin
          cc := cec.Layers[ii];
          if cc = nil then continue;
          if Uppercase(cc.Name) = 'L' then
             DrawLines(cc,cec.Color)
          else
          if Uppercase(cc.Name) = 'N' then
             DrawNotes(cc,cec.Color)
          else
          if Uppercase(cc.Name) = 'P' then
             DrawPoints(cc,cec.Color);
      end;
   end;
end;

procedure TMainForm.DrawLine(aLine: TPolyElement; aPart: integer; aColor: integer);
var
   A,B: TPointF;
   i: integer;
   Path: TPathData;
   aCanvas: TCanvas;
   aRect: TRectF;
   Starti,Endi: integer;
   P1,P2: TPointF;
begin
   if ImDrawing then exit;
   if aLine.CoordsCount < 2 then exit;

   ImDrawing := true;
   Path := TPathData.Create;
   try
   Starti := 0;
   Endi := aLine.CoordsCount - 1;
   aCanvas := Image.Bitmap.Canvas;
   aCanvas.BeginScene;
   aCanvas.Stroke.Color := aColor;//TAlphacolors.Red;
   aCanvas.Stroke.Join := TStrokeJoin.sjRound;
   aCanvas.Stroke.Dash := TStrokeDash.Solid;
   aCanvas.Stroke.Cap := TStrokeCap.scRound;
   aCanvas.Stroke.Kind := TBrushKind.Solid;
   aCanvas.StrokeThickness := 5;
   for i := Starti to Endi do
   begin
      if i = 0 then
      begin
         A.X := GetPageX(aLine.Xi[i]);
         A.Y := GetPageY(aLine.Yi[i]);
         Path.MoveTo(A);
      end
      else
      begin
         B.X := GetPageX(aLine.Xi[i]);
         B.Y := GetPageY(aLine.Yi[i]);
         if B.Distance(A) > 2 then
         begin
//            Image.Bitmap.Canvas.DrawLine(A,B,1);
            Path.LineTo(B);
            A.X := B.X;
            A.Y := B.Y;
         end;
      end;
   end;
   Path.MoveTo(A);
   aCanvas.DrawPath(Path,1);
   finally
   aCanvas.EndScene;
   ImDrawing := false;
   Path := nil;
   end;
//   Application.ProcessMessages;
end;

procedure TMainForm.DrawLineDetail(aLine: TPolyElement; aPart: integer; aColor: integer; aBM: TBitmap);
var
   A,B: TPointF;
   i: integer;
   Path: TPathData;
   aCanvas: TCanvas;
   aRect: TRectF;
   Starti,Endi: integer;
   P1,P2: TPointF;
begin
   if ImDrawing then exit;
   if aLine.CoordsCount < 1 then exit;
   ImDrawing := true;
   Path := TPathData.Create;
   try
   Starti := 0;
   Endi := aLine.CoordsCount - 1;
   if aBM <> nil then
      aCanvas := aBM.Canvas
   else
      aCanvas := Image_Edit_Detail.Bitmap.Canvas;
   if aPart > -1  then
   begin
      if aPart > 1 then
         Starti := aPart - 1;
      if aPart < Endi then
         Endi := aPart + 1;
   end;
   aCanvas.BeginScene;
   if aBM = nil then
      aCanvas.Clear(TAlphaColors.Null);

   aCanvas.Stroke.Color := aColor;//TAlphacolors.Red;
   aCanvas.Stroke.Join := TStrokeJoin.sjRound;
   aCanvas.Stroke.Dash := TStrokeDash.Solid;
   aCanvas.Stroke.Cap := TStrokeCap.scRound;
   aCanvas.Stroke.Kind := TBrushKind.Solid;
   aCanvas.StrokeThickness := 5;
   if aLine.CoordsCount > 1 then
   begin
      for i := Starti to Endi do
      begin
         if i = Starti then
         begin
            A.X := GetPageX(aLine.Xi[i]);
            A.Y := GetPageY(aLine.Yi[i]);
            Path.MoveTo(A);
         end
         else
         begin
            B.X := GetPageX(aLine.Xi[i]);
            B.Y := GetPageY(aLine.Yi[i]);
            if B.Distance(A) > 2 then
            begin
   //            Image.Bitmap.Canvas.DrawLine(A,B,1);
               Path.LineTo(B);
               A.X := B.X;
               A.Y := B.Y;
            end;
         end;
      end;
      Path.MoveTo(A);
      aCanvas.DrawPath(Path,1);
   end;

   aCanvas.Stroke.Color := EditColors.PointColor;
   aCanvas.StrokeThickness := 2;
   for i := Starti to Endi do
   begin
      A.X := GetPageX(aLine.Xi[i]);
      A.Y := GetPageY(aLine.Yi[i]);
      if aPart = i then
      begin
         aRect := TRectF.Create(A.X - 20,A.Y - 20,A.X + 20,A.Y +20);
         aCanvas.StrokeThickness := 4;
         aCanvas.DrawEllipse(aRect,0.6);
         aCanvas.StrokeThickness := 2;
         P1.X := A.X - 25;
         P1.Y := A.Y;
         P2.X := A.X + 25;
         P2.Y := A.Y;
         aCanvas.DrawLine(P1,P2,1);
         P1.X := A.X;
         P1.Y := A.Y - 25;
         P2.X := A.X;
//         if Endi = 0 then
//         begin
            P2.Y := A.Y + 70;
            aCanvas.DrawLine(P1,P2,1);
            aRect := TRectF.Create(A.X - 30,A.Y + 100 - 30,A.X + 30,A.Y +100 + 30);
            aCanvas.StrokeThickness := 3;
            aCanvas.DrawEllipse(aRect,0.6);
//         end
//         else
//         begin
//            P2.Y := A.Y + 25;
//            aCanvas.DrawLine(P1,P2,1);
//         end;
         aCanvas.StrokeThickness := 1;
      end
      else
      begin
         aRect := TRectF.Create(A.X - 15,A.Y - 15,A.X + 15,A.Y +15);
         aCanvas.DrawEllipse(aRect,0.6);
      end;
   end;
   finally
   aCanvas.EndScene;
   ImDrawing := false;
   Path := nil;
   end;
//   Application.ProcessMessages;
end;

procedure TMainForm.DrawLineEdit(aLine: TPolyElement; aPart: integer; aColor: integer; aBM: TBitmap);
var
   A,B: TPointF;
   i: integer;
   Path: TPathData;
   aCanvas: TCanvas;
   aRect: TRectF;
   Starti,Endi,M1,M2: integer;
   P1,P2: TPointF;
begin
   if ImDrawing then exit;
   if aLine.CoordsCount < 1 then exit;
   ImDrawing := true;
   Path := TPathData.Create;
   try
   Starti := 0;
   Endi := aLine.CoordsCount - 1;
   M1 := -1;
   M2 := -1;
   if aPart > -1 then
   begin
      M1 := aPart;
      M2 := aPart + 1;
   end;
   if aBM <> nil then
      aCanvas := aBM.Canvas
   else
      aCanvas := Image_Edit.Bitmap.Canvas;
   aCanvas.BeginScene;
   if aBM = nil then
      aCanvas.Clear(TAlphaColors.Null);
   aCanvas.Stroke.Color := aColor;//TAlphacolors.Red;
   aCanvas.Stroke.Join := TStrokeJoin.sjRound;
   aCanvas.Stroke.Dash := TStrokeDash.Solid;
   aCanvas.Stroke.Cap := TStrokeCap.scRound;
   aCanvas.Stroke.Kind := TBrushKind.Solid;
   aCanvas.StrokeThickness := 5;
   if aLine.CoordsCount > 1 then
   begin
      for i := Starti to Endi do
      begin
         if i = 0 then
         begin
            A.X := GetPageX(aLine.Xi[i]);
            A.Y := GetPageY(aLine.Yi[i]);
            Path.MoveTo(A);
         end
         else
         begin
            B.X := GetPageX(aLine.Xi[i]);
            B.Y := GetPageY(aLine.Yi[i]);
            if B.Distance(A) > 2 then
            begin
   //            Image.Bitmap.Canvas.DrawLine(A,B,1);
               if (i = M1) or (i = M2) then
                  Path.MoveTo(B)
               else
                  Path.LineTo(B);
               A.X := B.X;
               A.Y := B.Y;
            end;
         end;
      end;
      Path.MoveTo(A);
      aCanvas.DrawPath(Path,1);
   end;
   aCanvas.Stroke.Color := EditColors.PointColor;
//   aCanvas.Stroke.Color := TAlphacolors.White;
   aCanvas.StrokeThickness := 2;
   for i := Starti to Endi do
   begin
      if (i <> M1) and (i <> M2) then
      begin
         A.X := GetPageX(aLine.Xi[i]);
         A.Y := GetPageY(aLine.Yi[i]);
         aRect := TRectF.Create(A.X - 15,A.Y - 15,A.X + 15,A.Y +15);
         aCanvas.DrawEllipse(aRect,0.6);
      end;
   end;
//   aCanvas.Stroke.Color := TAlphacolors.Black;
//   aCanvas.StrokeThickness := 2;
//   for i := Starti to Endi do
//   begin
//      if (i <> M1) and (i <> M2) then
//      begin
//         A.X := GetPageX(aLine.Xi[i]);
//         A.Y := GetPageY(aLine.Yi[i]);
//         aRect := TRectF.Create(A.X - 15,A.Y - 15,A.X + 15,A.Y +15);
//         aCanvas.DrawEllipse(aRect,0.6);
//      end;
//   end;
   finally
   aCanvas.EndScene;
   ImDrawing := false;
   Path := nil;
   end;
//   Application.ProcessMessages;
end;

procedure TMainForm.DrawLines(aLay: TComplicatedGECollection; aColor: integer);
var
   i: integer;
   e: TElement;
   L: TPolyLineElement;
begin
   if aLay = nil then exit;
   for i := 0 to aLay.LastIndex do
   begin
      e := aLay.Elements[i];
      if not (e is TPolyLineElement) then continue;
      L := TPolyLineElement(E);
      if L.IsOverRegion(MinX,MinY,MaxX,MaxY) then
         DrawLine(L,-1, aColor);
   end;
end;

procedure TMainForm.DrawNotes(aLay: TComplicatedGECollection; aColor: integer);
var
   DestRect,SrcRect: TRectF;
   i: integer;
   T: TTextElement;
   XX,YY: single;
   P1,P2: TPointF;
begin
   if (aLay =  nil) or aLay.NoElements  then exit;
   Image.Bitmap.Canvas.BeginScene;
   for i := 0 to aLay.LastIndex do
   begin
      T := TTextElement(aLay.Elements[i]);
      if T.IsOverRegion(MinX,MinY,MaxX,MaxY) then
      begin
         XX := GetPageX(T.X);
         YY := GetPageY(T.Y);
         P1.X := XX - 20;
         P1.Y := YY;
         P2.X := XX + 20;
         P2.Y := YY;
         Image.Bitmap.Canvas.DrawLine(P1,P2,1);
         P1.X := XX;
         P1.Y := YY - 20;
         P2.X := XX;
         P2.Y := YY + 20;
         Image.Bitmap.Canvas.DrawLine(P1,P2,1);
         XX := XX - ((ImageBakule.Width{ * Image.Canvas.Scale}) /2);
         YY := YY - (ImageBakule.Height{ * Image.Canvas.Scale});
         SrcRect  := TRectF.Create(0,0,ImageBakule.Bitmap.Width,ImageBakule.Bitmap.Height);
         DestRect := TRectF.Create(XX,YY,XX+ImageBakule.Width,YY + ImageBakule.Height);
         Image.Bitmap.Canvas.DrawBitmap(ImageBakule.Bitmap,SrcRect,DestRect,1);
      end;
   end;
   Image.Bitmap.Canvas.EndScene;
end;

procedure TMainForm.DrawPoint(aPoint: Tgis_PointElement; edit: boolean; aBM: TBitmap);
var
   A,B: TPointF;
   i,ii: integer;
   Path: TPathData;
   aCanvas: TCanvas;
   aRect,aRect1: TRectF;
   P1,P2: TPointF;
   e: TElement;
   En: TEntity;
   L: TPolyLineElement;
begin
   if edit then
   begin
      if aBM <> nil then
         aCanvas := aBM.Canvas
      else
         aCanvas := Image_edit.Bitmap.Canvas;
   end
   else
      aCanvas := Image.Bitmap.Canvas;
   if PSYMB = nil then exit;
   e := PSYMB.FindElementName(aPoint.Symbol.ToString);
   if e = nil then exit;
   EN := TEntity(e);
   e := EN.FindElementName('G');
   if e = nil then exit;
   EN := TEntity(e);
   Path := TPathData.Create;
   for ii := 0 to EN.LastIndex do
   begin
      e := En.Elements[ii];
      if not (e is TPolyLineElement)  then exit;
      L := TPolyLineElement(e);
      for i := 0 to L.LastIndex do
      begin
         if i = 0 then
         begin
            A.X := GetPageX(aPoint.X + L.Xi[i]);
            A.Y := GetPageY(aPoint.Y + L.Yi[i]);
            Path.MoveTo(A);
         end
         else
         begin
            B.X := GetPageX(aPoint.X + L.Xi[i]);
            B.Y := GetPageY(aPoint.Y + L.Yi[i]);
            if B.Distance(A) > 2 then
            begin
   //            Image.Bitmap.Canvas.DrawLine(A,B,1);
               Path.LineTo(B);
               A.X := B.X;
               A.Y := B.Y;
            end;
         end;
      end;
   end;
   Path.MoveTo(A);

   try
   aCanvas.BeginScene;
   aCanvas.Stroke.Join := TStrokeJoin.sjRound;
   aCanvas.Stroke.Dash := TStrokeDash.Solid;
   aCanvas.Stroke.Cap := TStrokeCap.scRound;
   aCanvas.Stroke.Kind := TBrushKind.Solid;
   if edit then
   begin
      if aBM = nil then
         aCanvas.Clear(TAlphaColors.Null);
      //Manipulators;
      aRect.Create(GetPageX(aPoint.MinX)-10,GetPageY(aPoint.MaxY)-10,GetPageX(aPoint.MaxX)+10,GetPageY(aPoint.MinY)+10);
      aCanvas.Stroke.Color := EditColors.LineColor;
      aCanvas.StrokeThickness := 1;
      aCanvas.DrawRect(aRect,0,0,AllCorners,0.6);
      aCanvas.Stroke.Color := EditColors.PointColor;
      aRect1.Create(aRect.Left-10,aRect.Top-10,aRect.Left+10,aRect.Top+10);
      aCanvas.DrawRect(aRect1,0,0,AllCorners,0.6);
      aRect1.Create(aRect.Right-10,aRect.Top-10,aRect.Right+10,aRect.Top+10);
      aCanvas.DrawRect(aRect1,0,0,AllCorners,0.6);
      aRect1.Create(aRect.Right-10,aRect.Bottom-10,aRect.Right+10,aRect.Bottom+10);
      aCanvas.DrawRect(aRect1,0,0,AllCorners,0.6);
      aRect1.Create(aRect.Left-10,aRect.Bottom-10,aRect.Left+10,aRect.Bottom+10);
      aCanvas.DrawRect(aRect1,0,0,AllCorners,0.6);
   end;
   aCanvas.Stroke.Color := DejBarvicku(aPoint.Color); //TAlphacolors.Red;
   aCanvas.StrokeThickness := GetPageLength(1.75 ); //0.4/1000 * 5000;  // ha ha
   aCanvas.DrawPath(Path,1);
   finally
   aCanvas.EndScene;
   ImDrawing := false;
   Path := nil;
   end;
//   Application.ProcessMessages;
end;


procedure TMainForm.DrawPoints(aLay: TComplicatedGECollection; aColor: integer);
var
   i: integer;
   e: TElement;
   P: Tgis_PointElement;
begin
   if aLay = nil then exit;
   for i := 0 to aLay.LastIndex do
   begin
      e := aLay.Elements[i];
      if not (e is Tgis_PointElement) then continue;
      P := Tgis_PointElement(E);
      if (P.Status < 1) and P.IsOverRegion(MinX,MinY,MaxX,MaxY) then
         DrawPoint(P,false);
   end;
end;

procedure TMainForm.EditLineChangeSubTool(aIndex: integer);
var
   But: FMX.StdCtrls.TButton;
begin
   if aIndex = ActiveSubTool then exit;
   case aIndex of
//      0: But := b_AddLinePoint;
      1: But := b_SelectLinePoint;
//      2: But := b_MoveLinePoint;
      else
         But := nil;
   end;
//   b_AddLinePoint.TintColor := TAlphaColors.null;
   b_SelectLinePoint.TintColor := TAlphaColors.null;
//   b_MoveLinePoint.TintColor := TAlphaColors.null;
   if But <> nil then
      But.TintColor := TAlphaColors.Blueviolet;
   ActiveSubTool := aIndex;
   SelectLinePointLayout.Visible := aIndex = 1;
end;

procedure TMainForm.EditLineLayoutResize(Sender: TObject);
begin
//   if (EditLineLayout.Position.X + EditLineLayout.Size.Width) > Size.Width  then
//      EditLineLayout.Position.X := Width - EditLineLayout.Size.Width;
end;

procedure TMainForm.Edit_Clear;
begin
   Image_edit.Bitmap.Canvas.BeginScene;
   Image_edit.Bitmap.Canvas.Clear(TAlphaColors.Null);
   Image_edit.Bitmap.Canvas.EndScene;
   Image_edit_Detail.Bitmap.Canvas.BeginScene;
   Image_edit_Detail.Bitmap.Canvas.Clear(TAlphaColors.Null);
   Image_edit_Detail.Bitmap.Canvas.EndScene;
end;

procedure TMainForm.ed_DilChange(Sender: TObject);
var
   i: integer;
begin
   if ed_Dil.ItemIndex < 0 then exit;
   if LHC <> nil then
   begin
      LHC.Dilec_Name := ed_DIL.Items[ed_DIL.ItemIndex];
      ed_Por.Items.Clear;
      if (LHC.ActualDilec <> nil) and not LHC.ActualDilec.NoItems then
      begin
         for I := 0 to LHC.ActualDilec.Items.LastIndex do
         begin
             ed_Por.Items.Add(LHC.ActualDilec.Items.Elements[i].Name);
         end;
         ed_Por.ItemIndex := -1;
         ed_Por.ItemIndex := 0;
      end;
   end;
end;

procedure TMainForm.ed_oddChange(Sender: TObject);
var
   odd: integer;
   i: integer;
begin
   if ed_Odd.ItemIndex < 0 then exit;
   if LHC <> nil then
   begin
      LHC.Oddeleni_Cislo := StrToIntDef(ed_ODD.Items[ed_Odd.ItemIndex],0);
      ed_Dil.Items.Clear;
      if (LHC.ActualOddeleni <> nil) and not LHC.ActualOddeleni.NoItems then
      begin
         for I := 0 to LHC.ActualOddeleni.Items.LastIndex do
         begin
             ed_Dil.Items.Add(LHC.ActualOddeleni.Items.Elements[i].Name);
         end;
         ed_DIl.ItemIndex := -1;
         ed_DIl.ItemIndex := 0;
      end;
   end;
end;

procedure TMainForm.ed_porChange(Sender: TObject);
var
   i: integer;
begin
   if ed_POR.ItemIndex < 0 then exit;
   if LHC <> nil then
   begin
      LHC.Porost_Name := ed_Por.Items[ed_Por.ItemIndex];
      ed_PSK.Items.Clear;
      if (LHC.ActualPorost <> nil) and not LHC.ActualPorost.NoItems then
      begin
         for I := 0 to LHC.ActualPorost.Items.LastIndex do
         begin
             ed_PSK.Items.Add(LHC.ActualPorost.Items.Elements[i].Name);
         end;
         ed_PSK.ItemIndex := -1;
         ed_PSK.ItemIndex := 0;
      end;
   end;
end;

procedure TMainForm.ed_PSKChange(Sender: TObject);
var
   i: integer;
begin
   if ed_PSK.ItemIndex < 0 then exit;
   if LHC <> nil then
   begin
      LHC.Skupina_Name := ed_PSK.Items[ed_PSK.ItemIndex];
      if LHC.ActualLHC <> nil then  S_LHC := LHC.ActualLHC.Name;
      if LHC.ActualOddeleni <> nil then S_Oddeleni := LHC.ActualOddeleni.Name;
      if LHC.ActualDilec <> nil then S_Dilec := LHC.ActualDilec.Name;
      if LHC.ActualPorost <> nil then S_Porost := LHC.ActualPorost.Name;
      if LHC.ActualSkupina <> nil then S_Skupina := LHC.ActualSkupina.Name;
   end;
end;

function TMainForm.FindForestOnScreen(aPosition: TPointF; aBlink: boolean): Tgis_PorostniSkupina;
var
   _X,_Y: double;
   XX,YY: single;
   PSK: Tgis_PorostniSkupina;
begin
   result := nil;
   if (LHC <> nil) and (FMSelector <> nil) then
   begin
       _X := GetModelX(aPosition.X);
       _Y := GetModelY(aPosition.Y);
       XX := aPosition.X;
       YY := aPosition.Y;

       if not FMSelector.Busy then
       begin
          FMSelector.X := _X;
          FMSelector.Y := _Y;
          FMSelector.DoIt;
          if FMSelector.ActualFrame <> nil then
          begin
             PSK := Tgis_PorostniSkupina(FMSelector.ActualFrame);
             result := PSK;
             if aBlink  then
                BlinkArea(TAreaElement(PSK.Geometry));
             S_LHC := IntToStr(PSK.LHC);
             S_Oddeleni := IntToStr(PSK.Oddeleni);
             S_Dilec := PSK._Dilec.Name;
             S_Porost := PSK._Porost.Name;
             S_Skupina := PSK.Name;
             l_JPRL.Text := {S_LHC+' '+}S_Oddeleni+S_Dilec+S_Porost+' '+S_Skupina;
             l_JPRLs.Text := {S_LHC+' '+}S_Oddeleni+S_Dilec+S_Porost+' '+S_Skupina;
          end
          else
          begin
             l_jprl.Text := 'JPRL?';
             l_jprls.Text := 'JPRL?';
          end;
       end;
   end;
end;

function TMainForm.FindLayerExt(aLayer: string): string;
var
  i: integer;
  n,DE: IXMLNode;
  s: string;
begin
  Result := '';
  DE := XMLDocument.DocumentElement;
  for i := 0 to DE.ChildNodes.Count - 1 do
  begin
     N := DE.ChildNodes[i];
     s := N.ChildNodes['Layer'].Text;
     if s = aLayer then
     begin
        result := N.ChildNodes['Ext'].Text;
     end;
  end;
end;

function TMainForm.FindLayerPath(aLayer: string): string;
var
  i: integer;
  n,DE: IXMLNode;
  s: string;
begin
  Result := '';
  DE := XMLDocument.DocumentElement;
  for i := 0 to DE.ChildNodes.Count - 1 do
  begin
     N := DE.ChildNodes[i];
     s := N.ChildNodes['Layer'].Text;
     if s = aLayer then
     begin
        result := N.ChildNodes['File'].Text;
     end;
  end;
end;

function TMainForm.FindLayerValue(aLayer, aValue: string): string;
var
  i: integer;
  n,DE: IXMLNode;
  s: string;
begin
  Result := '';
  DE := XMLDocument.DocumentElement;
  for i := 0 to DE.ChildNodes.Count - 1 do
  begin
     N := DE.ChildNodes[i];
     s := N.ChildNodes['Layer'].Text;
     if s = aLayer then
     begin
        result := N.ChildNodes[aValue].Text;
     end;
  end;
end;

function TMainForm.FinishActiveTool: boolean;
begin
   result := true;
   case ActiveTool of
      at_Note:  // poznamky
      begin
         if dlg_General.Visible then
            dlg_CancelClick(nil);
         Application.ProcessMessages;
         if ActionPanel.Visible then
            b_ActionPanelCloseClick(nil);
      end;
      at_Meas: // mereni
      begin
         EditLineChangeSubTool(0);
         if EditLineLayout.Visible then
            EditLineLayout.Visible := false;
         if MLine.Count > 1  then
         begin
            ActualLayer.AddElement(MLine);
            Layers_Modified := true;
         end;
         if ActionPanel.Visible then
            b_ActionPanelCloseClick(nil);
         Edit_Clear;
      end;
      at_Line: // editace linie
      begin
         result := false;
         if MLine.Count > 1 then
         begin
            result := false;
            SaveLineDialog;
         end
         else
         begin
            EditLineChangeSubTool(0);
            if EditLineLayout.Visible then
               EditLineLayout.Visible := false;
            if ActionPanel.Visible then
               b_ActionPanelCloseClick(nil);
         end;
//         Edit_Clear;
      end;
      at_Point: // body
      begin
         if ActionPanel.Visible then
            b_ActionPanelCloseClick(nil);
         b_Point_Delete.Visible := false;
         Point_Edit_Layout.Visible := false;
         if ePoint <> nil then
         begin
             ePoint.Status := 0;
             DrawPoint(ePoint, false);
             Edit_Clear;
         end;
      end;
      at_Log: // trasovani
      begin
         if GPSTrack then
            ShowMessage('Nejdřív ukončete trasování GPS!')
         else
            p_gpslog.Visible := false;
      end;
   end;
end;

procedure TMainForm.FixTimerTimer(Sender: TObject);
begin
   if DoFindGPS then
   begin
      DoFindGps := false;
      b_gpsfindClick(nil);
      if GPSTrack then
         MainTool.PostMsg(tm_ReView,MainTool,ActualRoute,false);
   end;
end;

procedure TMainForm.FormActivate(Sender: TObject);
begin
   ImageBakule.Visible := false;
   Status := 0;
end;

procedure TMainForm.FormCreate(Sender: TObject);
var
   i: integer;
begin
//   {$IFNDEF HK}
//   b_HK.Visible := false;
//   {$ENDIF}
//   Routes_UseAlternative := true;
{$IFDEF TEST}
   TestPanel.Visible := true;
   TestMemo.Lines.Clear;
{$ENDIF}
   Pani := 0;
   pani1 := 0;
   EditColors.LineColor := TAlphaColors.Red;
   EditColors.PointColor := TAlphacolors.Deeppink;
   EditColors.DefaultColor := TAlphacolors.Deeppink;
   DataOnBackGround := true;
   Quality := TCanvasQuality.HighPerformance;
   FMX.Types.GlobalUseGPUCanvas := true;
   Status := 0;
   ImDrawing := false;
   Reviewing := false;
   Test := true;
   CHeckJPRL := true;
   CheckNotes := true;
   CheckLines := true;
   Tiles := TStringList.Create;
   Tiles.Sorted := true;
   ActualMap := 0;
   ActualTileMatrix := 0;
   MapChangeActive := false;
   Moving := false;
   bmMoving := true;
   bmInMove := false;
   Fix := false;
   GPSFixed := false;
   ToolsMoving := false;
   ToolsVisible := true;
   Rotate := false;
   AreaBlinked := false;
   iLastOdd := -1;
   BColor := TAlphaColors.Black;
   Image.Bitmap.Resize(Round(Image.Width{ * Image.Canvas.Scale}),Round(Image.Height{ * Image.Canvas.Scale}));
   Image.Bitmap.Canvas.BeginScene;
   Image.Bitmap.Canvas.Clear(BColor);
   Image.Bitmap.Canvas.EndScene;
   Bm := TBitmap.Create(Round(Image.Bitmap.Width),Round(Image.Bitmap.Height));
   Image_edit.Bitmap.Resize(Round(Image.Width{ * Image.Canvas.Scale}),Round(Image.Height{ * Image.Canvas.Scale}));
   Image_Edit.Visible := true;
   Image_Edit_Detail.Bitmap.Resize(Round(Image.Width{ * Image.Canvas.Scale}),Round(Image.Height{ * Image.Canvas.Scale}));
   Edit_Clear;
//   Image.Bitmap := TBitmap.Create(Round(Image.Width {* Image.Scene.GetSceneScale}),Round(Image.Height{ * Image.Scene.GetSceneScale}));
//   Image.Bitmap.BitmapScale := 1;
//   l_gps.Text := IntToStr(Round(Image.Width))+'x'+IntToStr(Round(Image.Height))+'('+IntToStr(Round(Width))+'x'+IntToStr(Round(Height))+') scale: '+IntToStr(Round(Image.Scene.GetSceneScale))+' c '+IntToStr(Round(Image.Canvas.Scale));
//   iScene.
   RefX := 0;
   RefY := 0;
   LastX := 0;
   LastY := 0;
//   aScale := 1;
   ActiveTool := at_Map;
   WaitingActiveTool := at_Null;
   SetLength(Reviews,20);
   for i  := 0 to Length(Reviews) - 1 do Reviews[i] := 0;

   LastReview := 0;
   aJTSK := false;
   MainTool := TMainTool.Create;
{$IFDEF MSWINDOWS}
   MainTool.CreateWorld(Self);
{$ELSE}
   MainTool.CreateWorld;
{$ENDIF}
   MainTool.On_Progress_Event := OnProgress ;
{$IFDEF HK}
   LHCSPath := _Path.Combine(_Path.GetHomePath,'LHCS.orb');
   LHC_Load;
   topBar.Visible := true;
   htopbar.Visible := false;
{$ELSE}
   topBar.Visible := false;
   htopbar.Visible := true;
   b_Settings.Visible := false;
   ListBoxItem6.Visible := false;

//   LHCListpanel.Visible := false;
{$ENDIF}
{$IFDEF TESTGUI}
   topBar.Visible := false;
   htopBar.Visible := false;
   botbar.Visible := false;
   cb_topbar.Visible := false;
   cb_botbar.Visible := false;
{$ENDIF}
   ZnPSYMB_Load;  // definice druhu a bodove znacky
   // Preparing Colors for points
   Colors_Prepare;
   LoadParams;
   Application.ProcessMessages;
end;

procedure TMainForm.FormGesture(Sender: TObject; const EventInfo: TGestureEventInfo; var Handled: Boolean);
var
   DestRect,SrcRect: TRectF;
   _X,_Y: double;
   i: integer;
   dX,dY,XX,YY: single;
   S: string;
   A,B: TPointF;
   PSK: Tgis_PorostniSkupina;
   T: TTextElement;
   P1,P2: TPointF;
   C: T2DCoordinate;
   mX,mY,mY1,Dist,Dist1,MinDist: double;

   procedure fixstop;
   begin
      if Fix then
      begin
         FixTimer.Enabled := false;
         Fix := false;
         {$IFDEF HK}
         Switch1.IsChecked := false;
         {$ELSE}
         Switch2.IsChecked := false;
         {$ENDIF}
         DoFindGPS := false;
         b_Gpss.ImageIndex := 2;
      end;
   end;
begin
   Handled := true;
   if Reviewing then exit;
//   if ActiveTool > 0 then exit;

   GPath.Visible := false;
   if EventInfo.GestureID = igiZoom then
   begin
      Handled := true;
      if (TInteractiveGestureFlag.gfBegin in EventInfo.Flags)then
      begin
           fixstop;
           p_Note.Visible := false;

           StopReviews;
//           if Test then Memo1.Lines.Add('G Z B');
//         exit;
//         if not BmPrepared then
//         begin
//            Bm := TBitmap.Create(Round(Image.Bitmap.Width),Round(Image.Bitmap.Height));
            if BmInMove then
            begin
//              if Test then Memo1.Lines.Add('BMIM');
               bmInMove := false;
               RefX := RefX + aX;
               RefY := RefY + aY;
               _X := GetModelLength(aX);
               _Y := GetModelLength(aY);
               CHangeProjection(CenterX - _X,CenterY + _Y, RealScale);
               //G.Dispose;
               LastX := 0;
               LastY := 0;
//               Review(false);
               PreparingMove := false;
            end;

//            bmMoving := true;
//            Bm.CopyFromBitmap(Image.Bitmap);
            X1 := MinX;
            Y1 := MaxY;
            X2 := MaxX;
            Y2 := MinY;
            Scale1 := RealScale;
            LastDist := EventInfo.Distance;
//            BMPrepared := true;
//         end;
//            Bm.CopyFromBitmap(Image.Bitmap);
      end
      else
      if (TInteractiveGestureFlag.gfEnd in EventInfo.Flags) then
      begin
//         if Test then Memo1.Lines.Add('G Z E');
//         exit;
//         BM.DisposeOf;
         //G := Graphics.FromImage(PictureBox1.Image);
  //       ChangeProjection(CenterX,CenterY,SrcScale * 1.5);
//         BmPrepared := false;
         if ActiveTool in [at_Meas,at_Line] then
         begin
            DrawLineEdit(MLine,MLineActivePoint, EditColors.LineColor,nil);
            DrawLineDetail(MLine,MLineActivePoint, EditColors.LineColor,nil);
         end
         else
         if ActiveTool = at_Point then
         begin
            if ePoint <> nil then
               Drawpoint(ePoint,true);
         end;
         Review(false);
         ShowScaleAndCoords;
      end
      else
      begin
//         if Test then Memo1.Lines.Add('G Z *****');
//         exit;
//         if not  BmPrepared then
//            exit;
         dX := EventInfo.Location.X - (Image.Width / 2);
         dY := EventInfo.Location.Y - (Image.Height / 2);
         _X := GetModelX(EventInfo.Location.X);
         _Y := GetModelY(EventInfo.Location.Y);
         ChangeProjection(CenterX,CenterY,Scale1 / (EventInfo.Distance / LastDist));
         _X := _X - GetModelLength(dX);
         _Y := _Y + GetModelLength(dY);
         ChangeProjection(_X,_Y,RealScale);
         SrcRect  := TRectF.Create(0,0,Bm.Width,Bm.Height);
         DestRect := TRectF.Create(GetPageX(X1),GetPageY(Y1),GetPageX(X2),GetPageY(Y2));
         Image.Bitmap.Canvas.BeginScene;
         Image.Bitmap.Canvas.Clear(BColor);
         Image.Bitmap.Canvas.DrawBitmap(Bm,SrcRect,DestRect,1);

         A.X := EventInfo.Location.X - 10;
         B.X := EventInfo.Location.X + 10;
         A.Y := Eventinfo.Location.Y;
         B.Y := Eventinfo.Location.Y;
         Image.Bitmap.Canvas.DrawLine(A,B,1);
         A.X := EventInfo.Location.X;
         B.X := EventInfo.Location.X;
         A.Y := Eventinfo.Location.Y - 10;
         B.Y := Eventinfo.Location.Y + 10;
         Image.Bitmap.Canvas.DrawLine(A,B,1);

         Image.Bitmap.Canvas.EndScene;
         DrawGPS;
         if ActiveTool in [at_Meas,at_Line] then
         begin
            DrawLineEdit(MLine,MLineActivePoint, EditColors.LineColor,nil);
            DrawLineDetail(MLine,MLineActivePoint, EditColors.LineColor,nil);
         end
         else
         if ActiveTool = at_Point then
         begin
            if ePoint <> nil then
               Drawpoint(ePoint,true);
         end;
         TThread.Queue(nil,ShowScaleAndCoords);
//         Application.ProcessMessages;
      end;
//      LastDist := EventInfo.Distance;
   end
   else
   if EventInfo.GestureID = igiPan then
   begin
//      exit;
      Handled := true;
      if (TInteractiveGestureFlag.gfBegin in EventInfo.Flags)then
      begin
         if Pani > 0 then exit;
         {$IFDEF TEST}
//         TestMemo.Lines.Add('Pan begin ');
         {$ENDIF}
         Handled := true;
         PanStatus := ps_PanInit;
         Inc(Pani);
         Inc(Pani1);
         fixstop;
//         Memo1.Lines.Add('G P B');
//         exit;
//         p_Note.Visible := false;
         StopReviews;
         LastX := EventInfo.Location.X;
         LastY := EventInfo.Location.Y;
         LastLocalX := EventInfo.Location.X;
         LastLocalY := EventInfo.Location.Y;
         if ActiveTool in [at_Meas,at_Line] then
         begin
            // Try to find Active point
            // Joystick or Point location
            MX := GetModelX(LastX);
            MY := GetModelY(LastY - 100);
            MY1 := GetModelY(LastY);
            MinDist := GetModelLength(50);
//            LastDist := 1E20;
            _X := MLine.Xi[MLineActivePoint];
            _Y := MLine.Yi[MLineActivePoint];
            Dist  := Distance(MX,MY,_X,_Y);
            Dist1 := Distance(MX,MY1,_X,_Y);
            if (Dist < MinDist) or (Dist1 < MinDist)then
            begin
              {$IFDEF TEST}
//              TestMemo.Lines.Add('Pan Line ');
              {$ENDIF}
               RefX := GetPageX(MLine.Xi[MLineActivePoint]);
               RefY := GetPageY(MLine.Yi[MLineActivePoint]);
               RefX := RefX - LastX;
               RefY := RefY - LastY;
//               Application.ProcessMessages;
               PanStatus := ps_LinPointMove;
               exit;
            end;
//            else
//            // try to find another point for active moving  ... next time
//            begin
//
//            end;
            // asi se bude posunovat kresba s mapou
           {$IFDEF TEST}
//           TestMemo.Lines.Add('Pan Pan ');
           {$ENDIF}
            Edit_Clear;
            DrawLineEdit(MLine,MLineActivePoint, EditColors.LineColor,BM);
            DrawLineDetail(MLine,MLineActivePoint, EditColors.LineColor,BM);
            PanStatus := ps_Pan;
         end
         else
         if ActiveTool = at_Point then
         begin
            MX := GetModelX(LastX);
            MY := GetModelY(LastY);
            if ePoint <> nil then
            begin
               if EPoint.PointIsInside(MX,MY) then
               begin
                  RefX := GetPageX(ePoint.X);
                  RefY := GetPageY(ePoint.Y);
                  RefX := RefX - LastX;
                  RefY := RefY - LastY;
                  DrawPoint(ePoint,true,Image_Edit_Detail.Bitmap);
                  PanStatus := ps_Point;
                  exit;
               end;
               Edit_Clear;
               DrawPoint(ePoint,true,bm);
            end;
         end;
         PanStatus := ps_Pan;

//            Application.ProcessMessages;
      end
      else
      if (TInteractiveGestureFlag.gfEnd in EventInfo.Flags) then
      begin
         if Pani1 = 0 then exit;
              {$IFDEF TEST}
//              TestMemo.Lines.Add('Pan End ');
              {$ENDIF}

//         Memo1.Lines.Add('G P E');
//         exit;
//         Bm.DisposeOf;
//         BmPrepared := false;
         Handled := true;
//         l_JPRL.Text := IntToStr(Pani)+'/'+IntToStr(Pani1)+'/'+IntToStr(PanStatus);
         Pani := 0;
         Pani1 := 0;
         if PanStatus = ps_Pan then
         begin
            RefX := RefX + aX;
            RefY := RefY + aY;
            _X := GetModelLength(aX);
            _Y := GetModelLength(aY);
            CHangeProjection(CenterX - _X,CenterY + _Y, RealScale);
            //G.Dispose;
            LastX := 0;
            LastY := 0;
            if ActiveTool in [at_Meas,at_Line] then
            begin
               DrawLineEdit(MLine,MLineActivePoint, EditColors.LineColor,nil);
               DrawLineDetail(MLine,MLineActivePoint, EditColors.LineColor,nil);
            end
            else
            if ActiveTool = at_Point then
            begin
               if ePoint <> nil then
                  DrawPoint(ePoint, true);
            end;
            Review(false);
            ShowScaleAndCoords;
         end
         else
         if PanStatus = ps_Point then
         begin
            if ePoint <> nil then
            begin
               Edit_Clear;
               DrawPoint(ePoint, true);
               Layers_Modified := true;
            end;
         end;
         PanStatus := ps_Pan;
//         bmMoving := false;
//         PreparingMove := false;
      end
      else
      begin
         Handled := true;
         if Pani = 0 then exit;
         if PanStatus = ps_PanInit then exit;

//         Inc(Pani1);
//         exit;
         S := '0';
//         if BmMoving then exit;
//         BmMoving := true;
         i := ActiveTool;//c_Action.SelectedIndex;

//         case i of
//            at_Map,at_Note:
            try
//            if PreparingMove then exit;
//           l_JPRL.Text := '*'+IntToStr(PanStatus)+'*';

            if (LastLocalX = EventInfo.Location.X) and (LastLocalY = EventInfo.Location.Y)  then exit;
            if PanStatus = ps_LinPointMove then
            begin
               {$IFDEF TEST}
//               TestMemo.Lines.Add('Pan Move lin ');
               {$ENDIF}
               LastLocalX := EventInfo.Location.X;
               LastLocalY := EventInfo.Location.Y;

               if (MLine = nil) or MLine.NoElements then exit;
            //   DrawLine(MLine,true,MLine.LastIndex,true);
               C := MLine.GetOrientedCoordElement(MLineActivePoint,true);

               C.X := GetModelX(LastLocalX + RefX);
               C.Y := GetModelY(LastLocalY + RefY);
               DrawLineDetail(MLine,MLineActivePoint, EditColors.LineColor,nil);
               l_Text.Text := 'Délka: '+FormatFloat('0.###',MLine.Length)+ ' m      Plocha:'+FormatFloat('0.##',abs(MLine.Area)/10000)+' ha';
//               Application.ProcessMessages;
               exit;
            end
            else
            if PanStatus = ps_Point then
            begin
               LastLocalX := EventInfo.Location.X;
               LastLocalY := EventInfo.Location.Y;
               ePoint.X := GetModelX(LastLocalX + RefX);
               ePoint.Y := GetModelY(LastLocalY + RefY);
               Image_Edit.Bitmap.Canvas.BeginScene;
               Image_Edit.Bitmap.Canvas.Clear(TAlphaColors.Null);
               aX := EventInfo.Location.X - LastX;
               aY := EventInfo.Location.Y - LastY;
               SrcRect.Create(0,0,Bm.Width,Bm.Height);
               DestRect.Create(aX,aY,aX + (Bm.Width{ / Image.Canvas.Scale}),aY + (Bm.Height{ / Image.Canvas.Scale}));
               Image_Edit.Bitmap.Canvas.DrawBitmap(Image_Edit_Detail.Bitmap,SrcRect,DestRect,100);
               Image_Edit.Bitmap.Canvas.EndScene;
            end
            else
            begin
               {$IFDEF TEST}
//               TestMemo.Lines.Add('Pan Move pan ');
               {$ENDIF}
         //      Memo1.Lines.Add('Move');
               if p_Note.Visible then
               begin
                  p_Note.Position.X := p_Note.Position.X + EventInfo.Location.X - LastLocalX;
                  p_Note.Position.y := p_Note.Position.Y + EventInfo.Location.Y - LastLocalY;
               end;
               if ImageBakule.Visible then
               begin
                  ImageBakule.Position.X := ImageBakule.Position.X + EventInfo.Location.X - LastLocalX;
                  ImageBakule.Position.y := ImageBakule.Position.Y + EventInfo.Location.Y - LastLocalY;
               end;
               if gpsCursor.Visible then
               begin
                  gpsCursor.Position.X := gpsCursor.Position.X + EventInfo.Location.X - LastLocalX;
                  gpsCursor.Position.y := gpsCursor.Position.Y + EventInfo.Location.Y - LastLocalY;
               end;
               LastLocalX := EventInfo.Location.X;
               LastLocalY := EventInfo.Location.Y;
               _X := GetModelX(EventInfo.Location.x);
               _Y := GetModelY(EventInfo.Location.Y);
         //      S := '0.##';
         //      l_Coords.Text := 'x:'+FormatFloat(S,_X)+' y:'+FormatFloat(S,_Y);

               //l_xy.Text := e.x.ToString + ',' + e.Y.ToString;
               //G.Clear(0);
               //G.Clear(Color.WhiteSmoke);
               Image.Bitmap.Canvas.BeginScene;
               Image.Bitmap.Canvas.Clear(BColor);
               aX := EventInfo.Location.X - LastX;
               aY := EventInfo.Location.Y - LastY;
         //      Image.Bitmap.Canvas.DrawLine(TPointF.Create(LastLocalX,LastLocalY),TPointF.Create(X,Y),100);
         //      LastLocalX := X;
         //      LastLocalY := Y;
               SrcRect.Create(0,0,Bm.Width,Bm.Height);
               DestRect.Create(aX,aY,aX + (Bm.Width{ / Image.Canvas.Scale}),aY + (Bm.Height{ / Image.Canvas.Scale}));
               Image.Bitmap.Canvas.DrawBitmap(Bm,SrcRect,DestRect,100);
               Image.Bitmap.Canvas.EndScene;
//               Application.ProcessMessages;
            end;
            finally

            end;
//         end;
//         BmMoving := false;
      end;
//      LastDist := EventInfo.Distance;
   end;
end;

procedure TMainForm.FormKeyUp(Sender: TObject; var Key: Word; var KeyChar: Char;
  Shift: TShiftState);
begin
   if Key = vkHardwareBack then
   begin
      // handle it
      {$IFDEF HK}
      Key := 0;
      {$ENDIF}
   end;
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
//   Edit1.Text := 'PaintBox '+ IntToStr(Round(PaintBox.Width))+'x'+IntToStr(Round(PaintBox.Height));
   if (b_Settings.Position.X + b_Settings.Width) > botbar.width then
   begin
      b_Settings.Position.X := botbar.Width - b_Settings.Width -20;
   end;
{$IFDEF HK}
   Timer1.Enabled := true;
//   MainTool.PostMsg(tm_Show,MainTool,nil,false);
{$ENDIF}
end;

function TMainForm.GetAbsolutePath(aRootPath, aRelativePath: string): string;
begin
   if aRootPath = '' then
      aRootPath := GetExecutablePath;
   result :=  _Path.Combine(aRootPath, aRelativePath);
end;

function TMainForm.GetExecutablePath: String;
begin
   result := Paramstr(0);
end;

function TMainForm.GetModelLength(aPageLength: single): System.Double;
begin
  Result:= aPageLength * MultX;
end;

function TMainForm.GetModelX(aPageX: single): System.Double;
begin
   Result:= MultX*aPageX + AddX ;
end;

function TMainForm.GetModelY(aPageY: single): System.Double;
begin
   Result:=  AddY-(MultY*aPageY);
end;

function TMainForm.GetPageLength(aModelLength: double): single;
begin
  result:= 0;
  if MultX = 0 then exit;
  try
    Result:= round(aModelLength / MultX);
{    Result:= round(ModelLength / UniMult); }
  except
  end
end;

function TMainForm.GetPageX(aModelX: double): single;
begin
  result:= 0;
  if MultX = 0 then exit;
  try
   Result:= (aModelX - AddX)/MultX;
  except
  end
end;

function TMainForm.GetPageY(aModelY: double): single;
begin
  result:= 0;
  if MultY = 0 then exit;
  try
   Result:= (AddY-aModelY)/MultY;
  except
  end
end;

function TMainForm.GetProc: TOwnerEntity;
begin
   if FProc = nil then
   begin
      FProc := TOwnerEntity.Create;
      FProc.Name := 'Processes';
   end;
   result := FProc;
end;

procedure TMainForm.b_NewLineClick(Sender: TObject);
begin
   case ActiveTool of
      at_Meas:
      begin
         if (MLine <> nil) and (MLine.Count > 1)  then
            ActualLayer.AddElement(MLine);
         b_editClick(nil);
      end;
      at_Line: SaveLineDialog;
   end;

end;

procedure TMainForm.b_NoteClick(Sender: TObject);
begin
   ActiveTool := at_Note;
//   b_Note_Glow.Enabled := true;
   ActionPanel.Visible := true;
   l_Caption.Text := 'Režim vkládání/výběru poznámky';
   l_Text.Text := 'Klepnutím vložte nebo vyberte poznámku v mapě...'
end;

procedure TMainForm.ImageMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Single);
var
   S: string;
   i, ii: integer;
//   aShape: GpsShapeNET.Shape;
//   aDataRecord: GpsShapeNET.DataRecord;
//   aDataField:  GpsShapeNET.DataField;
   _X,_Y: double;
   JPRLChecked: boolean;
   JPRLResult: boolean;
   PSK: Tgis_PorostniSkupina;

begin
   i := ActiveTool;//c_Action.SelectedIndex;
   if i < at_Map then i := at_Map;
   if i = at_Map then exit; // gesta

   case i of
      at_Note: //poznamka
      begin
//         if CheckJPRL and Assigned(FOnSelectJPRL) then
//            //FOnSelectJPRL(aOddeleni,aDilec,aPorost,aPSK);
//            FOnSelectJPRL(Self, nil);
         ShowMessage('Note');
         ActiveTool := 0;
//         b_Note_Glow.Enabled := false;
      end;
      at_Meas: // editace linie
      begin
         Route_StartNew;
//         l_gps.Text := 'start';
         bmMoving := false;
//         ii := ActiveSubTool;
//         case ii of
//            0:
//            begin
////               objShape.NewNode(-1);
////               objShape.Position := objPosition;
//            end;
//            1:
//            begin
//
//            end;
//            2:
//            begin
//
//            end;
//         end;

//         map1.Update();
      end;
   end;
   // Center on mouse click

   //firstPos = null;
end;

procedure TMainForm.ImageMouseMove(Sender: TObject; Shift: TShiftState; X,Y: Single);
var
   dX,sY: integer;
   _X,_Y: double;
   S: string;
   i: integer;
   SrcRect,DestRect: TRectF;
begin
//   if Test then Memo1.Lines.Add('M M');
//   exit;
//   if not BmPrepared then  exit;

   if BmMoving then exit;
   BmMoving := true;
   i := ActiveTool;//c_Action.SelectedIndex;
   case i of
      at_Map:
      begin
      try
//      if PreparingMove then exit;
//      Memo1.Lines.Add('M M');

      if (LastLocalX = x) and (LastLocalY = Y)  then
      begin
         BmMoving := false;
         exit;
      end;
//      Memo1.Lines.Add('...Move');
      LastLocalX := X;
      LastLocalY := Y;
      _X := GetModelX(x);
      _Y := GetModelY(Y);
//      S := '0.##';
//      l_Coords.Text := 'x:'+FormatFloat(S,_X)+' y:'+FormatFloat(S,_Y);

      //l_xy.Text := e.x.ToString + ',' + e.Y.ToString;
      //G.Clear(0);
      //G.Clear(Color.WhiteSmoke);
      Image.Bitmap.Canvas.BeginScene;
      Image.Bitmap.Canvas.Clear(BColor);
      aX := X - LastX;
      aY := Y - LastY;
//      Image.Bitmap.Canvas.DrawLine(TPointF.Create(LastLocalX,LastLocalY),TPointF.Create(X,Y),100);
//      LastLocalX := X;
//      LastLocalY := Y;
      SrcRect.Create(0,0,Bm.Width,Bm.Height);
      DestRect.Create(aX,aY,aX + (Bm.Width / Image.Canvas.Scale),aY + (Bm.Height / Image.Canvas.Scale));
      Image.Bitmap.Canvas.DrawBitmap(Bm,SrcRect,DestRect,1);
      Image.Bitmap.Canvas.EndScene;
      bmInMove := true;
      finally

      end;
      end;
      at_Meas:
      begin
         if (LastLocalX = x) and (LastLocalY = Y)  then
         begin
            BmMoving := false;
            exit;
         end;
   //      Memo1.Lines.Add('...Move');
         LastLocalX := X;
         LastLocalY := Y;
         _X := GetModelX(x);
         _Y := GetModelY(Y);
         Route_StoreCoords(_X,_Y,true);
         jtskX := _X;
         jtskY := _Y;
//         GpsFixed := true;
//         Drawgps;
         Application.ProcessMessages;
      end;
   end;
   BmMoving := false;
end;

procedure TMainForm.ImageMouseUp(Sender: TObject; Button: TMouseButton;  Shift: TShiftState; X, Y: Single);
var
   _X,_Y: double;
begin
//   if Test then Memo1.Lines.Add('M U');
//   exit;
   bmInMove := false;
   case ActiveTool of
      at_Map:
      begin
        if Reviewing then exit;

      //   Memo1.Lines.Add( 'Up') ;
      //   Bm.DisposeOf;
      //   BmPrepared := false;
         RefX := RefX + aX;
         RefY := RefY + aY;
         _X := GetModelLength(aX);
         _Y := GetModelLength(aY);
         CHangeProjection(CenterX - _X,CenterY + _Y, RealScale);
         //G.Dispose;
         LastX := 0;
         LastY := 0;
         Review(false);
      end;
      at_Meas:
      begin
        Route_End;
//        l_gps.Text := 'END ...' ;
        gpsCursor.Visible := false;
      end;
   end;
   bmMoving := true;
   PreparingMove := false;
end;

procedure TMainForm.ImageResize(Sender: TObject);
begin
   {$IFDEF TEST}
      TestMemo.Lines.Clear;
      TestMemo.Lines.Add(FormatFloat('0',Image.Width)+' x '+FormatFloat('0',Image.Height));
      TestMemo.Lines.Add(FormatFloat('0',Width)+' x '+FormatFloat('0',Height));
   {$ENDIF}
//   ShowMessage('resize');
//   Image.Bitmap.Canvas.BeginScene;

//   Image.Bitmap.Canvas.Clear(BColor);
//   Image.Bitmap.Canvas.EndScene;

   Image.Bitmap.Resize(Round(Image.Width{ * Image.Canvas.Scale}),Round(Image.Height{ * Image.Canvas.Scale}));
   Image_Edit.Bitmap.Resize(Round(Image.Width{ * Image.Canvas.Scale}),Round(Image.Height{ * Image.Canvas.Scale}));
   Image_Edit_Detail.Bitmap.Resize(Round(Image.Width{ * Image.Canvas.Scale}),Round(Image.Height{ * Image.Canvas.Scale}));
   Bm := TBitmap.Create(Round(Image.Bitmap.Width),Round(Image.Bitmap.Height));
//   Image.Bitmap.Width := Round(Image.Width);
//   Image.Bitmap.Height := Round(Image.Height);
   Image.Bitmap.Canvas.BeginScene;
   Image.Bitmap.Canvas.Clear(BColor);
   Image.Bitmap.Canvas.EndScene;
   Image_Edit_Detail.Bitmap.Resize(Round(Image.Width{ * Image.Canvas.Scale}),Round(Image.Height{ * Image.Canvas.Scale}));
   Edit_Clear;
   CHangeProjection(CenterX,CenterY,RealScale);
   Review(false);
   if ActiveTool in  [at_Meas,at_Line] then
   begin
      DrawLineEdit(MLine,MLineActivePoint, EditColors.LineColor,nil);
      DrawLineDetail(MLine,MLineActivePoint, EditColors.LineColor,nil);
   end;
//   Edit1.Text := 'resize '+IntToStr(Round(Image.Width))+'x'+IntToStr(Round(Image.Height));
end;

procedure TMainForm.ImageTap(Sender: TObject; const Point: TPointF);
var
   A,B: TPointF;
   T: TTextElement;
   PSK: Tgis_PorostniSkupina;
   i, ii: integer;
   S: string;
   dX,dY,XX,YY: single;
   cec, cec1: TComplicatedGECollection;
   dist: double;
   LL: TPolyLineElement;
   PP, SelP: Tgis_PointElement;
   aXX,aYY: double;
   Mli: integer;
   mX,mY,LastDist,MinDist: double;
   e: TElement;
begin
   Pani := 0;
//   if Pani > 0 then exit;     // pan in action

   if AreaBlinked then
      Image.Bitmap.CopyFromBitmap(BM);
   case ActiveTool of
      at_Line,at_Meas:
      begin
         // add point
         if MLine = nil then
            MLine := TPolyLineElement.Create;
         // No points
         if MLine.Count = 0 then
         begin
            RefX := 0;
            RefY := -100;
            MLine.AddXY(GetModelX(Point.X),GetModelY(Point.Y{-100}));
            MLine.Update;
            MLineActivePoint := 0;
            DrawLineEdit(MLine,MLineActivePoint, EditColors.LineColor,nil);
            DrawLineDetail(MLine,MLineActivePoint, EditColors.LineColor,nil);
         end
         else
         // try to select point
         begin
            MX := GetModelX(Point.X);
            MY := GetModelY(Point.Y);
            MinDist := GetModelLength(50);
            LastDist := 1E20;
            Mli := -1;
            for I := 0 to MLine.LastIndex do
            begin
               Dist := Distance(MX,MY,MLine.Xi[i],MLine.Yi[i]);
               if (Dist < MinDist) and (Dist < LastDist) then
               begin
                  Mli := i;
                  LastDist := Dist;
               end;
            end;
            if (Mli > -1) and (MLineActivePoint <> Mli) then
            begin
               MLineActivePoint := Mli;
               DrawLineEdit(MLine,MLineActivePoint, EditColors.LineColor,nil);
               DrawLineDetail(MLine,MLineActivePoint, EditColors.LineColor,nil);
            end;
            if Mli = -1 then
            begin
               // add point
               if MlineActivePoint = 0 then
               begin
                  MLine.InsertXY(0,MX,MY);
                  MLine.Update;
                  MLineActivePoint := 0;
               end
               else
               begin
                  MLine.AddXY(MX,MY);
                  MLine.Update;
                  MLineActivePoint := MLine.LastIndex;
               end;
               DrawLineEdit(MLine,MLineActivePoint,EditColors.LineColor,nil);
               DrawLineDetail(MLine,MLineActivePoint, EditColors.LineColor,nil);
               l_Text.Text := 'Délka: '+FormatFloat('0.###',MLine.Length)+ ' m      Plocha:'+FormatFloat('0.##',Abs(MLine.Area)/10000)+' ha';
               BMMoving := false;
               Application.ProcessMessages;
            end;
         end;
      end;
      at_Note:
      begin
         if Status > 0 then exit;
         // hledani poznamky
         if ActualLayer = nil then
            ActualLayer := Layers_Layer('User','N');
         Notes := ActualLayer;
         for i := 0 to Notes.LastIndex do
         begin
            T := TTextElement(Notes.Elements[i]);
            A.X := GetPageX(T.X);
            A.Y := GetPageY(T.Y);
            if A.Distance(Point)  < 30 then
            begin
               p_Note.Visible := true;
               p_note_Layer.Text := ActualLayer.Text;
               p_note_Caption.Text := T.Name;
               p_Note_Text.Text := T.Text;
               p_Note.Position.X := A.X - p_Note.Width/2;
               p_Note.Position.Y := A.Y + 5;
               exit;
            end;
         end;
         p_Note.Visible := false;
         Status := 1;
         PSK := FindForestOnScreen(Point,false);
         if PSK <> nil then
            S := (S_Oddeleni + S_Dilec + S_Porost + ' ' + S_Skupina)
         else
            S := 'Mimo les';
         XX := Point.X;
         YY := Point.Y;
         ImageBakule.Visible := true;
         ImageBakule.Position.X := Point.X - ((ImageBakule.Width * Image.Canvas.Scale) /2);
         ImageBakule.Position.Y := Point.Y - (ImageBakule.Height * Image.Canvas.Scale);
         Application.ProcessMessages;
         ActualNote := TTextElement.Create;
         ActualNote.X := GetModelX(Point.X);
         ACtualNote.Y := GetModelY(Point.Y);
         ActualNote.Name := S;
         dlg_Edit.Text := 'Poznámka ';
         dlg_Text.Text := 'Uložit poznámku pro '+S+':';
         dlg_General.Visible := true;
         dlg_Edit.SelectAll;
   //         ShowMessage('Note');
   //         ActiveTool := 0;
   //         b_Note_Glow.Enabled := false;
      end;
      at_Point:
      begin
         aXX := GetModelX(Point.X);
         aYY := GetModelY(Point.Y);
         SelP := nil;
         // Try to select any point first
         for i := 0 to ActualLayer.LastIndex do
         begin
            e := ActualLayer.Elements[i];
            if not (e is TGis_PointElement) then continue;
            PP := Tgis_PointElement(e);
            if PP.PointIsInside(aXX, aYY) then
            begin
               SelP := PP;
               Break;
            end;
         end;
         if ePoint <> nil then
         begin
            ePoint.Status := 0;
            DrawPoint(ePoint,false);
         end;
         if SelP <> nil  then
         begin
            ePoint := SelP;
            ePoint.Status := 0;
            Barva := ePoint.Color;
            PointColorButton.Color := DejBarvicku(ePoint.Color);
            Zn.B.FindDruhKod := ePoint.Group;
            Point_Edit_ComboBox.ItemIndex := Zn.B.IndexOf(Zn.B.ActualDruh);
            ePoint.Status := 1;
            DrawPoint(ePoint,true);
            Review(false);
            b_Point_Delete.Visible := true;
         end
         else
         begin
         // Newpoint
            ePoint := Tgis_PointElement.Create;
            ePoint.Status := 1;
            ePoint.Color := Barva;
            ePoint.Group := Zn.B.ActualDruh.KOD;  //1021;//1078;//3002;
            ePoint.Symbol := Zn.B.ActualDruh.Znacka;  //1021;//1078;//3002;
            ePoint.X := GetModelX(Point.X);
            ePoint.Y := GetModelY(Point.Y{-100});
            Point_UpdateBySymbol(ePoint);
            ActualLayer.AddAndUpdateRect(ePoint);
            Layers_Modified := true;
//            ActualLayer.AddElement(ePoint);
            DrawPoint(ePoint,true);
            b_Point_Delete.Visible := true;
            BMMoving := false;
         end;
      end
      else
      begin
         aXX := GetModelX(Point.X);
         aYY := GetModelY(Point.Y);
         dist := GetModelLength(20);
         if CheckNotes or CheckLines then
         begin
            for I := 0 to Layers.LastIndex do
            begin
               cec := TComplicatedGECollection(Layers.Elements[i]);
               if cec.Visible then
               begin
                  if CheckNotes and Layers_LayerExists(cec.Name,'N') then
                  begin
                     cec1 := Layers_Layer(cec.Name,'N');
                     for ii := 0 to cec1.LastIndex do
                     begin
                        T := TTextElement(cec1.Elements[ii]);
                        A.X := GetPageX(T.X);
                        A.Y := GetPageY(T.Y);
                        if A.Distance(Point)  < 30 then
                        begin
                           p_Note.Visible := true;
                           p_note_Layer.Text := cec.Text;
                           p_note_Caption.Text := T.Name;
                           p_Note_Text.Text := T.Text;
                           p_Note.Position.X := A.X - p_Note.Width/2;
                           p_Note.Position.Y := A.Y + 5;
                           exit;
                        end;
                     end;
                  end;
                  if CheckLines and Layers_LayerExists(cec.Name,'L') then
                  begin
                     cec1 := Layers_Layer(cec.Name,'L');
                     for ii := 0 to cec1.LastIndex do
                     begin
                        LL := TPolyLineElement(cec1.Elements[ii]);
                        if LL.IsHitByXY(aXX, aYY, dist) then
                        begin
                           p_Note.Visible := true;
                           p_note_Layer.Text := cec.Text;
                           if cec.Name = 'Meas' then
                           begin
                              p_note_Caption.Text := 'Dílčí měření';
                              p_Note_Text.Text := cec.Text +': '+ FormatFloat('0.##',LL.Length)+' m '+FormatFloat('0.##',Abs(LL.Area)/10000)+' ha '+IntToStr(LL.Count)+' bodů'
                           end
                           else
                           begin
                              p_note_Caption.Text := LL.Name;
                              p_Note_Text.Text := cec.Text +': '+ FormatFloat('0.##',LL.Length)+' m '+FormatFloat('0.##',Abs(LL.Area)/10000)+' ha '+IntToStr(LL.Count)+' bodů'
                           end;
                           p_Note.Position.X := Point.X - p_Note.Width/2;
                           p_Note.Position.Y := Point.Y + 5;
                           BlinkLine(LL);
                           exit;
                        end;
                     end;
                  end;
               end;
            end;
         end;
         p_Note.Visible := false;
         if CHeckJPRL then
         begin
            PSK := FindForestOnScreen(Point,true);
         end;
      end;
   end; // case
end;

procedure TMainForm.Image_editMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Single);
var
   i,Mli: integer;
   mX,mY,Dist,LastDist,MinDist: double;
begin
   case ActiveTool of
   at_Meas,at_Line:
      if ActiveSubTool in [0,2] then
      begin
         if MLine = nil then
            MLine := TPolyLineElement.Create;
      //   DrawLine(MLine,true,MLine.LastIndex,true);
         if MLine.Count = 0 then
         begin
            RefX := 0;
            RefY := -100;
            MLine.AddXY(GetModelX(X),GetModelY(Y-100));
            MLine.Update;
            MLineActivePoint := 0;
         end
         else
         begin
            RefX := GetPageX(MLine.Xi[MLineActivePoint]);
            RefY := GetPageY(MLine.Yi[MLineActivePoint]);
            if ActiveSubTool = 0 then
            begin
               if MLineActivePoint = MLine.LastIndex then
                  MLine.AddXY(MLine.Xi[MLine.LastIndex],MLine.Yi[MLine.LastIndex])
               else
                  MLine.InsertXY(MLineActivePoint,MLine.Xi[MLineActivePoint],MLine.Yi[MLineActivePoint]);
               MLine.Update;
               Inc(MLineActivePoint);
               DrawLineEdit(MLine,MLineActivePoint,EditColors.LineColor,nil);
            end;
            RefX := RefX - X;
            RefY := RefY - Y;
         end;

      //   Image_edit.Bitmap.Canvas.BeginScene;
      //   Image_edit.Bitmap.Canvas.ClearRect(TAlphaColors.Null);
      //   Image_edit.Bitmap.Canvas.EndScene;
         DrawLineDetail(MLine,MLineActivePoint, EditColors.LineColor,nil);
         l_Text.Text := 'Délka: '+FormatFloat('0.###',MLine.Length)+ ' m      Plocha:'+FormatFloat('0.##',Abs(MLine.Area)/10000)+' ha';
         BMMoving := false;
         Application.ProcessMessages;
      end
      else
      if ActiveSubTool = 1 then
      begin
         if MLine = nil then exit;
         MX := GetModelX(X);
         MY := GetModelY(Y);
         MinDist := GetModelLength(50);
         LastDist := 1E20;
         Mli := -1;
         for I := 0 to MLine.LastIndex do
         begin
            Dist := Distance(MX,MY,MLine.Xi[i],MLine.Yi[i]);
            if (Dist < MinDist) and (Dist < LastDist) then
            begin
               Mli := i;
               LastDist := Dist;
            end;
         end;
         if (Mli > -1) and (MLineActivePoint <> Mli) then
         begin
            MLineActivePoint := Mli;
            DrawLineEdit(MLine,MLineActivePoint, EditColors.LineColor,nil);
            DrawLineDetail(MLine,MLineActivePoint, EditColors.LineColor,nil);
         end;
      end;
   at_Point:
      begin
         ePoint := Tgis_PointElement.Create;
         ePoint.Color := Barva;
         ePoint.Symbol := Zn.B.ActualDruh.Znacka;  //1021;//1078;//3002;
         ePoint.X := GetModelX(X);
         ePoint.Y := GetModelY(Y-100);
         DrawPoint(ePoint,true);
         BMMoving := false;
      end;

   end;
end;

procedure TMainForm.Image_editMuseMove(Sender: TObject; Shift: TShiftState; X, Y: Single);
var
   C: T2DCoordinate;
   S: string;
begin
   if BmMoving then exit;
   case ActiveTool of
   at_Meas,at_Line: // line
      begin
         if MLine = nil then
            MLine := TPolyLineElement.Create;
         if MLine.NoElements then exit;
      //   DrawLine(MLine,true,MLine.LastIndex,true);
         C := MLine.GetOrientedCoordElement(MLineActivePoint,true);
         C.X := GetModelX(X + RefX);
         C.Y := GetModelY(Y + RefY);
      //   Image_edit.Bitmap.Canvas.BeginScene;
      //   Image_edit.Bitmap.Canvas.Clear(TAlphaColors.Null);
      //   Image_edit.Bitmap.Canvas.EndScene;
         DrawLineDetail(MLine,MLineActivePoint, EditColors.LineColor,nil);
         l_Text.Text := 'Délka: '+FormatFloat('0.###',MLine.Length)+ ' m      Plocha:'+FormatFloat('0.##',abs(MLine.Area)/10000)+' ha';
      //   Application.ProcessMessages;
      end;
   at_Point:  // point .. maybe
      begin
         if ePoint = nil then exit;
         ePoint.X := GetModelX(X);
         ePoint.Y := GetModelY(Y-100);
         //DrawPoint(ePoint,true);
         MainTool.PostMsg(tm_ReView,MainTool,ePoint,false);
      end;
   end;
end;

procedure TMainForm.Image_editMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Single);
begin
   if ActiveTool in [at_Meas,at_Line] then
   begin
      DrawLineEdit(MLine,MLineActivePoint, EditColors.LineColor,nil);
      DrawLineDetail(MLine,MLineActivePoint, EditColors.LineColor,nil);
   end;
   BMMoving := true;
end;

procedure TMainForm.Image_ViewClick(Sender: TObject);
begin
   MapCombo.DropDown;
//   Multiview.ShowMaster;
//   tabc.ActiveTab := tab_view;
end;

procedure TMainForm.Import;
begin
   MultiView.HideMaster;
   ImportLayer_Form.Start(false,'');
end;

function TMainForm.Layers_Add(aName, aText: string): TComplicatedGECollection;
var
   cec: TComplicatedGECollection;
begin
   if Layers = nil then exit;
   cec := TComplicatedGECollection.Create;
   Layers.NextElement := cec;
   result := cec;
   cec.Name := aName;
   cec.Text := aText;
end;

procedure TMainForm.Layers_Check;
var
   cec: TComplicatedGECollection;
begin
   if Layers = nil then
   begin
      Layers := TOwnerEntity.Create;
      Layers.Name := 'Layers';
      cec := Layers_Add('Meas','Měření');
      cec.Enabled := false;
      cec.Visible := false;
      cec.Color := TAlphaColors.Limegreen;
      cec := Layers_Add('Log','Trasy');
      cec.Enabled := false;
      cec.Visible := true;
      cec.Color := TAlphaColors.Orchid;
      cec := Layers_Add('User','Kreslení');
      cec.Enabled := false;
      cec.Visible := true;
      cec.Color := TAlphaColors.Red;
   end;
end;

procedure TMainForm.Layers_CheckColors;
var
   cec: TComplicatedGECollection;
   i: integer;
begin
   if Layers = nil then  exit;

   for i := 0 to Layers.LastIndex do
   begin
      cec := TComplicatedGECollection(Layers.Elements[i]);
      if (cec.Color and TAlphaColors.Alpha) <> TAlphaColors.Alpha then
      begin
         cec.Color := EditColors.DefaultColor;
         Layers_Modified := true;
      end;
   end;
end;

function TMainForm.Layers_Layer(aName, aLayer: string): TComplicatedGECollection;
var
   e: TElement;
begin
   result := nil;
   e := Layers.Element[aName];
   if e = nil then exit;
   if not (e is TComplicatedGECollection)  then exit;
   result := TComplicatedGECollection(e).Layer[aLayer];
end;

function TMainForm.Layers_LayerExists(aName, aLayer: string): boolean;
var
   e: TElement;
   cec: TComplicatedGECollection;
begin
   result := false;
   e := Layers.Element[aName];
   if e = nil then exit;
   if not (e is TComplicatedGECollection)  then exit;
   cec := TComplicatedGECollection(e);
   e := cec.Element[aLayer];
   result := e <> nil;
end;

procedure TMainForm.Layers_Load;
var
   L: TLoad;
   i,ii: integer;
   RPath: string;
begin
//   exit;
//   ShowMessage('before det');
   // nove umisteni
   RPath := ProjectPath.User;                            // nove umisteni
   if not System.IOUtils.TFile.Exists(RPath) then        // nova data neexistuji
   begin
      RPath := AlternativeLayersPath;                    // starsi umisteni alternativa
      if not System.IOUtils.TFile.Exists(RPath) then     // no a kdyz ni tam nic neni
      begin
         RPath := LayersPath;                            // tak hledame u souboru
         if not System.IOUtils.TFile.Exists(RPath) then  // a kdyz nejsou ani tam
         begin
            Layers_Check;   // pokud se nepodarilo layers nacist tak se asi vytvorej ....
            OldRoutesAndNotesLoad;                        // tak zkusime nacist uplne stara data
            exit;
         end;
//         ShowMessage('Budou načteny Vrstvy uložené v interní paměti!');
      end;
   end;
   AniIndicator.Visible := true;
   AniIndicator.Enabled := true;
   l_Progress.Text := 'Čtení Layers z '+ RPath;
   Application.ProcessMessages;
   L := TLoad.CreateAll(RPath);
   L.NoProgress := true;
   try
   L.DoIt;
   if not(L.output is TOwnerEntity) then exit;
   Layers := TOwnerEntity(L.Output);
   finally

   end;
//   Route_UpdateList;
   AniIndicator.Visible := false;
   AniIndicator.Enabled := false;
end;

procedure TMainForm.Layers_Save;
var
   S: TSave;
   i,ii: integer;
   RPath: string;
begin
//   exit;
//   ShowMessage('before det');
//   RPath := LayersPath;
   RPath := ProjectPath.User;
   AniIndicator.Visible := true;
   AniIndicator.Enabled := true;
   l_Progress.Visible := true;
   l_Progress.Text := 'uložení Layers do '+ RPath;
   l_Progress.Visible := false;
   Application.ProcessMessages;
   S := TSave.CreateAll(RPath);
   try
   S.NoProgress := true;
   S.Input := Layers;
   S.DoIt;
   Except
      ShowMessage('Není možné zapsat Vrstvy projektu !');
//      LayersPath  := AlternativeLayersPath;
//      RPath := LayersPath;
//      l_Progress.Text := 'uložení Layers do '+ RPath;
//      l_Progress.Visible := false;
//      Application.ProcessMessages;
//      S := TSave.CreateAll(RPath);
//      try
//      S.NoProgress := true;
//      S.Input := Layers;
//      S.DoIt;
//      except
//         ShowMessage('Není možné zapsat vrstvy NIKAM!');
//      end;
   end;
   AniIndicator.Visible := false;
   AniIndicator.Enabled := false;
end;

procedure TMainForm.Layers_UpdateList;
var
   i,ii: integer;
   LItem: TListBoxItem;
   en,en1: TComplicatedGECollection;
   S: string;
   ColorObj: TFmxObject;
   LIcont: boolean;
begin
  // Code to fill TListView
  ListBox_Layers.BeginUpdate;
  ActiveLayerCombo.BeginUpdate;
  try
    ListBox_Layers.Items.Clear;
    ActiveLayerCombo.Items.Clear;
   if Layers = nil then
      exit;
    for I := 0 to Layers.LastIndex do
    begin
       En := TComplicatedGECollection(Layers.Elements[i]);
       LItem := TListBoxItem.Create(ListBox_Layers);
       LItem.Text := (En.Text{ + ' [' + en.Name + ']'});
       LItem.Data := En;
       // Update data managed by custom appearance
       S := '';
       LICont := false;
       for ii := 0 to EN.LastIndex do
       begin
          en1 := EN.Layers[ii];
          if en1.Count > 0  then
          begin
             S := S + En1.Name + ' [' + en1.count.ToString + '] ';
             LICont := true;
          end;
         // (aNone=0, aMore=1, aDetail=2, aCheckmark=3)
//         LI.ItemData.Accessory := TListBoxItemData.TAccessory(2);
//         LItem.StyleLookup := 'listboxitembottomdetail';
       end;
       LItem.ItemData.Detail := S;
//       LItem.ItemData.Bitmap := Image1.Bitmap;
       LItem.ItemData.Accessory := TListBoxItemData.TAccessory(1);
//       LItem.StyleLookup := 'listboxitembottomdetail';
       LItem.StyleLookup := 'colorlistboxitemstyle';
       LItem.OnApplyStyleLookup := ListBox_Layers_ItemApplyStyleLookup;
       LItem.IsChecked := En.Visible;
       ListBox_Layers.AddObject(LItem);
       // color
//       ColorObj := LItem.FindStyleResource('color');
//       if ColorObj is TShape then
//          TShape(ColorObj).Fill.Color := En.Color;
       if not ((En.Name = 'OldRoutesAndNotes') or (En.Name = 'Meas') or (En.Name = 'Log')) then
          ActiveLayerCombo.Items.AddObject(En.Text,En);
    end;
  finally
    if (ActiveLayerCombo.ItemIndex < 0) and (ActiveLayerCombo.Count > 0) then
       ActiveLayerCombo.ItemIndex := 0;
    ListBox_Layers.EndUpdate;
    ActiveLayerCombo.EndUpdate;
  end;
end;

procedure TMainForm.Layer_UpdateList(aLayer: TComplicatedGECollection);
var
   e: TElement;
   cec: TComplicatedGECollection;
   i: integer;
begin
   MiniLed_Notes_Form.ActiveLayer := aLayer;
   MiniLed_Notes_Form.RoutesList.BeginUpdate;
   MiniLed_Notes_Form.RoutesList.Clear;
   MiniLed_Notes_Form.RoutesList.EndUpdate;
   MiniLed_Notes_Form.NotesList.BeginUpdate;
   MiniLed_Notes_Form.NotesList.Clear;
   MiniLed_Notes_Form.NotesList.EndUpdate;
   for I := 0 to aLayer.LastIndex do
   begin
      e := aLayer.Elements[i];
      if not (e is TComplicatedGECollection) then continue;
      cec := TComplicatedGECollection(e);
      Layer_UpdateListDetail(cec);
   end;
end;

procedure TMainForm.Layer_UpdateListDetail(aLayer: TComplicatedGECollection);
var
  I: Integer;
  LI: TListBoxItem;
  L: TPolyLineElement;
  T: TTextElement;
begin
   if Uppercase(aLayer.Name) = 'L' then
   begin
      MiniLed_Notes_Form.RoutesList.BeginUpdate;
      MiniLed_Notes_Form.RoutesList.Clear;
      if aLayer <> nil then
      begin
         for I := 0 to aLayer.LastIndex do
         begin
            L := TPolyLineElement(aLayer.Elements[i]);
            LI := TListBoxItem.Create(MiniLed_Notes_Form.RoutesList);
            LI.Text := L.Name;
            LI.Data := L;
            LI.ItemData.Detail := FormatFloat('0.##',L.Length)+' m '+IntToStr(L.Count)+' bodů';
            // (aNone=0, aMore=1, aDetail=2, aCheckmark=3)
   //         LI.ItemData.Accessory := TListBoxItemData.TAccessory(2);
            LI.StyleLookup := 'listboxitembottomdetail';
            MiniLed_Notes_Form.RoutesList.AddObject(LI);
         end;
      end;
      MiniLed_Notes_Form.RoutesList.EndUpdate;
   end
   else
   if UpperCase(aLayer.Name) = 'N' then
   begin
      MiniLed_Notes_Form.NotesList.BeginUpdate;
      MiniLed_Notes_Form.NotesList.Clear;
      if aLayer <> nil then
      begin
         for I := 0 to aLayer.LastIndex do
         begin
            T := TTextElement(aLayer.Elements[i]);
            LI := TListBoxItem.Create(MiniLed_Notes_Form.NotesList);
            LI.Text := T.Name;
            LI.Data := T;
            LI.ItemData.Detail := T.Text;//FormatFloat('0.##',L.Length)+' m '+IntToStr(L.Count)+' bodů';
            // (aNone=0, aMore=1, aDetail=2, aCheckmark=3)
   //         LI.ItemData.Accessory := TListBoxItemData.TAccessory(2);
            LI.StyleLookup := 'listboxitembottomdetail';
            MiniLed_Notes_Form.NotesList.AddObject(LI);
         end;
      end;
      MiniLed_Notes_Form.NotesList.EndUpdate;
   end;
end;

procedure TMainForm.InfoLayoutClick(Sender: TObject);
begin

end;

//var
//   i,ii: integer;
//   en,en1: TComplicatedGECollection;
//begin
//   Memo_Layers.Lines.Clear;
//   if Layers = nil then exit;
//
//   for i := 0 to Layers.LastIndex do
//   begin
//      En := TComplicatedGECollection(Layers.Elements[i]);
//      Memo_Layers.Lines.Add(En.Text + ' [' + en.Name + ']');
//      for ii := 0 to EN.LastIndex do
//      begin
//         en1 := EN.Layers[ii];
//         Memo_Layers.Lines.Add('     ' + En1.Name + ' [' + en1.count.ToString + ']');
//      end;
//   end;
//end;


procedure TMainForm.LHC_Load;
var
   L: TLoad;
   i,ii: integer;
begin
//   exit;
//   ShowMessage('before det');
   if not System.IOUtils.TFile.Exists(LHCSPath) then
   begin
      if LHCS = nil then
      begin
         LHCS := TOwnerEntity.Create;
         LHCS.Name := 'LHCS';
      end;
      exit;
   end;
   AniIndicator.Visible := true;
   AniIndicator.Enabled := true;
   l_Progress.Text := 'Čtení LHC z '+ LHCsPath;
   Application.ProcessMessages;
   L := TLoad.CreateAll(LHCsPath);
   L.NoProgress := true;
   try
   L.DoIt;
   if not(L.output is TOwnerEntity) then exit;
   LHCs := TOwnerEntity(L.Output);
   finally

   end;
//   LHC_UpdateList;
   AniIndicator.Visible := false;
   AniIndicator.Enabled := false;
end;

procedure TMainForm.LHC_Save;
var
   S: TSave;
   i,ii: integer;
begin
//   exit;
//   ShowMessage('before det');
   AniIndicator.Visible := true;
   AniIndicator.Enabled := true;
   l_Progress.Visible := true;
   l_Progress.Text := 'uložení LHC do '+ LHCSPath;
   l_Progress.Visible := false;
   Application.ProcessMessages;
   S := TSave.CreateAll(LHCsPath);
   try
   if LHCs = nil then
   begin
      LHCs := TOwnerEntity.Create;
      LHCS.Name := 'LHCS';
   end;
   S.NoProgress := true;
   S.Input := LHCs;
   S.DoIt;
   Except
   end;
   AniIndicator.Visible := false;
   AniIndicator.Enabled := false;
end;

procedure TMainForm.LHC_UpdateList;
var
  I: Integer;
  LI: TListBoxItem;
  SE: TStringElement;
begin
{$IFDEF HK}
   Karkulka_LHCList_Form.LHCListbox.BeginUpdate;
   Karkulka_LHCList_Form.LHCListbox.Clear;
   if LHCs <> nil then
   begin
      for I := 0 to LHCs.LastIndex do
      begin
         SE := TStringElement(LHCs.Elements[i]);
         LI := TListBoxItem.Create(Karkulka_LHCList_Form.LHCListbox);
         LI.Text := SE.Name;
         LI.Data := SE;
         LI.ItemData.Detail := SE.Text;//FormatFloat('0.##',L.Length)+' m '+IntToStr(L.Count)+' bodů';
         // (aNone=0, aMore=1, aDetail=2, aCheckmark=3)
//         LI.ItemData.Accessory := TListBoxItemData.TAccessory(2);
         LI.StyleLookup := 'listboxitembottomdetail';
         Karkulka_LHCList_Form.LHCListbox.AddObject(LI);
      end;
   end;
   Karkulka_LHCList_Form.LHCListbox.EndUpdate;
{$ENDIF}
end;

procedure TMainForm.ListBox_LayersChangeCheck(Sender: TObject);
var
  I: Integer;
  cec: TComplicatedGECollection;
begin
   for I := 0 to ListBox_Layers.Items.Count - 1 do
   begin
      cec := TComplicatedGECollection(ListBox_Layers.Items.Objects[i]);
      if cec = nil then continue;
      cec.Visible := ListBox_Layers.ListItems[i].IsChecked;
   end;
   Review(false);
end;

procedure TMainForm.ListBox_LayersItemClick(const Sender: TCustomListBox; const Item: TListBoxItem);
var
   cec: TComplicatedGECollection;
begin
   cec := TComplicatedGECollection(Item.Data);
//   Layer_UpdateList(cec);
//   MultiView.HideMaster;
//   MiniLed_Notes_Form.Show;
   tab_layers_Layout.Visible := true;
   tab_Layers_edit_LayerName.Text := cec.Text;
   tab_Layers_edit_LayerName.Enabled := cec.Enabled;
   tab_Layers_ComboColor.Color := cec.Color;
   tab_Layers_LayerDetail.Text := Item.ItemData.Detail;
   ListBox_Layers.Visible := false;
end;

procedure TMainForm.ListBox_Layers_ItemApplyStyleLookup(Sender: TObject);
var
  ColorObj: TFmxObject;
  LI: TListBoxItem;
begin
   LI := TListBoxItem(Sender);
   ColorObj := LI.FindStyleResource('color');
   if ColorObj is TShape then
     TShape(ColorObj).Fill.Color := TComplicatedGECollection(LI.Data).Color;
end;

procedure TMainForm.LoadDET(aFileName, aOddName: string);
//var
//   S,SS: string;
//   iODD,IDIL,iPOR,iPSK,i,ii: integer;
//   MDCount,MXCount: integer;
//   MapRec : RMap;
//   MXRec  : RTileMatrix;
////   objRow : DataRow;
//   xLHC,xODD,xDIL,xPor,xPSK,n,DE,TMS: IXMLNode;
//   SLHC,SODD,SDIL,SPOR,SPSK: string;
//begin
//   exit;
//   l_Progress.Visible := true;
//   l_Progress.Text := aFileName;
//   Application.ProcessMessages;
//   XMLDOcument_lhc.Active := false;
//   XMLDocument_lhc.FileName := aFileName;
//   XMLDocument_lhc.Active := true;
//   xLHC := XMLDocument_lhc.DocumentElement;
//   SLHC := xLHC.Text;
//   ProgressBar.Min := 0;
//   ProgressBar.Max := xLHC.ChildNodes.Count - 1;
//   AniIndicator.Enabled := false;
//   AniIndicator.Visible := false;
//   ShowMessage('before odd');
//   for iODD  := 0 to xLHC.ChildNodes.Count - 1 do   // cteni map
//   begin
//      xODD := xLHC.ChildNodes[iODD];
//      ProgressBar.Value := iODD;
//      SS := xODD.Text;
//      l_Progress.Text := 'Příprava oddeleni ' + SS;
//      Application.ProcessMessages;
//      for iDIL := 0 to xODD.ChildNodes.Count -1 do
//      begin
//         xDIL := xODD.ChildNodes[iDIL];
//         sDIL := xDIL.Text;
//         for IPOR := 0 to xDIL.ChildNodes.Count - 1 do
//         begin
//             xPOR := xDIl.ChildNodes[iPOR];
//             sPOR := xPOR.Text;
//             for iPSK := 0 to xPOR.ChildNodes.Count - 1 do
//             begin
//                 xPSK := xPOR.ChildNodes[iPSK];
//                 sPSK := xPSK.Text;
//                 l_Progress.Text := 'Příprava oddeleni ' + sLHC+sODD+sDIL+sPOR+sPSK;
//                 Application.ProcessMessages;
//             end;
//         end;
//      end;
//   end;
//end;
//var
//   Tl: TTool;
//   i: integer;
//begin
////   exit;  // jumping
//   TL := TTechnology.Create;
//   ShowMessage('start');
//   TL.StartProgress('Testovaci progress',0,10);
//   for i := 0 to 10 do
//   begin
//       ShowMessage(IntTostr(i));
//       TL.Progress := i;
////       TL.ProgressText := 'test '+IntToStr(i);
//       Application.ProcessMessages;
//   end;
//   TL.EndProgress;
//end;

var
   L: TLoad;
   i,ii: integer;
   LS: Tgis_LS;
   aTask: TTask;
begin
//   exit;
//   ShowMessage('before det');
   if not System.IOUtils.TFile.Exists(aFilename) then
   begin
      ShowMessage('Čtení DET : soubor '+aFileName+' neexistuje!');
      exit;
   end;
   if DataOnBackGround then
   begin
         l_JPRL.Text := 'Čtení...';
         l_JPRLs.Text := 'Čtení...';
      //   ShowMessage('Before DET');
         LoadDetThread := TLoadDetThread.Create(true);
      //   LoadDetThread.Priority := tpNormal;
         LoadDetThread.FreeOnTerminate := true;
         LoadDetThread.FileName := aFileName;
         LoadDetThread.OnTerminate := AfterLoadDET;
         LoadDetThread.Start;

         exit;
   end;

   AniIndicator.Visible := true;
   AniIndicator.Enabled := true;
   l_Progress.Text := 'Čtení DET z '+ aFileName;
   Application.ProcessMessages;
   L := TLoad.CreateAll(aFileName);
   L.NoProgress := true;
   try
   L.DoIt;
   if not(L.output is Tgis_ForestModel) then exit;
   LHC := Tgis_ForestModel(L.Output);
   finally

   end;
   if LHC <> nil then
   begin
      LHC.ActualLHC := Tgis_LHC(LHC.FindElementClass(Tgis_LHC));
      //Oddeleni
      ed_odd.Items.Clear;
      if not LHC.ActualLHC.NoItems  then
      begin
         for i := 0 to LHC.ActualLHC.Items.LastIndex do
         begin
            LS := Tgis_LS(LHC.ActualLHC.Items.ForestUnit[i]);
            if not LS.NoItems then
            for ii := 0 to LS.Items.LastIndex do
            begin
               ed_odd.Items.Add(LS.Items.Elements[ii].Name);
               Application.ProcessMessages;
            end;
         end;
         ed_odd.ItemIndex := 0;
      end;
      FMSelector := TForestModelSelector.Create;
      FMSelector.ForestModel := LHC;
      FMSelector.ReferenceFrameClass := Tgis_PorostniSkupina;
      FMSelector.FrameClass := Tgis_PorostniSkupina;
   end;

   AniIndicator.Visible := false;
   AniIndicator.Enabled := false;
   if Assigned(OnDataReady) then
      OnDataReady(nil);
end;

procedure TMainForm.LoadEdit(aFileName: string);
begin

end;

procedure TMainForm.LoadMap(aFileName, aExt: string);
var
   S,SS: string;
   i: integer;
   MDCount,MXCount: integer;
   MapRec : RMap;
   MXRec  : RTileMatrix;
//   objRow : DataRow;
   n,DE,TMS: IXMLNode;
   LocalMapDir: string;
   MOK: boolean;
   MapError: integer;
{$IFDEF HK}
   procedure CheckMapRegistration;
   var
      LI: TListBoxItem;
      MR: RMap;
      MRS: string;
   begin
      RegMapForm.Visible := true;
      RegMapForm.RegMapListBox.BeginUpdate;
      RegMapForm.RegMapListBox.Clear;
      for MR in Maps do
      begin
         LI := TListBoxItem.Create(RegMapForm.RegMapListBox);
         LI.Text := MR.MapName;
//         LI.Data := SE;
         if MR.Registered then
         begin
            MRS := '* Registrována';
            LI.ImageIndex := 2;
         end
         else
         begin
            case MR.Error of
               mrer_NoRegFile        : MRS := '! Chybí reg.soubor-NELZE REGISTROVAT';
               mrer_CorruptedRegFile : MRS := '! Vadný reg.soubor-NELZE REGISTROVAT';
               mrer_WrongMapID       : MRS := '! Vadné ID mapy-NELZE REGISTROVAT';
            else
               MRS := 'Připravena k registraci';
            end;
            if MR.Error = mrer_NotRegistered then
               LI.ImageIndex := 1
            else
               LI.ImageIndex := 0;

         end;
         LI.ItemData.Detail := MRS;//FormatFloat('0.##',L.Length)+' m '+IntToStr(L.Count)+' bodů';
         // (aNone=0, aMore=1, aDetail=2, aCheckmark=3)
//         LI.ItemData.Accessory := TListBoxItemData.TAccessory(2);
         LI.StyleLookup := 'listboxitembottomdetail';
         RegMapForm.RegMapListBox.AddObject(LI);
      end;
      RegMapForm.RegMapListBox.EndUpdate;
   end;
{$ENDIF}
   procedure ReadMap(Mind: integer; aNew, aLocal: boolean);
   var
      ii: integer;
      regFileName: string;
      confirmFileName: string;
{$IFDEF HK}
      mapreg: TKarkulka_MapRegElement;
{$ENDIF}
      L: TLoad;
      TestHash: string;
   begin
      SS := N.ChildNodes['name'].Text;
      if aNew then
         l_Progress.Text := 'Příprava mapy ' + SS
      else
         l_Progress.Text := 'Oprava mapy ' + SS;
      Application.ProcessMessages;
      MapRec.MapName := N.ChildNodes['name'].Text;
      if aNew then
      begin
         MapCombo.Items.Add(MapRec.MapName);  // pridava se jen pokud neni nova
         MapListBox.Items.Add(MapRec.MapName);
      end
      else
      begin
         MapCombo.Items.Strings[Mind] := MapRec.MapName;
         MapListBox.Items.Strings[Mind] := MapRec.MapName;
      end;
      MapRec.Ext := N.ChildNodes['ext'].Text;
      if aLocal then
         MapRec.MapDir := LocalMapDir
      else
         MapRec.MapDir := IncludeTrailingPathDelimiter(MapDirectory+ N.ChildNodes['dir'].Text);

      MapRec.MinX := 1E27;
      MapRec.MinY := 1E27;
      MapRec.MaxX := -1E27;
      MapRec.MaxY := -1E27;
//         MapRec.MapName :=  SS + '.' + aExt;
//         MapRec.Width := (MapRec.MaxX - MapRec.MinX);
//         MapRec.Height := (MapRec.MaxY - MapRec.MinY);
      TMS := N.ChildNodes['TileMatrixSet'];
      MXCount := TMS.ChildNodes.Count;
      SetLength(MapRec.TileMatrixSet,MXCount);
      for ii := 0 to MXCount - 1 do     // tilematrix
      begin
         N := TMS.ChildNodes[ii];
         MXRec.ID := N.ChildNodes['ID'].Text;
         MXRec.MinX := StrToIntDef(N.ChildNodes['MinX'].Text,0);
         MXRec.MinY := StrToIntDef(N.ChildNodes['MinY'].Text,0);
         MXRec.TileWidth := StrToIntDef(N.ChildNodes['TileWidth'].Text,0);
         MXRec.TileHeight := StrToIntDef(N.ChildNodes['TileHeight'].Text,0);
         MXRec.OverX := StrToIntDef(N.ChildNodes['OverX'].Text,0);
         MXRec.OverY := StrToIntDef(N.ChildNodes['OverY'].Text,0);
         MXRec.MatrixWidth := StrToIntDef(N.ChildNodes['MatrixWidth'].Text,0);
         MXRec.MatrixHeight := StrToIntDef(N.ChildNodes['MatrixHeight'].Text,0);
         if MXRec.MinX < MapRec.MinX then MapRec.MinX := MXRec.Minx;
         if MXRec.MinY < MapRec.MinY then MapRec.MinY := MXRec.MinY;
         MXRec.MaxX := MXRec.MinX + ((MXRec.MatrixWidth * MXRec.TileWidth) - ((MXRec.MatrixWidth - 1) * MXRec.OverX));
         MXRec.MaxY := MXRec.MinY + ((MXRec.MatrixHeight * MXRec.TileHeight) - ((MXRec.MatrixHeight - 1) * MXRec.OverY));
         MapRec.TileMatrixSet[ii] := MXRec;
         if MXRec.MaxX > MapRec.MaxX then MapRec.MaxX := MXRec.Maxx;
         if MXRec.MaxY > MapRec.MaxY then MapRec.MaxY := MXRec.MaxY;
      end;
      MapRec.Error := 0;
{$IFDEF HK}
      MapRec.Registered := false;
      RegFileName := MapRec.MapDir + 'mapreg.org';
      if System.IOUtils.TFile.Exists(RegFileName) then
      begin
         L := TLoad.CreateAll(RegFileName);
         L.DoIt;
         if not (L.Output is TKarkulka_MapRegElement) then
         begin
            MapRec.Error := mrer_CorruptedRegFile;  // mapreg je divnej
         end
         else
         begin
            mapreg := TKarkulka_MapRegElement(L.Output);
            MapRec.MapID   := mapreg.MapID;
            MapRec.Subject := mapreg.Subject;
            MapRec.Project := mapreg.Project;
            MapRec.user    := mapreg.User;
            MapRec.Plocha  := mapreg.Plocha;
            // kontrola id mapy
            TestHash := THashSHA1.GetHashString(MapRec.Subject+MapRec.Project+MapRec.MapName);
            if TestHash = MapRec.MapID then
            begin   // ID je spravne
               // Nasleduje kontrola registrace
               ConfirmFileName := ProjectPath.maps+THashSHA1.GetHashString(MapRec.MapID+T_DeviceInfo.GetIMEI);
               MapRec.Registered := System.IOUtils.TFile.Exists(ConfirmFileName);
               if not MapRec.Registered then
                  MapRec.Error := mrer_NotRegistered;
            end
            else
            begin   // ID je chybne
               MapRec.Error := mrer_WrongMapID;
            end;
         end;
      end
      else
      // mapreg.org neexistuje
      begin
          MapRec.Error := mrer_NoRegFile;
      end;
      if MapRec.Error > MapError then MapError := MapRec.Error;
{$ELSE}
      MapRec.Registered := true;
{$ENDIF}
      Maps[Mind] := MapRec;
   end;


   procedure CheckMapDirectory;
   var
      Dirs: TStringDynArray;
      SDir: string;
      MR: RMap;
      MIndex: integer;
      aNew: boolean;
   begin
      Dirs := TDirectory.GetDirectories(MapDirectory);
      l_Progress.Text := 'Kontrola mapových složek ...';
      AniIndicator.Visible := true;
      AniIndicator.Enabled := true;
      ProgressBar.Min := Low(Dirs);
      ProgressBar.Max := High(Dirs);
      ProgressBar.Value := Low(Dirs);
      Application.ProcessMessages;
      for SDir in Dirs do
      begin
         LocalMapDir := IncludeTrailingPathDelimiter(SDir);
         S := LocalMapDir + 'MapTiles.xml';
         if System.IOUtils.TFile.Exists(S) then // a pokud je i def soubor.....
         begin
            MOK := true;
            aNew := false;
            if not MapsDirExists(LocalMapDir, MIndex) then  // pokud Mapa neexistuje tak ....
            begin
               MIndex := Length(Maps);           // nova mapa
               SetLength(Maps,MIndex + 1);
               aNew := true;
            end;
            // cteme dataset
            XMLDOcument.Active := false;
            XMLDocument.FileName := S;
            XMLDocument.Active := true;
            N := XMLDocument.DocumentElement;
            ReadMap(Mindex, aNew, True);
         end;
      end;
      AniIndicator.Enabled := false;
      AniIndicator.Visible := false;
   end;

begin
   MOK := false;
   MapError := 0;
   if aFileName = ''  then
      exit;
   MapDirectory := IncludeTrailingPathDelimiter(aFileName);
   S := MapDirectory + 'Tiles.xml';
   MapCombo.Items.Clear;
   MapListBox.Clear;
   if System.IOUtils.TFile.Exists(S) then
   begin
      MOK := true;
      MapChangeActive := false;
      l_Progress.Text := 'Čtení mapového souboru ...';
      AniIndicator.Visible := true;
      AniIndicator.Enabled := true;
      Application.ProcessMessages;
      // cteme dataset
      XMLDOcument.Active := false;
      XMLDocument.FileName := S;
      XMLDocument.Active := true;
      DE := XMLDocument.DocumentElement;
      MDCount := DE.ChildNodes.Count;
      SetLength(Maps, MDCount);
      ProgressBar.Min := 0;
      ProgressBar.Max := MDCount - 1;
      ProgressBar.Value := 0;
      AniIndicator.Enabled := false;
      AniIndicator.Visible := false;
      for i  := 0 to MDCount - 1 do   // cteni map
      begin
         N := DE.ChildNodes[i];
         ProgressBar.Value := i;
         ReadMap(i, true, false);
      end;
   end;
   CheckMapDirectory;    // revize slozek a nacteni map
{$IFDEF HK}
   if MapError > 0 then
      CheckMapRegistration; // kontrola registrace map
{$ENDIF}
   MapCombo.ItemIndex := 0;
   MapListBox.ItemIndex := 0;
   ActualMap := 0;
   ActualTileMatrix := 0;
end;

// original version ----------------------------------
//procedure TMainForm.LoadMap(aFileName, aExt: string);
//var
//   S,SS: string;
//   i: integer;
//   MDCount: integer;
//   MapRec : RMap;
////   objRow : DataRow;
//   n,DE: IXMLNode;
//begin
//   if aFileName = ''  then
//      exit;
//   MapDirectory := IncludeTrailingPathDelimiter(aFileName);
//   S := MapDirectory + 'Tiles.xml';
//   if not (System.IOUtils.TFile.Exists(S)) then
//   begin
//      ShowMessage('Soubor '+ S + ' neexistuje!');
//      exit;
//   end
//   else
//   begin
//      l_Progress.Text := 'Čtení mapového souboru ...';
//      AniIndicator.Visible := true;
//      AniIndicator.Enabled := true;
//      Application.ProcessMessages;
//      // cteme dataset
//      XMLDOcument.Active := false;
//      XMLDocument.FileName := S;
//      XMLDocument.Active := true;
//      DE := XMLDocument.DocumentElement;
//      MDCount := DE.ChildNodes.Count;
//      SetLength(Maps, MDCount);
//      ProgressBar.Min := 0;
//      ProgressBar.Max := MDCount - 1;
//      AniIndicator.Enabled := false;
//      AniIndicator.Visible := false;
//      for i  := 0 to MDCount - 1 do
//      begin
//         N := DE.ChildNodes[i];
//         ProgressBar.Value := i;
//         SS := N.ChildNodes['TILE'].Text;
//         l_Progress.Text := 'Příprava mapy ' + SS;
//         Application.ProcessMessages;
//         MapRec.MinX := StrToIntDef(N.ChildNodes['minx'].Text,0);
//         MapRec.MinY := StrToIntDef(N.ChildNodes['miny'].Text,0);
//         MapRec.MaxX := StrToIntDef(N.ChildNodes['maxx'].Text,0);
//         MapRec.MaxY := StrToIntDef(N.ChildNodes['maxy'].Text,0);
//         MapRec.MapName :=  SS + '.' + aExt;
//         MapRec.Width := (MapRec.MaxX - MapRec.MinX);
//         MapRec.Height := (MapRec.MaxY - MapRec.MinY);
//         Maps[i] := MapRec;
//      end;
//   end;
//end;

procedure TMainForm.LoadParams;
var
   S,SysP: string;
//   DE,N: TXMLNode;
//   i: integer;
begin
   S := _Path.Combine(_Path.GetPublicPath, 'map');
   SysP := _Path.Combine(S, 'system');
   S := _Path.Combine(SysP, 'params.prx');
   cbActive := false;
   if System.IOUtils.TFile.Exists(S) then
   begin
//      XMLDocument.Active := false;
//      XMLDocument.LoadFromFile(S);
//      DE := XMLDocument.DocumentElement;
//      i := StrToIntDef(DE.ChildNodes['topbarmargin'].Text,0);
//      cb_TopBarMargin.IsChecked := i = 1;
        topBar.Margins.Top := TopBar.Height / 2;
   end;
//   cbActive := true;
end;

procedure TMainForm.LoadProject(aFileName: string);
var
   S,sDir,sMap,sDET,sEdit,sOdd,sMapExt: string;
   i: integer;
begin
//   Refresh;
{$IFDEF HK}
   Karkulka_LHCList_Form.Close;
{$ENDIF}
   Image.Enabled := true;
   MapChangeActive := false;
//   LHC := nil;
//   Routes := nil;
//   Route_UpdateList;
//   Notes := nil;
//   Note_UpdateList;
   Tiles.Clear;
   ActualSuperLayer := nil;
   ActualLayer := nil;
   Layers := nil;
   Layers_UpdateList;
   SetLength(Maps,0);
   Image.Bitmap.Canvas.BeginScene;
   Image.Bitmap.Canvas.Clear(BColor);
   Image.Bitmap.Canvas.EndScene;

   Application.ProcessMessages;
   OddListExists := false;
//  S := GetAbsolutePath('',aFileName);
   ProjectPath.Clear;
   ProjectPath.Project := aFileName;
   ProjectPath.CheckDirectories;
   S := aFileName;
   sDir := _Path.GetDirectoryName(S);
   AlternativeLayersPath := _Path.Combine(_Path.GetPublicPath,(_Path.GetFileNameWithoutExtension(S)+'_USER.orb'));
   LayersPath := _Path.Combine(sDir,(_Path.GetFileNameWithoutExtension(S)+'_USER.orb'));
   AlternativeRoutesPath := _Path.Combine(_Path.GetPublicPath,(_Path.GetFileNameWithoutExtension(S)+'_RTS.orb'));
   RoutesPath := _Path.Combine(sDir,(_Path.GetFileNameWithoutExtension(S)+'_RTS.orb'));
   AlternativeNotesPath := _Path.Combine(_Path.GetPublicPath,(_Path.GetFileNameWithoutExtension(S)+'_NTS.orb'));
   NotesPath := _Path.Combine(sDir,(_Path.GetFileNameWithoutExtension(S)+'_NTS.orb'));

//   if Routes_UseAlternative then
//      RoutesPath := TPath.Combine(TPath.GetHomePath,(TPath.GetFileNameWithoutExtension(S)+'_RTS.orb'))
//   else
//      RoutesPath := TPath.Combine(sDir,(TPath.GetFileNameWithoutExtension(S)+'_RTS.orb'));
   DBPath := SDir;
   {$IFDEF HK}
   Form2.OnSelectDir(DBPath);
   {$ENDIF}
   //MessageBox.Show('Before read');
   XMLDocument.Active := false;
   XMLDocument.FileName := S;
   XMLDocument.Active := true;
   //MessageBox.Show('After read');
   sMap := FindLayerPath('Map');
   sMapExt := FindLayerExt('Map');
   sDET := FindLayerPath('Det');
   S_rok := FindLayerValue('Det','rok');
   sEdit := FindLayerPath('Edit');
   sOdd := '';
   if sMap <> '' then
      sMap := GetAbsolutePath(sDir,sMap);
   if sDET <> '' then
   begin
      sDet := GetAbsolutePath(sDir,sDET);
      sOdd := _Path.ChangeExtension(sDet,'.odx');
   end;
   if sEdit <> '' then
   begin
      sEdit := GetAbsolutePath(sDir,sEdit);
   end;
   l_Progress.Visible := true;
   ProgressBar.Visible := true;
   Layers_Load;
//   OldRoutesAndNotesLoad;   // je kvuli zachovani predeslych dat  - presunuto do Layers_Load
//   Route_Load;  // je kvuli zachovani predeslych dat
//   Note_Load;   // DTTO
   Layers_CheckColors;
   Layers_UpdateList;
   if Layers_Modified then
      Layers_Save;
   Layers_Modified := false;
   if sDET <> '' then
      LoadDET(sDET,sOdd);
   LoadMap(sMap,sMapExt);
   LoadEdit(sEdit);
   l_Progress.Visible := false;
   ProgressBar.Visible := false;
   ChangeProjectionByFirstMapTile;
//   ShowMessage('BeforeReview');
   Review(false);
   MapChangeActive := true;
   Application.ProcessMessages;
   if Assigned(OnMapReady) then
      OnMapReady(nil);
end;

procedure TMainForm.LocationSensorLocationChanged(Sender: TObject;  const OldLocation, NewLocation: TLocationCoord2D);
var
   S: string;
   A: TMapCoord;
begin
   gpsLat := NewLocation.Latitude;
   gpsLong := NewLocation.Longitude;
   WGS84toJTSK(gpsLat,gpsLong,A);
   jtskX := -A.Y;
   jtskY := -A.X;
   if not GPSFixed then
   begin
      Img_Green.Visible := true;
      Img_Orange.Visible := false;
      Img_Black.Visible := false;
   end;
   GPSFIxed := true;
   if GPSTrack then
   begin
      try
      Route_StoreCoords(jtskX,jtskY, false);
//      CHangeProjection(jtskX,jtskY,RealScale);
//      if not Reviewing then
//          Review(false);
      MainTool.PostMsg(tm_ReView,MainTool,ActualRoute,false);
      finally

      end;
   end;
   Drawgps;
//   Application.ProcessMessages;
//   S := '0.###';
   S := '0';
   l_jtsk.Text := 'X: '+FormatFloat(S,jtskX) + ' Y: '+FormatFloat(S,jtskY);
   l_gps.Text := WGS84ToStr(gpsLat,gpsLong);//+ '  A:'+FormatFloat(S,LocationSensor.Accuracy);
end;

procedure TMainForm.LockDisplay;
begin
//    LockForm.Show;
   MultiView.HideMaster;
   Multiview.Enabled := false;
   LockText.Text := 'Displej je uzamčen !';
   LockPanel.Visible := true;
   LockLayout.Visible := true;
   LockTimer.Enabled := true;
end;

procedure TMainForm.LockPanelClick(Sender: TObject);
begin
   LockLayout.Visible := true;
   LockTimer.Enabled := true;
end;

procedure TMainForm.LockPanelMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Single);
begin
   if (X > 200) and (Y > 200) then
   begin
      Unlocking := true;
      UnlockX := X;
      UnlockY := Y;
   end;
end;

procedure TMainForm.LockPanelMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Single);
begin
   if Unlocking then
   begin
      if (Abs(X - UnlockX) > 50) or (Abs(y - UnlockY) > 50) then
      begin
         LockLayout.Visible := true;
         LockText.Text := 'Odemykání ...';
      end;
   end;
end;

procedure TMainForm.LockPanelMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Single);
begin
   if Unlocking and (X < 50) and (y < 50) then
   begin
      LockPanel.Visible := false;
      LockLayout.Visible := true;
      LockText.Text := 'Odemčeno !';
      LockTimer.Enabled := true;
      Unlocking := false;
      MultiView.Enabled := true;
   end
   else
   begin
      LockText.Text := 'Displej je uzamčen !';
      Unlocking := false;
   end;
end;

procedure TMainForm.LockTimerTimer(Sender: TObject);
begin
   LockLayout.Visible := false;
   LockTimer.Enabled := false;
end;

procedure TMainForm.l_JPRLClick(Sender: TObject);
begin
   p_FInd.Visible := p_FInd.Visible;
end;

procedure TMainForm.l_JPRLsClick(Sender: TObject);
begin
   b_HKClick(nil);
end;

procedure TMainForm.MainListBoxItemClick(const Sender: TCustomListBox; const Item: TListBoxItem);
begin
//   Multiview.HideMaster;
//   ToolsListBox.Visible := false;
//   b_Hand.TintColor := TAlphaColors.Null;
   case MainListBox.ItemIndex of
      0: tabc.ActiveTab := tab_Tools;
      1: tabc.ActiveTab := tab_view;
      2: tabc.ActiveTab := tab_layers;
      3: tabc.ActiveTab := tab_Options;
      4: LockDisplay;
      5: Import;
   end;
end;

procedure TMainForm.MapComboChange(Sender: TObject);
begin
   if MapChangeActive then
   begin
      MapChangeActive := false;
      ActualMap := MapCombo.ItemIndex;
      MapListBox.ItemIndex := ActualMap;
      MultiView.HideMaster;
      MapChangeActive := true;
      Review(false);
   end;

end;

procedure TMainForm.MapListBoxItemClick(const Sender: TCustomListBox; const Item: TListBoxItem);
begin
   if MapChangeActive then
   begin
      MapChangeActive := false;
      ActualMap := MapListBox.ItemIndex;
      MapCombo.ItemIndex := ActualMap;
      MultiView.HideMaster;
      MapChangeActive := true;
      Review(false);
   end;
end;

function TMainForm.MapsDirExists(aDir: string; var MapIndex: integer): boolean;
var
   MR: RMap;
   i: integer;
begin
   result := false;
   MapIndex := -1;
   if Maps = nil then  exit;
   if Length(Maps) < 1 then exit;
   i := 0;
   for MR in Maps do
   begin
      if AnsiCompareText(aDir,MR.MapDir) = 0 then
      begin
         result := true;
         MapIndex := i;
         exit;
      end;
      Inc(i);
   end;
end;

procedure TMainForm.Note_Load(CEC: TComplicatedGECollection);
var
   L: TLoad;
   i,ii: integer;
   NPath: string;
   cecN: TComplicatedGECollection;
begin
   if Layers.Element['Notes'] <> nil then
      exit;     // vypada to ze stare notes uz nacteny byly
//   exit;
//   ShowMessage('before det');
   NPath := AlternativeNotesPath;
   if not System.IOUtils.TFile.Exists(NPath) then
   begin
      NPath := NotesPath;
      if not System.IOUtils.TFile.Exists(NPath) then
      begin
         exit;
      end;
//      ShowMessage('Budou načteny poznámky uložené v interní paměti!');
   end;
   AniIndicator.Visible := true;
   AniIndicator.Enabled := true;
   l_Progress.Text := 'Čtení Poznámek z '+ NotesPath;
   Application.ProcessMessages;
   L := TLoad.CreateAll(NPath);
   L.NoProgress := true;
   try
   L.DoIt;
   if not(L.output is TOwnerEntity) then exit;
   cecN := CEC.Layer['N'];
   cecN.AddAllFrom := L.Output;
   CEC.Enabled := true;
   CEC.Visible := true;
   Layers_Modified := true;
   L.Output.Free;
//   Layers.NextElement := L.Output;
   finally

   end;
//   Note_UpdateList;
   AniIndicator.Visible := false;
   AniIndicator.Enabled := false;
end;



procedure TMainForm.OldRoutesAndNotesLoad;
var
   CEC: TComplicatedGECollection;
begin
   if Layers.Element['OldRoutesAndNotes'] <> nil then
      exit;     // vypada to ze stare routes a notes uz nacteny byly
   cec := Layers_Add('OldRoutesAndNotes','Staré trasy a pozn.');
   cec.Color := TAlphaColors.Aqua;
//   cec.Enabled := true;
//   cec.Visible := true;
   Route_Load(cec);
   Note_Load(cec);
end;

{$IFDEF DIRECTGPS}
procedure TMainForm.onLocationChanged(location: JLocation);
var
   S,SA: string;
   A: TMapCoord;
   Prec: Single;
begin
  try
   gpsLat := Location.GetLatitude;
   gpsLong := Location.GetLongitude;
   gpsAcu := Location.getAccuracy;
   gpsAlt := Location.getAltitude;
   WGS84toJTSK(gpsLat,gpsLong,A);
   jtskX := -A.Y;
   jtskY := -A.X;
   if not GPSFixed  then
   begin
      b_gpss.ImageIndex := 2;
      Img_Green.Visible := true;
      Img_Orange.Visible := false;
      Img_Black.Visible := false;
   end;
   GPSFIxed := true;
   if Fix then
   begin
      prec := GetPageLength(distance(CenterX,CenterY,jtskX,jtskY));
      if prec > 3 then
      begin
//         if not Reviewing then
         begin
            DoFindGPS := true;
//            CHangeProjection(jtskX,jtsky,RealScale);
//            Review(false);
//            MainTool.PostMsg(tm_ReView,MainTool,nil,false);
         end;
//         MainTool.PostMsg(tm_ReView,MainTool,nil,false);
      end;
   end;
   if GPSTrack then
   begin
      try
      Route_StoreCoords(jtskX,jtskY, false);
//      CHangeProjection(jtskX,jtskY,RealScale);
//      if not Reviewing then
//          Review(false);
      if not fix then
         MainTool.PostMsg(tm_ReView,MainTool,ActualRoute,false);
      finally

      end;
   end;
   if not fix then
      Drawgps;
//   Application.ProcessMessages;
   S := '0.#';
   if not Location.hasAccuracy then
   begin
      SA := 'NA';
      Prec := 20;
   end
   else
   begin
      Prec := Location.getAccuracy * 1.4;
      SA := FormatFloat(S,Prec);
      Prec := GetPageLength(Prec)+20;
      if Prec < 20 then
         Prec := 20;
   end;
   Precis.Width := Prec;
   Precis.Height := Prec;
   S := '0';
   MainTool.PostMsg(tm_CoordsView,MainTool,nil,false);
//   l_jtsk.Text := 'X: '+FormatFloat(S,jtskX) + ' Y: '+FormatFloat(S,jtskY);
//   l_gps.Text := WGS84ToStr(gpsLat,gpsLong)+SA+' '+FormatFloat(S,Location.getAltitude);//+ '  A:'+FormatFloat(S,LocationSensor.Accuracy);
//   SA := JStringToString(Location.toString);
//   l_gps.Text := SA;

  except
     l_gps.Text := 'GPS chybka';
  end;
end;
{$ENDIF}

procedure TMainForm.OnProgress(_ID, _Event: integer; _Name, _Text: string;
  _MinValue, _MaxValue, _Progress: integer);
begin
   case _Event  of
      tm_StartProgress:
            Orbis_ProgressStart(_ID,_Name,_MinValue,_MaxValue,_MinValue);
      tm_EndProgress:
            Orbis_ProgressEnd(_ID,0);
      tm_Progress:
            Orbis_Progress(_ID,_Progress);
      tm_MaxProgress:
            Orbis_ProgressMax(_ID,_MaxValue);
   else
         Orbis_ProgressText(_ID, _Text);
   end;
end;

procedure TMainForm.OnSelectFile(const S: string);
begin
//   l_Scale.Text := S;
   //XFileDialog.Close;
//   Application.ProcessMessages;
//{$IFDEF HK}
//   AddProject(S);
//{$ELSE}
   LoadProject(S);
//{$ENDIF}
end;

procedure TMainForm.Orbis_Progress(_ID, Value: Integer);
var
   P: TProgressElem;
begin
   P := TProgressElem(Proc.FindElementName(IntToStr(_ID)));
   P.Progress := Value;
   if _ID <> ActiveProgress  then
   begin
      ActiveProgress := _ID;
      ProgressBar.Min := P.Min;
      ProgressBar.Max := P.Max;
   end;
   ProgressBar.Value := P.Progress;
   CheckProgress;
end;

procedure TMainForm.Orbis_ProgressEnd(_ID, Value: Integer);
var
   P: TProgressElem;
begin
   P := TProgressElem(Proc.FindElementName(IntToStr(_ID)));
   Proc.ElementToFree := P;
   ActiveProgress := 0;
   ProgressBar.Value := 0;
   CheckProgress;
end;

procedure TMainForm.Orbis_ProgressMax(_ID, Value: Integer);
var
   P: TProgressElem;
begin
   P := TProgressElem(Proc.FindElementName(IntToStr(_ID)));
   P.Max := Value;
   if _ID <> ActiveProgress  then
   begin
      ActiveProgress := _ID;
      ProgressBar.Min := P.Min;
      ProgressBar.Value := P.Progress;
   end;
   ProgressBar.Max := P.Max;
   CheckProgress;
end;

procedure TMainForm.Orbis_ProgressStart(_ID: Integer; ProgressName: string;
  MinProgress, MaxProgress, Progress: Integer);
var
   P: TProgressElem;
begin
   P := TProgressElem.Create;
   P._ID := _ID;
   P._Name := ProgressName;
   P.Min := MinProgress;
   P.Max := MaxProgress;
   P.Progress := Progress;
   P.Name := IntToStr(_ID);
   Proc.NextElement := P;
   ActiveProgress := _ID;
   ProgressBar.Min := MinProgress;
   ProgressBar.Max := MaxProgress;
   ProgressBar.Value := MinProgress;
   CheckProgress;
end;

procedure TMainForm.Orbis_ProgressText(_ID: Integer; Value: string);
var
   P: TProgressElem;
begin
   P := TProgressElem(Proc.FindElementName(IntToStr(_ID)));
   P.Text := Value;
   CheckProgress;
end;

procedure TMainForm.PointColorButtonClick(Sender: TObject);
begin
   Barva := 13;
   ColorPopup.IsOpen := true;
end;

procedure TMainForm.Point_Edit_ComboBoxChange(Sender: TObject);
var
   TD: TTopolDruh;
begin
   if (ePoint <> nil) and (ePoint.Status = 0) then exit;

   TD := TTopolDruh(Point_Edit_ComboBox.Items.Objects[Point_Edit_ComboBox.ItemIndex]);
   Zn.B.ActualDruh := TD;
   if ePoint = nil then exit;
   ePoint.Group := TD.KOD;
   ePoint.Symbol := TD.Znacka;
   Point_UpdateBySymbol(ePoint);
   DrawPoint(ePoint,true);
   Layers_Modified := true;
end;

procedure TMainForm.Point_UpdateBySymbol(aPoint: Tgis_PointElement);
var
   i,ii: integer;
   e: TElement;
   En: TEntity;
   GEn: TRectEntity;
   L: TPolyLineElement;
   abX,abY: double;
begin
   if PSYMB = nil then exit;
   e := PSYMB.FindElementName(aPoint.Symbol.ToString);
   if e = nil then exit;
   EN := TEntity(e);
   e := EN.FindElementName('G');
   if e = nil then exit;
   if not (e is TRectEntity) then exit;
   GEN := TRectEntity(e);
   abX := aPoint.X;
   abY := aPoint.Y;
   aPoint.MinX := abX + GEN.MinX;
   aPoint.MinY := abY + GEN.MinY;
   aPoint.Width := GEN.Width;
   aPoint.Height := GEN.Height;
   aPoint.AbsRefX := abX;
   aPoint.AbsRefY := abY;
end;

procedure TMainForm.Review(compact: boolean);
var
   i,Xi,Yi,xi1,xi2,yi1,yi2: integer;
   X1,Y1,X2,Y2: double;
   Revi: integer;
   TileIndex: integer;
   Maprec: RMap;
   MX: RTileMatrix;
   S: string;
   bm1: TBitmap;
   DestRect,SrcRect: TRectf;
   dX: Single;
begin
   if (Length(Maps) = 0) or (ActualMap > High(Maps))  then exit;
   AreaBlinked := false;
   Reviewing := true;
   Revi := StopReviews;
   Reviews[Revi] := 1;
   //G.Clear(System.Drawing.Color.WhiteSmoke);
    Application.ProcessMessages;
    if Compact then
    begin
       Image.Bitmap.Canvas.BeginScene;
       Image.Bitmap.Canvas.Clear(BColor);
    end;
    // nalezeni spravneho Tilematrix pro projekci
    MapRec := Maps[ActualMap];
    for i := 0 to Length(MapRec.TileMatrixSet) - 1 do
    begin
       MX := MapRec.TileMatrixSet[i];
       ActualTileMatrix := i;
       dx := GetPageLength(MX.TileWidth);
       if dx <= 500 then break;
    end;
    MX := MapRec.TileMatrixSet[ActualTileMatrix];
//    Edit1.Text := MX.ID;
    // mazani prazdnych ploch
    // je tam vubec neco?
    if (MX.MinX > MaxX) or (MX.MaxX < MinX) or (MX.MinY > MaxY) or (MX.MaxY < MinY) then
    begin
       // NE
       Image.Bitmap.Canvas.BeginScene;
       Image.Bitmap.Canvas.Clear(BColor);
       Image.Bitmap.Canvas.EndScene;
    end
    else
    begin
       Image.Bitmap.Canvas.BeginScene;
       if MX.MinX > MinX then
       begin
          SrcRect := TRectF.Create(0,0,GetPageX(MX.MinX),BM.Height);
          Image.Bitmap.Canvas.ClearRect(SrcRect,BColor);
       end;
       if MX.MaxX < MaxX then
       begin
          SrcRect := TRectF.Create(GetPageX(MX.MaxX),0,BM.Width,BM.Height);
          Image.Bitmap.Canvas.ClearRect(SrcRect,BColor);
       end;
       if MX.MinY > MinY then
       begin
          SrcRect := TRectF.Create(0,GetPageY(MX.MinY),BM.Width,BM.Height);
          Image.Bitmap.Canvas.ClearRect(SrcRect,BColor);
       end;
       if MX.MaxY < MaxY then
       begin
          SrcRect := TRectF.Create(0,0,BM.Width,GetPageY(MX.MaxY));
          Image.Bitmap.Canvas.ClearRect(SrcRect,BColor);
       end;
       Image.Bitmap.Canvas.EndScene;
    end;
    X1 := MX.MinX;
    if x1 < MinX then
    begin
       xi1 := Trunc((Minx - X1) / (MX.TileWidth - MX.OverX));
       X1 := X1 + (xi1 * (MX.TileWidth - MX.OverX));
    end
    else
    begin
       xi1 := 0;
    end;
    X2 := X1 + MX.TileWidth;
    for Xi := xi1 to MX.MatrixWidth - 1 do
    begin
       Y1 := MX.MinY;
       if y1 < MinY then
       begin
          yi1 := Trunc((Miny - y1) / (MX.TileHeight - MX.OverY));
          Y1 := Y1 + (yi1 * (MX.TileHeight - MX.OverY));
       end
       else
       begin
          yi1 := 0;
       end;
       Y2 := Y1 + MX.TileHeight;
       for Yi := yi1 to MX.MatrixHeight - 1 do
       begin
//          ShowReviews('til'+IntToStr(Revi));
//          Application.ProcessMessages;
//          if Reviews[Revi] = 2 then     //stop
//          begin
//             Reviews[Revi] := 0;
//             DrawGPS;
//             Bm.CopyFromBitmap(Image.Bitmap);
////             ShowReviews('break');
//             exit;
//          end;

          if (X1 < MaxX) and (Y1 < MaxY) and
             (X2 > MinX) and (Y2 > MinY)then
          begin
             S := MapRec.MapDir + MX.ID + '_'+IntToStr(Xi)+'-'+IntToStr(Yi)+'.'+MapRec.Ext;
             try
             if not compact then
                Image.Bitmap.Canvas.BeginScene;
             TileIndex := Tiles.IndexOf(S);
             if TileIndex < 0 then
             begin
                Bm1 := TBitmap.CreateFromFile(S);   // hodit do live array
                if not MapRec.Registered then
                begin
                   Bm1.Canvas.BeginScene;
                   SrcRect  := TRectF.Create(0,0,Bm1.Width,Bm1.Height);
                   DestRect := TRectF.Create(0,0,Bm1.Width,Bm1.Height);
                   Bm1.Canvas.DrawBitmap(Image_LockedMap.Bitmap,SrcRect,DestRect,0.8,true);
                   Bm1.Canvas.EndScene;
                end;
                Tiles.AddObject(S,Bm1);
             end
             else
                Bm1 := TBitmap(Tiles.Objects[TileIndex]);
             SrcRect  := TRectF.Create(0,0,Bm1.Width,Bm1.Height);
             DestRect := TRectF.Create(GetPageX(X1),GetPageY(Y2),GetPageX(X2),GetPageY(Y1));
             Image.Bitmap.Canvas.DrawBitmap(Bm1,SrcRect,DestRect,100);
             if not Compact then
             begin
                Image.Bitmap.Canvas.EndScene;
                Application.ProcessMessages;
             end;
//             Bm1.DisposeOf;
             //PictureBox1.Image := System.Drawing.Bitmap.Create(S);
             finally
                //G.Dispose;
             end;
          end;
          Y1 := Y2 - MX.OverY;
          if Y1 > MaxY then Break;
          Y2 := Y1 + MX.TileHeight;
       end;
       X1 := X2 - MX.OverX;
       if X1 > MaxX then Break;
       X2 := X1 + MX.TileWidth;
    end;

//    for i := 0 to Length(Reviews) - 1 do
//    begin
//       if Reviews[Revi] = 2 then
//       begin
//          Reviews[Revi] := 0;
//          Application.ProcessMessages;
//          exit;
//       end;
//
//    end;
    Reviews[Revi] := 0;
    if Compact then
    begin
       Image.Bitmap.Canvas.EndScene;
       Application.ProcessMessages;
    end;
//   DrawRoutes;
//   DrawNotes;
   DrawLayers;
   DrawGPS;
   Bm.CopyFromBitmap(Image.Bitmap);
   Reviewing := false;
//   ShowReviews('tend');
end;

procedure TMainForm.RoutesListItemClick(const Sender: TCustomListBox; const Item: TListBoxItem);
var
   L: TPolyLineElement;
begin
   if Item = nil  then exit;
   if Item.Data = nil then exit;
   if not (Item.Data is TPolyLineElement) then exit;
   L := TPolyLineElement(Item.Data);
   L.Update;
   CHangeProjectionByRect(L.MinX,L.MinY,L.MaxX,L.MaxY);
   if RealScale < 2000 then
      CHangeProjection(CenterX,CenterY,2000);
   Review(false);
   BlinkLine(L);

end;

procedure TMainForm.Route_End;
begin
   GPSTrack := false;
end;

procedure TMainForm.Route_Load(CEC: TComplicatedGECollection);
var
   L: TLoad;
   i,ii: integer;
   RPath: string;
   LE: TPolyLineElement;
   cecL: TComplicatedGECollection;
begin
//   if Layers.Element['Routes'] <> nil then
//      exit;     // vypada to ze stare routes uz nacteny byly

//   exit;
//   ShowMessage('before det');
   RPath := AlternativeRoutesPath;
   if not System.IOUtils.TFile.Exists(RPath) then
   begin
      RPath := RoutesPath;
      if not System.IOUtils.TFile.Exists(RPath) then
      begin
         exit;
      end;
//      ShowMessage('Budou načteny trasy uložené v interní paměti!');
   end;
   AniIndicator.Visible := true;
   AniIndicator.Enabled := true;
   l_Progress.Text := 'Čtení Tras z '+ RoutesPath;
   Application.ProcessMessages;
   L := TLoad.CreateAll(RPath);
   L.NoProgress := true;
   try
   L.DoIt;
   if not(L.output is TOwnerEntity) then exit;
//   Routes := TOwnerEntity(L.Output);
   cecL := cec.Layer['L'];
   cecL.AddAllFrom := L.Output;
   cec.Enabled := true;
   cec.Visible := true;
   for i := 0 to cecL.LastIndex do
   begin
      LE := TPolyLineElement(cecL.Elements[i]);
      LE.Update;
   end;
   Layers_Modified := true;
   TRectEntity(cecL).Update;
   TRectEntity(cec).Update;
   L.Output.Free;
//   Layers.NextElement := L.Output;
   finally

   end;
//   Route_UpdateList;
   AniIndicator.Visible := false;
   AniIndicator.Enabled := false;
end;

//procedure TMainForm.Route_Save;
//var
//   S: TSave;
//   i,ii: integer;
//   RPath: string;
//begin
////   exit;
////   ShowMessage('before det');
//   RPath := RoutesPath;
//   AniIndicator.Visible := true;
//   AniIndicator.Enabled := true;
//   l_Progress.Visible := true;
//   l_Progress.Text := 'uložení Tras do '+ RPath;
//   l_Progress.Visible := false;
//   Application.ProcessMessages;
//   S := TSave.CreateAll(RPath);
//   try
//   S.NoProgress := true;
//   S.Input := Routes;
//   S.DoIt;
//   Except
//      ShowMessage('Není možné zapsat trasy k projektu - budou uloženy do interní paměti!');
//      RoutesPath  := AlternativeRoutesPath;
//      RPath := RoutesPath;
//      l_Progress.Text := 'uložení Tras do '+ RPath;
//      l_Progress.Visible := false;
//      Application.ProcessMessages;
//      S := TSave.CreateAll(RPath);
//      try
//      S.NoProgress := true;
//      S.Input := Routes;
//      S.DoIt;
//      except
//         ShowMessage('Není možné zapsat trasy NIKAM!');
//      end;
//   end;
//   AniIndicator.Visible := false;
//   AniIndicator.Enabled := false;
//end;


procedure TMainForm.Route_StartNew;
begin
//   if Routes = nil then
//   begin
//      Routes := TOwnerEntity.Create;
//      Routes.Name := 'Routes';
//   end;
   Routes := Layers_Layer('Log','L');
   ActualRoute := TPolyLineElement.Create;
   Routes.AddElement(ActualRoute);
   GPSTrack := true;
end;

procedure TMainForm.Route_StoreCoords(gx, gy: double; Redraw: boolean);
begin
   if ActualRoute  = nil then
   begin
//      Label9.Text := 'NIL';
      exit;
   end;
   ActualRoute.AddXY(gx,gy);
//   Label9.Text := 'L'+IntToStr(ActualRoute.CoordsCount);
   if Redraw then
      DrawLine(ActualRoute,-1, EditColors.LineColor);
end;


procedure TMainForm.SaveLineDialog;
begin
   Status := 2;
   dlg_Edit.Text := 'Linie ';
   dlg_Text.Text := 'Uložit Linii pod názvem:';
   dlg_General.Visible := true;
end;

procedure TMainForm.SaveParams;
begin

end;

procedure TMainForm.SetActiveProgress(const Value: integer);
begin
  FActiveProgress := Value;
end;

procedure TMainForm.SetOnDataReady(const Value: TNotifyEvent);
begin
  FOnDataReady := Value;
end;

procedure TMainForm.SetOnMapReady(const Value: TNotifyEvent);
begin
  FOnMapReady := Value;
end;

procedure TMainForm.SetOnSelectJPRL(const Value: TNotifyEvent);
begin
   FOnSelectJPRL := Value;
end;

procedure TMainForm.SetProc(const Value: TOwnerEntity);
begin
  FProc := Value;
end;

procedure TMainForm.set_GPSFixed(const Value: boolean);
begin
  FGPSFixed := Value;
end;


procedure TMainForm.ShowGPSCoords;
var
   S, SA: string;
begin
   S := '0';
   SA := '0.#';
   SA := FormatFloat(SA,gpsAcu) + ' ' + FormatFloat(S,gpsAlt);
   l_jtsk.Text := 'X: '+FormatFloat(S,jtskX) + ' Y: '+FormatFloat(S,jtskY);
   l_gps.Text := WGS84ToStr(gpsLat,gpsLong)+SA;//+ '  A:'+FormatFloat(S,LocationSensor.Accuracy);
end;

procedure TMainForm.ShowLHCList;
begin
{$IFDEF HK}
   Karkulka_LHCList_Form.Show;
{$ENDIF}
end;

procedure TMainForm.ShowScaleAndCoords;
var
   S: string;
   F, FLog: double;
   km: boolean;
   i: integer;
   LastF: double;
   nW : Single;
const
   Farr: Array[0..10] of Double = (0,1,2,5,10,25,50,100,200,500,1000);
begin
   l_Scale.Text := '1 : ' + IntToStr(Round(RealScale));
//   S := '0.###';
   S := '0';
   l_jtsk.Text := 'X: '+FormatFloat(S,CenterX) + ' Y: '+FormatFloat(S,CenterY);
//   Scale visualizer ha ha
   if not ScaleLayout.Visible then
      exit;

//   nalezeni delky useku
   km := false;
   f := GetModelLength(240);
   km := f >= 3000;
   f := f / 3;
   FLog := Log10(f);
//   f := RoundTo(f,FLog);
   for i := 0 to 10 do
   begin
      if f > Farr[i] then
         LastF := Farr[i]
      else
         Break;
   end;
   if LastF = 1000 then
   begin
      F := Floor(F / 1000);
      LastF := F * 1000;
   end
   else
      F := LastF;
   nW := GetPageLength(LastF);
   if km then
   begin
      LastF := LastF / 1000;
      Text5.Text := 'km';
      Text55.Text := 'km';
   end
   else
   begin
      Text5.Text := 'm';
      Text55.Text := 'm';
   end;
   Rectangle1.Width := nW;
   Rectangle2.Width := nW;
   Rectangle3.Width := nW;
   Rectangle2.Position.X := Rectangle1.Position.X + Rectangle1.Width;
   Rectangle3.Position.X := Rectangle2.Position.X + Rectangle2.Width;
   Text2.Text := FormatFloat('0',LastF);
   Text2.Position.X := Text1.Position.X + nW;
   Text22.Text := Text2.Text;
   Text22.Position.X := Text2.Position.X;
   Text3.Text := FormatFloat('0',LastF * 2);
   Text3.Position.X := Text2.Position.X + nW;
   Text33.Text := Text3.Text;
   Text33.Position.X := Text3.Position.X;
   Text4.Text := FormatFloat('0',LastF * 3);
   Text4.Position.X := Text3.Position.X + nW;
   Text44.Text := Text4.Text;
   Text44.Position.X := Text4.Position.X;
   Text5.Position.X := Rectangle3.Position.X + nW;
   Text55.Position.X := Text5.Position.X;
end;

procedure TMainForm.ShowTheForest(Highlight: boolean);
var
   FU: Tgis_ForestUnit;
begin
   LHC.ActualLS := nil;
   LHC.Oddeleni_Cislo := StrToIntDef(S_Oddeleni,0);
   LHC.Dilec_Name := S_Dilec;
   LHC.Porost_Name := S_Porost;
   LHC.Skupina_Name := S_Skupina;
   FU := LHC.ActualSkupina;
   if FU = nil then
      FU := LHC.ActualPorost;
   if FU = nil then
      FU := LHC.ActualDilec;
   if FU = nil then
      FU := LHC.ActualOddeleni;
   if FU = nil then
      FU := LHC.ActualLHC;
   if FU <> nil  then
   begin
      CHangeProjectionByRect(FU.MinX,FU.MinY,FU.MaxX,FU.MaxY);
      if RealScale  < 2000 then
      begin
          CHangeProjection(CenterX,CenterY,2000);
      end;
      Review(false);
      if HighLight then
      begin
          if LHC.ActualSkupina <> nil then
          begin
              BlinkArea(TAreaElement(LHC.ActualSkupina.Geometry));
          end;
      end;
      l_JPRL.Text := {S_LHC+' '+}S_Oddeleni+S_Dilec+S_Porost+' '+S_Skupina;
      l_JPRLs.Text := {S_LHC+' '+}S_Oddeleni+S_Dilec+S_Porost+' '+S_Skupina;
   end
   else
   begin
      l_JPRL.Text := 'X';
      l_JPRLs.Text := 'X';
   end;
end;

procedure TMainForm.SpeedButton1Click(Sender: TObject);
begin
   case ActiveTool of
      0: ActiveTool := 2;
   else
      ActiveTool := 0;
   end;
end;

procedure TMainForm.StartActiveTool(aIndex: integer);
begin
   if Aindex = 0 then
   begin
      b_Hand.TintColor := TAlphaColors.Blueviolet;
      b_Tools.TintColor := TAlphaColors.Null;
   end
   else
   begin
      b_Hand.TintColor := TAlphaColors.Null;
      b_Tools.TintColor := TAlphaColors.Blueviolet;
   end;
   case aIndex of
      at_Note:
      begin
         if ActualSuperLayer = nil then
            ActualSuperLayer := TComplicatedGECollection(Layers.Element['User']);
         ActualLayer := ActualSuperLayer.Layer['N'];
         b_NoteClick(nil);
      end;
      at_Meas:
      begin
         ActualLayer := Layers_Layer('Meas','L');
         b_editClick(nil);
      end;
      at_Line:
      begin
         if ActualSuperLayer = nil then
            ActualSuperLayer := TComplicatedGECollection(Layers.Element['User']);
         ActualLayer := ActualSuperLayer.Layer['L'];
         StartLineEditing;
//         b_editClick(nil);
      end;
      at_Point:
      begin
         if ActualSuperLayer = nil then
            ActualSuperLayer := TComplicatedGECollection(Layers.Element['User']);
         ActualLayer := ActualSuperLayer.Layer['P'];
         b_EditPointClick(nil);
      end;
      at_Log:
      begin
         p_gpslog.Visible := not p_gpslog.Visible;
         if p_gpslog.Visible then
         begin
            b_TraceRoute.Text := 'Zavřít trasování GPS' ;
         end
         else
         begin
            b_TraceRoute.Text := 'Trasování GPS' ;
         end;
      end;
   end;
end;

procedure TMainForm.StartLineEditing;
begin
   Image_edit_Detail.Visible := true;
   Image_edit.Visible := true;

   MLine := TPolyLineElement.Create;
   MLine.Name := 'Linie';
//   ActualLayer.AddElement(MLine);
//   Layers_UpdateList;

   if ActiveTool = at_Line then
   begin
      Edit_Clear;
      exit;
   end;
   Edit_Clear;
//   Image_edit.Bitmap.Resize(Round(Image.Bitmap.Width),Round(Image.Bitmap.Height));
//   Image_edit.Bitmap.Canvas.BeginScene;
//   Image_edit.Bitmap.Canvas.Clear(TAlphaColors.Null);
//   Image_edit.Bitmap.Canvas.EndScene;
//   Image_edit_Detail.Bitmap.Resize(Round(Image.Bitmap.Width),Round(Image.Bitmap.Height));
//   Image_edit_Detail.Bitmap.Canvas.BeginScene;
//   Image_edit_Detail.Bitmap.Canvas.Clear(TAlphaColors.Null);
//   Image_edit_Detail.Bitmap.Canvas.EndScene;
//
//   Image_edit.Bitmap.Resize(Round(Image.Bitmap.Width),Round(Image.Bitmap.Height));
//   Image_edit.Bitmap.Canvas.BeginScene;
//   Image_edit.Bitmap.Canvas.Clear(TAlphaColors.Null);
//   Image_edit.Bitmap.Canvas.EndScene;
//   Image_edit_Detail.Bitmap.Resize(Round(Image.Bitmap.Width),Round(Image.Bitmap.Height));
//   Image_edit_Detail.Bitmap.Canvas.BeginScene;
//   Image_edit_Detail.Bitmap.Canvas.Clear(TAlphaColors.Null);
//   Image_edit_Detail.Bitmap.Canvas.EndScene;

   ActiveTool := at_Line;
   ActionPanel.Visible := true;
   l_Caption.Text := 'Editace Linie';
   l_Text.Text := 'Aktivní vrstva... '+ActualSuperLayer.Text;
   EditLineLayout.Visible := true;
   b_NewLine.Text := 'Ukončit linii';
   EditLineChangeSubTool(0);
end;

function TMainForm.StopReviews: integer;
var
   i,ii: integer;
   val: integer;
begin
   result := -1;
   ii := 0;
   for i := 0 to Length(Reviews) - 1 do
   begin
      val := Reviews[i];
      if (result < 0) and (val = 0) then
         result := i
      else
      if val = 1 then
      begin
         Reviews[i] := 2;
         ii := ii + 1;
      end;
   end;
//   ShowReviews('stop');
   Application.ProcessMessages;
//   l_Coords.Text := ii.ToString;
end;


procedure TMainForm.Switch1Switch(Sender: TObject);
begin
{$IFDEF HK}
   Fix :=  Switch1.IsChecked ;
{$ELSE}
   Fix :=  Switch2.IsChecked ;
{$ENDIF}
   FixTimer.Enabled := Fix;
   if Fix then
      b_GPSs.ImageIndex := 3
   else
      b_GPSs.ImageIndex := 2;
   DoFindGPS := false;
end;

procedure TMainForm.Timer1Timer(Sender: TObject);
begin
{$IFDEF HK}
   Timer1.Enabled := false;
   ShowLHCList;
{$ENDIF}
end;

procedure TMainForm.ToolsListBoxItemClick(const Sender: TCustomListBox; const Item: TListBoxItem);
var
   NewATIndex: integer;
begin
   Multiview.HideMaster;
//   ToolsListBox.Visible := false;
   NewATIndex := -1;
   case ToolsListBox.ItemIndex of
      0: NewATIndex := 0; // prohlizeni mapy
      1: NewATIndex := 2; // mereni
      2: NewATIndex := 1; // poznamky
      3: NewATIndex := 4; // editace linii
      4: NewATIndex := 3; // body
      5: NewATIndex := 5; // trasovani
   end;
   if NewATIndex < 0  then
      ShowMessage('Funkce '+ Item.Text + ' není podporována');
   if not ChangeActiveTool(NewATIndex) or (NewATIndex < 0) then
   begin
      ToolsListBox.ItemIndex := LastToolListboxIndex;
      exit;
   end;
   LastToolListboxIndex := ToolsListBox.ItemIndex;
end;

{ TProgressElem }

procedure TProgressElem.SetMax(const Value: integer);
begin
   FMax := value;
end;

procedure TProgressElem.SetMin(const Value: integer);
begin
   FMin := Value;
end;

procedure TProgressElem.SetProgress(const Value: integer);
begin
   FProgress := Value;
end;

procedure TProgressElem.SetText(const Value: string);
begin
   FText := value;
end;

procedure TProgressElem.Set_ID(const Value: integer);
begin
   F_ID := Value;
end;

procedure TProgressElem.Set_Name(const Value: string);
begin
   F_Name := value;
end;

{ TMainTool }

procedure TMainTool.HandleMessage(var aMessage: TOrbisMessage; var Handled: boolean);
begin
   inherited HandleMessage(aMessage, Handled);
   if Handled then exit;
   case aMessage.Message of
      tm_ReView       : On_tm_ReView(aMessage, Handled);
      tm_CoordsView   : MainForm.ShowGPSCoords;
      tm_Show         : MainForm.ShowLHCList;
   end;
end;

procedure TMainTool.On_tm_ReView(var aMessage: TOrbisMessage; var Handled: boolean);
begin
   if aMessage.Data <> nil then
   begin
      if aMessage.Data is TPolyLineElement then
         MainForm.DrawLine(MainForm.ActualRoute,MainForm.ActualRoute.LastIndex, MainForm.EditColors.LineColor)
      else
         MainForm.DrawPoint(MainForm.ePoint,true);
   end
   else
   begin
      MainForm.Review(false);
   end;
end;

{ TLoadDetThread }

procedure TLoadDetThread.Execute;
var
   L: TLoad;
begin
   LHC := nil;
   L := TLoad.CreateAll(FileName);
   L.NoProgress := true;
   try
   L.DoIt;
   if not(L.output is Tgis_ForestModel) then exit;
   LHC := Tgis_ForestModel(L.Output);
   finally
   end;
end;

procedure TLoadDetThread.Finish;
begin

end;


{ TLocationListener }
{$IFDEF DIRECTGPS}
constructor TLocationListener.Create(AParent: TMainForm);
begin
  inherited Create;
  FParent := AParent;
end;

procedure TLocationListener.onLocationChanged(location: JLocation);
begin
  FParent.onLocationChanged(location);
end;

procedure TLocationListener.onProviderDisabled(provider: JString);
begin

end;

procedure TLocationListener.onProviderEnabled(provider: JString);
begin

end;

procedure TLocationListener.onStatusChanged(provider: JString; status: Integer;
  extras: JBundle);
begin

end;
{$ENDIF}

{ TProjectPath }

class procedure TProjectPath.CheckDirectories;
var
   S,SysP,PurePrj: string;
   L: TLoad;
   i: integer;
   En: TEntity;
   TD: TTopolDruh;
begin
   S := _Path.Combine(_Path.GetPublicPath, 'map');
   SysP := _Path.Combine(S, 'project');
   PurePrj := _Path.GetFileNameWithoutExtension(Project);
   SysP := _Path.Combine(SysP,PurePrj);
   ForceDirectories(SysP);
   root  := IncludeTrailingPathDelimiter(SysP);
   User  := _Path.Combine(root, PurePrj+'_USER.orb');
   Audio := IncludeTrailingPathDelimiter(root+'audio');
   Img   := IncludeTrailingPathDelimiter(root+'img');
   Maps   := IncludeTrailingPathDelimiter(root+'maps');
   ForceDirectories(Audio);
   ForceDirectories(Img);
   ForceDirectories(Maps);
end;

class procedure TProjectPath.Clear;
begin
     VeryOld.Clear;
     Old.Clear;
     Project          := '';
     Root             := '';
     User             := '';
     Audio            := '';
     Img              := '';
     maps             := '';
end;

{ TOldProjectPath }

class procedure TOldProjectPath_.Clear;
begin
   Routes      := '';
   Notes       := '';
   User        := '';
end;


{ TOldProjectPath }

class procedure TOldProjectPath.Clear;
begin
   Alt.Clear;
   prj.Clear;
end;

//initialization
end.
